% gen_direct_all.m
%
% Generates basic thread and kernel functions 
% for the direct convolution and LCC, for a 
% range of different template sizes.
%
% NOTE: In current FLCC version only the generated kernels are used.
%
% Georgios Papamakarios (gpapamak@auth.gr)
% Electrical and Computer Engineering AUTH
% April 2011


path = '../src/common/opt/';


% -- Kernel functions

t2d = 16;
t3d = 8;

f = fopen([path 'convolution2d_kernel.c'], 'w');
fprintf(f, '// This file is generated automatically. \n\n');
for t=2:32
    gen_direct2_kernel_conv(t, t, f, t2d);
end
fclose(f);

f = fopen([path 'lcorrelation2d_kernel.c'], 'w');
fprintf(f, '// This file is generated automatically. \n\n');
for t=2:32
    gen_direct2_kernel_lcorr(t, t, f, t2d);
end
fclose(f);

f = fopen([path 'convolution3d_kernel.c'], 'w');
fprintf(f, '// This file is generated automatically. \n\n');
for t=2:8
    gen_direct3_kernel_conv(t, t, t, f, t3d);
end
fclose(f);

f = fopen([path 'lcorrelation3d_kernel.c'], 'w');
fprintf(f, '// This file is generated automatically. \n\n');
for t=2:8
    gen_direct3_kernel_lcorr(t, t, t, f, t3d);
end
fclose(f);


% -- Thread functions
% (not used in current FLCC version)

% f = fopen([path 'convolution2d_thread.c'], 'w');
% fprintf(f, '// This file is generated automatically. \n\n');
% for t=2:32
%     gen_direct2_thread_conv(t, t, f);
% end
% fclose(f);
% 
% f = fopen([path 'lcorrelation2d_thread.c'], 'w');
% fprintf(f, '// This file is generated automatically. \n\n');
% for t=2:32
%     gen_direct2_thread_lcorr(t, t, f);
% end
% fclose(f);
% 
% f = fopen([path 'convolution3d_thread.c'], 'w');
% fprintf(f, '// This file is generated automatically. \n\n');
% for t=2:10
%     gen_direct3_thread_conv(t, t, t, f);
% end
% fclose(f);
% 
% f = fopen([path 'lcorrelation3d_thread.c'], 'w');
% fprintf(f, '// This file is generated automatically. \n\n');
% for t=2:10
%     gen_direct3_thread_lcorr(t, t, t, f);
% end
% fclose(f);

