/* 
 * FILE:
 * flcc_free.c
 * version 1.1
 *
 * DESCRIPTION:
 * This function frees the CPU memory allocated by flcc_malloc().
 *
 * AUTHORS:
 * Georgios Papamakarios 
 * Georgios Rizos
 *
 * Aristotle University of Thessaloniki
 * Facutly of Engineering
 * Department of Electrical and Computer Engineering
 *
 * DATE:
 * April 2011
 *
 * CONTACT INFO:
 * e-mail: gpapamak@auth.gr
 *         grizos@auth.gr
 */
 
 
#include <FLCC_general_defs.h>
#ifndef NO_CUDA	
#include <FLCC_cuda_defs.h>
#endif
 
 
void flcc_free (void *array)
{
	#ifndef NO_CUDA	
	cudaFreeHost (array);
	#else
	free (array);
	#endif
	
	return;
}
