/* 
 * FILE:
 * FLCC_thread_functions_2d.c
 * version 1.0
 *
 * DESCRIPTION:
 * These are the 2D CPU thread functions for the FLCC library.
 *
 * AUTHORS:
 * Georgios Papamakarios 
 * Georgios Rizos
 *
 * Aristotle University of Thessaloniki
 * Facutly of Engineering
 * Department of Electrical and Computer Engineering
 *
 * DATE:
 * November 2009
 *
 * CONTACT INFO:
 * e-mail: gpapamak@auth.gr
 *         georgios.rizos12@imperial.ac.uk
 */

 
// System include
#include <FLCC_general_defs.h>
#ifndef NO_FFTW
#include <FLCC_fftw_defs.h>
#endif
 

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Thread functions for conv2_host
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Optimized threads
GEN_DIRECT2_THREAD_CONV (  2,  2 )
GEN_DIRECT2_THREAD_CONV (  3,  3 )
GEN_DIRECT2_THREAD_CONV (  4,  4 )
GEN_DIRECT2_THREAD_CONV (  5,  5 )
GEN_DIRECT2_THREAD_CONV (  6,  6 )
GEN_DIRECT2_THREAD_CONV (  7,  7 )
GEN_DIRECT2_THREAD_CONV (  8,  8 )
GEN_DIRECT2_THREAD_CONV (  9,  9 )
GEN_DIRECT2_THREAD_CONV ( 10, 10 )
GEN_DIRECT2_THREAD_CONV ( 11, 11 )
GEN_DIRECT2_THREAD_CONV ( 12, 12 )
GEN_DIRECT2_THREAD_CONV ( 13, 13 )
GEN_DIRECT2_THREAD_CONV ( 14, 14 )
GEN_DIRECT2_THREAD_CONV ( 15, 15 )
GEN_DIRECT2_THREAD_CONV ( 16, 16 )
GEN_DIRECT2_THREAD_CONV ( 17, 17 )
GEN_DIRECT2_THREAD_CONV ( 18, 18 )
GEN_DIRECT2_THREAD_CONV ( 19, 19 )
GEN_DIRECT2_THREAD_CONV ( 20, 20 )
GEN_DIRECT2_THREAD_CONV ( 21, 21 )
GEN_DIRECT2_THREAD_CONV ( 22, 22 )
GEN_DIRECT2_THREAD_CONV ( 23, 23 )
GEN_DIRECT2_THREAD_CONV ( 24, 24 )
GEN_DIRECT2_THREAD_CONV ( 25, 25 )
GEN_DIRECT2_THREAD_CONV ( 26, 26 )
GEN_DIRECT2_THREAD_CONV ( 27, 27 )
GEN_DIRECT2_THREAD_CONV ( 28, 28 )
GEN_DIRECT2_THREAD_CONV ( 29, 29 )
GEN_DIRECT2_THREAD_CONV ( 30, 30 )
GEN_DIRECT2_THREAD_CONV ( 31, 31 )
GEN_DIRECT2_THREAD_CONV ( 32, 32 )

#ifndef NO_SINGLE_PREC
GEN_DIRECT2_THREAD_CONV_INSTANCE (  2,  2, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  3,  3, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  4,  4, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  5,  5, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  6,  6, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  7,  7, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  8,  8, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  9,  9, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 10, 10, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 11, 11, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 12, 12, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 13, 13, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 14, 14, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 15, 15, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 16, 16, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 17, 17, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 18, 18, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 19, 19, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 20, 20, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 21, 21, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 22, 22, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 23, 23, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 24, 24, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 25, 25, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 26, 26, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 27, 27, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 28, 28, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 29, 29, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 30, 30, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 31, 31, float )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 32, 32, float )
#endif

#ifndef NO_DOUBLE_PREC
GEN_DIRECT2_THREAD_CONV_INSTANCE (  2,  2, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  3,  3, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  4,  4, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  5,  5, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  6,  6, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  7,  7, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  8,  8, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE (  9,  9, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 10, 10, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 11, 11, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 12, 12, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 13, 13, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 14, 14, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 15, 15, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 16, 16, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 17, 17, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 18, 18, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 19, 19, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 20, 20, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 21, 21, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 22, 22, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 23, 23, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 24, 24, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 25, 25, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 26, 26, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 27, 27, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 28, 28, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 29, 29, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 30, 30, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 31, 31, double )
GEN_DIRECT2_THREAD_CONV_INSTANCE ( 32, 32, double )
#endif


// Perform the convolution direct method between 2D image and template on CPU
template <class flccPrecision>
void *convolution2d_thread_generic (void *arg)
{
	const corrParm<flccPrecision> *c = (corrParm<flccPrecision> *)arg;

	const int rem = c->tw%5;
	const int TW  = c->tw-rem;

	for (int n=0; n<c->offset; n++) {
		const int indx = c->initialPosition + n;	
		const int u = indx%c->sw;
		const int v = indx/c->sw;
		
		register flccPrecision conv = 0.0;
		
		int t_indx = c->th*c->tw-1;
		
		for (int j=0; j<c->th; j++) {
			int i_indx = (v+j)*c->bw + u;
			
			for (int i=0; i<TW; i+=5) {
				conv += c->image[i_indx  ] * c->templat[t_indx  ];
				conv += c->image[i_indx+1] * c->templat[t_indx-1];
				conv += c->image[i_indx+2] * c->templat[t_indx-2];
				conv += c->image[i_indx+3] * c->templat[t_indx-3];
				conv += c->image[i_indx+4] * c->templat[t_indx-4];
				
				i_indx += 5;
				t_indx -= 5;
			}
			
			switch (rem) {
				case 4: conv += c->image[i_indx+3] * c->templat[t_indx-3];
				case 3: conv += c->image[i_indx+2] * c->templat[t_indx-2];
				case 2: conv += c->image[i_indx+1] * c->templat[t_indx-1];
				case 1: conv += c->image[i_indx  ] * c->templat[t_indx  ];
			}
			
			t_indx -= rem;
		}
				
		c->lcc[indx] = conv;
	} 
	
	pthread_exit (NULL);	
} 

#ifndef NO_SINGLE_PREC
template void *convolution2d_thread_generic<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *convolution2d_thread_generic<double> (void *arg);
#endif


// Pad a 2D signal on both sides on CPU
template <class flccPrecision>
void *padSignal2d_both (void *arg)
{
	const padParm<flccPrecision> *p = (padParm<flccPrecision> *)arg;

	for (int n=0; n<p->offset; n++) {
		const int indx = p->initialPosition + n;
		const int x = indx%p->bw;
		const int y = indx/p->bw;
		
		if ( x>(p->tw - 2) && x<(p->sw) && y>(p->th - 2) && y<(p->sh) ) {
			p->padded[indx] = p->unpadded[x - p->tw + 1 + (p->iw)*(y - p->th + 1)];
		}
		else {
			p->padded[indx] = 0.0;
		}
	} 
	
	pthread_exit (NULL);	
} 

#ifndef NO_SINGLE_PREC
template void *padSignal2d_both<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *padSignal2d_both<double> (void *arg);
#endif


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Thread functions for lcorr2_host
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Optimized threads
GEN_DIRECT2_THREAD_LCORR (  2,  2 )
GEN_DIRECT2_THREAD_LCORR (  3,  3 )
GEN_DIRECT2_THREAD_LCORR (  4,  4 )
GEN_DIRECT2_THREAD_LCORR (  5,  5 )
GEN_DIRECT2_THREAD_LCORR (  6,  6 )
GEN_DIRECT2_THREAD_LCORR (  7,  7 )
GEN_DIRECT2_THREAD_LCORR (  8,  8 )
GEN_DIRECT2_THREAD_LCORR (  9,  9 )
GEN_DIRECT2_THREAD_LCORR ( 10, 10 )
GEN_DIRECT2_THREAD_LCORR ( 11, 11 )
GEN_DIRECT2_THREAD_LCORR ( 12, 12 )
GEN_DIRECT2_THREAD_LCORR ( 13, 13 )
GEN_DIRECT2_THREAD_LCORR ( 14, 14 )
GEN_DIRECT2_THREAD_LCORR ( 15, 15 )
GEN_DIRECT2_THREAD_LCORR ( 16, 16 )
GEN_DIRECT2_THREAD_LCORR ( 17, 17 )
GEN_DIRECT2_THREAD_LCORR ( 18, 18 )
GEN_DIRECT2_THREAD_LCORR ( 19, 19 )
GEN_DIRECT2_THREAD_LCORR ( 20, 20 )
GEN_DIRECT2_THREAD_LCORR ( 21, 21 )
GEN_DIRECT2_THREAD_LCORR ( 22, 22 )
GEN_DIRECT2_THREAD_LCORR ( 23, 23 )
GEN_DIRECT2_THREAD_LCORR ( 24, 24 )
GEN_DIRECT2_THREAD_LCORR ( 25, 25 )
GEN_DIRECT2_THREAD_LCORR ( 26, 26 )
GEN_DIRECT2_THREAD_LCORR ( 27, 27 )
GEN_DIRECT2_THREAD_LCORR ( 28, 28 )
GEN_DIRECT2_THREAD_LCORR ( 29, 29 )
GEN_DIRECT2_THREAD_LCORR ( 30, 30 )
GEN_DIRECT2_THREAD_LCORR ( 31, 31 )
GEN_DIRECT2_THREAD_LCORR ( 32, 32 )

#ifndef NO_SINGLE_PREC
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  2,  2, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  3,  3, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  4,  4, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  5,  5, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  6,  6, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  7,  7, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  8,  8, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  9,  9, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 10, 10, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 11, 11, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 12, 12, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 13, 13, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 14, 14, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 15, 15, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 16, 16, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 17, 17, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 18, 18, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 19, 19, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 20, 20, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 21, 21, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 22, 22, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 23, 23, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 24, 24, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 25, 25, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 26, 26, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 27, 27, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 28, 28, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 29, 29, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 30, 30, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 31, 31, float )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 32, 32, float )
#endif

#ifndef NO_DOUBLE_PREC
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  2,  2, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  3,  3, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  4,  4, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  5,  5, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  6,  6, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  7,  7, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  8,  8, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE (  9,  9, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 10, 10, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 11, 11, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 12, 12, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 13, 13, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 14, 14, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 15, 15, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 16, 16, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 17, 17, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 18, 18, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 19, 19, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 20, 20, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 21, 21, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 22, 22, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 23, 23, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 24, 24, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 25, 25, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 26, 26, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 27, 27, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 28, 28, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 29, 29, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 30, 30, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 31, 31, double )
GEN_DIRECT2_THREAD_LCORR_INSTANCE ( 32, 32, double )
#endif


// Perform the LCC direct method between 2D image and template on CPU
template <class flccPrecision>
void *lcorrelation2d_thread_generic (void *arg)
{
	const corrParm<flccPrecision> *c = (corrParm<flccPrecision> *)arg;

	const int rem = c->tw%5;
	const int TW  = c->tw-rem;
	
	for (int n=0; n<c->offset; n++) {
		const int indx = c->initialPosition + n;
		const int u = indx%c->sw;
		const int v = indx/c->sw;
		
		register flccPrecision corr   = 0.0;
		register flccPrecision sum    = 0.0;
		register flccPrecision sum_sq = 0.0;
		
		register flccPrecision im;
		
		int t_indx = 0;
		
		for (int j=0; j<c->th; j++) {
			int i_indx = (v+j)*c->bw + u;
			
			for (int i=0; i<TW; i+=5) {	
				im = c->image[i_indx  ];  corr += im * c->templat[t_indx  ];  sum += im;  sum_sq += im*im;
				im = c->image[i_indx+1];  corr += im * c->templat[t_indx+1];  sum += im;  sum_sq += im*im;
				im = c->image[i_indx+2];  corr += im * c->templat[t_indx+2];  sum += im;  sum_sq += im*im;
				im = c->image[i_indx+3];  corr += im * c->templat[t_indx+3];  sum += im;  sum_sq += im*im;
				im = c->image[i_indx+4];  corr += im * c->templat[t_indx+4];  sum += im;  sum_sq += im*im;
				
				i_indx += 5;
				t_indx += 5;
			}
			
			switch (rem) {
				case 4: im = c->image[i_indx+3];  corr += im * c->templat[t_indx+3];  sum += im;  sum_sq += im*im;
				case 3: im = c->image[i_indx+2];  corr += im * c->templat[t_indx+2];  sum += im;  sum_sq += im*im;
				case 2: im = c->image[i_indx+1];  corr += im * c->templat[t_indx+1];  sum += im;  sum_sq += im*im;
				case 1: im = c->image[i_indx  ];  corr += im * c->templat[t_indx  ];  sum += im;  sum_sq += im*im;
			}
			
			t_indx += rem;
		}
		
		const flccPrecision var = sum_sq - sum*sum/((c->tw)*(c->th));
		if (var == 0)	c->lcc[indx] = 0.0;
		else			c->lcc[indx] = corr / sqrt(var);
	} 
	
	pthread_exit (NULL);	
} 

#ifndef NO_SINGLE_PREC
template void *lcorrelation2d_thread_generic<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *lcorrelation2d_thread_generic<double> (void *arg);
#endif


#ifndef NO_FFTW


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Thread functions for fconv2_host
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Pad a 2D signal
template <class flccPrecision>
void *padSignal2d (void *arg)
{
	const padSigParm<flccPrecision> *padSig = (padSigParm<flccPrecision> *)arg;
	
	for (int n=0; n<padSig->offset; n++) {
		const int indx = padSig->initialPosition + n;
		const int x = indx%padSig->sw;
		const int y = indx/padSig->sw;
	
		if (x<padSig->w && y<padSig->h) {
			padSig->signal[indx] = padSig->tempSignal[x + y*padSig->w];
		} 
		else {
			padSig->signal[indx] = 0.0;
		} 
	} 
	
	pthread_exit (NULL);
} 

#ifndef NO_SINGLE_PREC
template void *padSignal2d<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *padSignal2d<double> (void *arg);
#endif


// Perform point-to-point multiplication
template <class fftwComplexPrecision>
void *complexProduct2d (void *arg)
{
	const prodParm<fftwComplexPrecision> *prod = (prodParm<fftwComplexPrecision> *)arg;
	
	for (int n=0; n<prod->offset; n++) {
		const int indx = prod->initialPosition + n;
		const fftwComplexPrecision f1 = {prod->fft1[indx][0], prod->fft1[indx][1]};
		const fftwComplexPrecision f2 = {prod->fft2[indx][0], prod->fft2[indx][1]};
		fftwComplexPrecision f;
		
		f[0] = (f1[0] * f2[0] - f1[1] * f2[1]) / prod->s_size;
		f[1] = (f1[0] * f2[1] + f1[1] * f2[0]) / prod->s_size; 
		
		prod->prod_fft[indx][0] = f[0]; 
		prod->prod_fft[indx][1] = f[1]; 
	} 
	
	pthread_exit (NULL);
} 

#ifndef NO_SINGLE_PREC
template void *complexProduct2d<fftwf_complex> (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *complexProduct2d<fftw_complex>  (void *arg);
#endif


// Calculate a 2D convolution array
template <class flccPrecision>
void *makeConvArray2d (void *arg)
{
	const makeConvParm<flccPrecision> *makeConv = (makeConvParm<flccPrecision> *)arg;

	for (int n=0; n<makeConv->offset; n++) {
		const int indx = makeConv->initialPosition + n;
		const int x = indx%makeConv->sw;
		const int y = indx/makeConv->sw;
		
		makeConv->conv[indx] = makeConv->sceneTimesT[x + y*makeConv->SW];
	} 
	
	pthread_exit (NULL);
} 

#ifndef NO_SINGLE_PREC
template void *makeConvArray2d<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *makeConvArray2d<double> (void *arg);
#endif


//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Thread functions for flcorr2_host
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////


// Normalize template and create template spatial support
template <class flccPrecision>
void *makePermanent2d (void *arg)
{
	const permParm<flccPrecision> *perm = (permParm<flccPrecision> *)arg;

	for (int n=0; n<perm->offset; n++) {
		const int indx = perm->initialPosition + n;
		const int x = indx%perm->sw;
		const int y = indx/perm->sw;
	
		if (x<perm->tw && y<perm->th) {
			perm->templat[indx] = ( perm->tempTemplate[perm->tw*perm->th - 1 - (x + y*perm->tw)] - perm->mean ) / perm->std; // Normalize here
			perm->Bt[indx]      = 1.0;
		} 
		else {
			perm->templat[indx] = 0.0;
			perm->Bt[indx]      = 0.0;
		} 
	} 
	
	pthread_exit (NULL);
} 

#ifndef NO_SINGLE_PREC
template void *makePermanent2d<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *makePermanent2d<double> (void *arg);
#endif
	
	
// Pad image and create square-valued image
template <class flccPrecision>
void *makeTransient2d (void *arg)
{
	const tranParm<flccPrecision> *tran = (tranParm<flccPrecision> *)arg;
	
	for (int n=0; n<tran->offset; n++) {
		const int indx = tran->initialPosition + n;
		const int x = indx%tran->sw;
		const int y = indx/tran->sw;
	
		if (x<tran->iw && y<tran->ih) {
			const flccPrecision im = tran->image[x + y*tran->iw];
			tran->scene[indx]   = im;
			tran->sceneSq[indx] = im * im;
		} 
		else {
			tran->scene[indx]   = 0.0;
			tran->sceneSq[indx] = 0.0;
		} 
	} 
	
	pthread_exit (NULL);
} 

#ifndef NO_SINGLE_PREC
template void *makeTransient2d<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *makeTransient2d<double> (void *arg);
#endif
	
	
// Calculate a 2D LCC array from precalculated arrays
template <class flccPrecision>
void *makeLccArray2d (void *arg)
{
	const makeLccParm<flccPrecision> *makeLcc = (makeLccParm<flccPrecision> *)arg;
	
	for (int n=0; n<makeLcc->offset; n++) {
		const int indx = makeLcc->initialPosition + n;
		const int x = indx%makeLcc->sw;
		const int y = indx/makeLcc->sw;
		const int INDX = x + y*makeLcc->SW;
		const flccPrecision SBt = makeLcc->sceneTimesBt[INDX];
		
		const flccPrecision nom   =    makeLcc->sceneTimesT[INDX];
		const flccPrecision denom = makeLcc->sceneSqTimesBt[INDX] - (SBt * SBt)/(makeLcc->t_size);
		
		if (denom == 0)	makeLcc->lcc[indx] = 0.0;
		else 			makeLcc->lcc[indx] = nom/sqrt(denom);
	} 
	
	pthread_exit (NULL);
} 

#ifndef NO_SINGLE_PREC
template void *makeLccArray2d<float>  (void *arg);
#endif
#ifndef NO_DOUBLE_PREC
template void *makeLccArray2d<double> (void *arg);
#endif


#endif // NO_FFTW

