// This file is generated automatically. 

template <class flccPrecision>
__global__ void convolution3d_kernel_2x2x2 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[729];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<9; k+=8) {
		for (int j=threadIdx.y; j<9; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<9; i+=8) {
				panelSh[i + IMUL(j, 9) + IMUL(k, 81)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[8];
	if (threadIdx.x < 2 && threadIdx.y < 2 && threadIdx.z < 2) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,2) + IMUL(threadIdx.z,4);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,9) + IMUL(threadIdx.z,81);
		conv += panelSh[p_idx + 0] * templateSh[7];
		conv += panelSh[p_idx + 1] * templateSh[6];
		conv += panelSh[p_idx + 9] * templateSh[5];
		conv += panelSh[p_idx + 10] * templateSh[4];
		conv += panelSh[p_idx + 81] * templateSh[3];
		conv += panelSh[p_idx + 82] * templateSh[2];
		conv += panelSh[p_idx + 90] * templateSh[1];
		conv += panelSh[p_idx + 91] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_2x2x2<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_2x2x2<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void convolution3d_kernel_3x3x3 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[1000];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<10; k+=8) {
		for (int j=threadIdx.y; j<10; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<10; i+=8) {
				panelSh[i + IMUL(j, 10) + IMUL(k, 100)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[27];
	if (threadIdx.x < 3 && threadIdx.y < 3 && threadIdx.z < 3) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,3) + IMUL(threadIdx.z,9);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,10) + IMUL(threadIdx.z,100);
		conv += panelSh[p_idx + 0] * templateSh[26];
		conv += panelSh[p_idx + 1] * templateSh[25];
		conv += panelSh[p_idx + 2] * templateSh[24];
		conv += panelSh[p_idx + 10] * templateSh[23];
		conv += panelSh[p_idx + 11] * templateSh[22];
		conv += panelSh[p_idx + 12] * templateSh[21];
		conv += panelSh[p_idx + 20] * templateSh[20];
		conv += panelSh[p_idx + 21] * templateSh[19];
		conv += panelSh[p_idx + 22] * templateSh[18];
		conv += panelSh[p_idx + 100] * templateSh[17];
		conv += panelSh[p_idx + 101] * templateSh[16];
		conv += panelSh[p_idx + 102] * templateSh[15];
		conv += panelSh[p_idx + 110] * templateSh[14];
		conv += panelSh[p_idx + 111] * templateSh[13];
		conv += panelSh[p_idx + 112] * templateSh[12];
		conv += panelSh[p_idx + 120] * templateSh[11];
		conv += panelSh[p_idx + 121] * templateSh[10];
		conv += panelSh[p_idx + 122] * templateSh[9];
		conv += panelSh[p_idx + 200] * templateSh[8];
		conv += panelSh[p_idx + 201] * templateSh[7];
		conv += panelSh[p_idx + 202] * templateSh[6];
		conv += panelSh[p_idx + 210] * templateSh[5];
		conv += panelSh[p_idx + 211] * templateSh[4];
		conv += panelSh[p_idx + 212] * templateSh[3];
		conv += panelSh[p_idx + 220] * templateSh[2];
		conv += panelSh[p_idx + 221] * templateSh[1];
		conv += panelSh[p_idx + 222] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_3x3x3<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_3x3x3<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void convolution3d_kernel_4x4x4 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[1331];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<11; k+=8) {
		for (int j=threadIdx.y; j<11; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<11; i+=8) {
				panelSh[i + IMUL(j, 11) + IMUL(k, 121)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[64];
	if (threadIdx.x < 4 && threadIdx.y < 4 && threadIdx.z < 4) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,4) + IMUL(threadIdx.z,16);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,11) + IMUL(threadIdx.z,121);
		conv += panelSh[p_idx + 0] * templateSh[63];
		conv += panelSh[p_idx + 1] * templateSh[62];
		conv += panelSh[p_idx + 2] * templateSh[61];
		conv += panelSh[p_idx + 3] * templateSh[60];
		conv += panelSh[p_idx + 11] * templateSh[59];
		conv += panelSh[p_idx + 12] * templateSh[58];
		conv += panelSh[p_idx + 13] * templateSh[57];
		conv += panelSh[p_idx + 14] * templateSh[56];
		conv += panelSh[p_idx + 22] * templateSh[55];
		conv += panelSh[p_idx + 23] * templateSh[54];
		conv += panelSh[p_idx + 24] * templateSh[53];
		conv += panelSh[p_idx + 25] * templateSh[52];
		conv += panelSh[p_idx + 33] * templateSh[51];
		conv += panelSh[p_idx + 34] * templateSh[50];
		conv += panelSh[p_idx + 35] * templateSh[49];
		conv += panelSh[p_idx + 36] * templateSh[48];
		conv += panelSh[p_idx + 121] * templateSh[47];
		conv += panelSh[p_idx + 122] * templateSh[46];
		conv += panelSh[p_idx + 123] * templateSh[45];
		conv += panelSh[p_idx + 124] * templateSh[44];
		conv += panelSh[p_idx + 132] * templateSh[43];
		conv += panelSh[p_idx + 133] * templateSh[42];
		conv += panelSh[p_idx + 134] * templateSh[41];
		conv += panelSh[p_idx + 135] * templateSh[40];
		conv += panelSh[p_idx + 143] * templateSh[39];
		conv += panelSh[p_idx + 144] * templateSh[38];
		conv += panelSh[p_idx + 145] * templateSh[37];
		conv += panelSh[p_idx + 146] * templateSh[36];
		conv += panelSh[p_idx + 154] * templateSh[35];
		conv += panelSh[p_idx + 155] * templateSh[34];
		conv += panelSh[p_idx + 156] * templateSh[33];
		conv += panelSh[p_idx + 157] * templateSh[32];
		conv += panelSh[p_idx + 242] * templateSh[31];
		conv += panelSh[p_idx + 243] * templateSh[30];
		conv += panelSh[p_idx + 244] * templateSh[29];
		conv += panelSh[p_idx + 245] * templateSh[28];
		conv += panelSh[p_idx + 253] * templateSh[27];
		conv += panelSh[p_idx + 254] * templateSh[26];
		conv += panelSh[p_idx + 255] * templateSh[25];
		conv += panelSh[p_idx + 256] * templateSh[24];
		conv += panelSh[p_idx + 264] * templateSh[23];
		conv += panelSh[p_idx + 265] * templateSh[22];
		conv += panelSh[p_idx + 266] * templateSh[21];
		conv += panelSh[p_idx + 267] * templateSh[20];
		conv += panelSh[p_idx + 275] * templateSh[19];
		conv += panelSh[p_idx + 276] * templateSh[18];
		conv += panelSh[p_idx + 277] * templateSh[17];
		conv += panelSh[p_idx + 278] * templateSh[16];
		conv += panelSh[p_idx + 363] * templateSh[15];
		conv += panelSh[p_idx + 364] * templateSh[14];
		conv += panelSh[p_idx + 365] * templateSh[13];
		conv += panelSh[p_idx + 366] * templateSh[12];
		conv += panelSh[p_idx + 374] * templateSh[11];
		conv += panelSh[p_idx + 375] * templateSh[10];
		conv += panelSh[p_idx + 376] * templateSh[9];
		conv += panelSh[p_idx + 377] * templateSh[8];
		conv += panelSh[p_idx + 385] * templateSh[7];
		conv += panelSh[p_idx + 386] * templateSh[6];
		conv += panelSh[p_idx + 387] * templateSh[5];
		conv += panelSh[p_idx + 388] * templateSh[4];
		conv += panelSh[p_idx + 396] * templateSh[3];
		conv += panelSh[p_idx + 397] * templateSh[2];
		conv += panelSh[p_idx + 398] * templateSh[1];
		conv += panelSh[p_idx + 399] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_4x4x4<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_4x4x4<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void convolution3d_kernel_5x5x5 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[1728];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<12; k+=8) {
		for (int j=threadIdx.y; j<12; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<12; i+=8) {
				panelSh[i + IMUL(j, 12) + IMUL(k, 144)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[125];
	if (threadIdx.x < 5 && threadIdx.y < 5 && threadIdx.z < 5) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,5) + IMUL(threadIdx.z,25);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,12) + IMUL(threadIdx.z,144);
		conv += panelSh[p_idx + 0] * templateSh[124];
		conv += panelSh[p_idx + 1] * templateSh[123];
		conv += panelSh[p_idx + 2] * templateSh[122];
		conv += panelSh[p_idx + 3] * templateSh[121];
		conv += panelSh[p_idx + 4] * templateSh[120];
		conv += panelSh[p_idx + 12] * templateSh[119];
		conv += panelSh[p_idx + 13] * templateSh[118];
		conv += panelSh[p_idx + 14] * templateSh[117];
		conv += panelSh[p_idx + 15] * templateSh[116];
		conv += panelSh[p_idx + 16] * templateSh[115];
		conv += panelSh[p_idx + 24] * templateSh[114];
		conv += panelSh[p_idx + 25] * templateSh[113];
		conv += panelSh[p_idx + 26] * templateSh[112];
		conv += panelSh[p_idx + 27] * templateSh[111];
		conv += panelSh[p_idx + 28] * templateSh[110];
		conv += panelSh[p_idx + 36] * templateSh[109];
		conv += panelSh[p_idx + 37] * templateSh[108];
		conv += panelSh[p_idx + 38] * templateSh[107];
		conv += panelSh[p_idx + 39] * templateSh[106];
		conv += panelSh[p_idx + 40] * templateSh[105];
		conv += panelSh[p_idx + 48] * templateSh[104];
		conv += panelSh[p_idx + 49] * templateSh[103];
		conv += panelSh[p_idx + 50] * templateSh[102];
		conv += panelSh[p_idx + 51] * templateSh[101];
		conv += panelSh[p_idx + 52] * templateSh[100];
		conv += panelSh[p_idx + 144] * templateSh[99];
		conv += panelSh[p_idx + 145] * templateSh[98];
		conv += panelSh[p_idx + 146] * templateSh[97];
		conv += panelSh[p_idx + 147] * templateSh[96];
		conv += panelSh[p_idx + 148] * templateSh[95];
		conv += panelSh[p_idx + 156] * templateSh[94];
		conv += panelSh[p_idx + 157] * templateSh[93];
		conv += panelSh[p_idx + 158] * templateSh[92];
		conv += panelSh[p_idx + 159] * templateSh[91];
		conv += panelSh[p_idx + 160] * templateSh[90];
		conv += panelSh[p_idx + 168] * templateSh[89];
		conv += panelSh[p_idx + 169] * templateSh[88];
		conv += panelSh[p_idx + 170] * templateSh[87];
		conv += panelSh[p_idx + 171] * templateSh[86];
		conv += panelSh[p_idx + 172] * templateSh[85];
		conv += panelSh[p_idx + 180] * templateSh[84];
		conv += panelSh[p_idx + 181] * templateSh[83];
		conv += panelSh[p_idx + 182] * templateSh[82];
		conv += panelSh[p_idx + 183] * templateSh[81];
		conv += panelSh[p_idx + 184] * templateSh[80];
		conv += panelSh[p_idx + 192] * templateSh[79];
		conv += panelSh[p_idx + 193] * templateSh[78];
		conv += panelSh[p_idx + 194] * templateSh[77];
		conv += panelSh[p_idx + 195] * templateSh[76];
		conv += panelSh[p_idx + 196] * templateSh[75];
		conv += panelSh[p_idx + 288] * templateSh[74];
		conv += panelSh[p_idx + 289] * templateSh[73];
		conv += panelSh[p_idx + 290] * templateSh[72];
		conv += panelSh[p_idx + 291] * templateSh[71];
		conv += panelSh[p_idx + 292] * templateSh[70];
		conv += panelSh[p_idx + 300] * templateSh[69];
		conv += panelSh[p_idx + 301] * templateSh[68];
		conv += panelSh[p_idx + 302] * templateSh[67];
		conv += panelSh[p_idx + 303] * templateSh[66];
		conv += panelSh[p_idx + 304] * templateSh[65];
		conv += panelSh[p_idx + 312] * templateSh[64];
		conv += panelSh[p_idx + 313] * templateSh[63];
		conv += panelSh[p_idx + 314] * templateSh[62];
		conv += panelSh[p_idx + 315] * templateSh[61];
		conv += panelSh[p_idx + 316] * templateSh[60];
		conv += panelSh[p_idx + 324] * templateSh[59];
		conv += panelSh[p_idx + 325] * templateSh[58];
		conv += panelSh[p_idx + 326] * templateSh[57];
		conv += panelSh[p_idx + 327] * templateSh[56];
		conv += panelSh[p_idx + 328] * templateSh[55];
		conv += panelSh[p_idx + 336] * templateSh[54];
		conv += panelSh[p_idx + 337] * templateSh[53];
		conv += panelSh[p_idx + 338] * templateSh[52];
		conv += panelSh[p_idx + 339] * templateSh[51];
		conv += panelSh[p_idx + 340] * templateSh[50];
		conv += panelSh[p_idx + 432] * templateSh[49];
		conv += panelSh[p_idx + 433] * templateSh[48];
		conv += panelSh[p_idx + 434] * templateSh[47];
		conv += panelSh[p_idx + 435] * templateSh[46];
		conv += panelSh[p_idx + 436] * templateSh[45];
		conv += panelSh[p_idx + 444] * templateSh[44];
		conv += panelSh[p_idx + 445] * templateSh[43];
		conv += panelSh[p_idx + 446] * templateSh[42];
		conv += panelSh[p_idx + 447] * templateSh[41];
		conv += panelSh[p_idx + 448] * templateSh[40];
		conv += panelSh[p_idx + 456] * templateSh[39];
		conv += panelSh[p_idx + 457] * templateSh[38];
		conv += panelSh[p_idx + 458] * templateSh[37];
		conv += panelSh[p_idx + 459] * templateSh[36];
		conv += panelSh[p_idx + 460] * templateSh[35];
		conv += panelSh[p_idx + 468] * templateSh[34];
		conv += panelSh[p_idx + 469] * templateSh[33];
		conv += panelSh[p_idx + 470] * templateSh[32];
		conv += panelSh[p_idx + 471] * templateSh[31];
		conv += panelSh[p_idx + 472] * templateSh[30];
		conv += panelSh[p_idx + 480] * templateSh[29];
		conv += panelSh[p_idx + 481] * templateSh[28];
		conv += panelSh[p_idx + 482] * templateSh[27];
		conv += panelSh[p_idx + 483] * templateSh[26];
		conv += panelSh[p_idx + 484] * templateSh[25];
		conv += panelSh[p_idx + 576] * templateSh[24];
		conv += panelSh[p_idx + 577] * templateSh[23];
		conv += panelSh[p_idx + 578] * templateSh[22];
		conv += panelSh[p_idx + 579] * templateSh[21];
		conv += panelSh[p_idx + 580] * templateSh[20];
		conv += panelSh[p_idx + 588] * templateSh[19];
		conv += panelSh[p_idx + 589] * templateSh[18];
		conv += panelSh[p_idx + 590] * templateSh[17];
		conv += panelSh[p_idx + 591] * templateSh[16];
		conv += panelSh[p_idx + 592] * templateSh[15];
		conv += panelSh[p_idx + 600] * templateSh[14];
		conv += panelSh[p_idx + 601] * templateSh[13];
		conv += panelSh[p_idx + 602] * templateSh[12];
		conv += panelSh[p_idx + 603] * templateSh[11];
		conv += panelSh[p_idx + 604] * templateSh[10];
		conv += panelSh[p_idx + 612] * templateSh[9];
		conv += panelSh[p_idx + 613] * templateSh[8];
		conv += panelSh[p_idx + 614] * templateSh[7];
		conv += panelSh[p_idx + 615] * templateSh[6];
		conv += panelSh[p_idx + 616] * templateSh[5];
		conv += panelSh[p_idx + 624] * templateSh[4];
		conv += panelSh[p_idx + 625] * templateSh[3];
		conv += panelSh[p_idx + 626] * templateSh[2];
		conv += panelSh[p_idx + 627] * templateSh[1];
		conv += panelSh[p_idx + 628] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_5x5x5<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_5x5x5<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void convolution3d_kernel_6x6x6 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[2197];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<13; k+=8) {
		for (int j=threadIdx.y; j<13; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<13; i+=8) {
				panelSh[i + IMUL(j, 13) + IMUL(k, 169)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[216];
	if (threadIdx.x < 6 && threadIdx.y < 6 && threadIdx.z < 6) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,6) + IMUL(threadIdx.z,36);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,13) + IMUL(threadIdx.z,169);
		conv += panelSh[p_idx + 0] * templateSh[215];
		conv += panelSh[p_idx + 1] * templateSh[214];
		conv += panelSh[p_idx + 2] * templateSh[213];
		conv += panelSh[p_idx + 3] * templateSh[212];
		conv += panelSh[p_idx + 4] * templateSh[211];
		conv += panelSh[p_idx + 5] * templateSh[210];
		conv += panelSh[p_idx + 13] * templateSh[209];
		conv += panelSh[p_idx + 14] * templateSh[208];
		conv += panelSh[p_idx + 15] * templateSh[207];
		conv += panelSh[p_idx + 16] * templateSh[206];
		conv += panelSh[p_idx + 17] * templateSh[205];
		conv += panelSh[p_idx + 18] * templateSh[204];
		conv += panelSh[p_idx + 26] * templateSh[203];
		conv += panelSh[p_idx + 27] * templateSh[202];
		conv += panelSh[p_idx + 28] * templateSh[201];
		conv += panelSh[p_idx + 29] * templateSh[200];
		conv += panelSh[p_idx + 30] * templateSh[199];
		conv += panelSh[p_idx + 31] * templateSh[198];
		conv += panelSh[p_idx + 39] * templateSh[197];
		conv += panelSh[p_idx + 40] * templateSh[196];
		conv += panelSh[p_idx + 41] * templateSh[195];
		conv += panelSh[p_idx + 42] * templateSh[194];
		conv += panelSh[p_idx + 43] * templateSh[193];
		conv += panelSh[p_idx + 44] * templateSh[192];
		conv += panelSh[p_idx + 52] * templateSh[191];
		conv += panelSh[p_idx + 53] * templateSh[190];
		conv += panelSh[p_idx + 54] * templateSh[189];
		conv += panelSh[p_idx + 55] * templateSh[188];
		conv += panelSh[p_idx + 56] * templateSh[187];
		conv += panelSh[p_idx + 57] * templateSh[186];
		conv += panelSh[p_idx + 65] * templateSh[185];
		conv += panelSh[p_idx + 66] * templateSh[184];
		conv += panelSh[p_idx + 67] * templateSh[183];
		conv += panelSh[p_idx + 68] * templateSh[182];
		conv += panelSh[p_idx + 69] * templateSh[181];
		conv += panelSh[p_idx + 70] * templateSh[180];
		conv += panelSh[p_idx + 169] * templateSh[179];
		conv += panelSh[p_idx + 170] * templateSh[178];
		conv += panelSh[p_idx + 171] * templateSh[177];
		conv += panelSh[p_idx + 172] * templateSh[176];
		conv += panelSh[p_idx + 173] * templateSh[175];
		conv += panelSh[p_idx + 174] * templateSh[174];
		conv += panelSh[p_idx + 182] * templateSh[173];
		conv += panelSh[p_idx + 183] * templateSh[172];
		conv += panelSh[p_idx + 184] * templateSh[171];
		conv += panelSh[p_idx + 185] * templateSh[170];
		conv += panelSh[p_idx + 186] * templateSh[169];
		conv += panelSh[p_idx + 187] * templateSh[168];
		conv += panelSh[p_idx + 195] * templateSh[167];
		conv += panelSh[p_idx + 196] * templateSh[166];
		conv += panelSh[p_idx + 197] * templateSh[165];
		conv += panelSh[p_idx + 198] * templateSh[164];
		conv += panelSh[p_idx + 199] * templateSh[163];
		conv += panelSh[p_idx + 200] * templateSh[162];
		conv += panelSh[p_idx + 208] * templateSh[161];
		conv += panelSh[p_idx + 209] * templateSh[160];
		conv += panelSh[p_idx + 210] * templateSh[159];
		conv += panelSh[p_idx + 211] * templateSh[158];
		conv += panelSh[p_idx + 212] * templateSh[157];
		conv += panelSh[p_idx + 213] * templateSh[156];
		conv += panelSh[p_idx + 221] * templateSh[155];
		conv += panelSh[p_idx + 222] * templateSh[154];
		conv += panelSh[p_idx + 223] * templateSh[153];
		conv += panelSh[p_idx + 224] * templateSh[152];
		conv += panelSh[p_idx + 225] * templateSh[151];
		conv += panelSh[p_idx + 226] * templateSh[150];
		conv += panelSh[p_idx + 234] * templateSh[149];
		conv += panelSh[p_idx + 235] * templateSh[148];
		conv += panelSh[p_idx + 236] * templateSh[147];
		conv += panelSh[p_idx + 237] * templateSh[146];
		conv += panelSh[p_idx + 238] * templateSh[145];
		conv += panelSh[p_idx + 239] * templateSh[144];
		conv += panelSh[p_idx + 338] * templateSh[143];
		conv += panelSh[p_idx + 339] * templateSh[142];
		conv += panelSh[p_idx + 340] * templateSh[141];
		conv += panelSh[p_idx + 341] * templateSh[140];
		conv += panelSh[p_idx + 342] * templateSh[139];
		conv += panelSh[p_idx + 343] * templateSh[138];
		conv += panelSh[p_idx + 351] * templateSh[137];
		conv += panelSh[p_idx + 352] * templateSh[136];
		conv += panelSh[p_idx + 353] * templateSh[135];
		conv += panelSh[p_idx + 354] * templateSh[134];
		conv += panelSh[p_idx + 355] * templateSh[133];
		conv += panelSh[p_idx + 356] * templateSh[132];
		conv += panelSh[p_idx + 364] * templateSh[131];
		conv += panelSh[p_idx + 365] * templateSh[130];
		conv += panelSh[p_idx + 366] * templateSh[129];
		conv += panelSh[p_idx + 367] * templateSh[128];
		conv += panelSh[p_idx + 368] * templateSh[127];
		conv += panelSh[p_idx + 369] * templateSh[126];
		conv += panelSh[p_idx + 377] * templateSh[125];
		conv += panelSh[p_idx + 378] * templateSh[124];
		conv += panelSh[p_idx + 379] * templateSh[123];
		conv += panelSh[p_idx + 380] * templateSh[122];
		conv += panelSh[p_idx + 381] * templateSh[121];
		conv += panelSh[p_idx + 382] * templateSh[120];
		conv += panelSh[p_idx + 390] * templateSh[119];
		conv += panelSh[p_idx + 391] * templateSh[118];
		conv += panelSh[p_idx + 392] * templateSh[117];
		conv += panelSh[p_idx + 393] * templateSh[116];
		conv += panelSh[p_idx + 394] * templateSh[115];
		conv += panelSh[p_idx + 395] * templateSh[114];
		conv += panelSh[p_idx + 403] * templateSh[113];
		conv += panelSh[p_idx + 404] * templateSh[112];
		conv += panelSh[p_idx + 405] * templateSh[111];
		conv += panelSh[p_idx + 406] * templateSh[110];
		conv += panelSh[p_idx + 407] * templateSh[109];
		conv += panelSh[p_idx + 408] * templateSh[108];
		conv += panelSh[p_idx + 507] * templateSh[107];
		conv += panelSh[p_idx + 508] * templateSh[106];
		conv += panelSh[p_idx + 509] * templateSh[105];
		conv += panelSh[p_idx + 510] * templateSh[104];
		conv += panelSh[p_idx + 511] * templateSh[103];
		conv += panelSh[p_idx + 512] * templateSh[102];
		conv += panelSh[p_idx + 520] * templateSh[101];
		conv += panelSh[p_idx + 521] * templateSh[100];
		conv += panelSh[p_idx + 522] * templateSh[99];
		conv += panelSh[p_idx + 523] * templateSh[98];
		conv += panelSh[p_idx + 524] * templateSh[97];
		conv += panelSh[p_idx + 525] * templateSh[96];
		conv += panelSh[p_idx + 533] * templateSh[95];
		conv += panelSh[p_idx + 534] * templateSh[94];
		conv += panelSh[p_idx + 535] * templateSh[93];
		conv += panelSh[p_idx + 536] * templateSh[92];
		conv += panelSh[p_idx + 537] * templateSh[91];
		conv += panelSh[p_idx + 538] * templateSh[90];
		conv += panelSh[p_idx + 546] * templateSh[89];
		conv += panelSh[p_idx + 547] * templateSh[88];
		conv += panelSh[p_idx + 548] * templateSh[87];
		conv += panelSh[p_idx + 549] * templateSh[86];
		conv += panelSh[p_idx + 550] * templateSh[85];
		conv += panelSh[p_idx + 551] * templateSh[84];
		conv += panelSh[p_idx + 559] * templateSh[83];
		conv += panelSh[p_idx + 560] * templateSh[82];
		conv += panelSh[p_idx + 561] * templateSh[81];
		conv += panelSh[p_idx + 562] * templateSh[80];
		conv += panelSh[p_idx + 563] * templateSh[79];
		conv += panelSh[p_idx + 564] * templateSh[78];
		conv += panelSh[p_idx + 572] * templateSh[77];
		conv += panelSh[p_idx + 573] * templateSh[76];
		conv += panelSh[p_idx + 574] * templateSh[75];
		conv += panelSh[p_idx + 575] * templateSh[74];
		conv += panelSh[p_idx + 576] * templateSh[73];
		conv += panelSh[p_idx + 577] * templateSh[72];
		conv += panelSh[p_idx + 676] * templateSh[71];
		conv += panelSh[p_idx + 677] * templateSh[70];
		conv += panelSh[p_idx + 678] * templateSh[69];
		conv += panelSh[p_idx + 679] * templateSh[68];
		conv += panelSh[p_idx + 680] * templateSh[67];
		conv += panelSh[p_idx + 681] * templateSh[66];
		conv += panelSh[p_idx + 689] * templateSh[65];
		conv += panelSh[p_idx + 690] * templateSh[64];
		conv += panelSh[p_idx + 691] * templateSh[63];
		conv += panelSh[p_idx + 692] * templateSh[62];
		conv += panelSh[p_idx + 693] * templateSh[61];
		conv += panelSh[p_idx + 694] * templateSh[60];
		conv += panelSh[p_idx + 702] * templateSh[59];
		conv += panelSh[p_idx + 703] * templateSh[58];
		conv += panelSh[p_idx + 704] * templateSh[57];
		conv += panelSh[p_idx + 705] * templateSh[56];
		conv += panelSh[p_idx + 706] * templateSh[55];
		conv += panelSh[p_idx + 707] * templateSh[54];
		conv += panelSh[p_idx + 715] * templateSh[53];
		conv += panelSh[p_idx + 716] * templateSh[52];
		conv += panelSh[p_idx + 717] * templateSh[51];
		conv += panelSh[p_idx + 718] * templateSh[50];
		conv += panelSh[p_idx + 719] * templateSh[49];
		conv += panelSh[p_idx + 720] * templateSh[48];
		conv += panelSh[p_idx + 728] * templateSh[47];
		conv += panelSh[p_idx + 729] * templateSh[46];
		conv += panelSh[p_idx + 730] * templateSh[45];
		conv += panelSh[p_idx + 731] * templateSh[44];
		conv += panelSh[p_idx + 732] * templateSh[43];
		conv += panelSh[p_idx + 733] * templateSh[42];
		conv += panelSh[p_idx + 741] * templateSh[41];
		conv += panelSh[p_idx + 742] * templateSh[40];
		conv += panelSh[p_idx + 743] * templateSh[39];
		conv += panelSh[p_idx + 744] * templateSh[38];
		conv += panelSh[p_idx + 745] * templateSh[37];
		conv += panelSh[p_idx + 746] * templateSh[36];
		conv += panelSh[p_idx + 845] * templateSh[35];
		conv += panelSh[p_idx + 846] * templateSh[34];
		conv += panelSh[p_idx + 847] * templateSh[33];
		conv += panelSh[p_idx + 848] * templateSh[32];
		conv += panelSh[p_idx + 849] * templateSh[31];
		conv += panelSh[p_idx + 850] * templateSh[30];
		conv += panelSh[p_idx + 858] * templateSh[29];
		conv += panelSh[p_idx + 859] * templateSh[28];
		conv += panelSh[p_idx + 860] * templateSh[27];
		conv += panelSh[p_idx + 861] * templateSh[26];
		conv += panelSh[p_idx + 862] * templateSh[25];
		conv += panelSh[p_idx + 863] * templateSh[24];
		conv += panelSh[p_idx + 871] * templateSh[23];
		conv += panelSh[p_idx + 872] * templateSh[22];
		conv += panelSh[p_idx + 873] * templateSh[21];
		conv += panelSh[p_idx + 874] * templateSh[20];
		conv += panelSh[p_idx + 875] * templateSh[19];
		conv += panelSh[p_idx + 876] * templateSh[18];
		conv += panelSh[p_idx + 884] * templateSh[17];
		conv += panelSh[p_idx + 885] * templateSh[16];
		conv += panelSh[p_idx + 886] * templateSh[15];
		conv += panelSh[p_idx + 887] * templateSh[14];
		conv += panelSh[p_idx + 888] * templateSh[13];
		conv += panelSh[p_idx + 889] * templateSh[12];
		conv += panelSh[p_idx + 897] * templateSh[11];
		conv += panelSh[p_idx + 898] * templateSh[10];
		conv += panelSh[p_idx + 899] * templateSh[9];
		conv += panelSh[p_idx + 900] * templateSh[8];
		conv += panelSh[p_idx + 901] * templateSh[7];
		conv += panelSh[p_idx + 902] * templateSh[6];
		conv += panelSh[p_idx + 910] * templateSh[5];
		conv += panelSh[p_idx + 911] * templateSh[4];
		conv += panelSh[p_idx + 912] * templateSh[3];
		conv += panelSh[p_idx + 913] * templateSh[2];
		conv += panelSh[p_idx + 914] * templateSh[1];
		conv += panelSh[p_idx + 915] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_6x6x6<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_6x6x6<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void convolution3d_kernel_7x7x7 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[2744];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<14; k+=8) {
		for (int j=threadIdx.y; j<14; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<14; i+=8) {
				panelSh[i + IMUL(j, 14) + IMUL(k, 196)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[343];
	if (threadIdx.x < 7 && threadIdx.y < 7 && threadIdx.z < 7) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,7) + IMUL(threadIdx.z,49);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,14) + IMUL(threadIdx.z,196);
		conv += panelSh[p_idx + 0] * templateSh[342];
		conv += panelSh[p_idx + 1] * templateSh[341];
		conv += panelSh[p_idx + 2] * templateSh[340];
		conv += panelSh[p_idx + 3] * templateSh[339];
		conv += panelSh[p_idx + 4] * templateSh[338];
		conv += panelSh[p_idx + 5] * templateSh[337];
		conv += panelSh[p_idx + 6] * templateSh[336];
		conv += panelSh[p_idx + 14] * templateSh[335];
		conv += panelSh[p_idx + 15] * templateSh[334];
		conv += panelSh[p_idx + 16] * templateSh[333];
		conv += panelSh[p_idx + 17] * templateSh[332];
		conv += panelSh[p_idx + 18] * templateSh[331];
		conv += panelSh[p_idx + 19] * templateSh[330];
		conv += panelSh[p_idx + 20] * templateSh[329];
		conv += panelSh[p_idx + 28] * templateSh[328];
		conv += panelSh[p_idx + 29] * templateSh[327];
		conv += panelSh[p_idx + 30] * templateSh[326];
		conv += panelSh[p_idx + 31] * templateSh[325];
		conv += panelSh[p_idx + 32] * templateSh[324];
		conv += panelSh[p_idx + 33] * templateSh[323];
		conv += panelSh[p_idx + 34] * templateSh[322];
		conv += panelSh[p_idx + 42] * templateSh[321];
		conv += panelSh[p_idx + 43] * templateSh[320];
		conv += panelSh[p_idx + 44] * templateSh[319];
		conv += panelSh[p_idx + 45] * templateSh[318];
		conv += panelSh[p_idx + 46] * templateSh[317];
		conv += panelSh[p_idx + 47] * templateSh[316];
		conv += panelSh[p_idx + 48] * templateSh[315];
		conv += panelSh[p_idx + 56] * templateSh[314];
		conv += panelSh[p_idx + 57] * templateSh[313];
		conv += panelSh[p_idx + 58] * templateSh[312];
		conv += panelSh[p_idx + 59] * templateSh[311];
		conv += panelSh[p_idx + 60] * templateSh[310];
		conv += panelSh[p_idx + 61] * templateSh[309];
		conv += panelSh[p_idx + 62] * templateSh[308];
		conv += panelSh[p_idx + 70] * templateSh[307];
		conv += panelSh[p_idx + 71] * templateSh[306];
		conv += panelSh[p_idx + 72] * templateSh[305];
		conv += panelSh[p_idx + 73] * templateSh[304];
		conv += panelSh[p_idx + 74] * templateSh[303];
		conv += panelSh[p_idx + 75] * templateSh[302];
		conv += panelSh[p_idx + 76] * templateSh[301];
		conv += panelSh[p_idx + 84] * templateSh[300];
		conv += panelSh[p_idx + 85] * templateSh[299];
		conv += panelSh[p_idx + 86] * templateSh[298];
		conv += panelSh[p_idx + 87] * templateSh[297];
		conv += panelSh[p_idx + 88] * templateSh[296];
		conv += panelSh[p_idx + 89] * templateSh[295];
		conv += panelSh[p_idx + 90] * templateSh[294];
		conv += panelSh[p_idx + 196] * templateSh[293];
		conv += panelSh[p_idx + 197] * templateSh[292];
		conv += panelSh[p_idx + 198] * templateSh[291];
		conv += panelSh[p_idx + 199] * templateSh[290];
		conv += panelSh[p_idx + 200] * templateSh[289];
		conv += panelSh[p_idx + 201] * templateSh[288];
		conv += panelSh[p_idx + 202] * templateSh[287];
		conv += panelSh[p_idx + 210] * templateSh[286];
		conv += panelSh[p_idx + 211] * templateSh[285];
		conv += panelSh[p_idx + 212] * templateSh[284];
		conv += panelSh[p_idx + 213] * templateSh[283];
		conv += panelSh[p_idx + 214] * templateSh[282];
		conv += panelSh[p_idx + 215] * templateSh[281];
		conv += panelSh[p_idx + 216] * templateSh[280];
		conv += panelSh[p_idx + 224] * templateSh[279];
		conv += panelSh[p_idx + 225] * templateSh[278];
		conv += panelSh[p_idx + 226] * templateSh[277];
		conv += panelSh[p_idx + 227] * templateSh[276];
		conv += panelSh[p_idx + 228] * templateSh[275];
		conv += panelSh[p_idx + 229] * templateSh[274];
		conv += panelSh[p_idx + 230] * templateSh[273];
		conv += panelSh[p_idx + 238] * templateSh[272];
		conv += panelSh[p_idx + 239] * templateSh[271];
		conv += panelSh[p_idx + 240] * templateSh[270];
		conv += panelSh[p_idx + 241] * templateSh[269];
		conv += panelSh[p_idx + 242] * templateSh[268];
		conv += panelSh[p_idx + 243] * templateSh[267];
		conv += panelSh[p_idx + 244] * templateSh[266];
		conv += panelSh[p_idx + 252] * templateSh[265];
		conv += panelSh[p_idx + 253] * templateSh[264];
		conv += panelSh[p_idx + 254] * templateSh[263];
		conv += panelSh[p_idx + 255] * templateSh[262];
		conv += panelSh[p_idx + 256] * templateSh[261];
		conv += panelSh[p_idx + 257] * templateSh[260];
		conv += panelSh[p_idx + 258] * templateSh[259];
		conv += panelSh[p_idx + 266] * templateSh[258];
		conv += panelSh[p_idx + 267] * templateSh[257];
		conv += panelSh[p_idx + 268] * templateSh[256];
		conv += panelSh[p_idx + 269] * templateSh[255];
		conv += panelSh[p_idx + 270] * templateSh[254];
		conv += panelSh[p_idx + 271] * templateSh[253];
		conv += panelSh[p_idx + 272] * templateSh[252];
		conv += panelSh[p_idx + 280] * templateSh[251];
		conv += panelSh[p_idx + 281] * templateSh[250];
		conv += panelSh[p_idx + 282] * templateSh[249];
		conv += panelSh[p_idx + 283] * templateSh[248];
		conv += panelSh[p_idx + 284] * templateSh[247];
		conv += panelSh[p_idx + 285] * templateSh[246];
		conv += panelSh[p_idx + 286] * templateSh[245];
		conv += panelSh[p_idx + 392] * templateSh[244];
		conv += panelSh[p_idx + 393] * templateSh[243];
		conv += panelSh[p_idx + 394] * templateSh[242];
		conv += panelSh[p_idx + 395] * templateSh[241];
		conv += panelSh[p_idx + 396] * templateSh[240];
		conv += panelSh[p_idx + 397] * templateSh[239];
		conv += panelSh[p_idx + 398] * templateSh[238];
		conv += panelSh[p_idx + 406] * templateSh[237];
		conv += panelSh[p_idx + 407] * templateSh[236];
		conv += panelSh[p_idx + 408] * templateSh[235];
		conv += panelSh[p_idx + 409] * templateSh[234];
		conv += panelSh[p_idx + 410] * templateSh[233];
		conv += panelSh[p_idx + 411] * templateSh[232];
		conv += panelSh[p_idx + 412] * templateSh[231];
		conv += panelSh[p_idx + 420] * templateSh[230];
		conv += panelSh[p_idx + 421] * templateSh[229];
		conv += panelSh[p_idx + 422] * templateSh[228];
		conv += panelSh[p_idx + 423] * templateSh[227];
		conv += panelSh[p_idx + 424] * templateSh[226];
		conv += panelSh[p_idx + 425] * templateSh[225];
		conv += panelSh[p_idx + 426] * templateSh[224];
		conv += panelSh[p_idx + 434] * templateSh[223];
		conv += panelSh[p_idx + 435] * templateSh[222];
		conv += panelSh[p_idx + 436] * templateSh[221];
		conv += panelSh[p_idx + 437] * templateSh[220];
		conv += panelSh[p_idx + 438] * templateSh[219];
		conv += panelSh[p_idx + 439] * templateSh[218];
		conv += panelSh[p_idx + 440] * templateSh[217];
		conv += panelSh[p_idx + 448] * templateSh[216];
		conv += panelSh[p_idx + 449] * templateSh[215];
		conv += panelSh[p_idx + 450] * templateSh[214];
		conv += panelSh[p_idx + 451] * templateSh[213];
		conv += panelSh[p_idx + 452] * templateSh[212];
		conv += panelSh[p_idx + 453] * templateSh[211];
		conv += panelSh[p_idx + 454] * templateSh[210];
		conv += panelSh[p_idx + 462] * templateSh[209];
		conv += panelSh[p_idx + 463] * templateSh[208];
		conv += panelSh[p_idx + 464] * templateSh[207];
		conv += panelSh[p_idx + 465] * templateSh[206];
		conv += panelSh[p_idx + 466] * templateSh[205];
		conv += panelSh[p_idx + 467] * templateSh[204];
		conv += panelSh[p_idx + 468] * templateSh[203];
		conv += panelSh[p_idx + 476] * templateSh[202];
		conv += panelSh[p_idx + 477] * templateSh[201];
		conv += panelSh[p_idx + 478] * templateSh[200];
		conv += panelSh[p_idx + 479] * templateSh[199];
		conv += panelSh[p_idx + 480] * templateSh[198];
		conv += panelSh[p_idx + 481] * templateSh[197];
		conv += panelSh[p_idx + 482] * templateSh[196];
		conv += panelSh[p_idx + 588] * templateSh[195];
		conv += panelSh[p_idx + 589] * templateSh[194];
		conv += panelSh[p_idx + 590] * templateSh[193];
		conv += panelSh[p_idx + 591] * templateSh[192];
		conv += panelSh[p_idx + 592] * templateSh[191];
		conv += panelSh[p_idx + 593] * templateSh[190];
		conv += panelSh[p_idx + 594] * templateSh[189];
		conv += panelSh[p_idx + 602] * templateSh[188];
		conv += panelSh[p_idx + 603] * templateSh[187];
		conv += panelSh[p_idx + 604] * templateSh[186];
		conv += panelSh[p_idx + 605] * templateSh[185];
		conv += panelSh[p_idx + 606] * templateSh[184];
		conv += panelSh[p_idx + 607] * templateSh[183];
		conv += panelSh[p_idx + 608] * templateSh[182];
		conv += panelSh[p_idx + 616] * templateSh[181];
		conv += panelSh[p_idx + 617] * templateSh[180];
		conv += panelSh[p_idx + 618] * templateSh[179];
		conv += panelSh[p_idx + 619] * templateSh[178];
		conv += panelSh[p_idx + 620] * templateSh[177];
		conv += panelSh[p_idx + 621] * templateSh[176];
		conv += panelSh[p_idx + 622] * templateSh[175];
		conv += panelSh[p_idx + 630] * templateSh[174];
		conv += panelSh[p_idx + 631] * templateSh[173];
		conv += panelSh[p_idx + 632] * templateSh[172];
		conv += panelSh[p_idx + 633] * templateSh[171];
		conv += panelSh[p_idx + 634] * templateSh[170];
		conv += panelSh[p_idx + 635] * templateSh[169];
		conv += panelSh[p_idx + 636] * templateSh[168];
		conv += panelSh[p_idx + 644] * templateSh[167];
		conv += panelSh[p_idx + 645] * templateSh[166];
		conv += panelSh[p_idx + 646] * templateSh[165];
		conv += panelSh[p_idx + 647] * templateSh[164];
		conv += panelSh[p_idx + 648] * templateSh[163];
		conv += panelSh[p_idx + 649] * templateSh[162];
		conv += panelSh[p_idx + 650] * templateSh[161];
		conv += panelSh[p_idx + 658] * templateSh[160];
		conv += panelSh[p_idx + 659] * templateSh[159];
		conv += panelSh[p_idx + 660] * templateSh[158];
		conv += panelSh[p_idx + 661] * templateSh[157];
		conv += panelSh[p_idx + 662] * templateSh[156];
		conv += panelSh[p_idx + 663] * templateSh[155];
		conv += panelSh[p_idx + 664] * templateSh[154];
		conv += panelSh[p_idx + 672] * templateSh[153];
		conv += panelSh[p_idx + 673] * templateSh[152];
		conv += panelSh[p_idx + 674] * templateSh[151];
		conv += panelSh[p_idx + 675] * templateSh[150];
		conv += panelSh[p_idx + 676] * templateSh[149];
		conv += panelSh[p_idx + 677] * templateSh[148];
		conv += panelSh[p_idx + 678] * templateSh[147];
		conv += panelSh[p_idx + 784] * templateSh[146];
		conv += panelSh[p_idx + 785] * templateSh[145];
		conv += panelSh[p_idx + 786] * templateSh[144];
		conv += panelSh[p_idx + 787] * templateSh[143];
		conv += panelSh[p_idx + 788] * templateSh[142];
		conv += panelSh[p_idx + 789] * templateSh[141];
		conv += panelSh[p_idx + 790] * templateSh[140];
		conv += panelSh[p_idx + 798] * templateSh[139];
		conv += panelSh[p_idx + 799] * templateSh[138];
		conv += panelSh[p_idx + 800] * templateSh[137];
		conv += panelSh[p_idx + 801] * templateSh[136];
		conv += panelSh[p_idx + 802] * templateSh[135];
		conv += panelSh[p_idx + 803] * templateSh[134];
		conv += panelSh[p_idx + 804] * templateSh[133];
		conv += panelSh[p_idx + 812] * templateSh[132];
		conv += panelSh[p_idx + 813] * templateSh[131];
		conv += panelSh[p_idx + 814] * templateSh[130];
		conv += panelSh[p_idx + 815] * templateSh[129];
		conv += panelSh[p_idx + 816] * templateSh[128];
		conv += panelSh[p_idx + 817] * templateSh[127];
		conv += panelSh[p_idx + 818] * templateSh[126];
		conv += panelSh[p_idx + 826] * templateSh[125];
		conv += panelSh[p_idx + 827] * templateSh[124];
		conv += panelSh[p_idx + 828] * templateSh[123];
		conv += panelSh[p_idx + 829] * templateSh[122];
		conv += panelSh[p_idx + 830] * templateSh[121];
		conv += panelSh[p_idx + 831] * templateSh[120];
		conv += panelSh[p_idx + 832] * templateSh[119];
		conv += panelSh[p_idx + 840] * templateSh[118];
		conv += panelSh[p_idx + 841] * templateSh[117];
		conv += panelSh[p_idx + 842] * templateSh[116];
		conv += panelSh[p_idx + 843] * templateSh[115];
		conv += panelSh[p_idx + 844] * templateSh[114];
		conv += panelSh[p_idx + 845] * templateSh[113];
		conv += panelSh[p_idx + 846] * templateSh[112];
		conv += panelSh[p_idx + 854] * templateSh[111];
		conv += panelSh[p_idx + 855] * templateSh[110];
		conv += panelSh[p_idx + 856] * templateSh[109];
		conv += panelSh[p_idx + 857] * templateSh[108];
		conv += panelSh[p_idx + 858] * templateSh[107];
		conv += panelSh[p_idx + 859] * templateSh[106];
		conv += panelSh[p_idx + 860] * templateSh[105];
		conv += panelSh[p_idx + 868] * templateSh[104];
		conv += panelSh[p_idx + 869] * templateSh[103];
		conv += panelSh[p_idx + 870] * templateSh[102];
		conv += panelSh[p_idx + 871] * templateSh[101];
		conv += panelSh[p_idx + 872] * templateSh[100];
		conv += panelSh[p_idx + 873] * templateSh[99];
		conv += panelSh[p_idx + 874] * templateSh[98];
		conv += panelSh[p_idx + 980] * templateSh[97];
		conv += panelSh[p_idx + 981] * templateSh[96];
		conv += panelSh[p_idx + 982] * templateSh[95];
		conv += panelSh[p_idx + 983] * templateSh[94];
		conv += panelSh[p_idx + 984] * templateSh[93];
		conv += panelSh[p_idx + 985] * templateSh[92];
		conv += panelSh[p_idx + 986] * templateSh[91];
		conv += panelSh[p_idx + 994] * templateSh[90];
		conv += panelSh[p_idx + 995] * templateSh[89];
		conv += panelSh[p_idx + 996] * templateSh[88];
		conv += panelSh[p_idx + 997] * templateSh[87];
		conv += panelSh[p_idx + 998] * templateSh[86];
		conv += panelSh[p_idx + 999] * templateSh[85];
		conv += panelSh[p_idx + 1000] * templateSh[84];
		conv += panelSh[p_idx + 1008] * templateSh[83];
		conv += panelSh[p_idx + 1009] * templateSh[82];
		conv += panelSh[p_idx + 1010] * templateSh[81];
		conv += panelSh[p_idx + 1011] * templateSh[80];
		conv += panelSh[p_idx + 1012] * templateSh[79];
		conv += panelSh[p_idx + 1013] * templateSh[78];
		conv += panelSh[p_idx + 1014] * templateSh[77];
		conv += panelSh[p_idx + 1022] * templateSh[76];
		conv += panelSh[p_idx + 1023] * templateSh[75];
		conv += panelSh[p_idx + 1024] * templateSh[74];
		conv += panelSh[p_idx + 1025] * templateSh[73];
		conv += panelSh[p_idx + 1026] * templateSh[72];
		conv += panelSh[p_idx + 1027] * templateSh[71];
		conv += panelSh[p_idx + 1028] * templateSh[70];
		conv += panelSh[p_idx + 1036] * templateSh[69];
		conv += panelSh[p_idx + 1037] * templateSh[68];
		conv += panelSh[p_idx + 1038] * templateSh[67];
		conv += panelSh[p_idx + 1039] * templateSh[66];
		conv += panelSh[p_idx + 1040] * templateSh[65];
		conv += panelSh[p_idx + 1041] * templateSh[64];
		conv += panelSh[p_idx + 1042] * templateSh[63];
		conv += panelSh[p_idx + 1050] * templateSh[62];
		conv += panelSh[p_idx + 1051] * templateSh[61];
		conv += panelSh[p_idx + 1052] * templateSh[60];
		conv += panelSh[p_idx + 1053] * templateSh[59];
		conv += panelSh[p_idx + 1054] * templateSh[58];
		conv += panelSh[p_idx + 1055] * templateSh[57];
		conv += panelSh[p_idx + 1056] * templateSh[56];
		conv += panelSh[p_idx + 1064] * templateSh[55];
		conv += panelSh[p_idx + 1065] * templateSh[54];
		conv += panelSh[p_idx + 1066] * templateSh[53];
		conv += panelSh[p_idx + 1067] * templateSh[52];
		conv += panelSh[p_idx + 1068] * templateSh[51];
		conv += panelSh[p_idx + 1069] * templateSh[50];
		conv += panelSh[p_idx + 1070] * templateSh[49];
		conv += panelSh[p_idx + 1176] * templateSh[48];
		conv += panelSh[p_idx + 1177] * templateSh[47];
		conv += panelSh[p_idx + 1178] * templateSh[46];
		conv += panelSh[p_idx + 1179] * templateSh[45];
		conv += panelSh[p_idx + 1180] * templateSh[44];
		conv += panelSh[p_idx + 1181] * templateSh[43];
		conv += panelSh[p_idx + 1182] * templateSh[42];
		conv += panelSh[p_idx + 1190] * templateSh[41];
		conv += panelSh[p_idx + 1191] * templateSh[40];
		conv += panelSh[p_idx + 1192] * templateSh[39];
		conv += panelSh[p_idx + 1193] * templateSh[38];
		conv += panelSh[p_idx + 1194] * templateSh[37];
		conv += panelSh[p_idx + 1195] * templateSh[36];
		conv += panelSh[p_idx + 1196] * templateSh[35];
		conv += panelSh[p_idx + 1204] * templateSh[34];
		conv += panelSh[p_idx + 1205] * templateSh[33];
		conv += panelSh[p_idx + 1206] * templateSh[32];
		conv += panelSh[p_idx + 1207] * templateSh[31];
		conv += panelSh[p_idx + 1208] * templateSh[30];
		conv += panelSh[p_idx + 1209] * templateSh[29];
		conv += panelSh[p_idx + 1210] * templateSh[28];
		conv += panelSh[p_idx + 1218] * templateSh[27];
		conv += panelSh[p_idx + 1219] * templateSh[26];
		conv += panelSh[p_idx + 1220] * templateSh[25];
		conv += panelSh[p_idx + 1221] * templateSh[24];
		conv += panelSh[p_idx + 1222] * templateSh[23];
		conv += panelSh[p_idx + 1223] * templateSh[22];
		conv += panelSh[p_idx + 1224] * templateSh[21];
		conv += panelSh[p_idx + 1232] * templateSh[20];
		conv += panelSh[p_idx + 1233] * templateSh[19];
		conv += panelSh[p_idx + 1234] * templateSh[18];
		conv += panelSh[p_idx + 1235] * templateSh[17];
		conv += panelSh[p_idx + 1236] * templateSh[16];
		conv += panelSh[p_idx + 1237] * templateSh[15];
		conv += panelSh[p_idx + 1238] * templateSh[14];
		conv += panelSh[p_idx + 1246] * templateSh[13];
		conv += panelSh[p_idx + 1247] * templateSh[12];
		conv += panelSh[p_idx + 1248] * templateSh[11];
		conv += panelSh[p_idx + 1249] * templateSh[10];
		conv += panelSh[p_idx + 1250] * templateSh[9];
		conv += panelSh[p_idx + 1251] * templateSh[8];
		conv += panelSh[p_idx + 1252] * templateSh[7];
		conv += panelSh[p_idx + 1260] * templateSh[6];
		conv += panelSh[p_idx + 1261] * templateSh[5];
		conv += panelSh[p_idx + 1262] * templateSh[4];
		conv += panelSh[p_idx + 1263] * templateSh[3];
		conv += panelSh[p_idx + 1264] * templateSh[2];
		conv += panelSh[p_idx + 1265] * templateSh[1];
		conv += panelSh[p_idx + 1266] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_7x7x7<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_7x7x7<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void convolution3d_kernel_8x8x8 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[3375];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<15; k+=8) {
		for (int j=threadIdx.y; j<15; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<15; i+=8) {
				panelSh[i + IMUL(j, 15) + IMUL(k, 225)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[512];
	if (threadIdx.x < 8 && threadIdx.y < 8 && threadIdx.z < 8) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,8) + IMUL(threadIdx.z,64);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,15) + IMUL(threadIdx.z,225);
		conv += panelSh[p_idx + 0] * templateSh[511];
		conv += panelSh[p_idx + 1] * templateSh[510];
		conv += panelSh[p_idx + 2] * templateSh[509];
		conv += panelSh[p_idx + 3] * templateSh[508];
		conv += panelSh[p_idx + 4] * templateSh[507];
		conv += panelSh[p_idx + 5] * templateSh[506];
		conv += panelSh[p_idx + 6] * templateSh[505];
		conv += panelSh[p_idx + 7] * templateSh[504];
		conv += panelSh[p_idx + 15] * templateSh[503];
		conv += panelSh[p_idx + 16] * templateSh[502];
		conv += panelSh[p_idx + 17] * templateSh[501];
		conv += panelSh[p_idx + 18] * templateSh[500];
		conv += panelSh[p_idx + 19] * templateSh[499];
		conv += panelSh[p_idx + 20] * templateSh[498];
		conv += panelSh[p_idx + 21] * templateSh[497];
		conv += panelSh[p_idx + 22] * templateSh[496];
		conv += panelSh[p_idx + 30] * templateSh[495];
		conv += panelSh[p_idx + 31] * templateSh[494];
		conv += panelSh[p_idx + 32] * templateSh[493];
		conv += panelSh[p_idx + 33] * templateSh[492];
		conv += panelSh[p_idx + 34] * templateSh[491];
		conv += panelSh[p_idx + 35] * templateSh[490];
		conv += panelSh[p_idx + 36] * templateSh[489];
		conv += panelSh[p_idx + 37] * templateSh[488];
		conv += panelSh[p_idx + 45] * templateSh[487];
		conv += panelSh[p_idx + 46] * templateSh[486];
		conv += panelSh[p_idx + 47] * templateSh[485];
		conv += panelSh[p_idx + 48] * templateSh[484];
		conv += panelSh[p_idx + 49] * templateSh[483];
		conv += panelSh[p_idx + 50] * templateSh[482];
		conv += panelSh[p_idx + 51] * templateSh[481];
		conv += panelSh[p_idx + 52] * templateSh[480];
		conv += panelSh[p_idx + 60] * templateSh[479];
		conv += panelSh[p_idx + 61] * templateSh[478];
		conv += panelSh[p_idx + 62] * templateSh[477];
		conv += panelSh[p_idx + 63] * templateSh[476];
		conv += panelSh[p_idx + 64] * templateSh[475];
		conv += panelSh[p_idx + 65] * templateSh[474];
		conv += panelSh[p_idx + 66] * templateSh[473];
		conv += panelSh[p_idx + 67] * templateSh[472];
		conv += panelSh[p_idx + 75] * templateSh[471];
		conv += panelSh[p_idx + 76] * templateSh[470];
		conv += panelSh[p_idx + 77] * templateSh[469];
		conv += panelSh[p_idx + 78] * templateSh[468];
		conv += panelSh[p_idx + 79] * templateSh[467];
		conv += panelSh[p_idx + 80] * templateSh[466];
		conv += panelSh[p_idx + 81] * templateSh[465];
		conv += panelSh[p_idx + 82] * templateSh[464];
		conv += panelSh[p_idx + 90] * templateSh[463];
		conv += panelSh[p_idx + 91] * templateSh[462];
		conv += panelSh[p_idx + 92] * templateSh[461];
		conv += panelSh[p_idx + 93] * templateSh[460];
		conv += panelSh[p_idx + 94] * templateSh[459];
		conv += panelSh[p_idx + 95] * templateSh[458];
		conv += panelSh[p_idx + 96] * templateSh[457];
		conv += panelSh[p_idx + 97] * templateSh[456];
		conv += panelSh[p_idx + 105] * templateSh[455];
		conv += panelSh[p_idx + 106] * templateSh[454];
		conv += panelSh[p_idx + 107] * templateSh[453];
		conv += panelSh[p_idx + 108] * templateSh[452];
		conv += panelSh[p_idx + 109] * templateSh[451];
		conv += panelSh[p_idx + 110] * templateSh[450];
		conv += panelSh[p_idx + 111] * templateSh[449];
		conv += panelSh[p_idx + 112] * templateSh[448];
		conv += panelSh[p_idx + 225] * templateSh[447];
		conv += panelSh[p_idx + 226] * templateSh[446];
		conv += panelSh[p_idx + 227] * templateSh[445];
		conv += panelSh[p_idx + 228] * templateSh[444];
		conv += panelSh[p_idx + 229] * templateSh[443];
		conv += panelSh[p_idx + 230] * templateSh[442];
		conv += panelSh[p_idx + 231] * templateSh[441];
		conv += panelSh[p_idx + 232] * templateSh[440];
		conv += panelSh[p_idx + 240] * templateSh[439];
		conv += panelSh[p_idx + 241] * templateSh[438];
		conv += panelSh[p_idx + 242] * templateSh[437];
		conv += panelSh[p_idx + 243] * templateSh[436];
		conv += panelSh[p_idx + 244] * templateSh[435];
		conv += panelSh[p_idx + 245] * templateSh[434];
		conv += panelSh[p_idx + 246] * templateSh[433];
		conv += panelSh[p_idx + 247] * templateSh[432];
		conv += panelSh[p_idx + 255] * templateSh[431];
		conv += panelSh[p_idx + 256] * templateSh[430];
		conv += panelSh[p_idx + 257] * templateSh[429];
		conv += panelSh[p_idx + 258] * templateSh[428];
		conv += panelSh[p_idx + 259] * templateSh[427];
		conv += panelSh[p_idx + 260] * templateSh[426];
		conv += panelSh[p_idx + 261] * templateSh[425];
		conv += panelSh[p_idx + 262] * templateSh[424];
		conv += panelSh[p_idx + 270] * templateSh[423];
		conv += panelSh[p_idx + 271] * templateSh[422];
		conv += panelSh[p_idx + 272] * templateSh[421];
		conv += panelSh[p_idx + 273] * templateSh[420];
		conv += panelSh[p_idx + 274] * templateSh[419];
		conv += panelSh[p_idx + 275] * templateSh[418];
		conv += panelSh[p_idx + 276] * templateSh[417];
		conv += panelSh[p_idx + 277] * templateSh[416];
		conv += panelSh[p_idx + 285] * templateSh[415];
		conv += panelSh[p_idx + 286] * templateSh[414];
		conv += panelSh[p_idx + 287] * templateSh[413];
		conv += panelSh[p_idx + 288] * templateSh[412];
		conv += panelSh[p_idx + 289] * templateSh[411];
		conv += panelSh[p_idx + 290] * templateSh[410];
		conv += panelSh[p_idx + 291] * templateSh[409];
		conv += panelSh[p_idx + 292] * templateSh[408];
		conv += panelSh[p_idx + 300] * templateSh[407];
		conv += panelSh[p_idx + 301] * templateSh[406];
		conv += panelSh[p_idx + 302] * templateSh[405];
		conv += panelSh[p_idx + 303] * templateSh[404];
		conv += panelSh[p_idx + 304] * templateSh[403];
		conv += panelSh[p_idx + 305] * templateSh[402];
		conv += panelSh[p_idx + 306] * templateSh[401];
		conv += panelSh[p_idx + 307] * templateSh[400];
		conv += panelSh[p_idx + 315] * templateSh[399];
		conv += panelSh[p_idx + 316] * templateSh[398];
		conv += panelSh[p_idx + 317] * templateSh[397];
		conv += panelSh[p_idx + 318] * templateSh[396];
		conv += panelSh[p_idx + 319] * templateSh[395];
		conv += panelSh[p_idx + 320] * templateSh[394];
		conv += panelSh[p_idx + 321] * templateSh[393];
		conv += panelSh[p_idx + 322] * templateSh[392];
		conv += panelSh[p_idx + 330] * templateSh[391];
		conv += panelSh[p_idx + 331] * templateSh[390];
		conv += panelSh[p_idx + 332] * templateSh[389];
		conv += panelSh[p_idx + 333] * templateSh[388];
		conv += panelSh[p_idx + 334] * templateSh[387];
		conv += panelSh[p_idx + 335] * templateSh[386];
		conv += panelSh[p_idx + 336] * templateSh[385];
		conv += panelSh[p_idx + 337] * templateSh[384];
		conv += panelSh[p_idx + 450] * templateSh[383];
		conv += panelSh[p_idx + 451] * templateSh[382];
		conv += panelSh[p_idx + 452] * templateSh[381];
		conv += panelSh[p_idx + 453] * templateSh[380];
		conv += panelSh[p_idx + 454] * templateSh[379];
		conv += panelSh[p_idx + 455] * templateSh[378];
		conv += panelSh[p_idx + 456] * templateSh[377];
		conv += panelSh[p_idx + 457] * templateSh[376];
		conv += panelSh[p_idx + 465] * templateSh[375];
		conv += panelSh[p_idx + 466] * templateSh[374];
		conv += panelSh[p_idx + 467] * templateSh[373];
		conv += panelSh[p_idx + 468] * templateSh[372];
		conv += panelSh[p_idx + 469] * templateSh[371];
		conv += panelSh[p_idx + 470] * templateSh[370];
		conv += panelSh[p_idx + 471] * templateSh[369];
		conv += panelSh[p_idx + 472] * templateSh[368];
		conv += panelSh[p_idx + 480] * templateSh[367];
		conv += panelSh[p_idx + 481] * templateSh[366];
		conv += panelSh[p_idx + 482] * templateSh[365];
		conv += panelSh[p_idx + 483] * templateSh[364];
		conv += panelSh[p_idx + 484] * templateSh[363];
		conv += panelSh[p_idx + 485] * templateSh[362];
		conv += panelSh[p_idx + 486] * templateSh[361];
		conv += panelSh[p_idx + 487] * templateSh[360];
		conv += panelSh[p_idx + 495] * templateSh[359];
		conv += panelSh[p_idx + 496] * templateSh[358];
		conv += panelSh[p_idx + 497] * templateSh[357];
		conv += panelSh[p_idx + 498] * templateSh[356];
		conv += panelSh[p_idx + 499] * templateSh[355];
		conv += panelSh[p_idx + 500] * templateSh[354];
		conv += panelSh[p_idx + 501] * templateSh[353];
		conv += panelSh[p_idx + 502] * templateSh[352];
		conv += panelSh[p_idx + 510] * templateSh[351];
		conv += panelSh[p_idx + 511] * templateSh[350];
		conv += panelSh[p_idx + 512] * templateSh[349];
		conv += panelSh[p_idx + 513] * templateSh[348];
		conv += panelSh[p_idx + 514] * templateSh[347];
		conv += panelSh[p_idx + 515] * templateSh[346];
		conv += panelSh[p_idx + 516] * templateSh[345];
		conv += panelSh[p_idx + 517] * templateSh[344];
		conv += panelSh[p_idx + 525] * templateSh[343];
		conv += panelSh[p_idx + 526] * templateSh[342];
		conv += panelSh[p_idx + 527] * templateSh[341];
		conv += panelSh[p_idx + 528] * templateSh[340];
		conv += panelSh[p_idx + 529] * templateSh[339];
		conv += panelSh[p_idx + 530] * templateSh[338];
		conv += panelSh[p_idx + 531] * templateSh[337];
		conv += panelSh[p_idx + 532] * templateSh[336];
		conv += panelSh[p_idx + 540] * templateSh[335];
		conv += panelSh[p_idx + 541] * templateSh[334];
		conv += panelSh[p_idx + 542] * templateSh[333];
		conv += panelSh[p_idx + 543] * templateSh[332];
		conv += panelSh[p_idx + 544] * templateSh[331];
		conv += panelSh[p_idx + 545] * templateSh[330];
		conv += panelSh[p_idx + 546] * templateSh[329];
		conv += panelSh[p_idx + 547] * templateSh[328];
		conv += panelSh[p_idx + 555] * templateSh[327];
		conv += panelSh[p_idx + 556] * templateSh[326];
		conv += panelSh[p_idx + 557] * templateSh[325];
		conv += panelSh[p_idx + 558] * templateSh[324];
		conv += panelSh[p_idx + 559] * templateSh[323];
		conv += panelSh[p_idx + 560] * templateSh[322];
		conv += panelSh[p_idx + 561] * templateSh[321];
		conv += panelSh[p_idx + 562] * templateSh[320];
		conv += panelSh[p_idx + 675] * templateSh[319];
		conv += panelSh[p_idx + 676] * templateSh[318];
		conv += panelSh[p_idx + 677] * templateSh[317];
		conv += panelSh[p_idx + 678] * templateSh[316];
		conv += panelSh[p_idx + 679] * templateSh[315];
		conv += panelSh[p_idx + 680] * templateSh[314];
		conv += panelSh[p_idx + 681] * templateSh[313];
		conv += panelSh[p_idx + 682] * templateSh[312];
		conv += panelSh[p_idx + 690] * templateSh[311];
		conv += panelSh[p_idx + 691] * templateSh[310];
		conv += panelSh[p_idx + 692] * templateSh[309];
		conv += panelSh[p_idx + 693] * templateSh[308];
		conv += panelSh[p_idx + 694] * templateSh[307];
		conv += panelSh[p_idx + 695] * templateSh[306];
		conv += panelSh[p_idx + 696] * templateSh[305];
		conv += panelSh[p_idx + 697] * templateSh[304];
		conv += panelSh[p_idx + 705] * templateSh[303];
		conv += panelSh[p_idx + 706] * templateSh[302];
		conv += panelSh[p_idx + 707] * templateSh[301];
		conv += panelSh[p_idx + 708] * templateSh[300];
		conv += panelSh[p_idx + 709] * templateSh[299];
		conv += panelSh[p_idx + 710] * templateSh[298];
		conv += panelSh[p_idx + 711] * templateSh[297];
		conv += panelSh[p_idx + 712] * templateSh[296];
		conv += panelSh[p_idx + 720] * templateSh[295];
		conv += panelSh[p_idx + 721] * templateSh[294];
		conv += panelSh[p_idx + 722] * templateSh[293];
		conv += panelSh[p_idx + 723] * templateSh[292];
		conv += panelSh[p_idx + 724] * templateSh[291];
		conv += panelSh[p_idx + 725] * templateSh[290];
		conv += panelSh[p_idx + 726] * templateSh[289];
		conv += panelSh[p_idx + 727] * templateSh[288];
		conv += panelSh[p_idx + 735] * templateSh[287];
		conv += panelSh[p_idx + 736] * templateSh[286];
		conv += panelSh[p_idx + 737] * templateSh[285];
		conv += panelSh[p_idx + 738] * templateSh[284];
		conv += panelSh[p_idx + 739] * templateSh[283];
		conv += panelSh[p_idx + 740] * templateSh[282];
		conv += panelSh[p_idx + 741] * templateSh[281];
		conv += panelSh[p_idx + 742] * templateSh[280];
		conv += panelSh[p_idx + 750] * templateSh[279];
		conv += panelSh[p_idx + 751] * templateSh[278];
		conv += panelSh[p_idx + 752] * templateSh[277];
		conv += panelSh[p_idx + 753] * templateSh[276];
		conv += panelSh[p_idx + 754] * templateSh[275];
		conv += panelSh[p_idx + 755] * templateSh[274];
		conv += panelSh[p_idx + 756] * templateSh[273];
		conv += panelSh[p_idx + 757] * templateSh[272];
		conv += panelSh[p_idx + 765] * templateSh[271];
		conv += panelSh[p_idx + 766] * templateSh[270];
		conv += panelSh[p_idx + 767] * templateSh[269];
		conv += panelSh[p_idx + 768] * templateSh[268];
		conv += panelSh[p_idx + 769] * templateSh[267];
		conv += panelSh[p_idx + 770] * templateSh[266];
		conv += panelSh[p_idx + 771] * templateSh[265];
		conv += panelSh[p_idx + 772] * templateSh[264];
		conv += panelSh[p_idx + 780] * templateSh[263];
		conv += panelSh[p_idx + 781] * templateSh[262];
		conv += panelSh[p_idx + 782] * templateSh[261];
		conv += panelSh[p_idx + 783] * templateSh[260];
		conv += panelSh[p_idx + 784] * templateSh[259];
		conv += panelSh[p_idx + 785] * templateSh[258];
		conv += panelSh[p_idx + 786] * templateSh[257];
		conv += panelSh[p_idx + 787] * templateSh[256];
		conv += panelSh[p_idx + 900] * templateSh[255];
		conv += panelSh[p_idx + 901] * templateSh[254];
		conv += panelSh[p_idx + 902] * templateSh[253];
		conv += panelSh[p_idx + 903] * templateSh[252];
		conv += panelSh[p_idx + 904] * templateSh[251];
		conv += panelSh[p_idx + 905] * templateSh[250];
		conv += panelSh[p_idx + 906] * templateSh[249];
		conv += panelSh[p_idx + 907] * templateSh[248];
		conv += panelSh[p_idx + 915] * templateSh[247];
		conv += panelSh[p_idx + 916] * templateSh[246];
		conv += panelSh[p_idx + 917] * templateSh[245];
		conv += panelSh[p_idx + 918] * templateSh[244];
		conv += panelSh[p_idx + 919] * templateSh[243];
		conv += panelSh[p_idx + 920] * templateSh[242];
		conv += panelSh[p_idx + 921] * templateSh[241];
		conv += panelSh[p_idx + 922] * templateSh[240];
		conv += panelSh[p_idx + 930] * templateSh[239];
		conv += panelSh[p_idx + 931] * templateSh[238];
		conv += panelSh[p_idx + 932] * templateSh[237];
		conv += panelSh[p_idx + 933] * templateSh[236];
		conv += panelSh[p_idx + 934] * templateSh[235];
		conv += panelSh[p_idx + 935] * templateSh[234];
		conv += panelSh[p_idx + 936] * templateSh[233];
		conv += panelSh[p_idx + 937] * templateSh[232];
		conv += panelSh[p_idx + 945] * templateSh[231];
		conv += panelSh[p_idx + 946] * templateSh[230];
		conv += panelSh[p_idx + 947] * templateSh[229];
		conv += panelSh[p_idx + 948] * templateSh[228];
		conv += panelSh[p_idx + 949] * templateSh[227];
		conv += panelSh[p_idx + 950] * templateSh[226];
		conv += panelSh[p_idx + 951] * templateSh[225];
		conv += panelSh[p_idx + 952] * templateSh[224];
		conv += panelSh[p_idx + 960] * templateSh[223];
		conv += panelSh[p_idx + 961] * templateSh[222];
		conv += panelSh[p_idx + 962] * templateSh[221];
		conv += panelSh[p_idx + 963] * templateSh[220];
		conv += panelSh[p_idx + 964] * templateSh[219];
		conv += panelSh[p_idx + 965] * templateSh[218];
		conv += panelSh[p_idx + 966] * templateSh[217];
		conv += panelSh[p_idx + 967] * templateSh[216];
		conv += panelSh[p_idx + 975] * templateSh[215];
		conv += panelSh[p_idx + 976] * templateSh[214];
		conv += panelSh[p_idx + 977] * templateSh[213];
		conv += panelSh[p_idx + 978] * templateSh[212];
		conv += panelSh[p_idx + 979] * templateSh[211];
		conv += panelSh[p_idx + 980] * templateSh[210];
		conv += panelSh[p_idx + 981] * templateSh[209];
		conv += panelSh[p_idx + 982] * templateSh[208];
		conv += panelSh[p_idx + 990] * templateSh[207];
		conv += panelSh[p_idx + 991] * templateSh[206];
		conv += panelSh[p_idx + 992] * templateSh[205];
		conv += panelSh[p_idx + 993] * templateSh[204];
		conv += panelSh[p_idx + 994] * templateSh[203];
		conv += panelSh[p_idx + 995] * templateSh[202];
		conv += panelSh[p_idx + 996] * templateSh[201];
		conv += panelSh[p_idx + 997] * templateSh[200];
		conv += panelSh[p_idx + 1005] * templateSh[199];
		conv += panelSh[p_idx + 1006] * templateSh[198];
		conv += panelSh[p_idx + 1007] * templateSh[197];
		conv += panelSh[p_idx + 1008] * templateSh[196];
		conv += panelSh[p_idx + 1009] * templateSh[195];
		conv += panelSh[p_idx + 1010] * templateSh[194];
		conv += panelSh[p_idx + 1011] * templateSh[193];
		conv += panelSh[p_idx + 1012] * templateSh[192];
		conv += panelSh[p_idx + 1125] * templateSh[191];
		conv += panelSh[p_idx + 1126] * templateSh[190];
		conv += panelSh[p_idx + 1127] * templateSh[189];
		conv += panelSh[p_idx + 1128] * templateSh[188];
		conv += panelSh[p_idx + 1129] * templateSh[187];
		conv += panelSh[p_idx + 1130] * templateSh[186];
		conv += panelSh[p_idx + 1131] * templateSh[185];
		conv += panelSh[p_idx + 1132] * templateSh[184];
		conv += panelSh[p_idx + 1140] * templateSh[183];
		conv += panelSh[p_idx + 1141] * templateSh[182];
		conv += panelSh[p_idx + 1142] * templateSh[181];
		conv += panelSh[p_idx + 1143] * templateSh[180];
		conv += panelSh[p_idx + 1144] * templateSh[179];
		conv += panelSh[p_idx + 1145] * templateSh[178];
		conv += panelSh[p_idx + 1146] * templateSh[177];
		conv += panelSh[p_idx + 1147] * templateSh[176];
		conv += panelSh[p_idx + 1155] * templateSh[175];
		conv += panelSh[p_idx + 1156] * templateSh[174];
		conv += panelSh[p_idx + 1157] * templateSh[173];
		conv += panelSh[p_idx + 1158] * templateSh[172];
		conv += panelSh[p_idx + 1159] * templateSh[171];
		conv += panelSh[p_idx + 1160] * templateSh[170];
		conv += panelSh[p_idx + 1161] * templateSh[169];
		conv += panelSh[p_idx + 1162] * templateSh[168];
		conv += panelSh[p_idx + 1170] * templateSh[167];
		conv += panelSh[p_idx + 1171] * templateSh[166];
		conv += panelSh[p_idx + 1172] * templateSh[165];
		conv += panelSh[p_idx + 1173] * templateSh[164];
		conv += panelSh[p_idx + 1174] * templateSh[163];
		conv += panelSh[p_idx + 1175] * templateSh[162];
		conv += panelSh[p_idx + 1176] * templateSh[161];
		conv += panelSh[p_idx + 1177] * templateSh[160];
		conv += panelSh[p_idx + 1185] * templateSh[159];
		conv += panelSh[p_idx + 1186] * templateSh[158];
		conv += panelSh[p_idx + 1187] * templateSh[157];
		conv += panelSh[p_idx + 1188] * templateSh[156];
		conv += panelSh[p_idx + 1189] * templateSh[155];
		conv += panelSh[p_idx + 1190] * templateSh[154];
		conv += panelSh[p_idx + 1191] * templateSh[153];
		conv += panelSh[p_idx + 1192] * templateSh[152];
		conv += panelSh[p_idx + 1200] * templateSh[151];
		conv += panelSh[p_idx + 1201] * templateSh[150];
		conv += panelSh[p_idx + 1202] * templateSh[149];
		conv += panelSh[p_idx + 1203] * templateSh[148];
		conv += panelSh[p_idx + 1204] * templateSh[147];
		conv += panelSh[p_idx + 1205] * templateSh[146];
		conv += panelSh[p_idx + 1206] * templateSh[145];
		conv += panelSh[p_idx + 1207] * templateSh[144];
		conv += panelSh[p_idx + 1215] * templateSh[143];
		conv += panelSh[p_idx + 1216] * templateSh[142];
		conv += panelSh[p_idx + 1217] * templateSh[141];
		conv += panelSh[p_idx + 1218] * templateSh[140];
		conv += panelSh[p_idx + 1219] * templateSh[139];
		conv += panelSh[p_idx + 1220] * templateSh[138];
		conv += panelSh[p_idx + 1221] * templateSh[137];
		conv += panelSh[p_idx + 1222] * templateSh[136];
		conv += panelSh[p_idx + 1230] * templateSh[135];
		conv += panelSh[p_idx + 1231] * templateSh[134];
		conv += panelSh[p_idx + 1232] * templateSh[133];
		conv += panelSh[p_idx + 1233] * templateSh[132];
		conv += panelSh[p_idx + 1234] * templateSh[131];
		conv += panelSh[p_idx + 1235] * templateSh[130];
		conv += panelSh[p_idx + 1236] * templateSh[129];
		conv += panelSh[p_idx + 1237] * templateSh[128];
		conv += panelSh[p_idx + 1350] * templateSh[127];
		conv += panelSh[p_idx + 1351] * templateSh[126];
		conv += panelSh[p_idx + 1352] * templateSh[125];
		conv += panelSh[p_idx + 1353] * templateSh[124];
		conv += panelSh[p_idx + 1354] * templateSh[123];
		conv += panelSh[p_idx + 1355] * templateSh[122];
		conv += panelSh[p_idx + 1356] * templateSh[121];
		conv += panelSh[p_idx + 1357] * templateSh[120];
		conv += panelSh[p_idx + 1365] * templateSh[119];
		conv += panelSh[p_idx + 1366] * templateSh[118];
		conv += panelSh[p_idx + 1367] * templateSh[117];
		conv += panelSh[p_idx + 1368] * templateSh[116];
		conv += panelSh[p_idx + 1369] * templateSh[115];
		conv += panelSh[p_idx + 1370] * templateSh[114];
		conv += panelSh[p_idx + 1371] * templateSh[113];
		conv += panelSh[p_idx + 1372] * templateSh[112];
		conv += panelSh[p_idx + 1380] * templateSh[111];
		conv += panelSh[p_idx + 1381] * templateSh[110];
		conv += panelSh[p_idx + 1382] * templateSh[109];
		conv += panelSh[p_idx + 1383] * templateSh[108];
		conv += panelSh[p_idx + 1384] * templateSh[107];
		conv += panelSh[p_idx + 1385] * templateSh[106];
		conv += panelSh[p_idx + 1386] * templateSh[105];
		conv += panelSh[p_idx + 1387] * templateSh[104];
		conv += panelSh[p_idx + 1395] * templateSh[103];
		conv += panelSh[p_idx + 1396] * templateSh[102];
		conv += panelSh[p_idx + 1397] * templateSh[101];
		conv += panelSh[p_idx + 1398] * templateSh[100];
		conv += panelSh[p_idx + 1399] * templateSh[99];
		conv += panelSh[p_idx + 1400] * templateSh[98];
		conv += panelSh[p_idx + 1401] * templateSh[97];
		conv += panelSh[p_idx + 1402] * templateSh[96];
		conv += panelSh[p_idx + 1410] * templateSh[95];
		conv += panelSh[p_idx + 1411] * templateSh[94];
		conv += panelSh[p_idx + 1412] * templateSh[93];
		conv += panelSh[p_idx + 1413] * templateSh[92];
		conv += panelSh[p_idx + 1414] * templateSh[91];
		conv += panelSh[p_idx + 1415] * templateSh[90];
		conv += panelSh[p_idx + 1416] * templateSh[89];
		conv += panelSh[p_idx + 1417] * templateSh[88];
		conv += panelSh[p_idx + 1425] * templateSh[87];
		conv += panelSh[p_idx + 1426] * templateSh[86];
		conv += panelSh[p_idx + 1427] * templateSh[85];
		conv += panelSh[p_idx + 1428] * templateSh[84];
		conv += panelSh[p_idx + 1429] * templateSh[83];
		conv += panelSh[p_idx + 1430] * templateSh[82];
		conv += panelSh[p_idx + 1431] * templateSh[81];
		conv += panelSh[p_idx + 1432] * templateSh[80];
		conv += panelSh[p_idx + 1440] * templateSh[79];
		conv += panelSh[p_idx + 1441] * templateSh[78];
		conv += panelSh[p_idx + 1442] * templateSh[77];
		conv += panelSh[p_idx + 1443] * templateSh[76];
		conv += panelSh[p_idx + 1444] * templateSh[75];
		conv += panelSh[p_idx + 1445] * templateSh[74];
		conv += panelSh[p_idx + 1446] * templateSh[73];
		conv += panelSh[p_idx + 1447] * templateSh[72];
		conv += panelSh[p_idx + 1455] * templateSh[71];
		conv += panelSh[p_idx + 1456] * templateSh[70];
		conv += panelSh[p_idx + 1457] * templateSh[69];
		conv += panelSh[p_idx + 1458] * templateSh[68];
		conv += panelSh[p_idx + 1459] * templateSh[67];
		conv += panelSh[p_idx + 1460] * templateSh[66];
		conv += panelSh[p_idx + 1461] * templateSh[65];
		conv += panelSh[p_idx + 1462] * templateSh[64];
		conv += panelSh[p_idx + 1575] * templateSh[63];
		conv += panelSh[p_idx + 1576] * templateSh[62];
		conv += panelSh[p_idx + 1577] * templateSh[61];
		conv += panelSh[p_idx + 1578] * templateSh[60];
		conv += panelSh[p_idx + 1579] * templateSh[59];
		conv += panelSh[p_idx + 1580] * templateSh[58];
		conv += panelSh[p_idx + 1581] * templateSh[57];
		conv += panelSh[p_idx + 1582] * templateSh[56];
		conv += panelSh[p_idx + 1590] * templateSh[55];
		conv += panelSh[p_idx + 1591] * templateSh[54];
		conv += panelSh[p_idx + 1592] * templateSh[53];
		conv += panelSh[p_idx + 1593] * templateSh[52];
		conv += panelSh[p_idx + 1594] * templateSh[51];
		conv += panelSh[p_idx + 1595] * templateSh[50];
		conv += panelSh[p_idx + 1596] * templateSh[49];
		conv += panelSh[p_idx + 1597] * templateSh[48];
		conv += panelSh[p_idx + 1605] * templateSh[47];
		conv += panelSh[p_idx + 1606] * templateSh[46];
		conv += panelSh[p_idx + 1607] * templateSh[45];
		conv += panelSh[p_idx + 1608] * templateSh[44];
		conv += panelSh[p_idx + 1609] * templateSh[43];
		conv += panelSh[p_idx + 1610] * templateSh[42];
		conv += panelSh[p_idx + 1611] * templateSh[41];
		conv += panelSh[p_idx + 1612] * templateSh[40];
		conv += panelSh[p_idx + 1620] * templateSh[39];
		conv += panelSh[p_idx + 1621] * templateSh[38];
		conv += panelSh[p_idx + 1622] * templateSh[37];
		conv += panelSh[p_idx + 1623] * templateSh[36];
		conv += panelSh[p_idx + 1624] * templateSh[35];
		conv += panelSh[p_idx + 1625] * templateSh[34];
		conv += panelSh[p_idx + 1626] * templateSh[33];
		conv += panelSh[p_idx + 1627] * templateSh[32];
		conv += panelSh[p_idx + 1635] * templateSh[31];
		conv += panelSh[p_idx + 1636] * templateSh[30];
		conv += panelSh[p_idx + 1637] * templateSh[29];
		conv += panelSh[p_idx + 1638] * templateSh[28];
		conv += panelSh[p_idx + 1639] * templateSh[27];
		conv += panelSh[p_idx + 1640] * templateSh[26];
		conv += panelSh[p_idx + 1641] * templateSh[25];
		conv += panelSh[p_idx + 1642] * templateSh[24];
		conv += panelSh[p_idx + 1650] * templateSh[23];
		conv += panelSh[p_idx + 1651] * templateSh[22];
		conv += panelSh[p_idx + 1652] * templateSh[21];
		conv += panelSh[p_idx + 1653] * templateSh[20];
		conv += panelSh[p_idx + 1654] * templateSh[19];
		conv += panelSh[p_idx + 1655] * templateSh[18];
		conv += panelSh[p_idx + 1656] * templateSh[17];
		conv += panelSh[p_idx + 1657] * templateSh[16];
		conv += panelSh[p_idx + 1665] * templateSh[15];
		conv += panelSh[p_idx + 1666] * templateSh[14];
		conv += panelSh[p_idx + 1667] * templateSh[13];
		conv += panelSh[p_idx + 1668] * templateSh[12];
		conv += panelSh[p_idx + 1669] * templateSh[11];
		conv += panelSh[p_idx + 1670] * templateSh[10];
		conv += panelSh[p_idx + 1671] * templateSh[9];
		conv += panelSh[p_idx + 1672] * templateSh[8];
		conv += panelSh[p_idx + 1680] * templateSh[7];
		conv += panelSh[p_idx + 1681] * templateSh[6];
		conv += panelSh[p_idx + 1682] * templateSh[5];
		conv += panelSh[p_idx + 1683] * templateSh[4];
		conv += panelSh[p_idx + 1684] * templateSh[3];
		conv += panelSh[p_idx + 1685] * templateSh[2];
		conv += panelSh[p_idx + 1686] * templateSh[1];
		conv += panelSh[p_idx + 1687] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW))] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution3d_kernel_8x8x8<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution3d_kernel_8x8x8<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

