
// Compare two 2D matrices
template <class flccPrecision>
double compare2d (flccPrecision *m_ref, flccPrecision *m_comp, flccSize imSize, flccSize temSize, int imCount)
{
	const int SH = imSize.h + temSize.h - 1;
	const int SW = imSize.w + temSize.w - 1;
	const int size = SH*SW*imCount;
	
	double sum = 0.0;
	double ref = 0.0;
	
	for (int i=0; i<size; i++) {
		sum += (m_ref[i] - m_comp[i]) * (m_ref[i] - m_comp[i]);
		ref += m_ref[i] * m_ref[i];
	}
	
	return sqrt(sum/ref);
} 

// Compare two 3D matrices
template <class flccPrecision>
double compare3d (flccPrecision *m_ref, flccPrecision *m_comp, flccSize imSize, flccSize temSize, int imCount)
{
	const int SH = imSize.h + temSize.h - 1;
	const int SW = imSize.w + temSize.w - 1;
	const int SD = imSize.d + temSize.d - 1;
	const int size = SH*SW*SD*imCount;
	
	double sum = 0.0;
	double ref = 0.0;
	
	for (int i=0; i<size; i++) {
		sum += (m_ref[i] - m_comp[i]) * (m_ref[i] - m_comp[i]);
		ref += m_ref[i] * m_ref[i];
	}
	
	return sqrt(sum/ref);
} 
