// This file is generated automatically. 

template <class flccPrecision>
__global__ void convolution2d_kernel_2x2 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[289];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<17; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<17; i+=16) {
			panelSh[IMUL(j, 17) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[4];
	if (threadIdx.x < 2 && threadIdx.y < 2) {
		const int jtwi = IMUL(threadIdx.y, 2) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 17);
		conv += panelSh[p_idx + 0] * templateSh[3];
		conv += panelSh[p_idx + 1] * templateSh[2];
		conv += panelSh[p_idx + 17] * templateSh[1];
		conv += panelSh[p_idx + 18] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_2x2<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_2x2<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_3x3 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[324];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<18; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<18; i+=16) {
			panelSh[IMUL(j, 18) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[9];
	if (threadIdx.x < 3 && threadIdx.y < 3) {
		const int jtwi = IMUL(threadIdx.y, 3) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 18);
		conv += panelSh[p_idx + 0] * templateSh[8];
		conv += panelSh[p_idx + 1] * templateSh[7];
		conv += panelSh[p_idx + 2] * templateSh[6];
		conv += panelSh[p_idx + 18] * templateSh[5];
		conv += panelSh[p_idx + 19] * templateSh[4];
		conv += panelSh[p_idx + 20] * templateSh[3];
		conv += panelSh[p_idx + 36] * templateSh[2];
		conv += panelSh[p_idx + 37] * templateSh[1];
		conv += panelSh[p_idx + 38] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_3x3<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_3x3<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_4x4 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[361];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<19; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<19; i+=16) {
			panelSh[IMUL(j, 19) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[16];
	if (threadIdx.x < 4 && threadIdx.y < 4) {
		const int jtwi = IMUL(threadIdx.y, 4) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 19);
		conv += panelSh[p_idx + 0] * templateSh[15];
		conv += panelSh[p_idx + 1] * templateSh[14];
		conv += panelSh[p_idx + 2] * templateSh[13];
		conv += panelSh[p_idx + 3] * templateSh[12];
		conv += panelSh[p_idx + 19] * templateSh[11];
		conv += panelSh[p_idx + 20] * templateSh[10];
		conv += panelSh[p_idx + 21] * templateSh[9];
		conv += panelSh[p_idx + 22] * templateSh[8];
		conv += panelSh[p_idx + 38] * templateSh[7];
		conv += panelSh[p_idx + 39] * templateSh[6];
		conv += panelSh[p_idx + 40] * templateSh[5];
		conv += panelSh[p_idx + 41] * templateSh[4];
		conv += panelSh[p_idx + 57] * templateSh[3];
		conv += panelSh[p_idx + 58] * templateSh[2];
		conv += panelSh[p_idx + 59] * templateSh[1];
		conv += panelSh[p_idx + 60] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_4x4<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_4x4<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_5x5 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[400];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<20; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<20; i+=16) {
			panelSh[IMUL(j, 20) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[25];
	if (threadIdx.x < 5 && threadIdx.y < 5) {
		const int jtwi = IMUL(threadIdx.y, 5) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 20);
		conv += panelSh[p_idx + 0] * templateSh[24];
		conv += panelSh[p_idx + 1] * templateSh[23];
		conv += panelSh[p_idx + 2] * templateSh[22];
		conv += panelSh[p_idx + 3] * templateSh[21];
		conv += panelSh[p_idx + 4] * templateSh[20];
		conv += panelSh[p_idx + 20] * templateSh[19];
		conv += panelSh[p_idx + 21] * templateSh[18];
		conv += panelSh[p_idx + 22] * templateSh[17];
		conv += panelSh[p_idx + 23] * templateSh[16];
		conv += panelSh[p_idx + 24] * templateSh[15];
		conv += panelSh[p_idx + 40] * templateSh[14];
		conv += panelSh[p_idx + 41] * templateSh[13];
		conv += panelSh[p_idx + 42] * templateSh[12];
		conv += panelSh[p_idx + 43] * templateSh[11];
		conv += panelSh[p_idx + 44] * templateSh[10];
		conv += panelSh[p_idx + 60] * templateSh[9];
		conv += panelSh[p_idx + 61] * templateSh[8];
		conv += panelSh[p_idx + 62] * templateSh[7];
		conv += panelSh[p_idx + 63] * templateSh[6];
		conv += panelSh[p_idx + 64] * templateSh[5];
		conv += panelSh[p_idx + 80] * templateSh[4];
		conv += panelSh[p_idx + 81] * templateSh[3];
		conv += panelSh[p_idx + 82] * templateSh[2];
		conv += panelSh[p_idx + 83] * templateSh[1];
		conv += panelSh[p_idx + 84] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_5x5<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_5x5<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_6x6 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[441];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<21; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<21; i+=16) {
			panelSh[IMUL(j, 21) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[36];
	if (threadIdx.x < 6 && threadIdx.y < 6) {
		const int jtwi = IMUL(threadIdx.y, 6) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 21);
		conv += panelSh[p_idx + 0] * templateSh[35];
		conv += panelSh[p_idx + 1] * templateSh[34];
		conv += panelSh[p_idx + 2] * templateSh[33];
		conv += panelSh[p_idx + 3] * templateSh[32];
		conv += panelSh[p_idx + 4] * templateSh[31];
		conv += panelSh[p_idx + 5] * templateSh[30];
		conv += panelSh[p_idx + 21] * templateSh[29];
		conv += panelSh[p_idx + 22] * templateSh[28];
		conv += panelSh[p_idx + 23] * templateSh[27];
		conv += panelSh[p_idx + 24] * templateSh[26];
		conv += panelSh[p_idx + 25] * templateSh[25];
		conv += panelSh[p_idx + 26] * templateSh[24];
		conv += panelSh[p_idx + 42] * templateSh[23];
		conv += panelSh[p_idx + 43] * templateSh[22];
		conv += panelSh[p_idx + 44] * templateSh[21];
		conv += panelSh[p_idx + 45] * templateSh[20];
		conv += panelSh[p_idx + 46] * templateSh[19];
		conv += panelSh[p_idx + 47] * templateSh[18];
		conv += panelSh[p_idx + 63] * templateSh[17];
		conv += panelSh[p_idx + 64] * templateSh[16];
		conv += panelSh[p_idx + 65] * templateSh[15];
		conv += panelSh[p_idx + 66] * templateSh[14];
		conv += panelSh[p_idx + 67] * templateSh[13];
		conv += panelSh[p_idx + 68] * templateSh[12];
		conv += panelSh[p_idx + 84] * templateSh[11];
		conv += panelSh[p_idx + 85] * templateSh[10];
		conv += panelSh[p_idx + 86] * templateSh[9];
		conv += panelSh[p_idx + 87] * templateSh[8];
		conv += panelSh[p_idx + 88] * templateSh[7];
		conv += panelSh[p_idx + 89] * templateSh[6];
		conv += panelSh[p_idx + 105] * templateSh[5];
		conv += panelSh[p_idx + 106] * templateSh[4];
		conv += panelSh[p_idx + 107] * templateSh[3];
		conv += panelSh[p_idx + 108] * templateSh[2];
		conv += panelSh[p_idx + 109] * templateSh[1];
		conv += panelSh[p_idx + 110] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_6x6<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_6x6<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_7x7 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[484];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<22; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<22; i+=16) {
			panelSh[IMUL(j, 22) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[49];
	if (threadIdx.x < 7 && threadIdx.y < 7) {
		const int jtwi = IMUL(threadIdx.y, 7) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 22);
		conv += panelSh[p_idx + 0] * templateSh[48];
		conv += panelSh[p_idx + 1] * templateSh[47];
		conv += panelSh[p_idx + 2] * templateSh[46];
		conv += panelSh[p_idx + 3] * templateSh[45];
		conv += panelSh[p_idx + 4] * templateSh[44];
		conv += panelSh[p_idx + 5] * templateSh[43];
		conv += panelSh[p_idx + 6] * templateSh[42];
		conv += panelSh[p_idx + 22] * templateSh[41];
		conv += panelSh[p_idx + 23] * templateSh[40];
		conv += panelSh[p_idx + 24] * templateSh[39];
		conv += panelSh[p_idx + 25] * templateSh[38];
		conv += panelSh[p_idx + 26] * templateSh[37];
		conv += panelSh[p_idx + 27] * templateSh[36];
		conv += panelSh[p_idx + 28] * templateSh[35];
		conv += panelSh[p_idx + 44] * templateSh[34];
		conv += panelSh[p_idx + 45] * templateSh[33];
		conv += panelSh[p_idx + 46] * templateSh[32];
		conv += panelSh[p_idx + 47] * templateSh[31];
		conv += panelSh[p_idx + 48] * templateSh[30];
		conv += panelSh[p_idx + 49] * templateSh[29];
		conv += panelSh[p_idx + 50] * templateSh[28];
		conv += panelSh[p_idx + 66] * templateSh[27];
		conv += panelSh[p_idx + 67] * templateSh[26];
		conv += panelSh[p_idx + 68] * templateSh[25];
		conv += panelSh[p_idx + 69] * templateSh[24];
		conv += panelSh[p_idx + 70] * templateSh[23];
		conv += panelSh[p_idx + 71] * templateSh[22];
		conv += panelSh[p_idx + 72] * templateSh[21];
		conv += panelSh[p_idx + 88] * templateSh[20];
		conv += panelSh[p_idx + 89] * templateSh[19];
		conv += panelSh[p_idx + 90] * templateSh[18];
		conv += panelSh[p_idx + 91] * templateSh[17];
		conv += panelSh[p_idx + 92] * templateSh[16];
		conv += panelSh[p_idx + 93] * templateSh[15];
		conv += panelSh[p_idx + 94] * templateSh[14];
		conv += panelSh[p_idx + 110] * templateSh[13];
		conv += panelSh[p_idx + 111] * templateSh[12];
		conv += panelSh[p_idx + 112] * templateSh[11];
		conv += panelSh[p_idx + 113] * templateSh[10];
		conv += panelSh[p_idx + 114] * templateSh[9];
		conv += panelSh[p_idx + 115] * templateSh[8];
		conv += panelSh[p_idx + 116] * templateSh[7];
		conv += panelSh[p_idx + 132] * templateSh[6];
		conv += panelSh[p_idx + 133] * templateSh[5];
		conv += panelSh[p_idx + 134] * templateSh[4];
		conv += panelSh[p_idx + 135] * templateSh[3];
		conv += panelSh[p_idx + 136] * templateSh[2];
		conv += panelSh[p_idx + 137] * templateSh[1];
		conv += panelSh[p_idx + 138] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_7x7<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_7x7<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_8x8 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[529];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<23; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<23; i+=16) {
			panelSh[IMUL(j, 23) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[64];
	if (threadIdx.x < 8 && threadIdx.y < 8) {
		const int jtwi = IMUL(threadIdx.y, 8) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 23);
		conv += panelSh[p_idx + 0] * templateSh[63];
		conv += panelSh[p_idx + 1] * templateSh[62];
		conv += panelSh[p_idx + 2] * templateSh[61];
		conv += panelSh[p_idx + 3] * templateSh[60];
		conv += panelSh[p_idx + 4] * templateSh[59];
		conv += panelSh[p_idx + 5] * templateSh[58];
		conv += panelSh[p_idx + 6] * templateSh[57];
		conv += panelSh[p_idx + 7] * templateSh[56];
		conv += panelSh[p_idx + 23] * templateSh[55];
		conv += panelSh[p_idx + 24] * templateSh[54];
		conv += panelSh[p_idx + 25] * templateSh[53];
		conv += panelSh[p_idx + 26] * templateSh[52];
		conv += panelSh[p_idx + 27] * templateSh[51];
		conv += panelSh[p_idx + 28] * templateSh[50];
		conv += panelSh[p_idx + 29] * templateSh[49];
		conv += panelSh[p_idx + 30] * templateSh[48];
		conv += panelSh[p_idx + 46] * templateSh[47];
		conv += panelSh[p_idx + 47] * templateSh[46];
		conv += panelSh[p_idx + 48] * templateSh[45];
		conv += panelSh[p_idx + 49] * templateSh[44];
		conv += panelSh[p_idx + 50] * templateSh[43];
		conv += panelSh[p_idx + 51] * templateSh[42];
		conv += panelSh[p_idx + 52] * templateSh[41];
		conv += panelSh[p_idx + 53] * templateSh[40];
		conv += panelSh[p_idx + 69] * templateSh[39];
		conv += panelSh[p_idx + 70] * templateSh[38];
		conv += panelSh[p_idx + 71] * templateSh[37];
		conv += panelSh[p_idx + 72] * templateSh[36];
		conv += panelSh[p_idx + 73] * templateSh[35];
		conv += panelSh[p_idx + 74] * templateSh[34];
		conv += panelSh[p_idx + 75] * templateSh[33];
		conv += panelSh[p_idx + 76] * templateSh[32];
		conv += panelSh[p_idx + 92] * templateSh[31];
		conv += panelSh[p_idx + 93] * templateSh[30];
		conv += panelSh[p_idx + 94] * templateSh[29];
		conv += panelSh[p_idx + 95] * templateSh[28];
		conv += panelSh[p_idx + 96] * templateSh[27];
		conv += panelSh[p_idx + 97] * templateSh[26];
		conv += panelSh[p_idx + 98] * templateSh[25];
		conv += panelSh[p_idx + 99] * templateSh[24];
		conv += panelSh[p_idx + 115] * templateSh[23];
		conv += panelSh[p_idx + 116] * templateSh[22];
		conv += panelSh[p_idx + 117] * templateSh[21];
		conv += panelSh[p_idx + 118] * templateSh[20];
		conv += panelSh[p_idx + 119] * templateSh[19];
		conv += panelSh[p_idx + 120] * templateSh[18];
		conv += panelSh[p_idx + 121] * templateSh[17];
		conv += panelSh[p_idx + 122] * templateSh[16];
		conv += panelSh[p_idx + 138] * templateSh[15];
		conv += panelSh[p_idx + 139] * templateSh[14];
		conv += panelSh[p_idx + 140] * templateSh[13];
		conv += panelSh[p_idx + 141] * templateSh[12];
		conv += panelSh[p_idx + 142] * templateSh[11];
		conv += panelSh[p_idx + 143] * templateSh[10];
		conv += panelSh[p_idx + 144] * templateSh[9];
		conv += panelSh[p_idx + 145] * templateSh[8];
		conv += panelSh[p_idx + 161] * templateSh[7];
		conv += panelSh[p_idx + 162] * templateSh[6];
		conv += panelSh[p_idx + 163] * templateSh[5];
		conv += panelSh[p_idx + 164] * templateSh[4];
		conv += panelSh[p_idx + 165] * templateSh[3];
		conv += panelSh[p_idx + 166] * templateSh[2];
		conv += panelSh[p_idx + 167] * templateSh[1];
		conv += panelSh[p_idx + 168] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_8x8<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_8x8<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_9x9 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[576];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<24; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<24; i+=16) {
			panelSh[IMUL(j, 24) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[81];
	if (threadIdx.x < 9 && threadIdx.y < 9) {
		const int jtwi = IMUL(threadIdx.y, 9) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 24);
		conv += panelSh[p_idx + 0] * templateSh[80];
		conv += panelSh[p_idx + 1] * templateSh[79];
		conv += panelSh[p_idx + 2] * templateSh[78];
		conv += panelSh[p_idx + 3] * templateSh[77];
		conv += panelSh[p_idx + 4] * templateSh[76];
		conv += panelSh[p_idx + 5] * templateSh[75];
		conv += panelSh[p_idx + 6] * templateSh[74];
		conv += panelSh[p_idx + 7] * templateSh[73];
		conv += panelSh[p_idx + 8] * templateSh[72];
		conv += panelSh[p_idx + 24] * templateSh[71];
		conv += panelSh[p_idx + 25] * templateSh[70];
		conv += panelSh[p_idx + 26] * templateSh[69];
		conv += panelSh[p_idx + 27] * templateSh[68];
		conv += panelSh[p_idx + 28] * templateSh[67];
		conv += panelSh[p_idx + 29] * templateSh[66];
		conv += panelSh[p_idx + 30] * templateSh[65];
		conv += panelSh[p_idx + 31] * templateSh[64];
		conv += panelSh[p_idx + 32] * templateSh[63];
		conv += panelSh[p_idx + 48] * templateSh[62];
		conv += panelSh[p_idx + 49] * templateSh[61];
		conv += panelSh[p_idx + 50] * templateSh[60];
		conv += panelSh[p_idx + 51] * templateSh[59];
		conv += panelSh[p_idx + 52] * templateSh[58];
		conv += panelSh[p_idx + 53] * templateSh[57];
		conv += panelSh[p_idx + 54] * templateSh[56];
		conv += panelSh[p_idx + 55] * templateSh[55];
		conv += panelSh[p_idx + 56] * templateSh[54];
		conv += panelSh[p_idx + 72] * templateSh[53];
		conv += panelSh[p_idx + 73] * templateSh[52];
		conv += panelSh[p_idx + 74] * templateSh[51];
		conv += panelSh[p_idx + 75] * templateSh[50];
		conv += panelSh[p_idx + 76] * templateSh[49];
		conv += panelSh[p_idx + 77] * templateSh[48];
		conv += panelSh[p_idx + 78] * templateSh[47];
		conv += panelSh[p_idx + 79] * templateSh[46];
		conv += panelSh[p_idx + 80] * templateSh[45];
		conv += panelSh[p_idx + 96] * templateSh[44];
		conv += panelSh[p_idx + 97] * templateSh[43];
		conv += panelSh[p_idx + 98] * templateSh[42];
		conv += panelSh[p_idx + 99] * templateSh[41];
		conv += panelSh[p_idx + 100] * templateSh[40];
		conv += panelSh[p_idx + 101] * templateSh[39];
		conv += panelSh[p_idx + 102] * templateSh[38];
		conv += panelSh[p_idx + 103] * templateSh[37];
		conv += panelSh[p_idx + 104] * templateSh[36];
		conv += panelSh[p_idx + 120] * templateSh[35];
		conv += panelSh[p_idx + 121] * templateSh[34];
		conv += panelSh[p_idx + 122] * templateSh[33];
		conv += panelSh[p_idx + 123] * templateSh[32];
		conv += panelSh[p_idx + 124] * templateSh[31];
		conv += panelSh[p_idx + 125] * templateSh[30];
		conv += panelSh[p_idx + 126] * templateSh[29];
		conv += panelSh[p_idx + 127] * templateSh[28];
		conv += panelSh[p_idx + 128] * templateSh[27];
		conv += panelSh[p_idx + 144] * templateSh[26];
		conv += panelSh[p_idx + 145] * templateSh[25];
		conv += panelSh[p_idx + 146] * templateSh[24];
		conv += panelSh[p_idx + 147] * templateSh[23];
		conv += panelSh[p_idx + 148] * templateSh[22];
		conv += panelSh[p_idx + 149] * templateSh[21];
		conv += panelSh[p_idx + 150] * templateSh[20];
		conv += panelSh[p_idx + 151] * templateSh[19];
		conv += panelSh[p_idx + 152] * templateSh[18];
		conv += panelSh[p_idx + 168] * templateSh[17];
		conv += panelSh[p_idx + 169] * templateSh[16];
		conv += panelSh[p_idx + 170] * templateSh[15];
		conv += panelSh[p_idx + 171] * templateSh[14];
		conv += panelSh[p_idx + 172] * templateSh[13];
		conv += panelSh[p_idx + 173] * templateSh[12];
		conv += panelSh[p_idx + 174] * templateSh[11];
		conv += panelSh[p_idx + 175] * templateSh[10];
		conv += panelSh[p_idx + 176] * templateSh[9];
		conv += panelSh[p_idx + 192] * templateSh[8];
		conv += panelSh[p_idx + 193] * templateSh[7];
		conv += panelSh[p_idx + 194] * templateSh[6];
		conv += panelSh[p_idx + 195] * templateSh[5];
		conv += panelSh[p_idx + 196] * templateSh[4];
		conv += panelSh[p_idx + 197] * templateSh[3];
		conv += panelSh[p_idx + 198] * templateSh[2];
		conv += panelSh[p_idx + 199] * templateSh[1];
		conv += panelSh[p_idx + 200] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_9x9<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_9x9<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_10x10 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[625];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<25; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<25; i+=16) {
			panelSh[IMUL(j, 25) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[100];
	if (threadIdx.x < 10 && threadIdx.y < 10) {
		const int jtwi = IMUL(threadIdx.y, 10) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 25);
		conv += panelSh[p_idx + 0] * templateSh[99];
		conv += panelSh[p_idx + 1] * templateSh[98];
		conv += panelSh[p_idx + 2] * templateSh[97];
		conv += panelSh[p_idx + 3] * templateSh[96];
		conv += panelSh[p_idx + 4] * templateSh[95];
		conv += panelSh[p_idx + 5] * templateSh[94];
		conv += panelSh[p_idx + 6] * templateSh[93];
		conv += panelSh[p_idx + 7] * templateSh[92];
		conv += panelSh[p_idx + 8] * templateSh[91];
		conv += panelSh[p_idx + 9] * templateSh[90];
		conv += panelSh[p_idx + 25] * templateSh[89];
		conv += panelSh[p_idx + 26] * templateSh[88];
		conv += panelSh[p_idx + 27] * templateSh[87];
		conv += panelSh[p_idx + 28] * templateSh[86];
		conv += panelSh[p_idx + 29] * templateSh[85];
		conv += panelSh[p_idx + 30] * templateSh[84];
		conv += panelSh[p_idx + 31] * templateSh[83];
		conv += panelSh[p_idx + 32] * templateSh[82];
		conv += panelSh[p_idx + 33] * templateSh[81];
		conv += panelSh[p_idx + 34] * templateSh[80];
		conv += panelSh[p_idx + 50] * templateSh[79];
		conv += panelSh[p_idx + 51] * templateSh[78];
		conv += panelSh[p_idx + 52] * templateSh[77];
		conv += panelSh[p_idx + 53] * templateSh[76];
		conv += panelSh[p_idx + 54] * templateSh[75];
		conv += panelSh[p_idx + 55] * templateSh[74];
		conv += panelSh[p_idx + 56] * templateSh[73];
		conv += panelSh[p_idx + 57] * templateSh[72];
		conv += panelSh[p_idx + 58] * templateSh[71];
		conv += panelSh[p_idx + 59] * templateSh[70];
		conv += panelSh[p_idx + 75] * templateSh[69];
		conv += panelSh[p_idx + 76] * templateSh[68];
		conv += panelSh[p_idx + 77] * templateSh[67];
		conv += panelSh[p_idx + 78] * templateSh[66];
		conv += panelSh[p_idx + 79] * templateSh[65];
		conv += panelSh[p_idx + 80] * templateSh[64];
		conv += panelSh[p_idx + 81] * templateSh[63];
		conv += panelSh[p_idx + 82] * templateSh[62];
		conv += panelSh[p_idx + 83] * templateSh[61];
		conv += panelSh[p_idx + 84] * templateSh[60];
		conv += panelSh[p_idx + 100] * templateSh[59];
		conv += panelSh[p_idx + 101] * templateSh[58];
		conv += panelSh[p_idx + 102] * templateSh[57];
		conv += panelSh[p_idx + 103] * templateSh[56];
		conv += panelSh[p_idx + 104] * templateSh[55];
		conv += panelSh[p_idx + 105] * templateSh[54];
		conv += panelSh[p_idx + 106] * templateSh[53];
		conv += panelSh[p_idx + 107] * templateSh[52];
		conv += panelSh[p_idx + 108] * templateSh[51];
		conv += panelSh[p_idx + 109] * templateSh[50];
		conv += panelSh[p_idx + 125] * templateSh[49];
		conv += panelSh[p_idx + 126] * templateSh[48];
		conv += panelSh[p_idx + 127] * templateSh[47];
		conv += panelSh[p_idx + 128] * templateSh[46];
		conv += panelSh[p_idx + 129] * templateSh[45];
		conv += panelSh[p_idx + 130] * templateSh[44];
		conv += panelSh[p_idx + 131] * templateSh[43];
		conv += panelSh[p_idx + 132] * templateSh[42];
		conv += panelSh[p_idx + 133] * templateSh[41];
		conv += panelSh[p_idx + 134] * templateSh[40];
		conv += panelSh[p_idx + 150] * templateSh[39];
		conv += panelSh[p_idx + 151] * templateSh[38];
		conv += panelSh[p_idx + 152] * templateSh[37];
		conv += panelSh[p_idx + 153] * templateSh[36];
		conv += panelSh[p_idx + 154] * templateSh[35];
		conv += panelSh[p_idx + 155] * templateSh[34];
		conv += panelSh[p_idx + 156] * templateSh[33];
		conv += panelSh[p_idx + 157] * templateSh[32];
		conv += panelSh[p_idx + 158] * templateSh[31];
		conv += panelSh[p_idx + 159] * templateSh[30];
		conv += panelSh[p_idx + 175] * templateSh[29];
		conv += panelSh[p_idx + 176] * templateSh[28];
		conv += panelSh[p_idx + 177] * templateSh[27];
		conv += panelSh[p_idx + 178] * templateSh[26];
		conv += panelSh[p_idx + 179] * templateSh[25];
		conv += panelSh[p_idx + 180] * templateSh[24];
		conv += panelSh[p_idx + 181] * templateSh[23];
		conv += panelSh[p_idx + 182] * templateSh[22];
		conv += panelSh[p_idx + 183] * templateSh[21];
		conv += panelSh[p_idx + 184] * templateSh[20];
		conv += panelSh[p_idx + 200] * templateSh[19];
		conv += panelSh[p_idx + 201] * templateSh[18];
		conv += panelSh[p_idx + 202] * templateSh[17];
		conv += panelSh[p_idx + 203] * templateSh[16];
		conv += panelSh[p_idx + 204] * templateSh[15];
		conv += panelSh[p_idx + 205] * templateSh[14];
		conv += panelSh[p_idx + 206] * templateSh[13];
		conv += panelSh[p_idx + 207] * templateSh[12];
		conv += panelSh[p_idx + 208] * templateSh[11];
		conv += panelSh[p_idx + 209] * templateSh[10];
		conv += panelSh[p_idx + 225] * templateSh[9];
		conv += panelSh[p_idx + 226] * templateSh[8];
		conv += panelSh[p_idx + 227] * templateSh[7];
		conv += panelSh[p_idx + 228] * templateSh[6];
		conv += panelSh[p_idx + 229] * templateSh[5];
		conv += panelSh[p_idx + 230] * templateSh[4];
		conv += panelSh[p_idx + 231] * templateSh[3];
		conv += panelSh[p_idx + 232] * templateSh[2];
		conv += panelSh[p_idx + 233] * templateSh[1];
		conv += panelSh[p_idx + 234] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_10x10<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_10x10<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_11x11 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[676];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<26; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<26; i+=16) {
			panelSh[IMUL(j, 26) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[121];
	if (threadIdx.x < 11 && threadIdx.y < 11) {
		const int jtwi = IMUL(threadIdx.y, 11) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 26);
		conv += panelSh[p_idx + 0] * templateSh[120];
		conv += panelSh[p_idx + 1] * templateSh[119];
		conv += panelSh[p_idx + 2] * templateSh[118];
		conv += panelSh[p_idx + 3] * templateSh[117];
		conv += panelSh[p_idx + 4] * templateSh[116];
		conv += panelSh[p_idx + 5] * templateSh[115];
		conv += panelSh[p_idx + 6] * templateSh[114];
		conv += panelSh[p_idx + 7] * templateSh[113];
		conv += panelSh[p_idx + 8] * templateSh[112];
		conv += panelSh[p_idx + 9] * templateSh[111];
		conv += panelSh[p_idx + 10] * templateSh[110];
		conv += panelSh[p_idx + 26] * templateSh[109];
		conv += panelSh[p_idx + 27] * templateSh[108];
		conv += panelSh[p_idx + 28] * templateSh[107];
		conv += panelSh[p_idx + 29] * templateSh[106];
		conv += panelSh[p_idx + 30] * templateSh[105];
		conv += panelSh[p_idx + 31] * templateSh[104];
		conv += panelSh[p_idx + 32] * templateSh[103];
		conv += panelSh[p_idx + 33] * templateSh[102];
		conv += panelSh[p_idx + 34] * templateSh[101];
		conv += panelSh[p_idx + 35] * templateSh[100];
		conv += panelSh[p_idx + 36] * templateSh[99];
		conv += panelSh[p_idx + 52] * templateSh[98];
		conv += panelSh[p_idx + 53] * templateSh[97];
		conv += panelSh[p_idx + 54] * templateSh[96];
		conv += panelSh[p_idx + 55] * templateSh[95];
		conv += panelSh[p_idx + 56] * templateSh[94];
		conv += panelSh[p_idx + 57] * templateSh[93];
		conv += panelSh[p_idx + 58] * templateSh[92];
		conv += panelSh[p_idx + 59] * templateSh[91];
		conv += panelSh[p_idx + 60] * templateSh[90];
		conv += panelSh[p_idx + 61] * templateSh[89];
		conv += panelSh[p_idx + 62] * templateSh[88];
		conv += panelSh[p_idx + 78] * templateSh[87];
		conv += panelSh[p_idx + 79] * templateSh[86];
		conv += panelSh[p_idx + 80] * templateSh[85];
		conv += panelSh[p_idx + 81] * templateSh[84];
		conv += panelSh[p_idx + 82] * templateSh[83];
		conv += panelSh[p_idx + 83] * templateSh[82];
		conv += panelSh[p_idx + 84] * templateSh[81];
		conv += panelSh[p_idx + 85] * templateSh[80];
		conv += panelSh[p_idx + 86] * templateSh[79];
		conv += panelSh[p_idx + 87] * templateSh[78];
		conv += panelSh[p_idx + 88] * templateSh[77];
		conv += panelSh[p_idx + 104] * templateSh[76];
		conv += panelSh[p_idx + 105] * templateSh[75];
		conv += panelSh[p_idx + 106] * templateSh[74];
		conv += panelSh[p_idx + 107] * templateSh[73];
		conv += panelSh[p_idx + 108] * templateSh[72];
		conv += panelSh[p_idx + 109] * templateSh[71];
		conv += panelSh[p_idx + 110] * templateSh[70];
		conv += panelSh[p_idx + 111] * templateSh[69];
		conv += panelSh[p_idx + 112] * templateSh[68];
		conv += panelSh[p_idx + 113] * templateSh[67];
		conv += panelSh[p_idx + 114] * templateSh[66];
		conv += panelSh[p_idx + 130] * templateSh[65];
		conv += panelSh[p_idx + 131] * templateSh[64];
		conv += panelSh[p_idx + 132] * templateSh[63];
		conv += panelSh[p_idx + 133] * templateSh[62];
		conv += panelSh[p_idx + 134] * templateSh[61];
		conv += panelSh[p_idx + 135] * templateSh[60];
		conv += panelSh[p_idx + 136] * templateSh[59];
		conv += panelSh[p_idx + 137] * templateSh[58];
		conv += panelSh[p_idx + 138] * templateSh[57];
		conv += panelSh[p_idx + 139] * templateSh[56];
		conv += panelSh[p_idx + 140] * templateSh[55];
		conv += panelSh[p_idx + 156] * templateSh[54];
		conv += panelSh[p_idx + 157] * templateSh[53];
		conv += panelSh[p_idx + 158] * templateSh[52];
		conv += panelSh[p_idx + 159] * templateSh[51];
		conv += panelSh[p_idx + 160] * templateSh[50];
		conv += panelSh[p_idx + 161] * templateSh[49];
		conv += panelSh[p_idx + 162] * templateSh[48];
		conv += panelSh[p_idx + 163] * templateSh[47];
		conv += panelSh[p_idx + 164] * templateSh[46];
		conv += panelSh[p_idx + 165] * templateSh[45];
		conv += panelSh[p_idx + 166] * templateSh[44];
		conv += panelSh[p_idx + 182] * templateSh[43];
		conv += panelSh[p_idx + 183] * templateSh[42];
		conv += panelSh[p_idx + 184] * templateSh[41];
		conv += panelSh[p_idx + 185] * templateSh[40];
		conv += panelSh[p_idx + 186] * templateSh[39];
		conv += panelSh[p_idx + 187] * templateSh[38];
		conv += panelSh[p_idx + 188] * templateSh[37];
		conv += panelSh[p_idx + 189] * templateSh[36];
		conv += panelSh[p_idx + 190] * templateSh[35];
		conv += panelSh[p_idx + 191] * templateSh[34];
		conv += panelSh[p_idx + 192] * templateSh[33];
		conv += panelSh[p_idx + 208] * templateSh[32];
		conv += panelSh[p_idx + 209] * templateSh[31];
		conv += panelSh[p_idx + 210] * templateSh[30];
		conv += panelSh[p_idx + 211] * templateSh[29];
		conv += panelSh[p_idx + 212] * templateSh[28];
		conv += panelSh[p_idx + 213] * templateSh[27];
		conv += panelSh[p_idx + 214] * templateSh[26];
		conv += panelSh[p_idx + 215] * templateSh[25];
		conv += panelSh[p_idx + 216] * templateSh[24];
		conv += panelSh[p_idx + 217] * templateSh[23];
		conv += panelSh[p_idx + 218] * templateSh[22];
		conv += panelSh[p_idx + 234] * templateSh[21];
		conv += panelSh[p_idx + 235] * templateSh[20];
		conv += panelSh[p_idx + 236] * templateSh[19];
		conv += panelSh[p_idx + 237] * templateSh[18];
		conv += panelSh[p_idx + 238] * templateSh[17];
		conv += panelSh[p_idx + 239] * templateSh[16];
		conv += panelSh[p_idx + 240] * templateSh[15];
		conv += panelSh[p_idx + 241] * templateSh[14];
		conv += panelSh[p_idx + 242] * templateSh[13];
		conv += panelSh[p_idx + 243] * templateSh[12];
		conv += panelSh[p_idx + 244] * templateSh[11];
		conv += panelSh[p_idx + 260] * templateSh[10];
		conv += panelSh[p_idx + 261] * templateSh[9];
		conv += panelSh[p_idx + 262] * templateSh[8];
		conv += panelSh[p_idx + 263] * templateSh[7];
		conv += panelSh[p_idx + 264] * templateSh[6];
		conv += panelSh[p_idx + 265] * templateSh[5];
		conv += panelSh[p_idx + 266] * templateSh[4];
		conv += panelSh[p_idx + 267] * templateSh[3];
		conv += panelSh[p_idx + 268] * templateSh[2];
		conv += panelSh[p_idx + 269] * templateSh[1];
		conv += panelSh[p_idx + 270] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_11x11<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_11x11<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_12x12 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[729];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<27; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<27; i+=16) {
			panelSh[IMUL(j, 27) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[144];
	if (threadIdx.x < 12 && threadIdx.y < 12) {
		const int jtwi = IMUL(threadIdx.y, 12) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 27);
		conv += panelSh[p_idx + 0] * templateSh[143];
		conv += panelSh[p_idx + 1] * templateSh[142];
		conv += panelSh[p_idx + 2] * templateSh[141];
		conv += panelSh[p_idx + 3] * templateSh[140];
		conv += panelSh[p_idx + 4] * templateSh[139];
		conv += panelSh[p_idx + 5] * templateSh[138];
		conv += panelSh[p_idx + 6] * templateSh[137];
		conv += panelSh[p_idx + 7] * templateSh[136];
		conv += panelSh[p_idx + 8] * templateSh[135];
		conv += panelSh[p_idx + 9] * templateSh[134];
		conv += panelSh[p_idx + 10] * templateSh[133];
		conv += panelSh[p_idx + 11] * templateSh[132];
		conv += panelSh[p_idx + 27] * templateSh[131];
		conv += panelSh[p_idx + 28] * templateSh[130];
		conv += panelSh[p_idx + 29] * templateSh[129];
		conv += panelSh[p_idx + 30] * templateSh[128];
		conv += panelSh[p_idx + 31] * templateSh[127];
		conv += panelSh[p_idx + 32] * templateSh[126];
		conv += panelSh[p_idx + 33] * templateSh[125];
		conv += panelSh[p_idx + 34] * templateSh[124];
		conv += panelSh[p_idx + 35] * templateSh[123];
		conv += panelSh[p_idx + 36] * templateSh[122];
		conv += panelSh[p_idx + 37] * templateSh[121];
		conv += panelSh[p_idx + 38] * templateSh[120];
		conv += panelSh[p_idx + 54] * templateSh[119];
		conv += panelSh[p_idx + 55] * templateSh[118];
		conv += panelSh[p_idx + 56] * templateSh[117];
		conv += panelSh[p_idx + 57] * templateSh[116];
		conv += panelSh[p_idx + 58] * templateSh[115];
		conv += panelSh[p_idx + 59] * templateSh[114];
		conv += panelSh[p_idx + 60] * templateSh[113];
		conv += panelSh[p_idx + 61] * templateSh[112];
		conv += panelSh[p_idx + 62] * templateSh[111];
		conv += panelSh[p_idx + 63] * templateSh[110];
		conv += panelSh[p_idx + 64] * templateSh[109];
		conv += panelSh[p_idx + 65] * templateSh[108];
		conv += panelSh[p_idx + 81] * templateSh[107];
		conv += panelSh[p_idx + 82] * templateSh[106];
		conv += panelSh[p_idx + 83] * templateSh[105];
		conv += panelSh[p_idx + 84] * templateSh[104];
		conv += panelSh[p_idx + 85] * templateSh[103];
		conv += panelSh[p_idx + 86] * templateSh[102];
		conv += panelSh[p_idx + 87] * templateSh[101];
		conv += panelSh[p_idx + 88] * templateSh[100];
		conv += panelSh[p_idx + 89] * templateSh[99];
		conv += panelSh[p_idx + 90] * templateSh[98];
		conv += panelSh[p_idx + 91] * templateSh[97];
		conv += panelSh[p_idx + 92] * templateSh[96];
		conv += panelSh[p_idx + 108] * templateSh[95];
		conv += panelSh[p_idx + 109] * templateSh[94];
		conv += panelSh[p_idx + 110] * templateSh[93];
		conv += panelSh[p_idx + 111] * templateSh[92];
		conv += panelSh[p_idx + 112] * templateSh[91];
		conv += panelSh[p_idx + 113] * templateSh[90];
		conv += panelSh[p_idx + 114] * templateSh[89];
		conv += panelSh[p_idx + 115] * templateSh[88];
		conv += panelSh[p_idx + 116] * templateSh[87];
		conv += panelSh[p_idx + 117] * templateSh[86];
		conv += panelSh[p_idx + 118] * templateSh[85];
		conv += panelSh[p_idx + 119] * templateSh[84];
		conv += panelSh[p_idx + 135] * templateSh[83];
		conv += panelSh[p_idx + 136] * templateSh[82];
		conv += panelSh[p_idx + 137] * templateSh[81];
		conv += panelSh[p_idx + 138] * templateSh[80];
		conv += panelSh[p_idx + 139] * templateSh[79];
		conv += panelSh[p_idx + 140] * templateSh[78];
		conv += panelSh[p_idx + 141] * templateSh[77];
		conv += panelSh[p_idx + 142] * templateSh[76];
		conv += panelSh[p_idx + 143] * templateSh[75];
		conv += panelSh[p_idx + 144] * templateSh[74];
		conv += panelSh[p_idx + 145] * templateSh[73];
		conv += panelSh[p_idx + 146] * templateSh[72];
		conv += panelSh[p_idx + 162] * templateSh[71];
		conv += panelSh[p_idx + 163] * templateSh[70];
		conv += panelSh[p_idx + 164] * templateSh[69];
		conv += panelSh[p_idx + 165] * templateSh[68];
		conv += panelSh[p_idx + 166] * templateSh[67];
		conv += panelSh[p_idx + 167] * templateSh[66];
		conv += panelSh[p_idx + 168] * templateSh[65];
		conv += panelSh[p_idx + 169] * templateSh[64];
		conv += panelSh[p_idx + 170] * templateSh[63];
		conv += panelSh[p_idx + 171] * templateSh[62];
		conv += panelSh[p_idx + 172] * templateSh[61];
		conv += panelSh[p_idx + 173] * templateSh[60];
		conv += panelSh[p_idx + 189] * templateSh[59];
		conv += panelSh[p_idx + 190] * templateSh[58];
		conv += panelSh[p_idx + 191] * templateSh[57];
		conv += panelSh[p_idx + 192] * templateSh[56];
		conv += panelSh[p_idx + 193] * templateSh[55];
		conv += panelSh[p_idx + 194] * templateSh[54];
		conv += panelSh[p_idx + 195] * templateSh[53];
		conv += panelSh[p_idx + 196] * templateSh[52];
		conv += panelSh[p_idx + 197] * templateSh[51];
		conv += panelSh[p_idx + 198] * templateSh[50];
		conv += panelSh[p_idx + 199] * templateSh[49];
		conv += panelSh[p_idx + 200] * templateSh[48];
		conv += panelSh[p_idx + 216] * templateSh[47];
		conv += panelSh[p_idx + 217] * templateSh[46];
		conv += panelSh[p_idx + 218] * templateSh[45];
		conv += panelSh[p_idx + 219] * templateSh[44];
		conv += panelSh[p_idx + 220] * templateSh[43];
		conv += panelSh[p_idx + 221] * templateSh[42];
		conv += panelSh[p_idx + 222] * templateSh[41];
		conv += panelSh[p_idx + 223] * templateSh[40];
		conv += panelSh[p_idx + 224] * templateSh[39];
		conv += panelSh[p_idx + 225] * templateSh[38];
		conv += panelSh[p_idx + 226] * templateSh[37];
		conv += panelSh[p_idx + 227] * templateSh[36];
		conv += panelSh[p_idx + 243] * templateSh[35];
		conv += panelSh[p_idx + 244] * templateSh[34];
		conv += panelSh[p_idx + 245] * templateSh[33];
		conv += panelSh[p_idx + 246] * templateSh[32];
		conv += panelSh[p_idx + 247] * templateSh[31];
		conv += panelSh[p_idx + 248] * templateSh[30];
		conv += panelSh[p_idx + 249] * templateSh[29];
		conv += panelSh[p_idx + 250] * templateSh[28];
		conv += panelSh[p_idx + 251] * templateSh[27];
		conv += panelSh[p_idx + 252] * templateSh[26];
		conv += panelSh[p_idx + 253] * templateSh[25];
		conv += panelSh[p_idx + 254] * templateSh[24];
		conv += panelSh[p_idx + 270] * templateSh[23];
		conv += panelSh[p_idx + 271] * templateSh[22];
		conv += panelSh[p_idx + 272] * templateSh[21];
		conv += panelSh[p_idx + 273] * templateSh[20];
		conv += panelSh[p_idx + 274] * templateSh[19];
		conv += panelSh[p_idx + 275] * templateSh[18];
		conv += panelSh[p_idx + 276] * templateSh[17];
		conv += panelSh[p_idx + 277] * templateSh[16];
		conv += panelSh[p_idx + 278] * templateSh[15];
		conv += panelSh[p_idx + 279] * templateSh[14];
		conv += panelSh[p_idx + 280] * templateSh[13];
		conv += panelSh[p_idx + 281] * templateSh[12];
		conv += panelSh[p_idx + 297] * templateSh[11];
		conv += panelSh[p_idx + 298] * templateSh[10];
		conv += panelSh[p_idx + 299] * templateSh[9];
		conv += panelSh[p_idx + 300] * templateSh[8];
		conv += panelSh[p_idx + 301] * templateSh[7];
		conv += panelSh[p_idx + 302] * templateSh[6];
		conv += panelSh[p_idx + 303] * templateSh[5];
		conv += panelSh[p_idx + 304] * templateSh[4];
		conv += panelSh[p_idx + 305] * templateSh[3];
		conv += panelSh[p_idx + 306] * templateSh[2];
		conv += panelSh[p_idx + 307] * templateSh[1];
		conv += panelSh[p_idx + 308] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_12x12<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_12x12<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_13x13 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[784];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<28; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<28; i+=16) {
			panelSh[IMUL(j, 28) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[169];
	if (threadIdx.x < 13 && threadIdx.y < 13) {
		const int jtwi = IMUL(threadIdx.y, 13) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 28);
		conv += panelSh[p_idx + 0] * templateSh[168];
		conv += panelSh[p_idx + 1] * templateSh[167];
		conv += panelSh[p_idx + 2] * templateSh[166];
		conv += panelSh[p_idx + 3] * templateSh[165];
		conv += panelSh[p_idx + 4] * templateSh[164];
		conv += panelSh[p_idx + 5] * templateSh[163];
		conv += panelSh[p_idx + 6] * templateSh[162];
		conv += panelSh[p_idx + 7] * templateSh[161];
		conv += panelSh[p_idx + 8] * templateSh[160];
		conv += panelSh[p_idx + 9] * templateSh[159];
		conv += panelSh[p_idx + 10] * templateSh[158];
		conv += panelSh[p_idx + 11] * templateSh[157];
		conv += panelSh[p_idx + 12] * templateSh[156];
		conv += panelSh[p_idx + 28] * templateSh[155];
		conv += panelSh[p_idx + 29] * templateSh[154];
		conv += panelSh[p_idx + 30] * templateSh[153];
		conv += panelSh[p_idx + 31] * templateSh[152];
		conv += panelSh[p_idx + 32] * templateSh[151];
		conv += panelSh[p_idx + 33] * templateSh[150];
		conv += panelSh[p_idx + 34] * templateSh[149];
		conv += panelSh[p_idx + 35] * templateSh[148];
		conv += panelSh[p_idx + 36] * templateSh[147];
		conv += panelSh[p_idx + 37] * templateSh[146];
		conv += panelSh[p_idx + 38] * templateSh[145];
		conv += panelSh[p_idx + 39] * templateSh[144];
		conv += panelSh[p_idx + 40] * templateSh[143];
		conv += panelSh[p_idx + 56] * templateSh[142];
		conv += panelSh[p_idx + 57] * templateSh[141];
		conv += panelSh[p_idx + 58] * templateSh[140];
		conv += panelSh[p_idx + 59] * templateSh[139];
		conv += panelSh[p_idx + 60] * templateSh[138];
		conv += panelSh[p_idx + 61] * templateSh[137];
		conv += panelSh[p_idx + 62] * templateSh[136];
		conv += panelSh[p_idx + 63] * templateSh[135];
		conv += panelSh[p_idx + 64] * templateSh[134];
		conv += panelSh[p_idx + 65] * templateSh[133];
		conv += panelSh[p_idx + 66] * templateSh[132];
		conv += panelSh[p_idx + 67] * templateSh[131];
		conv += panelSh[p_idx + 68] * templateSh[130];
		conv += panelSh[p_idx + 84] * templateSh[129];
		conv += panelSh[p_idx + 85] * templateSh[128];
		conv += panelSh[p_idx + 86] * templateSh[127];
		conv += panelSh[p_idx + 87] * templateSh[126];
		conv += panelSh[p_idx + 88] * templateSh[125];
		conv += panelSh[p_idx + 89] * templateSh[124];
		conv += panelSh[p_idx + 90] * templateSh[123];
		conv += panelSh[p_idx + 91] * templateSh[122];
		conv += panelSh[p_idx + 92] * templateSh[121];
		conv += panelSh[p_idx + 93] * templateSh[120];
		conv += panelSh[p_idx + 94] * templateSh[119];
		conv += panelSh[p_idx + 95] * templateSh[118];
		conv += panelSh[p_idx + 96] * templateSh[117];
		conv += panelSh[p_idx + 112] * templateSh[116];
		conv += panelSh[p_idx + 113] * templateSh[115];
		conv += panelSh[p_idx + 114] * templateSh[114];
		conv += panelSh[p_idx + 115] * templateSh[113];
		conv += panelSh[p_idx + 116] * templateSh[112];
		conv += panelSh[p_idx + 117] * templateSh[111];
		conv += panelSh[p_idx + 118] * templateSh[110];
		conv += panelSh[p_idx + 119] * templateSh[109];
		conv += panelSh[p_idx + 120] * templateSh[108];
		conv += panelSh[p_idx + 121] * templateSh[107];
		conv += panelSh[p_idx + 122] * templateSh[106];
		conv += panelSh[p_idx + 123] * templateSh[105];
		conv += panelSh[p_idx + 124] * templateSh[104];
		conv += panelSh[p_idx + 140] * templateSh[103];
		conv += panelSh[p_idx + 141] * templateSh[102];
		conv += panelSh[p_idx + 142] * templateSh[101];
		conv += panelSh[p_idx + 143] * templateSh[100];
		conv += panelSh[p_idx + 144] * templateSh[99];
		conv += panelSh[p_idx + 145] * templateSh[98];
		conv += panelSh[p_idx + 146] * templateSh[97];
		conv += panelSh[p_idx + 147] * templateSh[96];
		conv += panelSh[p_idx + 148] * templateSh[95];
		conv += panelSh[p_idx + 149] * templateSh[94];
		conv += panelSh[p_idx + 150] * templateSh[93];
		conv += panelSh[p_idx + 151] * templateSh[92];
		conv += panelSh[p_idx + 152] * templateSh[91];
		conv += panelSh[p_idx + 168] * templateSh[90];
		conv += panelSh[p_idx + 169] * templateSh[89];
		conv += panelSh[p_idx + 170] * templateSh[88];
		conv += panelSh[p_idx + 171] * templateSh[87];
		conv += panelSh[p_idx + 172] * templateSh[86];
		conv += panelSh[p_idx + 173] * templateSh[85];
		conv += panelSh[p_idx + 174] * templateSh[84];
		conv += panelSh[p_idx + 175] * templateSh[83];
		conv += panelSh[p_idx + 176] * templateSh[82];
		conv += panelSh[p_idx + 177] * templateSh[81];
		conv += panelSh[p_idx + 178] * templateSh[80];
		conv += panelSh[p_idx + 179] * templateSh[79];
		conv += panelSh[p_idx + 180] * templateSh[78];
		conv += panelSh[p_idx + 196] * templateSh[77];
		conv += panelSh[p_idx + 197] * templateSh[76];
		conv += panelSh[p_idx + 198] * templateSh[75];
		conv += panelSh[p_idx + 199] * templateSh[74];
		conv += panelSh[p_idx + 200] * templateSh[73];
		conv += panelSh[p_idx + 201] * templateSh[72];
		conv += panelSh[p_idx + 202] * templateSh[71];
		conv += panelSh[p_idx + 203] * templateSh[70];
		conv += panelSh[p_idx + 204] * templateSh[69];
		conv += panelSh[p_idx + 205] * templateSh[68];
		conv += panelSh[p_idx + 206] * templateSh[67];
		conv += panelSh[p_idx + 207] * templateSh[66];
		conv += panelSh[p_idx + 208] * templateSh[65];
		conv += panelSh[p_idx + 224] * templateSh[64];
		conv += panelSh[p_idx + 225] * templateSh[63];
		conv += panelSh[p_idx + 226] * templateSh[62];
		conv += panelSh[p_idx + 227] * templateSh[61];
		conv += panelSh[p_idx + 228] * templateSh[60];
		conv += panelSh[p_idx + 229] * templateSh[59];
		conv += panelSh[p_idx + 230] * templateSh[58];
		conv += panelSh[p_idx + 231] * templateSh[57];
		conv += panelSh[p_idx + 232] * templateSh[56];
		conv += panelSh[p_idx + 233] * templateSh[55];
		conv += panelSh[p_idx + 234] * templateSh[54];
		conv += panelSh[p_idx + 235] * templateSh[53];
		conv += panelSh[p_idx + 236] * templateSh[52];
		conv += panelSh[p_idx + 252] * templateSh[51];
		conv += panelSh[p_idx + 253] * templateSh[50];
		conv += panelSh[p_idx + 254] * templateSh[49];
		conv += panelSh[p_idx + 255] * templateSh[48];
		conv += panelSh[p_idx + 256] * templateSh[47];
		conv += panelSh[p_idx + 257] * templateSh[46];
		conv += panelSh[p_idx + 258] * templateSh[45];
		conv += panelSh[p_idx + 259] * templateSh[44];
		conv += panelSh[p_idx + 260] * templateSh[43];
		conv += panelSh[p_idx + 261] * templateSh[42];
		conv += panelSh[p_idx + 262] * templateSh[41];
		conv += panelSh[p_idx + 263] * templateSh[40];
		conv += panelSh[p_idx + 264] * templateSh[39];
		conv += panelSh[p_idx + 280] * templateSh[38];
		conv += panelSh[p_idx + 281] * templateSh[37];
		conv += panelSh[p_idx + 282] * templateSh[36];
		conv += panelSh[p_idx + 283] * templateSh[35];
		conv += panelSh[p_idx + 284] * templateSh[34];
		conv += panelSh[p_idx + 285] * templateSh[33];
		conv += panelSh[p_idx + 286] * templateSh[32];
		conv += panelSh[p_idx + 287] * templateSh[31];
		conv += panelSh[p_idx + 288] * templateSh[30];
		conv += panelSh[p_idx + 289] * templateSh[29];
		conv += panelSh[p_idx + 290] * templateSh[28];
		conv += panelSh[p_idx + 291] * templateSh[27];
		conv += panelSh[p_idx + 292] * templateSh[26];
		conv += panelSh[p_idx + 308] * templateSh[25];
		conv += panelSh[p_idx + 309] * templateSh[24];
		conv += panelSh[p_idx + 310] * templateSh[23];
		conv += panelSh[p_idx + 311] * templateSh[22];
		conv += panelSh[p_idx + 312] * templateSh[21];
		conv += panelSh[p_idx + 313] * templateSh[20];
		conv += panelSh[p_idx + 314] * templateSh[19];
		conv += panelSh[p_idx + 315] * templateSh[18];
		conv += panelSh[p_idx + 316] * templateSh[17];
		conv += panelSh[p_idx + 317] * templateSh[16];
		conv += panelSh[p_idx + 318] * templateSh[15];
		conv += panelSh[p_idx + 319] * templateSh[14];
		conv += panelSh[p_idx + 320] * templateSh[13];
		conv += panelSh[p_idx + 336] * templateSh[12];
		conv += panelSh[p_idx + 337] * templateSh[11];
		conv += panelSh[p_idx + 338] * templateSh[10];
		conv += panelSh[p_idx + 339] * templateSh[9];
		conv += panelSh[p_idx + 340] * templateSh[8];
		conv += panelSh[p_idx + 341] * templateSh[7];
		conv += panelSh[p_idx + 342] * templateSh[6];
		conv += panelSh[p_idx + 343] * templateSh[5];
		conv += panelSh[p_idx + 344] * templateSh[4];
		conv += panelSh[p_idx + 345] * templateSh[3];
		conv += panelSh[p_idx + 346] * templateSh[2];
		conv += panelSh[p_idx + 347] * templateSh[1];
		conv += panelSh[p_idx + 348] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_13x13<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_13x13<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_14x14 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[841];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<29; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<29; i+=16) {
			panelSh[IMUL(j, 29) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[196];
	if (threadIdx.x < 14 && threadIdx.y < 14) {
		const int jtwi = IMUL(threadIdx.y, 14) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 29);
		conv += panelSh[p_idx + 0] * templateSh[195];
		conv += panelSh[p_idx + 1] * templateSh[194];
		conv += panelSh[p_idx + 2] * templateSh[193];
		conv += panelSh[p_idx + 3] * templateSh[192];
		conv += panelSh[p_idx + 4] * templateSh[191];
		conv += panelSh[p_idx + 5] * templateSh[190];
		conv += panelSh[p_idx + 6] * templateSh[189];
		conv += panelSh[p_idx + 7] * templateSh[188];
		conv += panelSh[p_idx + 8] * templateSh[187];
		conv += panelSh[p_idx + 9] * templateSh[186];
		conv += panelSh[p_idx + 10] * templateSh[185];
		conv += panelSh[p_idx + 11] * templateSh[184];
		conv += panelSh[p_idx + 12] * templateSh[183];
		conv += panelSh[p_idx + 13] * templateSh[182];
		conv += panelSh[p_idx + 29] * templateSh[181];
		conv += panelSh[p_idx + 30] * templateSh[180];
		conv += panelSh[p_idx + 31] * templateSh[179];
		conv += panelSh[p_idx + 32] * templateSh[178];
		conv += panelSh[p_idx + 33] * templateSh[177];
		conv += panelSh[p_idx + 34] * templateSh[176];
		conv += panelSh[p_idx + 35] * templateSh[175];
		conv += panelSh[p_idx + 36] * templateSh[174];
		conv += panelSh[p_idx + 37] * templateSh[173];
		conv += panelSh[p_idx + 38] * templateSh[172];
		conv += panelSh[p_idx + 39] * templateSh[171];
		conv += panelSh[p_idx + 40] * templateSh[170];
		conv += panelSh[p_idx + 41] * templateSh[169];
		conv += panelSh[p_idx + 42] * templateSh[168];
		conv += panelSh[p_idx + 58] * templateSh[167];
		conv += panelSh[p_idx + 59] * templateSh[166];
		conv += panelSh[p_idx + 60] * templateSh[165];
		conv += panelSh[p_idx + 61] * templateSh[164];
		conv += panelSh[p_idx + 62] * templateSh[163];
		conv += panelSh[p_idx + 63] * templateSh[162];
		conv += panelSh[p_idx + 64] * templateSh[161];
		conv += panelSh[p_idx + 65] * templateSh[160];
		conv += panelSh[p_idx + 66] * templateSh[159];
		conv += panelSh[p_idx + 67] * templateSh[158];
		conv += panelSh[p_idx + 68] * templateSh[157];
		conv += panelSh[p_idx + 69] * templateSh[156];
		conv += panelSh[p_idx + 70] * templateSh[155];
		conv += panelSh[p_idx + 71] * templateSh[154];
		conv += panelSh[p_idx + 87] * templateSh[153];
		conv += panelSh[p_idx + 88] * templateSh[152];
		conv += panelSh[p_idx + 89] * templateSh[151];
		conv += panelSh[p_idx + 90] * templateSh[150];
		conv += panelSh[p_idx + 91] * templateSh[149];
		conv += panelSh[p_idx + 92] * templateSh[148];
		conv += panelSh[p_idx + 93] * templateSh[147];
		conv += panelSh[p_idx + 94] * templateSh[146];
		conv += panelSh[p_idx + 95] * templateSh[145];
		conv += panelSh[p_idx + 96] * templateSh[144];
		conv += panelSh[p_idx + 97] * templateSh[143];
		conv += panelSh[p_idx + 98] * templateSh[142];
		conv += panelSh[p_idx + 99] * templateSh[141];
		conv += panelSh[p_idx + 100] * templateSh[140];
		conv += panelSh[p_idx + 116] * templateSh[139];
		conv += panelSh[p_idx + 117] * templateSh[138];
		conv += panelSh[p_idx + 118] * templateSh[137];
		conv += panelSh[p_idx + 119] * templateSh[136];
		conv += panelSh[p_idx + 120] * templateSh[135];
		conv += panelSh[p_idx + 121] * templateSh[134];
		conv += panelSh[p_idx + 122] * templateSh[133];
		conv += panelSh[p_idx + 123] * templateSh[132];
		conv += panelSh[p_idx + 124] * templateSh[131];
		conv += panelSh[p_idx + 125] * templateSh[130];
		conv += panelSh[p_idx + 126] * templateSh[129];
		conv += panelSh[p_idx + 127] * templateSh[128];
		conv += panelSh[p_idx + 128] * templateSh[127];
		conv += panelSh[p_idx + 129] * templateSh[126];
		conv += panelSh[p_idx + 145] * templateSh[125];
		conv += panelSh[p_idx + 146] * templateSh[124];
		conv += panelSh[p_idx + 147] * templateSh[123];
		conv += panelSh[p_idx + 148] * templateSh[122];
		conv += panelSh[p_idx + 149] * templateSh[121];
		conv += panelSh[p_idx + 150] * templateSh[120];
		conv += panelSh[p_idx + 151] * templateSh[119];
		conv += panelSh[p_idx + 152] * templateSh[118];
		conv += panelSh[p_idx + 153] * templateSh[117];
		conv += panelSh[p_idx + 154] * templateSh[116];
		conv += panelSh[p_idx + 155] * templateSh[115];
		conv += panelSh[p_idx + 156] * templateSh[114];
		conv += panelSh[p_idx + 157] * templateSh[113];
		conv += panelSh[p_idx + 158] * templateSh[112];
		conv += panelSh[p_idx + 174] * templateSh[111];
		conv += panelSh[p_idx + 175] * templateSh[110];
		conv += panelSh[p_idx + 176] * templateSh[109];
		conv += panelSh[p_idx + 177] * templateSh[108];
		conv += panelSh[p_idx + 178] * templateSh[107];
		conv += panelSh[p_idx + 179] * templateSh[106];
		conv += panelSh[p_idx + 180] * templateSh[105];
		conv += panelSh[p_idx + 181] * templateSh[104];
		conv += panelSh[p_idx + 182] * templateSh[103];
		conv += panelSh[p_idx + 183] * templateSh[102];
		conv += panelSh[p_idx + 184] * templateSh[101];
		conv += panelSh[p_idx + 185] * templateSh[100];
		conv += panelSh[p_idx + 186] * templateSh[99];
		conv += panelSh[p_idx + 187] * templateSh[98];
		conv += panelSh[p_idx + 203] * templateSh[97];
		conv += panelSh[p_idx + 204] * templateSh[96];
		conv += panelSh[p_idx + 205] * templateSh[95];
		conv += panelSh[p_idx + 206] * templateSh[94];
		conv += panelSh[p_idx + 207] * templateSh[93];
		conv += panelSh[p_idx + 208] * templateSh[92];
		conv += panelSh[p_idx + 209] * templateSh[91];
		conv += panelSh[p_idx + 210] * templateSh[90];
		conv += panelSh[p_idx + 211] * templateSh[89];
		conv += panelSh[p_idx + 212] * templateSh[88];
		conv += panelSh[p_idx + 213] * templateSh[87];
		conv += panelSh[p_idx + 214] * templateSh[86];
		conv += panelSh[p_idx + 215] * templateSh[85];
		conv += panelSh[p_idx + 216] * templateSh[84];
		conv += panelSh[p_idx + 232] * templateSh[83];
		conv += panelSh[p_idx + 233] * templateSh[82];
		conv += panelSh[p_idx + 234] * templateSh[81];
		conv += panelSh[p_idx + 235] * templateSh[80];
		conv += panelSh[p_idx + 236] * templateSh[79];
		conv += panelSh[p_idx + 237] * templateSh[78];
		conv += panelSh[p_idx + 238] * templateSh[77];
		conv += panelSh[p_idx + 239] * templateSh[76];
		conv += panelSh[p_idx + 240] * templateSh[75];
		conv += panelSh[p_idx + 241] * templateSh[74];
		conv += panelSh[p_idx + 242] * templateSh[73];
		conv += panelSh[p_idx + 243] * templateSh[72];
		conv += panelSh[p_idx + 244] * templateSh[71];
		conv += panelSh[p_idx + 245] * templateSh[70];
		conv += panelSh[p_idx + 261] * templateSh[69];
		conv += panelSh[p_idx + 262] * templateSh[68];
		conv += panelSh[p_idx + 263] * templateSh[67];
		conv += panelSh[p_idx + 264] * templateSh[66];
		conv += panelSh[p_idx + 265] * templateSh[65];
		conv += panelSh[p_idx + 266] * templateSh[64];
		conv += panelSh[p_idx + 267] * templateSh[63];
		conv += panelSh[p_idx + 268] * templateSh[62];
		conv += panelSh[p_idx + 269] * templateSh[61];
		conv += panelSh[p_idx + 270] * templateSh[60];
		conv += panelSh[p_idx + 271] * templateSh[59];
		conv += panelSh[p_idx + 272] * templateSh[58];
		conv += panelSh[p_idx + 273] * templateSh[57];
		conv += panelSh[p_idx + 274] * templateSh[56];
		conv += panelSh[p_idx + 290] * templateSh[55];
		conv += panelSh[p_idx + 291] * templateSh[54];
		conv += panelSh[p_idx + 292] * templateSh[53];
		conv += panelSh[p_idx + 293] * templateSh[52];
		conv += panelSh[p_idx + 294] * templateSh[51];
		conv += panelSh[p_idx + 295] * templateSh[50];
		conv += panelSh[p_idx + 296] * templateSh[49];
		conv += panelSh[p_idx + 297] * templateSh[48];
		conv += panelSh[p_idx + 298] * templateSh[47];
		conv += panelSh[p_idx + 299] * templateSh[46];
		conv += panelSh[p_idx + 300] * templateSh[45];
		conv += panelSh[p_idx + 301] * templateSh[44];
		conv += panelSh[p_idx + 302] * templateSh[43];
		conv += panelSh[p_idx + 303] * templateSh[42];
		conv += panelSh[p_idx + 319] * templateSh[41];
		conv += panelSh[p_idx + 320] * templateSh[40];
		conv += panelSh[p_idx + 321] * templateSh[39];
		conv += panelSh[p_idx + 322] * templateSh[38];
		conv += panelSh[p_idx + 323] * templateSh[37];
		conv += panelSh[p_idx + 324] * templateSh[36];
		conv += panelSh[p_idx + 325] * templateSh[35];
		conv += panelSh[p_idx + 326] * templateSh[34];
		conv += panelSh[p_idx + 327] * templateSh[33];
		conv += panelSh[p_idx + 328] * templateSh[32];
		conv += panelSh[p_idx + 329] * templateSh[31];
		conv += panelSh[p_idx + 330] * templateSh[30];
		conv += panelSh[p_idx + 331] * templateSh[29];
		conv += panelSh[p_idx + 332] * templateSh[28];
		conv += panelSh[p_idx + 348] * templateSh[27];
		conv += panelSh[p_idx + 349] * templateSh[26];
		conv += panelSh[p_idx + 350] * templateSh[25];
		conv += panelSh[p_idx + 351] * templateSh[24];
		conv += panelSh[p_idx + 352] * templateSh[23];
		conv += panelSh[p_idx + 353] * templateSh[22];
		conv += panelSh[p_idx + 354] * templateSh[21];
		conv += panelSh[p_idx + 355] * templateSh[20];
		conv += panelSh[p_idx + 356] * templateSh[19];
		conv += panelSh[p_idx + 357] * templateSh[18];
		conv += panelSh[p_idx + 358] * templateSh[17];
		conv += panelSh[p_idx + 359] * templateSh[16];
		conv += panelSh[p_idx + 360] * templateSh[15];
		conv += panelSh[p_idx + 361] * templateSh[14];
		conv += panelSh[p_idx + 377] * templateSh[13];
		conv += panelSh[p_idx + 378] * templateSh[12];
		conv += panelSh[p_idx + 379] * templateSh[11];
		conv += panelSh[p_idx + 380] * templateSh[10];
		conv += panelSh[p_idx + 381] * templateSh[9];
		conv += panelSh[p_idx + 382] * templateSh[8];
		conv += panelSh[p_idx + 383] * templateSh[7];
		conv += panelSh[p_idx + 384] * templateSh[6];
		conv += panelSh[p_idx + 385] * templateSh[5];
		conv += panelSh[p_idx + 386] * templateSh[4];
		conv += panelSh[p_idx + 387] * templateSh[3];
		conv += panelSh[p_idx + 388] * templateSh[2];
		conv += panelSh[p_idx + 389] * templateSh[1];
		conv += panelSh[p_idx + 390] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_14x14<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_14x14<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_15x15 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[900];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<30; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<30; i+=16) {
			panelSh[IMUL(j, 30) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[225];
	if (threadIdx.x < 15 && threadIdx.y < 15) {
		const int jtwi = IMUL(threadIdx.y, 15) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 30);
		conv += panelSh[p_idx + 0] * templateSh[224];
		conv += panelSh[p_idx + 1] * templateSh[223];
		conv += panelSh[p_idx + 2] * templateSh[222];
		conv += panelSh[p_idx + 3] * templateSh[221];
		conv += panelSh[p_idx + 4] * templateSh[220];
		conv += panelSh[p_idx + 5] * templateSh[219];
		conv += panelSh[p_idx + 6] * templateSh[218];
		conv += panelSh[p_idx + 7] * templateSh[217];
		conv += panelSh[p_idx + 8] * templateSh[216];
		conv += panelSh[p_idx + 9] * templateSh[215];
		conv += panelSh[p_idx + 10] * templateSh[214];
		conv += panelSh[p_idx + 11] * templateSh[213];
		conv += panelSh[p_idx + 12] * templateSh[212];
		conv += panelSh[p_idx + 13] * templateSh[211];
		conv += panelSh[p_idx + 14] * templateSh[210];
		conv += panelSh[p_idx + 30] * templateSh[209];
		conv += panelSh[p_idx + 31] * templateSh[208];
		conv += panelSh[p_idx + 32] * templateSh[207];
		conv += panelSh[p_idx + 33] * templateSh[206];
		conv += panelSh[p_idx + 34] * templateSh[205];
		conv += panelSh[p_idx + 35] * templateSh[204];
		conv += panelSh[p_idx + 36] * templateSh[203];
		conv += panelSh[p_idx + 37] * templateSh[202];
		conv += panelSh[p_idx + 38] * templateSh[201];
		conv += panelSh[p_idx + 39] * templateSh[200];
		conv += panelSh[p_idx + 40] * templateSh[199];
		conv += panelSh[p_idx + 41] * templateSh[198];
		conv += panelSh[p_idx + 42] * templateSh[197];
		conv += panelSh[p_idx + 43] * templateSh[196];
		conv += panelSh[p_idx + 44] * templateSh[195];
		conv += panelSh[p_idx + 60] * templateSh[194];
		conv += panelSh[p_idx + 61] * templateSh[193];
		conv += panelSh[p_idx + 62] * templateSh[192];
		conv += panelSh[p_idx + 63] * templateSh[191];
		conv += panelSh[p_idx + 64] * templateSh[190];
		conv += panelSh[p_idx + 65] * templateSh[189];
		conv += panelSh[p_idx + 66] * templateSh[188];
		conv += panelSh[p_idx + 67] * templateSh[187];
		conv += panelSh[p_idx + 68] * templateSh[186];
		conv += panelSh[p_idx + 69] * templateSh[185];
		conv += panelSh[p_idx + 70] * templateSh[184];
		conv += panelSh[p_idx + 71] * templateSh[183];
		conv += panelSh[p_idx + 72] * templateSh[182];
		conv += panelSh[p_idx + 73] * templateSh[181];
		conv += panelSh[p_idx + 74] * templateSh[180];
		conv += panelSh[p_idx + 90] * templateSh[179];
		conv += panelSh[p_idx + 91] * templateSh[178];
		conv += panelSh[p_idx + 92] * templateSh[177];
		conv += panelSh[p_idx + 93] * templateSh[176];
		conv += panelSh[p_idx + 94] * templateSh[175];
		conv += panelSh[p_idx + 95] * templateSh[174];
		conv += panelSh[p_idx + 96] * templateSh[173];
		conv += panelSh[p_idx + 97] * templateSh[172];
		conv += panelSh[p_idx + 98] * templateSh[171];
		conv += panelSh[p_idx + 99] * templateSh[170];
		conv += panelSh[p_idx + 100] * templateSh[169];
		conv += panelSh[p_idx + 101] * templateSh[168];
		conv += panelSh[p_idx + 102] * templateSh[167];
		conv += panelSh[p_idx + 103] * templateSh[166];
		conv += panelSh[p_idx + 104] * templateSh[165];
		conv += panelSh[p_idx + 120] * templateSh[164];
		conv += panelSh[p_idx + 121] * templateSh[163];
		conv += panelSh[p_idx + 122] * templateSh[162];
		conv += panelSh[p_idx + 123] * templateSh[161];
		conv += panelSh[p_idx + 124] * templateSh[160];
		conv += panelSh[p_idx + 125] * templateSh[159];
		conv += panelSh[p_idx + 126] * templateSh[158];
		conv += panelSh[p_idx + 127] * templateSh[157];
		conv += panelSh[p_idx + 128] * templateSh[156];
		conv += panelSh[p_idx + 129] * templateSh[155];
		conv += panelSh[p_idx + 130] * templateSh[154];
		conv += panelSh[p_idx + 131] * templateSh[153];
		conv += panelSh[p_idx + 132] * templateSh[152];
		conv += panelSh[p_idx + 133] * templateSh[151];
		conv += panelSh[p_idx + 134] * templateSh[150];
		conv += panelSh[p_idx + 150] * templateSh[149];
		conv += panelSh[p_idx + 151] * templateSh[148];
		conv += panelSh[p_idx + 152] * templateSh[147];
		conv += panelSh[p_idx + 153] * templateSh[146];
		conv += panelSh[p_idx + 154] * templateSh[145];
		conv += panelSh[p_idx + 155] * templateSh[144];
		conv += panelSh[p_idx + 156] * templateSh[143];
		conv += panelSh[p_idx + 157] * templateSh[142];
		conv += panelSh[p_idx + 158] * templateSh[141];
		conv += panelSh[p_idx + 159] * templateSh[140];
		conv += panelSh[p_idx + 160] * templateSh[139];
		conv += panelSh[p_idx + 161] * templateSh[138];
		conv += panelSh[p_idx + 162] * templateSh[137];
		conv += panelSh[p_idx + 163] * templateSh[136];
		conv += panelSh[p_idx + 164] * templateSh[135];
		conv += panelSh[p_idx + 180] * templateSh[134];
		conv += panelSh[p_idx + 181] * templateSh[133];
		conv += panelSh[p_idx + 182] * templateSh[132];
		conv += panelSh[p_idx + 183] * templateSh[131];
		conv += panelSh[p_idx + 184] * templateSh[130];
		conv += panelSh[p_idx + 185] * templateSh[129];
		conv += panelSh[p_idx + 186] * templateSh[128];
		conv += panelSh[p_idx + 187] * templateSh[127];
		conv += panelSh[p_idx + 188] * templateSh[126];
		conv += panelSh[p_idx + 189] * templateSh[125];
		conv += panelSh[p_idx + 190] * templateSh[124];
		conv += panelSh[p_idx + 191] * templateSh[123];
		conv += panelSh[p_idx + 192] * templateSh[122];
		conv += panelSh[p_idx + 193] * templateSh[121];
		conv += panelSh[p_idx + 194] * templateSh[120];
		conv += panelSh[p_idx + 210] * templateSh[119];
		conv += panelSh[p_idx + 211] * templateSh[118];
		conv += panelSh[p_idx + 212] * templateSh[117];
		conv += panelSh[p_idx + 213] * templateSh[116];
		conv += panelSh[p_idx + 214] * templateSh[115];
		conv += panelSh[p_idx + 215] * templateSh[114];
		conv += panelSh[p_idx + 216] * templateSh[113];
		conv += panelSh[p_idx + 217] * templateSh[112];
		conv += panelSh[p_idx + 218] * templateSh[111];
		conv += panelSh[p_idx + 219] * templateSh[110];
		conv += panelSh[p_idx + 220] * templateSh[109];
		conv += panelSh[p_idx + 221] * templateSh[108];
		conv += panelSh[p_idx + 222] * templateSh[107];
		conv += panelSh[p_idx + 223] * templateSh[106];
		conv += panelSh[p_idx + 224] * templateSh[105];
		conv += panelSh[p_idx + 240] * templateSh[104];
		conv += panelSh[p_idx + 241] * templateSh[103];
		conv += panelSh[p_idx + 242] * templateSh[102];
		conv += panelSh[p_idx + 243] * templateSh[101];
		conv += panelSh[p_idx + 244] * templateSh[100];
		conv += panelSh[p_idx + 245] * templateSh[99];
		conv += panelSh[p_idx + 246] * templateSh[98];
		conv += panelSh[p_idx + 247] * templateSh[97];
		conv += panelSh[p_idx + 248] * templateSh[96];
		conv += panelSh[p_idx + 249] * templateSh[95];
		conv += panelSh[p_idx + 250] * templateSh[94];
		conv += panelSh[p_idx + 251] * templateSh[93];
		conv += panelSh[p_idx + 252] * templateSh[92];
		conv += panelSh[p_idx + 253] * templateSh[91];
		conv += panelSh[p_idx + 254] * templateSh[90];
		conv += panelSh[p_idx + 270] * templateSh[89];
		conv += panelSh[p_idx + 271] * templateSh[88];
		conv += panelSh[p_idx + 272] * templateSh[87];
		conv += panelSh[p_idx + 273] * templateSh[86];
		conv += panelSh[p_idx + 274] * templateSh[85];
		conv += panelSh[p_idx + 275] * templateSh[84];
		conv += panelSh[p_idx + 276] * templateSh[83];
		conv += panelSh[p_idx + 277] * templateSh[82];
		conv += panelSh[p_idx + 278] * templateSh[81];
		conv += panelSh[p_idx + 279] * templateSh[80];
		conv += panelSh[p_idx + 280] * templateSh[79];
		conv += panelSh[p_idx + 281] * templateSh[78];
		conv += panelSh[p_idx + 282] * templateSh[77];
		conv += panelSh[p_idx + 283] * templateSh[76];
		conv += panelSh[p_idx + 284] * templateSh[75];
		conv += panelSh[p_idx + 300] * templateSh[74];
		conv += panelSh[p_idx + 301] * templateSh[73];
		conv += panelSh[p_idx + 302] * templateSh[72];
		conv += panelSh[p_idx + 303] * templateSh[71];
		conv += panelSh[p_idx + 304] * templateSh[70];
		conv += panelSh[p_idx + 305] * templateSh[69];
		conv += panelSh[p_idx + 306] * templateSh[68];
		conv += panelSh[p_idx + 307] * templateSh[67];
		conv += panelSh[p_idx + 308] * templateSh[66];
		conv += panelSh[p_idx + 309] * templateSh[65];
		conv += panelSh[p_idx + 310] * templateSh[64];
		conv += panelSh[p_idx + 311] * templateSh[63];
		conv += panelSh[p_idx + 312] * templateSh[62];
		conv += panelSh[p_idx + 313] * templateSh[61];
		conv += panelSh[p_idx + 314] * templateSh[60];
		conv += panelSh[p_idx + 330] * templateSh[59];
		conv += panelSh[p_idx + 331] * templateSh[58];
		conv += panelSh[p_idx + 332] * templateSh[57];
		conv += panelSh[p_idx + 333] * templateSh[56];
		conv += panelSh[p_idx + 334] * templateSh[55];
		conv += panelSh[p_idx + 335] * templateSh[54];
		conv += panelSh[p_idx + 336] * templateSh[53];
		conv += panelSh[p_idx + 337] * templateSh[52];
		conv += panelSh[p_idx + 338] * templateSh[51];
		conv += panelSh[p_idx + 339] * templateSh[50];
		conv += panelSh[p_idx + 340] * templateSh[49];
		conv += panelSh[p_idx + 341] * templateSh[48];
		conv += panelSh[p_idx + 342] * templateSh[47];
		conv += panelSh[p_idx + 343] * templateSh[46];
		conv += panelSh[p_idx + 344] * templateSh[45];
		conv += panelSh[p_idx + 360] * templateSh[44];
		conv += panelSh[p_idx + 361] * templateSh[43];
		conv += panelSh[p_idx + 362] * templateSh[42];
		conv += panelSh[p_idx + 363] * templateSh[41];
		conv += panelSh[p_idx + 364] * templateSh[40];
		conv += panelSh[p_idx + 365] * templateSh[39];
		conv += panelSh[p_idx + 366] * templateSh[38];
		conv += panelSh[p_idx + 367] * templateSh[37];
		conv += panelSh[p_idx + 368] * templateSh[36];
		conv += panelSh[p_idx + 369] * templateSh[35];
		conv += panelSh[p_idx + 370] * templateSh[34];
		conv += panelSh[p_idx + 371] * templateSh[33];
		conv += panelSh[p_idx + 372] * templateSh[32];
		conv += panelSh[p_idx + 373] * templateSh[31];
		conv += panelSh[p_idx + 374] * templateSh[30];
		conv += panelSh[p_idx + 390] * templateSh[29];
		conv += panelSh[p_idx + 391] * templateSh[28];
		conv += panelSh[p_idx + 392] * templateSh[27];
		conv += panelSh[p_idx + 393] * templateSh[26];
		conv += panelSh[p_idx + 394] * templateSh[25];
		conv += panelSh[p_idx + 395] * templateSh[24];
		conv += panelSh[p_idx + 396] * templateSh[23];
		conv += panelSh[p_idx + 397] * templateSh[22];
		conv += panelSh[p_idx + 398] * templateSh[21];
		conv += panelSh[p_idx + 399] * templateSh[20];
		conv += panelSh[p_idx + 400] * templateSh[19];
		conv += panelSh[p_idx + 401] * templateSh[18];
		conv += panelSh[p_idx + 402] * templateSh[17];
		conv += panelSh[p_idx + 403] * templateSh[16];
		conv += panelSh[p_idx + 404] * templateSh[15];
		conv += panelSh[p_idx + 420] * templateSh[14];
		conv += panelSh[p_idx + 421] * templateSh[13];
		conv += panelSh[p_idx + 422] * templateSh[12];
		conv += panelSh[p_idx + 423] * templateSh[11];
		conv += panelSh[p_idx + 424] * templateSh[10];
		conv += panelSh[p_idx + 425] * templateSh[9];
		conv += panelSh[p_idx + 426] * templateSh[8];
		conv += panelSh[p_idx + 427] * templateSh[7];
		conv += panelSh[p_idx + 428] * templateSh[6];
		conv += panelSh[p_idx + 429] * templateSh[5];
		conv += panelSh[p_idx + 430] * templateSh[4];
		conv += panelSh[p_idx + 431] * templateSh[3];
		conv += panelSh[p_idx + 432] * templateSh[2];
		conv += panelSh[p_idx + 433] * templateSh[1];
		conv += panelSh[p_idx + 434] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_15x15<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_15x15<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_16x16 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[961];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<31; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<31; i+=16) {
			panelSh[IMUL(j, 31) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[256];
	if (threadIdx.x < 16 && threadIdx.y < 16) {
		const int jtwi = IMUL(threadIdx.y, 16) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 31);
		conv += panelSh[p_idx + 0] * templateSh[255];
		conv += panelSh[p_idx + 1] * templateSh[254];
		conv += panelSh[p_idx + 2] * templateSh[253];
		conv += panelSh[p_idx + 3] * templateSh[252];
		conv += panelSh[p_idx + 4] * templateSh[251];
		conv += panelSh[p_idx + 5] * templateSh[250];
		conv += panelSh[p_idx + 6] * templateSh[249];
		conv += panelSh[p_idx + 7] * templateSh[248];
		conv += panelSh[p_idx + 8] * templateSh[247];
		conv += panelSh[p_idx + 9] * templateSh[246];
		conv += panelSh[p_idx + 10] * templateSh[245];
		conv += panelSh[p_idx + 11] * templateSh[244];
		conv += panelSh[p_idx + 12] * templateSh[243];
		conv += panelSh[p_idx + 13] * templateSh[242];
		conv += panelSh[p_idx + 14] * templateSh[241];
		conv += panelSh[p_idx + 15] * templateSh[240];
		conv += panelSh[p_idx + 31] * templateSh[239];
		conv += panelSh[p_idx + 32] * templateSh[238];
		conv += panelSh[p_idx + 33] * templateSh[237];
		conv += panelSh[p_idx + 34] * templateSh[236];
		conv += panelSh[p_idx + 35] * templateSh[235];
		conv += panelSh[p_idx + 36] * templateSh[234];
		conv += panelSh[p_idx + 37] * templateSh[233];
		conv += panelSh[p_idx + 38] * templateSh[232];
		conv += panelSh[p_idx + 39] * templateSh[231];
		conv += panelSh[p_idx + 40] * templateSh[230];
		conv += panelSh[p_idx + 41] * templateSh[229];
		conv += panelSh[p_idx + 42] * templateSh[228];
		conv += panelSh[p_idx + 43] * templateSh[227];
		conv += panelSh[p_idx + 44] * templateSh[226];
		conv += panelSh[p_idx + 45] * templateSh[225];
		conv += panelSh[p_idx + 46] * templateSh[224];
		conv += panelSh[p_idx + 62] * templateSh[223];
		conv += panelSh[p_idx + 63] * templateSh[222];
		conv += panelSh[p_idx + 64] * templateSh[221];
		conv += panelSh[p_idx + 65] * templateSh[220];
		conv += panelSh[p_idx + 66] * templateSh[219];
		conv += panelSh[p_idx + 67] * templateSh[218];
		conv += panelSh[p_idx + 68] * templateSh[217];
		conv += panelSh[p_idx + 69] * templateSh[216];
		conv += panelSh[p_idx + 70] * templateSh[215];
		conv += panelSh[p_idx + 71] * templateSh[214];
		conv += panelSh[p_idx + 72] * templateSh[213];
		conv += panelSh[p_idx + 73] * templateSh[212];
		conv += panelSh[p_idx + 74] * templateSh[211];
		conv += panelSh[p_idx + 75] * templateSh[210];
		conv += panelSh[p_idx + 76] * templateSh[209];
		conv += panelSh[p_idx + 77] * templateSh[208];
		conv += panelSh[p_idx + 93] * templateSh[207];
		conv += panelSh[p_idx + 94] * templateSh[206];
		conv += panelSh[p_idx + 95] * templateSh[205];
		conv += panelSh[p_idx + 96] * templateSh[204];
		conv += panelSh[p_idx + 97] * templateSh[203];
		conv += panelSh[p_idx + 98] * templateSh[202];
		conv += panelSh[p_idx + 99] * templateSh[201];
		conv += panelSh[p_idx + 100] * templateSh[200];
		conv += panelSh[p_idx + 101] * templateSh[199];
		conv += panelSh[p_idx + 102] * templateSh[198];
		conv += panelSh[p_idx + 103] * templateSh[197];
		conv += panelSh[p_idx + 104] * templateSh[196];
		conv += panelSh[p_idx + 105] * templateSh[195];
		conv += panelSh[p_idx + 106] * templateSh[194];
		conv += panelSh[p_idx + 107] * templateSh[193];
		conv += panelSh[p_idx + 108] * templateSh[192];
		conv += panelSh[p_idx + 124] * templateSh[191];
		conv += panelSh[p_idx + 125] * templateSh[190];
		conv += panelSh[p_idx + 126] * templateSh[189];
		conv += panelSh[p_idx + 127] * templateSh[188];
		conv += panelSh[p_idx + 128] * templateSh[187];
		conv += panelSh[p_idx + 129] * templateSh[186];
		conv += panelSh[p_idx + 130] * templateSh[185];
		conv += panelSh[p_idx + 131] * templateSh[184];
		conv += panelSh[p_idx + 132] * templateSh[183];
		conv += panelSh[p_idx + 133] * templateSh[182];
		conv += panelSh[p_idx + 134] * templateSh[181];
		conv += panelSh[p_idx + 135] * templateSh[180];
		conv += panelSh[p_idx + 136] * templateSh[179];
		conv += panelSh[p_idx + 137] * templateSh[178];
		conv += panelSh[p_idx + 138] * templateSh[177];
		conv += panelSh[p_idx + 139] * templateSh[176];
		conv += panelSh[p_idx + 155] * templateSh[175];
		conv += panelSh[p_idx + 156] * templateSh[174];
		conv += panelSh[p_idx + 157] * templateSh[173];
		conv += panelSh[p_idx + 158] * templateSh[172];
		conv += panelSh[p_idx + 159] * templateSh[171];
		conv += panelSh[p_idx + 160] * templateSh[170];
		conv += panelSh[p_idx + 161] * templateSh[169];
		conv += panelSh[p_idx + 162] * templateSh[168];
		conv += panelSh[p_idx + 163] * templateSh[167];
		conv += panelSh[p_idx + 164] * templateSh[166];
		conv += panelSh[p_idx + 165] * templateSh[165];
		conv += panelSh[p_idx + 166] * templateSh[164];
		conv += panelSh[p_idx + 167] * templateSh[163];
		conv += panelSh[p_idx + 168] * templateSh[162];
		conv += panelSh[p_idx + 169] * templateSh[161];
		conv += panelSh[p_idx + 170] * templateSh[160];
		conv += panelSh[p_idx + 186] * templateSh[159];
		conv += panelSh[p_idx + 187] * templateSh[158];
		conv += panelSh[p_idx + 188] * templateSh[157];
		conv += panelSh[p_idx + 189] * templateSh[156];
		conv += panelSh[p_idx + 190] * templateSh[155];
		conv += panelSh[p_idx + 191] * templateSh[154];
		conv += panelSh[p_idx + 192] * templateSh[153];
		conv += panelSh[p_idx + 193] * templateSh[152];
		conv += panelSh[p_idx + 194] * templateSh[151];
		conv += panelSh[p_idx + 195] * templateSh[150];
		conv += panelSh[p_idx + 196] * templateSh[149];
		conv += panelSh[p_idx + 197] * templateSh[148];
		conv += panelSh[p_idx + 198] * templateSh[147];
		conv += panelSh[p_idx + 199] * templateSh[146];
		conv += panelSh[p_idx + 200] * templateSh[145];
		conv += panelSh[p_idx + 201] * templateSh[144];
		conv += panelSh[p_idx + 217] * templateSh[143];
		conv += panelSh[p_idx + 218] * templateSh[142];
		conv += panelSh[p_idx + 219] * templateSh[141];
		conv += panelSh[p_idx + 220] * templateSh[140];
		conv += panelSh[p_idx + 221] * templateSh[139];
		conv += panelSh[p_idx + 222] * templateSh[138];
		conv += panelSh[p_idx + 223] * templateSh[137];
		conv += panelSh[p_idx + 224] * templateSh[136];
		conv += panelSh[p_idx + 225] * templateSh[135];
		conv += panelSh[p_idx + 226] * templateSh[134];
		conv += panelSh[p_idx + 227] * templateSh[133];
		conv += panelSh[p_idx + 228] * templateSh[132];
		conv += panelSh[p_idx + 229] * templateSh[131];
		conv += panelSh[p_idx + 230] * templateSh[130];
		conv += panelSh[p_idx + 231] * templateSh[129];
		conv += panelSh[p_idx + 232] * templateSh[128];
		conv += panelSh[p_idx + 248] * templateSh[127];
		conv += panelSh[p_idx + 249] * templateSh[126];
		conv += panelSh[p_idx + 250] * templateSh[125];
		conv += panelSh[p_idx + 251] * templateSh[124];
		conv += panelSh[p_idx + 252] * templateSh[123];
		conv += panelSh[p_idx + 253] * templateSh[122];
		conv += panelSh[p_idx + 254] * templateSh[121];
		conv += panelSh[p_idx + 255] * templateSh[120];
		conv += panelSh[p_idx + 256] * templateSh[119];
		conv += panelSh[p_idx + 257] * templateSh[118];
		conv += panelSh[p_idx + 258] * templateSh[117];
		conv += panelSh[p_idx + 259] * templateSh[116];
		conv += panelSh[p_idx + 260] * templateSh[115];
		conv += panelSh[p_idx + 261] * templateSh[114];
		conv += panelSh[p_idx + 262] * templateSh[113];
		conv += panelSh[p_idx + 263] * templateSh[112];
		conv += panelSh[p_idx + 279] * templateSh[111];
		conv += panelSh[p_idx + 280] * templateSh[110];
		conv += panelSh[p_idx + 281] * templateSh[109];
		conv += panelSh[p_idx + 282] * templateSh[108];
		conv += panelSh[p_idx + 283] * templateSh[107];
		conv += panelSh[p_idx + 284] * templateSh[106];
		conv += panelSh[p_idx + 285] * templateSh[105];
		conv += panelSh[p_idx + 286] * templateSh[104];
		conv += panelSh[p_idx + 287] * templateSh[103];
		conv += panelSh[p_idx + 288] * templateSh[102];
		conv += panelSh[p_idx + 289] * templateSh[101];
		conv += panelSh[p_idx + 290] * templateSh[100];
		conv += panelSh[p_idx + 291] * templateSh[99];
		conv += panelSh[p_idx + 292] * templateSh[98];
		conv += panelSh[p_idx + 293] * templateSh[97];
		conv += panelSh[p_idx + 294] * templateSh[96];
		conv += panelSh[p_idx + 310] * templateSh[95];
		conv += panelSh[p_idx + 311] * templateSh[94];
		conv += panelSh[p_idx + 312] * templateSh[93];
		conv += panelSh[p_idx + 313] * templateSh[92];
		conv += panelSh[p_idx + 314] * templateSh[91];
		conv += panelSh[p_idx + 315] * templateSh[90];
		conv += panelSh[p_idx + 316] * templateSh[89];
		conv += panelSh[p_idx + 317] * templateSh[88];
		conv += panelSh[p_idx + 318] * templateSh[87];
		conv += panelSh[p_idx + 319] * templateSh[86];
		conv += panelSh[p_idx + 320] * templateSh[85];
		conv += panelSh[p_idx + 321] * templateSh[84];
		conv += panelSh[p_idx + 322] * templateSh[83];
		conv += panelSh[p_idx + 323] * templateSh[82];
		conv += panelSh[p_idx + 324] * templateSh[81];
		conv += panelSh[p_idx + 325] * templateSh[80];
		conv += panelSh[p_idx + 341] * templateSh[79];
		conv += panelSh[p_idx + 342] * templateSh[78];
		conv += panelSh[p_idx + 343] * templateSh[77];
		conv += panelSh[p_idx + 344] * templateSh[76];
		conv += panelSh[p_idx + 345] * templateSh[75];
		conv += panelSh[p_idx + 346] * templateSh[74];
		conv += panelSh[p_idx + 347] * templateSh[73];
		conv += panelSh[p_idx + 348] * templateSh[72];
		conv += panelSh[p_idx + 349] * templateSh[71];
		conv += panelSh[p_idx + 350] * templateSh[70];
		conv += panelSh[p_idx + 351] * templateSh[69];
		conv += panelSh[p_idx + 352] * templateSh[68];
		conv += panelSh[p_idx + 353] * templateSh[67];
		conv += panelSh[p_idx + 354] * templateSh[66];
		conv += panelSh[p_idx + 355] * templateSh[65];
		conv += panelSh[p_idx + 356] * templateSh[64];
		conv += panelSh[p_idx + 372] * templateSh[63];
		conv += panelSh[p_idx + 373] * templateSh[62];
		conv += panelSh[p_idx + 374] * templateSh[61];
		conv += panelSh[p_idx + 375] * templateSh[60];
		conv += panelSh[p_idx + 376] * templateSh[59];
		conv += panelSh[p_idx + 377] * templateSh[58];
		conv += panelSh[p_idx + 378] * templateSh[57];
		conv += panelSh[p_idx + 379] * templateSh[56];
		conv += panelSh[p_idx + 380] * templateSh[55];
		conv += panelSh[p_idx + 381] * templateSh[54];
		conv += panelSh[p_idx + 382] * templateSh[53];
		conv += panelSh[p_idx + 383] * templateSh[52];
		conv += panelSh[p_idx + 384] * templateSh[51];
		conv += panelSh[p_idx + 385] * templateSh[50];
		conv += panelSh[p_idx + 386] * templateSh[49];
		conv += panelSh[p_idx + 387] * templateSh[48];
		conv += panelSh[p_idx + 403] * templateSh[47];
		conv += panelSh[p_idx + 404] * templateSh[46];
		conv += panelSh[p_idx + 405] * templateSh[45];
		conv += panelSh[p_idx + 406] * templateSh[44];
		conv += panelSh[p_idx + 407] * templateSh[43];
		conv += panelSh[p_idx + 408] * templateSh[42];
		conv += panelSh[p_idx + 409] * templateSh[41];
		conv += panelSh[p_idx + 410] * templateSh[40];
		conv += panelSh[p_idx + 411] * templateSh[39];
		conv += panelSh[p_idx + 412] * templateSh[38];
		conv += panelSh[p_idx + 413] * templateSh[37];
		conv += panelSh[p_idx + 414] * templateSh[36];
		conv += panelSh[p_idx + 415] * templateSh[35];
		conv += panelSh[p_idx + 416] * templateSh[34];
		conv += panelSh[p_idx + 417] * templateSh[33];
		conv += panelSh[p_idx + 418] * templateSh[32];
		conv += panelSh[p_idx + 434] * templateSh[31];
		conv += panelSh[p_idx + 435] * templateSh[30];
		conv += panelSh[p_idx + 436] * templateSh[29];
		conv += panelSh[p_idx + 437] * templateSh[28];
		conv += panelSh[p_idx + 438] * templateSh[27];
		conv += panelSh[p_idx + 439] * templateSh[26];
		conv += panelSh[p_idx + 440] * templateSh[25];
		conv += panelSh[p_idx + 441] * templateSh[24];
		conv += panelSh[p_idx + 442] * templateSh[23];
		conv += panelSh[p_idx + 443] * templateSh[22];
		conv += panelSh[p_idx + 444] * templateSh[21];
		conv += panelSh[p_idx + 445] * templateSh[20];
		conv += panelSh[p_idx + 446] * templateSh[19];
		conv += panelSh[p_idx + 447] * templateSh[18];
		conv += panelSh[p_idx + 448] * templateSh[17];
		conv += panelSh[p_idx + 449] * templateSh[16];
		conv += panelSh[p_idx + 465] * templateSh[15];
		conv += panelSh[p_idx + 466] * templateSh[14];
		conv += panelSh[p_idx + 467] * templateSh[13];
		conv += panelSh[p_idx + 468] * templateSh[12];
		conv += panelSh[p_idx + 469] * templateSh[11];
		conv += panelSh[p_idx + 470] * templateSh[10];
		conv += panelSh[p_idx + 471] * templateSh[9];
		conv += panelSh[p_idx + 472] * templateSh[8];
		conv += panelSh[p_idx + 473] * templateSh[7];
		conv += panelSh[p_idx + 474] * templateSh[6];
		conv += panelSh[p_idx + 475] * templateSh[5];
		conv += panelSh[p_idx + 476] * templateSh[4];
		conv += panelSh[p_idx + 477] * templateSh[3];
		conv += panelSh[p_idx + 478] * templateSh[2];
		conv += panelSh[p_idx + 479] * templateSh[1];
		conv += panelSh[p_idx + 480] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_16x16<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_16x16<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_17x17 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1024];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<32; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<32; i+=16) {
			panelSh[IMUL(j, 32) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[289];
	for (int j=threadIdx.y; j<17; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<17; i+=16) {
			const int jtwi = IMUL(j, 17) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 32);
		conv += panelSh[p_idx + 0] * templateSh[288];
		conv += panelSh[p_idx + 1] * templateSh[287];
		conv += panelSh[p_idx + 2] * templateSh[286];
		conv += panelSh[p_idx + 3] * templateSh[285];
		conv += panelSh[p_idx + 4] * templateSh[284];
		conv += panelSh[p_idx + 5] * templateSh[283];
		conv += panelSh[p_idx + 6] * templateSh[282];
		conv += panelSh[p_idx + 7] * templateSh[281];
		conv += panelSh[p_idx + 8] * templateSh[280];
		conv += panelSh[p_idx + 9] * templateSh[279];
		conv += panelSh[p_idx + 10] * templateSh[278];
		conv += panelSh[p_idx + 11] * templateSh[277];
		conv += panelSh[p_idx + 12] * templateSh[276];
		conv += panelSh[p_idx + 13] * templateSh[275];
		conv += panelSh[p_idx + 14] * templateSh[274];
		conv += panelSh[p_idx + 15] * templateSh[273];
		conv += panelSh[p_idx + 16] * templateSh[272];
		conv += panelSh[p_idx + 32] * templateSh[271];
		conv += panelSh[p_idx + 33] * templateSh[270];
		conv += panelSh[p_idx + 34] * templateSh[269];
		conv += panelSh[p_idx + 35] * templateSh[268];
		conv += panelSh[p_idx + 36] * templateSh[267];
		conv += panelSh[p_idx + 37] * templateSh[266];
		conv += panelSh[p_idx + 38] * templateSh[265];
		conv += panelSh[p_idx + 39] * templateSh[264];
		conv += panelSh[p_idx + 40] * templateSh[263];
		conv += panelSh[p_idx + 41] * templateSh[262];
		conv += panelSh[p_idx + 42] * templateSh[261];
		conv += panelSh[p_idx + 43] * templateSh[260];
		conv += panelSh[p_idx + 44] * templateSh[259];
		conv += panelSh[p_idx + 45] * templateSh[258];
		conv += panelSh[p_idx + 46] * templateSh[257];
		conv += panelSh[p_idx + 47] * templateSh[256];
		conv += panelSh[p_idx + 48] * templateSh[255];
		conv += panelSh[p_idx + 64] * templateSh[254];
		conv += panelSh[p_idx + 65] * templateSh[253];
		conv += panelSh[p_idx + 66] * templateSh[252];
		conv += panelSh[p_idx + 67] * templateSh[251];
		conv += panelSh[p_idx + 68] * templateSh[250];
		conv += panelSh[p_idx + 69] * templateSh[249];
		conv += panelSh[p_idx + 70] * templateSh[248];
		conv += panelSh[p_idx + 71] * templateSh[247];
		conv += panelSh[p_idx + 72] * templateSh[246];
		conv += panelSh[p_idx + 73] * templateSh[245];
		conv += panelSh[p_idx + 74] * templateSh[244];
		conv += panelSh[p_idx + 75] * templateSh[243];
		conv += panelSh[p_idx + 76] * templateSh[242];
		conv += panelSh[p_idx + 77] * templateSh[241];
		conv += panelSh[p_idx + 78] * templateSh[240];
		conv += panelSh[p_idx + 79] * templateSh[239];
		conv += panelSh[p_idx + 80] * templateSh[238];
		conv += panelSh[p_idx + 96] * templateSh[237];
		conv += panelSh[p_idx + 97] * templateSh[236];
		conv += panelSh[p_idx + 98] * templateSh[235];
		conv += panelSh[p_idx + 99] * templateSh[234];
		conv += panelSh[p_idx + 100] * templateSh[233];
		conv += panelSh[p_idx + 101] * templateSh[232];
		conv += panelSh[p_idx + 102] * templateSh[231];
		conv += panelSh[p_idx + 103] * templateSh[230];
		conv += panelSh[p_idx + 104] * templateSh[229];
		conv += panelSh[p_idx + 105] * templateSh[228];
		conv += panelSh[p_idx + 106] * templateSh[227];
		conv += panelSh[p_idx + 107] * templateSh[226];
		conv += panelSh[p_idx + 108] * templateSh[225];
		conv += panelSh[p_idx + 109] * templateSh[224];
		conv += panelSh[p_idx + 110] * templateSh[223];
		conv += panelSh[p_idx + 111] * templateSh[222];
		conv += panelSh[p_idx + 112] * templateSh[221];
		conv += panelSh[p_idx + 128] * templateSh[220];
		conv += panelSh[p_idx + 129] * templateSh[219];
		conv += panelSh[p_idx + 130] * templateSh[218];
		conv += panelSh[p_idx + 131] * templateSh[217];
		conv += panelSh[p_idx + 132] * templateSh[216];
		conv += panelSh[p_idx + 133] * templateSh[215];
		conv += panelSh[p_idx + 134] * templateSh[214];
		conv += panelSh[p_idx + 135] * templateSh[213];
		conv += panelSh[p_idx + 136] * templateSh[212];
		conv += panelSh[p_idx + 137] * templateSh[211];
		conv += panelSh[p_idx + 138] * templateSh[210];
		conv += panelSh[p_idx + 139] * templateSh[209];
		conv += panelSh[p_idx + 140] * templateSh[208];
		conv += panelSh[p_idx + 141] * templateSh[207];
		conv += panelSh[p_idx + 142] * templateSh[206];
		conv += panelSh[p_idx + 143] * templateSh[205];
		conv += panelSh[p_idx + 144] * templateSh[204];
		conv += panelSh[p_idx + 160] * templateSh[203];
		conv += panelSh[p_idx + 161] * templateSh[202];
		conv += panelSh[p_idx + 162] * templateSh[201];
		conv += panelSh[p_idx + 163] * templateSh[200];
		conv += panelSh[p_idx + 164] * templateSh[199];
		conv += panelSh[p_idx + 165] * templateSh[198];
		conv += panelSh[p_idx + 166] * templateSh[197];
		conv += panelSh[p_idx + 167] * templateSh[196];
		conv += panelSh[p_idx + 168] * templateSh[195];
		conv += panelSh[p_idx + 169] * templateSh[194];
		conv += panelSh[p_idx + 170] * templateSh[193];
		conv += panelSh[p_idx + 171] * templateSh[192];
		conv += panelSh[p_idx + 172] * templateSh[191];
		conv += panelSh[p_idx + 173] * templateSh[190];
		conv += panelSh[p_idx + 174] * templateSh[189];
		conv += panelSh[p_idx + 175] * templateSh[188];
		conv += panelSh[p_idx + 176] * templateSh[187];
		conv += panelSh[p_idx + 192] * templateSh[186];
		conv += panelSh[p_idx + 193] * templateSh[185];
		conv += panelSh[p_idx + 194] * templateSh[184];
		conv += panelSh[p_idx + 195] * templateSh[183];
		conv += panelSh[p_idx + 196] * templateSh[182];
		conv += panelSh[p_idx + 197] * templateSh[181];
		conv += panelSh[p_idx + 198] * templateSh[180];
		conv += panelSh[p_idx + 199] * templateSh[179];
		conv += panelSh[p_idx + 200] * templateSh[178];
		conv += panelSh[p_idx + 201] * templateSh[177];
		conv += panelSh[p_idx + 202] * templateSh[176];
		conv += panelSh[p_idx + 203] * templateSh[175];
		conv += panelSh[p_idx + 204] * templateSh[174];
		conv += panelSh[p_idx + 205] * templateSh[173];
		conv += panelSh[p_idx + 206] * templateSh[172];
		conv += panelSh[p_idx + 207] * templateSh[171];
		conv += panelSh[p_idx + 208] * templateSh[170];
		conv += panelSh[p_idx + 224] * templateSh[169];
		conv += panelSh[p_idx + 225] * templateSh[168];
		conv += panelSh[p_idx + 226] * templateSh[167];
		conv += panelSh[p_idx + 227] * templateSh[166];
		conv += panelSh[p_idx + 228] * templateSh[165];
		conv += panelSh[p_idx + 229] * templateSh[164];
		conv += panelSh[p_idx + 230] * templateSh[163];
		conv += panelSh[p_idx + 231] * templateSh[162];
		conv += panelSh[p_idx + 232] * templateSh[161];
		conv += panelSh[p_idx + 233] * templateSh[160];
		conv += panelSh[p_idx + 234] * templateSh[159];
		conv += panelSh[p_idx + 235] * templateSh[158];
		conv += panelSh[p_idx + 236] * templateSh[157];
		conv += panelSh[p_idx + 237] * templateSh[156];
		conv += panelSh[p_idx + 238] * templateSh[155];
		conv += panelSh[p_idx + 239] * templateSh[154];
		conv += panelSh[p_idx + 240] * templateSh[153];
		conv += panelSh[p_idx + 256] * templateSh[152];
		conv += panelSh[p_idx + 257] * templateSh[151];
		conv += panelSh[p_idx + 258] * templateSh[150];
		conv += panelSh[p_idx + 259] * templateSh[149];
		conv += panelSh[p_idx + 260] * templateSh[148];
		conv += panelSh[p_idx + 261] * templateSh[147];
		conv += panelSh[p_idx + 262] * templateSh[146];
		conv += panelSh[p_idx + 263] * templateSh[145];
		conv += panelSh[p_idx + 264] * templateSh[144];
		conv += panelSh[p_idx + 265] * templateSh[143];
		conv += panelSh[p_idx + 266] * templateSh[142];
		conv += panelSh[p_idx + 267] * templateSh[141];
		conv += panelSh[p_idx + 268] * templateSh[140];
		conv += panelSh[p_idx + 269] * templateSh[139];
		conv += panelSh[p_idx + 270] * templateSh[138];
		conv += panelSh[p_idx + 271] * templateSh[137];
		conv += panelSh[p_idx + 272] * templateSh[136];
		conv += panelSh[p_idx + 288] * templateSh[135];
		conv += panelSh[p_idx + 289] * templateSh[134];
		conv += panelSh[p_idx + 290] * templateSh[133];
		conv += panelSh[p_idx + 291] * templateSh[132];
		conv += panelSh[p_idx + 292] * templateSh[131];
		conv += panelSh[p_idx + 293] * templateSh[130];
		conv += panelSh[p_idx + 294] * templateSh[129];
		conv += panelSh[p_idx + 295] * templateSh[128];
		conv += panelSh[p_idx + 296] * templateSh[127];
		conv += panelSh[p_idx + 297] * templateSh[126];
		conv += panelSh[p_idx + 298] * templateSh[125];
		conv += panelSh[p_idx + 299] * templateSh[124];
		conv += panelSh[p_idx + 300] * templateSh[123];
		conv += panelSh[p_idx + 301] * templateSh[122];
		conv += panelSh[p_idx + 302] * templateSh[121];
		conv += panelSh[p_idx + 303] * templateSh[120];
		conv += panelSh[p_idx + 304] * templateSh[119];
		conv += panelSh[p_idx + 320] * templateSh[118];
		conv += panelSh[p_idx + 321] * templateSh[117];
		conv += panelSh[p_idx + 322] * templateSh[116];
		conv += panelSh[p_idx + 323] * templateSh[115];
		conv += panelSh[p_idx + 324] * templateSh[114];
		conv += panelSh[p_idx + 325] * templateSh[113];
		conv += panelSh[p_idx + 326] * templateSh[112];
		conv += panelSh[p_idx + 327] * templateSh[111];
		conv += panelSh[p_idx + 328] * templateSh[110];
		conv += panelSh[p_idx + 329] * templateSh[109];
		conv += panelSh[p_idx + 330] * templateSh[108];
		conv += panelSh[p_idx + 331] * templateSh[107];
		conv += panelSh[p_idx + 332] * templateSh[106];
		conv += panelSh[p_idx + 333] * templateSh[105];
		conv += panelSh[p_idx + 334] * templateSh[104];
		conv += panelSh[p_idx + 335] * templateSh[103];
		conv += panelSh[p_idx + 336] * templateSh[102];
		conv += panelSh[p_idx + 352] * templateSh[101];
		conv += panelSh[p_idx + 353] * templateSh[100];
		conv += panelSh[p_idx + 354] * templateSh[99];
		conv += panelSh[p_idx + 355] * templateSh[98];
		conv += panelSh[p_idx + 356] * templateSh[97];
		conv += panelSh[p_idx + 357] * templateSh[96];
		conv += panelSh[p_idx + 358] * templateSh[95];
		conv += panelSh[p_idx + 359] * templateSh[94];
		conv += panelSh[p_idx + 360] * templateSh[93];
		conv += panelSh[p_idx + 361] * templateSh[92];
		conv += panelSh[p_idx + 362] * templateSh[91];
		conv += panelSh[p_idx + 363] * templateSh[90];
		conv += panelSh[p_idx + 364] * templateSh[89];
		conv += panelSh[p_idx + 365] * templateSh[88];
		conv += panelSh[p_idx + 366] * templateSh[87];
		conv += panelSh[p_idx + 367] * templateSh[86];
		conv += panelSh[p_idx + 368] * templateSh[85];
		conv += panelSh[p_idx + 384] * templateSh[84];
		conv += panelSh[p_idx + 385] * templateSh[83];
		conv += panelSh[p_idx + 386] * templateSh[82];
		conv += panelSh[p_idx + 387] * templateSh[81];
		conv += panelSh[p_idx + 388] * templateSh[80];
		conv += panelSh[p_idx + 389] * templateSh[79];
		conv += panelSh[p_idx + 390] * templateSh[78];
		conv += panelSh[p_idx + 391] * templateSh[77];
		conv += panelSh[p_idx + 392] * templateSh[76];
		conv += panelSh[p_idx + 393] * templateSh[75];
		conv += panelSh[p_idx + 394] * templateSh[74];
		conv += panelSh[p_idx + 395] * templateSh[73];
		conv += panelSh[p_idx + 396] * templateSh[72];
		conv += panelSh[p_idx + 397] * templateSh[71];
		conv += panelSh[p_idx + 398] * templateSh[70];
		conv += panelSh[p_idx + 399] * templateSh[69];
		conv += panelSh[p_idx + 400] * templateSh[68];
		conv += panelSh[p_idx + 416] * templateSh[67];
		conv += panelSh[p_idx + 417] * templateSh[66];
		conv += panelSh[p_idx + 418] * templateSh[65];
		conv += panelSh[p_idx + 419] * templateSh[64];
		conv += panelSh[p_idx + 420] * templateSh[63];
		conv += panelSh[p_idx + 421] * templateSh[62];
		conv += panelSh[p_idx + 422] * templateSh[61];
		conv += panelSh[p_idx + 423] * templateSh[60];
		conv += panelSh[p_idx + 424] * templateSh[59];
		conv += panelSh[p_idx + 425] * templateSh[58];
		conv += panelSh[p_idx + 426] * templateSh[57];
		conv += panelSh[p_idx + 427] * templateSh[56];
		conv += panelSh[p_idx + 428] * templateSh[55];
		conv += panelSh[p_idx + 429] * templateSh[54];
		conv += panelSh[p_idx + 430] * templateSh[53];
		conv += panelSh[p_idx + 431] * templateSh[52];
		conv += panelSh[p_idx + 432] * templateSh[51];
		conv += panelSh[p_idx + 448] * templateSh[50];
		conv += panelSh[p_idx + 449] * templateSh[49];
		conv += panelSh[p_idx + 450] * templateSh[48];
		conv += panelSh[p_idx + 451] * templateSh[47];
		conv += panelSh[p_idx + 452] * templateSh[46];
		conv += panelSh[p_idx + 453] * templateSh[45];
		conv += panelSh[p_idx + 454] * templateSh[44];
		conv += panelSh[p_idx + 455] * templateSh[43];
		conv += panelSh[p_idx + 456] * templateSh[42];
		conv += panelSh[p_idx + 457] * templateSh[41];
		conv += panelSh[p_idx + 458] * templateSh[40];
		conv += panelSh[p_idx + 459] * templateSh[39];
		conv += panelSh[p_idx + 460] * templateSh[38];
		conv += panelSh[p_idx + 461] * templateSh[37];
		conv += panelSh[p_idx + 462] * templateSh[36];
		conv += panelSh[p_idx + 463] * templateSh[35];
		conv += panelSh[p_idx + 464] * templateSh[34];
		conv += panelSh[p_idx + 480] * templateSh[33];
		conv += panelSh[p_idx + 481] * templateSh[32];
		conv += panelSh[p_idx + 482] * templateSh[31];
		conv += panelSh[p_idx + 483] * templateSh[30];
		conv += panelSh[p_idx + 484] * templateSh[29];
		conv += panelSh[p_idx + 485] * templateSh[28];
		conv += panelSh[p_idx + 486] * templateSh[27];
		conv += panelSh[p_idx + 487] * templateSh[26];
		conv += panelSh[p_idx + 488] * templateSh[25];
		conv += panelSh[p_idx + 489] * templateSh[24];
		conv += panelSh[p_idx + 490] * templateSh[23];
		conv += panelSh[p_idx + 491] * templateSh[22];
		conv += panelSh[p_idx + 492] * templateSh[21];
		conv += panelSh[p_idx + 493] * templateSh[20];
		conv += panelSh[p_idx + 494] * templateSh[19];
		conv += panelSh[p_idx + 495] * templateSh[18];
		conv += panelSh[p_idx + 496] * templateSh[17];
		conv += panelSh[p_idx + 512] * templateSh[16];
		conv += panelSh[p_idx + 513] * templateSh[15];
		conv += panelSh[p_idx + 514] * templateSh[14];
		conv += panelSh[p_idx + 515] * templateSh[13];
		conv += panelSh[p_idx + 516] * templateSh[12];
		conv += panelSh[p_idx + 517] * templateSh[11];
		conv += panelSh[p_idx + 518] * templateSh[10];
		conv += panelSh[p_idx + 519] * templateSh[9];
		conv += panelSh[p_idx + 520] * templateSh[8];
		conv += panelSh[p_idx + 521] * templateSh[7];
		conv += panelSh[p_idx + 522] * templateSh[6];
		conv += panelSh[p_idx + 523] * templateSh[5];
		conv += panelSh[p_idx + 524] * templateSh[4];
		conv += panelSh[p_idx + 525] * templateSh[3];
		conv += panelSh[p_idx + 526] * templateSh[2];
		conv += panelSh[p_idx + 527] * templateSh[1];
		conv += panelSh[p_idx + 528] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_17x17<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_17x17<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_18x18 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1089];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<33; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<33; i+=16) {
			panelSh[IMUL(j, 33) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[324];
	for (int j=threadIdx.y; j<18; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<18; i+=16) {
			const int jtwi = IMUL(j, 18) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 33);
		conv += panelSh[p_idx + 0] * templateSh[323];
		conv += panelSh[p_idx + 1] * templateSh[322];
		conv += panelSh[p_idx + 2] * templateSh[321];
		conv += panelSh[p_idx + 3] * templateSh[320];
		conv += panelSh[p_idx + 4] * templateSh[319];
		conv += panelSh[p_idx + 5] * templateSh[318];
		conv += panelSh[p_idx + 6] * templateSh[317];
		conv += panelSh[p_idx + 7] * templateSh[316];
		conv += panelSh[p_idx + 8] * templateSh[315];
		conv += panelSh[p_idx + 9] * templateSh[314];
		conv += panelSh[p_idx + 10] * templateSh[313];
		conv += panelSh[p_idx + 11] * templateSh[312];
		conv += panelSh[p_idx + 12] * templateSh[311];
		conv += panelSh[p_idx + 13] * templateSh[310];
		conv += panelSh[p_idx + 14] * templateSh[309];
		conv += panelSh[p_idx + 15] * templateSh[308];
		conv += panelSh[p_idx + 16] * templateSh[307];
		conv += panelSh[p_idx + 17] * templateSh[306];
		conv += panelSh[p_idx + 33] * templateSh[305];
		conv += panelSh[p_idx + 34] * templateSh[304];
		conv += panelSh[p_idx + 35] * templateSh[303];
		conv += panelSh[p_idx + 36] * templateSh[302];
		conv += panelSh[p_idx + 37] * templateSh[301];
		conv += panelSh[p_idx + 38] * templateSh[300];
		conv += panelSh[p_idx + 39] * templateSh[299];
		conv += panelSh[p_idx + 40] * templateSh[298];
		conv += panelSh[p_idx + 41] * templateSh[297];
		conv += panelSh[p_idx + 42] * templateSh[296];
		conv += panelSh[p_idx + 43] * templateSh[295];
		conv += panelSh[p_idx + 44] * templateSh[294];
		conv += panelSh[p_idx + 45] * templateSh[293];
		conv += panelSh[p_idx + 46] * templateSh[292];
		conv += panelSh[p_idx + 47] * templateSh[291];
		conv += panelSh[p_idx + 48] * templateSh[290];
		conv += panelSh[p_idx + 49] * templateSh[289];
		conv += panelSh[p_idx + 50] * templateSh[288];
		conv += panelSh[p_idx + 66] * templateSh[287];
		conv += panelSh[p_idx + 67] * templateSh[286];
		conv += panelSh[p_idx + 68] * templateSh[285];
		conv += panelSh[p_idx + 69] * templateSh[284];
		conv += panelSh[p_idx + 70] * templateSh[283];
		conv += panelSh[p_idx + 71] * templateSh[282];
		conv += panelSh[p_idx + 72] * templateSh[281];
		conv += panelSh[p_idx + 73] * templateSh[280];
		conv += panelSh[p_idx + 74] * templateSh[279];
		conv += panelSh[p_idx + 75] * templateSh[278];
		conv += panelSh[p_idx + 76] * templateSh[277];
		conv += panelSh[p_idx + 77] * templateSh[276];
		conv += panelSh[p_idx + 78] * templateSh[275];
		conv += panelSh[p_idx + 79] * templateSh[274];
		conv += panelSh[p_idx + 80] * templateSh[273];
		conv += panelSh[p_idx + 81] * templateSh[272];
		conv += panelSh[p_idx + 82] * templateSh[271];
		conv += panelSh[p_idx + 83] * templateSh[270];
		conv += panelSh[p_idx + 99] * templateSh[269];
		conv += panelSh[p_idx + 100] * templateSh[268];
		conv += panelSh[p_idx + 101] * templateSh[267];
		conv += panelSh[p_idx + 102] * templateSh[266];
		conv += panelSh[p_idx + 103] * templateSh[265];
		conv += panelSh[p_idx + 104] * templateSh[264];
		conv += panelSh[p_idx + 105] * templateSh[263];
		conv += panelSh[p_idx + 106] * templateSh[262];
		conv += panelSh[p_idx + 107] * templateSh[261];
		conv += panelSh[p_idx + 108] * templateSh[260];
		conv += panelSh[p_idx + 109] * templateSh[259];
		conv += panelSh[p_idx + 110] * templateSh[258];
		conv += panelSh[p_idx + 111] * templateSh[257];
		conv += panelSh[p_idx + 112] * templateSh[256];
		conv += panelSh[p_idx + 113] * templateSh[255];
		conv += panelSh[p_idx + 114] * templateSh[254];
		conv += panelSh[p_idx + 115] * templateSh[253];
		conv += panelSh[p_idx + 116] * templateSh[252];
		conv += panelSh[p_idx + 132] * templateSh[251];
		conv += panelSh[p_idx + 133] * templateSh[250];
		conv += panelSh[p_idx + 134] * templateSh[249];
		conv += panelSh[p_idx + 135] * templateSh[248];
		conv += panelSh[p_idx + 136] * templateSh[247];
		conv += panelSh[p_idx + 137] * templateSh[246];
		conv += panelSh[p_idx + 138] * templateSh[245];
		conv += panelSh[p_idx + 139] * templateSh[244];
		conv += panelSh[p_idx + 140] * templateSh[243];
		conv += panelSh[p_idx + 141] * templateSh[242];
		conv += panelSh[p_idx + 142] * templateSh[241];
		conv += panelSh[p_idx + 143] * templateSh[240];
		conv += panelSh[p_idx + 144] * templateSh[239];
		conv += panelSh[p_idx + 145] * templateSh[238];
		conv += panelSh[p_idx + 146] * templateSh[237];
		conv += panelSh[p_idx + 147] * templateSh[236];
		conv += panelSh[p_idx + 148] * templateSh[235];
		conv += panelSh[p_idx + 149] * templateSh[234];
		conv += panelSh[p_idx + 165] * templateSh[233];
		conv += panelSh[p_idx + 166] * templateSh[232];
		conv += panelSh[p_idx + 167] * templateSh[231];
		conv += panelSh[p_idx + 168] * templateSh[230];
		conv += panelSh[p_idx + 169] * templateSh[229];
		conv += panelSh[p_idx + 170] * templateSh[228];
		conv += panelSh[p_idx + 171] * templateSh[227];
		conv += panelSh[p_idx + 172] * templateSh[226];
		conv += panelSh[p_idx + 173] * templateSh[225];
		conv += panelSh[p_idx + 174] * templateSh[224];
		conv += panelSh[p_idx + 175] * templateSh[223];
		conv += panelSh[p_idx + 176] * templateSh[222];
		conv += panelSh[p_idx + 177] * templateSh[221];
		conv += panelSh[p_idx + 178] * templateSh[220];
		conv += panelSh[p_idx + 179] * templateSh[219];
		conv += panelSh[p_idx + 180] * templateSh[218];
		conv += panelSh[p_idx + 181] * templateSh[217];
		conv += panelSh[p_idx + 182] * templateSh[216];
		conv += panelSh[p_idx + 198] * templateSh[215];
		conv += panelSh[p_idx + 199] * templateSh[214];
		conv += panelSh[p_idx + 200] * templateSh[213];
		conv += panelSh[p_idx + 201] * templateSh[212];
		conv += panelSh[p_idx + 202] * templateSh[211];
		conv += panelSh[p_idx + 203] * templateSh[210];
		conv += panelSh[p_idx + 204] * templateSh[209];
		conv += panelSh[p_idx + 205] * templateSh[208];
		conv += panelSh[p_idx + 206] * templateSh[207];
		conv += panelSh[p_idx + 207] * templateSh[206];
		conv += panelSh[p_idx + 208] * templateSh[205];
		conv += panelSh[p_idx + 209] * templateSh[204];
		conv += panelSh[p_idx + 210] * templateSh[203];
		conv += panelSh[p_idx + 211] * templateSh[202];
		conv += panelSh[p_idx + 212] * templateSh[201];
		conv += panelSh[p_idx + 213] * templateSh[200];
		conv += panelSh[p_idx + 214] * templateSh[199];
		conv += panelSh[p_idx + 215] * templateSh[198];
		conv += panelSh[p_idx + 231] * templateSh[197];
		conv += panelSh[p_idx + 232] * templateSh[196];
		conv += panelSh[p_idx + 233] * templateSh[195];
		conv += panelSh[p_idx + 234] * templateSh[194];
		conv += panelSh[p_idx + 235] * templateSh[193];
		conv += panelSh[p_idx + 236] * templateSh[192];
		conv += panelSh[p_idx + 237] * templateSh[191];
		conv += panelSh[p_idx + 238] * templateSh[190];
		conv += panelSh[p_idx + 239] * templateSh[189];
		conv += panelSh[p_idx + 240] * templateSh[188];
		conv += panelSh[p_idx + 241] * templateSh[187];
		conv += panelSh[p_idx + 242] * templateSh[186];
		conv += panelSh[p_idx + 243] * templateSh[185];
		conv += panelSh[p_idx + 244] * templateSh[184];
		conv += panelSh[p_idx + 245] * templateSh[183];
		conv += panelSh[p_idx + 246] * templateSh[182];
		conv += panelSh[p_idx + 247] * templateSh[181];
		conv += panelSh[p_idx + 248] * templateSh[180];
		conv += panelSh[p_idx + 264] * templateSh[179];
		conv += panelSh[p_idx + 265] * templateSh[178];
		conv += panelSh[p_idx + 266] * templateSh[177];
		conv += panelSh[p_idx + 267] * templateSh[176];
		conv += panelSh[p_idx + 268] * templateSh[175];
		conv += panelSh[p_idx + 269] * templateSh[174];
		conv += panelSh[p_idx + 270] * templateSh[173];
		conv += panelSh[p_idx + 271] * templateSh[172];
		conv += panelSh[p_idx + 272] * templateSh[171];
		conv += panelSh[p_idx + 273] * templateSh[170];
		conv += panelSh[p_idx + 274] * templateSh[169];
		conv += panelSh[p_idx + 275] * templateSh[168];
		conv += panelSh[p_idx + 276] * templateSh[167];
		conv += panelSh[p_idx + 277] * templateSh[166];
		conv += panelSh[p_idx + 278] * templateSh[165];
		conv += panelSh[p_idx + 279] * templateSh[164];
		conv += panelSh[p_idx + 280] * templateSh[163];
		conv += panelSh[p_idx + 281] * templateSh[162];
		conv += panelSh[p_idx + 297] * templateSh[161];
		conv += panelSh[p_idx + 298] * templateSh[160];
		conv += panelSh[p_idx + 299] * templateSh[159];
		conv += panelSh[p_idx + 300] * templateSh[158];
		conv += panelSh[p_idx + 301] * templateSh[157];
		conv += panelSh[p_idx + 302] * templateSh[156];
		conv += panelSh[p_idx + 303] * templateSh[155];
		conv += panelSh[p_idx + 304] * templateSh[154];
		conv += panelSh[p_idx + 305] * templateSh[153];
		conv += panelSh[p_idx + 306] * templateSh[152];
		conv += panelSh[p_idx + 307] * templateSh[151];
		conv += panelSh[p_idx + 308] * templateSh[150];
		conv += panelSh[p_idx + 309] * templateSh[149];
		conv += panelSh[p_idx + 310] * templateSh[148];
		conv += panelSh[p_idx + 311] * templateSh[147];
		conv += panelSh[p_idx + 312] * templateSh[146];
		conv += panelSh[p_idx + 313] * templateSh[145];
		conv += panelSh[p_idx + 314] * templateSh[144];
		conv += panelSh[p_idx + 330] * templateSh[143];
		conv += panelSh[p_idx + 331] * templateSh[142];
		conv += panelSh[p_idx + 332] * templateSh[141];
		conv += panelSh[p_idx + 333] * templateSh[140];
		conv += panelSh[p_idx + 334] * templateSh[139];
		conv += panelSh[p_idx + 335] * templateSh[138];
		conv += panelSh[p_idx + 336] * templateSh[137];
		conv += panelSh[p_idx + 337] * templateSh[136];
		conv += panelSh[p_idx + 338] * templateSh[135];
		conv += panelSh[p_idx + 339] * templateSh[134];
		conv += panelSh[p_idx + 340] * templateSh[133];
		conv += panelSh[p_idx + 341] * templateSh[132];
		conv += panelSh[p_idx + 342] * templateSh[131];
		conv += panelSh[p_idx + 343] * templateSh[130];
		conv += panelSh[p_idx + 344] * templateSh[129];
		conv += panelSh[p_idx + 345] * templateSh[128];
		conv += panelSh[p_idx + 346] * templateSh[127];
		conv += panelSh[p_idx + 347] * templateSh[126];
		conv += panelSh[p_idx + 363] * templateSh[125];
		conv += panelSh[p_idx + 364] * templateSh[124];
		conv += panelSh[p_idx + 365] * templateSh[123];
		conv += panelSh[p_idx + 366] * templateSh[122];
		conv += panelSh[p_idx + 367] * templateSh[121];
		conv += panelSh[p_idx + 368] * templateSh[120];
		conv += panelSh[p_idx + 369] * templateSh[119];
		conv += panelSh[p_idx + 370] * templateSh[118];
		conv += panelSh[p_idx + 371] * templateSh[117];
		conv += panelSh[p_idx + 372] * templateSh[116];
		conv += panelSh[p_idx + 373] * templateSh[115];
		conv += panelSh[p_idx + 374] * templateSh[114];
		conv += panelSh[p_idx + 375] * templateSh[113];
		conv += panelSh[p_idx + 376] * templateSh[112];
		conv += panelSh[p_idx + 377] * templateSh[111];
		conv += panelSh[p_idx + 378] * templateSh[110];
		conv += panelSh[p_idx + 379] * templateSh[109];
		conv += panelSh[p_idx + 380] * templateSh[108];
		conv += panelSh[p_idx + 396] * templateSh[107];
		conv += panelSh[p_idx + 397] * templateSh[106];
		conv += panelSh[p_idx + 398] * templateSh[105];
		conv += panelSh[p_idx + 399] * templateSh[104];
		conv += panelSh[p_idx + 400] * templateSh[103];
		conv += panelSh[p_idx + 401] * templateSh[102];
		conv += panelSh[p_idx + 402] * templateSh[101];
		conv += panelSh[p_idx + 403] * templateSh[100];
		conv += panelSh[p_idx + 404] * templateSh[99];
		conv += panelSh[p_idx + 405] * templateSh[98];
		conv += panelSh[p_idx + 406] * templateSh[97];
		conv += panelSh[p_idx + 407] * templateSh[96];
		conv += panelSh[p_idx + 408] * templateSh[95];
		conv += panelSh[p_idx + 409] * templateSh[94];
		conv += panelSh[p_idx + 410] * templateSh[93];
		conv += panelSh[p_idx + 411] * templateSh[92];
		conv += panelSh[p_idx + 412] * templateSh[91];
		conv += panelSh[p_idx + 413] * templateSh[90];
		conv += panelSh[p_idx + 429] * templateSh[89];
		conv += panelSh[p_idx + 430] * templateSh[88];
		conv += panelSh[p_idx + 431] * templateSh[87];
		conv += panelSh[p_idx + 432] * templateSh[86];
		conv += panelSh[p_idx + 433] * templateSh[85];
		conv += panelSh[p_idx + 434] * templateSh[84];
		conv += panelSh[p_idx + 435] * templateSh[83];
		conv += panelSh[p_idx + 436] * templateSh[82];
		conv += panelSh[p_idx + 437] * templateSh[81];
		conv += panelSh[p_idx + 438] * templateSh[80];
		conv += panelSh[p_idx + 439] * templateSh[79];
		conv += panelSh[p_idx + 440] * templateSh[78];
		conv += panelSh[p_idx + 441] * templateSh[77];
		conv += panelSh[p_idx + 442] * templateSh[76];
		conv += panelSh[p_idx + 443] * templateSh[75];
		conv += panelSh[p_idx + 444] * templateSh[74];
		conv += panelSh[p_idx + 445] * templateSh[73];
		conv += panelSh[p_idx + 446] * templateSh[72];
		conv += panelSh[p_idx + 462] * templateSh[71];
		conv += panelSh[p_idx + 463] * templateSh[70];
		conv += panelSh[p_idx + 464] * templateSh[69];
		conv += panelSh[p_idx + 465] * templateSh[68];
		conv += panelSh[p_idx + 466] * templateSh[67];
		conv += panelSh[p_idx + 467] * templateSh[66];
		conv += panelSh[p_idx + 468] * templateSh[65];
		conv += panelSh[p_idx + 469] * templateSh[64];
		conv += panelSh[p_idx + 470] * templateSh[63];
		conv += panelSh[p_idx + 471] * templateSh[62];
		conv += panelSh[p_idx + 472] * templateSh[61];
		conv += panelSh[p_idx + 473] * templateSh[60];
		conv += panelSh[p_idx + 474] * templateSh[59];
		conv += panelSh[p_idx + 475] * templateSh[58];
		conv += panelSh[p_idx + 476] * templateSh[57];
		conv += panelSh[p_idx + 477] * templateSh[56];
		conv += panelSh[p_idx + 478] * templateSh[55];
		conv += panelSh[p_idx + 479] * templateSh[54];
		conv += panelSh[p_idx + 495] * templateSh[53];
		conv += panelSh[p_idx + 496] * templateSh[52];
		conv += panelSh[p_idx + 497] * templateSh[51];
		conv += panelSh[p_idx + 498] * templateSh[50];
		conv += panelSh[p_idx + 499] * templateSh[49];
		conv += panelSh[p_idx + 500] * templateSh[48];
		conv += panelSh[p_idx + 501] * templateSh[47];
		conv += panelSh[p_idx + 502] * templateSh[46];
		conv += panelSh[p_idx + 503] * templateSh[45];
		conv += panelSh[p_idx + 504] * templateSh[44];
		conv += panelSh[p_idx + 505] * templateSh[43];
		conv += panelSh[p_idx + 506] * templateSh[42];
		conv += panelSh[p_idx + 507] * templateSh[41];
		conv += panelSh[p_idx + 508] * templateSh[40];
		conv += panelSh[p_idx + 509] * templateSh[39];
		conv += panelSh[p_idx + 510] * templateSh[38];
		conv += panelSh[p_idx + 511] * templateSh[37];
		conv += panelSh[p_idx + 512] * templateSh[36];
		conv += panelSh[p_idx + 528] * templateSh[35];
		conv += panelSh[p_idx + 529] * templateSh[34];
		conv += panelSh[p_idx + 530] * templateSh[33];
		conv += panelSh[p_idx + 531] * templateSh[32];
		conv += panelSh[p_idx + 532] * templateSh[31];
		conv += panelSh[p_idx + 533] * templateSh[30];
		conv += panelSh[p_idx + 534] * templateSh[29];
		conv += panelSh[p_idx + 535] * templateSh[28];
		conv += panelSh[p_idx + 536] * templateSh[27];
		conv += panelSh[p_idx + 537] * templateSh[26];
		conv += panelSh[p_idx + 538] * templateSh[25];
		conv += panelSh[p_idx + 539] * templateSh[24];
		conv += panelSh[p_idx + 540] * templateSh[23];
		conv += panelSh[p_idx + 541] * templateSh[22];
		conv += panelSh[p_idx + 542] * templateSh[21];
		conv += panelSh[p_idx + 543] * templateSh[20];
		conv += panelSh[p_idx + 544] * templateSh[19];
		conv += panelSh[p_idx + 545] * templateSh[18];
		conv += panelSh[p_idx + 561] * templateSh[17];
		conv += panelSh[p_idx + 562] * templateSh[16];
		conv += panelSh[p_idx + 563] * templateSh[15];
		conv += panelSh[p_idx + 564] * templateSh[14];
		conv += panelSh[p_idx + 565] * templateSh[13];
		conv += panelSh[p_idx + 566] * templateSh[12];
		conv += panelSh[p_idx + 567] * templateSh[11];
		conv += panelSh[p_idx + 568] * templateSh[10];
		conv += panelSh[p_idx + 569] * templateSh[9];
		conv += panelSh[p_idx + 570] * templateSh[8];
		conv += panelSh[p_idx + 571] * templateSh[7];
		conv += panelSh[p_idx + 572] * templateSh[6];
		conv += panelSh[p_idx + 573] * templateSh[5];
		conv += panelSh[p_idx + 574] * templateSh[4];
		conv += panelSh[p_idx + 575] * templateSh[3];
		conv += panelSh[p_idx + 576] * templateSh[2];
		conv += panelSh[p_idx + 577] * templateSh[1];
		conv += panelSh[p_idx + 578] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_18x18<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_18x18<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_19x19 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1156];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<34; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<34; i+=16) {
			panelSh[IMUL(j, 34) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[361];
	for (int j=threadIdx.y; j<19; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<19; i+=16) {
			const int jtwi = IMUL(j, 19) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 34);
		conv += panelSh[p_idx + 0] * templateSh[360];
		conv += panelSh[p_idx + 1] * templateSh[359];
		conv += panelSh[p_idx + 2] * templateSh[358];
		conv += panelSh[p_idx + 3] * templateSh[357];
		conv += panelSh[p_idx + 4] * templateSh[356];
		conv += panelSh[p_idx + 5] * templateSh[355];
		conv += panelSh[p_idx + 6] * templateSh[354];
		conv += panelSh[p_idx + 7] * templateSh[353];
		conv += panelSh[p_idx + 8] * templateSh[352];
		conv += panelSh[p_idx + 9] * templateSh[351];
		conv += panelSh[p_idx + 10] * templateSh[350];
		conv += panelSh[p_idx + 11] * templateSh[349];
		conv += panelSh[p_idx + 12] * templateSh[348];
		conv += panelSh[p_idx + 13] * templateSh[347];
		conv += panelSh[p_idx + 14] * templateSh[346];
		conv += panelSh[p_idx + 15] * templateSh[345];
		conv += panelSh[p_idx + 16] * templateSh[344];
		conv += panelSh[p_idx + 17] * templateSh[343];
		conv += panelSh[p_idx + 18] * templateSh[342];
		conv += panelSh[p_idx + 34] * templateSh[341];
		conv += panelSh[p_idx + 35] * templateSh[340];
		conv += panelSh[p_idx + 36] * templateSh[339];
		conv += panelSh[p_idx + 37] * templateSh[338];
		conv += panelSh[p_idx + 38] * templateSh[337];
		conv += panelSh[p_idx + 39] * templateSh[336];
		conv += panelSh[p_idx + 40] * templateSh[335];
		conv += panelSh[p_idx + 41] * templateSh[334];
		conv += panelSh[p_idx + 42] * templateSh[333];
		conv += panelSh[p_idx + 43] * templateSh[332];
		conv += panelSh[p_idx + 44] * templateSh[331];
		conv += panelSh[p_idx + 45] * templateSh[330];
		conv += panelSh[p_idx + 46] * templateSh[329];
		conv += panelSh[p_idx + 47] * templateSh[328];
		conv += panelSh[p_idx + 48] * templateSh[327];
		conv += panelSh[p_idx + 49] * templateSh[326];
		conv += panelSh[p_idx + 50] * templateSh[325];
		conv += panelSh[p_idx + 51] * templateSh[324];
		conv += panelSh[p_idx + 52] * templateSh[323];
		conv += panelSh[p_idx + 68] * templateSh[322];
		conv += panelSh[p_idx + 69] * templateSh[321];
		conv += panelSh[p_idx + 70] * templateSh[320];
		conv += panelSh[p_idx + 71] * templateSh[319];
		conv += panelSh[p_idx + 72] * templateSh[318];
		conv += panelSh[p_idx + 73] * templateSh[317];
		conv += panelSh[p_idx + 74] * templateSh[316];
		conv += panelSh[p_idx + 75] * templateSh[315];
		conv += panelSh[p_idx + 76] * templateSh[314];
		conv += panelSh[p_idx + 77] * templateSh[313];
		conv += panelSh[p_idx + 78] * templateSh[312];
		conv += panelSh[p_idx + 79] * templateSh[311];
		conv += panelSh[p_idx + 80] * templateSh[310];
		conv += panelSh[p_idx + 81] * templateSh[309];
		conv += panelSh[p_idx + 82] * templateSh[308];
		conv += panelSh[p_idx + 83] * templateSh[307];
		conv += panelSh[p_idx + 84] * templateSh[306];
		conv += panelSh[p_idx + 85] * templateSh[305];
		conv += panelSh[p_idx + 86] * templateSh[304];
		conv += panelSh[p_idx + 102] * templateSh[303];
		conv += panelSh[p_idx + 103] * templateSh[302];
		conv += panelSh[p_idx + 104] * templateSh[301];
		conv += panelSh[p_idx + 105] * templateSh[300];
		conv += panelSh[p_idx + 106] * templateSh[299];
		conv += panelSh[p_idx + 107] * templateSh[298];
		conv += panelSh[p_idx + 108] * templateSh[297];
		conv += panelSh[p_idx + 109] * templateSh[296];
		conv += panelSh[p_idx + 110] * templateSh[295];
		conv += panelSh[p_idx + 111] * templateSh[294];
		conv += panelSh[p_idx + 112] * templateSh[293];
		conv += panelSh[p_idx + 113] * templateSh[292];
		conv += panelSh[p_idx + 114] * templateSh[291];
		conv += panelSh[p_idx + 115] * templateSh[290];
		conv += panelSh[p_idx + 116] * templateSh[289];
		conv += panelSh[p_idx + 117] * templateSh[288];
		conv += panelSh[p_idx + 118] * templateSh[287];
		conv += panelSh[p_idx + 119] * templateSh[286];
		conv += panelSh[p_idx + 120] * templateSh[285];
		conv += panelSh[p_idx + 136] * templateSh[284];
		conv += panelSh[p_idx + 137] * templateSh[283];
		conv += panelSh[p_idx + 138] * templateSh[282];
		conv += panelSh[p_idx + 139] * templateSh[281];
		conv += panelSh[p_idx + 140] * templateSh[280];
		conv += panelSh[p_idx + 141] * templateSh[279];
		conv += panelSh[p_idx + 142] * templateSh[278];
		conv += panelSh[p_idx + 143] * templateSh[277];
		conv += panelSh[p_idx + 144] * templateSh[276];
		conv += panelSh[p_idx + 145] * templateSh[275];
		conv += panelSh[p_idx + 146] * templateSh[274];
		conv += panelSh[p_idx + 147] * templateSh[273];
		conv += panelSh[p_idx + 148] * templateSh[272];
		conv += panelSh[p_idx + 149] * templateSh[271];
		conv += panelSh[p_idx + 150] * templateSh[270];
		conv += panelSh[p_idx + 151] * templateSh[269];
		conv += panelSh[p_idx + 152] * templateSh[268];
		conv += panelSh[p_idx + 153] * templateSh[267];
		conv += panelSh[p_idx + 154] * templateSh[266];
		conv += panelSh[p_idx + 170] * templateSh[265];
		conv += panelSh[p_idx + 171] * templateSh[264];
		conv += panelSh[p_idx + 172] * templateSh[263];
		conv += panelSh[p_idx + 173] * templateSh[262];
		conv += panelSh[p_idx + 174] * templateSh[261];
		conv += panelSh[p_idx + 175] * templateSh[260];
		conv += panelSh[p_idx + 176] * templateSh[259];
		conv += panelSh[p_idx + 177] * templateSh[258];
		conv += panelSh[p_idx + 178] * templateSh[257];
		conv += panelSh[p_idx + 179] * templateSh[256];
		conv += panelSh[p_idx + 180] * templateSh[255];
		conv += panelSh[p_idx + 181] * templateSh[254];
		conv += panelSh[p_idx + 182] * templateSh[253];
		conv += panelSh[p_idx + 183] * templateSh[252];
		conv += panelSh[p_idx + 184] * templateSh[251];
		conv += panelSh[p_idx + 185] * templateSh[250];
		conv += panelSh[p_idx + 186] * templateSh[249];
		conv += panelSh[p_idx + 187] * templateSh[248];
		conv += panelSh[p_idx + 188] * templateSh[247];
		conv += panelSh[p_idx + 204] * templateSh[246];
		conv += panelSh[p_idx + 205] * templateSh[245];
		conv += panelSh[p_idx + 206] * templateSh[244];
		conv += panelSh[p_idx + 207] * templateSh[243];
		conv += panelSh[p_idx + 208] * templateSh[242];
		conv += panelSh[p_idx + 209] * templateSh[241];
		conv += panelSh[p_idx + 210] * templateSh[240];
		conv += panelSh[p_idx + 211] * templateSh[239];
		conv += panelSh[p_idx + 212] * templateSh[238];
		conv += panelSh[p_idx + 213] * templateSh[237];
		conv += panelSh[p_idx + 214] * templateSh[236];
		conv += panelSh[p_idx + 215] * templateSh[235];
		conv += panelSh[p_idx + 216] * templateSh[234];
		conv += panelSh[p_idx + 217] * templateSh[233];
		conv += panelSh[p_idx + 218] * templateSh[232];
		conv += panelSh[p_idx + 219] * templateSh[231];
		conv += panelSh[p_idx + 220] * templateSh[230];
		conv += panelSh[p_idx + 221] * templateSh[229];
		conv += panelSh[p_idx + 222] * templateSh[228];
		conv += panelSh[p_idx + 238] * templateSh[227];
		conv += panelSh[p_idx + 239] * templateSh[226];
		conv += panelSh[p_idx + 240] * templateSh[225];
		conv += panelSh[p_idx + 241] * templateSh[224];
		conv += panelSh[p_idx + 242] * templateSh[223];
		conv += panelSh[p_idx + 243] * templateSh[222];
		conv += panelSh[p_idx + 244] * templateSh[221];
		conv += panelSh[p_idx + 245] * templateSh[220];
		conv += panelSh[p_idx + 246] * templateSh[219];
		conv += panelSh[p_idx + 247] * templateSh[218];
		conv += panelSh[p_idx + 248] * templateSh[217];
		conv += panelSh[p_idx + 249] * templateSh[216];
		conv += panelSh[p_idx + 250] * templateSh[215];
		conv += panelSh[p_idx + 251] * templateSh[214];
		conv += panelSh[p_idx + 252] * templateSh[213];
		conv += panelSh[p_idx + 253] * templateSh[212];
		conv += panelSh[p_idx + 254] * templateSh[211];
		conv += panelSh[p_idx + 255] * templateSh[210];
		conv += panelSh[p_idx + 256] * templateSh[209];
		conv += panelSh[p_idx + 272] * templateSh[208];
		conv += panelSh[p_idx + 273] * templateSh[207];
		conv += panelSh[p_idx + 274] * templateSh[206];
		conv += panelSh[p_idx + 275] * templateSh[205];
		conv += panelSh[p_idx + 276] * templateSh[204];
		conv += panelSh[p_idx + 277] * templateSh[203];
		conv += panelSh[p_idx + 278] * templateSh[202];
		conv += panelSh[p_idx + 279] * templateSh[201];
		conv += panelSh[p_idx + 280] * templateSh[200];
		conv += panelSh[p_idx + 281] * templateSh[199];
		conv += panelSh[p_idx + 282] * templateSh[198];
		conv += panelSh[p_idx + 283] * templateSh[197];
		conv += panelSh[p_idx + 284] * templateSh[196];
		conv += panelSh[p_idx + 285] * templateSh[195];
		conv += panelSh[p_idx + 286] * templateSh[194];
		conv += panelSh[p_idx + 287] * templateSh[193];
		conv += panelSh[p_idx + 288] * templateSh[192];
		conv += panelSh[p_idx + 289] * templateSh[191];
		conv += panelSh[p_idx + 290] * templateSh[190];
		conv += panelSh[p_idx + 306] * templateSh[189];
		conv += panelSh[p_idx + 307] * templateSh[188];
		conv += panelSh[p_idx + 308] * templateSh[187];
		conv += panelSh[p_idx + 309] * templateSh[186];
		conv += panelSh[p_idx + 310] * templateSh[185];
		conv += panelSh[p_idx + 311] * templateSh[184];
		conv += panelSh[p_idx + 312] * templateSh[183];
		conv += panelSh[p_idx + 313] * templateSh[182];
		conv += panelSh[p_idx + 314] * templateSh[181];
		conv += panelSh[p_idx + 315] * templateSh[180];
		conv += panelSh[p_idx + 316] * templateSh[179];
		conv += panelSh[p_idx + 317] * templateSh[178];
		conv += panelSh[p_idx + 318] * templateSh[177];
		conv += panelSh[p_idx + 319] * templateSh[176];
		conv += panelSh[p_idx + 320] * templateSh[175];
		conv += panelSh[p_idx + 321] * templateSh[174];
		conv += panelSh[p_idx + 322] * templateSh[173];
		conv += panelSh[p_idx + 323] * templateSh[172];
		conv += panelSh[p_idx + 324] * templateSh[171];
		conv += panelSh[p_idx + 340] * templateSh[170];
		conv += panelSh[p_idx + 341] * templateSh[169];
		conv += panelSh[p_idx + 342] * templateSh[168];
		conv += panelSh[p_idx + 343] * templateSh[167];
		conv += panelSh[p_idx + 344] * templateSh[166];
		conv += panelSh[p_idx + 345] * templateSh[165];
		conv += panelSh[p_idx + 346] * templateSh[164];
		conv += panelSh[p_idx + 347] * templateSh[163];
		conv += panelSh[p_idx + 348] * templateSh[162];
		conv += panelSh[p_idx + 349] * templateSh[161];
		conv += panelSh[p_idx + 350] * templateSh[160];
		conv += panelSh[p_idx + 351] * templateSh[159];
		conv += panelSh[p_idx + 352] * templateSh[158];
		conv += panelSh[p_idx + 353] * templateSh[157];
		conv += panelSh[p_idx + 354] * templateSh[156];
		conv += panelSh[p_idx + 355] * templateSh[155];
		conv += panelSh[p_idx + 356] * templateSh[154];
		conv += panelSh[p_idx + 357] * templateSh[153];
		conv += panelSh[p_idx + 358] * templateSh[152];
		conv += panelSh[p_idx + 374] * templateSh[151];
		conv += panelSh[p_idx + 375] * templateSh[150];
		conv += panelSh[p_idx + 376] * templateSh[149];
		conv += panelSh[p_idx + 377] * templateSh[148];
		conv += panelSh[p_idx + 378] * templateSh[147];
		conv += panelSh[p_idx + 379] * templateSh[146];
		conv += panelSh[p_idx + 380] * templateSh[145];
		conv += panelSh[p_idx + 381] * templateSh[144];
		conv += panelSh[p_idx + 382] * templateSh[143];
		conv += panelSh[p_idx + 383] * templateSh[142];
		conv += panelSh[p_idx + 384] * templateSh[141];
		conv += panelSh[p_idx + 385] * templateSh[140];
		conv += panelSh[p_idx + 386] * templateSh[139];
		conv += panelSh[p_idx + 387] * templateSh[138];
		conv += panelSh[p_idx + 388] * templateSh[137];
		conv += panelSh[p_idx + 389] * templateSh[136];
		conv += panelSh[p_idx + 390] * templateSh[135];
		conv += panelSh[p_idx + 391] * templateSh[134];
		conv += panelSh[p_idx + 392] * templateSh[133];
		conv += panelSh[p_idx + 408] * templateSh[132];
		conv += panelSh[p_idx + 409] * templateSh[131];
		conv += panelSh[p_idx + 410] * templateSh[130];
		conv += panelSh[p_idx + 411] * templateSh[129];
		conv += panelSh[p_idx + 412] * templateSh[128];
		conv += panelSh[p_idx + 413] * templateSh[127];
		conv += panelSh[p_idx + 414] * templateSh[126];
		conv += panelSh[p_idx + 415] * templateSh[125];
		conv += panelSh[p_idx + 416] * templateSh[124];
		conv += panelSh[p_idx + 417] * templateSh[123];
		conv += panelSh[p_idx + 418] * templateSh[122];
		conv += panelSh[p_idx + 419] * templateSh[121];
		conv += panelSh[p_idx + 420] * templateSh[120];
		conv += panelSh[p_idx + 421] * templateSh[119];
		conv += panelSh[p_idx + 422] * templateSh[118];
		conv += panelSh[p_idx + 423] * templateSh[117];
		conv += panelSh[p_idx + 424] * templateSh[116];
		conv += panelSh[p_idx + 425] * templateSh[115];
		conv += panelSh[p_idx + 426] * templateSh[114];
		conv += panelSh[p_idx + 442] * templateSh[113];
		conv += panelSh[p_idx + 443] * templateSh[112];
		conv += panelSh[p_idx + 444] * templateSh[111];
		conv += panelSh[p_idx + 445] * templateSh[110];
		conv += panelSh[p_idx + 446] * templateSh[109];
		conv += panelSh[p_idx + 447] * templateSh[108];
		conv += panelSh[p_idx + 448] * templateSh[107];
		conv += panelSh[p_idx + 449] * templateSh[106];
		conv += panelSh[p_idx + 450] * templateSh[105];
		conv += panelSh[p_idx + 451] * templateSh[104];
		conv += panelSh[p_idx + 452] * templateSh[103];
		conv += panelSh[p_idx + 453] * templateSh[102];
		conv += panelSh[p_idx + 454] * templateSh[101];
		conv += panelSh[p_idx + 455] * templateSh[100];
		conv += panelSh[p_idx + 456] * templateSh[99];
		conv += panelSh[p_idx + 457] * templateSh[98];
		conv += panelSh[p_idx + 458] * templateSh[97];
		conv += panelSh[p_idx + 459] * templateSh[96];
		conv += panelSh[p_idx + 460] * templateSh[95];
		conv += panelSh[p_idx + 476] * templateSh[94];
		conv += panelSh[p_idx + 477] * templateSh[93];
		conv += panelSh[p_idx + 478] * templateSh[92];
		conv += panelSh[p_idx + 479] * templateSh[91];
		conv += panelSh[p_idx + 480] * templateSh[90];
		conv += panelSh[p_idx + 481] * templateSh[89];
		conv += panelSh[p_idx + 482] * templateSh[88];
		conv += panelSh[p_idx + 483] * templateSh[87];
		conv += panelSh[p_idx + 484] * templateSh[86];
		conv += panelSh[p_idx + 485] * templateSh[85];
		conv += panelSh[p_idx + 486] * templateSh[84];
		conv += panelSh[p_idx + 487] * templateSh[83];
		conv += panelSh[p_idx + 488] * templateSh[82];
		conv += panelSh[p_idx + 489] * templateSh[81];
		conv += panelSh[p_idx + 490] * templateSh[80];
		conv += panelSh[p_idx + 491] * templateSh[79];
		conv += panelSh[p_idx + 492] * templateSh[78];
		conv += panelSh[p_idx + 493] * templateSh[77];
		conv += panelSh[p_idx + 494] * templateSh[76];
		conv += panelSh[p_idx + 510] * templateSh[75];
		conv += panelSh[p_idx + 511] * templateSh[74];
		conv += panelSh[p_idx + 512] * templateSh[73];
		conv += panelSh[p_idx + 513] * templateSh[72];
		conv += panelSh[p_idx + 514] * templateSh[71];
		conv += panelSh[p_idx + 515] * templateSh[70];
		conv += panelSh[p_idx + 516] * templateSh[69];
		conv += panelSh[p_idx + 517] * templateSh[68];
		conv += panelSh[p_idx + 518] * templateSh[67];
		conv += panelSh[p_idx + 519] * templateSh[66];
		conv += panelSh[p_idx + 520] * templateSh[65];
		conv += panelSh[p_idx + 521] * templateSh[64];
		conv += panelSh[p_idx + 522] * templateSh[63];
		conv += panelSh[p_idx + 523] * templateSh[62];
		conv += panelSh[p_idx + 524] * templateSh[61];
		conv += panelSh[p_idx + 525] * templateSh[60];
		conv += panelSh[p_idx + 526] * templateSh[59];
		conv += panelSh[p_idx + 527] * templateSh[58];
		conv += panelSh[p_idx + 528] * templateSh[57];
		conv += panelSh[p_idx + 544] * templateSh[56];
		conv += panelSh[p_idx + 545] * templateSh[55];
		conv += panelSh[p_idx + 546] * templateSh[54];
		conv += panelSh[p_idx + 547] * templateSh[53];
		conv += panelSh[p_idx + 548] * templateSh[52];
		conv += panelSh[p_idx + 549] * templateSh[51];
		conv += panelSh[p_idx + 550] * templateSh[50];
		conv += panelSh[p_idx + 551] * templateSh[49];
		conv += panelSh[p_idx + 552] * templateSh[48];
		conv += panelSh[p_idx + 553] * templateSh[47];
		conv += panelSh[p_idx + 554] * templateSh[46];
		conv += panelSh[p_idx + 555] * templateSh[45];
		conv += panelSh[p_idx + 556] * templateSh[44];
		conv += panelSh[p_idx + 557] * templateSh[43];
		conv += panelSh[p_idx + 558] * templateSh[42];
		conv += panelSh[p_idx + 559] * templateSh[41];
		conv += panelSh[p_idx + 560] * templateSh[40];
		conv += panelSh[p_idx + 561] * templateSh[39];
		conv += panelSh[p_idx + 562] * templateSh[38];
		conv += panelSh[p_idx + 578] * templateSh[37];
		conv += panelSh[p_idx + 579] * templateSh[36];
		conv += panelSh[p_idx + 580] * templateSh[35];
		conv += panelSh[p_idx + 581] * templateSh[34];
		conv += panelSh[p_idx + 582] * templateSh[33];
		conv += panelSh[p_idx + 583] * templateSh[32];
		conv += panelSh[p_idx + 584] * templateSh[31];
		conv += panelSh[p_idx + 585] * templateSh[30];
		conv += panelSh[p_idx + 586] * templateSh[29];
		conv += panelSh[p_idx + 587] * templateSh[28];
		conv += panelSh[p_idx + 588] * templateSh[27];
		conv += panelSh[p_idx + 589] * templateSh[26];
		conv += panelSh[p_idx + 590] * templateSh[25];
		conv += panelSh[p_idx + 591] * templateSh[24];
		conv += panelSh[p_idx + 592] * templateSh[23];
		conv += panelSh[p_idx + 593] * templateSh[22];
		conv += panelSh[p_idx + 594] * templateSh[21];
		conv += panelSh[p_idx + 595] * templateSh[20];
		conv += panelSh[p_idx + 596] * templateSh[19];
		conv += panelSh[p_idx + 612] * templateSh[18];
		conv += panelSh[p_idx + 613] * templateSh[17];
		conv += panelSh[p_idx + 614] * templateSh[16];
		conv += panelSh[p_idx + 615] * templateSh[15];
		conv += panelSh[p_idx + 616] * templateSh[14];
		conv += panelSh[p_idx + 617] * templateSh[13];
		conv += panelSh[p_idx + 618] * templateSh[12];
		conv += panelSh[p_idx + 619] * templateSh[11];
		conv += panelSh[p_idx + 620] * templateSh[10];
		conv += panelSh[p_idx + 621] * templateSh[9];
		conv += panelSh[p_idx + 622] * templateSh[8];
		conv += panelSh[p_idx + 623] * templateSh[7];
		conv += panelSh[p_idx + 624] * templateSh[6];
		conv += panelSh[p_idx + 625] * templateSh[5];
		conv += panelSh[p_idx + 626] * templateSh[4];
		conv += panelSh[p_idx + 627] * templateSh[3];
		conv += panelSh[p_idx + 628] * templateSh[2];
		conv += panelSh[p_idx + 629] * templateSh[1];
		conv += panelSh[p_idx + 630] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_19x19<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_19x19<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_20x20 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1225];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<35; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<35; i+=16) {
			panelSh[IMUL(j, 35) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[400];
	for (int j=threadIdx.y; j<20; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<20; i+=16) {
			const int jtwi = IMUL(j, 20) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 35);
		conv += panelSh[p_idx + 0] * templateSh[399];
		conv += panelSh[p_idx + 1] * templateSh[398];
		conv += panelSh[p_idx + 2] * templateSh[397];
		conv += panelSh[p_idx + 3] * templateSh[396];
		conv += panelSh[p_idx + 4] * templateSh[395];
		conv += panelSh[p_idx + 5] * templateSh[394];
		conv += panelSh[p_idx + 6] * templateSh[393];
		conv += panelSh[p_idx + 7] * templateSh[392];
		conv += panelSh[p_idx + 8] * templateSh[391];
		conv += panelSh[p_idx + 9] * templateSh[390];
		conv += panelSh[p_idx + 10] * templateSh[389];
		conv += panelSh[p_idx + 11] * templateSh[388];
		conv += panelSh[p_idx + 12] * templateSh[387];
		conv += panelSh[p_idx + 13] * templateSh[386];
		conv += panelSh[p_idx + 14] * templateSh[385];
		conv += panelSh[p_idx + 15] * templateSh[384];
		conv += panelSh[p_idx + 16] * templateSh[383];
		conv += panelSh[p_idx + 17] * templateSh[382];
		conv += panelSh[p_idx + 18] * templateSh[381];
		conv += panelSh[p_idx + 19] * templateSh[380];
		conv += panelSh[p_idx + 35] * templateSh[379];
		conv += panelSh[p_idx + 36] * templateSh[378];
		conv += panelSh[p_idx + 37] * templateSh[377];
		conv += panelSh[p_idx + 38] * templateSh[376];
		conv += panelSh[p_idx + 39] * templateSh[375];
		conv += panelSh[p_idx + 40] * templateSh[374];
		conv += panelSh[p_idx + 41] * templateSh[373];
		conv += panelSh[p_idx + 42] * templateSh[372];
		conv += panelSh[p_idx + 43] * templateSh[371];
		conv += panelSh[p_idx + 44] * templateSh[370];
		conv += panelSh[p_idx + 45] * templateSh[369];
		conv += panelSh[p_idx + 46] * templateSh[368];
		conv += panelSh[p_idx + 47] * templateSh[367];
		conv += panelSh[p_idx + 48] * templateSh[366];
		conv += panelSh[p_idx + 49] * templateSh[365];
		conv += panelSh[p_idx + 50] * templateSh[364];
		conv += panelSh[p_idx + 51] * templateSh[363];
		conv += panelSh[p_idx + 52] * templateSh[362];
		conv += panelSh[p_idx + 53] * templateSh[361];
		conv += panelSh[p_idx + 54] * templateSh[360];
		conv += panelSh[p_idx + 70] * templateSh[359];
		conv += panelSh[p_idx + 71] * templateSh[358];
		conv += panelSh[p_idx + 72] * templateSh[357];
		conv += panelSh[p_idx + 73] * templateSh[356];
		conv += panelSh[p_idx + 74] * templateSh[355];
		conv += panelSh[p_idx + 75] * templateSh[354];
		conv += panelSh[p_idx + 76] * templateSh[353];
		conv += panelSh[p_idx + 77] * templateSh[352];
		conv += panelSh[p_idx + 78] * templateSh[351];
		conv += panelSh[p_idx + 79] * templateSh[350];
		conv += panelSh[p_idx + 80] * templateSh[349];
		conv += panelSh[p_idx + 81] * templateSh[348];
		conv += panelSh[p_idx + 82] * templateSh[347];
		conv += panelSh[p_idx + 83] * templateSh[346];
		conv += panelSh[p_idx + 84] * templateSh[345];
		conv += panelSh[p_idx + 85] * templateSh[344];
		conv += panelSh[p_idx + 86] * templateSh[343];
		conv += panelSh[p_idx + 87] * templateSh[342];
		conv += panelSh[p_idx + 88] * templateSh[341];
		conv += panelSh[p_idx + 89] * templateSh[340];
		conv += panelSh[p_idx + 105] * templateSh[339];
		conv += panelSh[p_idx + 106] * templateSh[338];
		conv += panelSh[p_idx + 107] * templateSh[337];
		conv += panelSh[p_idx + 108] * templateSh[336];
		conv += panelSh[p_idx + 109] * templateSh[335];
		conv += panelSh[p_idx + 110] * templateSh[334];
		conv += panelSh[p_idx + 111] * templateSh[333];
		conv += panelSh[p_idx + 112] * templateSh[332];
		conv += panelSh[p_idx + 113] * templateSh[331];
		conv += panelSh[p_idx + 114] * templateSh[330];
		conv += panelSh[p_idx + 115] * templateSh[329];
		conv += panelSh[p_idx + 116] * templateSh[328];
		conv += panelSh[p_idx + 117] * templateSh[327];
		conv += panelSh[p_idx + 118] * templateSh[326];
		conv += panelSh[p_idx + 119] * templateSh[325];
		conv += panelSh[p_idx + 120] * templateSh[324];
		conv += panelSh[p_idx + 121] * templateSh[323];
		conv += panelSh[p_idx + 122] * templateSh[322];
		conv += panelSh[p_idx + 123] * templateSh[321];
		conv += panelSh[p_idx + 124] * templateSh[320];
		conv += panelSh[p_idx + 140] * templateSh[319];
		conv += panelSh[p_idx + 141] * templateSh[318];
		conv += panelSh[p_idx + 142] * templateSh[317];
		conv += panelSh[p_idx + 143] * templateSh[316];
		conv += panelSh[p_idx + 144] * templateSh[315];
		conv += panelSh[p_idx + 145] * templateSh[314];
		conv += panelSh[p_idx + 146] * templateSh[313];
		conv += panelSh[p_idx + 147] * templateSh[312];
		conv += panelSh[p_idx + 148] * templateSh[311];
		conv += panelSh[p_idx + 149] * templateSh[310];
		conv += panelSh[p_idx + 150] * templateSh[309];
		conv += panelSh[p_idx + 151] * templateSh[308];
		conv += panelSh[p_idx + 152] * templateSh[307];
		conv += panelSh[p_idx + 153] * templateSh[306];
		conv += panelSh[p_idx + 154] * templateSh[305];
		conv += panelSh[p_idx + 155] * templateSh[304];
		conv += panelSh[p_idx + 156] * templateSh[303];
		conv += panelSh[p_idx + 157] * templateSh[302];
		conv += panelSh[p_idx + 158] * templateSh[301];
		conv += panelSh[p_idx + 159] * templateSh[300];
		conv += panelSh[p_idx + 175] * templateSh[299];
		conv += panelSh[p_idx + 176] * templateSh[298];
		conv += panelSh[p_idx + 177] * templateSh[297];
		conv += panelSh[p_idx + 178] * templateSh[296];
		conv += panelSh[p_idx + 179] * templateSh[295];
		conv += panelSh[p_idx + 180] * templateSh[294];
		conv += panelSh[p_idx + 181] * templateSh[293];
		conv += panelSh[p_idx + 182] * templateSh[292];
		conv += panelSh[p_idx + 183] * templateSh[291];
		conv += panelSh[p_idx + 184] * templateSh[290];
		conv += panelSh[p_idx + 185] * templateSh[289];
		conv += panelSh[p_idx + 186] * templateSh[288];
		conv += panelSh[p_idx + 187] * templateSh[287];
		conv += panelSh[p_idx + 188] * templateSh[286];
		conv += panelSh[p_idx + 189] * templateSh[285];
		conv += panelSh[p_idx + 190] * templateSh[284];
		conv += panelSh[p_idx + 191] * templateSh[283];
		conv += panelSh[p_idx + 192] * templateSh[282];
		conv += panelSh[p_idx + 193] * templateSh[281];
		conv += panelSh[p_idx + 194] * templateSh[280];
		conv += panelSh[p_idx + 210] * templateSh[279];
		conv += panelSh[p_idx + 211] * templateSh[278];
		conv += panelSh[p_idx + 212] * templateSh[277];
		conv += panelSh[p_idx + 213] * templateSh[276];
		conv += panelSh[p_idx + 214] * templateSh[275];
		conv += panelSh[p_idx + 215] * templateSh[274];
		conv += panelSh[p_idx + 216] * templateSh[273];
		conv += panelSh[p_idx + 217] * templateSh[272];
		conv += panelSh[p_idx + 218] * templateSh[271];
		conv += panelSh[p_idx + 219] * templateSh[270];
		conv += panelSh[p_idx + 220] * templateSh[269];
		conv += panelSh[p_idx + 221] * templateSh[268];
		conv += panelSh[p_idx + 222] * templateSh[267];
		conv += panelSh[p_idx + 223] * templateSh[266];
		conv += panelSh[p_idx + 224] * templateSh[265];
		conv += panelSh[p_idx + 225] * templateSh[264];
		conv += panelSh[p_idx + 226] * templateSh[263];
		conv += panelSh[p_idx + 227] * templateSh[262];
		conv += panelSh[p_idx + 228] * templateSh[261];
		conv += panelSh[p_idx + 229] * templateSh[260];
		conv += panelSh[p_idx + 245] * templateSh[259];
		conv += panelSh[p_idx + 246] * templateSh[258];
		conv += panelSh[p_idx + 247] * templateSh[257];
		conv += panelSh[p_idx + 248] * templateSh[256];
		conv += panelSh[p_idx + 249] * templateSh[255];
		conv += panelSh[p_idx + 250] * templateSh[254];
		conv += panelSh[p_idx + 251] * templateSh[253];
		conv += panelSh[p_idx + 252] * templateSh[252];
		conv += panelSh[p_idx + 253] * templateSh[251];
		conv += panelSh[p_idx + 254] * templateSh[250];
		conv += panelSh[p_idx + 255] * templateSh[249];
		conv += panelSh[p_idx + 256] * templateSh[248];
		conv += panelSh[p_idx + 257] * templateSh[247];
		conv += panelSh[p_idx + 258] * templateSh[246];
		conv += panelSh[p_idx + 259] * templateSh[245];
		conv += panelSh[p_idx + 260] * templateSh[244];
		conv += panelSh[p_idx + 261] * templateSh[243];
		conv += panelSh[p_idx + 262] * templateSh[242];
		conv += panelSh[p_idx + 263] * templateSh[241];
		conv += panelSh[p_idx + 264] * templateSh[240];
		conv += panelSh[p_idx + 280] * templateSh[239];
		conv += panelSh[p_idx + 281] * templateSh[238];
		conv += panelSh[p_idx + 282] * templateSh[237];
		conv += panelSh[p_idx + 283] * templateSh[236];
		conv += panelSh[p_idx + 284] * templateSh[235];
		conv += panelSh[p_idx + 285] * templateSh[234];
		conv += panelSh[p_idx + 286] * templateSh[233];
		conv += panelSh[p_idx + 287] * templateSh[232];
		conv += panelSh[p_idx + 288] * templateSh[231];
		conv += panelSh[p_idx + 289] * templateSh[230];
		conv += panelSh[p_idx + 290] * templateSh[229];
		conv += panelSh[p_idx + 291] * templateSh[228];
		conv += panelSh[p_idx + 292] * templateSh[227];
		conv += panelSh[p_idx + 293] * templateSh[226];
		conv += panelSh[p_idx + 294] * templateSh[225];
		conv += panelSh[p_idx + 295] * templateSh[224];
		conv += panelSh[p_idx + 296] * templateSh[223];
		conv += panelSh[p_idx + 297] * templateSh[222];
		conv += panelSh[p_idx + 298] * templateSh[221];
		conv += panelSh[p_idx + 299] * templateSh[220];
		conv += panelSh[p_idx + 315] * templateSh[219];
		conv += panelSh[p_idx + 316] * templateSh[218];
		conv += panelSh[p_idx + 317] * templateSh[217];
		conv += panelSh[p_idx + 318] * templateSh[216];
		conv += panelSh[p_idx + 319] * templateSh[215];
		conv += panelSh[p_idx + 320] * templateSh[214];
		conv += panelSh[p_idx + 321] * templateSh[213];
		conv += panelSh[p_idx + 322] * templateSh[212];
		conv += panelSh[p_idx + 323] * templateSh[211];
		conv += panelSh[p_idx + 324] * templateSh[210];
		conv += panelSh[p_idx + 325] * templateSh[209];
		conv += panelSh[p_idx + 326] * templateSh[208];
		conv += panelSh[p_idx + 327] * templateSh[207];
		conv += panelSh[p_idx + 328] * templateSh[206];
		conv += panelSh[p_idx + 329] * templateSh[205];
		conv += panelSh[p_idx + 330] * templateSh[204];
		conv += panelSh[p_idx + 331] * templateSh[203];
		conv += panelSh[p_idx + 332] * templateSh[202];
		conv += panelSh[p_idx + 333] * templateSh[201];
		conv += panelSh[p_idx + 334] * templateSh[200];
		conv += panelSh[p_idx + 350] * templateSh[199];
		conv += panelSh[p_idx + 351] * templateSh[198];
		conv += panelSh[p_idx + 352] * templateSh[197];
		conv += panelSh[p_idx + 353] * templateSh[196];
		conv += panelSh[p_idx + 354] * templateSh[195];
		conv += panelSh[p_idx + 355] * templateSh[194];
		conv += panelSh[p_idx + 356] * templateSh[193];
		conv += panelSh[p_idx + 357] * templateSh[192];
		conv += panelSh[p_idx + 358] * templateSh[191];
		conv += panelSh[p_idx + 359] * templateSh[190];
		conv += panelSh[p_idx + 360] * templateSh[189];
		conv += panelSh[p_idx + 361] * templateSh[188];
		conv += panelSh[p_idx + 362] * templateSh[187];
		conv += panelSh[p_idx + 363] * templateSh[186];
		conv += panelSh[p_idx + 364] * templateSh[185];
		conv += panelSh[p_idx + 365] * templateSh[184];
		conv += panelSh[p_idx + 366] * templateSh[183];
		conv += panelSh[p_idx + 367] * templateSh[182];
		conv += panelSh[p_idx + 368] * templateSh[181];
		conv += panelSh[p_idx + 369] * templateSh[180];
		conv += panelSh[p_idx + 385] * templateSh[179];
		conv += panelSh[p_idx + 386] * templateSh[178];
		conv += panelSh[p_idx + 387] * templateSh[177];
		conv += panelSh[p_idx + 388] * templateSh[176];
		conv += panelSh[p_idx + 389] * templateSh[175];
		conv += panelSh[p_idx + 390] * templateSh[174];
		conv += panelSh[p_idx + 391] * templateSh[173];
		conv += panelSh[p_idx + 392] * templateSh[172];
		conv += panelSh[p_idx + 393] * templateSh[171];
		conv += panelSh[p_idx + 394] * templateSh[170];
		conv += panelSh[p_idx + 395] * templateSh[169];
		conv += panelSh[p_idx + 396] * templateSh[168];
		conv += panelSh[p_idx + 397] * templateSh[167];
		conv += panelSh[p_idx + 398] * templateSh[166];
		conv += panelSh[p_idx + 399] * templateSh[165];
		conv += panelSh[p_idx + 400] * templateSh[164];
		conv += panelSh[p_idx + 401] * templateSh[163];
		conv += panelSh[p_idx + 402] * templateSh[162];
		conv += panelSh[p_idx + 403] * templateSh[161];
		conv += panelSh[p_idx + 404] * templateSh[160];
		conv += panelSh[p_idx + 420] * templateSh[159];
		conv += panelSh[p_idx + 421] * templateSh[158];
		conv += panelSh[p_idx + 422] * templateSh[157];
		conv += panelSh[p_idx + 423] * templateSh[156];
		conv += panelSh[p_idx + 424] * templateSh[155];
		conv += panelSh[p_idx + 425] * templateSh[154];
		conv += panelSh[p_idx + 426] * templateSh[153];
		conv += panelSh[p_idx + 427] * templateSh[152];
		conv += panelSh[p_idx + 428] * templateSh[151];
		conv += panelSh[p_idx + 429] * templateSh[150];
		conv += panelSh[p_idx + 430] * templateSh[149];
		conv += panelSh[p_idx + 431] * templateSh[148];
		conv += panelSh[p_idx + 432] * templateSh[147];
		conv += panelSh[p_idx + 433] * templateSh[146];
		conv += panelSh[p_idx + 434] * templateSh[145];
		conv += panelSh[p_idx + 435] * templateSh[144];
		conv += panelSh[p_idx + 436] * templateSh[143];
		conv += panelSh[p_idx + 437] * templateSh[142];
		conv += panelSh[p_idx + 438] * templateSh[141];
		conv += panelSh[p_idx + 439] * templateSh[140];
		conv += panelSh[p_idx + 455] * templateSh[139];
		conv += panelSh[p_idx + 456] * templateSh[138];
		conv += panelSh[p_idx + 457] * templateSh[137];
		conv += panelSh[p_idx + 458] * templateSh[136];
		conv += panelSh[p_idx + 459] * templateSh[135];
		conv += panelSh[p_idx + 460] * templateSh[134];
		conv += panelSh[p_idx + 461] * templateSh[133];
		conv += panelSh[p_idx + 462] * templateSh[132];
		conv += panelSh[p_idx + 463] * templateSh[131];
		conv += panelSh[p_idx + 464] * templateSh[130];
		conv += panelSh[p_idx + 465] * templateSh[129];
		conv += panelSh[p_idx + 466] * templateSh[128];
		conv += panelSh[p_idx + 467] * templateSh[127];
		conv += panelSh[p_idx + 468] * templateSh[126];
		conv += panelSh[p_idx + 469] * templateSh[125];
		conv += panelSh[p_idx + 470] * templateSh[124];
		conv += panelSh[p_idx + 471] * templateSh[123];
		conv += panelSh[p_idx + 472] * templateSh[122];
		conv += panelSh[p_idx + 473] * templateSh[121];
		conv += panelSh[p_idx + 474] * templateSh[120];
		conv += panelSh[p_idx + 490] * templateSh[119];
		conv += panelSh[p_idx + 491] * templateSh[118];
		conv += panelSh[p_idx + 492] * templateSh[117];
		conv += panelSh[p_idx + 493] * templateSh[116];
		conv += panelSh[p_idx + 494] * templateSh[115];
		conv += panelSh[p_idx + 495] * templateSh[114];
		conv += panelSh[p_idx + 496] * templateSh[113];
		conv += panelSh[p_idx + 497] * templateSh[112];
		conv += panelSh[p_idx + 498] * templateSh[111];
		conv += panelSh[p_idx + 499] * templateSh[110];
		conv += panelSh[p_idx + 500] * templateSh[109];
		conv += panelSh[p_idx + 501] * templateSh[108];
		conv += panelSh[p_idx + 502] * templateSh[107];
		conv += panelSh[p_idx + 503] * templateSh[106];
		conv += panelSh[p_idx + 504] * templateSh[105];
		conv += panelSh[p_idx + 505] * templateSh[104];
		conv += panelSh[p_idx + 506] * templateSh[103];
		conv += panelSh[p_idx + 507] * templateSh[102];
		conv += panelSh[p_idx + 508] * templateSh[101];
		conv += panelSh[p_idx + 509] * templateSh[100];
		conv += panelSh[p_idx + 525] * templateSh[99];
		conv += panelSh[p_idx + 526] * templateSh[98];
		conv += panelSh[p_idx + 527] * templateSh[97];
		conv += panelSh[p_idx + 528] * templateSh[96];
		conv += panelSh[p_idx + 529] * templateSh[95];
		conv += panelSh[p_idx + 530] * templateSh[94];
		conv += panelSh[p_idx + 531] * templateSh[93];
		conv += panelSh[p_idx + 532] * templateSh[92];
		conv += panelSh[p_idx + 533] * templateSh[91];
		conv += panelSh[p_idx + 534] * templateSh[90];
		conv += panelSh[p_idx + 535] * templateSh[89];
		conv += panelSh[p_idx + 536] * templateSh[88];
		conv += panelSh[p_idx + 537] * templateSh[87];
		conv += panelSh[p_idx + 538] * templateSh[86];
		conv += panelSh[p_idx + 539] * templateSh[85];
		conv += panelSh[p_idx + 540] * templateSh[84];
		conv += panelSh[p_idx + 541] * templateSh[83];
		conv += panelSh[p_idx + 542] * templateSh[82];
		conv += panelSh[p_idx + 543] * templateSh[81];
		conv += panelSh[p_idx + 544] * templateSh[80];
		conv += panelSh[p_idx + 560] * templateSh[79];
		conv += panelSh[p_idx + 561] * templateSh[78];
		conv += panelSh[p_idx + 562] * templateSh[77];
		conv += panelSh[p_idx + 563] * templateSh[76];
		conv += panelSh[p_idx + 564] * templateSh[75];
		conv += panelSh[p_idx + 565] * templateSh[74];
		conv += panelSh[p_idx + 566] * templateSh[73];
		conv += panelSh[p_idx + 567] * templateSh[72];
		conv += panelSh[p_idx + 568] * templateSh[71];
		conv += panelSh[p_idx + 569] * templateSh[70];
		conv += panelSh[p_idx + 570] * templateSh[69];
		conv += panelSh[p_idx + 571] * templateSh[68];
		conv += panelSh[p_idx + 572] * templateSh[67];
		conv += panelSh[p_idx + 573] * templateSh[66];
		conv += panelSh[p_idx + 574] * templateSh[65];
		conv += panelSh[p_idx + 575] * templateSh[64];
		conv += panelSh[p_idx + 576] * templateSh[63];
		conv += panelSh[p_idx + 577] * templateSh[62];
		conv += panelSh[p_idx + 578] * templateSh[61];
		conv += panelSh[p_idx + 579] * templateSh[60];
		conv += panelSh[p_idx + 595] * templateSh[59];
		conv += panelSh[p_idx + 596] * templateSh[58];
		conv += panelSh[p_idx + 597] * templateSh[57];
		conv += panelSh[p_idx + 598] * templateSh[56];
		conv += panelSh[p_idx + 599] * templateSh[55];
		conv += panelSh[p_idx + 600] * templateSh[54];
		conv += panelSh[p_idx + 601] * templateSh[53];
		conv += panelSh[p_idx + 602] * templateSh[52];
		conv += panelSh[p_idx + 603] * templateSh[51];
		conv += panelSh[p_idx + 604] * templateSh[50];
		conv += panelSh[p_idx + 605] * templateSh[49];
		conv += panelSh[p_idx + 606] * templateSh[48];
		conv += panelSh[p_idx + 607] * templateSh[47];
		conv += panelSh[p_idx + 608] * templateSh[46];
		conv += panelSh[p_idx + 609] * templateSh[45];
		conv += panelSh[p_idx + 610] * templateSh[44];
		conv += panelSh[p_idx + 611] * templateSh[43];
		conv += panelSh[p_idx + 612] * templateSh[42];
		conv += panelSh[p_idx + 613] * templateSh[41];
		conv += panelSh[p_idx + 614] * templateSh[40];
		conv += panelSh[p_idx + 630] * templateSh[39];
		conv += panelSh[p_idx + 631] * templateSh[38];
		conv += panelSh[p_idx + 632] * templateSh[37];
		conv += panelSh[p_idx + 633] * templateSh[36];
		conv += panelSh[p_idx + 634] * templateSh[35];
		conv += panelSh[p_idx + 635] * templateSh[34];
		conv += panelSh[p_idx + 636] * templateSh[33];
		conv += panelSh[p_idx + 637] * templateSh[32];
		conv += panelSh[p_idx + 638] * templateSh[31];
		conv += panelSh[p_idx + 639] * templateSh[30];
		conv += panelSh[p_idx + 640] * templateSh[29];
		conv += panelSh[p_idx + 641] * templateSh[28];
		conv += panelSh[p_idx + 642] * templateSh[27];
		conv += panelSh[p_idx + 643] * templateSh[26];
		conv += panelSh[p_idx + 644] * templateSh[25];
		conv += panelSh[p_idx + 645] * templateSh[24];
		conv += panelSh[p_idx + 646] * templateSh[23];
		conv += panelSh[p_idx + 647] * templateSh[22];
		conv += panelSh[p_idx + 648] * templateSh[21];
		conv += panelSh[p_idx + 649] * templateSh[20];
		conv += panelSh[p_idx + 665] * templateSh[19];
		conv += panelSh[p_idx + 666] * templateSh[18];
		conv += panelSh[p_idx + 667] * templateSh[17];
		conv += panelSh[p_idx + 668] * templateSh[16];
		conv += panelSh[p_idx + 669] * templateSh[15];
		conv += panelSh[p_idx + 670] * templateSh[14];
		conv += panelSh[p_idx + 671] * templateSh[13];
		conv += panelSh[p_idx + 672] * templateSh[12];
		conv += panelSh[p_idx + 673] * templateSh[11];
		conv += panelSh[p_idx + 674] * templateSh[10];
		conv += panelSh[p_idx + 675] * templateSh[9];
		conv += panelSh[p_idx + 676] * templateSh[8];
		conv += panelSh[p_idx + 677] * templateSh[7];
		conv += panelSh[p_idx + 678] * templateSh[6];
		conv += panelSh[p_idx + 679] * templateSh[5];
		conv += panelSh[p_idx + 680] * templateSh[4];
		conv += panelSh[p_idx + 681] * templateSh[3];
		conv += panelSh[p_idx + 682] * templateSh[2];
		conv += panelSh[p_idx + 683] * templateSh[1];
		conv += panelSh[p_idx + 684] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_20x20<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_20x20<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_21x21 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1296];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<36; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<36; i+=16) {
			panelSh[IMUL(j, 36) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[441];
	for (int j=threadIdx.y; j<21; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<21; i+=16) {
			const int jtwi = IMUL(j, 21) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 36);
		conv += panelSh[p_idx + 0] * templateSh[440];
		conv += panelSh[p_idx + 1] * templateSh[439];
		conv += panelSh[p_idx + 2] * templateSh[438];
		conv += panelSh[p_idx + 3] * templateSh[437];
		conv += panelSh[p_idx + 4] * templateSh[436];
		conv += panelSh[p_idx + 5] * templateSh[435];
		conv += panelSh[p_idx + 6] * templateSh[434];
		conv += panelSh[p_idx + 7] * templateSh[433];
		conv += panelSh[p_idx + 8] * templateSh[432];
		conv += panelSh[p_idx + 9] * templateSh[431];
		conv += panelSh[p_idx + 10] * templateSh[430];
		conv += panelSh[p_idx + 11] * templateSh[429];
		conv += panelSh[p_idx + 12] * templateSh[428];
		conv += panelSh[p_idx + 13] * templateSh[427];
		conv += panelSh[p_idx + 14] * templateSh[426];
		conv += panelSh[p_idx + 15] * templateSh[425];
		conv += panelSh[p_idx + 16] * templateSh[424];
		conv += panelSh[p_idx + 17] * templateSh[423];
		conv += panelSh[p_idx + 18] * templateSh[422];
		conv += panelSh[p_idx + 19] * templateSh[421];
		conv += panelSh[p_idx + 20] * templateSh[420];
		conv += panelSh[p_idx + 36] * templateSh[419];
		conv += panelSh[p_idx + 37] * templateSh[418];
		conv += panelSh[p_idx + 38] * templateSh[417];
		conv += panelSh[p_idx + 39] * templateSh[416];
		conv += panelSh[p_idx + 40] * templateSh[415];
		conv += panelSh[p_idx + 41] * templateSh[414];
		conv += panelSh[p_idx + 42] * templateSh[413];
		conv += panelSh[p_idx + 43] * templateSh[412];
		conv += panelSh[p_idx + 44] * templateSh[411];
		conv += panelSh[p_idx + 45] * templateSh[410];
		conv += panelSh[p_idx + 46] * templateSh[409];
		conv += panelSh[p_idx + 47] * templateSh[408];
		conv += panelSh[p_idx + 48] * templateSh[407];
		conv += panelSh[p_idx + 49] * templateSh[406];
		conv += panelSh[p_idx + 50] * templateSh[405];
		conv += panelSh[p_idx + 51] * templateSh[404];
		conv += panelSh[p_idx + 52] * templateSh[403];
		conv += panelSh[p_idx + 53] * templateSh[402];
		conv += panelSh[p_idx + 54] * templateSh[401];
		conv += panelSh[p_idx + 55] * templateSh[400];
		conv += panelSh[p_idx + 56] * templateSh[399];
		conv += panelSh[p_idx + 72] * templateSh[398];
		conv += panelSh[p_idx + 73] * templateSh[397];
		conv += panelSh[p_idx + 74] * templateSh[396];
		conv += panelSh[p_idx + 75] * templateSh[395];
		conv += panelSh[p_idx + 76] * templateSh[394];
		conv += panelSh[p_idx + 77] * templateSh[393];
		conv += panelSh[p_idx + 78] * templateSh[392];
		conv += panelSh[p_idx + 79] * templateSh[391];
		conv += panelSh[p_idx + 80] * templateSh[390];
		conv += panelSh[p_idx + 81] * templateSh[389];
		conv += panelSh[p_idx + 82] * templateSh[388];
		conv += panelSh[p_idx + 83] * templateSh[387];
		conv += panelSh[p_idx + 84] * templateSh[386];
		conv += panelSh[p_idx + 85] * templateSh[385];
		conv += panelSh[p_idx + 86] * templateSh[384];
		conv += panelSh[p_idx + 87] * templateSh[383];
		conv += panelSh[p_idx + 88] * templateSh[382];
		conv += panelSh[p_idx + 89] * templateSh[381];
		conv += panelSh[p_idx + 90] * templateSh[380];
		conv += panelSh[p_idx + 91] * templateSh[379];
		conv += panelSh[p_idx + 92] * templateSh[378];
		conv += panelSh[p_idx + 108] * templateSh[377];
		conv += panelSh[p_idx + 109] * templateSh[376];
		conv += panelSh[p_idx + 110] * templateSh[375];
		conv += panelSh[p_idx + 111] * templateSh[374];
		conv += panelSh[p_idx + 112] * templateSh[373];
		conv += panelSh[p_idx + 113] * templateSh[372];
		conv += panelSh[p_idx + 114] * templateSh[371];
		conv += panelSh[p_idx + 115] * templateSh[370];
		conv += panelSh[p_idx + 116] * templateSh[369];
		conv += panelSh[p_idx + 117] * templateSh[368];
		conv += panelSh[p_idx + 118] * templateSh[367];
		conv += panelSh[p_idx + 119] * templateSh[366];
		conv += panelSh[p_idx + 120] * templateSh[365];
		conv += panelSh[p_idx + 121] * templateSh[364];
		conv += panelSh[p_idx + 122] * templateSh[363];
		conv += panelSh[p_idx + 123] * templateSh[362];
		conv += panelSh[p_idx + 124] * templateSh[361];
		conv += panelSh[p_idx + 125] * templateSh[360];
		conv += panelSh[p_idx + 126] * templateSh[359];
		conv += panelSh[p_idx + 127] * templateSh[358];
		conv += panelSh[p_idx + 128] * templateSh[357];
		conv += panelSh[p_idx + 144] * templateSh[356];
		conv += panelSh[p_idx + 145] * templateSh[355];
		conv += panelSh[p_idx + 146] * templateSh[354];
		conv += panelSh[p_idx + 147] * templateSh[353];
		conv += panelSh[p_idx + 148] * templateSh[352];
		conv += panelSh[p_idx + 149] * templateSh[351];
		conv += panelSh[p_idx + 150] * templateSh[350];
		conv += panelSh[p_idx + 151] * templateSh[349];
		conv += panelSh[p_idx + 152] * templateSh[348];
		conv += panelSh[p_idx + 153] * templateSh[347];
		conv += panelSh[p_idx + 154] * templateSh[346];
		conv += panelSh[p_idx + 155] * templateSh[345];
		conv += panelSh[p_idx + 156] * templateSh[344];
		conv += panelSh[p_idx + 157] * templateSh[343];
		conv += panelSh[p_idx + 158] * templateSh[342];
		conv += panelSh[p_idx + 159] * templateSh[341];
		conv += panelSh[p_idx + 160] * templateSh[340];
		conv += panelSh[p_idx + 161] * templateSh[339];
		conv += panelSh[p_idx + 162] * templateSh[338];
		conv += panelSh[p_idx + 163] * templateSh[337];
		conv += panelSh[p_idx + 164] * templateSh[336];
		conv += panelSh[p_idx + 180] * templateSh[335];
		conv += panelSh[p_idx + 181] * templateSh[334];
		conv += panelSh[p_idx + 182] * templateSh[333];
		conv += panelSh[p_idx + 183] * templateSh[332];
		conv += panelSh[p_idx + 184] * templateSh[331];
		conv += panelSh[p_idx + 185] * templateSh[330];
		conv += panelSh[p_idx + 186] * templateSh[329];
		conv += panelSh[p_idx + 187] * templateSh[328];
		conv += panelSh[p_idx + 188] * templateSh[327];
		conv += panelSh[p_idx + 189] * templateSh[326];
		conv += panelSh[p_idx + 190] * templateSh[325];
		conv += panelSh[p_idx + 191] * templateSh[324];
		conv += panelSh[p_idx + 192] * templateSh[323];
		conv += panelSh[p_idx + 193] * templateSh[322];
		conv += panelSh[p_idx + 194] * templateSh[321];
		conv += panelSh[p_idx + 195] * templateSh[320];
		conv += panelSh[p_idx + 196] * templateSh[319];
		conv += panelSh[p_idx + 197] * templateSh[318];
		conv += panelSh[p_idx + 198] * templateSh[317];
		conv += panelSh[p_idx + 199] * templateSh[316];
		conv += panelSh[p_idx + 200] * templateSh[315];
		conv += panelSh[p_idx + 216] * templateSh[314];
		conv += panelSh[p_idx + 217] * templateSh[313];
		conv += panelSh[p_idx + 218] * templateSh[312];
		conv += panelSh[p_idx + 219] * templateSh[311];
		conv += panelSh[p_idx + 220] * templateSh[310];
		conv += panelSh[p_idx + 221] * templateSh[309];
		conv += panelSh[p_idx + 222] * templateSh[308];
		conv += panelSh[p_idx + 223] * templateSh[307];
		conv += panelSh[p_idx + 224] * templateSh[306];
		conv += panelSh[p_idx + 225] * templateSh[305];
		conv += panelSh[p_idx + 226] * templateSh[304];
		conv += panelSh[p_idx + 227] * templateSh[303];
		conv += panelSh[p_idx + 228] * templateSh[302];
		conv += panelSh[p_idx + 229] * templateSh[301];
		conv += panelSh[p_idx + 230] * templateSh[300];
		conv += panelSh[p_idx + 231] * templateSh[299];
		conv += panelSh[p_idx + 232] * templateSh[298];
		conv += panelSh[p_idx + 233] * templateSh[297];
		conv += panelSh[p_idx + 234] * templateSh[296];
		conv += panelSh[p_idx + 235] * templateSh[295];
		conv += panelSh[p_idx + 236] * templateSh[294];
		conv += panelSh[p_idx + 252] * templateSh[293];
		conv += panelSh[p_idx + 253] * templateSh[292];
		conv += panelSh[p_idx + 254] * templateSh[291];
		conv += panelSh[p_idx + 255] * templateSh[290];
		conv += panelSh[p_idx + 256] * templateSh[289];
		conv += panelSh[p_idx + 257] * templateSh[288];
		conv += panelSh[p_idx + 258] * templateSh[287];
		conv += panelSh[p_idx + 259] * templateSh[286];
		conv += panelSh[p_idx + 260] * templateSh[285];
		conv += panelSh[p_idx + 261] * templateSh[284];
		conv += panelSh[p_idx + 262] * templateSh[283];
		conv += panelSh[p_idx + 263] * templateSh[282];
		conv += panelSh[p_idx + 264] * templateSh[281];
		conv += panelSh[p_idx + 265] * templateSh[280];
		conv += panelSh[p_idx + 266] * templateSh[279];
		conv += panelSh[p_idx + 267] * templateSh[278];
		conv += panelSh[p_idx + 268] * templateSh[277];
		conv += panelSh[p_idx + 269] * templateSh[276];
		conv += panelSh[p_idx + 270] * templateSh[275];
		conv += panelSh[p_idx + 271] * templateSh[274];
		conv += panelSh[p_idx + 272] * templateSh[273];
		conv += panelSh[p_idx + 288] * templateSh[272];
		conv += panelSh[p_idx + 289] * templateSh[271];
		conv += panelSh[p_idx + 290] * templateSh[270];
		conv += panelSh[p_idx + 291] * templateSh[269];
		conv += panelSh[p_idx + 292] * templateSh[268];
		conv += panelSh[p_idx + 293] * templateSh[267];
		conv += panelSh[p_idx + 294] * templateSh[266];
		conv += panelSh[p_idx + 295] * templateSh[265];
		conv += panelSh[p_idx + 296] * templateSh[264];
		conv += panelSh[p_idx + 297] * templateSh[263];
		conv += panelSh[p_idx + 298] * templateSh[262];
		conv += panelSh[p_idx + 299] * templateSh[261];
		conv += panelSh[p_idx + 300] * templateSh[260];
		conv += panelSh[p_idx + 301] * templateSh[259];
		conv += panelSh[p_idx + 302] * templateSh[258];
		conv += panelSh[p_idx + 303] * templateSh[257];
		conv += panelSh[p_idx + 304] * templateSh[256];
		conv += panelSh[p_idx + 305] * templateSh[255];
		conv += panelSh[p_idx + 306] * templateSh[254];
		conv += panelSh[p_idx + 307] * templateSh[253];
		conv += panelSh[p_idx + 308] * templateSh[252];
		conv += panelSh[p_idx + 324] * templateSh[251];
		conv += panelSh[p_idx + 325] * templateSh[250];
		conv += panelSh[p_idx + 326] * templateSh[249];
		conv += panelSh[p_idx + 327] * templateSh[248];
		conv += panelSh[p_idx + 328] * templateSh[247];
		conv += panelSh[p_idx + 329] * templateSh[246];
		conv += panelSh[p_idx + 330] * templateSh[245];
		conv += panelSh[p_idx + 331] * templateSh[244];
		conv += panelSh[p_idx + 332] * templateSh[243];
		conv += panelSh[p_idx + 333] * templateSh[242];
		conv += panelSh[p_idx + 334] * templateSh[241];
		conv += panelSh[p_idx + 335] * templateSh[240];
		conv += panelSh[p_idx + 336] * templateSh[239];
		conv += panelSh[p_idx + 337] * templateSh[238];
		conv += panelSh[p_idx + 338] * templateSh[237];
		conv += panelSh[p_idx + 339] * templateSh[236];
		conv += panelSh[p_idx + 340] * templateSh[235];
		conv += panelSh[p_idx + 341] * templateSh[234];
		conv += panelSh[p_idx + 342] * templateSh[233];
		conv += panelSh[p_idx + 343] * templateSh[232];
		conv += panelSh[p_idx + 344] * templateSh[231];
		conv += panelSh[p_idx + 360] * templateSh[230];
		conv += panelSh[p_idx + 361] * templateSh[229];
		conv += panelSh[p_idx + 362] * templateSh[228];
		conv += panelSh[p_idx + 363] * templateSh[227];
		conv += panelSh[p_idx + 364] * templateSh[226];
		conv += panelSh[p_idx + 365] * templateSh[225];
		conv += panelSh[p_idx + 366] * templateSh[224];
		conv += panelSh[p_idx + 367] * templateSh[223];
		conv += panelSh[p_idx + 368] * templateSh[222];
		conv += panelSh[p_idx + 369] * templateSh[221];
		conv += panelSh[p_idx + 370] * templateSh[220];
		conv += panelSh[p_idx + 371] * templateSh[219];
		conv += panelSh[p_idx + 372] * templateSh[218];
		conv += panelSh[p_idx + 373] * templateSh[217];
		conv += panelSh[p_idx + 374] * templateSh[216];
		conv += panelSh[p_idx + 375] * templateSh[215];
		conv += panelSh[p_idx + 376] * templateSh[214];
		conv += panelSh[p_idx + 377] * templateSh[213];
		conv += panelSh[p_idx + 378] * templateSh[212];
		conv += panelSh[p_idx + 379] * templateSh[211];
		conv += panelSh[p_idx + 380] * templateSh[210];
		conv += panelSh[p_idx + 396] * templateSh[209];
		conv += panelSh[p_idx + 397] * templateSh[208];
		conv += panelSh[p_idx + 398] * templateSh[207];
		conv += panelSh[p_idx + 399] * templateSh[206];
		conv += panelSh[p_idx + 400] * templateSh[205];
		conv += panelSh[p_idx + 401] * templateSh[204];
		conv += panelSh[p_idx + 402] * templateSh[203];
		conv += panelSh[p_idx + 403] * templateSh[202];
		conv += panelSh[p_idx + 404] * templateSh[201];
		conv += panelSh[p_idx + 405] * templateSh[200];
		conv += panelSh[p_idx + 406] * templateSh[199];
		conv += panelSh[p_idx + 407] * templateSh[198];
		conv += panelSh[p_idx + 408] * templateSh[197];
		conv += panelSh[p_idx + 409] * templateSh[196];
		conv += panelSh[p_idx + 410] * templateSh[195];
		conv += panelSh[p_idx + 411] * templateSh[194];
		conv += panelSh[p_idx + 412] * templateSh[193];
		conv += panelSh[p_idx + 413] * templateSh[192];
		conv += panelSh[p_idx + 414] * templateSh[191];
		conv += panelSh[p_idx + 415] * templateSh[190];
		conv += panelSh[p_idx + 416] * templateSh[189];
		conv += panelSh[p_idx + 432] * templateSh[188];
		conv += panelSh[p_idx + 433] * templateSh[187];
		conv += panelSh[p_idx + 434] * templateSh[186];
		conv += panelSh[p_idx + 435] * templateSh[185];
		conv += panelSh[p_idx + 436] * templateSh[184];
		conv += panelSh[p_idx + 437] * templateSh[183];
		conv += panelSh[p_idx + 438] * templateSh[182];
		conv += panelSh[p_idx + 439] * templateSh[181];
		conv += panelSh[p_idx + 440] * templateSh[180];
		conv += panelSh[p_idx + 441] * templateSh[179];
		conv += panelSh[p_idx + 442] * templateSh[178];
		conv += panelSh[p_idx + 443] * templateSh[177];
		conv += panelSh[p_idx + 444] * templateSh[176];
		conv += panelSh[p_idx + 445] * templateSh[175];
		conv += panelSh[p_idx + 446] * templateSh[174];
		conv += panelSh[p_idx + 447] * templateSh[173];
		conv += panelSh[p_idx + 448] * templateSh[172];
		conv += panelSh[p_idx + 449] * templateSh[171];
		conv += panelSh[p_idx + 450] * templateSh[170];
		conv += panelSh[p_idx + 451] * templateSh[169];
		conv += panelSh[p_idx + 452] * templateSh[168];
		conv += panelSh[p_idx + 468] * templateSh[167];
		conv += panelSh[p_idx + 469] * templateSh[166];
		conv += panelSh[p_idx + 470] * templateSh[165];
		conv += panelSh[p_idx + 471] * templateSh[164];
		conv += panelSh[p_idx + 472] * templateSh[163];
		conv += panelSh[p_idx + 473] * templateSh[162];
		conv += panelSh[p_idx + 474] * templateSh[161];
		conv += panelSh[p_idx + 475] * templateSh[160];
		conv += panelSh[p_idx + 476] * templateSh[159];
		conv += panelSh[p_idx + 477] * templateSh[158];
		conv += panelSh[p_idx + 478] * templateSh[157];
		conv += panelSh[p_idx + 479] * templateSh[156];
		conv += panelSh[p_idx + 480] * templateSh[155];
		conv += panelSh[p_idx + 481] * templateSh[154];
		conv += panelSh[p_idx + 482] * templateSh[153];
		conv += panelSh[p_idx + 483] * templateSh[152];
		conv += panelSh[p_idx + 484] * templateSh[151];
		conv += panelSh[p_idx + 485] * templateSh[150];
		conv += panelSh[p_idx + 486] * templateSh[149];
		conv += panelSh[p_idx + 487] * templateSh[148];
		conv += panelSh[p_idx + 488] * templateSh[147];
		conv += panelSh[p_idx + 504] * templateSh[146];
		conv += panelSh[p_idx + 505] * templateSh[145];
		conv += panelSh[p_idx + 506] * templateSh[144];
		conv += panelSh[p_idx + 507] * templateSh[143];
		conv += panelSh[p_idx + 508] * templateSh[142];
		conv += panelSh[p_idx + 509] * templateSh[141];
		conv += panelSh[p_idx + 510] * templateSh[140];
		conv += panelSh[p_idx + 511] * templateSh[139];
		conv += panelSh[p_idx + 512] * templateSh[138];
		conv += panelSh[p_idx + 513] * templateSh[137];
		conv += panelSh[p_idx + 514] * templateSh[136];
		conv += panelSh[p_idx + 515] * templateSh[135];
		conv += panelSh[p_idx + 516] * templateSh[134];
		conv += panelSh[p_idx + 517] * templateSh[133];
		conv += panelSh[p_idx + 518] * templateSh[132];
		conv += panelSh[p_idx + 519] * templateSh[131];
		conv += panelSh[p_idx + 520] * templateSh[130];
		conv += panelSh[p_idx + 521] * templateSh[129];
		conv += panelSh[p_idx + 522] * templateSh[128];
		conv += panelSh[p_idx + 523] * templateSh[127];
		conv += panelSh[p_idx + 524] * templateSh[126];
		conv += panelSh[p_idx + 540] * templateSh[125];
		conv += panelSh[p_idx + 541] * templateSh[124];
		conv += panelSh[p_idx + 542] * templateSh[123];
		conv += panelSh[p_idx + 543] * templateSh[122];
		conv += panelSh[p_idx + 544] * templateSh[121];
		conv += panelSh[p_idx + 545] * templateSh[120];
		conv += panelSh[p_idx + 546] * templateSh[119];
		conv += panelSh[p_idx + 547] * templateSh[118];
		conv += panelSh[p_idx + 548] * templateSh[117];
		conv += panelSh[p_idx + 549] * templateSh[116];
		conv += panelSh[p_idx + 550] * templateSh[115];
		conv += panelSh[p_idx + 551] * templateSh[114];
		conv += panelSh[p_idx + 552] * templateSh[113];
		conv += panelSh[p_idx + 553] * templateSh[112];
		conv += panelSh[p_idx + 554] * templateSh[111];
		conv += panelSh[p_idx + 555] * templateSh[110];
		conv += panelSh[p_idx + 556] * templateSh[109];
		conv += panelSh[p_idx + 557] * templateSh[108];
		conv += panelSh[p_idx + 558] * templateSh[107];
		conv += panelSh[p_idx + 559] * templateSh[106];
		conv += panelSh[p_idx + 560] * templateSh[105];
		conv += panelSh[p_idx + 576] * templateSh[104];
		conv += panelSh[p_idx + 577] * templateSh[103];
		conv += panelSh[p_idx + 578] * templateSh[102];
		conv += panelSh[p_idx + 579] * templateSh[101];
		conv += panelSh[p_idx + 580] * templateSh[100];
		conv += panelSh[p_idx + 581] * templateSh[99];
		conv += panelSh[p_idx + 582] * templateSh[98];
		conv += panelSh[p_idx + 583] * templateSh[97];
		conv += panelSh[p_idx + 584] * templateSh[96];
		conv += panelSh[p_idx + 585] * templateSh[95];
		conv += panelSh[p_idx + 586] * templateSh[94];
		conv += panelSh[p_idx + 587] * templateSh[93];
		conv += panelSh[p_idx + 588] * templateSh[92];
		conv += panelSh[p_idx + 589] * templateSh[91];
		conv += panelSh[p_idx + 590] * templateSh[90];
		conv += panelSh[p_idx + 591] * templateSh[89];
		conv += panelSh[p_idx + 592] * templateSh[88];
		conv += panelSh[p_idx + 593] * templateSh[87];
		conv += panelSh[p_idx + 594] * templateSh[86];
		conv += panelSh[p_idx + 595] * templateSh[85];
		conv += panelSh[p_idx + 596] * templateSh[84];
		conv += panelSh[p_idx + 612] * templateSh[83];
		conv += panelSh[p_idx + 613] * templateSh[82];
		conv += panelSh[p_idx + 614] * templateSh[81];
		conv += panelSh[p_idx + 615] * templateSh[80];
		conv += panelSh[p_idx + 616] * templateSh[79];
		conv += panelSh[p_idx + 617] * templateSh[78];
		conv += panelSh[p_idx + 618] * templateSh[77];
		conv += panelSh[p_idx + 619] * templateSh[76];
		conv += panelSh[p_idx + 620] * templateSh[75];
		conv += panelSh[p_idx + 621] * templateSh[74];
		conv += panelSh[p_idx + 622] * templateSh[73];
		conv += panelSh[p_idx + 623] * templateSh[72];
		conv += panelSh[p_idx + 624] * templateSh[71];
		conv += panelSh[p_idx + 625] * templateSh[70];
		conv += panelSh[p_idx + 626] * templateSh[69];
		conv += panelSh[p_idx + 627] * templateSh[68];
		conv += panelSh[p_idx + 628] * templateSh[67];
		conv += panelSh[p_idx + 629] * templateSh[66];
		conv += panelSh[p_idx + 630] * templateSh[65];
		conv += panelSh[p_idx + 631] * templateSh[64];
		conv += panelSh[p_idx + 632] * templateSh[63];
		conv += panelSh[p_idx + 648] * templateSh[62];
		conv += panelSh[p_idx + 649] * templateSh[61];
		conv += panelSh[p_idx + 650] * templateSh[60];
		conv += panelSh[p_idx + 651] * templateSh[59];
		conv += panelSh[p_idx + 652] * templateSh[58];
		conv += panelSh[p_idx + 653] * templateSh[57];
		conv += panelSh[p_idx + 654] * templateSh[56];
		conv += panelSh[p_idx + 655] * templateSh[55];
		conv += panelSh[p_idx + 656] * templateSh[54];
		conv += panelSh[p_idx + 657] * templateSh[53];
		conv += panelSh[p_idx + 658] * templateSh[52];
		conv += panelSh[p_idx + 659] * templateSh[51];
		conv += panelSh[p_idx + 660] * templateSh[50];
		conv += panelSh[p_idx + 661] * templateSh[49];
		conv += panelSh[p_idx + 662] * templateSh[48];
		conv += panelSh[p_idx + 663] * templateSh[47];
		conv += panelSh[p_idx + 664] * templateSh[46];
		conv += panelSh[p_idx + 665] * templateSh[45];
		conv += panelSh[p_idx + 666] * templateSh[44];
		conv += panelSh[p_idx + 667] * templateSh[43];
		conv += panelSh[p_idx + 668] * templateSh[42];
		conv += panelSh[p_idx + 684] * templateSh[41];
		conv += panelSh[p_idx + 685] * templateSh[40];
		conv += panelSh[p_idx + 686] * templateSh[39];
		conv += panelSh[p_idx + 687] * templateSh[38];
		conv += panelSh[p_idx + 688] * templateSh[37];
		conv += panelSh[p_idx + 689] * templateSh[36];
		conv += panelSh[p_idx + 690] * templateSh[35];
		conv += panelSh[p_idx + 691] * templateSh[34];
		conv += panelSh[p_idx + 692] * templateSh[33];
		conv += panelSh[p_idx + 693] * templateSh[32];
		conv += panelSh[p_idx + 694] * templateSh[31];
		conv += panelSh[p_idx + 695] * templateSh[30];
		conv += panelSh[p_idx + 696] * templateSh[29];
		conv += panelSh[p_idx + 697] * templateSh[28];
		conv += panelSh[p_idx + 698] * templateSh[27];
		conv += panelSh[p_idx + 699] * templateSh[26];
		conv += panelSh[p_idx + 700] * templateSh[25];
		conv += panelSh[p_idx + 701] * templateSh[24];
		conv += panelSh[p_idx + 702] * templateSh[23];
		conv += panelSh[p_idx + 703] * templateSh[22];
		conv += panelSh[p_idx + 704] * templateSh[21];
		conv += panelSh[p_idx + 720] * templateSh[20];
		conv += panelSh[p_idx + 721] * templateSh[19];
		conv += panelSh[p_idx + 722] * templateSh[18];
		conv += panelSh[p_idx + 723] * templateSh[17];
		conv += panelSh[p_idx + 724] * templateSh[16];
		conv += panelSh[p_idx + 725] * templateSh[15];
		conv += panelSh[p_idx + 726] * templateSh[14];
		conv += panelSh[p_idx + 727] * templateSh[13];
		conv += panelSh[p_idx + 728] * templateSh[12];
		conv += panelSh[p_idx + 729] * templateSh[11];
		conv += panelSh[p_idx + 730] * templateSh[10];
		conv += panelSh[p_idx + 731] * templateSh[9];
		conv += panelSh[p_idx + 732] * templateSh[8];
		conv += panelSh[p_idx + 733] * templateSh[7];
		conv += panelSh[p_idx + 734] * templateSh[6];
		conv += panelSh[p_idx + 735] * templateSh[5];
		conv += panelSh[p_idx + 736] * templateSh[4];
		conv += panelSh[p_idx + 737] * templateSh[3];
		conv += panelSh[p_idx + 738] * templateSh[2];
		conv += panelSh[p_idx + 739] * templateSh[1];
		conv += panelSh[p_idx + 740] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_21x21<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_21x21<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_22x22 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1369];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<37; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<37; i+=16) {
			panelSh[IMUL(j, 37) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[484];
	for (int j=threadIdx.y; j<22; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<22; i+=16) {
			const int jtwi = IMUL(j, 22) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 37);
		conv += panelSh[p_idx + 0] * templateSh[483];
		conv += panelSh[p_idx + 1] * templateSh[482];
		conv += panelSh[p_idx + 2] * templateSh[481];
		conv += panelSh[p_idx + 3] * templateSh[480];
		conv += panelSh[p_idx + 4] * templateSh[479];
		conv += panelSh[p_idx + 5] * templateSh[478];
		conv += panelSh[p_idx + 6] * templateSh[477];
		conv += panelSh[p_idx + 7] * templateSh[476];
		conv += panelSh[p_idx + 8] * templateSh[475];
		conv += panelSh[p_idx + 9] * templateSh[474];
		conv += panelSh[p_idx + 10] * templateSh[473];
		conv += panelSh[p_idx + 11] * templateSh[472];
		conv += panelSh[p_idx + 12] * templateSh[471];
		conv += panelSh[p_idx + 13] * templateSh[470];
		conv += panelSh[p_idx + 14] * templateSh[469];
		conv += panelSh[p_idx + 15] * templateSh[468];
		conv += panelSh[p_idx + 16] * templateSh[467];
		conv += panelSh[p_idx + 17] * templateSh[466];
		conv += panelSh[p_idx + 18] * templateSh[465];
		conv += panelSh[p_idx + 19] * templateSh[464];
		conv += panelSh[p_idx + 20] * templateSh[463];
		conv += panelSh[p_idx + 21] * templateSh[462];
		conv += panelSh[p_idx + 37] * templateSh[461];
		conv += panelSh[p_idx + 38] * templateSh[460];
		conv += panelSh[p_idx + 39] * templateSh[459];
		conv += panelSh[p_idx + 40] * templateSh[458];
		conv += panelSh[p_idx + 41] * templateSh[457];
		conv += panelSh[p_idx + 42] * templateSh[456];
		conv += panelSh[p_idx + 43] * templateSh[455];
		conv += panelSh[p_idx + 44] * templateSh[454];
		conv += panelSh[p_idx + 45] * templateSh[453];
		conv += panelSh[p_idx + 46] * templateSh[452];
		conv += panelSh[p_idx + 47] * templateSh[451];
		conv += panelSh[p_idx + 48] * templateSh[450];
		conv += panelSh[p_idx + 49] * templateSh[449];
		conv += panelSh[p_idx + 50] * templateSh[448];
		conv += panelSh[p_idx + 51] * templateSh[447];
		conv += panelSh[p_idx + 52] * templateSh[446];
		conv += panelSh[p_idx + 53] * templateSh[445];
		conv += panelSh[p_idx + 54] * templateSh[444];
		conv += panelSh[p_idx + 55] * templateSh[443];
		conv += panelSh[p_idx + 56] * templateSh[442];
		conv += panelSh[p_idx + 57] * templateSh[441];
		conv += panelSh[p_idx + 58] * templateSh[440];
		conv += panelSh[p_idx + 74] * templateSh[439];
		conv += panelSh[p_idx + 75] * templateSh[438];
		conv += panelSh[p_idx + 76] * templateSh[437];
		conv += panelSh[p_idx + 77] * templateSh[436];
		conv += panelSh[p_idx + 78] * templateSh[435];
		conv += panelSh[p_idx + 79] * templateSh[434];
		conv += panelSh[p_idx + 80] * templateSh[433];
		conv += panelSh[p_idx + 81] * templateSh[432];
		conv += panelSh[p_idx + 82] * templateSh[431];
		conv += panelSh[p_idx + 83] * templateSh[430];
		conv += panelSh[p_idx + 84] * templateSh[429];
		conv += panelSh[p_idx + 85] * templateSh[428];
		conv += panelSh[p_idx + 86] * templateSh[427];
		conv += panelSh[p_idx + 87] * templateSh[426];
		conv += panelSh[p_idx + 88] * templateSh[425];
		conv += panelSh[p_idx + 89] * templateSh[424];
		conv += panelSh[p_idx + 90] * templateSh[423];
		conv += panelSh[p_idx + 91] * templateSh[422];
		conv += panelSh[p_idx + 92] * templateSh[421];
		conv += panelSh[p_idx + 93] * templateSh[420];
		conv += panelSh[p_idx + 94] * templateSh[419];
		conv += panelSh[p_idx + 95] * templateSh[418];
		conv += panelSh[p_idx + 111] * templateSh[417];
		conv += panelSh[p_idx + 112] * templateSh[416];
		conv += panelSh[p_idx + 113] * templateSh[415];
		conv += panelSh[p_idx + 114] * templateSh[414];
		conv += panelSh[p_idx + 115] * templateSh[413];
		conv += panelSh[p_idx + 116] * templateSh[412];
		conv += panelSh[p_idx + 117] * templateSh[411];
		conv += panelSh[p_idx + 118] * templateSh[410];
		conv += panelSh[p_idx + 119] * templateSh[409];
		conv += panelSh[p_idx + 120] * templateSh[408];
		conv += panelSh[p_idx + 121] * templateSh[407];
		conv += panelSh[p_idx + 122] * templateSh[406];
		conv += panelSh[p_idx + 123] * templateSh[405];
		conv += panelSh[p_idx + 124] * templateSh[404];
		conv += panelSh[p_idx + 125] * templateSh[403];
		conv += panelSh[p_idx + 126] * templateSh[402];
		conv += panelSh[p_idx + 127] * templateSh[401];
		conv += panelSh[p_idx + 128] * templateSh[400];
		conv += panelSh[p_idx + 129] * templateSh[399];
		conv += panelSh[p_idx + 130] * templateSh[398];
		conv += panelSh[p_idx + 131] * templateSh[397];
		conv += panelSh[p_idx + 132] * templateSh[396];
		conv += panelSh[p_idx + 148] * templateSh[395];
		conv += panelSh[p_idx + 149] * templateSh[394];
		conv += panelSh[p_idx + 150] * templateSh[393];
		conv += panelSh[p_idx + 151] * templateSh[392];
		conv += panelSh[p_idx + 152] * templateSh[391];
		conv += panelSh[p_idx + 153] * templateSh[390];
		conv += panelSh[p_idx + 154] * templateSh[389];
		conv += panelSh[p_idx + 155] * templateSh[388];
		conv += panelSh[p_idx + 156] * templateSh[387];
		conv += panelSh[p_idx + 157] * templateSh[386];
		conv += panelSh[p_idx + 158] * templateSh[385];
		conv += panelSh[p_idx + 159] * templateSh[384];
		conv += panelSh[p_idx + 160] * templateSh[383];
		conv += panelSh[p_idx + 161] * templateSh[382];
		conv += panelSh[p_idx + 162] * templateSh[381];
		conv += panelSh[p_idx + 163] * templateSh[380];
		conv += panelSh[p_idx + 164] * templateSh[379];
		conv += panelSh[p_idx + 165] * templateSh[378];
		conv += panelSh[p_idx + 166] * templateSh[377];
		conv += panelSh[p_idx + 167] * templateSh[376];
		conv += panelSh[p_idx + 168] * templateSh[375];
		conv += panelSh[p_idx + 169] * templateSh[374];
		conv += panelSh[p_idx + 185] * templateSh[373];
		conv += panelSh[p_idx + 186] * templateSh[372];
		conv += panelSh[p_idx + 187] * templateSh[371];
		conv += panelSh[p_idx + 188] * templateSh[370];
		conv += panelSh[p_idx + 189] * templateSh[369];
		conv += panelSh[p_idx + 190] * templateSh[368];
		conv += panelSh[p_idx + 191] * templateSh[367];
		conv += panelSh[p_idx + 192] * templateSh[366];
		conv += panelSh[p_idx + 193] * templateSh[365];
		conv += panelSh[p_idx + 194] * templateSh[364];
		conv += panelSh[p_idx + 195] * templateSh[363];
		conv += panelSh[p_idx + 196] * templateSh[362];
		conv += panelSh[p_idx + 197] * templateSh[361];
		conv += panelSh[p_idx + 198] * templateSh[360];
		conv += panelSh[p_idx + 199] * templateSh[359];
		conv += panelSh[p_idx + 200] * templateSh[358];
		conv += panelSh[p_idx + 201] * templateSh[357];
		conv += panelSh[p_idx + 202] * templateSh[356];
		conv += panelSh[p_idx + 203] * templateSh[355];
		conv += panelSh[p_idx + 204] * templateSh[354];
		conv += panelSh[p_idx + 205] * templateSh[353];
		conv += panelSh[p_idx + 206] * templateSh[352];
		conv += panelSh[p_idx + 222] * templateSh[351];
		conv += panelSh[p_idx + 223] * templateSh[350];
		conv += panelSh[p_idx + 224] * templateSh[349];
		conv += panelSh[p_idx + 225] * templateSh[348];
		conv += panelSh[p_idx + 226] * templateSh[347];
		conv += panelSh[p_idx + 227] * templateSh[346];
		conv += panelSh[p_idx + 228] * templateSh[345];
		conv += panelSh[p_idx + 229] * templateSh[344];
		conv += panelSh[p_idx + 230] * templateSh[343];
		conv += panelSh[p_idx + 231] * templateSh[342];
		conv += panelSh[p_idx + 232] * templateSh[341];
		conv += panelSh[p_idx + 233] * templateSh[340];
		conv += panelSh[p_idx + 234] * templateSh[339];
		conv += panelSh[p_idx + 235] * templateSh[338];
		conv += panelSh[p_idx + 236] * templateSh[337];
		conv += panelSh[p_idx + 237] * templateSh[336];
		conv += panelSh[p_idx + 238] * templateSh[335];
		conv += panelSh[p_idx + 239] * templateSh[334];
		conv += panelSh[p_idx + 240] * templateSh[333];
		conv += panelSh[p_idx + 241] * templateSh[332];
		conv += panelSh[p_idx + 242] * templateSh[331];
		conv += panelSh[p_idx + 243] * templateSh[330];
		conv += panelSh[p_idx + 259] * templateSh[329];
		conv += panelSh[p_idx + 260] * templateSh[328];
		conv += panelSh[p_idx + 261] * templateSh[327];
		conv += panelSh[p_idx + 262] * templateSh[326];
		conv += panelSh[p_idx + 263] * templateSh[325];
		conv += panelSh[p_idx + 264] * templateSh[324];
		conv += panelSh[p_idx + 265] * templateSh[323];
		conv += panelSh[p_idx + 266] * templateSh[322];
		conv += panelSh[p_idx + 267] * templateSh[321];
		conv += panelSh[p_idx + 268] * templateSh[320];
		conv += panelSh[p_idx + 269] * templateSh[319];
		conv += panelSh[p_idx + 270] * templateSh[318];
		conv += panelSh[p_idx + 271] * templateSh[317];
		conv += panelSh[p_idx + 272] * templateSh[316];
		conv += panelSh[p_idx + 273] * templateSh[315];
		conv += panelSh[p_idx + 274] * templateSh[314];
		conv += panelSh[p_idx + 275] * templateSh[313];
		conv += panelSh[p_idx + 276] * templateSh[312];
		conv += panelSh[p_idx + 277] * templateSh[311];
		conv += panelSh[p_idx + 278] * templateSh[310];
		conv += panelSh[p_idx + 279] * templateSh[309];
		conv += panelSh[p_idx + 280] * templateSh[308];
		conv += panelSh[p_idx + 296] * templateSh[307];
		conv += panelSh[p_idx + 297] * templateSh[306];
		conv += panelSh[p_idx + 298] * templateSh[305];
		conv += panelSh[p_idx + 299] * templateSh[304];
		conv += panelSh[p_idx + 300] * templateSh[303];
		conv += panelSh[p_idx + 301] * templateSh[302];
		conv += panelSh[p_idx + 302] * templateSh[301];
		conv += panelSh[p_idx + 303] * templateSh[300];
		conv += panelSh[p_idx + 304] * templateSh[299];
		conv += panelSh[p_idx + 305] * templateSh[298];
		conv += panelSh[p_idx + 306] * templateSh[297];
		conv += panelSh[p_idx + 307] * templateSh[296];
		conv += panelSh[p_idx + 308] * templateSh[295];
		conv += panelSh[p_idx + 309] * templateSh[294];
		conv += panelSh[p_idx + 310] * templateSh[293];
		conv += panelSh[p_idx + 311] * templateSh[292];
		conv += panelSh[p_idx + 312] * templateSh[291];
		conv += panelSh[p_idx + 313] * templateSh[290];
		conv += panelSh[p_idx + 314] * templateSh[289];
		conv += panelSh[p_idx + 315] * templateSh[288];
		conv += panelSh[p_idx + 316] * templateSh[287];
		conv += panelSh[p_idx + 317] * templateSh[286];
		conv += panelSh[p_idx + 333] * templateSh[285];
		conv += panelSh[p_idx + 334] * templateSh[284];
		conv += panelSh[p_idx + 335] * templateSh[283];
		conv += panelSh[p_idx + 336] * templateSh[282];
		conv += panelSh[p_idx + 337] * templateSh[281];
		conv += panelSh[p_idx + 338] * templateSh[280];
		conv += panelSh[p_idx + 339] * templateSh[279];
		conv += panelSh[p_idx + 340] * templateSh[278];
		conv += panelSh[p_idx + 341] * templateSh[277];
		conv += panelSh[p_idx + 342] * templateSh[276];
		conv += panelSh[p_idx + 343] * templateSh[275];
		conv += panelSh[p_idx + 344] * templateSh[274];
		conv += panelSh[p_idx + 345] * templateSh[273];
		conv += panelSh[p_idx + 346] * templateSh[272];
		conv += panelSh[p_idx + 347] * templateSh[271];
		conv += panelSh[p_idx + 348] * templateSh[270];
		conv += panelSh[p_idx + 349] * templateSh[269];
		conv += panelSh[p_idx + 350] * templateSh[268];
		conv += panelSh[p_idx + 351] * templateSh[267];
		conv += panelSh[p_idx + 352] * templateSh[266];
		conv += panelSh[p_idx + 353] * templateSh[265];
		conv += panelSh[p_idx + 354] * templateSh[264];
		conv += panelSh[p_idx + 370] * templateSh[263];
		conv += panelSh[p_idx + 371] * templateSh[262];
		conv += panelSh[p_idx + 372] * templateSh[261];
		conv += panelSh[p_idx + 373] * templateSh[260];
		conv += panelSh[p_idx + 374] * templateSh[259];
		conv += panelSh[p_idx + 375] * templateSh[258];
		conv += panelSh[p_idx + 376] * templateSh[257];
		conv += panelSh[p_idx + 377] * templateSh[256];
		conv += panelSh[p_idx + 378] * templateSh[255];
		conv += panelSh[p_idx + 379] * templateSh[254];
		conv += panelSh[p_idx + 380] * templateSh[253];
		conv += panelSh[p_idx + 381] * templateSh[252];
		conv += panelSh[p_idx + 382] * templateSh[251];
		conv += panelSh[p_idx + 383] * templateSh[250];
		conv += panelSh[p_idx + 384] * templateSh[249];
		conv += panelSh[p_idx + 385] * templateSh[248];
		conv += panelSh[p_idx + 386] * templateSh[247];
		conv += panelSh[p_idx + 387] * templateSh[246];
		conv += panelSh[p_idx + 388] * templateSh[245];
		conv += panelSh[p_idx + 389] * templateSh[244];
		conv += panelSh[p_idx + 390] * templateSh[243];
		conv += panelSh[p_idx + 391] * templateSh[242];
		conv += panelSh[p_idx + 407] * templateSh[241];
		conv += panelSh[p_idx + 408] * templateSh[240];
		conv += panelSh[p_idx + 409] * templateSh[239];
		conv += panelSh[p_idx + 410] * templateSh[238];
		conv += panelSh[p_idx + 411] * templateSh[237];
		conv += panelSh[p_idx + 412] * templateSh[236];
		conv += panelSh[p_idx + 413] * templateSh[235];
		conv += panelSh[p_idx + 414] * templateSh[234];
		conv += panelSh[p_idx + 415] * templateSh[233];
		conv += panelSh[p_idx + 416] * templateSh[232];
		conv += panelSh[p_idx + 417] * templateSh[231];
		conv += panelSh[p_idx + 418] * templateSh[230];
		conv += panelSh[p_idx + 419] * templateSh[229];
		conv += panelSh[p_idx + 420] * templateSh[228];
		conv += panelSh[p_idx + 421] * templateSh[227];
		conv += panelSh[p_idx + 422] * templateSh[226];
		conv += panelSh[p_idx + 423] * templateSh[225];
		conv += panelSh[p_idx + 424] * templateSh[224];
		conv += panelSh[p_idx + 425] * templateSh[223];
		conv += panelSh[p_idx + 426] * templateSh[222];
		conv += panelSh[p_idx + 427] * templateSh[221];
		conv += panelSh[p_idx + 428] * templateSh[220];
		conv += panelSh[p_idx + 444] * templateSh[219];
		conv += panelSh[p_idx + 445] * templateSh[218];
		conv += panelSh[p_idx + 446] * templateSh[217];
		conv += panelSh[p_idx + 447] * templateSh[216];
		conv += panelSh[p_idx + 448] * templateSh[215];
		conv += panelSh[p_idx + 449] * templateSh[214];
		conv += panelSh[p_idx + 450] * templateSh[213];
		conv += panelSh[p_idx + 451] * templateSh[212];
		conv += panelSh[p_idx + 452] * templateSh[211];
		conv += panelSh[p_idx + 453] * templateSh[210];
		conv += panelSh[p_idx + 454] * templateSh[209];
		conv += panelSh[p_idx + 455] * templateSh[208];
		conv += panelSh[p_idx + 456] * templateSh[207];
		conv += panelSh[p_idx + 457] * templateSh[206];
		conv += panelSh[p_idx + 458] * templateSh[205];
		conv += panelSh[p_idx + 459] * templateSh[204];
		conv += panelSh[p_idx + 460] * templateSh[203];
		conv += panelSh[p_idx + 461] * templateSh[202];
		conv += panelSh[p_idx + 462] * templateSh[201];
		conv += panelSh[p_idx + 463] * templateSh[200];
		conv += panelSh[p_idx + 464] * templateSh[199];
		conv += panelSh[p_idx + 465] * templateSh[198];
		conv += panelSh[p_idx + 481] * templateSh[197];
		conv += panelSh[p_idx + 482] * templateSh[196];
		conv += panelSh[p_idx + 483] * templateSh[195];
		conv += panelSh[p_idx + 484] * templateSh[194];
		conv += panelSh[p_idx + 485] * templateSh[193];
		conv += panelSh[p_idx + 486] * templateSh[192];
		conv += panelSh[p_idx + 487] * templateSh[191];
		conv += panelSh[p_idx + 488] * templateSh[190];
		conv += panelSh[p_idx + 489] * templateSh[189];
		conv += panelSh[p_idx + 490] * templateSh[188];
		conv += panelSh[p_idx + 491] * templateSh[187];
		conv += panelSh[p_idx + 492] * templateSh[186];
		conv += panelSh[p_idx + 493] * templateSh[185];
		conv += panelSh[p_idx + 494] * templateSh[184];
		conv += panelSh[p_idx + 495] * templateSh[183];
		conv += panelSh[p_idx + 496] * templateSh[182];
		conv += panelSh[p_idx + 497] * templateSh[181];
		conv += panelSh[p_idx + 498] * templateSh[180];
		conv += panelSh[p_idx + 499] * templateSh[179];
		conv += panelSh[p_idx + 500] * templateSh[178];
		conv += panelSh[p_idx + 501] * templateSh[177];
		conv += panelSh[p_idx + 502] * templateSh[176];
		conv += panelSh[p_idx + 518] * templateSh[175];
		conv += panelSh[p_idx + 519] * templateSh[174];
		conv += panelSh[p_idx + 520] * templateSh[173];
		conv += panelSh[p_idx + 521] * templateSh[172];
		conv += panelSh[p_idx + 522] * templateSh[171];
		conv += panelSh[p_idx + 523] * templateSh[170];
		conv += panelSh[p_idx + 524] * templateSh[169];
		conv += panelSh[p_idx + 525] * templateSh[168];
		conv += panelSh[p_idx + 526] * templateSh[167];
		conv += panelSh[p_idx + 527] * templateSh[166];
		conv += panelSh[p_idx + 528] * templateSh[165];
		conv += panelSh[p_idx + 529] * templateSh[164];
		conv += panelSh[p_idx + 530] * templateSh[163];
		conv += panelSh[p_idx + 531] * templateSh[162];
		conv += panelSh[p_idx + 532] * templateSh[161];
		conv += panelSh[p_idx + 533] * templateSh[160];
		conv += panelSh[p_idx + 534] * templateSh[159];
		conv += panelSh[p_idx + 535] * templateSh[158];
		conv += panelSh[p_idx + 536] * templateSh[157];
		conv += panelSh[p_idx + 537] * templateSh[156];
		conv += panelSh[p_idx + 538] * templateSh[155];
		conv += panelSh[p_idx + 539] * templateSh[154];
		conv += panelSh[p_idx + 555] * templateSh[153];
		conv += panelSh[p_idx + 556] * templateSh[152];
		conv += panelSh[p_idx + 557] * templateSh[151];
		conv += panelSh[p_idx + 558] * templateSh[150];
		conv += panelSh[p_idx + 559] * templateSh[149];
		conv += panelSh[p_idx + 560] * templateSh[148];
		conv += panelSh[p_idx + 561] * templateSh[147];
		conv += panelSh[p_idx + 562] * templateSh[146];
		conv += panelSh[p_idx + 563] * templateSh[145];
		conv += panelSh[p_idx + 564] * templateSh[144];
		conv += panelSh[p_idx + 565] * templateSh[143];
		conv += panelSh[p_idx + 566] * templateSh[142];
		conv += panelSh[p_idx + 567] * templateSh[141];
		conv += panelSh[p_idx + 568] * templateSh[140];
		conv += panelSh[p_idx + 569] * templateSh[139];
		conv += panelSh[p_idx + 570] * templateSh[138];
		conv += panelSh[p_idx + 571] * templateSh[137];
		conv += panelSh[p_idx + 572] * templateSh[136];
		conv += panelSh[p_idx + 573] * templateSh[135];
		conv += panelSh[p_idx + 574] * templateSh[134];
		conv += panelSh[p_idx + 575] * templateSh[133];
		conv += panelSh[p_idx + 576] * templateSh[132];
		conv += panelSh[p_idx + 592] * templateSh[131];
		conv += panelSh[p_idx + 593] * templateSh[130];
		conv += panelSh[p_idx + 594] * templateSh[129];
		conv += panelSh[p_idx + 595] * templateSh[128];
		conv += panelSh[p_idx + 596] * templateSh[127];
		conv += panelSh[p_idx + 597] * templateSh[126];
		conv += panelSh[p_idx + 598] * templateSh[125];
		conv += panelSh[p_idx + 599] * templateSh[124];
		conv += panelSh[p_idx + 600] * templateSh[123];
		conv += panelSh[p_idx + 601] * templateSh[122];
		conv += panelSh[p_idx + 602] * templateSh[121];
		conv += panelSh[p_idx + 603] * templateSh[120];
		conv += panelSh[p_idx + 604] * templateSh[119];
		conv += panelSh[p_idx + 605] * templateSh[118];
		conv += panelSh[p_idx + 606] * templateSh[117];
		conv += panelSh[p_idx + 607] * templateSh[116];
		conv += panelSh[p_idx + 608] * templateSh[115];
		conv += panelSh[p_idx + 609] * templateSh[114];
		conv += panelSh[p_idx + 610] * templateSh[113];
		conv += panelSh[p_idx + 611] * templateSh[112];
		conv += panelSh[p_idx + 612] * templateSh[111];
		conv += panelSh[p_idx + 613] * templateSh[110];
		conv += panelSh[p_idx + 629] * templateSh[109];
		conv += panelSh[p_idx + 630] * templateSh[108];
		conv += panelSh[p_idx + 631] * templateSh[107];
		conv += panelSh[p_idx + 632] * templateSh[106];
		conv += panelSh[p_idx + 633] * templateSh[105];
		conv += panelSh[p_idx + 634] * templateSh[104];
		conv += panelSh[p_idx + 635] * templateSh[103];
		conv += panelSh[p_idx + 636] * templateSh[102];
		conv += panelSh[p_idx + 637] * templateSh[101];
		conv += panelSh[p_idx + 638] * templateSh[100];
		conv += panelSh[p_idx + 639] * templateSh[99];
		conv += panelSh[p_idx + 640] * templateSh[98];
		conv += panelSh[p_idx + 641] * templateSh[97];
		conv += panelSh[p_idx + 642] * templateSh[96];
		conv += panelSh[p_idx + 643] * templateSh[95];
		conv += panelSh[p_idx + 644] * templateSh[94];
		conv += panelSh[p_idx + 645] * templateSh[93];
		conv += panelSh[p_idx + 646] * templateSh[92];
		conv += panelSh[p_idx + 647] * templateSh[91];
		conv += panelSh[p_idx + 648] * templateSh[90];
		conv += panelSh[p_idx + 649] * templateSh[89];
		conv += panelSh[p_idx + 650] * templateSh[88];
		conv += panelSh[p_idx + 666] * templateSh[87];
		conv += panelSh[p_idx + 667] * templateSh[86];
		conv += panelSh[p_idx + 668] * templateSh[85];
		conv += panelSh[p_idx + 669] * templateSh[84];
		conv += panelSh[p_idx + 670] * templateSh[83];
		conv += panelSh[p_idx + 671] * templateSh[82];
		conv += panelSh[p_idx + 672] * templateSh[81];
		conv += panelSh[p_idx + 673] * templateSh[80];
		conv += panelSh[p_idx + 674] * templateSh[79];
		conv += panelSh[p_idx + 675] * templateSh[78];
		conv += panelSh[p_idx + 676] * templateSh[77];
		conv += panelSh[p_idx + 677] * templateSh[76];
		conv += panelSh[p_idx + 678] * templateSh[75];
		conv += panelSh[p_idx + 679] * templateSh[74];
		conv += panelSh[p_idx + 680] * templateSh[73];
		conv += panelSh[p_idx + 681] * templateSh[72];
		conv += panelSh[p_idx + 682] * templateSh[71];
		conv += panelSh[p_idx + 683] * templateSh[70];
		conv += panelSh[p_idx + 684] * templateSh[69];
		conv += panelSh[p_idx + 685] * templateSh[68];
		conv += panelSh[p_idx + 686] * templateSh[67];
		conv += panelSh[p_idx + 687] * templateSh[66];
		conv += panelSh[p_idx + 703] * templateSh[65];
		conv += panelSh[p_idx + 704] * templateSh[64];
		conv += panelSh[p_idx + 705] * templateSh[63];
		conv += panelSh[p_idx + 706] * templateSh[62];
		conv += panelSh[p_idx + 707] * templateSh[61];
		conv += panelSh[p_idx + 708] * templateSh[60];
		conv += panelSh[p_idx + 709] * templateSh[59];
		conv += panelSh[p_idx + 710] * templateSh[58];
		conv += panelSh[p_idx + 711] * templateSh[57];
		conv += panelSh[p_idx + 712] * templateSh[56];
		conv += panelSh[p_idx + 713] * templateSh[55];
		conv += panelSh[p_idx + 714] * templateSh[54];
		conv += panelSh[p_idx + 715] * templateSh[53];
		conv += panelSh[p_idx + 716] * templateSh[52];
		conv += panelSh[p_idx + 717] * templateSh[51];
		conv += panelSh[p_idx + 718] * templateSh[50];
		conv += panelSh[p_idx + 719] * templateSh[49];
		conv += panelSh[p_idx + 720] * templateSh[48];
		conv += panelSh[p_idx + 721] * templateSh[47];
		conv += panelSh[p_idx + 722] * templateSh[46];
		conv += panelSh[p_idx + 723] * templateSh[45];
		conv += panelSh[p_idx + 724] * templateSh[44];
		conv += panelSh[p_idx + 740] * templateSh[43];
		conv += panelSh[p_idx + 741] * templateSh[42];
		conv += panelSh[p_idx + 742] * templateSh[41];
		conv += panelSh[p_idx + 743] * templateSh[40];
		conv += panelSh[p_idx + 744] * templateSh[39];
		conv += panelSh[p_idx + 745] * templateSh[38];
		conv += panelSh[p_idx + 746] * templateSh[37];
		conv += panelSh[p_idx + 747] * templateSh[36];
		conv += panelSh[p_idx + 748] * templateSh[35];
		conv += panelSh[p_idx + 749] * templateSh[34];
		conv += panelSh[p_idx + 750] * templateSh[33];
		conv += panelSh[p_idx + 751] * templateSh[32];
		conv += panelSh[p_idx + 752] * templateSh[31];
		conv += panelSh[p_idx + 753] * templateSh[30];
		conv += panelSh[p_idx + 754] * templateSh[29];
		conv += panelSh[p_idx + 755] * templateSh[28];
		conv += panelSh[p_idx + 756] * templateSh[27];
		conv += panelSh[p_idx + 757] * templateSh[26];
		conv += panelSh[p_idx + 758] * templateSh[25];
		conv += panelSh[p_idx + 759] * templateSh[24];
		conv += panelSh[p_idx + 760] * templateSh[23];
		conv += panelSh[p_idx + 761] * templateSh[22];
		conv += panelSh[p_idx + 777] * templateSh[21];
		conv += panelSh[p_idx + 778] * templateSh[20];
		conv += panelSh[p_idx + 779] * templateSh[19];
		conv += panelSh[p_idx + 780] * templateSh[18];
		conv += panelSh[p_idx + 781] * templateSh[17];
		conv += panelSh[p_idx + 782] * templateSh[16];
		conv += panelSh[p_idx + 783] * templateSh[15];
		conv += panelSh[p_idx + 784] * templateSh[14];
		conv += panelSh[p_idx + 785] * templateSh[13];
		conv += panelSh[p_idx + 786] * templateSh[12];
		conv += panelSh[p_idx + 787] * templateSh[11];
		conv += panelSh[p_idx + 788] * templateSh[10];
		conv += panelSh[p_idx + 789] * templateSh[9];
		conv += panelSh[p_idx + 790] * templateSh[8];
		conv += panelSh[p_idx + 791] * templateSh[7];
		conv += panelSh[p_idx + 792] * templateSh[6];
		conv += panelSh[p_idx + 793] * templateSh[5];
		conv += panelSh[p_idx + 794] * templateSh[4];
		conv += panelSh[p_idx + 795] * templateSh[3];
		conv += panelSh[p_idx + 796] * templateSh[2];
		conv += panelSh[p_idx + 797] * templateSh[1];
		conv += panelSh[p_idx + 798] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_22x22<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_22x22<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_23x23 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1444];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<38; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<38; i+=16) {
			panelSh[IMUL(j, 38) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[529];
	for (int j=threadIdx.y; j<23; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<23; i+=16) {
			const int jtwi = IMUL(j, 23) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 38);
		conv += panelSh[p_idx + 0] * templateSh[528];
		conv += panelSh[p_idx + 1] * templateSh[527];
		conv += panelSh[p_idx + 2] * templateSh[526];
		conv += panelSh[p_idx + 3] * templateSh[525];
		conv += panelSh[p_idx + 4] * templateSh[524];
		conv += panelSh[p_idx + 5] * templateSh[523];
		conv += panelSh[p_idx + 6] * templateSh[522];
		conv += panelSh[p_idx + 7] * templateSh[521];
		conv += panelSh[p_idx + 8] * templateSh[520];
		conv += panelSh[p_idx + 9] * templateSh[519];
		conv += panelSh[p_idx + 10] * templateSh[518];
		conv += panelSh[p_idx + 11] * templateSh[517];
		conv += panelSh[p_idx + 12] * templateSh[516];
		conv += panelSh[p_idx + 13] * templateSh[515];
		conv += panelSh[p_idx + 14] * templateSh[514];
		conv += panelSh[p_idx + 15] * templateSh[513];
		conv += panelSh[p_idx + 16] * templateSh[512];
		conv += panelSh[p_idx + 17] * templateSh[511];
		conv += panelSh[p_idx + 18] * templateSh[510];
		conv += panelSh[p_idx + 19] * templateSh[509];
		conv += panelSh[p_idx + 20] * templateSh[508];
		conv += panelSh[p_idx + 21] * templateSh[507];
		conv += panelSh[p_idx + 22] * templateSh[506];
		conv += panelSh[p_idx + 38] * templateSh[505];
		conv += panelSh[p_idx + 39] * templateSh[504];
		conv += panelSh[p_idx + 40] * templateSh[503];
		conv += panelSh[p_idx + 41] * templateSh[502];
		conv += panelSh[p_idx + 42] * templateSh[501];
		conv += panelSh[p_idx + 43] * templateSh[500];
		conv += panelSh[p_idx + 44] * templateSh[499];
		conv += panelSh[p_idx + 45] * templateSh[498];
		conv += panelSh[p_idx + 46] * templateSh[497];
		conv += panelSh[p_idx + 47] * templateSh[496];
		conv += panelSh[p_idx + 48] * templateSh[495];
		conv += panelSh[p_idx + 49] * templateSh[494];
		conv += panelSh[p_idx + 50] * templateSh[493];
		conv += panelSh[p_idx + 51] * templateSh[492];
		conv += panelSh[p_idx + 52] * templateSh[491];
		conv += panelSh[p_idx + 53] * templateSh[490];
		conv += panelSh[p_idx + 54] * templateSh[489];
		conv += panelSh[p_idx + 55] * templateSh[488];
		conv += panelSh[p_idx + 56] * templateSh[487];
		conv += panelSh[p_idx + 57] * templateSh[486];
		conv += panelSh[p_idx + 58] * templateSh[485];
		conv += panelSh[p_idx + 59] * templateSh[484];
		conv += panelSh[p_idx + 60] * templateSh[483];
		conv += panelSh[p_idx + 76] * templateSh[482];
		conv += panelSh[p_idx + 77] * templateSh[481];
		conv += panelSh[p_idx + 78] * templateSh[480];
		conv += panelSh[p_idx + 79] * templateSh[479];
		conv += panelSh[p_idx + 80] * templateSh[478];
		conv += panelSh[p_idx + 81] * templateSh[477];
		conv += panelSh[p_idx + 82] * templateSh[476];
		conv += panelSh[p_idx + 83] * templateSh[475];
		conv += panelSh[p_idx + 84] * templateSh[474];
		conv += panelSh[p_idx + 85] * templateSh[473];
		conv += panelSh[p_idx + 86] * templateSh[472];
		conv += panelSh[p_idx + 87] * templateSh[471];
		conv += panelSh[p_idx + 88] * templateSh[470];
		conv += panelSh[p_idx + 89] * templateSh[469];
		conv += panelSh[p_idx + 90] * templateSh[468];
		conv += panelSh[p_idx + 91] * templateSh[467];
		conv += panelSh[p_idx + 92] * templateSh[466];
		conv += panelSh[p_idx + 93] * templateSh[465];
		conv += panelSh[p_idx + 94] * templateSh[464];
		conv += panelSh[p_idx + 95] * templateSh[463];
		conv += panelSh[p_idx + 96] * templateSh[462];
		conv += panelSh[p_idx + 97] * templateSh[461];
		conv += panelSh[p_idx + 98] * templateSh[460];
		conv += panelSh[p_idx + 114] * templateSh[459];
		conv += panelSh[p_idx + 115] * templateSh[458];
		conv += panelSh[p_idx + 116] * templateSh[457];
		conv += panelSh[p_idx + 117] * templateSh[456];
		conv += panelSh[p_idx + 118] * templateSh[455];
		conv += panelSh[p_idx + 119] * templateSh[454];
		conv += panelSh[p_idx + 120] * templateSh[453];
		conv += panelSh[p_idx + 121] * templateSh[452];
		conv += panelSh[p_idx + 122] * templateSh[451];
		conv += panelSh[p_idx + 123] * templateSh[450];
		conv += panelSh[p_idx + 124] * templateSh[449];
		conv += panelSh[p_idx + 125] * templateSh[448];
		conv += panelSh[p_idx + 126] * templateSh[447];
		conv += panelSh[p_idx + 127] * templateSh[446];
		conv += panelSh[p_idx + 128] * templateSh[445];
		conv += panelSh[p_idx + 129] * templateSh[444];
		conv += panelSh[p_idx + 130] * templateSh[443];
		conv += panelSh[p_idx + 131] * templateSh[442];
		conv += panelSh[p_idx + 132] * templateSh[441];
		conv += panelSh[p_idx + 133] * templateSh[440];
		conv += panelSh[p_idx + 134] * templateSh[439];
		conv += panelSh[p_idx + 135] * templateSh[438];
		conv += panelSh[p_idx + 136] * templateSh[437];
		conv += panelSh[p_idx + 152] * templateSh[436];
		conv += panelSh[p_idx + 153] * templateSh[435];
		conv += panelSh[p_idx + 154] * templateSh[434];
		conv += panelSh[p_idx + 155] * templateSh[433];
		conv += panelSh[p_idx + 156] * templateSh[432];
		conv += panelSh[p_idx + 157] * templateSh[431];
		conv += panelSh[p_idx + 158] * templateSh[430];
		conv += panelSh[p_idx + 159] * templateSh[429];
		conv += panelSh[p_idx + 160] * templateSh[428];
		conv += panelSh[p_idx + 161] * templateSh[427];
		conv += panelSh[p_idx + 162] * templateSh[426];
		conv += panelSh[p_idx + 163] * templateSh[425];
		conv += panelSh[p_idx + 164] * templateSh[424];
		conv += panelSh[p_idx + 165] * templateSh[423];
		conv += panelSh[p_idx + 166] * templateSh[422];
		conv += panelSh[p_idx + 167] * templateSh[421];
		conv += panelSh[p_idx + 168] * templateSh[420];
		conv += panelSh[p_idx + 169] * templateSh[419];
		conv += panelSh[p_idx + 170] * templateSh[418];
		conv += panelSh[p_idx + 171] * templateSh[417];
		conv += panelSh[p_idx + 172] * templateSh[416];
		conv += panelSh[p_idx + 173] * templateSh[415];
		conv += panelSh[p_idx + 174] * templateSh[414];
		conv += panelSh[p_idx + 190] * templateSh[413];
		conv += panelSh[p_idx + 191] * templateSh[412];
		conv += panelSh[p_idx + 192] * templateSh[411];
		conv += panelSh[p_idx + 193] * templateSh[410];
		conv += panelSh[p_idx + 194] * templateSh[409];
		conv += panelSh[p_idx + 195] * templateSh[408];
		conv += panelSh[p_idx + 196] * templateSh[407];
		conv += panelSh[p_idx + 197] * templateSh[406];
		conv += panelSh[p_idx + 198] * templateSh[405];
		conv += panelSh[p_idx + 199] * templateSh[404];
		conv += panelSh[p_idx + 200] * templateSh[403];
		conv += panelSh[p_idx + 201] * templateSh[402];
		conv += panelSh[p_idx + 202] * templateSh[401];
		conv += panelSh[p_idx + 203] * templateSh[400];
		conv += panelSh[p_idx + 204] * templateSh[399];
		conv += panelSh[p_idx + 205] * templateSh[398];
		conv += panelSh[p_idx + 206] * templateSh[397];
		conv += panelSh[p_idx + 207] * templateSh[396];
		conv += panelSh[p_idx + 208] * templateSh[395];
		conv += panelSh[p_idx + 209] * templateSh[394];
		conv += panelSh[p_idx + 210] * templateSh[393];
		conv += panelSh[p_idx + 211] * templateSh[392];
		conv += panelSh[p_idx + 212] * templateSh[391];
		conv += panelSh[p_idx + 228] * templateSh[390];
		conv += panelSh[p_idx + 229] * templateSh[389];
		conv += panelSh[p_idx + 230] * templateSh[388];
		conv += panelSh[p_idx + 231] * templateSh[387];
		conv += panelSh[p_idx + 232] * templateSh[386];
		conv += panelSh[p_idx + 233] * templateSh[385];
		conv += panelSh[p_idx + 234] * templateSh[384];
		conv += panelSh[p_idx + 235] * templateSh[383];
		conv += panelSh[p_idx + 236] * templateSh[382];
		conv += panelSh[p_idx + 237] * templateSh[381];
		conv += panelSh[p_idx + 238] * templateSh[380];
		conv += panelSh[p_idx + 239] * templateSh[379];
		conv += panelSh[p_idx + 240] * templateSh[378];
		conv += panelSh[p_idx + 241] * templateSh[377];
		conv += panelSh[p_idx + 242] * templateSh[376];
		conv += panelSh[p_idx + 243] * templateSh[375];
		conv += panelSh[p_idx + 244] * templateSh[374];
		conv += panelSh[p_idx + 245] * templateSh[373];
		conv += panelSh[p_idx + 246] * templateSh[372];
		conv += panelSh[p_idx + 247] * templateSh[371];
		conv += panelSh[p_idx + 248] * templateSh[370];
		conv += panelSh[p_idx + 249] * templateSh[369];
		conv += panelSh[p_idx + 250] * templateSh[368];
		conv += panelSh[p_idx + 266] * templateSh[367];
		conv += panelSh[p_idx + 267] * templateSh[366];
		conv += panelSh[p_idx + 268] * templateSh[365];
		conv += panelSh[p_idx + 269] * templateSh[364];
		conv += panelSh[p_idx + 270] * templateSh[363];
		conv += panelSh[p_idx + 271] * templateSh[362];
		conv += panelSh[p_idx + 272] * templateSh[361];
		conv += panelSh[p_idx + 273] * templateSh[360];
		conv += panelSh[p_idx + 274] * templateSh[359];
		conv += panelSh[p_idx + 275] * templateSh[358];
		conv += panelSh[p_idx + 276] * templateSh[357];
		conv += panelSh[p_idx + 277] * templateSh[356];
		conv += panelSh[p_idx + 278] * templateSh[355];
		conv += panelSh[p_idx + 279] * templateSh[354];
		conv += panelSh[p_idx + 280] * templateSh[353];
		conv += panelSh[p_idx + 281] * templateSh[352];
		conv += panelSh[p_idx + 282] * templateSh[351];
		conv += panelSh[p_idx + 283] * templateSh[350];
		conv += panelSh[p_idx + 284] * templateSh[349];
		conv += panelSh[p_idx + 285] * templateSh[348];
		conv += panelSh[p_idx + 286] * templateSh[347];
		conv += panelSh[p_idx + 287] * templateSh[346];
		conv += panelSh[p_idx + 288] * templateSh[345];
		conv += panelSh[p_idx + 304] * templateSh[344];
		conv += panelSh[p_idx + 305] * templateSh[343];
		conv += panelSh[p_idx + 306] * templateSh[342];
		conv += panelSh[p_idx + 307] * templateSh[341];
		conv += panelSh[p_idx + 308] * templateSh[340];
		conv += panelSh[p_idx + 309] * templateSh[339];
		conv += panelSh[p_idx + 310] * templateSh[338];
		conv += panelSh[p_idx + 311] * templateSh[337];
		conv += panelSh[p_idx + 312] * templateSh[336];
		conv += panelSh[p_idx + 313] * templateSh[335];
		conv += panelSh[p_idx + 314] * templateSh[334];
		conv += panelSh[p_idx + 315] * templateSh[333];
		conv += panelSh[p_idx + 316] * templateSh[332];
		conv += panelSh[p_idx + 317] * templateSh[331];
		conv += panelSh[p_idx + 318] * templateSh[330];
		conv += panelSh[p_idx + 319] * templateSh[329];
		conv += panelSh[p_idx + 320] * templateSh[328];
		conv += panelSh[p_idx + 321] * templateSh[327];
		conv += panelSh[p_idx + 322] * templateSh[326];
		conv += panelSh[p_idx + 323] * templateSh[325];
		conv += panelSh[p_idx + 324] * templateSh[324];
		conv += panelSh[p_idx + 325] * templateSh[323];
		conv += panelSh[p_idx + 326] * templateSh[322];
		conv += panelSh[p_idx + 342] * templateSh[321];
		conv += panelSh[p_idx + 343] * templateSh[320];
		conv += panelSh[p_idx + 344] * templateSh[319];
		conv += panelSh[p_idx + 345] * templateSh[318];
		conv += panelSh[p_idx + 346] * templateSh[317];
		conv += panelSh[p_idx + 347] * templateSh[316];
		conv += panelSh[p_idx + 348] * templateSh[315];
		conv += panelSh[p_idx + 349] * templateSh[314];
		conv += panelSh[p_idx + 350] * templateSh[313];
		conv += panelSh[p_idx + 351] * templateSh[312];
		conv += panelSh[p_idx + 352] * templateSh[311];
		conv += panelSh[p_idx + 353] * templateSh[310];
		conv += panelSh[p_idx + 354] * templateSh[309];
		conv += panelSh[p_idx + 355] * templateSh[308];
		conv += panelSh[p_idx + 356] * templateSh[307];
		conv += panelSh[p_idx + 357] * templateSh[306];
		conv += panelSh[p_idx + 358] * templateSh[305];
		conv += panelSh[p_idx + 359] * templateSh[304];
		conv += panelSh[p_idx + 360] * templateSh[303];
		conv += panelSh[p_idx + 361] * templateSh[302];
		conv += panelSh[p_idx + 362] * templateSh[301];
		conv += panelSh[p_idx + 363] * templateSh[300];
		conv += panelSh[p_idx + 364] * templateSh[299];
		conv += panelSh[p_idx + 380] * templateSh[298];
		conv += panelSh[p_idx + 381] * templateSh[297];
		conv += panelSh[p_idx + 382] * templateSh[296];
		conv += panelSh[p_idx + 383] * templateSh[295];
		conv += panelSh[p_idx + 384] * templateSh[294];
		conv += panelSh[p_idx + 385] * templateSh[293];
		conv += panelSh[p_idx + 386] * templateSh[292];
		conv += panelSh[p_idx + 387] * templateSh[291];
		conv += panelSh[p_idx + 388] * templateSh[290];
		conv += panelSh[p_idx + 389] * templateSh[289];
		conv += panelSh[p_idx + 390] * templateSh[288];
		conv += panelSh[p_idx + 391] * templateSh[287];
		conv += panelSh[p_idx + 392] * templateSh[286];
		conv += panelSh[p_idx + 393] * templateSh[285];
		conv += panelSh[p_idx + 394] * templateSh[284];
		conv += panelSh[p_idx + 395] * templateSh[283];
		conv += panelSh[p_idx + 396] * templateSh[282];
		conv += panelSh[p_idx + 397] * templateSh[281];
		conv += panelSh[p_idx + 398] * templateSh[280];
		conv += panelSh[p_idx + 399] * templateSh[279];
		conv += panelSh[p_idx + 400] * templateSh[278];
		conv += panelSh[p_idx + 401] * templateSh[277];
		conv += panelSh[p_idx + 402] * templateSh[276];
		conv += panelSh[p_idx + 418] * templateSh[275];
		conv += panelSh[p_idx + 419] * templateSh[274];
		conv += panelSh[p_idx + 420] * templateSh[273];
		conv += panelSh[p_idx + 421] * templateSh[272];
		conv += panelSh[p_idx + 422] * templateSh[271];
		conv += panelSh[p_idx + 423] * templateSh[270];
		conv += panelSh[p_idx + 424] * templateSh[269];
		conv += panelSh[p_idx + 425] * templateSh[268];
		conv += panelSh[p_idx + 426] * templateSh[267];
		conv += panelSh[p_idx + 427] * templateSh[266];
		conv += panelSh[p_idx + 428] * templateSh[265];
		conv += panelSh[p_idx + 429] * templateSh[264];
		conv += panelSh[p_idx + 430] * templateSh[263];
		conv += panelSh[p_idx + 431] * templateSh[262];
		conv += panelSh[p_idx + 432] * templateSh[261];
		conv += panelSh[p_idx + 433] * templateSh[260];
		conv += panelSh[p_idx + 434] * templateSh[259];
		conv += panelSh[p_idx + 435] * templateSh[258];
		conv += panelSh[p_idx + 436] * templateSh[257];
		conv += panelSh[p_idx + 437] * templateSh[256];
		conv += panelSh[p_idx + 438] * templateSh[255];
		conv += panelSh[p_idx + 439] * templateSh[254];
		conv += panelSh[p_idx + 440] * templateSh[253];
		conv += panelSh[p_idx + 456] * templateSh[252];
		conv += panelSh[p_idx + 457] * templateSh[251];
		conv += panelSh[p_idx + 458] * templateSh[250];
		conv += panelSh[p_idx + 459] * templateSh[249];
		conv += panelSh[p_idx + 460] * templateSh[248];
		conv += panelSh[p_idx + 461] * templateSh[247];
		conv += panelSh[p_idx + 462] * templateSh[246];
		conv += panelSh[p_idx + 463] * templateSh[245];
		conv += panelSh[p_idx + 464] * templateSh[244];
		conv += panelSh[p_idx + 465] * templateSh[243];
		conv += panelSh[p_idx + 466] * templateSh[242];
		conv += panelSh[p_idx + 467] * templateSh[241];
		conv += panelSh[p_idx + 468] * templateSh[240];
		conv += panelSh[p_idx + 469] * templateSh[239];
		conv += panelSh[p_idx + 470] * templateSh[238];
		conv += panelSh[p_idx + 471] * templateSh[237];
		conv += panelSh[p_idx + 472] * templateSh[236];
		conv += panelSh[p_idx + 473] * templateSh[235];
		conv += panelSh[p_idx + 474] * templateSh[234];
		conv += panelSh[p_idx + 475] * templateSh[233];
		conv += panelSh[p_idx + 476] * templateSh[232];
		conv += panelSh[p_idx + 477] * templateSh[231];
		conv += panelSh[p_idx + 478] * templateSh[230];
		conv += panelSh[p_idx + 494] * templateSh[229];
		conv += panelSh[p_idx + 495] * templateSh[228];
		conv += panelSh[p_idx + 496] * templateSh[227];
		conv += panelSh[p_idx + 497] * templateSh[226];
		conv += panelSh[p_idx + 498] * templateSh[225];
		conv += panelSh[p_idx + 499] * templateSh[224];
		conv += panelSh[p_idx + 500] * templateSh[223];
		conv += panelSh[p_idx + 501] * templateSh[222];
		conv += panelSh[p_idx + 502] * templateSh[221];
		conv += panelSh[p_idx + 503] * templateSh[220];
		conv += panelSh[p_idx + 504] * templateSh[219];
		conv += panelSh[p_idx + 505] * templateSh[218];
		conv += panelSh[p_idx + 506] * templateSh[217];
		conv += panelSh[p_idx + 507] * templateSh[216];
		conv += panelSh[p_idx + 508] * templateSh[215];
		conv += panelSh[p_idx + 509] * templateSh[214];
		conv += panelSh[p_idx + 510] * templateSh[213];
		conv += panelSh[p_idx + 511] * templateSh[212];
		conv += panelSh[p_idx + 512] * templateSh[211];
		conv += panelSh[p_idx + 513] * templateSh[210];
		conv += panelSh[p_idx + 514] * templateSh[209];
		conv += panelSh[p_idx + 515] * templateSh[208];
		conv += panelSh[p_idx + 516] * templateSh[207];
		conv += panelSh[p_idx + 532] * templateSh[206];
		conv += panelSh[p_idx + 533] * templateSh[205];
		conv += panelSh[p_idx + 534] * templateSh[204];
		conv += panelSh[p_idx + 535] * templateSh[203];
		conv += panelSh[p_idx + 536] * templateSh[202];
		conv += panelSh[p_idx + 537] * templateSh[201];
		conv += panelSh[p_idx + 538] * templateSh[200];
		conv += panelSh[p_idx + 539] * templateSh[199];
		conv += panelSh[p_idx + 540] * templateSh[198];
		conv += panelSh[p_idx + 541] * templateSh[197];
		conv += panelSh[p_idx + 542] * templateSh[196];
		conv += panelSh[p_idx + 543] * templateSh[195];
		conv += panelSh[p_idx + 544] * templateSh[194];
		conv += panelSh[p_idx + 545] * templateSh[193];
		conv += panelSh[p_idx + 546] * templateSh[192];
		conv += panelSh[p_idx + 547] * templateSh[191];
		conv += panelSh[p_idx + 548] * templateSh[190];
		conv += panelSh[p_idx + 549] * templateSh[189];
		conv += panelSh[p_idx + 550] * templateSh[188];
		conv += panelSh[p_idx + 551] * templateSh[187];
		conv += panelSh[p_idx + 552] * templateSh[186];
		conv += panelSh[p_idx + 553] * templateSh[185];
		conv += panelSh[p_idx + 554] * templateSh[184];
		conv += panelSh[p_idx + 570] * templateSh[183];
		conv += panelSh[p_idx + 571] * templateSh[182];
		conv += panelSh[p_idx + 572] * templateSh[181];
		conv += panelSh[p_idx + 573] * templateSh[180];
		conv += panelSh[p_idx + 574] * templateSh[179];
		conv += panelSh[p_idx + 575] * templateSh[178];
		conv += panelSh[p_idx + 576] * templateSh[177];
		conv += panelSh[p_idx + 577] * templateSh[176];
		conv += panelSh[p_idx + 578] * templateSh[175];
		conv += panelSh[p_idx + 579] * templateSh[174];
		conv += panelSh[p_idx + 580] * templateSh[173];
		conv += panelSh[p_idx + 581] * templateSh[172];
		conv += panelSh[p_idx + 582] * templateSh[171];
		conv += panelSh[p_idx + 583] * templateSh[170];
		conv += panelSh[p_idx + 584] * templateSh[169];
		conv += panelSh[p_idx + 585] * templateSh[168];
		conv += panelSh[p_idx + 586] * templateSh[167];
		conv += panelSh[p_idx + 587] * templateSh[166];
		conv += panelSh[p_idx + 588] * templateSh[165];
		conv += panelSh[p_idx + 589] * templateSh[164];
		conv += panelSh[p_idx + 590] * templateSh[163];
		conv += panelSh[p_idx + 591] * templateSh[162];
		conv += panelSh[p_idx + 592] * templateSh[161];
		conv += panelSh[p_idx + 608] * templateSh[160];
		conv += panelSh[p_idx + 609] * templateSh[159];
		conv += panelSh[p_idx + 610] * templateSh[158];
		conv += panelSh[p_idx + 611] * templateSh[157];
		conv += panelSh[p_idx + 612] * templateSh[156];
		conv += panelSh[p_idx + 613] * templateSh[155];
		conv += panelSh[p_idx + 614] * templateSh[154];
		conv += panelSh[p_idx + 615] * templateSh[153];
		conv += panelSh[p_idx + 616] * templateSh[152];
		conv += panelSh[p_idx + 617] * templateSh[151];
		conv += panelSh[p_idx + 618] * templateSh[150];
		conv += panelSh[p_idx + 619] * templateSh[149];
		conv += panelSh[p_idx + 620] * templateSh[148];
		conv += panelSh[p_idx + 621] * templateSh[147];
		conv += panelSh[p_idx + 622] * templateSh[146];
		conv += panelSh[p_idx + 623] * templateSh[145];
		conv += panelSh[p_idx + 624] * templateSh[144];
		conv += panelSh[p_idx + 625] * templateSh[143];
		conv += panelSh[p_idx + 626] * templateSh[142];
		conv += panelSh[p_idx + 627] * templateSh[141];
		conv += panelSh[p_idx + 628] * templateSh[140];
		conv += panelSh[p_idx + 629] * templateSh[139];
		conv += panelSh[p_idx + 630] * templateSh[138];
		conv += panelSh[p_idx + 646] * templateSh[137];
		conv += panelSh[p_idx + 647] * templateSh[136];
		conv += panelSh[p_idx + 648] * templateSh[135];
		conv += panelSh[p_idx + 649] * templateSh[134];
		conv += panelSh[p_idx + 650] * templateSh[133];
		conv += panelSh[p_idx + 651] * templateSh[132];
		conv += panelSh[p_idx + 652] * templateSh[131];
		conv += panelSh[p_idx + 653] * templateSh[130];
		conv += panelSh[p_idx + 654] * templateSh[129];
		conv += panelSh[p_idx + 655] * templateSh[128];
		conv += panelSh[p_idx + 656] * templateSh[127];
		conv += panelSh[p_idx + 657] * templateSh[126];
		conv += panelSh[p_idx + 658] * templateSh[125];
		conv += panelSh[p_idx + 659] * templateSh[124];
		conv += panelSh[p_idx + 660] * templateSh[123];
		conv += panelSh[p_idx + 661] * templateSh[122];
		conv += panelSh[p_idx + 662] * templateSh[121];
		conv += panelSh[p_idx + 663] * templateSh[120];
		conv += panelSh[p_idx + 664] * templateSh[119];
		conv += panelSh[p_idx + 665] * templateSh[118];
		conv += panelSh[p_idx + 666] * templateSh[117];
		conv += panelSh[p_idx + 667] * templateSh[116];
		conv += panelSh[p_idx + 668] * templateSh[115];
		conv += panelSh[p_idx + 684] * templateSh[114];
		conv += panelSh[p_idx + 685] * templateSh[113];
		conv += panelSh[p_idx + 686] * templateSh[112];
		conv += panelSh[p_idx + 687] * templateSh[111];
		conv += panelSh[p_idx + 688] * templateSh[110];
		conv += panelSh[p_idx + 689] * templateSh[109];
		conv += panelSh[p_idx + 690] * templateSh[108];
		conv += panelSh[p_idx + 691] * templateSh[107];
		conv += panelSh[p_idx + 692] * templateSh[106];
		conv += panelSh[p_idx + 693] * templateSh[105];
		conv += panelSh[p_idx + 694] * templateSh[104];
		conv += panelSh[p_idx + 695] * templateSh[103];
		conv += panelSh[p_idx + 696] * templateSh[102];
		conv += panelSh[p_idx + 697] * templateSh[101];
		conv += panelSh[p_idx + 698] * templateSh[100];
		conv += panelSh[p_idx + 699] * templateSh[99];
		conv += panelSh[p_idx + 700] * templateSh[98];
		conv += panelSh[p_idx + 701] * templateSh[97];
		conv += panelSh[p_idx + 702] * templateSh[96];
		conv += panelSh[p_idx + 703] * templateSh[95];
		conv += panelSh[p_idx + 704] * templateSh[94];
		conv += panelSh[p_idx + 705] * templateSh[93];
		conv += panelSh[p_idx + 706] * templateSh[92];
		conv += panelSh[p_idx + 722] * templateSh[91];
		conv += panelSh[p_idx + 723] * templateSh[90];
		conv += panelSh[p_idx + 724] * templateSh[89];
		conv += panelSh[p_idx + 725] * templateSh[88];
		conv += panelSh[p_idx + 726] * templateSh[87];
		conv += panelSh[p_idx + 727] * templateSh[86];
		conv += panelSh[p_idx + 728] * templateSh[85];
		conv += panelSh[p_idx + 729] * templateSh[84];
		conv += panelSh[p_idx + 730] * templateSh[83];
		conv += panelSh[p_idx + 731] * templateSh[82];
		conv += panelSh[p_idx + 732] * templateSh[81];
		conv += panelSh[p_idx + 733] * templateSh[80];
		conv += panelSh[p_idx + 734] * templateSh[79];
		conv += panelSh[p_idx + 735] * templateSh[78];
		conv += panelSh[p_idx + 736] * templateSh[77];
		conv += panelSh[p_idx + 737] * templateSh[76];
		conv += panelSh[p_idx + 738] * templateSh[75];
		conv += panelSh[p_idx + 739] * templateSh[74];
		conv += panelSh[p_idx + 740] * templateSh[73];
		conv += panelSh[p_idx + 741] * templateSh[72];
		conv += panelSh[p_idx + 742] * templateSh[71];
		conv += panelSh[p_idx + 743] * templateSh[70];
		conv += panelSh[p_idx + 744] * templateSh[69];
		conv += panelSh[p_idx + 760] * templateSh[68];
		conv += panelSh[p_idx + 761] * templateSh[67];
		conv += panelSh[p_idx + 762] * templateSh[66];
		conv += panelSh[p_idx + 763] * templateSh[65];
		conv += panelSh[p_idx + 764] * templateSh[64];
		conv += panelSh[p_idx + 765] * templateSh[63];
		conv += panelSh[p_idx + 766] * templateSh[62];
		conv += panelSh[p_idx + 767] * templateSh[61];
		conv += panelSh[p_idx + 768] * templateSh[60];
		conv += panelSh[p_idx + 769] * templateSh[59];
		conv += panelSh[p_idx + 770] * templateSh[58];
		conv += panelSh[p_idx + 771] * templateSh[57];
		conv += panelSh[p_idx + 772] * templateSh[56];
		conv += panelSh[p_idx + 773] * templateSh[55];
		conv += panelSh[p_idx + 774] * templateSh[54];
		conv += panelSh[p_idx + 775] * templateSh[53];
		conv += panelSh[p_idx + 776] * templateSh[52];
		conv += panelSh[p_idx + 777] * templateSh[51];
		conv += panelSh[p_idx + 778] * templateSh[50];
		conv += panelSh[p_idx + 779] * templateSh[49];
		conv += panelSh[p_idx + 780] * templateSh[48];
		conv += panelSh[p_idx + 781] * templateSh[47];
		conv += panelSh[p_idx + 782] * templateSh[46];
		conv += panelSh[p_idx + 798] * templateSh[45];
		conv += panelSh[p_idx + 799] * templateSh[44];
		conv += panelSh[p_idx + 800] * templateSh[43];
		conv += panelSh[p_idx + 801] * templateSh[42];
		conv += panelSh[p_idx + 802] * templateSh[41];
		conv += panelSh[p_idx + 803] * templateSh[40];
		conv += panelSh[p_idx + 804] * templateSh[39];
		conv += panelSh[p_idx + 805] * templateSh[38];
		conv += panelSh[p_idx + 806] * templateSh[37];
		conv += panelSh[p_idx + 807] * templateSh[36];
		conv += panelSh[p_idx + 808] * templateSh[35];
		conv += panelSh[p_idx + 809] * templateSh[34];
		conv += panelSh[p_idx + 810] * templateSh[33];
		conv += panelSh[p_idx + 811] * templateSh[32];
		conv += panelSh[p_idx + 812] * templateSh[31];
		conv += panelSh[p_idx + 813] * templateSh[30];
		conv += panelSh[p_idx + 814] * templateSh[29];
		conv += panelSh[p_idx + 815] * templateSh[28];
		conv += panelSh[p_idx + 816] * templateSh[27];
		conv += panelSh[p_idx + 817] * templateSh[26];
		conv += panelSh[p_idx + 818] * templateSh[25];
		conv += panelSh[p_idx + 819] * templateSh[24];
		conv += panelSh[p_idx + 820] * templateSh[23];
		conv += panelSh[p_idx + 836] * templateSh[22];
		conv += panelSh[p_idx + 837] * templateSh[21];
		conv += panelSh[p_idx + 838] * templateSh[20];
		conv += panelSh[p_idx + 839] * templateSh[19];
		conv += panelSh[p_idx + 840] * templateSh[18];
		conv += panelSh[p_idx + 841] * templateSh[17];
		conv += panelSh[p_idx + 842] * templateSh[16];
		conv += panelSh[p_idx + 843] * templateSh[15];
		conv += panelSh[p_idx + 844] * templateSh[14];
		conv += panelSh[p_idx + 845] * templateSh[13];
		conv += panelSh[p_idx + 846] * templateSh[12];
		conv += panelSh[p_idx + 847] * templateSh[11];
		conv += panelSh[p_idx + 848] * templateSh[10];
		conv += panelSh[p_idx + 849] * templateSh[9];
		conv += panelSh[p_idx + 850] * templateSh[8];
		conv += panelSh[p_idx + 851] * templateSh[7];
		conv += panelSh[p_idx + 852] * templateSh[6];
		conv += panelSh[p_idx + 853] * templateSh[5];
		conv += panelSh[p_idx + 854] * templateSh[4];
		conv += panelSh[p_idx + 855] * templateSh[3];
		conv += panelSh[p_idx + 856] * templateSh[2];
		conv += panelSh[p_idx + 857] * templateSh[1];
		conv += panelSh[p_idx + 858] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_23x23<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_23x23<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_24x24 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1521];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<39; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<39; i+=16) {
			panelSh[IMUL(j, 39) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[576];
	for (int j=threadIdx.y; j<24; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<24; i+=16) {
			const int jtwi = IMUL(j, 24) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 39);
		conv += panelSh[p_idx + 0] * templateSh[575];
		conv += panelSh[p_idx + 1] * templateSh[574];
		conv += panelSh[p_idx + 2] * templateSh[573];
		conv += panelSh[p_idx + 3] * templateSh[572];
		conv += panelSh[p_idx + 4] * templateSh[571];
		conv += panelSh[p_idx + 5] * templateSh[570];
		conv += panelSh[p_idx + 6] * templateSh[569];
		conv += panelSh[p_idx + 7] * templateSh[568];
		conv += panelSh[p_idx + 8] * templateSh[567];
		conv += panelSh[p_idx + 9] * templateSh[566];
		conv += panelSh[p_idx + 10] * templateSh[565];
		conv += panelSh[p_idx + 11] * templateSh[564];
		conv += panelSh[p_idx + 12] * templateSh[563];
		conv += panelSh[p_idx + 13] * templateSh[562];
		conv += panelSh[p_idx + 14] * templateSh[561];
		conv += panelSh[p_idx + 15] * templateSh[560];
		conv += panelSh[p_idx + 16] * templateSh[559];
		conv += panelSh[p_idx + 17] * templateSh[558];
		conv += panelSh[p_idx + 18] * templateSh[557];
		conv += panelSh[p_idx + 19] * templateSh[556];
		conv += panelSh[p_idx + 20] * templateSh[555];
		conv += panelSh[p_idx + 21] * templateSh[554];
		conv += panelSh[p_idx + 22] * templateSh[553];
		conv += panelSh[p_idx + 23] * templateSh[552];
		conv += panelSh[p_idx + 39] * templateSh[551];
		conv += panelSh[p_idx + 40] * templateSh[550];
		conv += panelSh[p_idx + 41] * templateSh[549];
		conv += panelSh[p_idx + 42] * templateSh[548];
		conv += panelSh[p_idx + 43] * templateSh[547];
		conv += panelSh[p_idx + 44] * templateSh[546];
		conv += panelSh[p_idx + 45] * templateSh[545];
		conv += panelSh[p_idx + 46] * templateSh[544];
		conv += panelSh[p_idx + 47] * templateSh[543];
		conv += panelSh[p_idx + 48] * templateSh[542];
		conv += panelSh[p_idx + 49] * templateSh[541];
		conv += panelSh[p_idx + 50] * templateSh[540];
		conv += panelSh[p_idx + 51] * templateSh[539];
		conv += panelSh[p_idx + 52] * templateSh[538];
		conv += panelSh[p_idx + 53] * templateSh[537];
		conv += panelSh[p_idx + 54] * templateSh[536];
		conv += panelSh[p_idx + 55] * templateSh[535];
		conv += panelSh[p_idx + 56] * templateSh[534];
		conv += panelSh[p_idx + 57] * templateSh[533];
		conv += panelSh[p_idx + 58] * templateSh[532];
		conv += panelSh[p_idx + 59] * templateSh[531];
		conv += panelSh[p_idx + 60] * templateSh[530];
		conv += panelSh[p_idx + 61] * templateSh[529];
		conv += panelSh[p_idx + 62] * templateSh[528];
		conv += panelSh[p_idx + 78] * templateSh[527];
		conv += panelSh[p_idx + 79] * templateSh[526];
		conv += panelSh[p_idx + 80] * templateSh[525];
		conv += panelSh[p_idx + 81] * templateSh[524];
		conv += panelSh[p_idx + 82] * templateSh[523];
		conv += panelSh[p_idx + 83] * templateSh[522];
		conv += panelSh[p_idx + 84] * templateSh[521];
		conv += panelSh[p_idx + 85] * templateSh[520];
		conv += panelSh[p_idx + 86] * templateSh[519];
		conv += panelSh[p_idx + 87] * templateSh[518];
		conv += panelSh[p_idx + 88] * templateSh[517];
		conv += panelSh[p_idx + 89] * templateSh[516];
		conv += panelSh[p_idx + 90] * templateSh[515];
		conv += panelSh[p_idx + 91] * templateSh[514];
		conv += panelSh[p_idx + 92] * templateSh[513];
		conv += panelSh[p_idx + 93] * templateSh[512];
		conv += panelSh[p_idx + 94] * templateSh[511];
		conv += panelSh[p_idx + 95] * templateSh[510];
		conv += panelSh[p_idx + 96] * templateSh[509];
		conv += panelSh[p_idx + 97] * templateSh[508];
		conv += panelSh[p_idx + 98] * templateSh[507];
		conv += panelSh[p_idx + 99] * templateSh[506];
		conv += panelSh[p_idx + 100] * templateSh[505];
		conv += panelSh[p_idx + 101] * templateSh[504];
		conv += panelSh[p_idx + 117] * templateSh[503];
		conv += panelSh[p_idx + 118] * templateSh[502];
		conv += panelSh[p_idx + 119] * templateSh[501];
		conv += panelSh[p_idx + 120] * templateSh[500];
		conv += panelSh[p_idx + 121] * templateSh[499];
		conv += panelSh[p_idx + 122] * templateSh[498];
		conv += panelSh[p_idx + 123] * templateSh[497];
		conv += panelSh[p_idx + 124] * templateSh[496];
		conv += panelSh[p_idx + 125] * templateSh[495];
		conv += panelSh[p_idx + 126] * templateSh[494];
		conv += panelSh[p_idx + 127] * templateSh[493];
		conv += panelSh[p_idx + 128] * templateSh[492];
		conv += panelSh[p_idx + 129] * templateSh[491];
		conv += panelSh[p_idx + 130] * templateSh[490];
		conv += panelSh[p_idx + 131] * templateSh[489];
		conv += panelSh[p_idx + 132] * templateSh[488];
		conv += panelSh[p_idx + 133] * templateSh[487];
		conv += panelSh[p_idx + 134] * templateSh[486];
		conv += panelSh[p_idx + 135] * templateSh[485];
		conv += panelSh[p_idx + 136] * templateSh[484];
		conv += panelSh[p_idx + 137] * templateSh[483];
		conv += panelSh[p_idx + 138] * templateSh[482];
		conv += panelSh[p_idx + 139] * templateSh[481];
		conv += panelSh[p_idx + 140] * templateSh[480];
		conv += panelSh[p_idx + 156] * templateSh[479];
		conv += panelSh[p_idx + 157] * templateSh[478];
		conv += panelSh[p_idx + 158] * templateSh[477];
		conv += panelSh[p_idx + 159] * templateSh[476];
		conv += panelSh[p_idx + 160] * templateSh[475];
		conv += panelSh[p_idx + 161] * templateSh[474];
		conv += panelSh[p_idx + 162] * templateSh[473];
		conv += panelSh[p_idx + 163] * templateSh[472];
		conv += panelSh[p_idx + 164] * templateSh[471];
		conv += panelSh[p_idx + 165] * templateSh[470];
		conv += panelSh[p_idx + 166] * templateSh[469];
		conv += panelSh[p_idx + 167] * templateSh[468];
		conv += panelSh[p_idx + 168] * templateSh[467];
		conv += panelSh[p_idx + 169] * templateSh[466];
		conv += panelSh[p_idx + 170] * templateSh[465];
		conv += panelSh[p_idx + 171] * templateSh[464];
		conv += panelSh[p_idx + 172] * templateSh[463];
		conv += panelSh[p_idx + 173] * templateSh[462];
		conv += panelSh[p_idx + 174] * templateSh[461];
		conv += panelSh[p_idx + 175] * templateSh[460];
		conv += panelSh[p_idx + 176] * templateSh[459];
		conv += panelSh[p_idx + 177] * templateSh[458];
		conv += panelSh[p_idx + 178] * templateSh[457];
		conv += panelSh[p_idx + 179] * templateSh[456];
		conv += panelSh[p_idx + 195] * templateSh[455];
		conv += panelSh[p_idx + 196] * templateSh[454];
		conv += panelSh[p_idx + 197] * templateSh[453];
		conv += panelSh[p_idx + 198] * templateSh[452];
		conv += panelSh[p_idx + 199] * templateSh[451];
		conv += panelSh[p_idx + 200] * templateSh[450];
		conv += panelSh[p_idx + 201] * templateSh[449];
		conv += panelSh[p_idx + 202] * templateSh[448];
		conv += panelSh[p_idx + 203] * templateSh[447];
		conv += panelSh[p_idx + 204] * templateSh[446];
		conv += panelSh[p_idx + 205] * templateSh[445];
		conv += panelSh[p_idx + 206] * templateSh[444];
		conv += panelSh[p_idx + 207] * templateSh[443];
		conv += panelSh[p_idx + 208] * templateSh[442];
		conv += panelSh[p_idx + 209] * templateSh[441];
		conv += panelSh[p_idx + 210] * templateSh[440];
		conv += panelSh[p_idx + 211] * templateSh[439];
		conv += panelSh[p_idx + 212] * templateSh[438];
		conv += panelSh[p_idx + 213] * templateSh[437];
		conv += panelSh[p_idx + 214] * templateSh[436];
		conv += panelSh[p_idx + 215] * templateSh[435];
		conv += panelSh[p_idx + 216] * templateSh[434];
		conv += panelSh[p_idx + 217] * templateSh[433];
		conv += panelSh[p_idx + 218] * templateSh[432];
		conv += panelSh[p_idx + 234] * templateSh[431];
		conv += panelSh[p_idx + 235] * templateSh[430];
		conv += panelSh[p_idx + 236] * templateSh[429];
		conv += panelSh[p_idx + 237] * templateSh[428];
		conv += panelSh[p_idx + 238] * templateSh[427];
		conv += panelSh[p_idx + 239] * templateSh[426];
		conv += panelSh[p_idx + 240] * templateSh[425];
		conv += panelSh[p_idx + 241] * templateSh[424];
		conv += panelSh[p_idx + 242] * templateSh[423];
		conv += panelSh[p_idx + 243] * templateSh[422];
		conv += panelSh[p_idx + 244] * templateSh[421];
		conv += panelSh[p_idx + 245] * templateSh[420];
		conv += panelSh[p_idx + 246] * templateSh[419];
		conv += panelSh[p_idx + 247] * templateSh[418];
		conv += panelSh[p_idx + 248] * templateSh[417];
		conv += panelSh[p_idx + 249] * templateSh[416];
		conv += panelSh[p_idx + 250] * templateSh[415];
		conv += panelSh[p_idx + 251] * templateSh[414];
		conv += panelSh[p_idx + 252] * templateSh[413];
		conv += panelSh[p_idx + 253] * templateSh[412];
		conv += panelSh[p_idx + 254] * templateSh[411];
		conv += panelSh[p_idx + 255] * templateSh[410];
		conv += panelSh[p_idx + 256] * templateSh[409];
		conv += panelSh[p_idx + 257] * templateSh[408];
		conv += panelSh[p_idx + 273] * templateSh[407];
		conv += panelSh[p_idx + 274] * templateSh[406];
		conv += panelSh[p_idx + 275] * templateSh[405];
		conv += panelSh[p_idx + 276] * templateSh[404];
		conv += panelSh[p_idx + 277] * templateSh[403];
		conv += panelSh[p_idx + 278] * templateSh[402];
		conv += panelSh[p_idx + 279] * templateSh[401];
		conv += panelSh[p_idx + 280] * templateSh[400];
		conv += panelSh[p_idx + 281] * templateSh[399];
		conv += panelSh[p_idx + 282] * templateSh[398];
		conv += panelSh[p_idx + 283] * templateSh[397];
		conv += panelSh[p_idx + 284] * templateSh[396];
		conv += panelSh[p_idx + 285] * templateSh[395];
		conv += panelSh[p_idx + 286] * templateSh[394];
		conv += panelSh[p_idx + 287] * templateSh[393];
		conv += panelSh[p_idx + 288] * templateSh[392];
		conv += panelSh[p_idx + 289] * templateSh[391];
		conv += panelSh[p_idx + 290] * templateSh[390];
		conv += panelSh[p_idx + 291] * templateSh[389];
		conv += panelSh[p_idx + 292] * templateSh[388];
		conv += panelSh[p_idx + 293] * templateSh[387];
		conv += panelSh[p_idx + 294] * templateSh[386];
		conv += panelSh[p_idx + 295] * templateSh[385];
		conv += panelSh[p_idx + 296] * templateSh[384];
		conv += panelSh[p_idx + 312] * templateSh[383];
		conv += panelSh[p_idx + 313] * templateSh[382];
		conv += panelSh[p_idx + 314] * templateSh[381];
		conv += panelSh[p_idx + 315] * templateSh[380];
		conv += panelSh[p_idx + 316] * templateSh[379];
		conv += panelSh[p_idx + 317] * templateSh[378];
		conv += panelSh[p_idx + 318] * templateSh[377];
		conv += panelSh[p_idx + 319] * templateSh[376];
		conv += panelSh[p_idx + 320] * templateSh[375];
		conv += panelSh[p_idx + 321] * templateSh[374];
		conv += panelSh[p_idx + 322] * templateSh[373];
		conv += panelSh[p_idx + 323] * templateSh[372];
		conv += panelSh[p_idx + 324] * templateSh[371];
		conv += panelSh[p_idx + 325] * templateSh[370];
		conv += panelSh[p_idx + 326] * templateSh[369];
		conv += panelSh[p_idx + 327] * templateSh[368];
		conv += panelSh[p_idx + 328] * templateSh[367];
		conv += panelSh[p_idx + 329] * templateSh[366];
		conv += panelSh[p_idx + 330] * templateSh[365];
		conv += panelSh[p_idx + 331] * templateSh[364];
		conv += panelSh[p_idx + 332] * templateSh[363];
		conv += panelSh[p_idx + 333] * templateSh[362];
		conv += panelSh[p_idx + 334] * templateSh[361];
		conv += panelSh[p_idx + 335] * templateSh[360];
		conv += panelSh[p_idx + 351] * templateSh[359];
		conv += panelSh[p_idx + 352] * templateSh[358];
		conv += panelSh[p_idx + 353] * templateSh[357];
		conv += panelSh[p_idx + 354] * templateSh[356];
		conv += panelSh[p_idx + 355] * templateSh[355];
		conv += panelSh[p_idx + 356] * templateSh[354];
		conv += panelSh[p_idx + 357] * templateSh[353];
		conv += panelSh[p_idx + 358] * templateSh[352];
		conv += panelSh[p_idx + 359] * templateSh[351];
		conv += panelSh[p_idx + 360] * templateSh[350];
		conv += panelSh[p_idx + 361] * templateSh[349];
		conv += panelSh[p_idx + 362] * templateSh[348];
		conv += panelSh[p_idx + 363] * templateSh[347];
		conv += panelSh[p_idx + 364] * templateSh[346];
		conv += panelSh[p_idx + 365] * templateSh[345];
		conv += panelSh[p_idx + 366] * templateSh[344];
		conv += panelSh[p_idx + 367] * templateSh[343];
		conv += panelSh[p_idx + 368] * templateSh[342];
		conv += panelSh[p_idx + 369] * templateSh[341];
		conv += panelSh[p_idx + 370] * templateSh[340];
		conv += panelSh[p_idx + 371] * templateSh[339];
		conv += panelSh[p_idx + 372] * templateSh[338];
		conv += panelSh[p_idx + 373] * templateSh[337];
		conv += panelSh[p_idx + 374] * templateSh[336];
		conv += panelSh[p_idx + 390] * templateSh[335];
		conv += panelSh[p_idx + 391] * templateSh[334];
		conv += panelSh[p_idx + 392] * templateSh[333];
		conv += panelSh[p_idx + 393] * templateSh[332];
		conv += panelSh[p_idx + 394] * templateSh[331];
		conv += panelSh[p_idx + 395] * templateSh[330];
		conv += panelSh[p_idx + 396] * templateSh[329];
		conv += panelSh[p_idx + 397] * templateSh[328];
		conv += panelSh[p_idx + 398] * templateSh[327];
		conv += panelSh[p_idx + 399] * templateSh[326];
		conv += panelSh[p_idx + 400] * templateSh[325];
		conv += panelSh[p_idx + 401] * templateSh[324];
		conv += panelSh[p_idx + 402] * templateSh[323];
		conv += panelSh[p_idx + 403] * templateSh[322];
		conv += panelSh[p_idx + 404] * templateSh[321];
		conv += panelSh[p_idx + 405] * templateSh[320];
		conv += panelSh[p_idx + 406] * templateSh[319];
		conv += panelSh[p_idx + 407] * templateSh[318];
		conv += panelSh[p_idx + 408] * templateSh[317];
		conv += panelSh[p_idx + 409] * templateSh[316];
		conv += panelSh[p_idx + 410] * templateSh[315];
		conv += panelSh[p_idx + 411] * templateSh[314];
		conv += panelSh[p_idx + 412] * templateSh[313];
		conv += panelSh[p_idx + 413] * templateSh[312];
		conv += panelSh[p_idx + 429] * templateSh[311];
		conv += panelSh[p_idx + 430] * templateSh[310];
		conv += panelSh[p_idx + 431] * templateSh[309];
		conv += panelSh[p_idx + 432] * templateSh[308];
		conv += panelSh[p_idx + 433] * templateSh[307];
		conv += panelSh[p_idx + 434] * templateSh[306];
		conv += panelSh[p_idx + 435] * templateSh[305];
		conv += panelSh[p_idx + 436] * templateSh[304];
		conv += panelSh[p_idx + 437] * templateSh[303];
		conv += panelSh[p_idx + 438] * templateSh[302];
		conv += panelSh[p_idx + 439] * templateSh[301];
		conv += panelSh[p_idx + 440] * templateSh[300];
		conv += panelSh[p_idx + 441] * templateSh[299];
		conv += panelSh[p_idx + 442] * templateSh[298];
		conv += panelSh[p_idx + 443] * templateSh[297];
		conv += panelSh[p_idx + 444] * templateSh[296];
		conv += panelSh[p_idx + 445] * templateSh[295];
		conv += panelSh[p_idx + 446] * templateSh[294];
		conv += panelSh[p_idx + 447] * templateSh[293];
		conv += panelSh[p_idx + 448] * templateSh[292];
		conv += panelSh[p_idx + 449] * templateSh[291];
		conv += panelSh[p_idx + 450] * templateSh[290];
		conv += panelSh[p_idx + 451] * templateSh[289];
		conv += panelSh[p_idx + 452] * templateSh[288];
		conv += panelSh[p_idx + 468] * templateSh[287];
		conv += panelSh[p_idx + 469] * templateSh[286];
		conv += panelSh[p_idx + 470] * templateSh[285];
		conv += panelSh[p_idx + 471] * templateSh[284];
		conv += panelSh[p_idx + 472] * templateSh[283];
		conv += panelSh[p_idx + 473] * templateSh[282];
		conv += panelSh[p_idx + 474] * templateSh[281];
		conv += panelSh[p_idx + 475] * templateSh[280];
		conv += panelSh[p_idx + 476] * templateSh[279];
		conv += panelSh[p_idx + 477] * templateSh[278];
		conv += panelSh[p_idx + 478] * templateSh[277];
		conv += panelSh[p_idx + 479] * templateSh[276];
		conv += panelSh[p_idx + 480] * templateSh[275];
		conv += panelSh[p_idx + 481] * templateSh[274];
		conv += panelSh[p_idx + 482] * templateSh[273];
		conv += panelSh[p_idx + 483] * templateSh[272];
		conv += panelSh[p_idx + 484] * templateSh[271];
		conv += panelSh[p_idx + 485] * templateSh[270];
		conv += panelSh[p_idx + 486] * templateSh[269];
		conv += panelSh[p_idx + 487] * templateSh[268];
		conv += panelSh[p_idx + 488] * templateSh[267];
		conv += panelSh[p_idx + 489] * templateSh[266];
		conv += panelSh[p_idx + 490] * templateSh[265];
		conv += panelSh[p_idx + 491] * templateSh[264];
		conv += panelSh[p_idx + 507] * templateSh[263];
		conv += panelSh[p_idx + 508] * templateSh[262];
		conv += panelSh[p_idx + 509] * templateSh[261];
		conv += panelSh[p_idx + 510] * templateSh[260];
		conv += panelSh[p_idx + 511] * templateSh[259];
		conv += panelSh[p_idx + 512] * templateSh[258];
		conv += panelSh[p_idx + 513] * templateSh[257];
		conv += panelSh[p_idx + 514] * templateSh[256];
		conv += panelSh[p_idx + 515] * templateSh[255];
		conv += panelSh[p_idx + 516] * templateSh[254];
		conv += panelSh[p_idx + 517] * templateSh[253];
		conv += panelSh[p_idx + 518] * templateSh[252];
		conv += panelSh[p_idx + 519] * templateSh[251];
		conv += panelSh[p_idx + 520] * templateSh[250];
		conv += panelSh[p_idx + 521] * templateSh[249];
		conv += panelSh[p_idx + 522] * templateSh[248];
		conv += panelSh[p_idx + 523] * templateSh[247];
		conv += panelSh[p_idx + 524] * templateSh[246];
		conv += panelSh[p_idx + 525] * templateSh[245];
		conv += panelSh[p_idx + 526] * templateSh[244];
		conv += panelSh[p_idx + 527] * templateSh[243];
		conv += panelSh[p_idx + 528] * templateSh[242];
		conv += panelSh[p_idx + 529] * templateSh[241];
		conv += panelSh[p_idx + 530] * templateSh[240];
		conv += panelSh[p_idx + 546] * templateSh[239];
		conv += panelSh[p_idx + 547] * templateSh[238];
		conv += panelSh[p_idx + 548] * templateSh[237];
		conv += panelSh[p_idx + 549] * templateSh[236];
		conv += panelSh[p_idx + 550] * templateSh[235];
		conv += panelSh[p_idx + 551] * templateSh[234];
		conv += panelSh[p_idx + 552] * templateSh[233];
		conv += panelSh[p_idx + 553] * templateSh[232];
		conv += panelSh[p_idx + 554] * templateSh[231];
		conv += panelSh[p_idx + 555] * templateSh[230];
		conv += panelSh[p_idx + 556] * templateSh[229];
		conv += panelSh[p_idx + 557] * templateSh[228];
		conv += panelSh[p_idx + 558] * templateSh[227];
		conv += panelSh[p_idx + 559] * templateSh[226];
		conv += panelSh[p_idx + 560] * templateSh[225];
		conv += panelSh[p_idx + 561] * templateSh[224];
		conv += panelSh[p_idx + 562] * templateSh[223];
		conv += panelSh[p_idx + 563] * templateSh[222];
		conv += panelSh[p_idx + 564] * templateSh[221];
		conv += panelSh[p_idx + 565] * templateSh[220];
		conv += panelSh[p_idx + 566] * templateSh[219];
		conv += panelSh[p_idx + 567] * templateSh[218];
		conv += panelSh[p_idx + 568] * templateSh[217];
		conv += panelSh[p_idx + 569] * templateSh[216];
		conv += panelSh[p_idx + 585] * templateSh[215];
		conv += panelSh[p_idx + 586] * templateSh[214];
		conv += panelSh[p_idx + 587] * templateSh[213];
		conv += panelSh[p_idx + 588] * templateSh[212];
		conv += panelSh[p_idx + 589] * templateSh[211];
		conv += panelSh[p_idx + 590] * templateSh[210];
		conv += panelSh[p_idx + 591] * templateSh[209];
		conv += panelSh[p_idx + 592] * templateSh[208];
		conv += panelSh[p_idx + 593] * templateSh[207];
		conv += panelSh[p_idx + 594] * templateSh[206];
		conv += panelSh[p_idx + 595] * templateSh[205];
		conv += panelSh[p_idx + 596] * templateSh[204];
		conv += panelSh[p_idx + 597] * templateSh[203];
		conv += panelSh[p_idx + 598] * templateSh[202];
		conv += panelSh[p_idx + 599] * templateSh[201];
		conv += panelSh[p_idx + 600] * templateSh[200];
		conv += panelSh[p_idx + 601] * templateSh[199];
		conv += panelSh[p_idx + 602] * templateSh[198];
		conv += panelSh[p_idx + 603] * templateSh[197];
		conv += panelSh[p_idx + 604] * templateSh[196];
		conv += panelSh[p_idx + 605] * templateSh[195];
		conv += panelSh[p_idx + 606] * templateSh[194];
		conv += panelSh[p_idx + 607] * templateSh[193];
		conv += panelSh[p_idx + 608] * templateSh[192];
		conv += panelSh[p_idx + 624] * templateSh[191];
		conv += panelSh[p_idx + 625] * templateSh[190];
		conv += panelSh[p_idx + 626] * templateSh[189];
		conv += panelSh[p_idx + 627] * templateSh[188];
		conv += panelSh[p_idx + 628] * templateSh[187];
		conv += panelSh[p_idx + 629] * templateSh[186];
		conv += panelSh[p_idx + 630] * templateSh[185];
		conv += panelSh[p_idx + 631] * templateSh[184];
		conv += panelSh[p_idx + 632] * templateSh[183];
		conv += panelSh[p_idx + 633] * templateSh[182];
		conv += panelSh[p_idx + 634] * templateSh[181];
		conv += panelSh[p_idx + 635] * templateSh[180];
		conv += panelSh[p_idx + 636] * templateSh[179];
		conv += panelSh[p_idx + 637] * templateSh[178];
		conv += panelSh[p_idx + 638] * templateSh[177];
		conv += panelSh[p_idx + 639] * templateSh[176];
		conv += panelSh[p_idx + 640] * templateSh[175];
		conv += panelSh[p_idx + 641] * templateSh[174];
		conv += panelSh[p_idx + 642] * templateSh[173];
		conv += panelSh[p_idx + 643] * templateSh[172];
		conv += panelSh[p_idx + 644] * templateSh[171];
		conv += panelSh[p_idx + 645] * templateSh[170];
		conv += panelSh[p_idx + 646] * templateSh[169];
		conv += panelSh[p_idx + 647] * templateSh[168];
		conv += panelSh[p_idx + 663] * templateSh[167];
		conv += panelSh[p_idx + 664] * templateSh[166];
		conv += panelSh[p_idx + 665] * templateSh[165];
		conv += panelSh[p_idx + 666] * templateSh[164];
		conv += panelSh[p_idx + 667] * templateSh[163];
		conv += panelSh[p_idx + 668] * templateSh[162];
		conv += panelSh[p_idx + 669] * templateSh[161];
		conv += panelSh[p_idx + 670] * templateSh[160];
		conv += panelSh[p_idx + 671] * templateSh[159];
		conv += panelSh[p_idx + 672] * templateSh[158];
		conv += panelSh[p_idx + 673] * templateSh[157];
		conv += panelSh[p_idx + 674] * templateSh[156];
		conv += panelSh[p_idx + 675] * templateSh[155];
		conv += panelSh[p_idx + 676] * templateSh[154];
		conv += panelSh[p_idx + 677] * templateSh[153];
		conv += panelSh[p_idx + 678] * templateSh[152];
		conv += panelSh[p_idx + 679] * templateSh[151];
		conv += panelSh[p_idx + 680] * templateSh[150];
		conv += panelSh[p_idx + 681] * templateSh[149];
		conv += panelSh[p_idx + 682] * templateSh[148];
		conv += panelSh[p_idx + 683] * templateSh[147];
		conv += panelSh[p_idx + 684] * templateSh[146];
		conv += panelSh[p_idx + 685] * templateSh[145];
		conv += panelSh[p_idx + 686] * templateSh[144];
		conv += panelSh[p_idx + 702] * templateSh[143];
		conv += panelSh[p_idx + 703] * templateSh[142];
		conv += panelSh[p_idx + 704] * templateSh[141];
		conv += panelSh[p_idx + 705] * templateSh[140];
		conv += panelSh[p_idx + 706] * templateSh[139];
		conv += panelSh[p_idx + 707] * templateSh[138];
		conv += panelSh[p_idx + 708] * templateSh[137];
		conv += panelSh[p_idx + 709] * templateSh[136];
		conv += panelSh[p_idx + 710] * templateSh[135];
		conv += panelSh[p_idx + 711] * templateSh[134];
		conv += panelSh[p_idx + 712] * templateSh[133];
		conv += panelSh[p_idx + 713] * templateSh[132];
		conv += panelSh[p_idx + 714] * templateSh[131];
		conv += panelSh[p_idx + 715] * templateSh[130];
		conv += panelSh[p_idx + 716] * templateSh[129];
		conv += panelSh[p_idx + 717] * templateSh[128];
		conv += panelSh[p_idx + 718] * templateSh[127];
		conv += panelSh[p_idx + 719] * templateSh[126];
		conv += panelSh[p_idx + 720] * templateSh[125];
		conv += panelSh[p_idx + 721] * templateSh[124];
		conv += panelSh[p_idx + 722] * templateSh[123];
		conv += panelSh[p_idx + 723] * templateSh[122];
		conv += panelSh[p_idx + 724] * templateSh[121];
		conv += panelSh[p_idx + 725] * templateSh[120];
		conv += panelSh[p_idx + 741] * templateSh[119];
		conv += panelSh[p_idx + 742] * templateSh[118];
		conv += panelSh[p_idx + 743] * templateSh[117];
		conv += panelSh[p_idx + 744] * templateSh[116];
		conv += panelSh[p_idx + 745] * templateSh[115];
		conv += panelSh[p_idx + 746] * templateSh[114];
		conv += panelSh[p_idx + 747] * templateSh[113];
		conv += panelSh[p_idx + 748] * templateSh[112];
		conv += panelSh[p_idx + 749] * templateSh[111];
		conv += panelSh[p_idx + 750] * templateSh[110];
		conv += panelSh[p_idx + 751] * templateSh[109];
		conv += panelSh[p_idx + 752] * templateSh[108];
		conv += panelSh[p_idx + 753] * templateSh[107];
		conv += panelSh[p_idx + 754] * templateSh[106];
		conv += panelSh[p_idx + 755] * templateSh[105];
		conv += panelSh[p_idx + 756] * templateSh[104];
		conv += panelSh[p_idx + 757] * templateSh[103];
		conv += panelSh[p_idx + 758] * templateSh[102];
		conv += panelSh[p_idx + 759] * templateSh[101];
		conv += panelSh[p_idx + 760] * templateSh[100];
		conv += panelSh[p_idx + 761] * templateSh[99];
		conv += panelSh[p_idx + 762] * templateSh[98];
		conv += panelSh[p_idx + 763] * templateSh[97];
		conv += panelSh[p_idx + 764] * templateSh[96];
		conv += panelSh[p_idx + 780] * templateSh[95];
		conv += panelSh[p_idx + 781] * templateSh[94];
		conv += panelSh[p_idx + 782] * templateSh[93];
		conv += panelSh[p_idx + 783] * templateSh[92];
		conv += panelSh[p_idx + 784] * templateSh[91];
		conv += panelSh[p_idx + 785] * templateSh[90];
		conv += panelSh[p_idx + 786] * templateSh[89];
		conv += panelSh[p_idx + 787] * templateSh[88];
		conv += panelSh[p_idx + 788] * templateSh[87];
		conv += panelSh[p_idx + 789] * templateSh[86];
		conv += panelSh[p_idx + 790] * templateSh[85];
		conv += panelSh[p_idx + 791] * templateSh[84];
		conv += panelSh[p_idx + 792] * templateSh[83];
		conv += panelSh[p_idx + 793] * templateSh[82];
		conv += panelSh[p_idx + 794] * templateSh[81];
		conv += panelSh[p_idx + 795] * templateSh[80];
		conv += panelSh[p_idx + 796] * templateSh[79];
		conv += panelSh[p_idx + 797] * templateSh[78];
		conv += panelSh[p_idx + 798] * templateSh[77];
		conv += panelSh[p_idx + 799] * templateSh[76];
		conv += panelSh[p_idx + 800] * templateSh[75];
		conv += panelSh[p_idx + 801] * templateSh[74];
		conv += panelSh[p_idx + 802] * templateSh[73];
		conv += panelSh[p_idx + 803] * templateSh[72];
		conv += panelSh[p_idx + 819] * templateSh[71];
		conv += panelSh[p_idx + 820] * templateSh[70];
		conv += panelSh[p_idx + 821] * templateSh[69];
		conv += panelSh[p_idx + 822] * templateSh[68];
		conv += panelSh[p_idx + 823] * templateSh[67];
		conv += panelSh[p_idx + 824] * templateSh[66];
		conv += panelSh[p_idx + 825] * templateSh[65];
		conv += panelSh[p_idx + 826] * templateSh[64];
		conv += panelSh[p_idx + 827] * templateSh[63];
		conv += panelSh[p_idx + 828] * templateSh[62];
		conv += panelSh[p_idx + 829] * templateSh[61];
		conv += panelSh[p_idx + 830] * templateSh[60];
		conv += panelSh[p_idx + 831] * templateSh[59];
		conv += panelSh[p_idx + 832] * templateSh[58];
		conv += panelSh[p_idx + 833] * templateSh[57];
		conv += panelSh[p_idx + 834] * templateSh[56];
		conv += panelSh[p_idx + 835] * templateSh[55];
		conv += panelSh[p_idx + 836] * templateSh[54];
		conv += panelSh[p_idx + 837] * templateSh[53];
		conv += panelSh[p_idx + 838] * templateSh[52];
		conv += panelSh[p_idx + 839] * templateSh[51];
		conv += panelSh[p_idx + 840] * templateSh[50];
		conv += panelSh[p_idx + 841] * templateSh[49];
		conv += panelSh[p_idx + 842] * templateSh[48];
		conv += panelSh[p_idx + 858] * templateSh[47];
		conv += panelSh[p_idx + 859] * templateSh[46];
		conv += panelSh[p_idx + 860] * templateSh[45];
		conv += panelSh[p_idx + 861] * templateSh[44];
		conv += panelSh[p_idx + 862] * templateSh[43];
		conv += panelSh[p_idx + 863] * templateSh[42];
		conv += panelSh[p_idx + 864] * templateSh[41];
		conv += panelSh[p_idx + 865] * templateSh[40];
		conv += panelSh[p_idx + 866] * templateSh[39];
		conv += panelSh[p_idx + 867] * templateSh[38];
		conv += panelSh[p_idx + 868] * templateSh[37];
		conv += panelSh[p_idx + 869] * templateSh[36];
		conv += panelSh[p_idx + 870] * templateSh[35];
		conv += panelSh[p_idx + 871] * templateSh[34];
		conv += panelSh[p_idx + 872] * templateSh[33];
		conv += panelSh[p_idx + 873] * templateSh[32];
		conv += panelSh[p_idx + 874] * templateSh[31];
		conv += panelSh[p_idx + 875] * templateSh[30];
		conv += panelSh[p_idx + 876] * templateSh[29];
		conv += panelSh[p_idx + 877] * templateSh[28];
		conv += panelSh[p_idx + 878] * templateSh[27];
		conv += panelSh[p_idx + 879] * templateSh[26];
		conv += panelSh[p_idx + 880] * templateSh[25];
		conv += panelSh[p_idx + 881] * templateSh[24];
		conv += panelSh[p_idx + 897] * templateSh[23];
		conv += panelSh[p_idx + 898] * templateSh[22];
		conv += panelSh[p_idx + 899] * templateSh[21];
		conv += panelSh[p_idx + 900] * templateSh[20];
		conv += panelSh[p_idx + 901] * templateSh[19];
		conv += panelSh[p_idx + 902] * templateSh[18];
		conv += panelSh[p_idx + 903] * templateSh[17];
		conv += panelSh[p_idx + 904] * templateSh[16];
		conv += panelSh[p_idx + 905] * templateSh[15];
		conv += panelSh[p_idx + 906] * templateSh[14];
		conv += panelSh[p_idx + 907] * templateSh[13];
		conv += panelSh[p_idx + 908] * templateSh[12];
		conv += panelSh[p_idx + 909] * templateSh[11];
		conv += panelSh[p_idx + 910] * templateSh[10];
		conv += panelSh[p_idx + 911] * templateSh[9];
		conv += panelSh[p_idx + 912] * templateSh[8];
		conv += panelSh[p_idx + 913] * templateSh[7];
		conv += panelSh[p_idx + 914] * templateSh[6];
		conv += panelSh[p_idx + 915] * templateSh[5];
		conv += panelSh[p_idx + 916] * templateSh[4];
		conv += panelSh[p_idx + 917] * templateSh[3];
		conv += panelSh[p_idx + 918] * templateSh[2];
		conv += panelSh[p_idx + 919] * templateSh[1];
		conv += panelSh[p_idx + 920] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_24x24<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_24x24<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_25x25 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1600];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<40; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<40; i+=16) {
			panelSh[IMUL(j, 40) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[625];
	for (int j=threadIdx.y; j<25; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<25; i+=16) {
			const int jtwi = IMUL(j, 25) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 40);
		conv += panelSh[p_idx + 0] * templateSh[624];
		conv += panelSh[p_idx + 1] * templateSh[623];
		conv += panelSh[p_idx + 2] * templateSh[622];
		conv += panelSh[p_idx + 3] * templateSh[621];
		conv += panelSh[p_idx + 4] * templateSh[620];
		conv += panelSh[p_idx + 5] * templateSh[619];
		conv += panelSh[p_idx + 6] * templateSh[618];
		conv += panelSh[p_idx + 7] * templateSh[617];
		conv += panelSh[p_idx + 8] * templateSh[616];
		conv += panelSh[p_idx + 9] * templateSh[615];
		conv += panelSh[p_idx + 10] * templateSh[614];
		conv += panelSh[p_idx + 11] * templateSh[613];
		conv += panelSh[p_idx + 12] * templateSh[612];
		conv += panelSh[p_idx + 13] * templateSh[611];
		conv += panelSh[p_idx + 14] * templateSh[610];
		conv += panelSh[p_idx + 15] * templateSh[609];
		conv += panelSh[p_idx + 16] * templateSh[608];
		conv += panelSh[p_idx + 17] * templateSh[607];
		conv += panelSh[p_idx + 18] * templateSh[606];
		conv += panelSh[p_idx + 19] * templateSh[605];
		conv += panelSh[p_idx + 20] * templateSh[604];
		conv += panelSh[p_idx + 21] * templateSh[603];
		conv += panelSh[p_idx + 22] * templateSh[602];
		conv += panelSh[p_idx + 23] * templateSh[601];
		conv += panelSh[p_idx + 24] * templateSh[600];
		conv += panelSh[p_idx + 40] * templateSh[599];
		conv += panelSh[p_idx + 41] * templateSh[598];
		conv += panelSh[p_idx + 42] * templateSh[597];
		conv += panelSh[p_idx + 43] * templateSh[596];
		conv += panelSh[p_idx + 44] * templateSh[595];
		conv += panelSh[p_idx + 45] * templateSh[594];
		conv += panelSh[p_idx + 46] * templateSh[593];
		conv += panelSh[p_idx + 47] * templateSh[592];
		conv += panelSh[p_idx + 48] * templateSh[591];
		conv += panelSh[p_idx + 49] * templateSh[590];
		conv += panelSh[p_idx + 50] * templateSh[589];
		conv += panelSh[p_idx + 51] * templateSh[588];
		conv += panelSh[p_idx + 52] * templateSh[587];
		conv += panelSh[p_idx + 53] * templateSh[586];
		conv += panelSh[p_idx + 54] * templateSh[585];
		conv += panelSh[p_idx + 55] * templateSh[584];
		conv += panelSh[p_idx + 56] * templateSh[583];
		conv += panelSh[p_idx + 57] * templateSh[582];
		conv += panelSh[p_idx + 58] * templateSh[581];
		conv += panelSh[p_idx + 59] * templateSh[580];
		conv += panelSh[p_idx + 60] * templateSh[579];
		conv += panelSh[p_idx + 61] * templateSh[578];
		conv += panelSh[p_idx + 62] * templateSh[577];
		conv += panelSh[p_idx + 63] * templateSh[576];
		conv += panelSh[p_idx + 64] * templateSh[575];
		conv += panelSh[p_idx + 80] * templateSh[574];
		conv += panelSh[p_idx + 81] * templateSh[573];
		conv += panelSh[p_idx + 82] * templateSh[572];
		conv += panelSh[p_idx + 83] * templateSh[571];
		conv += panelSh[p_idx + 84] * templateSh[570];
		conv += panelSh[p_idx + 85] * templateSh[569];
		conv += panelSh[p_idx + 86] * templateSh[568];
		conv += panelSh[p_idx + 87] * templateSh[567];
		conv += panelSh[p_idx + 88] * templateSh[566];
		conv += panelSh[p_idx + 89] * templateSh[565];
		conv += panelSh[p_idx + 90] * templateSh[564];
		conv += panelSh[p_idx + 91] * templateSh[563];
		conv += panelSh[p_idx + 92] * templateSh[562];
		conv += panelSh[p_idx + 93] * templateSh[561];
		conv += panelSh[p_idx + 94] * templateSh[560];
		conv += panelSh[p_idx + 95] * templateSh[559];
		conv += panelSh[p_idx + 96] * templateSh[558];
		conv += panelSh[p_idx + 97] * templateSh[557];
		conv += panelSh[p_idx + 98] * templateSh[556];
		conv += panelSh[p_idx + 99] * templateSh[555];
		conv += panelSh[p_idx + 100] * templateSh[554];
		conv += panelSh[p_idx + 101] * templateSh[553];
		conv += panelSh[p_idx + 102] * templateSh[552];
		conv += panelSh[p_idx + 103] * templateSh[551];
		conv += panelSh[p_idx + 104] * templateSh[550];
		conv += panelSh[p_idx + 120] * templateSh[549];
		conv += panelSh[p_idx + 121] * templateSh[548];
		conv += panelSh[p_idx + 122] * templateSh[547];
		conv += panelSh[p_idx + 123] * templateSh[546];
		conv += panelSh[p_idx + 124] * templateSh[545];
		conv += panelSh[p_idx + 125] * templateSh[544];
		conv += panelSh[p_idx + 126] * templateSh[543];
		conv += panelSh[p_idx + 127] * templateSh[542];
		conv += panelSh[p_idx + 128] * templateSh[541];
		conv += panelSh[p_idx + 129] * templateSh[540];
		conv += panelSh[p_idx + 130] * templateSh[539];
		conv += panelSh[p_idx + 131] * templateSh[538];
		conv += panelSh[p_idx + 132] * templateSh[537];
		conv += panelSh[p_idx + 133] * templateSh[536];
		conv += panelSh[p_idx + 134] * templateSh[535];
		conv += panelSh[p_idx + 135] * templateSh[534];
		conv += panelSh[p_idx + 136] * templateSh[533];
		conv += panelSh[p_idx + 137] * templateSh[532];
		conv += panelSh[p_idx + 138] * templateSh[531];
		conv += panelSh[p_idx + 139] * templateSh[530];
		conv += panelSh[p_idx + 140] * templateSh[529];
		conv += panelSh[p_idx + 141] * templateSh[528];
		conv += panelSh[p_idx + 142] * templateSh[527];
		conv += panelSh[p_idx + 143] * templateSh[526];
		conv += panelSh[p_idx + 144] * templateSh[525];
		conv += panelSh[p_idx + 160] * templateSh[524];
		conv += panelSh[p_idx + 161] * templateSh[523];
		conv += panelSh[p_idx + 162] * templateSh[522];
		conv += panelSh[p_idx + 163] * templateSh[521];
		conv += panelSh[p_idx + 164] * templateSh[520];
		conv += panelSh[p_idx + 165] * templateSh[519];
		conv += panelSh[p_idx + 166] * templateSh[518];
		conv += panelSh[p_idx + 167] * templateSh[517];
		conv += panelSh[p_idx + 168] * templateSh[516];
		conv += panelSh[p_idx + 169] * templateSh[515];
		conv += panelSh[p_idx + 170] * templateSh[514];
		conv += panelSh[p_idx + 171] * templateSh[513];
		conv += panelSh[p_idx + 172] * templateSh[512];
		conv += panelSh[p_idx + 173] * templateSh[511];
		conv += panelSh[p_idx + 174] * templateSh[510];
		conv += panelSh[p_idx + 175] * templateSh[509];
		conv += panelSh[p_idx + 176] * templateSh[508];
		conv += panelSh[p_idx + 177] * templateSh[507];
		conv += panelSh[p_idx + 178] * templateSh[506];
		conv += panelSh[p_idx + 179] * templateSh[505];
		conv += panelSh[p_idx + 180] * templateSh[504];
		conv += panelSh[p_idx + 181] * templateSh[503];
		conv += panelSh[p_idx + 182] * templateSh[502];
		conv += panelSh[p_idx + 183] * templateSh[501];
		conv += panelSh[p_idx + 184] * templateSh[500];
		conv += panelSh[p_idx + 200] * templateSh[499];
		conv += panelSh[p_idx + 201] * templateSh[498];
		conv += panelSh[p_idx + 202] * templateSh[497];
		conv += panelSh[p_idx + 203] * templateSh[496];
		conv += panelSh[p_idx + 204] * templateSh[495];
		conv += panelSh[p_idx + 205] * templateSh[494];
		conv += panelSh[p_idx + 206] * templateSh[493];
		conv += panelSh[p_idx + 207] * templateSh[492];
		conv += panelSh[p_idx + 208] * templateSh[491];
		conv += panelSh[p_idx + 209] * templateSh[490];
		conv += panelSh[p_idx + 210] * templateSh[489];
		conv += panelSh[p_idx + 211] * templateSh[488];
		conv += panelSh[p_idx + 212] * templateSh[487];
		conv += panelSh[p_idx + 213] * templateSh[486];
		conv += panelSh[p_idx + 214] * templateSh[485];
		conv += panelSh[p_idx + 215] * templateSh[484];
		conv += panelSh[p_idx + 216] * templateSh[483];
		conv += panelSh[p_idx + 217] * templateSh[482];
		conv += panelSh[p_idx + 218] * templateSh[481];
		conv += panelSh[p_idx + 219] * templateSh[480];
		conv += panelSh[p_idx + 220] * templateSh[479];
		conv += panelSh[p_idx + 221] * templateSh[478];
		conv += panelSh[p_idx + 222] * templateSh[477];
		conv += panelSh[p_idx + 223] * templateSh[476];
		conv += panelSh[p_idx + 224] * templateSh[475];
		conv += panelSh[p_idx + 240] * templateSh[474];
		conv += panelSh[p_idx + 241] * templateSh[473];
		conv += panelSh[p_idx + 242] * templateSh[472];
		conv += panelSh[p_idx + 243] * templateSh[471];
		conv += panelSh[p_idx + 244] * templateSh[470];
		conv += panelSh[p_idx + 245] * templateSh[469];
		conv += panelSh[p_idx + 246] * templateSh[468];
		conv += panelSh[p_idx + 247] * templateSh[467];
		conv += panelSh[p_idx + 248] * templateSh[466];
		conv += panelSh[p_idx + 249] * templateSh[465];
		conv += panelSh[p_idx + 250] * templateSh[464];
		conv += panelSh[p_idx + 251] * templateSh[463];
		conv += panelSh[p_idx + 252] * templateSh[462];
		conv += panelSh[p_idx + 253] * templateSh[461];
		conv += panelSh[p_idx + 254] * templateSh[460];
		conv += panelSh[p_idx + 255] * templateSh[459];
		conv += panelSh[p_idx + 256] * templateSh[458];
		conv += panelSh[p_idx + 257] * templateSh[457];
		conv += panelSh[p_idx + 258] * templateSh[456];
		conv += panelSh[p_idx + 259] * templateSh[455];
		conv += panelSh[p_idx + 260] * templateSh[454];
		conv += panelSh[p_idx + 261] * templateSh[453];
		conv += panelSh[p_idx + 262] * templateSh[452];
		conv += panelSh[p_idx + 263] * templateSh[451];
		conv += panelSh[p_idx + 264] * templateSh[450];
		conv += panelSh[p_idx + 280] * templateSh[449];
		conv += panelSh[p_idx + 281] * templateSh[448];
		conv += panelSh[p_idx + 282] * templateSh[447];
		conv += panelSh[p_idx + 283] * templateSh[446];
		conv += panelSh[p_idx + 284] * templateSh[445];
		conv += panelSh[p_idx + 285] * templateSh[444];
		conv += panelSh[p_idx + 286] * templateSh[443];
		conv += panelSh[p_idx + 287] * templateSh[442];
		conv += panelSh[p_idx + 288] * templateSh[441];
		conv += panelSh[p_idx + 289] * templateSh[440];
		conv += panelSh[p_idx + 290] * templateSh[439];
		conv += panelSh[p_idx + 291] * templateSh[438];
		conv += panelSh[p_idx + 292] * templateSh[437];
		conv += panelSh[p_idx + 293] * templateSh[436];
		conv += panelSh[p_idx + 294] * templateSh[435];
		conv += panelSh[p_idx + 295] * templateSh[434];
		conv += panelSh[p_idx + 296] * templateSh[433];
		conv += panelSh[p_idx + 297] * templateSh[432];
		conv += panelSh[p_idx + 298] * templateSh[431];
		conv += panelSh[p_idx + 299] * templateSh[430];
		conv += panelSh[p_idx + 300] * templateSh[429];
		conv += panelSh[p_idx + 301] * templateSh[428];
		conv += panelSh[p_idx + 302] * templateSh[427];
		conv += panelSh[p_idx + 303] * templateSh[426];
		conv += panelSh[p_idx + 304] * templateSh[425];
		conv += panelSh[p_idx + 320] * templateSh[424];
		conv += panelSh[p_idx + 321] * templateSh[423];
		conv += panelSh[p_idx + 322] * templateSh[422];
		conv += panelSh[p_idx + 323] * templateSh[421];
		conv += panelSh[p_idx + 324] * templateSh[420];
		conv += panelSh[p_idx + 325] * templateSh[419];
		conv += panelSh[p_idx + 326] * templateSh[418];
		conv += panelSh[p_idx + 327] * templateSh[417];
		conv += panelSh[p_idx + 328] * templateSh[416];
		conv += panelSh[p_idx + 329] * templateSh[415];
		conv += panelSh[p_idx + 330] * templateSh[414];
		conv += panelSh[p_idx + 331] * templateSh[413];
		conv += panelSh[p_idx + 332] * templateSh[412];
		conv += panelSh[p_idx + 333] * templateSh[411];
		conv += panelSh[p_idx + 334] * templateSh[410];
		conv += panelSh[p_idx + 335] * templateSh[409];
		conv += panelSh[p_idx + 336] * templateSh[408];
		conv += panelSh[p_idx + 337] * templateSh[407];
		conv += panelSh[p_idx + 338] * templateSh[406];
		conv += panelSh[p_idx + 339] * templateSh[405];
		conv += panelSh[p_idx + 340] * templateSh[404];
		conv += panelSh[p_idx + 341] * templateSh[403];
		conv += panelSh[p_idx + 342] * templateSh[402];
		conv += panelSh[p_idx + 343] * templateSh[401];
		conv += panelSh[p_idx + 344] * templateSh[400];
		conv += panelSh[p_idx + 360] * templateSh[399];
		conv += panelSh[p_idx + 361] * templateSh[398];
		conv += panelSh[p_idx + 362] * templateSh[397];
		conv += panelSh[p_idx + 363] * templateSh[396];
		conv += panelSh[p_idx + 364] * templateSh[395];
		conv += panelSh[p_idx + 365] * templateSh[394];
		conv += panelSh[p_idx + 366] * templateSh[393];
		conv += panelSh[p_idx + 367] * templateSh[392];
		conv += panelSh[p_idx + 368] * templateSh[391];
		conv += panelSh[p_idx + 369] * templateSh[390];
		conv += panelSh[p_idx + 370] * templateSh[389];
		conv += panelSh[p_idx + 371] * templateSh[388];
		conv += panelSh[p_idx + 372] * templateSh[387];
		conv += panelSh[p_idx + 373] * templateSh[386];
		conv += panelSh[p_idx + 374] * templateSh[385];
		conv += panelSh[p_idx + 375] * templateSh[384];
		conv += panelSh[p_idx + 376] * templateSh[383];
		conv += panelSh[p_idx + 377] * templateSh[382];
		conv += panelSh[p_idx + 378] * templateSh[381];
		conv += panelSh[p_idx + 379] * templateSh[380];
		conv += panelSh[p_idx + 380] * templateSh[379];
		conv += panelSh[p_idx + 381] * templateSh[378];
		conv += panelSh[p_idx + 382] * templateSh[377];
		conv += panelSh[p_idx + 383] * templateSh[376];
		conv += panelSh[p_idx + 384] * templateSh[375];
		conv += panelSh[p_idx + 400] * templateSh[374];
		conv += panelSh[p_idx + 401] * templateSh[373];
		conv += panelSh[p_idx + 402] * templateSh[372];
		conv += panelSh[p_idx + 403] * templateSh[371];
		conv += panelSh[p_idx + 404] * templateSh[370];
		conv += panelSh[p_idx + 405] * templateSh[369];
		conv += panelSh[p_idx + 406] * templateSh[368];
		conv += panelSh[p_idx + 407] * templateSh[367];
		conv += panelSh[p_idx + 408] * templateSh[366];
		conv += panelSh[p_idx + 409] * templateSh[365];
		conv += panelSh[p_idx + 410] * templateSh[364];
		conv += panelSh[p_idx + 411] * templateSh[363];
		conv += panelSh[p_idx + 412] * templateSh[362];
		conv += panelSh[p_idx + 413] * templateSh[361];
		conv += panelSh[p_idx + 414] * templateSh[360];
		conv += panelSh[p_idx + 415] * templateSh[359];
		conv += panelSh[p_idx + 416] * templateSh[358];
		conv += panelSh[p_idx + 417] * templateSh[357];
		conv += panelSh[p_idx + 418] * templateSh[356];
		conv += panelSh[p_idx + 419] * templateSh[355];
		conv += panelSh[p_idx + 420] * templateSh[354];
		conv += panelSh[p_idx + 421] * templateSh[353];
		conv += panelSh[p_idx + 422] * templateSh[352];
		conv += panelSh[p_idx + 423] * templateSh[351];
		conv += panelSh[p_idx + 424] * templateSh[350];
		conv += panelSh[p_idx + 440] * templateSh[349];
		conv += panelSh[p_idx + 441] * templateSh[348];
		conv += panelSh[p_idx + 442] * templateSh[347];
		conv += panelSh[p_idx + 443] * templateSh[346];
		conv += panelSh[p_idx + 444] * templateSh[345];
		conv += panelSh[p_idx + 445] * templateSh[344];
		conv += panelSh[p_idx + 446] * templateSh[343];
		conv += panelSh[p_idx + 447] * templateSh[342];
		conv += panelSh[p_idx + 448] * templateSh[341];
		conv += panelSh[p_idx + 449] * templateSh[340];
		conv += panelSh[p_idx + 450] * templateSh[339];
		conv += panelSh[p_idx + 451] * templateSh[338];
		conv += panelSh[p_idx + 452] * templateSh[337];
		conv += panelSh[p_idx + 453] * templateSh[336];
		conv += panelSh[p_idx + 454] * templateSh[335];
		conv += panelSh[p_idx + 455] * templateSh[334];
		conv += panelSh[p_idx + 456] * templateSh[333];
		conv += panelSh[p_idx + 457] * templateSh[332];
		conv += panelSh[p_idx + 458] * templateSh[331];
		conv += panelSh[p_idx + 459] * templateSh[330];
		conv += panelSh[p_idx + 460] * templateSh[329];
		conv += panelSh[p_idx + 461] * templateSh[328];
		conv += panelSh[p_idx + 462] * templateSh[327];
		conv += panelSh[p_idx + 463] * templateSh[326];
		conv += panelSh[p_idx + 464] * templateSh[325];
		conv += panelSh[p_idx + 480] * templateSh[324];
		conv += panelSh[p_idx + 481] * templateSh[323];
		conv += panelSh[p_idx + 482] * templateSh[322];
		conv += panelSh[p_idx + 483] * templateSh[321];
		conv += panelSh[p_idx + 484] * templateSh[320];
		conv += panelSh[p_idx + 485] * templateSh[319];
		conv += panelSh[p_idx + 486] * templateSh[318];
		conv += panelSh[p_idx + 487] * templateSh[317];
		conv += panelSh[p_idx + 488] * templateSh[316];
		conv += panelSh[p_idx + 489] * templateSh[315];
		conv += panelSh[p_idx + 490] * templateSh[314];
		conv += panelSh[p_idx + 491] * templateSh[313];
		conv += panelSh[p_idx + 492] * templateSh[312];
		conv += panelSh[p_idx + 493] * templateSh[311];
		conv += panelSh[p_idx + 494] * templateSh[310];
		conv += panelSh[p_idx + 495] * templateSh[309];
		conv += panelSh[p_idx + 496] * templateSh[308];
		conv += panelSh[p_idx + 497] * templateSh[307];
		conv += panelSh[p_idx + 498] * templateSh[306];
		conv += panelSh[p_idx + 499] * templateSh[305];
		conv += panelSh[p_idx + 500] * templateSh[304];
		conv += panelSh[p_idx + 501] * templateSh[303];
		conv += panelSh[p_idx + 502] * templateSh[302];
		conv += panelSh[p_idx + 503] * templateSh[301];
		conv += panelSh[p_idx + 504] * templateSh[300];
		conv += panelSh[p_idx + 520] * templateSh[299];
		conv += panelSh[p_idx + 521] * templateSh[298];
		conv += panelSh[p_idx + 522] * templateSh[297];
		conv += panelSh[p_idx + 523] * templateSh[296];
		conv += panelSh[p_idx + 524] * templateSh[295];
		conv += panelSh[p_idx + 525] * templateSh[294];
		conv += panelSh[p_idx + 526] * templateSh[293];
		conv += panelSh[p_idx + 527] * templateSh[292];
		conv += panelSh[p_idx + 528] * templateSh[291];
		conv += panelSh[p_idx + 529] * templateSh[290];
		conv += panelSh[p_idx + 530] * templateSh[289];
		conv += panelSh[p_idx + 531] * templateSh[288];
		conv += panelSh[p_idx + 532] * templateSh[287];
		conv += panelSh[p_idx + 533] * templateSh[286];
		conv += panelSh[p_idx + 534] * templateSh[285];
		conv += panelSh[p_idx + 535] * templateSh[284];
		conv += panelSh[p_idx + 536] * templateSh[283];
		conv += panelSh[p_idx + 537] * templateSh[282];
		conv += panelSh[p_idx + 538] * templateSh[281];
		conv += panelSh[p_idx + 539] * templateSh[280];
		conv += panelSh[p_idx + 540] * templateSh[279];
		conv += panelSh[p_idx + 541] * templateSh[278];
		conv += panelSh[p_idx + 542] * templateSh[277];
		conv += panelSh[p_idx + 543] * templateSh[276];
		conv += panelSh[p_idx + 544] * templateSh[275];
		conv += panelSh[p_idx + 560] * templateSh[274];
		conv += panelSh[p_idx + 561] * templateSh[273];
		conv += panelSh[p_idx + 562] * templateSh[272];
		conv += panelSh[p_idx + 563] * templateSh[271];
		conv += panelSh[p_idx + 564] * templateSh[270];
		conv += panelSh[p_idx + 565] * templateSh[269];
		conv += panelSh[p_idx + 566] * templateSh[268];
		conv += panelSh[p_idx + 567] * templateSh[267];
		conv += panelSh[p_idx + 568] * templateSh[266];
		conv += panelSh[p_idx + 569] * templateSh[265];
		conv += panelSh[p_idx + 570] * templateSh[264];
		conv += panelSh[p_idx + 571] * templateSh[263];
		conv += panelSh[p_idx + 572] * templateSh[262];
		conv += panelSh[p_idx + 573] * templateSh[261];
		conv += panelSh[p_idx + 574] * templateSh[260];
		conv += panelSh[p_idx + 575] * templateSh[259];
		conv += panelSh[p_idx + 576] * templateSh[258];
		conv += panelSh[p_idx + 577] * templateSh[257];
		conv += panelSh[p_idx + 578] * templateSh[256];
		conv += panelSh[p_idx + 579] * templateSh[255];
		conv += panelSh[p_idx + 580] * templateSh[254];
		conv += panelSh[p_idx + 581] * templateSh[253];
		conv += panelSh[p_idx + 582] * templateSh[252];
		conv += panelSh[p_idx + 583] * templateSh[251];
		conv += panelSh[p_idx + 584] * templateSh[250];
		conv += panelSh[p_idx + 600] * templateSh[249];
		conv += panelSh[p_idx + 601] * templateSh[248];
		conv += panelSh[p_idx + 602] * templateSh[247];
		conv += panelSh[p_idx + 603] * templateSh[246];
		conv += panelSh[p_idx + 604] * templateSh[245];
		conv += panelSh[p_idx + 605] * templateSh[244];
		conv += panelSh[p_idx + 606] * templateSh[243];
		conv += panelSh[p_idx + 607] * templateSh[242];
		conv += panelSh[p_idx + 608] * templateSh[241];
		conv += panelSh[p_idx + 609] * templateSh[240];
		conv += panelSh[p_idx + 610] * templateSh[239];
		conv += panelSh[p_idx + 611] * templateSh[238];
		conv += panelSh[p_idx + 612] * templateSh[237];
		conv += panelSh[p_idx + 613] * templateSh[236];
		conv += panelSh[p_idx + 614] * templateSh[235];
		conv += panelSh[p_idx + 615] * templateSh[234];
		conv += panelSh[p_idx + 616] * templateSh[233];
		conv += panelSh[p_idx + 617] * templateSh[232];
		conv += panelSh[p_idx + 618] * templateSh[231];
		conv += panelSh[p_idx + 619] * templateSh[230];
		conv += panelSh[p_idx + 620] * templateSh[229];
		conv += panelSh[p_idx + 621] * templateSh[228];
		conv += panelSh[p_idx + 622] * templateSh[227];
		conv += panelSh[p_idx + 623] * templateSh[226];
		conv += panelSh[p_idx + 624] * templateSh[225];
		conv += panelSh[p_idx + 640] * templateSh[224];
		conv += panelSh[p_idx + 641] * templateSh[223];
		conv += panelSh[p_idx + 642] * templateSh[222];
		conv += panelSh[p_idx + 643] * templateSh[221];
		conv += panelSh[p_idx + 644] * templateSh[220];
		conv += panelSh[p_idx + 645] * templateSh[219];
		conv += panelSh[p_idx + 646] * templateSh[218];
		conv += panelSh[p_idx + 647] * templateSh[217];
		conv += panelSh[p_idx + 648] * templateSh[216];
		conv += panelSh[p_idx + 649] * templateSh[215];
		conv += panelSh[p_idx + 650] * templateSh[214];
		conv += panelSh[p_idx + 651] * templateSh[213];
		conv += panelSh[p_idx + 652] * templateSh[212];
		conv += panelSh[p_idx + 653] * templateSh[211];
		conv += panelSh[p_idx + 654] * templateSh[210];
		conv += panelSh[p_idx + 655] * templateSh[209];
		conv += panelSh[p_idx + 656] * templateSh[208];
		conv += panelSh[p_idx + 657] * templateSh[207];
		conv += panelSh[p_idx + 658] * templateSh[206];
		conv += panelSh[p_idx + 659] * templateSh[205];
		conv += panelSh[p_idx + 660] * templateSh[204];
		conv += panelSh[p_idx + 661] * templateSh[203];
		conv += panelSh[p_idx + 662] * templateSh[202];
		conv += panelSh[p_idx + 663] * templateSh[201];
		conv += panelSh[p_idx + 664] * templateSh[200];
		conv += panelSh[p_idx + 680] * templateSh[199];
		conv += panelSh[p_idx + 681] * templateSh[198];
		conv += panelSh[p_idx + 682] * templateSh[197];
		conv += panelSh[p_idx + 683] * templateSh[196];
		conv += panelSh[p_idx + 684] * templateSh[195];
		conv += panelSh[p_idx + 685] * templateSh[194];
		conv += panelSh[p_idx + 686] * templateSh[193];
		conv += panelSh[p_idx + 687] * templateSh[192];
		conv += panelSh[p_idx + 688] * templateSh[191];
		conv += panelSh[p_idx + 689] * templateSh[190];
		conv += panelSh[p_idx + 690] * templateSh[189];
		conv += panelSh[p_idx + 691] * templateSh[188];
		conv += panelSh[p_idx + 692] * templateSh[187];
		conv += panelSh[p_idx + 693] * templateSh[186];
		conv += panelSh[p_idx + 694] * templateSh[185];
		conv += panelSh[p_idx + 695] * templateSh[184];
		conv += panelSh[p_idx + 696] * templateSh[183];
		conv += panelSh[p_idx + 697] * templateSh[182];
		conv += panelSh[p_idx + 698] * templateSh[181];
		conv += panelSh[p_idx + 699] * templateSh[180];
		conv += panelSh[p_idx + 700] * templateSh[179];
		conv += panelSh[p_idx + 701] * templateSh[178];
		conv += panelSh[p_idx + 702] * templateSh[177];
		conv += panelSh[p_idx + 703] * templateSh[176];
		conv += panelSh[p_idx + 704] * templateSh[175];
		conv += panelSh[p_idx + 720] * templateSh[174];
		conv += panelSh[p_idx + 721] * templateSh[173];
		conv += panelSh[p_idx + 722] * templateSh[172];
		conv += panelSh[p_idx + 723] * templateSh[171];
		conv += panelSh[p_idx + 724] * templateSh[170];
		conv += panelSh[p_idx + 725] * templateSh[169];
		conv += panelSh[p_idx + 726] * templateSh[168];
		conv += panelSh[p_idx + 727] * templateSh[167];
		conv += panelSh[p_idx + 728] * templateSh[166];
		conv += panelSh[p_idx + 729] * templateSh[165];
		conv += panelSh[p_idx + 730] * templateSh[164];
		conv += panelSh[p_idx + 731] * templateSh[163];
		conv += panelSh[p_idx + 732] * templateSh[162];
		conv += panelSh[p_idx + 733] * templateSh[161];
		conv += panelSh[p_idx + 734] * templateSh[160];
		conv += panelSh[p_idx + 735] * templateSh[159];
		conv += panelSh[p_idx + 736] * templateSh[158];
		conv += panelSh[p_idx + 737] * templateSh[157];
		conv += panelSh[p_idx + 738] * templateSh[156];
		conv += panelSh[p_idx + 739] * templateSh[155];
		conv += panelSh[p_idx + 740] * templateSh[154];
		conv += panelSh[p_idx + 741] * templateSh[153];
		conv += panelSh[p_idx + 742] * templateSh[152];
		conv += panelSh[p_idx + 743] * templateSh[151];
		conv += panelSh[p_idx + 744] * templateSh[150];
		conv += panelSh[p_idx + 760] * templateSh[149];
		conv += panelSh[p_idx + 761] * templateSh[148];
		conv += panelSh[p_idx + 762] * templateSh[147];
		conv += panelSh[p_idx + 763] * templateSh[146];
		conv += panelSh[p_idx + 764] * templateSh[145];
		conv += panelSh[p_idx + 765] * templateSh[144];
		conv += panelSh[p_idx + 766] * templateSh[143];
		conv += panelSh[p_idx + 767] * templateSh[142];
		conv += panelSh[p_idx + 768] * templateSh[141];
		conv += panelSh[p_idx + 769] * templateSh[140];
		conv += panelSh[p_idx + 770] * templateSh[139];
		conv += panelSh[p_idx + 771] * templateSh[138];
		conv += panelSh[p_idx + 772] * templateSh[137];
		conv += panelSh[p_idx + 773] * templateSh[136];
		conv += panelSh[p_idx + 774] * templateSh[135];
		conv += panelSh[p_idx + 775] * templateSh[134];
		conv += panelSh[p_idx + 776] * templateSh[133];
		conv += panelSh[p_idx + 777] * templateSh[132];
		conv += panelSh[p_idx + 778] * templateSh[131];
		conv += panelSh[p_idx + 779] * templateSh[130];
		conv += panelSh[p_idx + 780] * templateSh[129];
		conv += panelSh[p_idx + 781] * templateSh[128];
		conv += panelSh[p_idx + 782] * templateSh[127];
		conv += panelSh[p_idx + 783] * templateSh[126];
		conv += panelSh[p_idx + 784] * templateSh[125];
		conv += panelSh[p_idx + 800] * templateSh[124];
		conv += panelSh[p_idx + 801] * templateSh[123];
		conv += panelSh[p_idx + 802] * templateSh[122];
		conv += panelSh[p_idx + 803] * templateSh[121];
		conv += panelSh[p_idx + 804] * templateSh[120];
		conv += panelSh[p_idx + 805] * templateSh[119];
		conv += panelSh[p_idx + 806] * templateSh[118];
		conv += panelSh[p_idx + 807] * templateSh[117];
		conv += panelSh[p_idx + 808] * templateSh[116];
		conv += panelSh[p_idx + 809] * templateSh[115];
		conv += panelSh[p_idx + 810] * templateSh[114];
		conv += panelSh[p_idx + 811] * templateSh[113];
		conv += panelSh[p_idx + 812] * templateSh[112];
		conv += panelSh[p_idx + 813] * templateSh[111];
		conv += panelSh[p_idx + 814] * templateSh[110];
		conv += panelSh[p_idx + 815] * templateSh[109];
		conv += panelSh[p_idx + 816] * templateSh[108];
		conv += panelSh[p_idx + 817] * templateSh[107];
		conv += panelSh[p_idx + 818] * templateSh[106];
		conv += panelSh[p_idx + 819] * templateSh[105];
		conv += panelSh[p_idx + 820] * templateSh[104];
		conv += panelSh[p_idx + 821] * templateSh[103];
		conv += panelSh[p_idx + 822] * templateSh[102];
		conv += panelSh[p_idx + 823] * templateSh[101];
		conv += panelSh[p_idx + 824] * templateSh[100];
		conv += panelSh[p_idx + 840] * templateSh[99];
		conv += panelSh[p_idx + 841] * templateSh[98];
		conv += panelSh[p_idx + 842] * templateSh[97];
		conv += panelSh[p_idx + 843] * templateSh[96];
		conv += panelSh[p_idx + 844] * templateSh[95];
		conv += panelSh[p_idx + 845] * templateSh[94];
		conv += panelSh[p_idx + 846] * templateSh[93];
		conv += panelSh[p_idx + 847] * templateSh[92];
		conv += panelSh[p_idx + 848] * templateSh[91];
		conv += panelSh[p_idx + 849] * templateSh[90];
		conv += panelSh[p_idx + 850] * templateSh[89];
		conv += panelSh[p_idx + 851] * templateSh[88];
		conv += panelSh[p_idx + 852] * templateSh[87];
		conv += panelSh[p_idx + 853] * templateSh[86];
		conv += panelSh[p_idx + 854] * templateSh[85];
		conv += panelSh[p_idx + 855] * templateSh[84];
		conv += panelSh[p_idx + 856] * templateSh[83];
		conv += panelSh[p_idx + 857] * templateSh[82];
		conv += panelSh[p_idx + 858] * templateSh[81];
		conv += panelSh[p_idx + 859] * templateSh[80];
		conv += panelSh[p_idx + 860] * templateSh[79];
		conv += panelSh[p_idx + 861] * templateSh[78];
		conv += panelSh[p_idx + 862] * templateSh[77];
		conv += panelSh[p_idx + 863] * templateSh[76];
		conv += panelSh[p_idx + 864] * templateSh[75];
		conv += panelSh[p_idx + 880] * templateSh[74];
		conv += panelSh[p_idx + 881] * templateSh[73];
		conv += panelSh[p_idx + 882] * templateSh[72];
		conv += panelSh[p_idx + 883] * templateSh[71];
		conv += panelSh[p_idx + 884] * templateSh[70];
		conv += panelSh[p_idx + 885] * templateSh[69];
		conv += panelSh[p_idx + 886] * templateSh[68];
		conv += panelSh[p_idx + 887] * templateSh[67];
		conv += panelSh[p_idx + 888] * templateSh[66];
		conv += panelSh[p_idx + 889] * templateSh[65];
		conv += panelSh[p_idx + 890] * templateSh[64];
		conv += panelSh[p_idx + 891] * templateSh[63];
		conv += panelSh[p_idx + 892] * templateSh[62];
		conv += panelSh[p_idx + 893] * templateSh[61];
		conv += panelSh[p_idx + 894] * templateSh[60];
		conv += panelSh[p_idx + 895] * templateSh[59];
		conv += panelSh[p_idx + 896] * templateSh[58];
		conv += panelSh[p_idx + 897] * templateSh[57];
		conv += panelSh[p_idx + 898] * templateSh[56];
		conv += panelSh[p_idx + 899] * templateSh[55];
		conv += panelSh[p_idx + 900] * templateSh[54];
		conv += panelSh[p_idx + 901] * templateSh[53];
		conv += panelSh[p_idx + 902] * templateSh[52];
		conv += panelSh[p_idx + 903] * templateSh[51];
		conv += panelSh[p_idx + 904] * templateSh[50];
		conv += panelSh[p_idx + 920] * templateSh[49];
		conv += panelSh[p_idx + 921] * templateSh[48];
		conv += panelSh[p_idx + 922] * templateSh[47];
		conv += panelSh[p_idx + 923] * templateSh[46];
		conv += panelSh[p_idx + 924] * templateSh[45];
		conv += panelSh[p_idx + 925] * templateSh[44];
		conv += panelSh[p_idx + 926] * templateSh[43];
		conv += panelSh[p_idx + 927] * templateSh[42];
		conv += panelSh[p_idx + 928] * templateSh[41];
		conv += panelSh[p_idx + 929] * templateSh[40];
		conv += panelSh[p_idx + 930] * templateSh[39];
		conv += panelSh[p_idx + 931] * templateSh[38];
		conv += panelSh[p_idx + 932] * templateSh[37];
		conv += panelSh[p_idx + 933] * templateSh[36];
		conv += panelSh[p_idx + 934] * templateSh[35];
		conv += panelSh[p_idx + 935] * templateSh[34];
		conv += panelSh[p_idx + 936] * templateSh[33];
		conv += panelSh[p_idx + 937] * templateSh[32];
		conv += panelSh[p_idx + 938] * templateSh[31];
		conv += panelSh[p_idx + 939] * templateSh[30];
		conv += panelSh[p_idx + 940] * templateSh[29];
		conv += panelSh[p_idx + 941] * templateSh[28];
		conv += panelSh[p_idx + 942] * templateSh[27];
		conv += panelSh[p_idx + 943] * templateSh[26];
		conv += panelSh[p_idx + 944] * templateSh[25];
		conv += panelSh[p_idx + 960] * templateSh[24];
		conv += panelSh[p_idx + 961] * templateSh[23];
		conv += panelSh[p_idx + 962] * templateSh[22];
		conv += panelSh[p_idx + 963] * templateSh[21];
		conv += panelSh[p_idx + 964] * templateSh[20];
		conv += panelSh[p_idx + 965] * templateSh[19];
		conv += panelSh[p_idx + 966] * templateSh[18];
		conv += panelSh[p_idx + 967] * templateSh[17];
		conv += panelSh[p_idx + 968] * templateSh[16];
		conv += panelSh[p_idx + 969] * templateSh[15];
		conv += panelSh[p_idx + 970] * templateSh[14];
		conv += panelSh[p_idx + 971] * templateSh[13];
		conv += panelSh[p_idx + 972] * templateSh[12];
		conv += panelSh[p_idx + 973] * templateSh[11];
		conv += panelSh[p_idx + 974] * templateSh[10];
		conv += panelSh[p_idx + 975] * templateSh[9];
		conv += panelSh[p_idx + 976] * templateSh[8];
		conv += panelSh[p_idx + 977] * templateSh[7];
		conv += panelSh[p_idx + 978] * templateSh[6];
		conv += panelSh[p_idx + 979] * templateSh[5];
		conv += panelSh[p_idx + 980] * templateSh[4];
		conv += panelSh[p_idx + 981] * templateSh[3];
		conv += panelSh[p_idx + 982] * templateSh[2];
		conv += panelSh[p_idx + 983] * templateSh[1];
		conv += panelSh[p_idx + 984] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_25x25<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_25x25<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_26x26 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1681];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<41; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<41; i+=16) {
			panelSh[IMUL(j, 41) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[676];
	for (int j=threadIdx.y; j<26; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<26; i+=16) {
			const int jtwi = IMUL(j, 26) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 41);
		conv += panelSh[p_idx + 0] * templateSh[675];
		conv += panelSh[p_idx + 1] * templateSh[674];
		conv += panelSh[p_idx + 2] * templateSh[673];
		conv += panelSh[p_idx + 3] * templateSh[672];
		conv += panelSh[p_idx + 4] * templateSh[671];
		conv += panelSh[p_idx + 5] * templateSh[670];
		conv += panelSh[p_idx + 6] * templateSh[669];
		conv += panelSh[p_idx + 7] * templateSh[668];
		conv += panelSh[p_idx + 8] * templateSh[667];
		conv += panelSh[p_idx + 9] * templateSh[666];
		conv += panelSh[p_idx + 10] * templateSh[665];
		conv += panelSh[p_idx + 11] * templateSh[664];
		conv += panelSh[p_idx + 12] * templateSh[663];
		conv += panelSh[p_idx + 13] * templateSh[662];
		conv += panelSh[p_idx + 14] * templateSh[661];
		conv += panelSh[p_idx + 15] * templateSh[660];
		conv += panelSh[p_idx + 16] * templateSh[659];
		conv += panelSh[p_idx + 17] * templateSh[658];
		conv += panelSh[p_idx + 18] * templateSh[657];
		conv += panelSh[p_idx + 19] * templateSh[656];
		conv += panelSh[p_idx + 20] * templateSh[655];
		conv += panelSh[p_idx + 21] * templateSh[654];
		conv += panelSh[p_idx + 22] * templateSh[653];
		conv += panelSh[p_idx + 23] * templateSh[652];
		conv += panelSh[p_idx + 24] * templateSh[651];
		conv += panelSh[p_idx + 25] * templateSh[650];
		conv += panelSh[p_idx + 41] * templateSh[649];
		conv += panelSh[p_idx + 42] * templateSh[648];
		conv += panelSh[p_idx + 43] * templateSh[647];
		conv += panelSh[p_idx + 44] * templateSh[646];
		conv += panelSh[p_idx + 45] * templateSh[645];
		conv += panelSh[p_idx + 46] * templateSh[644];
		conv += panelSh[p_idx + 47] * templateSh[643];
		conv += panelSh[p_idx + 48] * templateSh[642];
		conv += panelSh[p_idx + 49] * templateSh[641];
		conv += panelSh[p_idx + 50] * templateSh[640];
		conv += panelSh[p_idx + 51] * templateSh[639];
		conv += panelSh[p_idx + 52] * templateSh[638];
		conv += panelSh[p_idx + 53] * templateSh[637];
		conv += panelSh[p_idx + 54] * templateSh[636];
		conv += panelSh[p_idx + 55] * templateSh[635];
		conv += panelSh[p_idx + 56] * templateSh[634];
		conv += panelSh[p_idx + 57] * templateSh[633];
		conv += panelSh[p_idx + 58] * templateSh[632];
		conv += panelSh[p_idx + 59] * templateSh[631];
		conv += panelSh[p_idx + 60] * templateSh[630];
		conv += panelSh[p_idx + 61] * templateSh[629];
		conv += panelSh[p_idx + 62] * templateSh[628];
		conv += panelSh[p_idx + 63] * templateSh[627];
		conv += panelSh[p_idx + 64] * templateSh[626];
		conv += panelSh[p_idx + 65] * templateSh[625];
		conv += panelSh[p_idx + 66] * templateSh[624];
		conv += panelSh[p_idx + 82] * templateSh[623];
		conv += panelSh[p_idx + 83] * templateSh[622];
		conv += panelSh[p_idx + 84] * templateSh[621];
		conv += panelSh[p_idx + 85] * templateSh[620];
		conv += panelSh[p_idx + 86] * templateSh[619];
		conv += panelSh[p_idx + 87] * templateSh[618];
		conv += panelSh[p_idx + 88] * templateSh[617];
		conv += panelSh[p_idx + 89] * templateSh[616];
		conv += panelSh[p_idx + 90] * templateSh[615];
		conv += panelSh[p_idx + 91] * templateSh[614];
		conv += panelSh[p_idx + 92] * templateSh[613];
		conv += panelSh[p_idx + 93] * templateSh[612];
		conv += panelSh[p_idx + 94] * templateSh[611];
		conv += panelSh[p_idx + 95] * templateSh[610];
		conv += panelSh[p_idx + 96] * templateSh[609];
		conv += panelSh[p_idx + 97] * templateSh[608];
		conv += panelSh[p_idx + 98] * templateSh[607];
		conv += panelSh[p_idx + 99] * templateSh[606];
		conv += panelSh[p_idx + 100] * templateSh[605];
		conv += panelSh[p_idx + 101] * templateSh[604];
		conv += panelSh[p_idx + 102] * templateSh[603];
		conv += panelSh[p_idx + 103] * templateSh[602];
		conv += panelSh[p_idx + 104] * templateSh[601];
		conv += panelSh[p_idx + 105] * templateSh[600];
		conv += panelSh[p_idx + 106] * templateSh[599];
		conv += panelSh[p_idx + 107] * templateSh[598];
		conv += panelSh[p_idx + 123] * templateSh[597];
		conv += panelSh[p_idx + 124] * templateSh[596];
		conv += panelSh[p_idx + 125] * templateSh[595];
		conv += panelSh[p_idx + 126] * templateSh[594];
		conv += panelSh[p_idx + 127] * templateSh[593];
		conv += panelSh[p_idx + 128] * templateSh[592];
		conv += panelSh[p_idx + 129] * templateSh[591];
		conv += panelSh[p_idx + 130] * templateSh[590];
		conv += panelSh[p_idx + 131] * templateSh[589];
		conv += panelSh[p_idx + 132] * templateSh[588];
		conv += panelSh[p_idx + 133] * templateSh[587];
		conv += panelSh[p_idx + 134] * templateSh[586];
		conv += panelSh[p_idx + 135] * templateSh[585];
		conv += panelSh[p_idx + 136] * templateSh[584];
		conv += panelSh[p_idx + 137] * templateSh[583];
		conv += panelSh[p_idx + 138] * templateSh[582];
		conv += panelSh[p_idx + 139] * templateSh[581];
		conv += panelSh[p_idx + 140] * templateSh[580];
		conv += panelSh[p_idx + 141] * templateSh[579];
		conv += panelSh[p_idx + 142] * templateSh[578];
		conv += panelSh[p_idx + 143] * templateSh[577];
		conv += panelSh[p_idx + 144] * templateSh[576];
		conv += panelSh[p_idx + 145] * templateSh[575];
		conv += panelSh[p_idx + 146] * templateSh[574];
		conv += panelSh[p_idx + 147] * templateSh[573];
		conv += panelSh[p_idx + 148] * templateSh[572];
		conv += panelSh[p_idx + 164] * templateSh[571];
		conv += panelSh[p_idx + 165] * templateSh[570];
		conv += panelSh[p_idx + 166] * templateSh[569];
		conv += panelSh[p_idx + 167] * templateSh[568];
		conv += panelSh[p_idx + 168] * templateSh[567];
		conv += panelSh[p_idx + 169] * templateSh[566];
		conv += panelSh[p_idx + 170] * templateSh[565];
		conv += panelSh[p_idx + 171] * templateSh[564];
		conv += panelSh[p_idx + 172] * templateSh[563];
		conv += panelSh[p_idx + 173] * templateSh[562];
		conv += panelSh[p_idx + 174] * templateSh[561];
		conv += panelSh[p_idx + 175] * templateSh[560];
		conv += panelSh[p_idx + 176] * templateSh[559];
		conv += panelSh[p_idx + 177] * templateSh[558];
		conv += panelSh[p_idx + 178] * templateSh[557];
		conv += panelSh[p_idx + 179] * templateSh[556];
		conv += panelSh[p_idx + 180] * templateSh[555];
		conv += panelSh[p_idx + 181] * templateSh[554];
		conv += panelSh[p_idx + 182] * templateSh[553];
		conv += panelSh[p_idx + 183] * templateSh[552];
		conv += panelSh[p_idx + 184] * templateSh[551];
		conv += panelSh[p_idx + 185] * templateSh[550];
		conv += panelSh[p_idx + 186] * templateSh[549];
		conv += panelSh[p_idx + 187] * templateSh[548];
		conv += panelSh[p_idx + 188] * templateSh[547];
		conv += panelSh[p_idx + 189] * templateSh[546];
		conv += panelSh[p_idx + 205] * templateSh[545];
		conv += panelSh[p_idx + 206] * templateSh[544];
		conv += panelSh[p_idx + 207] * templateSh[543];
		conv += panelSh[p_idx + 208] * templateSh[542];
		conv += panelSh[p_idx + 209] * templateSh[541];
		conv += panelSh[p_idx + 210] * templateSh[540];
		conv += panelSh[p_idx + 211] * templateSh[539];
		conv += panelSh[p_idx + 212] * templateSh[538];
		conv += panelSh[p_idx + 213] * templateSh[537];
		conv += panelSh[p_idx + 214] * templateSh[536];
		conv += panelSh[p_idx + 215] * templateSh[535];
		conv += panelSh[p_idx + 216] * templateSh[534];
		conv += panelSh[p_idx + 217] * templateSh[533];
		conv += panelSh[p_idx + 218] * templateSh[532];
		conv += panelSh[p_idx + 219] * templateSh[531];
		conv += panelSh[p_idx + 220] * templateSh[530];
		conv += panelSh[p_idx + 221] * templateSh[529];
		conv += panelSh[p_idx + 222] * templateSh[528];
		conv += panelSh[p_idx + 223] * templateSh[527];
		conv += panelSh[p_idx + 224] * templateSh[526];
		conv += panelSh[p_idx + 225] * templateSh[525];
		conv += panelSh[p_idx + 226] * templateSh[524];
		conv += panelSh[p_idx + 227] * templateSh[523];
		conv += panelSh[p_idx + 228] * templateSh[522];
		conv += panelSh[p_idx + 229] * templateSh[521];
		conv += panelSh[p_idx + 230] * templateSh[520];
		conv += panelSh[p_idx + 246] * templateSh[519];
		conv += panelSh[p_idx + 247] * templateSh[518];
		conv += panelSh[p_idx + 248] * templateSh[517];
		conv += panelSh[p_idx + 249] * templateSh[516];
		conv += panelSh[p_idx + 250] * templateSh[515];
		conv += panelSh[p_idx + 251] * templateSh[514];
		conv += panelSh[p_idx + 252] * templateSh[513];
		conv += panelSh[p_idx + 253] * templateSh[512];
		conv += panelSh[p_idx + 254] * templateSh[511];
		conv += panelSh[p_idx + 255] * templateSh[510];
		conv += panelSh[p_idx + 256] * templateSh[509];
		conv += panelSh[p_idx + 257] * templateSh[508];
		conv += panelSh[p_idx + 258] * templateSh[507];
		conv += panelSh[p_idx + 259] * templateSh[506];
		conv += panelSh[p_idx + 260] * templateSh[505];
		conv += panelSh[p_idx + 261] * templateSh[504];
		conv += panelSh[p_idx + 262] * templateSh[503];
		conv += panelSh[p_idx + 263] * templateSh[502];
		conv += panelSh[p_idx + 264] * templateSh[501];
		conv += panelSh[p_idx + 265] * templateSh[500];
		conv += panelSh[p_idx + 266] * templateSh[499];
		conv += panelSh[p_idx + 267] * templateSh[498];
		conv += panelSh[p_idx + 268] * templateSh[497];
		conv += panelSh[p_idx + 269] * templateSh[496];
		conv += panelSh[p_idx + 270] * templateSh[495];
		conv += panelSh[p_idx + 271] * templateSh[494];
		conv += panelSh[p_idx + 287] * templateSh[493];
		conv += panelSh[p_idx + 288] * templateSh[492];
		conv += panelSh[p_idx + 289] * templateSh[491];
		conv += panelSh[p_idx + 290] * templateSh[490];
		conv += panelSh[p_idx + 291] * templateSh[489];
		conv += panelSh[p_idx + 292] * templateSh[488];
		conv += panelSh[p_idx + 293] * templateSh[487];
		conv += panelSh[p_idx + 294] * templateSh[486];
		conv += panelSh[p_idx + 295] * templateSh[485];
		conv += panelSh[p_idx + 296] * templateSh[484];
		conv += panelSh[p_idx + 297] * templateSh[483];
		conv += panelSh[p_idx + 298] * templateSh[482];
		conv += panelSh[p_idx + 299] * templateSh[481];
		conv += panelSh[p_idx + 300] * templateSh[480];
		conv += panelSh[p_idx + 301] * templateSh[479];
		conv += panelSh[p_idx + 302] * templateSh[478];
		conv += panelSh[p_idx + 303] * templateSh[477];
		conv += panelSh[p_idx + 304] * templateSh[476];
		conv += panelSh[p_idx + 305] * templateSh[475];
		conv += panelSh[p_idx + 306] * templateSh[474];
		conv += panelSh[p_idx + 307] * templateSh[473];
		conv += panelSh[p_idx + 308] * templateSh[472];
		conv += panelSh[p_idx + 309] * templateSh[471];
		conv += panelSh[p_idx + 310] * templateSh[470];
		conv += panelSh[p_idx + 311] * templateSh[469];
		conv += panelSh[p_idx + 312] * templateSh[468];
		conv += panelSh[p_idx + 328] * templateSh[467];
		conv += panelSh[p_idx + 329] * templateSh[466];
		conv += panelSh[p_idx + 330] * templateSh[465];
		conv += panelSh[p_idx + 331] * templateSh[464];
		conv += panelSh[p_idx + 332] * templateSh[463];
		conv += panelSh[p_idx + 333] * templateSh[462];
		conv += panelSh[p_idx + 334] * templateSh[461];
		conv += panelSh[p_idx + 335] * templateSh[460];
		conv += panelSh[p_idx + 336] * templateSh[459];
		conv += panelSh[p_idx + 337] * templateSh[458];
		conv += panelSh[p_idx + 338] * templateSh[457];
		conv += panelSh[p_idx + 339] * templateSh[456];
		conv += panelSh[p_idx + 340] * templateSh[455];
		conv += panelSh[p_idx + 341] * templateSh[454];
		conv += panelSh[p_idx + 342] * templateSh[453];
		conv += panelSh[p_idx + 343] * templateSh[452];
		conv += panelSh[p_idx + 344] * templateSh[451];
		conv += panelSh[p_idx + 345] * templateSh[450];
		conv += panelSh[p_idx + 346] * templateSh[449];
		conv += panelSh[p_idx + 347] * templateSh[448];
		conv += panelSh[p_idx + 348] * templateSh[447];
		conv += panelSh[p_idx + 349] * templateSh[446];
		conv += panelSh[p_idx + 350] * templateSh[445];
		conv += panelSh[p_idx + 351] * templateSh[444];
		conv += panelSh[p_idx + 352] * templateSh[443];
		conv += panelSh[p_idx + 353] * templateSh[442];
		conv += panelSh[p_idx + 369] * templateSh[441];
		conv += panelSh[p_idx + 370] * templateSh[440];
		conv += panelSh[p_idx + 371] * templateSh[439];
		conv += panelSh[p_idx + 372] * templateSh[438];
		conv += panelSh[p_idx + 373] * templateSh[437];
		conv += panelSh[p_idx + 374] * templateSh[436];
		conv += panelSh[p_idx + 375] * templateSh[435];
		conv += panelSh[p_idx + 376] * templateSh[434];
		conv += panelSh[p_idx + 377] * templateSh[433];
		conv += panelSh[p_idx + 378] * templateSh[432];
		conv += panelSh[p_idx + 379] * templateSh[431];
		conv += panelSh[p_idx + 380] * templateSh[430];
		conv += panelSh[p_idx + 381] * templateSh[429];
		conv += panelSh[p_idx + 382] * templateSh[428];
		conv += panelSh[p_idx + 383] * templateSh[427];
		conv += panelSh[p_idx + 384] * templateSh[426];
		conv += panelSh[p_idx + 385] * templateSh[425];
		conv += panelSh[p_idx + 386] * templateSh[424];
		conv += panelSh[p_idx + 387] * templateSh[423];
		conv += panelSh[p_idx + 388] * templateSh[422];
		conv += panelSh[p_idx + 389] * templateSh[421];
		conv += panelSh[p_idx + 390] * templateSh[420];
		conv += panelSh[p_idx + 391] * templateSh[419];
		conv += panelSh[p_idx + 392] * templateSh[418];
		conv += panelSh[p_idx + 393] * templateSh[417];
		conv += panelSh[p_idx + 394] * templateSh[416];
		conv += panelSh[p_idx + 410] * templateSh[415];
		conv += panelSh[p_idx + 411] * templateSh[414];
		conv += panelSh[p_idx + 412] * templateSh[413];
		conv += panelSh[p_idx + 413] * templateSh[412];
		conv += panelSh[p_idx + 414] * templateSh[411];
		conv += panelSh[p_idx + 415] * templateSh[410];
		conv += panelSh[p_idx + 416] * templateSh[409];
		conv += panelSh[p_idx + 417] * templateSh[408];
		conv += panelSh[p_idx + 418] * templateSh[407];
		conv += panelSh[p_idx + 419] * templateSh[406];
		conv += panelSh[p_idx + 420] * templateSh[405];
		conv += panelSh[p_idx + 421] * templateSh[404];
		conv += panelSh[p_idx + 422] * templateSh[403];
		conv += panelSh[p_idx + 423] * templateSh[402];
		conv += panelSh[p_idx + 424] * templateSh[401];
		conv += panelSh[p_idx + 425] * templateSh[400];
		conv += panelSh[p_idx + 426] * templateSh[399];
		conv += panelSh[p_idx + 427] * templateSh[398];
		conv += panelSh[p_idx + 428] * templateSh[397];
		conv += panelSh[p_idx + 429] * templateSh[396];
		conv += panelSh[p_idx + 430] * templateSh[395];
		conv += panelSh[p_idx + 431] * templateSh[394];
		conv += panelSh[p_idx + 432] * templateSh[393];
		conv += panelSh[p_idx + 433] * templateSh[392];
		conv += panelSh[p_idx + 434] * templateSh[391];
		conv += panelSh[p_idx + 435] * templateSh[390];
		conv += panelSh[p_idx + 451] * templateSh[389];
		conv += panelSh[p_idx + 452] * templateSh[388];
		conv += panelSh[p_idx + 453] * templateSh[387];
		conv += panelSh[p_idx + 454] * templateSh[386];
		conv += panelSh[p_idx + 455] * templateSh[385];
		conv += panelSh[p_idx + 456] * templateSh[384];
		conv += panelSh[p_idx + 457] * templateSh[383];
		conv += panelSh[p_idx + 458] * templateSh[382];
		conv += panelSh[p_idx + 459] * templateSh[381];
		conv += panelSh[p_idx + 460] * templateSh[380];
		conv += panelSh[p_idx + 461] * templateSh[379];
		conv += panelSh[p_idx + 462] * templateSh[378];
		conv += panelSh[p_idx + 463] * templateSh[377];
		conv += panelSh[p_idx + 464] * templateSh[376];
		conv += panelSh[p_idx + 465] * templateSh[375];
		conv += panelSh[p_idx + 466] * templateSh[374];
		conv += panelSh[p_idx + 467] * templateSh[373];
		conv += panelSh[p_idx + 468] * templateSh[372];
		conv += panelSh[p_idx + 469] * templateSh[371];
		conv += panelSh[p_idx + 470] * templateSh[370];
		conv += panelSh[p_idx + 471] * templateSh[369];
		conv += panelSh[p_idx + 472] * templateSh[368];
		conv += panelSh[p_idx + 473] * templateSh[367];
		conv += panelSh[p_idx + 474] * templateSh[366];
		conv += panelSh[p_idx + 475] * templateSh[365];
		conv += panelSh[p_idx + 476] * templateSh[364];
		conv += panelSh[p_idx + 492] * templateSh[363];
		conv += panelSh[p_idx + 493] * templateSh[362];
		conv += panelSh[p_idx + 494] * templateSh[361];
		conv += panelSh[p_idx + 495] * templateSh[360];
		conv += panelSh[p_idx + 496] * templateSh[359];
		conv += panelSh[p_idx + 497] * templateSh[358];
		conv += panelSh[p_idx + 498] * templateSh[357];
		conv += panelSh[p_idx + 499] * templateSh[356];
		conv += panelSh[p_idx + 500] * templateSh[355];
		conv += panelSh[p_idx + 501] * templateSh[354];
		conv += panelSh[p_idx + 502] * templateSh[353];
		conv += panelSh[p_idx + 503] * templateSh[352];
		conv += panelSh[p_idx + 504] * templateSh[351];
		conv += panelSh[p_idx + 505] * templateSh[350];
		conv += panelSh[p_idx + 506] * templateSh[349];
		conv += panelSh[p_idx + 507] * templateSh[348];
		conv += panelSh[p_idx + 508] * templateSh[347];
		conv += panelSh[p_idx + 509] * templateSh[346];
		conv += panelSh[p_idx + 510] * templateSh[345];
		conv += panelSh[p_idx + 511] * templateSh[344];
		conv += panelSh[p_idx + 512] * templateSh[343];
		conv += panelSh[p_idx + 513] * templateSh[342];
		conv += panelSh[p_idx + 514] * templateSh[341];
		conv += panelSh[p_idx + 515] * templateSh[340];
		conv += panelSh[p_idx + 516] * templateSh[339];
		conv += panelSh[p_idx + 517] * templateSh[338];
		conv += panelSh[p_idx + 533] * templateSh[337];
		conv += panelSh[p_idx + 534] * templateSh[336];
		conv += panelSh[p_idx + 535] * templateSh[335];
		conv += panelSh[p_idx + 536] * templateSh[334];
		conv += panelSh[p_idx + 537] * templateSh[333];
		conv += panelSh[p_idx + 538] * templateSh[332];
		conv += panelSh[p_idx + 539] * templateSh[331];
		conv += panelSh[p_idx + 540] * templateSh[330];
		conv += panelSh[p_idx + 541] * templateSh[329];
		conv += panelSh[p_idx + 542] * templateSh[328];
		conv += panelSh[p_idx + 543] * templateSh[327];
		conv += panelSh[p_idx + 544] * templateSh[326];
		conv += panelSh[p_idx + 545] * templateSh[325];
		conv += panelSh[p_idx + 546] * templateSh[324];
		conv += panelSh[p_idx + 547] * templateSh[323];
		conv += panelSh[p_idx + 548] * templateSh[322];
		conv += panelSh[p_idx + 549] * templateSh[321];
		conv += panelSh[p_idx + 550] * templateSh[320];
		conv += panelSh[p_idx + 551] * templateSh[319];
		conv += panelSh[p_idx + 552] * templateSh[318];
		conv += panelSh[p_idx + 553] * templateSh[317];
		conv += panelSh[p_idx + 554] * templateSh[316];
		conv += panelSh[p_idx + 555] * templateSh[315];
		conv += panelSh[p_idx + 556] * templateSh[314];
		conv += panelSh[p_idx + 557] * templateSh[313];
		conv += panelSh[p_idx + 558] * templateSh[312];
		conv += panelSh[p_idx + 574] * templateSh[311];
		conv += panelSh[p_idx + 575] * templateSh[310];
		conv += panelSh[p_idx + 576] * templateSh[309];
		conv += panelSh[p_idx + 577] * templateSh[308];
		conv += panelSh[p_idx + 578] * templateSh[307];
		conv += panelSh[p_idx + 579] * templateSh[306];
		conv += panelSh[p_idx + 580] * templateSh[305];
		conv += panelSh[p_idx + 581] * templateSh[304];
		conv += panelSh[p_idx + 582] * templateSh[303];
		conv += panelSh[p_idx + 583] * templateSh[302];
		conv += panelSh[p_idx + 584] * templateSh[301];
		conv += panelSh[p_idx + 585] * templateSh[300];
		conv += panelSh[p_idx + 586] * templateSh[299];
		conv += panelSh[p_idx + 587] * templateSh[298];
		conv += panelSh[p_idx + 588] * templateSh[297];
		conv += panelSh[p_idx + 589] * templateSh[296];
		conv += panelSh[p_idx + 590] * templateSh[295];
		conv += panelSh[p_idx + 591] * templateSh[294];
		conv += panelSh[p_idx + 592] * templateSh[293];
		conv += panelSh[p_idx + 593] * templateSh[292];
		conv += panelSh[p_idx + 594] * templateSh[291];
		conv += panelSh[p_idx + 595] * templateSh[290];
		conv += panelSh[p_idx + 596] * templateSh[289];
		conv += panelSh[p_idx + 597] * templateSh[288];
		conv += panelSh[p_idx + 598] * templateSh[287];
		conv += panelSh[p_idx + 599] * templateSh[286];
		conv += panelSh[p_idx + 615] * templateSh[285];
		conv += panelSh[p_idx + 616] * templateSh[284];
		conv += panelSh[p_idx + 617] * templateSh[283];
		conv += panelSh[p_idx + 618] * templateSh[282];
		conv += panelSh[p_idx + 619] * templateSh[281];
		conv += panelSh[p_idx + 620] * templateSh[280];
		conv += panelSh[p_idx + 621] * templateSh[279];
		conv += panelSh[p_idx + 622] * templateSh[278];
		conv += panelSh[p_idx + 623] * templateSh[277];
		conv += panelSh[p_idx + 624] * templateSh[276];
		conv += panelSh[p_idx + 625] * templateSh[275];
		conv += panelSh[p_idx + 626] * templateSh[274];
		conv += panelSh[p_idx + 627] * templateSh[273];
		conv += panelSh[p_idx + 628] * templateSh[272];
		conv += panelSh[p_idx + 629] * templateSh[271];
		conv += panelSh[p_idx + 630] * templateSh[270];
		conv += panelSh[p_idx + 631] * templateSh[269];
		conv += panelSh[p_idx + 632] * templateSh[268];
		conv += panelSh[p_idx + 633] * templateSh[267];
		conv += panelSh[p_idx + 634] * templateSh[266];
		conv += panelSh[p_idx + 635] * templateSh[265];
		conv += panelSh[p_idx + 636] * templateSh[264];
		conv += panelSh[p_idx + 637] * templateSh[263];
		conv += panelSh[p_idx + 638] * templateSh[262];
		conv += panelSh[p_idx + 639] * templateSh[261];
		conv += panelSh[p_idx + 640] * templateSh[260];
		conv += panelSh[p_idx + 656] * templateSh[259];
		conv += panelSh[p_idx + 657] * templateSh[258];
		conv += panelSh[p_idx + 658] * templateSh[257];
		conv += panelSh[p_idx + 659] * templateSh[256];
		conv += panelSh[p_idx + 660] * templateSh[255];
		conv += panelSh[p_idx + 661] * templateSh[254];
		conv += panelSh[p_idx + 662] * templateSh[253];
		conv += panelSh[p_idx + 663] * templateSh[252];
		conv += panelSh[p_idx + 664] * templateSh[251];
		conv += panelSh[p_idx + 665] * templateSh[250];
		conv += panelSh[p_idx + 666] * templateSh[249];
		conv += panelSh[p_idx + 667] * templateSh[248];
		conv += panelSh[p_idx + 668] * templateSh[247];
		conv += panelSh[p_idx + 669] * templateSh[246];
		conv += panelSh[p_idx + 670] * templateSh[245];
		conv += panelSh[p_idx + 671] * templateSh[244];
		conv += panelSh[p_idx + 672] * templateSh[243];
		conv += panelSh[p_idx + 673] * templateSh[242];
		conv += panelSh[p_idx + 674] * templateSh[241];
		conv += panelSh[p_idx + 675] * templateSh[240];
		conv += panelSh[p_idx + 676] * templateSh[239];
		conv += panelSh[p_idx + 677] * templateSh[238];
		conv += panelSh[p_idx + 678] * templateSh[237];
		conv += panelSh[p_idx + 679] * templateSh[236];
		conv += panelSh[p_idx + 680] * templateSh[235];
		conv += panelSh[p_idx + 681] * templateSh[234];
		conv += panelSh[p_idx + 697] * templateSh[233];
		conv += panelSh[p_idx + 698] * templateSh[232];
		conv += panelSh[p_idx + 699] * templateSh[231];
		conv += panelSh[p_idx + 700] * templateSh[230];
		conv += panelSh[p_idx + 701] * templateSh[229];
		conv += panelSh[p_idx + 702] * templateSh[228];
		conv += panelSh[p_idx + 703] * templateSh[227];
		conv += panelSh[p_idx + 704] * templateSh[226];
		conv += panelSh[p_idx + 705] * templateSh[225];
		conv += panelSh[p_idx + 706] * templateSh[224];
		conv += panelSh[p_idx + 707] * templateSh[223];
		conv += panelSh[p_idx + 708] * templateSh[222];
		conv += panelSh[p_idx + 709] * templateSh[221];
		conv += panelSh[p_idx + 710] * templateSh[220];
		conv += panelSh[p_idx + 711] * templateSh[219];
		conv += panelSh[p_idx + 712] * templateSh[218];
		conv += panelSh[p_idx + 713] * templateSh[217];
		conv += panelSh[p_idx + 714] * templateSh[216];
		conv += panelSh[p_idx + 715] * templateSh[215];
		conv += panelSh[p_idx + 716] * templateSh[214];
		conv += panelSh[p_idx + 717] * templateSh[213];
		conv += panelSh[p_idx + 718] * templateSh[212];
		conv += panelSh[p_idx + 719] * templateSh[211];
		conv += panelSh[p_idx + 720] * templateSh[210];
		conv += panelSh[p_idx + 721] * templateSh[209];
		conv += panelSh[p_idx + 722] * templateSh[208];
		conv += panelSh[p_idx + 738] * templateSh[207];
		conv += panelSh[p_idx + 739] * templateSh[206];
		conv += panelSh[p_idx + 740] * templateSh[205];
		conv += panelSh[p_idx + 741] * templateSh[204];
		conv += panelSh[p_idx + 742] * templateSh[203];
		conv += panelSh[p_idx + 743] * templateSh[202];
		conv += panelSh[p_idx + 744] * templateSh[201];
		conv += panelSh[p_idx + 745] * templateSh[200];
		conv += panelSh[p_idx + 746] * templateSh[199];
		conv += panelSh[p_idx + 747] * templateSh[198];
		conv += panelSh[p_idx + 748] * templateSh[197];
		conv += panelSh[p_idx + 749] * templateSh[196];
		conv += panelSh[p_idx + 750] * templateSh[195];
		conv += panelSh[p_idx + 751] * templateSh[194];
		conv += panelSh[p_idx + 752] * templateSh[193];
		conv += panelSh[p_idx + 753] * templateSh[192];
		conv += panelSh[p_idx + 754] * templateSh[191];
		conv += panelSh[p_idx + 755] * templateSh[190];
		conv += panelSh[p_idx + 756] * templateSh[189];
		conv += panelSh[p_idx + 757] * templateSh[188];
		conv += panelSh[p_idx + 758] * templateSh[187];
		conv += panelSh[p_idx + 759] * templateSh[186];
		conv += panelSh[p_idx + 760] * templateSh[185];
		conv += panelSh[p_idx + 761] * templateSh[184];
		conv += panelSh[p_idx + 762] * templateSh[183];
		conv += panelSh[p_idx + 763] * templateSh[182];
		conv += panelSh[p_idx + 779] * templateSh[181];
		conv += panelSh[p_idx + 780] * templateSh[180];
		conv += panelSh[p_idx + 781] * templateSh[179];
		conv += panelSh[p_idx + 782] * templateSh[178];
		conv += panelSh[p_idx + 783] * templateSh[177];
		conv += panelSh[p_idx + 784] * templateSh[176];
		conv += panelSh[p_idx + 785] * templateSh[175];
		conv += panelSh[p_idx + 786] * templateSh[174];
		conv += panelSh[p_idx + 787] * templateSh[173];
		conv += panelSh[p_idx + 788] * templateSh[172];
		conv += panelSh[p_idx + 789] * templateSh[171];
		conv += panelSh[p_idx + 790] * templateSh[170];
		conv += panelSh[p_idx + 791] * templateSh[169];
		conv += panelSh[p_idx + 792] * templateSh[168];
		conv += panelSh[p_idx + 793] * templateSh[167];
		conv += panelSh[p_idx + 794] * templateSh[166];
		conv += panelSh[p_idx + 795] * templateSh[165];
		conv += panelSh[p_idx + 796] * templateSh[164];
		conv += panelSh[p_idx + 797] * templateSh[163];
		conv += panelSh[p_idx + 798] * templateSh[162];
		conv += panelSh[p_idx + 799] * templateSh[161];
		conv += panelSh[p_idx + 800] * templateSh[160];
		conv += panelSh[p_idx + 801] * templateSh[159];
		conv += panelSh[p_idx + 802] * templateSh[158];
		conv += panelSh[p_idx + 803] * templateSh[157];
		conv += panelSh[p_idx + 804] * templateSh[156];
		conv += panelSh[p_idx + 820] * templateSh[155];
		conv += panelSh[p_idx + 821] * templateSh[154];
		conv += panelSh[p_idx + 822] * templateSh[153];
		conv += panelSh[p_idx + 823] * templateSh[152];
		conv += panelSh[p_idx + 824] * templateSh[151];
		conv += panelSh[p_idx + 825] * templateSh[150];
		conv += panelSh[p_idx + 826] * templateSh[149];
		conv += panelSh[p_idx + 827] * templateSh[148];
		conv += panelSh[p_idx + 828] * templateSh[147];
		conv += panelSh[p_idx + 829] * templateSh[146];
		conv += panelSh[p_idx + 830] * templateSh[145];
		conv += panelSh[p_idx + 831] * templateSh[144];
		conv += panelSh[p_idx + 832] * templateSh[143];
		conv += panelSh[p_idx + 833] * templateSh[142];
		conv += panelSh[p_idx + 834] * templateSh[141];
		conv += panelSh[p_idx + 835] * templateSh[140];
		conv += panelSh[p_idx + 836] * templateSh[139];
		conv += panelSh[p_idx + 837] * templateSh[138];
		conv += panelSh[p_idx + 838] * templateSh[137];
		conv += panelSh[p_idx + 839] * templateSh[136];
		conv += panelSh[p_idx + 840] * templateSh[135];
		conv += panelSh[p_idx + 841] * templateSh[134];
		conv += panelSh[p_idx + 842] * templateSh[133];
		conv += panelSh[p_idx + 843] * templateSh[132];
		conv += panelSh[p_idx + 844] * templateSh[131];
		conv += panelSh[p_idx + 845] * templateSh[130];
		conv += panelSh[p_idx + 861] * templateSh[129];
		conv += panelSh[p_idx + 862] * templateSh[128];
		conv += panelSh[p_idx + 863] * templateSh[127];
		conv += panelSh[p_idx + 864] * templateSh[126];
		conv += panelSh[p_idx + 865] * templateSh[125];
		conv += panelSh[p_idx + 866] * templateSh[124];
		conv += panelSh[p_idx + 867] * templateSh[123];
		conv += panelSh[p_idx + 868] * templateSh[122];
		conv += panelSh[p_idx + 869] * templateSh[121];
		conv += panelSh[p_idx + 870] * templateSh[120];
		conv += panelSh[p_idx + 871] * templateSh[119];
		conv += panelSh[p_idx + 872] * templateSh[118];
		conv += panelSh[p_idx + 873] * templateSh[117];
		conv += panelSh[p_idx + 874] * templateSh[116];
		conv += panelSh[p_idx + 875] * templateSh[115];
		conv += panelSh[p_idx + 876] * templateSh[114];
		conv += panelSh[p_idx + 877] * templateSh[113];
		conv += panelSh[p_idx + 878] * templateSh[112];
		conv += panelSh[p_idx + 879] * templateSh[111];
		conv += panelSh[p_idx + 880] * templateSh[110];
		conv += panelSh[p_idx + 881] * templateSh[109];
		conv += panelSh[p_idx + 882] * templateSh[108];
		conv += panelSh[p_idx + 883] * templateSh[107];
		conv += panelSh[p_idx + 884] * templateSh[106];
		conv += panelSh[p_idx + 885] * templateSh[105];
		conv += panelSh[p_idx + 886] * templateSh[104];
		conv += panelSh[p_idx + 902] * templateSh[103];
		conv += panelSh[p_idx + 903] * templateSh[102];
		conv += panelSh[p_idx + 904] * templateSh[101];
		conv += panelSh[p_idx + 905] * templateSh[100];
		conv += panelSh[p_idx + 906] * templateSh[99];
		conv += panelSh[p_idx + 907] * templateSh[98];
		conv += panelSh[p_idx + 908] * templateSh[97];
		conv += panelSh[p_idx + 909] * templateSh[96];
		conv += panelSh[p_idx + 910] * templateSh[95];
		conv += panelSh[p_idx + 911] * templateSh[94];
		conv += panelSh[p_idx + 912] * templateSh[93];
		conv += panelSh[p_idx + 913] * templateSh[92];
		conv += panelSh[p_idx + 914] * templateSh[91];
		conv += panelSh[p_idx + 915] * templateSh[90];
		conv += panelSh[p_idx + 916] * templateSh[89];
		conv += panelSh[p_idx + 917] * templateSh[88];
		conv += panelSh[p_idx + 918] * templateSh[87];
		conv += panelSh[p_idx + 919] * templateSh[86];
		conv += panelSh[p_idx + 920] * templateSh[85];
		conv += panelSh[p_idx + 921] * templateSh[84];
		conv += panelSh[p_idx + 922] * templateSh[83];
		conv += panelSh[p_idx + 923] * templateSh[82];
		conv += panelSh[p_idx + 924] * templateSh[81];
		conv += panelSh[p_idx + 925] * templateSh[80];
		conv += panelSh[p_idx + 926] * templateSh[79];
		conv += panelSh[p_idx + 927] * templateSh[78];
		conv += panelSh[p_idx + 943] * templateSh[77];
		conv += panelSh[p_idx + 944] * templateSh[76];
		conv += panelSh[p_idx + 945] * templateSh[75];
		conv += panelSh[p_idx + 946] * templateSh[74];
		conv += panelSh[p_idx + 947] * templateSh[73];
		conv += panelSh[p_idx + 948] * templateSh[72];
		conv += panelSh[p_idx + 949] * templateSh[71];
		conv += panelSh[p_idx + 950] * templateSh[70];
		conv += panelSh[p_idx + 951] * templateSh[69];
		conv += panelSh[p_idx + 952] * templateSh[68];
		conv += panelSh[p_idx + 953] * templateSh[67];
		conv += panelSh[p_idx + 954] * templateSh[66];
		conv += panelSh[p_idx + 955] * templateSh[65];
		conv += panelSh[p_idx + 956] * templateSh[64];
		conv += panelSh[p_idx + 957] * templateSh[63];
		conv += panelSh[p_idx + 958] * templateSh[62];
		conv += panelSh[p_idx + 959] * templateSh[61];
		conv += panelSh[p_idx + 960] * templateSh[60];
		conv += panelSh[p_idx + 961] * templateSh[59];
		conv += panelSh[p_idx + 962] * templateSh[58];
		conv += panelSh[p_idx + 963] * templateSh[57];
		conv += panelSh[p_idx + 964] * templateSh[56];
		conv += panelSh[p_idx + 965] * templateSh[55];
		conv += panelSh[p_idx + 966] * templateSh[54];
		conv += panelSh[p_idx + 967] * templateSh[53];
		conv += panelSh[p_idx + 968] * templateSh[52];
		conv += panelSh[p_idx + 984] * templateSh[51];
		conv += panelSh[p_idx + 985] * templateSh[50];
		conv += panelSh[p_idx + 986] * templateSh[49];
		conv += panelSh[p_idx + 987] * templateSh[48];
		conv += panelSh[p_idx + 988] * templateSh[47];
		conv += panelSh[p_idx + 989] * templateSh[46];
		conv += panelSh[p_idx + 990] * templateSh[45];
		conv += panelSh[p_idx + 991] * templateSh[44];
		conv += panelSh[p_idx + 992] * templateSh[43];
		conv += panelSh[p_idx + 993] * templateSh[42];
		conv += panelSh[p_idx + 994] * templateSh[41];
		conv += panelSh[p_idx + 995] * templateSh[40];
		conv += panelSh[p_idx + 996] * templateSh[39];
		conv += panelSh[p_idx + 997] * templateSh[38];
		conv += panelSh[p_idx + 998] * templateSh[37];
		conv += panelSh[p_idx + 999] * templateSh[36];
		conv += panelSh[p_idx + 1000] * templateSh[35];
		conv += panelSh[p_idx + 1001] * templateSh[34];
		conv += panelSh[p_idx + 1002] * templateSh[33];
		conv += panelSh[p_idx + 1003] * templateSh[32];
		conv += panelSh[p_idx + 1004] * templateSh[31];
		conv += panelSh[p_idx + 1005] * templateSh[30];
		conv += panelSh[p_idx + 1006] * templateSh[29];
		conv += panelSh[p_idx + 1007] * templateSh[28];
		conv += panelSh[p_idx + 1008] * templateSh[27];
		conv += panelSh[p_idx + 1009] * templateSh[26];
		conv += panelSh[p_idx + 1025] * templateSh[25];
		conv += panelSh[p_idx + 1026] * templateSh[24];
		conv += panelSh[p_idx + 1027] * templateSh[23];
		conv += panelSh[p_idx + 1028] * templateSh[22];
		conv += panelSh[p_idx + 1029] * templateSh[21];
		conv += panelSh[p_idx + 1030] * templateSh[20];
		conv += panelSh[p_idx + 1031] * templateSh[19];
		conv += panelSh[p_idx + 1032] * templateSh[18];
		conv += panelSh[p_idx + 1033] * templateSh[17];
		conv += panelSh[p_idx + 1034] * templateSh[16];
		conv += panelSh[p_idx + 1035] * templateSh[15];
		conv += panelSh[p_idx + 1036] * templateSh[14];
		conv += panelSh[p_idx + 1037] * templateSh[13];
		conv += panelSh[p_idx + 1038] * templateSh[12];
		conv += panelSh[p_idx + 1039] * templateSh[11];
		conv += panelSh[p_idx + 1040] * templateSh[10];
		conv += panelSh[p_idx + 1041] * templateSh[9];
		conv += panelSh[p_idx + 1042] * templateSh[8];
		conv += panelSh[p_idx + 1043] * templateSh[7];
		conv += panelSh[p_idx + 1044] * templateSh[6];
		conv += panelSh[p_idx + 1045] * templateSh[5];
		conv += panelSh[p_idx + 1046] * templateSh[4];
		conv += panelSh[p_idx + 1047] * templateSh[3];
		conv += panelSh[p_idx + 1048] * templateSh[2];
		conv += panelSh[p_idx + 1049] * templateSh[1];
		conv += panelSh[p_idx + 1050] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_26x26<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_26x26<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_27x27 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1764];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<42; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<42; i+=16) {
			panelSh[IMUL(j, 42) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[729];
	for (int j=threadIdx.y; j<27; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<27; i+=16) {
			const int jtwi = IMUL(j, 27) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 42);
		conv += panelSh[p_idx + 0] * templateSh[728];
		conv += panelSh[p_idx + 1] * templateSh[727];
		conv += panelSh[p_idx + 2] * templateSh[726];
		conv += panelSh[p_idx + 3] * templateSh[725];
		conv += panelSh[p_idx + 4] * templateSh[724];
		conv += panelSh[p_idx + 5] * templateSh[723];
		conv += panelSh[p_idx + 6] * templateSh[722];
		conv += panelSh[p_idx + 7] * templateSh[721];
		conv += panelSh[p_idx + 8] * templateSh[720];
		conv += panelSh[p_idx + 9] * templateSh[719];
		conv += panelSh[p_idx + 10] * templateSh[718];
		conv += panelSh[p_idx + 11] * templateSh[717];
		conv += panelSh[p_idx + 12] * templateSh[716];
		conv += panelSh[p_idx + 13] * templateSh[715];
		conv += panelSh[p_idx + 14] * templateSh[714];
		conv += panelSh[p_idx + 15] * templateSh[713];
		conv += panelSh[p_idx + 16] * templateSh[712];
		conv += panelSh[p_idx + 17] * templateSh[711];
		conv += panelSh[p_idx + 18] * templateSh[710];
		conv += panelSh[p_idx + 19] * templateSh[709];
		conv += panelSh[p_idx + 20] * templateSh[708];
		conv += panelSh[p_idx + 21] * templateSh[707];
		conv += panelSh[p_idx + 22] * templateSh[706];
		conv += panelSh[p_idx + 23] * templateSh[705];
		conv += panelSh[p_idx + 24] * templateSh[704];
		conv += panelSh[p_idx + 25] * templateSh[703];
		conv += panelSh[p_idx + 26] * templateSh[702];
		conv += panelSh[p_idx + 42] * templateSh[701];
		conv += panelSh[p_idx + 43] * templateSh[700];
		conv += panelSh[p_idx + 44] * templateSh[699];
		conv += panelSh[p_idx + 45] * templateSh[698];
		conv += panelSh[p_idx + 46] * templateSh[697];
		conv += panelSh[p_idx + 47] * templateSh[696];
		conv += panelSh[p_idx + 48] * templateSh[695];
		conv += panelSh[p_idx + 49] * templateSh[694];
		conv += panelSh[p_idx + 50] * templateSh[693];
		conv += panelSh[p_idx + 51] * templateSh[692];
		conv += panelSh[p_idx + 52] * templateSh[691];
		conv += panelSh[p_idx + 53] * templateSh[690];
		conv += panelSh[p_idx + 54] * templateSh[689];
		conv += panelSh[p_idx + 55] * templateSh[688];
		conv += panelSh[p_idx + 56] * templateSh[687];
		conv += panelSh[p_idx + 57] * templateSh[686];
		conv += panelSh[p_idx + 58] * templateSh[685];
		conv += panelSh[p_idx + 59] * templateSh[684];
		conv += panelSh[p_idx + 60] * templateSh[683];
		conv += panelSh[p_idx + 61] * templateSh[682];
		conv += panelSh[p_idx + 62] * templateSh[681];
		conv += panelSh[p_idx + 63] * templateSh[680];
		conv += panelSh[p_idx + 64] * templateSh[679];
		conv += panelSh[p_idx + 65] * templateSh[678];
		conv += panelSh[p_idx + 66] * templateSh[677];
		conv += panelSh[p_idx + 67] * templateSh[676];
		conv += panelSh[p_idx + 68] * templateSh[675];
		conv += panelSh[p_idx + 84] * templateSh[674];
		conv += panelSh[p_idx + 85] * templateSh[673];
		conv += panelSh[p_idx + 86] * templateSh[672];
		conv += panelSh[p_idx + 87] * templateSh[671];
		conv += panelSh[p_idx + 88] * templateSh[670];
		conv += panelSh[p_idx + 89] * templateSh[669];
		conv += panelSh[p_idx + 90] * templateSh[668];
		conv += panelSh[p_idx + 91] * templateSh[667];
		conv += panelSh[p_idx + 92] * templateSh[666];
		conv += panelSh[p_idx + 93] * templateSh[665];
		conv += panelSh[p_idx + 94] * templateSh[664];
		conv += panelSh[p_idx + 95] * templateSh[663];
		conv += panelSh[p_idx + 96] * templateSh[662];
		conv += panelSh[p_idx + 97] * templateSh[661];
		conv += panelSh[p_idx + 98] * templateSh[660];
		conv += panelSh[p_idx + 99] * templateSh[659];
		conv += panelSh[p_idx + 100] * templateSh[658];
		conv += panelSh[p_idx + 101] * templateSh[657];
		conv += panelSh[p_idx + 102] * templateSh[656];
		conv += panelSh[p_idx + 103] * templateSh[655];
		conv += panelSh[p_idx + 104] * templateSh[654];
		conv += panelSh[p_idx + 105] * templateSh[653];
		conv += panelSh[p_idx + 106] * templateSh[652];
		conv += panelSh[p_idx + 107] * templateSh[651];
		conv += panelSh[p_idx + 108] * templateSh[650];
		conv += panelSh[p_idx + 109] * templateSh[649];
		conv += panelSh[p_idx + 110] * templateSh[648];
		conv += panelSh[p_idx + 126] * templateSh[647];
		conv += panelSh[p_idx + 127] * templateSh[646];
		conv += panelSh[p_idx + 128] * templateSh[645];
		conv += panelSh[p_idx + 129] * templateSh[644];
		conv += panelSh[p_idx + 130] * templateSh[643];
		conv += panelSh[p_idx + 131] * templateSh[642];
		conv += panelSh[p_idx + 132] * templateSh[641];
		conv += panelSh[p_idx + 133] * templateSh[640];
		conv += panelSh[p_idx + 134] * templateSh[639];
		conv += panelSh[p_idx + 135] * templateSh[638];
		conv += panelSh[p_idx + 136] * templateSh[637];
		conv += panelSh[p_idx + 137] * templateSh[636];
		conv += panelSh[p_idx + 138] * templateSh[635];
		conv += panelSh[p_idx + 139] * templateSh[634];
		conv += panelSh[p_idx + 140] * templateSh[633];
		conv += panelSh[p_idx + 141] * templateSh[632];
		conv += panelSh[p_idx + 142] * templateSh[631];
		conv += panelSh[p_idx + 143] * templateSh[630];
		conv += panelSh[p_idx + 144] * templateSh[629];
		conv += panelSh[p_idx + 145] * templateSh[628];
		conv += panelSh[p_idx + 146] * templateSh[627];
		conv += panelSh[p_idx + 147] * templateSh[626];
		conv += panelSh[p_idx + 148] * templateSh[625];
		conv += panelSh[p_idx + 149] * templateSh[624];
		conv += panelSh[p_idx + 150] * templateSh[623];
		conv += panelSh[p_idx + 151] * templateSh[622];
		conv += panelSh[p_idx + 152] * templateSh[621];
		conv += panelSh[p_idx + 168] * templateSh[620];
		conv += panelSh[p_idx + 169] * templateSh[619];
		conv += panelSh[p_idx + 170] * templateSh[618];
		conv += panelSh[p_idx + 171] * templateSh[617];
		conv += panelSh[p_idx + 172] * templateSh[616];
		conv += panelSh[p_idx + 173] * templateSh[615];
		conv += panelSh[p_idx + 174] * templateSh[614];
		conv += panelSh[p_idx + 175] * templateSh[613];
		conv += panelSh[p_idx + 176] * templateSh[612];
		conv += panelSh[p_idx + 177] * templateSh[611];
		conv += panelSh[p_idx + 178] * templateSh[610];
		conv += panelSh[p_idx + 179] * templateSh[609];
		conv += panelSh[p_idx + 180] * templateSh[608];
		conv += panelSh[p_idx + 181] * templateSh[607];
		conv += panelSh[p_idx + 182] * templateSh[606];
		conv += panelSh[p_idx + 183] * templateSh[605];
		conv += panelSh[p_idx + 184] * templateSh[604];
		conv += panelSh[p_idx + 185] * templateSh[603];
		conv += panelSh[p_idx + 186] * templateSh[602];
		conv += panelSh[p_idx + 187] * templateSh[601];
		conv += panelSh[p_idx + 188] * templateSh[600];
		conv += panelSh[p_idx + 189] * templateSh[599];
		conv += panelSh[p_idx + 190] * templateSh[598];
		conv += panelSh[p_idx + 191] * templateSh[597];
		conv += panelSh[p_idx + 192] * templateSh[596];
		conv += panelSh[p_idx + 193] * templateSh[595];
		conv += panelSh[p_idx + 194] * templateSh[594];
		conv += panelSh[p_idx + 210] * templateSh[593];
		conv += panelSh[p_idx + 211] * templateSh[592];
		conv += panelSh[p_idx + 212] * templateSh[591];
		conv += panelSh[p_idx + 213] * templateSh[590];
		conv += panelSh[p_idx + 214] * templateSh[589];
		conv += panelSh[p_idx + 215] * templateSh[588];
		conv += panelSh[p_idx + 216] * templateSh[587];
		conv += panelSh[p_idx + 217] * templateSh[586];
		conv += panelSh[p_idx + 218] * templateSh[585];
		conv += panelSh[p_idx + 219] * templateSh[584];
		conv += panelSh[p_idx + 220] * templateSh[583];
		conv += panelSh[p_idx + 221] * templateSh[582];
		conv += panelSh[p_idx + 222] * templateSh[581];
		conv += panelSh[p_idx + 223] * templateSh[580];
		conv += panelSh[p_idx + 224] * templateSh[579];
		conv += panelSh[p_idx + 225] * templateSh[578];
		conv += panelSh[p_idx + 226] * templateSh[577];
		conv += panelSh[p_idx + 227] * templateSh[576];
		conv += panelSh[p_idx + 228] * templateSh[575];
		conv += panelSh[p_idx + 229] * templateSh[574];
		conv += panelSh[p_idx + 230] * templateSh[573];
		conv += panelSh[p_idx + 231] * templateSh[572];
		conv += panelSh[p_idx + 232] * templateSh[571];
		conv += panelSh[p_idx + 233] * templateSh[570];
		conv += panelSh[p_idx + 234] * templateSh[569];
		conv += panelSh[p_idx + 235] * templateSh[568];
		conv += panelSh[p_idx + 236] * templateSh[567];
		conv += panelSh[p_idx + 252] * templateSh[566];
		conv += panelSh[p_idx + 253] * templateSh[565];
		conv += panelSh[p_idx + 254] * templateSh[564];
		conv += panelSh[p_idx + 255] * templateSh[563];
		conv += panelSh[p_idx + 256] * templateSh[562];
		conv += panelSh[p_idx + 257] * templateSh[561];
		conv += panelSh[p_idx + 258] * templateSh[560];
		conv += panelSh[p_idx + 259] * templateSh[559];
		conv += panelSh[p_idx + 260] * templateSh[558];
		conv += panelSh[p_idx + 261] * templateSh[557];
		conv += panelSh[p_idx + 262] * templateSh[556];
		conv += panelSh[p_idx + 263] * templateSh[555];
		conv += panelSh[p_idx + 264] * templateSh[554];
		conv += panelSh[p_idx + 265] * templateSh[553];
		conv += panelSh[p_idx + 266] * templateSh[552];
		conv += panelSh[p_idx + 267] * templateSh[551];
		conv += panelSh[p_idx + 268] * templateSh[550];
		conv += panelSh[p_idx + 269] * templateSh[549];
		conv += panelSh[p_idx + 270] * templateSh[548];
		conv += panelSh[p_idx + 271] * templateSh[547];
		conv += panelSh[p_idx + 272] * templateSh[546];
		conv += panelSh[p_idx + 273] * templateSh[545];
		conv += panelSh[p_idx + 274] * templateSh[544];
		conv += panelSh[p_idx + 275] * templateSh[543];
		conv += panelSh[p_idx + 276] * templateSh[542];
		conv += panelSh[p_idx + 277] * templateSh[541];
		conv += panelSh[p_idx + 278] * templateSh[540];
		conv += panelSh[p_idx + 294] * templateSh[539];
		conv += panelSh[p_idx + 295] * templateSh[538];
		conv += panelSh[p_idx + 296] * templateSh[537];
		conv += panelSh[p_idx + 297] * templateSh[536];
		conv += panelSh[p_idx + 298] * templateSh[535];
		conv += panelSh[p_idx + 299] * templateSh[534];
		conv += panelSh[p_idx + 300] * templateSh[533];
		conv += panelSh[p_idx + 301] * templateSh[532];
		conv += panelSh[p_idx + 302] * templateSh[531];
		conv += panelSh[p_idx + 303] * templateSh[530];
		conv += panelSh[p_idx + 304] * templateSh[529];
		conv += panelSh[p_idx + 305] * templateSh[528];
		conv += panelSh[p_idx + 306] * templateSh[527];
		conv += panelSh[p_idx + 307] * templateSh[526];
		conv += panelSh[p_idx + 308] * templateSh[525];
		conv += panelSh[p_idx + 309] * templateSh[524];
		conv += panelSh[p_idx + 310] * templateSh[523];
		conv += panelSh[p_idx + 311] * templateSh[522];
		conv += panelSh[p_idx + 312] * templateSh[521];
		conv += panelSh[p_idx + 313] * templateSh[520];
		conv += panelSh[p_idx + 314] * templateSh[519];
		conv += panelSh[p_idx + 315] * templateSh[518];
		conv += panelSh[p_idx + 316] * templateSh[517];
		conv += panelSh[p_idx + 317] * templateSh[516];
		conv += panelSh[p_idx + 318] * templateSh[515];
		conv += panelSh[p_idx + 319] * templateSh[514];
		conv += panelSh[p_idx + 320] * templateSh[513];
		conv += panelSh[p_idx + 336] * templateSh[512];
		conv += panelSh[p_idx + 337] * templateSh[511];
		conv += panelSh[p_idx + 338] * templateSh[510];
		conv += panelSh[p_idx + 339] * templateSh[509];
		conv += panelSh[p_idx + 340] * templateSh[508];
		conv += panelSh[p_idx + 341] * templateSh[507];
		conv += panelSh[p_idx + 342] * templateSh[506];
		conv += panelSh[p_idx + 343] * templateSh[505];
		conv += panelSh[p_idx + 344] * templateSh[504];
		conv += panelSh[p_idx + 345] * templateSh[503];
		conv += panelSh[p_idx + 346] * templateSh[502];
		conv += panelSh[p_idx + 347] * templateSh[501];
		conv += panelSh[p_idx + 348] * templateSh[500];
		conv += panelSh[p_idx + 349] * templateSh[499];
		conv += panelSh[p_idx + 350] * templateSh[498];
		conv += panelSh[p_idx + 351] * templateSh[497];
		conv += panelSh[p_idx + 352] * templateSh[496];
		conv += panelSh[p_idx + 353] * templateSh[495];
		conv += panelSh[p_idx + 354] * templateSh[494];
		conv += panelSh[p_idx + 355] * templateSh[493];
		conv += panelSh[p_idx + 356] * templateSh[492];
		conv += panelSh[p_idx + 357] * templateSh[491];
		conv += panelSh[p_idx + 358] * templateSh[490];
		conv += panelSh[p_idx + 359] * templateSh[489];
		conv += panelSh[p_idx + 360] * templateSh[488];
		conv += panelSh[p_idx + 361] * templateSh[487];
		conv += panelSh[p_idx + 362] * templateSh[486];
		conv += panelSh[p_idx + 378] * templateSh[485];
		conv += panelSh[p_idx + 379] * templateSh[484];
		conv += panelSh[p_idx + 380] * templateSh[483];
		conv += panelSh[p_idx + 381] * templateSh[482];
		conv += panelSh[p_idx + 382] * templateSh[481];
		conv += panelSh[p_idx + 383] * templateSh[480];
		conv += panelSh[p_idx + 384] * templateSh[479];
		conv += panelSh[p_idx + 385] * templateSh[478];
		conv += panelSh[p_idx + 386] * templateSh[477];
		conv += panelSh[p_idx + 387] * templateSh[476];
		conv += panelSh[p_idx + 388] * templateSh[475];
		conv += panelSh[p_idx + 389] * templateSh[474];
		conv += panelSh[p_idx + 390] * templateSh[473];
		conv += panelSh[p_idx + 391] * templateSh[472];
		conv += panelSh[p_idx + 392] * templateSh[471];
		conv += panelSh[p_idx + 393] * templateSh[470];
		conv += panelSh[p_idx + 394] * templateSh[469];
		conv += panelSh[p_idx + 395] * templateSh[468];
		conv += panelSh[p_idx + 396] * templateSh[467];
		conv += panelSh[p_idx + 397] * templateSh[466];
		conv += panelSh[p_idx + 398] * templateSh[465];
		conv += panelSh[p_idx + 399] * templateSh[464];
		conv += panelSh[p_idx + 400] * templateSh[463];
		conv += panelSh[p_idx + 401] * templateSh[462];
		conv += panelSh[p_idx + 402] * templateSh[461];
		conv += panelSh[p_idx + 403] * templateSh[460];
		conv += panelSh[p_idx + 404] * templateSh[459];
		conv += panelSh[p_idx + 420] * templateSh[458];
		conv += panelSh[p_idx + 421] * templateSh[457];
		conv += panelSh[p_idx + 422] * templateSh[456];
		conv += panelSh[p_idx + 423] * templateSh[455];
		conv += panelSh[p_idx + 424] * templateSh[454];
		conv += panelSh[p_idx + 425] * templateSh[453];
		conv += panelSh[p_idx + 426] * templateSh[452];
		conv += panelSh[p_idx + 427] * templateSh[451];
		conv += panelSh[p_idx + 428] * templateSh[450];
		conv += panelSh[p_idx + 429] * templateSh[449];
		conv += panelSh[p_idx + 430] * templateSh[448];
		conv += panelSh[p_idx + 431] * templateSh[447];
		conv += panelSh[p_idx + 432] * templateSh[446];
		conv += panelSh[p_idx + 433] * templateSh[445];
		conv += panelSh[p_idx + 434] * templateSh[444];
		conv += panelSh[p_idx + 435] * templateSh[443];
		conv += panelSh[p_idx + 436] * templateSh[442];
		conv += panelSh[p_idx + 437] * templateSh[441];
		conv += panelSh[p_idx + 438] * templateSh[440];
		conv += panelSh[p_idx + 439] * templateSh[439];
		conv += panelSh[p_idx + 440] * templateSh[438];
		conv += panelSh[p_idx + 441] * templateSh[437];
		conv += panelSh[p_idx + 442] * templateSh[436];
		conv += panelSh[p_idx + 443] * templateSh[435];
		conv += panelSh[p_idx + 444] * templateSh[434];
		conv += panelSh[p_idx + 445] * templateSh[433];
		conv += panelSh[p_idx + 446] * templateSh[432];
		conv += panelSh[p_idx + 462] * templateSh[431];
		conv += panelSh[p_idx + 463] * templateSh[430];
		conv += panelSh[p_idx + 464] * templateSh[429];
		conv += panelSh[p_idx + 465] * templateSh[428];
		conv += panelSh[p_idx + 466] * templateSh[427];
		conv += panelSh[p_idx + 467] * templateSh[426];
		conv += panelSh[p_idx + 468] * templateSh[425];
		conv += panelSh[p_idx + 469] * templateSh[424];
		conv += panelSh[p_idx + 470] * templateSh[423];
		conv += panelSh[p_idx + 471] * templateSh[422];
		conv += panelSh[p_idx + 472] * templateSh[421];
		conv += panelSh[p_idx + 473] * templateSh[420];
		conv += panelSh[p_idx + 474] * templateSh[419];
		conv += panelSh[p_idx + 475] * templateSh[418];
		conv += panelSh[p_idx + 476] * templateSh[417];
		conv += panelSh[p_idx + 477] * templateSh[416];
		conv += panelSh[p_idx + 478] * templateSh[415];
		conv += panelSh[p_idx + 479] * templateSh[414];
		conv += panelSh[p_idx + 480] * templateSh[413];
		conv += panelSh[p_idx + 481] * templateSh[412];
		conv += panelSh[p_idx + 482] * templateSh[411];
		conv += panelSh[p_idx + 483] * templateSh[410];
		conv += panelSh[p_idx + 484] * templateSh[409];
		conv += panelSh[p_idx + 485] * templateSh[408];
		conv += panelSh[p_idx + 486] * templateSh[407];
		conv += panelSh[p_idx + 487] * templateSh[406];
		conv += panelSh[p_idx + 488] * templateSh[405];
		conv += panelSh[p_idx + 504] * templateSh[404];
		conv += panelSh[p_idx + 505] * templateSh[403];
		conv += panelSh[p_idx + 506] * templateSh[402];
		conv += panelSh[p_idx + 507] * templateSh[401];
		conv += panelSh[p_idx + 508] * templateSh[400];
		conv += panelSh[p_idx + 509] * templateSh[399];
		conv += panelSh[p_idx + 510] * templateSh[398];
		conv += panelSh[p_idx + 511] * templateSh[397];
		conv += panelSh[p_idx + 512] * templateSh[396];
		conv += panelSh[p_idx + 513] * templateSh[395];
		conv += panelSh[p_idx + 514] * templateSh[394];
		conv += panelSh[p_idx + 515] * templateSh[393];
		conv += panelSh[p_idx + 516] * templateSh[392];
		conv += panelSh[p_idx + 517] * templateSh[391];
		conv += panelSh[p_idx + 518] * templateSh[390];
		conv += panelSh[p_idx + 519] * templateSh[389];
		conv += panelSh[p_idx + 520] * templateSh[388];
		conv += panelSh[p_idx + 521] * templateSh[387];
		conv += panelSh[p_idx + 522] * templateSh[386];
		conv += panelSh[p_idx + 523] * templateSh[385];
		conv += panelSh[p_idx + 524] * templateSh[384];
		conv += panelSh[p_idx + 525] * templateSh[383];
		conv += panelSh[p_idx + 526] * templateSh[382];
		conv += panelSh[p_idx + 527] * templateSh[381];
		conv += panelSh[p_idx + 528] * templateSh[380];
		conv += panelSh[p_idx + 529] * templateSh[379];
		conv += panelSh[p_idx + 530] * templateSh[378];
		conv += panelSh[p_idx + 546] * templateSh[377];
		conv += panelSh[p_idx + 547] * templateSh[376];
		conv += panelSh[p_idx + 548] * templateSh[375];
		conv += panelSh[p_idx + 549] * templateSh[374];
		conv += panelSh[p_idx + 550] * templateSh[373];
		conv += panelSh[p_idx + 551] * templateSh[372];
		conv += panelSh[p_idx + 552] * templateSh[371];
		conv += panelSh[p_idx + 553] * templateSh[370];
		conv += panelSh[p_idx + 554] * templateSh[369];
		conv += panelSh[p_idx + 555] * templateSh[368];
		conv += panelSh[p_idx + 556] * templateSh[367];
		conv += panelSh[p_idx + 557] * templateSh[366];
		conv += panelSh[p_idx + 558] * templateSh[365];
		conv += panelSh[p_idx + 559] * templateSh[364];
		conv += panelSh[p_idx + 560] * templateSh[363];
		conv += panelSh[p_idx + 561] * templateSh[362];
		conv += panelSh[p_idx + 562] * templateSh[361];
		conv += panelSh[p_idx + 563] * templateSh[360];
		conv += panelSh[p_idx + 564] * templateSh[359];
		conv += panelSh[p_idx + 565] * templateSh[358];
		conv += panelSh[p_idx + 566] * templateSh[357];
		conv += panelSh[p_idx + 567] * templateSh[356];
		conv += panelSh[p_idx + 568] * templateSh[355];
		conv += panelSh[p_idx + 569] * templateSh[354];
		conv += panelSh[p_idx + 570] * templateSh[353];
		conv += panelSh[p_idx + 571] * templateSh[352];
		conv += panelSh[p_idx + 572] * templateSh[351];
		conv += panelSh[p_idx + 588] * templateSh[350];
		conv += panelSh[p_idx + 589] * templateSh[349];
		conv += panelSh[p_idx + 590] * templateSh[348];
		conv += panelSh[p_idx + 591] * templateSh[347];
		conv += panelSh[p_idx + 592] * templateSh[346];
		conv += panelSh[p_idx + 593] * templateSh[345];
		conv += panelSh[p_idx + 594] * templateSh[344];
		conv += panelSh[p_idx + 595] * templateSh[343];
		conv += panelSh[p_idx + 596] * templateSh[342];
		conv += panelSh[p_idx + 597] * templateSh[341];
		conv += panelSh[p_idx + 598] * templateSh[340];
		conv += panelSh[p_idx + 599] * templateSh[339];
		conv += panelSh[p_idx + 600] * templateSh[338];
		conv += panelSh[p_idx + 601] * templateSh[337];
		conv += panelSh[p_idx + 602] * templateSh[336];
		conv += panelSh[p_idx + 603] * templateSh[335];
		conv += panelSh[p_idx + 604] * templateSh[334];
		conv += panelSh[p_idx + 605] * templateSh[333];
		conv += panelSh[p_idx + 606] * templateSh[332];
		conv += panelSh[p_idx + 607] * templateSh[331];
		conv += panelSh[p_idx + 608] * templateSh[330];
		conv += panelSh[p_idx + 609] * templateSh[329];
		conv += panelSh[p_idx + 610] * templateSh[328];
		conv += panelSh[p_idx + 611] * templateSh[327];
		conv += panelSh[p_idx + 612] * templateSh[326];
		conv += panelSh[p_idx + 613] * templateSh[325];
		conv += panelSh[p_idx + 614] * templateSh[324];
		conv += panelSh[p_idx + 630] * templateSh[323];
		conv += panelSh[p_idx + 631] * templateSh[322];
		conv += panelSh[p_idx + 632] * templateSh[321];
		conv += panelSh[p_idx + 633] * templateSh[320];
		conv += panelSh[p_idx + 634] * templateSh[319];
		conv += panelSh[p_idx + 635] * templateSh[318];
		conv += panelSh[p_idx + 636] * templateSh[317];
		conv += panelSh[p_idx + 637] * templateSh[316];
		conv += panelSh[p_idx + 638] * templateSh[315];
		conv += panelSh[p_idx + 639] * templateSh[314];
		conv += panelSh[p_idx + 640] * templateSh[313];
		conv += panelSh[p_idx + 641] * templateSh[312];
		conv += panelSh[p_idx + 642] * templateSh[311];
		conv += panelSh[p_idx + 643] * templateSh[310];
		conv += panelSh[p_idx + 644] * templateSh[309];
		conv += panelSh[p_idx + 645] * templateSh[308];
		conv += panelSh[p_idx + 646] * templateSh[307];
		conv += panelSh[p_idx + 647] * templateSh[306];
		conv += panelSh[p_idx + 648] * templateSh[305];
		conv += panelSh[p_idx + 649] * templateSh[304];
		conv += panelSh[p_idx + 650] * templateSh[303];
		conv += panelSh[p_idx + 651] * templateSh[302];
		conv += panelSh[p_idx + 652] * templateSh[301];
		conv += panelSh[p_idx + 653] * templateSh[300];
		conv += panelSh[p_idx + 654] * templateSh[299];
		conv += panelSh[p_idx + 655] * templateSh[298];
		conv += panelSh[p_idx + 656] * templateSh[297];
		conv += panelSh[p_idx + 672] * templateSh[296];
		conv += panelSh[p_idx + 673] * templateSh[295];
		conv += panelSh[p_idx + 674] * templateSh[294];
		conv += panelSh[p_idx + 675] * templateSh[293];
		conv += panelSh[p_idx + 676] * templateSh[292];
		conv += panelSh[p_idx + 677] * templateSh[291];
		conv += panelSh[p_idx + 678] * templateSh[290];
		conv += panelSh[p_idx + 679] * templateSh[289];
		conv += panelSh[p_idx + 680] * templateSh[288];
		conv += panelSh[p_idx + 681] * templateSh[287];
		conv += panelSh[p_idx + 682] * templateSh[286];
		conv += panelSh[p_idx + 683] * templateSh[285];
		conv += panelSh[p_idx + 684] * templateSh[284];
		conv += panelSh[p_idx + 685] * templateSh[283];
		conv += panelSh[p_idx + 686] * templateSh[282];
		conv += panelSh[p_idx + 687] * templateSh[281];
		conv += panelSh[p_idx + 688] * templateSh[280];
		conv += panelSh[p_idx + 689] * templateSh[279];
		conv += panelSh[p_idx + 690] * templateSh[278];
		conv += panelSh[p_idx + 691] * templateSh[277];
		conv += panelSh[p_idx + 692] * templateSh[276];
		conv += panelSh[p_idx + 693] * templateSh[275];
		conv += panelSh[p_idx + 694] * templateSh[274];
		conv += panelSh[p_idx + 695] * templateSh[273];
		conv += panelSh[p_idx + 696] * templateSh[272];
		conv += panelSh[p_idx + 697] * templateSh[271];
		conv += panelSh[p_idx + 698] * templateSh[270];
		conv += panelSh[p_idx + 714] * templateSh[269];
		conv += panelSh[p_idx + 715] * templateSh[268];
		conv += panelSh[p_idx + 716] * templateSh[267];
		conv += panelSh[p_idx + 717] * templateSh[266];
		conv += panelSh[p_idx + 718] * templateSh[265];
		conv += panelSh[p_idx + 719] * templateSh[264];
		conv += panelSh[p_idx + 720] * templateSh[263];
		conv += panelSh[p_idx + 721] * templateSh[262];
		conv += panelSh[p_idx + 722] * templateSh[261];
		conv += panelSh[p_idx + 723] * templateSh[260];
		conv += panelSh[p_idx + 724] * templateSh[259];
		conv += panelSh[p_idx + 725] * templateSh[258];
		conv += panelSh[p_idx + 726] * templateSh[257];
		conv += panelSh[p_idx + 727] * templateSh[256];
		conv += panelSh[p_idx + 728] * templateSh[255];
		conv += panelSh[p_idx + 729] * templateSh[254];
		conv += panelSh[p_idx + 730] * templateSh[253];
		conv += panelSh[p_idx + 731] * templateSh[252];
		conv += panelSh[p_idx + 732] * templateSh[251];
		conv += panelSh[p_idx + 733] * templateSh[250];
		conv += panelSh[p_idx + 734] * templateSh[249];
		conv += panelSh[p_idx + 735] * templateSh[248];
		conv += panelSh[p_idx + 736] * templateSh[247];
		conv += panelSh[p_idx + 737] * templateSh[246];
		conv += panelSh[p_idx + 738] * templateSh[245];
		conv += panelSh[p_idx + 739] * templateSh[244];
		conv += panelSh[p_idx + 740] * templateSh[243];
		conv += panelSh[p_idx + 756] * templateSh[242];
		conv += panelSh[p_idx + 757] * templateSh[241];
		conv += panelSh[p_idx + 758] * templateSh[240];
		conv += panelSh[p_idx + 759] * templateSh[239];
		conv += panelSh[p_idx + 760] * templateSh[238];
		conv += panelSh[p_idx + 761] * templateSh[237];
		conv += panelSh[p_idx + 762] * templateSh[236];
		conv += panelSh[p_idx + 763] * templateSh[235];
		conv += panelSh[p_idx + 764] * templateSh[234];
		conv += panelSh[p_idx + 765] * templateSh[233];
		conv += panelSh[p_idx + 766] * templateSh[232];
		conv += panelSh[p_idx + 767] * templateSh[231];
		conv += panelSh[p_idx + 768] * templateSh[230];
		conv += panelSh[p_idx + 769] * templateSh[229];
		conv += panelSh[p_idx + 770] * templateSh[228];
		conv += panelSh[p_idx + 771] * templateSh[227];
		conv += panelSh[p_idx + 772] * templateSh[226];
		conv += panelSh[p_idx + 773] * templateSh[225];
		conv += panelSh[p_idx + 774] * templateSh[224];
		conv += panelSh[p_idx + 775] * templateSh[223];
		conv += panelSh[p_idx + 776] * templateSh[222];
		conv += panelSh[p_idx + 777] * templateSh[221];
		conv += panelSh[p_idx + 778] * templateSh[220];
		conv += panelSh[p_idx + 779] * templateSh[219];
		conv += panelSh[p_idx + 780] * templateSh[218];
		conv += panelSh[p_idx + 781] * templateSh[217];
		conv += panelSh[p_idx + 782] * templateSh[216];
		conv += panelSh[p_idx + 798] * templateSh[215];
		conv += panelSh[p_idx + 799] * templateSh[214];
		conv += panelSh[p_idx + 800] * templateSh[213];
		conv += panelSh[p_idx + 801] * templateSh[212];
		conv += panelSh[p_idx + 802] * templateSh[211];
		conv += panelSh[p_idx + 803] * templateSh[210];
		conv += panelSh[p_idx + 804] * templateSh[209];
		conv += panelSh[p_idx + 805] * templateSh[208];
		conv += panelSh[p_idx + 806] * templateSh[207];
		conv += panelSh[p_idx + 807] * templateSh[206];
		conv += panelSh[p_idx + 808] * templateSh[205];
		conv += panelSh[p_idx + 809] * templateSh[204];
		conv += panelSh[p_idx + 810] * templateSh[203];
		conv += panelSh[p_idx + 811] * templateSh[202];
		conv += panelSh[p_idx + 812] * templateSh[201];
		conv += panelSh[p_idx + 813] * templateSh[200];
		conv += panelSh[p_idx + 814] * templateSh[199];
		conv += panelSh[p_idx + 815] * templateSh[198];
		conv += panelSh[p_idx + 816] * templateSh[197];
		conv += panelSh[p_idx + 817] * templateSh[196];
		conv += panelSh[p_idx + 818] * templateSh[195];
		conv += panelSh[p_idx + 819] * templateSh[194];
		conv += panelSh[p_idx + 820] * templateSh[193];
		conv += panelSh[p_idx + 821] * templateSh[192];
		conv += panelSh[p_idx + 822] * templateSh[191];
		conv += panelSh[p_idx + 823] * templateSh[190];
		conv += panelSh[p_idx + 824] * templateSh[189];
		conv += panelSh[p_idx + 840] * templateSh[188];
		conv += panelSh[p_idx + 841] * templateSh[187];
		conv += panelSh[p_idx + 842] * templateSh[186];
		conv += panelSh[p_idx + 843] * templateSh[185];
		conv += panelSh[p_idx + 844] * templateSh[184];
		conv += panelSh[p_idx + 845] * templateSh[183];
		conv += panelSh[p_idx + 846] * templateSh[182];
		conv += panelSh[p_idx + 847] * templateSh[181];
		conv += panelSh[p_idx + 848] * templateSh[180];
		conv += panelSh[p_idx + 849] * templateSh[179];
		conv += panelSh[p_idx + 850] * templateSh[178];
		conv += panelSh[p_idx + 851] * templateSh[177];
		conv += panelSh[p_idx + 852] * templateSh[176];
		conv += panelSh[p_idx + 853] * templateSh[175];
		conv += panelSh[p_idx + 854] * templateSh[174];
		conv += panelSh[p_idx + 855] * templateSh[173];
		conv += panelSh[p_idx + 856] * templateSh[172];
		conv += panelSh[p_idx + 857] * templateSh[171];
		conv += panelSh[p_idx + 858] * templateSh[170];
		conv += panelSh[p_idx + 859] * templateSh[169];
		conv += panelSh[p_idx + 860] * templateSh[168];
		conv += panelSh[p_idx + 861] * templateSh[167];
		conv += panelSh[p_idx + 862] * templateSh[166];
		conv += panelSh[p_idx + 863] * templateSh[165];
		conv += panelSh[p_idx + 864] * templateSh[164];
		conv += panelSh[p_idx + 865] * templateSh[163];
		conv += panelSh[p_idx + 866] * templateSh[162];
		conv += panelSh[p_idx + 882] * templateSh[161];
		conv += panelSh[p_idx + 883] * templateSh[160];
		conv += panelSh[p_idx + 884] * templateSh[159];
		conv += panelSh[p_idx + 885] * templateSh[158];
		conv += panelSh[p_idx + 886] * templateSh[157];
		conv += panelSh[p_idx + 887] * templateSh[156];
		conv += panelSh[p_idx + 888] * templateSh[155];
		conv += panelSh[p_idx + 889] * templateSh[154];
		conv += panelSh[p_idx + 890] * templateSh[153];
		conv += panelSh[p_idx + 891] * templateSh[152];
		conv += panelSh[p_idx + 892] * templateSh[151];
		conv += panelSh[p_idx + 893] * templateSh[150];
		conv += panelSh[p_idx + 894] * templateSh[149];
		conv += panelSh[p_idx + 895] * templateSh[148];
		conv += panelSh[p_idx + 896] * templateSh[147];
		conv += panelSh[p_idx + 897] * templateSh[146];
		conv += panelSh[p_idx + 898] * templateSh[145];
		conv += panelSh[p_idx + 899] * templateSh[144];
		conv += panelSh[p_idx + 900] * templateSh[143];
		conv += panelSh[p_idx + 901] * templateSh[142];
		conv += panelSh[p_idx + 902] * templateSh[141];
		conv += panelSh[p_idx + 903] * templateSh[140];
		conv += panelSh[p_idx + 904] * templateSh[139];
		conv += panelSh[p_idx + 905] * templateSh[138];
		conv += panelSh[p_idx + 906] * templateSh[137];
		conv += panelSh[p_idx + 907] * templateSh[136];
		conv += panelSh[p_idx + 908] * templateSh[135];
		conv += panelSh[p_idx + 924] * templateSh[134];
		conv += panelSh[p_idx + 925] * templateSh[133];
		conv += panelSh[p_idx + 926] * templateSh[132];
		conv += panelSh[p_idx + 927] * templateSh[131];
		conv += panelSh[p_idx + 928] * templateSh[130];
		conv += panelSh[p_idx + 929] * templateSh[129];
		conv += panelSh[p_idx + 930] * templateSh[128];
		conv += panelSh[p_idx + 931] * templateSh[127];
		conv += panelSh[p_idx + 932] * templateSh[126];
		conv += panelSh[p_idx + 933] * templateSh[125];
		conv += panelSh[p_idx + 934] * templateSh[124];
		conv += panelSh[p_idx + 935] * templateSh[123];
		conv += panelSh[p_idx + 936] * templateSh[122];
		conv += panelSh[p_idx + 937] * templateSh[121];
		conv += panelSh[p_idx + 938] * templateSh[120];
		conv += panelSh[p_idx + 939] * templateSh[119];
		conv += panelSh[p_idx + 940] * templateSh[118];
		conv += panelSh[p_idx + 941] * templateSh[117];
		conv += panelSh[p_idx + 942] * templateSh[116];
		conv += panelSh[p_idx + 943] * templateSh[115];
		conv += panelSh[p_idx + 944] * templateSh[114];
		conv += panelSh[p_idx + 945] * templateSh[113];
		conv += panelSh[p_idx + 946] * templateSh[112];
		conv += panelSh[p_idx + 947] * templateSh[111];
		conv += panelSh[p_idx + 948] * templateSh[110];
		conv += panelSh[p_idx + 949] * templateSh[109];
		conv += panelSh[p_idx + 950] * templateSh[108];
		conv += panelSh[p_idx + 966] * templateSh[107];
		conv += panelSh[p_idx + 967] * templateSh[106];
		conv += panelSh[p_idx + 968] * templateSh[105];
		conv += panelSh[p_idx + 969] * templateSh[104];
		conv += panelSh[p_idx + 970] * templateSh[103];
		conv += panelSh[p_idx + 971] * templateSh[102];
		conv += panelSh[p_idx + 972] * templateSh[101];
		conv += panelSh[p_idx + 973] * templateSh[100];
		conv += panelSh[p_idx + 974] * templateSh[99];
		conv += panelSh[p_idx + 975] * templateSh[98];
		conv += panelSh[p_idx + 976] * templateSh[97];
		conv += panelSh[p_idx + 977] * templateSh[96];
		conv += panelSh[p_idx + 978] * templateSh[95];
		conv += panelSh[p_idx + 979] * templateSh[94];
		conv += panelSh[p_idx + 980] * templateSh[93];
		conv += panelSh[p_idx + 981] * templateSh[92];
		conv += panelSh[p_idx + 982] * templateSh[91];
		conv += panelSh[p_idx + 983] * templateSh[90];
		conv += panelSh[p_idx + 984] * templateSh[89];
		conv += panelSh[p_idx + 985] * templateSh[88];
		conv += panelSh[p_idx + 986] * templateSh[87];
		conv += panelSh[p_idx + 987] * templateSh[86];
		conv += panelSh[p_idx + 988] * templateSh[85];
		conv += panelSh[p_idx + 989] * templateSh[84];
		conv += panelSh[p_idx + 990] * templateSh[83];
		conv += panelSh[p_idx + 991] * templateSh[82];
		conv += panelSh[p_idx + 992] * templateSh[81];
		conv += panelSh[p_idx + 1008] * templateSh[80];
		conv += panelSh[p_idx + 1009] * templateSh[79];
		conv += panelSh[p_idx + 1010] * templateSh[78];
		conv += panelSh[p_idx + 1011] * templateSh[77];
		conv += panelSh[p_idx + 1012] * templateSh[76];
		conv += panelSh[p_idx + 1013] * templateSh[75];
		conv += panelSh[p_idx + 1014] * templateSh[74];
		conv += panelSh[p_idx + 1015] * templateSh[73];
		conv += panelSh[p_idx + 1016] * templateSh[72];
		conv += panelSh[p_idx + 1017] * templateSh[71];
		conv += panelSh[p_idx + 1018] * templateSh[70];
		conv += panelSh[p_idx + 1019] * templateSh[69];
		conv += panelSh[p_idx + 1020] * templateSh[68];
		conv += panelSh[p_idx + 1021] * templateSh[67];
		conv += panelSh[p_idx + 1022] * templateSh[66];
		conv += panelSh[p_idx + 1023] * templateSh[65];
		conv += panelSh[p_idx + 1024] * templateSh[64];
		conv += panelSh[p_idx + 1025] * templateSh[63];
		conv += panelSh[p_idx + 1026] * templateSh[62];
		conv += panelSh[p_idx + 1027] * templateSh[61];
		conv += panelSh[p_idx + 1028] * templateSh[60];
		conv += panelSh[p_idx + 1029] * templateSh[59];
		conv += panelSh[p_idx + 1030] * templateSh[58];
		conv += panelSh[p_idx + 1031] * templateSh[57];
		conv += panelSh[p_idx + 1032] * templateSh[56];
		conv += panelSh[p_idx + 1033] * templateSh[55];
		conv += panelSh[p_idx + 1034] * templateSh[54];
		conv += panelSh[p_idx + 1050] * templateSh[53];
		conv += panelSh[p_idx + 1051] * templateSh[52];
		conv += panelSh[p_idx + 1052] * templateSh[51];
		conv += panelSh[p_idx + 1053] * templateSh[50];
		conv += panelSh[p_idx + 1054] * templateSh[49];
		conv += panelSh[p_idx + 1055] * templateSh[48];
		conv += panelSh[p_idx + 1056] * templateSh[47];
		conv += panelSh[p_idx + 1057] * templateSh[46];
		conv += panelSh[p_idx + 1058] * templateSh[45];
		conv += panelSh[p_idx + 1059] * templateSh[44];
		conv += panelSh[p_idx + 1060] * templateSh[43];
		conv += panelSh[p_idx + 1061] * templateSh[42];
		conv += panelSh[p_idx + 1062] * templateSh[41];
		conv += panelSh[p_idx + 1063] * templateSh[40];
		conv += panelSh[p_idx + 1064] * templateSh[39];
		conv += panelSh[p_idx + 1065] * templateSh[38];
		conv += panelSh[p_idx + 1066] * templateSh[37];
		conv += panelSh[p_idx + 1067] * templateSh[36];
		conv += panelSh[p_idx + 1068] * templateSh[35];
		conv += panelSh[p_idx + 1069] * templateSh[34];
		conv += panelSh[p_idx + 1070] * templateSh[33];
		conv += panelSh[p_idx + 1071] * templateSh[32];
		conv += panelSh[p_idx + 1072] * templateSh[31];
		conv += panelSh[p_idx + 1073] * templateSh[30];
		conv += panelSh[p_idx + 1074] * templateSh[29];
		conv += panelSh[p_idx + 1075] * templateSh[28];
		conv += panelSh[p_idx + 1076] * templateSh[27];
		conv += panelSh[p_idx + 1092] * templateSh[26];
		conv += panelSh[p_idx + 1093] * templateSh[25];
		conv += panelSh[p_idx + 1094] * templateSh[24];
		conv += panelSh[p_idx + 1095] * templateSh[23];
		conv += panelSh[p_idx + 1096] * templateSh[22];
		conv += panelSh[p_idx + 1097] * templateSh[21];
		conv += panelSh[p_idx + 1098] * templateSh[20];
		conv += panelSh[p_idx + 1099] * templateSh[19];
		conv += panelSh[p_idx + 1100] * templateSh[18];
		conv += panelSh[p_idx + 1101] * templateSh[17];
		conv += panelSh[p_idx + 1102] * templateSh[16];
		conv += panelSh[p_idx + 1103] * templateSh[15];
		conv += panelSh[p_idx + 1104] * templateSh[14];
		conv += panelSh[p_idx + 1105] * templateSh[13];
		conv += panelSh[p_idx + 1106] * templateSh[12];
		conv += panelSh[p_idx + 1107] * templateSh[11];
		conv += panelSh[p_idx + 1108] * templateSh[10];
		conv += panelSh[p_idx + 1109] * templateSh[9];
		conv += panelSh[p_idx + 1110] * templateSh[8];
		conv += panelSh[p_idx + 1111] * templateSh[7];
		conv += panelSh[p_idx + 1112] * templateSh[6];
		conv += panelSh[p_idx + 1113] * templateSh[5];
		conv += panelSh[p_idx + 1114] * templateSh[4];
		conv += panelSh[p_idx + 1115] * templateSh[3];
		conv += panelSh[p_idx + 1116] * templateSh[2];
		conv += panelSh[p_idx + 1117] * templateSh[1];
		conv += panelSh[p_idx + 1118] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_27x27<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_27x27<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_28x28 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1849];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<43; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<43; i+=16) {
			panelSh[IMUL(j, 43) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[784];
	for (int j=threadIdx.y; j<28; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<28; i+=16) {
			const int jtwi = IMUL(j, 28) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 43);
		conv += panelSh[p_idx + 0] * templateSh[783];
		conv += panelSh[p_idx + 1] * templateSh[782];
		conv += panelSh[p_idx + 2] * templateSh[781];
		conv += panelSh[p_idx + 3] * templateSh[780];
		conv += panelSh[p_idx + 4] * templateSh[779];
		conv += panelSh[p_idx + 5] * templateSh[778];
		conv += panelSh[p_idx + 6] * templateSh[777];
		conv += panelSh[p_idx + 7] * templateSh[776];
		conv += panelSh[p_idx + 8] * templateSh[775];
		conv += panelSh[p_idx + 9] * templateSh[774];
		conv += panelSh[p_idx + 10] * templateSh[773];
		conv += panelSh[p_idx + 11] * templateSh[772];
		conv += panelSh[p_idx + 12] * templateSh[771];
		conv += panelSh[p_idx + 13] * templateSh[770];
		conv += panelSh[p_idx + 14] * templateSh[769];
		conv += panelSh[p_idx + 15] * templateSh[768];
		conv += panelSh[p_idx + 16] * templateSh[767];
		conv += panelSh[p_idx + 17] * templateSh[766];
		conv += panelSh[p_idx + 18] * templateSh[765];
		conv += panelSh[p_idx + 19] * templateSh[764];
		conv += panelSh[p_idx + 20] * templateSh[763];
		conv += panelSh[p_idx + 21] * templateSh[762];
		conv += panelSh[p_idx + 22] * templateSh[761];
		conv += panelSh[p_idx + 23] * templateSh[760];
		conv += panelSh[p_idx + 24] * templateSh[759];
		conv += panelSh[p_idx + 25] * templateSh[758];
		conv += panelSh[p_idx + 26] * templateSh[757];
		conv += panelSh[p_idx + 27] * templateSh[756];
		conv += panelSh[p_idx + 43] * templateSh[755];
		conv += panelSh[p_idx + 44] * templateSh[754];
		conv += panelSh[p_idx + 45] * templateSh[753];
		conv += panelSh[p_idx + 46] * templateSh[752];
		conv += panelSh[p_idx + 47] * templateSh[751];
		conv += panelSh[p_idx + 48] * templateSh[750];
		conv += panelSh[p_idx + 49] * templateSh[749];
		conv += panelSh[p_idx + 50] * templateSh[748];
		conv += panelSh[p_idx + 51] * templateSh[747];
		conv += panelSh[p_idx + 52] * templateSh[746];
		conv += panelSh[p_idx + 53] * templateSh[745];
		conv += panelSh[p_idx + 54] * templateSh[744];
		conv += panelSh[p_idx + 55] * templateSh[743];
		conv += panelSh[p_idx + 56] * templateSh[742];
		conv += panelSh[p_idx + 57] * templateSh[741];
		conv += panelSh[p_idx + 58] * templateSh[740];
		conv += panelSh[p_idx + 59] * templateSh[739];
		conv += panelSh[p_idx + 60] * templateSh[738];
		conv += panelSh[p_idx + 61] * templateSh[737];
		conv += panelSh[p_idx + 62] * templateSh[736];
		conv += panelSh[p_idx + 63] * templateSh[735];
		conv += panelSh[p_idx + 64] * templateSh[734];
		conv += panelSh[p_idx + 65] * templateSh[733];
		conv += panelSh[p_idx + 66] * templateSh[732];
		conv += panelSh[p_idx + 67] * templateSh[731];
		conv += panelSh[p_idx + 68] * templateSh[730];
		conv += panelSh[p_idx + 69] * templateSh[729];
		conv += panelSh[p_idx + 70] * templateSh[728];
		conv += panelSh[p_idx + 86] * templateSh[727];
		conv += panelSh[p_idx + 87] * templateSh[726];
		conv += panelSh[p_idx + 88] * templateSh[725];
		conv += panelSh[p_idx + 89] * templateSh[724];
		conv += panelSh[p_idx + 90] * templateSh[723];
		conv += panelSh[p_idx + 91] * templateSh[722];
		conv += panelSh[p_idx + 92] * templateSh[721];
		conv += panelSh[p_idx + 93] * templateSh[720];
		conv += panelSh[p_idx + 94] * templateSh[719];
		conv += panelSh[p_idx + 95] * templateSh[718];
		conv += panelSh[p_idx + 96] * templateSh[717];
		conv += panelSh[p_idx + 97] * templateSh[716];
		conv += panelSh[p_idx + 98] * templateSh[715];
		conv += panelSh[p_idx + 99] * templateSh[714];
		conv += panelSh[p_idx + 100] * templateSh[713];
		conv += panelSh[p_idx + 101] * templateSh[712];
		conv += panelSh[p_idx + 102] * templateSh[711];
		conv += panelSh[p_idx + 103] * templateSh[710];
		conv += panelSh[p_idx + 104] * templateSh[709];
		conv += panelSh[p_idx + 105] * templateSh[708];
		conv += panelSh[p_idx + 106] * templateSh[707];
		conv += panelSh[p_idx + 107] * templateSh[706];
		conv += panelSh[p_idx + 108] * templateSh[705];
		conv += panelSh[p_idx + 109] * templateSh[704];
		conv += panelSh[p_idx + 110] * templateSh[703];
		conv += panelSh[p_idx + 111] * templateSh[702];
		conv += panelSh[p_idx + 112] * templateSh[701];
		conv += panelSh[p_idx + 113] * templateSh[700];
		conv += panelSh[p_idx + 129] * templateSh[699];
		conv += panelSh[p_idx + 130] * templateSh[698];
		conv += panelSh[p_idx + 131] * templateSh[697];
		conv += panelSh[p_idx + 132] * templateSh[696];
		conv += panelSh[p_idx + 133] * templateSh[695];
		conv += panelSh[p_idx + 134] * templateSh[694];
		conv += panelSh[p_idx + 135] * templateSh[693];
		conv += panelSh[p_idx + 136] * templateSh[692];
		conv += panelSh[p_idx + 137] * templateSh[691];
		conv += panelSh[p_idx + 138] * templateSh[690];
		conv += panelSh[p_idx + 139] * templateSh[689];
		conv += panelSh[p_idx + 140] * templateSh[688];
		conv += panelSh[p_idx + 141] * templateSh[687];
		conv += panelSh[p_idx + 142] * templateSh[686];
		conv += panelSh[p_idx + 143] * templateSh[685];
		conv += panelSh[p_idx + 144] * templateSh[684];
		conv += panelSh[p_idx + 145] * templateSh[683];
		conv += panelSh[p_idx + 146] * templateSh[682];
		conv += panelSh[p_idx + 147] * templateSh[681];
		conv += panelSh[p_idx + 148] * templateSh[680];
		conv += panelSh[p_idx + 149] * templateSh[679];
		conv += panelSh[p_idx + 150] * templateSh[678];
		conv += panelSh[p_idx + 151] * templateSh[677];
		conv += panelSh[p_idx + 152] * templateSh[676];
		conv += panelSh[p_idx + 153] * templateSh[675];
		conv += panelSh[p_idx + 154] * templateSh[674];
		conv += panelSh[p_idx + 155] * templateSh[673];
		conv += panelSh[p_idx + 156] * templateSh[672];
		conv += panelSh[p_idx + 172] * templateSh[671];
		conv += panelSh[p_idx + 173] * templateSh[670];
		conv += panelSh[p_idx + 174] * templateSh[669];
		conv += panelSh[p_idx + 175] * templateSh[668];
		conv += panelSh[p_idx + 176] * templateSh[667];
		conv += panelSh[p_idx + 177] * templateSh[666];
		conv += panelSh[p_idx + 178] * templateSh[665];
		conv += panelSh[p_idx + 179] * templateSh[664];
		conv += panelSh[p_idx + 180] * templateSh[663];
		conv += panelSh[p_idx + 181] * templateSh[662];
		conv += panelSh[p_idx + 182] * templateSh[661];
		conv += panelSh[p_idx + 183] * templateSh[660];
		conv += panelSh[p_idx + 184] * templateSh[659];
		conv += panelSh[p_idx + 185] * templateSh[658];
		conv += panelSh[p_idx + 186] * templateSh[657];
		conv += panelSh[p_idx + 187] * templateSh[656];
		conv += panelSh[p_idx + 188] * templateSh[655];
		conv += panelSh[p_idx + 189] * templateSh[654];
		conv += panelSh[p_idx + 190] * templateSh[653];
		conv += panelSh[p_idx + 191] * templateSh[652];
		conv += panelSh[p_idx + 192] * templateSh[651];
		conv += panelSh[p_idx + 193] * templateSh[650];
		conv += panelSh[p_idx + 194] * templateSh[649];
		conv += panelSh[p_idx + 195] * templateSh[648];
		conv += panelSh[p_idx + 196] * templateSh[647];
		conv += panelSh[p_idx + 197] * templateSh[646];
		conv += panelSh[p_idx + 198] * templateSh[645];
		conv += panelSh[p_idx + 199] * templateSh[644];
		conv += panelSh[p_idx + 215] * templateSh[643];
		conv += panelSh[p_idx + 216] * templateSh[642];
		conv += panelSh[p_idx + 217] * templateSh[641];
		conv += panelSh[p_idx + 218] * templateSh[640];
		conv += panelSh[p_idx + 219] * templateSh[639];
		conv += panelSh[p_idx + 220] * templateSh[638];
		conv += panelSh[p_idx + 221] * templateSh[637];
		conv += panelSh[p_idx + 222] * templateSh[636];
		conv += panelSh[p_idx + 223] * templateSh[635];
		conv += panelSh[p_idx + 224] * templateSh[634];
		conv += panelSh[p_idx + 225] * templateSh[633];
		conv += panelSh[p_idx + 226] * templateSh[632];
		conv += panelSh[p_idx + 227] * templateSh[631];
		conv += panelSh[p_idx + 228] * templateSh[630];
		conv += panelSh[p_idx + 229] * templateSh[629];
		conv += panelSh[p_idx + 230] * templateSh[628];
		conv += panelSh[p_idx + 231] * templateSh[627];
		conv += panelSh[p_idx + 232] * templateSh[626];
		conv += panelSh[p_idx + 233] * templateSh[625];
		conv += panelSh[p_idx + 234] * templateSh[624];
		conv += panelSh[p_idx + 235] * templateSh[623];
		conv += panelSh[p_idx + 236] * templateSh[622];
		conv += panelSh[p_idx + 237] * templateSh[621];
		conv += panelSh[p_idx + 238] * templateSh[620];
		conv += panelSh[p_idx + 239] * templateSh[619];
		conv += panelSh[p_idx + 240] * templateSh[618];
		conv += panelSh[p_idx + 241] * templateSh[617];
		conv += panelSh[p_idx + 242] * templateSh[616];
		conv += panelSh[p_idx + 258] * templateSh[615];
		conv += panelSh[p_idx + 259] * templateSh[614];
		conv += panelSh[p_idx + 260] * templateSh[613];
		conv += panelSh[p_idx + 261] * templateSh[612];
		conv += panelSh[p_idx + 262] * templateSh[611];
		conv += panelSh[p_idx + 263] * templateSh[610];
		conv += panelSh[p_idx + 264] * templateSh[609];
		conv += panelSh[p_idx + 265] * templateSh[608];
		conv += panelSh[p_idx + 266] * templateSh[607];
		conv += panelSh[p_idx + 267] * templateSh[606];
		conv += panelSh[p_idx + 268] * templateSh[605];
		conv += panelSh[p_idx + 269] * templateSh[604];
		conv += panelSh[p_idx + 270] * templateSh[603];
		conv += panelSh[p_idx + 271] * templateSh[602];
		conv += panelSh[p_idx + 272] * templateSh[601];
		conv += panelSh[p_idx + 273] * templateSh[600];
		conv += panelSh[p_idx + 274] * templateSh[599];
		conv += panelSh[p_idx + 275] * templateSh[598];
		conv += panelSh[p_idx + 276] * templateSh[597];
		conv += panelSh[p_idx + 277] * templateSh[596];
		conv += panelSh[p_idx + 278] * templateSh[595];
		conv += panelSh[p_idx + 279] * templateSh[594];
		conv += panelSh[p_idx + 280] * templateSh[593];
		conv += panelSh[p_idx + 281] * templateSh[592];
		conv += panelSh[p_idx + 282] * templateSh[591];
		conv += panelSh[p_idx + 283] * templateSh[590];
		conv += panelSh[p_idx + 284] * templateSh[589];
		conv += panelSh[p_idx + 285] * templateSh[588];
		conv += panelSh[p_idx + 301] * templateSh[587];
		conv += panelSh[p_idx + 302] * templateSh[586];
		conv += panelSh[p_idx + 303] * templateSh[585];
		conv += panelSh[p_idx + 304] * templateSh[584];
		conv += panelSh[p_idx + 305] * templateSh[583];
		conv += panelSh[p_idx + 306] * templateSh[582];
		conv += panelSh[p_idx + 307] * templateSh[581];
		conv += panelSh[p_idx + 308] * templateSh[580];
		conv += panelSh[p_idx + 309] * templateSh[579];
		conv += panelSh[p_idx + 310] * templateSh[578];
		conv += panelSh[p_idx + 311] * templateSh[577];
		conv += panelSh[p_idx + 312] * templateSh[576];
		conv += panelSh[p_idx + 313] * templateSh[575];
		conv += panelSh[p_idx + 314] * templateSh[574];
		conv += panelSh[p_idx + 315] * templateSh[573];
		conv += panelSh[p_idx + 316] * templateSh[572];
		conv += panelSh[p_idx + 317] * templateSh[571];
		conv += panelSh[p_idx + 318] * templateSh[570];
		conv += panelSh[p_idx + 319] * templateSh[569];
		conv += panelSh[p_idx + 320] * templateSh[568];
		conv += panelSh[p_idx + 321] * templateSh[567];
		conv += panelSh[p_idx + 322] * templateSh[566];
		conv += panelSh[p_idx + 323] * templateSh[565];
		conv += panelSh[p_idx + 324] * templateSh[564];
		conv += panelSh[p_idx + 325] * templateSh[563];
		conv += panelSh[p_idx + 326] * templateSh[562];
		conv += panelSh[p_idx + 327] * templateSh[561];
		conv += panelSh[p_idx + 328] * templateSh[560];
		conv += panelSh[p_idx + 344] * templateSh[559];
		conv += panelSh[p_idx + 345] * templateSh[558];
		conv += panelSh[p_idx + 346] * templateSh[557];
		conv += panelSh[p_idx + 347] * templateSh[556];
		conv += panelSh[p_idx + 348] * templateSh[555];
		conv += panelSh[p_idx + 349] * templateSh[554];
		conv += panelSh[p_idx + 350] * templateSh[553];
		conv += panelSh[p_idx + 351] * templateSh[552];
		conv += panelSh[p_idx + 352] * templateSh[551];
		conv += panelSh[p_idx + 353] * templateSh[550];
		conv += panelSh[p_idx + 354] * templateSh[549];
		conv += panelSh[p_idx + 355] * templateSh[548];
		conv += panelSh[p_idx + 356] * templateSh[547];
		conv += panelSh[p_idx + 357] * templateSh[546];
		conv += panelSh[p_idx + 358] * templateSh[545];
		conv += panelSh[p_idx + 359] * templateSh[544];
		conv += panelSh[p_idx + 360] * templateSh[543];
		conv += panelSh[p_idx + 361] * templateSh[542];
		conv += panelSh[p_idx + 362] * templateSh[541];
		conv += panelSh[p_idx + 363] * templateSh[540];
		conv += panelSh[p_idx + 364] * templateSh[539];
		conv += panelSh[p_idx + 365] * templateSh[538];
		conv += panelSh[p_idx + 366] * templateSh[537];
		conv += panelSh[p_idx + 367] * templateSh[536];
		conv += panelSh[p_idx + 368] * templateSh[535];
		conv += panelSh[p_idx + 369] * templateSh[534];
		conv += panelSh[p_idx + 370] * templateSh[533];
		conv += panelSh[p_idx + 371] * templateSh[532];
		conv += panelSh[p_idx + 387] * templateSh[531];
		conv += panelSh[p_idx + 388] * templateSh[530];
		conv += panelSh[p_idx + 389] * templateSh[529];
		conv += panelSh[p_idx + 390] * templateSh[528];
		conv += panelSh[p_idx + 391] * templateSh[527];
		conv += panelSh[p_idx + 392] * templateSh[526];
		conv += panelSh[p_idx + 393] * templateSh[525];
		conv += panelSh[p_idx + 394] * templateSh[524];
		conv += panelSh[p_idx + 395] * templateSh[523];
		conv += panelSh[p_idx + 396] * templateSh[522];
		conv += panelSh[p_idx + 397] * templateSh[521];
		conv += panelSh[p_idx + 398] * templateSh[520];
		conv += panelSh[p_idx + 399] * templateSh[519];
		conv += panelSh[p_idx + 400] * templateSh[518];
		conv += panelSh[p_idx + 401] * templateSh[517];
		conv += panelSh[p_idx + 402] * templateSh[516];
		conv += panelSh[p_idx + 403] * templateSh[515];
		conv += panelSh[p_idx + 404] * templateSh[514];
		conv += panelSh[p_idx + 405] * templateSh[513];
		conv += panelSh[p_idx + 406] * templateSh[512];
		conv += panelSh[p_idx + 407] * templateSh[511];
		conv += panelSh[p_idx + 408] * templateSh[510];
		conv += panelSh[p_idx + 409] * templateSh[509];
		conv += panelSh[p_idx + 410] * templateSh[508];
		conv += panelSh[p_idx + 411] * templateSh[507];
		conv += panelSh[p_idx + 412] * templateSh[506];
		conv += panelSh[p_idx + 413] * templateSh[505];
		conv += panelSh[p_idx + 414] * templateSh[504];
		conv += panelSh[p_idx + 430] * templateSh[503];
		conv += panelSh[p_idx + 431] * templateSh[502];
		conv += panelSh[p_idx + 432] * templateSh[501];
		conv += panelSh[p_idx + 433] * templateSh[500];
		conv += panelSh[p_idx + 434] * templateSh[499];
		conv += panelSh[p_idx + 435] * templateSh[498];
		conv += panelSh[p_idx + 436] * templateSh[497];
		conv += panelSh[p_idx + 437] * templateSh[496];
		conv += panelSh[p_idx + 438] * templateSh[495];
		conv += panelSh[p_idx + 439] * templateSh[494];
		conv += panelSh[p_idx + 440] * templateSh[493];
		conv += panelSh[p_idx + 441] * templateSh[492];
		conv += panelSh[p_idx + 442] * templateSh[491];
		conv += panelSh[p_idx + 443] * templateSh[490];
		conv += panelSh[p_idx + 444] * templateSh[489];
		conv += panelSh[p_idx + 445] * templateSh[488];
		conv += panelSh[p_idx + 446] * templateSh[487];
		conv += panelSh[p_idx + 447] * templateSh[486];
		conv += panelSh[p_idx + 448] * templateSh[485];
		conv += panelSh[p_idx + 449] * templateSh[484];
		conv += panelSh[p_idx + 450] * templateSh[483];
		conv += panelSh[p_idx + 451] * templateSh[482];
		conv += panelSh[p_idx + 452] * templateSh[481];
		conv += panelSh[p_idx + 453] * templateSh[480];
		conv += panelSh[p_idx + 454] * templateSh[479];
		conv += panelSh[p_idx + 455] * templateSh[478];
		conv += panelSh[p_idx + 456] * templateSh[477];
		conv += panelSh[p_idx + 457] * templateSh[476];
		conv += panelSh[p_idx + 473] * templateSh[475];
		conv += panelSh[p_idx + 474] * templateSh[474];
		conv += panelSh[p_idx + 475] * templateSh[473];
		conv += panelSh[p_idx + 476] * templateSh[472];
		conv += panelSh[p_idx + 477] * templateSh[471];
		conv += panelSh[p_idx + 478] * templateSh[470];
		conv += panelSh[p_idx + 479] * templateSh[469];
		conv += panelSh[p_idx + 480] * templateSh[468];
		conv += panelSh[p_idx + 481] * templateSh[467];
		conv += panelSh[p_idx + 482] * templateSh[466];
		conv += panelSh[p_idx + 483] * templateSh[465];
		conv += panelSh[p_idx + 484] * templateSh[464];
		conv += panelSh[p_idx + 485] * templateSh[463];
		conv += panelSh[p_idx + 486] * templateSh[462];
		conv += panelSh[p_idx + 487] * templateSh[461];
		conv += panelSh[p_idx + 488] * templateSh[460];
		conv += panelSh[p_idx + 489] * templateSh[459];
		conv += panelSh[p_idx + 490] * templateSh[458];
		conv += panelSh[p_idx + 491] * templateSh[457];
		conv += panelSh[p_idx + 492] * templateSh[456];
		conv += panelSh[p_idx + 493] * templateSh[455];
		conv += panelSh[p_idx + 494] * templateSh[454];
		conv += panelSh[p_idx + 495] * templateSh[453];
		conv += panelSh[p_idx + 496] * templateSh[452];
		conv += panelSh[p_idx + 497] * templateSh[451];
		conv += panelSh[p_idx + 498] * templateSh[450];
		conv += panelSh[p_idx + 499] * templateSh[449];
		conv += panelSh[p_idx + 500] * templateSh[448];
		conv += panelSh[p_idx + 516] * templateSh[447];
		conv += panelSh[p_idx + 517] * templateSh[446];
		conv += panelSh[p_idx + 518] * templateSh[445];
		conv += panelSh[p_idx + 519] * templateSh[444];
		conv += panelSh[p_idx + 520] * templateSh[443];
		conv += panelSh[p_idx + 521] * templateSh[442];
		conv += panelSh[p_idx + 522] * templateSh[441];
		conv += panelSh[p_idx + 523] * templateSh[440];
		conv += panelSh[p_idx + 524] * templateSh[439];
		conv += panelSh[p_idx + 525] * templateSh[438];
		conv += panelSh[p_idx + 526] * templateSh[437];
		conv += panelSh[p_idx + 527] * templateSh[436];
		conv += panelSh[p_idx + 528] * templateSh[435];
		conv += panelSh[p_idx + 529] * templateSh[434];
		conv += panelSh[p_idx + 530] * templateSh[433];
		conv += panelSh[p_idx + 531] * templateSh[432];
		conv += panelSh[p_idx + 532] * templateSh[431];
		conv += panelSh[p_idx + 533] * templateSh[430];
		conv += panelSh[p_idx + 534] * templateSh[429];
		conv += panelSh[p_idx + 535] * templateSh[428];
		conv += panelSh[p_idx + 536] * templateSh[427];
		conv += panelSh[p_idx + 537] * templateSh[426];
		conv += panelSh[p_idx + 538] * templateSh[425];
		conv += panelSh[p_idx + 539] * templateSh[424];
		conv += panelSh[p_idx + 540] * templateSh[423];
		conv += panelSh[p_idx + 541] * templateSh[422];
		conv += panelSh[p_idx + 542] * templateSh[421];
		conv += panelSh[p_idx + 543] * templateSh[420];
		conv += panelSh[p_idx + 559] * templateSh[419];
		conv += panelSh[p_idx + 560] * templateSh[418];
		conv += panelSh[p_idx + 561] * templateSh[417];
		conv += panelSh[p_idx + 562] * templateSh[416];
		conv += panelSh[p_idx + 563] * templateSh[415];
		conv += panelSh[p_idx + 564] * templateSh[414];
		conv += panelSh[p_idx + 565] * templateSh[413];
		conv += panelSh[p_idx + 566] * templateSh[412];
		conv += panelSh[p_idx + 567] * templateSh[411];
		conv += panelSh[p_idx + 568] * templateSh[410];
		conv += panelSh[p_idx + 569] * templateSh[409];
		conv += panelSh[p_idx + 570] * templateSh[408];
		conv += panelSh[p_idx + 571] * templateSh[407];
		conv += panelSh[p_idx + 572] * templateSh[406];
		conv += panelSh[p_idx + 573] * templateSh[405];
		conv += panelSh[p_idx + 574] * templateSh[404];
		conv += panelSh[p_idx + 575] * templateSh[403];
		conv += panelSh[p_idx + 576] * templateSh[402];
		conv += panelSh[p_idx + 577] * templateSh[401];
		conv += panelSh[p_idx + 578] * templateSh[400];
		conv += panelSh[p_idx + 579] * templateSh[399];
		conv += panelSh[p_idx + 580] * templateSh[398];
		conv += panelSh[p_idx + 581] * templateSh[397];
		conv += panelSh[p_idx + 582] * templateSh[396];
		conv += panelSh[p_idx + 583] * templateSh[395];
		conv += panelSh[p_idx + 584] * templateSh[394];
		conv += panelSh[p_idx + 585] * templateSh[393];
		conv += panelSh[p_idx + 586] * templateSh[392];
		conv += panelSh[p_idx + 602] * templateSh[391];
		conv += panelSh[p_idx + 603] * templateSh[390];
		conv += panelSh[p_idx + 604] * templateSh[389];
		conv += panelSh[p_idx + 605] * templateSh[388];
		conv += panelSh[p_idx + 606] * templateSh[387];
		conv += panelSh[p_idx + 607] * templateSh[386];
		conv += panelSh[p_idx + 608] * templateSh[385];
		conv += panelSh[p_idx + 609] * templateSh[384];
		conv += panelSh[p_idx + 610] * templateSh[383];
		conv += panelSh[p_idx + 611] * templateSh[382];
		conv += panelSh[p_idx + 612] * templateSh[381];
		conv += panelSh[p_idx + 613] * templateSh[380];
		conv += panelSh[p_idx + 614] * templateSh[379];
		conv += panelSh[p_idx + 615] * templateSh[378];
		conv += panelSh[p_idx + 616] * templateSh[377];
		conv += panelSh[p_idx + 617] * templateSh[376];
		conv += panelSh[p_idx + 618] * templateSh[375];
		conv += panelSh[p_idx + 619] * templateSh[374];
		conv += panelSh[p_idx + 620] * templateSh[373];
		conv += panelSh[p_idx + 621] * templateSh[372];
		conv += panelSh[p_idx + 622] * templateSh[371];
		conv += panelSh[p_idx + 623] * templateSh[370];
		conv += panelSh[p_idx + 624] * templateSh[369];
		conv += panelSh[p_idx + 625] * templateSh[368];
		conv += panelSh[p_idx + 626] * templateSh[367];
		conv += panelSh[p_idx + 627] * templateSh[366];
		conv += panelSh[p_idx + 628] * templateSh[365];
		conv += panelSh[p_idx + 629] * templateSh[364];
		conv += panelSh[p_idx + 645] * templateSh[363];
		conv += panelSh[p_idx + 646] * templateSh[362];
		conv += panelSh[p_idx + 647] * templateSh[361];
		conv += panelSh[p_idx + 648] * templateSh[360];
		conv += panelSh[p_idx + 649] * templateSh[359];
		conv += panelSh[p_idx + 650] * templateSh[358];
		conv += panelSh[p_idx + 651] * templateSh[357];
		conv += panelSh[p_idx + 652] * templateSh[356];
		conv += panelSh[p_idx + 653] * templateSh[355];
		conv += panelSh[p_idx + 654] * templateSh[354];
		conv += panelSh[p_idx + 655] * templateSh[353];
		conv += panelSh[p_idx + 656] * templateSh[352];
		conv += panelSh[p_idx + 657] * templateSh[351];
		conv += panelSh[p_idx + 658] * templateSh[350];
		conv += panelSh[p_idx + 659] * templateSh[349];
		conv += panelSh[p_idx + 660] * templateSh[348];
		conv += panelSh[p_idx + 661] * templateSh[347];
		conv += panelSh[p_idx + 662] * templateSh[346];
		conv += panelSh[p_idx + 663] * templateSh[345];
		conv += panelSh[p_idx + 664] * templateSh[344];
		conv += panelSh[p_idx + 665] * templateSh[343];
		conv += panelSh[p_idx + 666] * templateSh[342];
		conv += panelSh[p_idx + 667] * templateSh[341];
		conv += panelSh[p_idx + 668] * templateSh[340];
		conv += panelSh[p_idx + 669] * templateSh[339];
		conv += panelSh[p_idx + 670] * templateSh[338];
		conv += panelSh[p_idx + 671] * templateSh[337];
		conv += panelSh[p_idx + 672] * templateSh[336];
		conv += panelSh[p_idx + 688] * templateSh[335];
		conv += panelSh[p_idx + 689] * templateSh[334];
		conv += panelSh[p_idx + 690] * templateSh[333];
		conv += panelSh[p_idx + 691] * templateSh[332];
		conv += panelSh[p_idx + 692] * templateSh[331];
		conv += panelSh[p_idx + 693] * templateSh[330];
		conv += panelSh[p_idx + 694] * templateSh[329];
		conv += panelSh[p_idx + 695] * templateSh[328];
		conv += panelSh[p_idx + 696] * templateSh[327];
		conv += panelSh[p_idx + 697] * templateSh[326];
		conv += panelSh[p_idx + 698] * templateSh[325];
		conv += panelSh[p_idx + 699] * templateSh[324];
		conv += panelSh[p_idx + 700] * templateSh[323];
		conv += panelSh[p_idx + 701] * templateSh[322];
		conv += panelSh[p_idx + 702] * templateSh[321];
		conv += panelSh[p_idx + 703] * templateSh[320];
		conv += panelSh[p_idx + 704] * templateSh[319];
		conv += panelSh[p_idx + 705] * templateSh[318];
		conv += panelSh[p_idx + 706] * templateSh[317];
		conv += panelSh[p_idx + 707] * templateSh[316];
		conv += panelSh[p_idx + 708] * templateSh[315];
		conv += panelSh[p_idx + 709] * templateSh[314];
		conv += panelSh[p_idx + 710] * templateSh[313];
		conv += panelSh[p_idx + 711] * templateSh[312];
		conv += panelSh[p_idx + 712] * templateSh[311];
		conv += panelSh[p_idx + 713] * templateSh[310];
		conv += panelSh[p_idx + 714] * templateSh[309];
		conv += panelSh[p_idx + 715] * templateSh[308];
		conv += panelSh[p_idx + 731] * templateSh[307];
		conv += panelSh[p_idx + 732] * templateSh[306];
		conv += panelSh[p_idx + 733] * templateSh[305];
		conv += panelSh[p_idx + 734] * templateSh[304];
		conv += panelSh[p_idx + 735] * templateSh[303];
		conv += panelSh[p_idx + 736] * templateSh[302];
		conv += panelSh[p_idx + 737] * templateSh[301];
		conv += panelSh[p_idx + 738] * templateSh[300];
		conv += panelSh[p_idx + 739] * templateSh[299];
		conv += panelSh[p_idx + 740] * templateSh[298];
		conv += panelSh[p_idx + 741] * templateSh[297];
		conv += panelSh[p_idx + 742] * templateSh[296];
		conv += panelSh[p_idx + 743] * templateSh[295];
		conv += panelSh[p_idx + 744] * templateSh[294];
		conv += panelSh[p_idx + 745] * templateSh[293];
		conv += panelSh[p_idx + 746] * templateSh[292];
		conv += panelSh[p_idx + 747] * templateSh[291];
		conv += panelSh[p_idx + 748] * templateSh[290];
		conv += panelSh[p_idx + 749] * templateSh[289];
		conv += panelSh[p_idx + 750] * templateSh[288];
		conv += panelSh[p_idx + 751] * templateSh[287];
		conv += panelSh[p_idx + 752] * templateSh[286];
		conv += panelSh[p_idx + 753] * templateSh[285];
		conv += panelSh[p_idx + 754] * templateSh[284];
		conv += panelSh[p_idx + 755] * templateSh[283];
		conv += panelSh[p_idx + 756] * templateSh[282];
		conv += panelSh[p_idx + 757] * templateSh[281];
		conv += panelSh[p_idx + 758] * templateSh[280];
		conv += panelSh[p_idx + 774] * templateSh[279];
		conv += panelSh[p_idx + 775] * templateSh[278];
		conv += panelSh[p_idx + 776] * templateSh[277];
		conv += panelSh[p_idx + 777] * templateSh[276];
		conv += panelSh[p_idx + 778] * templateSh[275];
		conv += panelSh[p_idx + 779] * templateSh[274];
		conv += panelSh[p_idx + 780] * templateSh[273];
		conv += panelSh[p_idx + 781] * templateSh[272];
		conv += panelSh[p_idx + 782] * templateSh[271];
		conv += panelSh[p_idx + 783] * templateSh[270];
		conv += panelSh[p_idx + 784] * templateSh[269];
		conv += panelSh[p_idx + 785] * templateSh[268];
		conv += panelSh[p_idx + 786] * templateSh[267];
		conv += panelSh[p_idx + 787] * templateSh[266];
		conv += panelSh[p_idx + 788] * templateSh[265];
		conv += panelSh[p_idx + 789] * templateSh[264];
		conv += panelSh[p_idx + 790] * templateSh[263];
		conv += panelSh[p_idx + 791] * templateSh[262];
		conv += panelSh[p_idx + 792] * templateSh[261];
		conv += panelSh[p_idx + 793] * templateSh[260];
		conv += panelSh[p_idx + 794] * templateSh[259];
		conv += panelSh[p_idx + 795] * templateSh[258];
		conv += panelSh[p_idx + 796] * templateSh[257];
		conv += panelSh[p_idx + 797] * templateSh[256];
		conv += panelSh[p_idx + 798] * templateSh[255];
		conv += panelSh[p_idx + 799] * templateSh[254];
		conv += panelSh[p_idx + 800] * templateSh[253];
		conv += panelSh[p_idx + 801] * templateSh[252];
		conv += panelSh[p_idx + 817] * templateSh[251];
		conv += panelSh[p_idx + 818] * templateSh[250];
		conv += panelSh[p_idx + 819] * templateSh[249];
		conv += panelSh[p_idx + 820] * templateSh[248];
		conv += panelSh[p_idx + 821] * templateSh[247];
		conv += panelSh[p_idx + 822] * templateSh[246];
		conv += panelSh[p_idx + 823] * templateSh[245];
		conv += panelSh[p_idx + 824] * templateSh[244];
		conv += panelSh[p_idx + 825] * templateSh[243];
		conv += panelSh[p_idx + 826] * templateSh[242];
		conv += panelSh[p_idx + 827] * templateSh[241];
		conv += panelSh[p_idx + 828] * templateSh[240];
		conv += panelSh[p_idx + 829] * templateSh[239];
		conv += panelSh[p_idx + 830] * templateSh[238];
		conv += panelSh[p_idx + 831] * templateSh[237];
		conv += panelSh[p_idx + 832] * templateSh[236];
		conv += panelSh[p_idx + 833] * templateSh[235];
		conv += panelSh[p_idx + 834] * templateSh[234];
		conv += panelSh[p_idx + 835] * templateSh[233];
		conv += panelSh[p_idx + 836] * templateSh[232];
		conv += panelSh[p_idx + 837] * templateSh[231];
		conv += panelSh[p_idx + 838] * templateSh[230];
		conv += panelSh[p_idx + 839] * templateSh[229];
		conv += panelSh[p_idx + 840] * templateSh[228];
		conv += panelSh[p_idx + 841] * templateSh[227];
		conv += panelSh[p_idx + 842] * templateSh[226];
		conv += panelSh[p_idx + 843] * templateSh[225];
		conv += panelSh[p_idx + 844] * templateSh[224];
		conv += panelSh[p_idx + 860] * templateSh[223];
		conv += panelSh[p_idx + 861] * templateSh[222];
		conv += panelSh[p_idx + 862] * templateSh[221];
		conv += panelSh[p_idx + 863] * templateSh[220];
		conv += panelSh[p_idx + 864] * templateSh[219];
		conv += panelSh[p_idx + 865] * templateSh[218];
		conv += panelSh[p_idx + 866] * templateSh[217];
		conv += panelSh[p_idx + 867] * templateSh[216];
		conv += panelSh[p_idx + 868] * templateSh[215];
		conv += panelSh[p_idx + 869] * templateSh[214];
		conv += panelSh[p_idx + 870] * templateSh[213];
		conv += panelSh[p_idx + 871] * templateSh[212];
		conv += panelSh[p_idx + 872] * templateSh[211];
		conv += panelSh[p_idx + 873] * templateSh[210];
		conv += panelSh[p_idx + 874] * templateSh[209];
		conv += panelSh[p_idx + 875] * templateSh[208];
		conv += panelSh[p_idx + 876] * templateSh[207];
		conv += panelSh[p_idx + 877] * templateSh[206];
		conv += panelSh[p_idx + 878] * templateSh[205];
		conv += panelSh[p_idx + 879] * templateSh[204];
		conv += panelSh[p_idx + 880] * templateSh[203];
		conv += panelSh[p_idx + 881] * templateSh[202];
		conv += panelSh[p_idx + 882] * templateSh[201];
		conv += panelSh[p_idx + 883] * templateSh[200];
		conv += panelSh[p_idx + 884] * templateSh[199];
		conv += panelSh[p_idx + 885] * templateSh[198];
		conv += panelSh[p_idx + 886] * templateSh[197];
		conv += panelSh[p_idx + 887] * templateSh[196];
		conv += panelSh[p_idx + 903] * templateSh[195];
		conv += panelSh[p_idx + 904] * templateSh[194];
		conv += panelSh[p_idx + 905] * templateSh[193];
		conv += panelSh[p_idx + 906] * templateSh[192];
		conv += panelSh[p_idx + 907] * templateSh[191];
		conv += panelSh[p_idx + 908] * templateSh[190];
		conv += panelSh[p_idx + 909] * templateSh[189];
		conv += panelSh[p_idx + 910] * templateSh[188];
		conv += panelSh[p_idx + 911] * templateSh[187];
		conv += panelSh[p_idx + 912] * templateSh[186];
		conv += panelSh[p_idx + 913] * templateSh[185];
		conv += panelSh[p_idx + 914] * templateSh[184];
		conv += panelSh[p_idx + 915] * templateSh[183];
		conv += panelSh[p_idx + 916] * templateSh[182];
		conv += panelSh[p_idx + 917] * templateSh[181];
		conv += panelSh[p_idx + 918] * templateSh[180];
		conv += panelSh[p_idx + 919] * templateSh[179];
		conv += panelSh[p_idx + 920] * templateSh[178];
		conv += panelSh[p_idx + 921] * templateSh[177];
		conv += panelSh[p_idx + 922] * templateSh[176];
		conv += panelSh[p_idx + 923] * templateSh[175];
		conv += panelSh[p_idx + 924] * templateSh[174];
		conv += panelSh[p_idx + 925] * templateSh[173];
		conv += panelSh[p_idx + 926] * templateSh[172];
		conv += panelSh[p_idx + 927] * templateSh[171];
		conv += panelSh[p_idx + 928] * templateSh[170];
		conv += panelSh[p_idx + 929] * templateSh[169];
		conv += panelSh[p_idx + 930] * templateSh[168];
		conv += panelSh[p_idx + 946] * templateSh[167];
		conv += panelSh[p_idx + 947] * templateSh[166];
		conv += panelSh[p_idx + 948] * templateSh[165];
		conv += panelSh[p_idx + 949] * templateSh[164];
		conv += panelSh[p_idx + 950] * templateSh[163];
		conv += panelSh[p_idx + 951] * templateSh[162];
		conv += panelSh[p_idx + 952] * templateSh[161];
		conv += panelSh[p_idx + 953] * templateSh[160];
		conv += panelSh[p_idx + 954] * templateSh[159];
		conv += panelSh[p_idx + 955] * templateSh[158];
		conv += panelSh[p_idx + 956] * templateSh[157];
		conv += panelSh[p_idx + 957] * templateSh[156];
		conv += panelSh[p_idx + 958] * templateSh[155];
		conv += panelSh[p_idx + 959] * templateSh[154];
		conv += panelSh[p_idx + 960] * templateSh[153];
		conv += panelSh[p_idx + 961] * templateSh[152];
		conv += panelSh[p_idx + 962] * templateSh[151];
		conv += panelSh[p_idx + 963] * templateSh[150];
		conv += panelSh[p_idx + 964] * templateSh[149];
		conv += panelSh[p_idx + 965] * templateSh[148];
		conv += panelSh[p_idx + 966] * templateSh[147];
		conv += panelSh[p_idx + 967] * templateSh[146];
		conv += panelSh[p_idx + 968] * templateSh[145];
		conv += panelSh[p_idx + 969] * templateSh[144];
		conv += panelSh[p_idx + 970] * templateSh[143];
		conv += panelSh[p_idx + 971] * templateSh[142];
		conv += panelSh[p_idx + 972] * templateSh[141];
		conv += panelSh[p_idx + 973] * templateSh[140];
		conv += panelSh[p_idx + 989] * templateSh[139];
		conv += panelSh[p_idx + 990] * templateSh[138];
		conv += panelSh[p_idx + 991] * templateSh[137];
		conv += panelSh[p_idx + 992] * templateSh[136];
		conv += panelSh[p_idx + 993] * templateSh[135];
		conv += panelSh[p_idx + 994] * templateSh[134];
		conv += panelSh[p_idx + 995] * templateSh[133];
		conv += panelSh[p_idx + 996] * templateSh[132];
		conv += panelSh[p_idx + 997] * templateSh[131];
		conv += panelSh[p_idx + 998] * templateSh[130];
		conv += panelSh[p_idx + 999] * templateSh[129];
		conv += panelSh[p_idx + 1000] * templateSh[128];
		conv += panelSh[p_idx + 1001] * templateSh[127];
		conv += panelSh[p_idx + 1002] * templateSh[126];
		conv += panelSh[p_idx + 1003] * templateSh[125];
		conv += panelSh[p_idx + 1004] * templateSh[124];
		conv += panelSh[p_idx + 1005] * templateSh[123];
		conv += panelSh[p_idx + 1006] * templateSh[122];
		conv += panelSh[p_idx + 1007] * templateSh[121];
		conv += panelSh[p_idx + 1008] * templateSh[120];
		conv += panelSh[p_idx + 1009] * templateSh[119];
		conv += panelSh[p_idx + 1010] * templateSh[118];
		conv += panelSh[p_idx + 1011] * templateSh[117];
		conv += panelSh[p_idx + 1012] * templateSh[116];
		conv += panelSh[p_idx + 1013] * templateSh[115];
		conv += panelSh[p_idx + 1014] * templateSh[114];
		conv += panelSh[p_idx + 1015] * templateSh[113];
		conv += panelSh[p_idx + 1016] * templateSh[112];
		conv += panelSh[p_idx + 1032] * templateSh[111];
		conv += panelSh[p_idx + 1033] * templateSh[110];
		conv += panelSh[p_idx + 1034] * templateSh[109];
		conv += panelSh[p_idx + 1035] * templateSh[108];
		conv += panelSh[p_idx + 1036] * templateSh[107];
		conv += panelSh[p_idx + 1037] * templateSh[106];
		conv += panelSh[p_idx + 1038] * templateSh[105];
		conv += panelSh[p_idx + 1039] * templateSh[104];
		conv += panelSh[p_idx + 1040] * templateSh[103];
		conv += panelSh[p_idx + 1041] * templateSh[102];
		conv += panelSh[p_idx + 1042] * templateSh[101];
		conv += panelSh[p_idx + 1043] * templateSh[100];
		conv += panelSh[p_idx + 1044] * templateSh[99];
		conv += panelSh[p_idx + 1045] * templateSh[98];
		conv += panelSh[p_idx + 1046] * templateSh[97];
		conv += panelSh[p_idx + 1047] * templateSh[96];
		conv += panelSh[p_idx + 1048] * templateSh[95];
		conv += panelSh[p_idx + 1049] * templateSh[94];
		conv += panelSh[p_idx + 1050] * templateSh[93];
		conv += panelSh[p_idx + 1051] * templateSh[92];
		conv += panelSh[p_idx + 1052] * templateSh[91];
		conv += panelSh[p_idx + 1053] * templateSh[90];
		conv += panelSh[p_idx + 1054] * templateSh[89];
		conv += panelSh[p_idx + 1055] * templateSh[88];
		conv += panelSh[p_idx + 1056] * templateSh[87];
		conv += panelSh[p_idx + 1057] * templateSh[86];
		conv += panelSh[p_idx + 1058] * templateSh[85];
		conv += panelSh[p_idx + 1059] * templateSh[84];
		conv += panelSh[p_idx + 1075] * templateSh[83];
		conv += panelSh[p_idx + 1076] * templateSh[82];
		conv += panelSh[p_idx + 1077] * templateSh[81];
		conv += panelSh[p_idx + 1078] * templateSh[80];
		conv += panelSh[p_idx + 1079] * templateSh[79];
		conv += panelSh[p_idx + 1080] * templateSh[78];
		conv += panelSh[p_idx + 1081] * templateSh[77];
		conv += panelSh[p_idx + 1082] * templateSh[76];
		conv += panelSh[p_idx + 1083] * templateSh[75];
		conv += panelSh[p_idx + 1084] * templateSh[74];
		conv += panelSh[p_idx + 1085] * templateSh[73];
		conv += panelSh[p_idx + 1086] * templateSh[72];
		conv += panelSh[p_idx + 1087] * templateSh[71];
		conv += panelSh[p_idx + 1088] * templateSh[70];
		conv += panelSh[p_idx + 1089] * templateSh[69];
		conv += panelSh[p_idx + 1090] * templateSh[68];
		conv += panelSh[p_idx + 1091] * templateSh[67];
		conv += panelSh[p_idx + 1092] * templateSh[66];
		conv += panelSh[p_idx + 1093] * templateSh[65];
		conv += panelSh[p_idx + 1094] * templateSh[64];
		conv += panelSh[p_idx + 1095] * templateSh[63];
		conv += panelSh[p_idx + 1096] * templateSh[62];
		conv += panelSh[p_idx + 1097] * templateSh[61];
		conv += panelSh[p_idx + 1098] * templateSh[60];
		conv += panelSh[p_idx + 1099] * templateSh[59];
		conv += panelSh[p_idx + 1100] * templateSh[58];
		conv += panelSh[p_idx + 1101] * templateSh[57];
		conv += panelSh[p_idx + 1102] * templateSh[56];
		conv += panelSh[p_idx + 1118] * templateSh[55];
		conv += panelSh[p_idx + 1119] * templateSh[54];
		conv += panelSh[p_idx + 1120] * templateSh[53];
		conv += panelSh[p_idx + 1121] * templateSh[52];
		conv += panelSh[p_idx + 1122] * templateSh[51];
		conv += panelSh[p_idx + 1123] * templateSh[50];
		conv += panelSh[p_idx + 1124] * templateSh[49];
		conv += panelSh[p_idx + 1125] * templateSh[48];
		conv += panelSh[p_idx + 1126] * templateSh[47];
		conv += panelSh[p_idx + 1127] * templateSh[46];
		conv += panelSh[p_idx + 1128] * templateSh[45];
		conv += panelSh[p_idx + 1129] * templateSh[44];
		conv += panelSh[p_idx + 1130] * templateSh[43];
		conv += panelSh[p_idx + 1131] * templateSh[42];
		conv += panelSh[p_idx + 1132] * templateSh[41];
		conv += panelSh[p_idx + 1133] * templateSh[40];
		conv += panelSh[p_idx + 1134] * templateSh[39];
		conv += panelSh[p_idx + 1135] * templateSh[38];
		conv += panelSh[p_idx + 1136] * templateSh[37];
		conv += panelSh[p_idx + 1137] * templateSh[36];
		conv += panelSh[p_idx + 1138] * templateSh[35];
		conv += panelSh[p_idx + 1139] * templateSh[34];
		conv += panelSh[p_idx + 1140] * templateSh[33];
		conv += panelSh[p_idx + 1141] * templateSh[32];
		conv += panelSh[p_idx + 1142] * templateSh[31];
		conv += panelSh[p_idx + 1143] * templateSh[30];
		conv += panelSh[p_idx + 1144] * templateSh[29];
		conv += panelSh[p_idx + 1145] * templateSh[28];
		conv += panelSh[p_idx + 1161] * templateSh[27];
		conv += panelSh[p_idx + 1162] * templateSh[26];
		conv += panelSh[p_idx + 1163] * templateSh[25];
		conv += panelSh[p_idx + 1164] * templateSh[24];
		conv += panelSh[p_idx + 1165] * templateSh[23];
		conv += panelSh[p_idx + 1166] * templateSh[22];
		conv += panelSh[p_idx + 1167] * templateSh[21];
		conv += panelSh[p_idx + 1168] * templateSh[20];
		conv += panelSh[p_idx + 1169] * templateSh[19];
		conv += panelSh[p_idx + 1170] * templateSh[18];
		conv += panelSh[p_idx + 1171] * templateSh[17];
		conv += panelSh[p_idx + 1172] * templateSh[16];
		conv += panelSh[p_idx + 1173] * templateSh[15];
		conv += panelSh[p_idx + 1174] * templateSh[14];
		conv += panelSh[p_idx + 1175] * templateSh[13];
		conv += panelSh[p_idx + 1176] * templateSh[12];
		conv += panelSh[p_idx + 1177] * templateSh[11];
		conv += panelSh[p_idx + 1178] * templateSh[10];
		conv += panelSh[p_idx + 1179] * templateSh[9];
		conv += panelSh[p_idx + 1180] * templateSh[8];
		conv += panelSh[p_idx + 1181] * templateSh[7];
		conv += panelSh[p_idx + 1182] * templateSh[6];
		conv += panelSh[p_idx + 1183] * templateSh[5];
		conv += panelSh[p_idx + 1184] * templateSh[4];
		conv += panelSh[p_idx + 1185] * templateSh[3];
		conv += panelSh[p_idx + 1186] * templateSh[2];
		conv += panelSh[p_idx + 1187] * templateSh[1];
		conv += panelSh[p_idx + 1188] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_28x28<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_28x28<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_29x29 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1936];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<44; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<44; i+=16) {
			panelSh[IMUL(j, 44) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[841];
	for (int j=threadIdx.y; j<29; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<29; i+=16) {
			const int jtwi = IMUL(j, 29) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 44);
		conv += panelSh[p_idx + 0] * templateSh[840];
		conv += panelSh[p_idx + 1] * templateSh[839];
		conv += panelSh[p_idx + 2] * templateSh[838];
		conv += panelSh[p_idx + 3] * templateSh[837];
		conv += panelSh[p_idx + 4] * templateSh[836];
		conv += panelSh[p_idx + 5] * templateSh[835];
		conv += panelSh[p_idx + 6] * templateSh[834];
		conv += panelSh[p_idx + 7] * templateSh[833];
		conv += panelSh[p_idx + 8] * templateSh[832];
		conv += panelSh[p_idx + 9] * templateSh[831];
		conv += panelSh[p_idx + 10] * templateSh[830];
		conv += panelSh[p_idx + 11] * templateSh[829];
		conv += panelSh[p_idx + 12] * templateSh[828];
		conv += panelSh[p_idx + 13] * templateSh[827];
		conv += panelSh[p_idx + 14] * templateSh[826];
		conv += panelSh[p_idx + 15] * templateSh[825];
		conv += panelSh[p_idx + 16] * templateSh[824];
		conv += panelSh[p_idx + 17] * templateSh[823];
		conv += panelSh[p_idx + 18] * templateSh[822];
		conv += panelSh[p_idx + 19] * templateSh[821];
		conv += panelSh[p_idx + 20] * templateSh[820];
		conv += panelSh[p_idx + 21] * templateSh[819];
		conv += panelSh[p_idx + 22] * templateSh[818];
		conv += panelSh[p_idx + 23] * templateSh[817];
		conv += panelSh[p_idx + 24] * templateSh[816];
		conv += panelSh[p_idx + 25] * templateSh[815];
		conv += panelSh[p_idx + 26] * templateSh[814];
		conv += panelSh[p_idx + 27] * templateSh[813];
		conv += panelSh[p_idx + 28] * templateSh[812];
		conv += panelSh[p_idx + 44] * templateSh[811];
		conv += panelSh[p_idx + 45] * templateSh[810];
		conv += panelSh[p_idx + 46] * templateSh[809];
		conv += panelSh[p_idx + 47] * templateSh[808];
		conv += panelSh[p_idx + 48] * templateSh[807];
		conv += panelSh[p_idx + 49] * templateSh[806];
		conv += panelSh[p_idx + 50] * templateSh[805];
		conv += panelSh[p_idx + 51] * templateSh[804];
		conv += panelSh[p_idx + 52] * templateSh[803];
		conv += panelSh[p_idx + 53] * templateSh[802];
		conv += panelSh[p_idx + 54] * templateSh[801];
		conv += panelSh[p_idx + 55] * templateSh[800];
		conv += panelSh[p_idx + 56] * templateSh[799];
		conv += panelSh[p_idx + 57] * templateSh[798];
		conv += panelSh[p_idx + 58] * templateSh[797];
		conv += panelSh[p_idx + 59] * templateSh[796];
		conv += panelSh[p_idx + 60] * templateSh[795];
		conv += panelSh[p_idx + 61] * templateSh[794];
		conv += panelSh[p_idx + 62] * templateSh[793];
		conv += panelSh[p_idx + 63] * templateSh[792];
		conv += panelSh[p_idx + 64] * templateSh[791];
		conv += panelSh[p_idx + 65] * templateSh[790];
		conv += panelSh[p_idx + 66] * templateSh[789];
		conv += panelSh[p_idx + 67] * templateSh[788];
		conv += panelSh[p_idx + 68] * templateSh[787];
		conv += panelSh[p_idx + 69] * templateSh[786];
		conv += panelSh[p_idx + 70] * templateSh[785];
		conv += panelSh[p_idx + 71] * templateSh[784];
		conv += panelSh[p_idx + 72] * templateSh[783];
		conv += panelSh[p_idx + 88] * templateSh[782];
		conv += panelSh[p_idx + 89] * templateSh[781];
		conv += panelSh[p_idx + 90] * templateSh[780];
		conv += panelSh[p_idx + 91] * templateSh[779];
		conv += panelSh[p_idx + 92] * templateSh[778];
		conv += panelSh[p_idx + 93] * templateSh[777];
		conv += panelSh[p_idx + 94] * templateSh[776];
		conv += panelSh[p_idx + 95] * templateSh[775];
		conv += panelSh[p_idx + 96] * templateSh[774];
		conv += panelSh[p_idx + 97] * templateSh[773];
		conv += panelSh[p_idx + 98] * templateSh[772];
		conv += panelSh[p_idx + 99] * templateSh[771];
		conv += panelSh[p_idx + 100] * templateSh[770];
		conv += panelSh[p_idx + 101] * templateSh[769];
		conv += panelSh[p_idx + 102] * templateSh[768];
		conv += panelSh[p_idx + 103] * templateSh[767];
		conv += panelSh[p_idx + 104] * templateSh[766];
		conv += panelSh[p_idx + 105] * templateSh[765];
		conv += panelSh[p_idx + 106] * templateSh[764];
		conv += panelSh[p_idx + 107] * templateSh[763];
		conv += panelSh[p_idx + 108] * templateSh[762];
		conv += panelSh[p_idx + 109] * templateSh[761];
		conv += panelSh[p_idx + 110] * templateSh[760];
		conv += panelSh[p_idx + 111] * templateSh[759];
		conv += panelSh[p_idx + 112] * templateSh[758];
		conv += panelSh[p_idx + 113] * templateSh[757];
		conv += panelSh[p_idx + 114] * templateSh[756];
		conv += panelSh[p_idx + 115] * templateSh[755];
		conv += panelSh[p_idx + 116] * templateSh[754];
		conv += panelSh[p_idx + 132] * templateSh[753];
		conv += panelSh[p_idx + 133] * templateSh[752];
		conv += panelSh[p_idx + 134] * templateSh[751];
		conv += panelSh[p_idx + 135] * templateSh[750];
		conv += panelSh[p_idx + 136] * templateSh[749];
		conv += panelSh[p_idx + 137] * templateSh[748];
		conv += panelSh[p_idx + 138] * templateSh[747];
		conv += panelSh[p_idx + 139] * templateSh[746];
		conv += panelSh[p_idx + 140] * templateSh[745];
		conv += panelSh[p_idx + 141] * templateSh[744];
		conv += panelSh[p_idx + 142] * templateSh[743];
		conv += panelSh[p_idx + 143] * templateSh[742];
		conv += panelSh[p_idx + 144] * templateSh[741];
		conv += panelSh[p_idx + 145] * templateSh[740];
		conv += panelSh[p_idx + 146] * templateSh[739];
		conv += panelSh[p_idx + 147] * templateSh[738];
		conv += panelSh[p_idx + 148] * templateSh[737];
		conv += panelSh[p_idx + 149] * templateSh[736];
		conv += panelSh[p_idx + 150] * templateSh[735];
		conv += panelSh[p_idx + 151] * templateSh[734];
		conv += panelSh[p_idx + 152] * templateSh[733];
		conv += panelSh[p_idx + 153] * templateSh[732];
		conv += panelSh[p_idx + 154] * templateSh[731];
		conv += panelSh[p_idx + 155] * templateSh[730];
		conv += panelSh[p_idx + 156] * templateSh[729];
		conv += panelSh[p_idx + 157] * templateSh[728];
		conv += panelSh[p_idx + 158] * templateSh[727];
		conv += panelSh[p_idx + 159] * templateSh[726];
		conv += panelSh[p_idx + 160] * templateSh[725];
		conv += panelSh[p_idx + 176] * templateSh[724];
		conv += panelSh[p_idx + 177] * templateSh[723];
		conv += panelSh[p_idx + 178] * templateSh[722];
		conv += panelSh[p_idx + 179] * templateSh[721];
		conv += panelSh[p_idx + 180] * templateSh[720];
		conv += panelSh[p_idx + 181] * templateSh[719];
		conv += panelSh[p_idx + 182] * templateSh[718];
		conv += panelSh[p_idx + 183] * templateSh[717];
		conv += panelSh[p_idx + 184] * templateSh[716];
		conv += panelSh[p_idx + 185] * templateSh[715];
		conv += panelSh[p_idx + 186] * templateSh[714];
		conv += panelSh[p_idx + 187] * templateSh[713];
		conv += panelSh[p_idx + 188] * templateSh[712];
		conv += panelSh[p_idx + 189] * templateSh[711];
		conv += panelSh[p_idx + 190] * templateSh[710];
		conv += panelSh[p_idx + 191] * templateSh[709];
		conv += panelSh[p_idx + 192] * templateSh[708];
		conv += panelSh[p_idx + 193] * templateSh[707];
		conv += panelSh[p_idx + 194] * templateSh[706];
		conv += panelSh[p_idx + 195] * templateSh[705];
		conv += panelSh[p_idx + 196] * templateSh[704];
		conv += panelSh[p_idx + 197] * templateSh[703];
		conv += panelSh[p_idx + 198] * templateSh[702];
		conv += panelSh[p_idx + 199] * templateSh[701];
		conv += panelSh[p_idx + 200] * templateSh[700];
		conv += panelSh[p_idx + 201] * templateSh[699];
		conv += panelSh[p_idx + 202] * templateSh[698];
		conv += panelSh[p_idx + 203] * templateSh[697];
		conv += panelSh[p_idx + 204] * templateSh[696];
		conv += panelSh[p_idx + 220] * templateSh[695];
		conv += panelSh[p_idx + 221] * templateSh[694];
		conv += panelSh[p_idx + 222] * templateSh[693];
		conv += panelSh[p_idx + 223] * templateSh[692];
		conv += panelSh[p_idx + 224] * templateSh[691];
		conv += panelSh[p_idx + 225] * templateSh[690];
		conv += panelSh[p_idx + 226] * templateSh[689];
		conv += panelSh[p_idx + 227] * templateSh[688];
		conv += panelSh[p_idx + 228] * templateSh[687];
		conv += panelSh[p_idx + 229] * templateSh[686];
		conv += panelSh[p_idx + 230] * templateSh[685];
		conv += panelSh[p_idx + 231] * templateSh[684];
		conv += panelSh[p_idx + 232] * templateSh[683];
		conv += panelSh[p_idx + 233] * templateSh[682];
		conv += panelSh[p_idx + 234] * templateSh[681];
		conv += panelSh[p_idx + 235] * templateSh[680];
		conv += panelSh[p_idx + 236] * templateSh[679];
		conv += panelSh[p_idx + 237] * templateSh[678];
		conv += panelSh[p_idx + 238] * templateSh[677];
		conv += panelSh[p_idx + 239] * templateSh[676];
		conv += panelSh[p_idx + 240] * templateSh[675];
		conv += panelSh[p_idx + 241] * templateSh[674];
		conv += panelSh[p_idx + 242] * templateSh[673];
		conv += panelSh[p_idx + 243] * templateSh[672];
		conv += panelSh[p_idx + 244] * templateSh[671];
		conv += panelSh[p_idx + 245] * templateSh[670];
		conv += panelSh[p_idx + 246] * templateSh[669];
		conv += panelSh[p_idx + 247] * templateSh[668];
		conv += panelSh[p_idx + 248] * templateSh[667];
		conv += panelSh[p_idx + 264] * templateSh[666];
		conv += panelSh[p_idx + 265] * templateSh[665];
		conv += panelSh[p_idx + 266] * templateSh[664];
		conv += panelSh[p_idx + 267] * templateSh[663];
		conv += panelSh[p_idx + 268] * templateSh[662];
		conv += panelSh[p_idx + 269] * templateSh[661];
		conv += panelSh[p_idx + 270] * templateSh[660];
		conv += panelSh[p_idx + 271] * templateSh[659];
		conv += panelSh[p_idx + 272] * templateSh[658];
		conv += panelSh[p_idx + 273] * templateSh[657];
		conv += panelSh[p_idx + 274] * templateSh[656];
		conv += panelSh[p_idx + 275] * templateSh[655];
		conv += panelSh[p_idx + 276] * templateSh[654];
		conv += panelSh[p_idx + 277] * templateSh[653];
		conv += panelSh[p_idx + 278] * templateSh[652];
		conv += panelSh[p_idx + 279] * templateSh[651];
		conv += panelSh[p_idx + 280] * templateSh[650];
		conv += panelSh[p_idx + 281] * templateSh[649];
		conv += panelSh[p_idx + 282] * templateSh[648];
		conv += panelSh[p_idx + 283] * templateSh[647];
		conv += panelSh[p_idx + 284] * templateSh[646];
		conv += panelSh[p_idx + 285] * templateSh[645];
		conv += panelSh[p_idx + 286] * templateSh[644];
		conv += panelSh[p_idx + 287] * templateSh[643];
		conv += panelSh[p_idx + 288] * templateSh[642];
		conv += panelSh[p_idx + 289] * templateSh[641];
		conv += panelSh[p_idx + 290] * templateSh[640];
		conv += panelSh[p_idx + 291] * templateSh[639];
		conv += panelSh[p_idx + 292] * templateSh[638];
		conv += panelSh[p_idx + 308] * templateSh[637];
		conv += panelSh[p_idx + 309] * templateSh[636];
		conv += panelSh[p_idx + 310] * templateSh[635];
		conv += panelSh[p_idx + 311] * templateSh[634];
		conv += panelSh[p_idx + 312] * templateSh[633];
		conv += panelSh[p_idx + 313] * templateSh[632];
		conv += panelSh[p_idx + 314] * templateSh[631];
		conv += panelSh[p_idx + 315] * templateSh[630];
		conv += panelSh[p_idx + 316] * templateSh[629];
		conv += panelSh[p_idx + 317] * templateSh[628];
		conv += panelSh[p_idx + 318] * templateSh[627];
		conv += panelSh[p_idx + 319] * templateSh[626];
		conv += panelSh[p_idx + 320] * templateSh[625];
		conv += panelSh[p_idx + 321] * templateSh[624];
		conv += panelSh[p_idx + 322] * templateSh[623];
		conv += panelSh[p_idx + 323] * templateSh[622];
		conv += panelSh[p_idx + 324] * templateSh[621];
		conv += panelSh[p_idx + 325] * templateSh[620];
		conv += panelSh[p_idx + 326] * templateSh[619];
		conv += panelSh[p_idx + 327] * templateSh[618];
		conv += panelSh[p_idx + 328] * templateSh[617];
		conv += panelSh[p_idx + 329] * templateSh[616];
		conv += panelSh[p_idx + 330] * templateSh[615];
		conv += panelSh[p_idx + 331] * templateSh[614];
		conv += panelSh[p_idx + 332] * templateSh[613];
		conv += panelSh[p_idx + 333] * templateSh[612];
		conv += panelSh[p_idx + 334] * templateSh[611];
		conv += panelSh[p_idx + 335] * templateSh[610];
		conv += panelSh[p_idx + 336] * templateSh[609];
		conv += panelSh[p_idx + 352] * templateSh[608];
		conv += panelSh[p_idx + 353] * templateSh[607];
		conv += panelSh[p_idx + 354] * templateSh[606];
		conv += panelSh[p_idx + 355] * templateSh[605];
		conv += panelSh[p_idx + 356] * templateSh[604];
		conv += panelSh[p_idx + 357] * templateSh[603];
		conv += panelSh[p_idx + 358] * templateSh[602];
		conv += panelSh[p_idx + 359] * templateSh[601];
		conv += panelSh[p_idx + 360] * templateSh[600];
		conv += panelSh[p_idx + 361] * templateSh[599];
		conv += panelSh[p_idx + 362] * templateSh[598];
		conv += panelSh[p_idx + 363] * templateSh[597];
		conv += panelSh[p_idx + 364] * templateSh[596];
		conv += panelSh[p_idx + 365] * templateSh[595];
		conv += panelSh[p_idx + 366] * templateSh[594];
		conv += panelSh[p_idx + 367] * templateSh[593];
		conv += panelSh[p_idx + 368] * templateSh[592];
		conv += panelSh[p_idx + 369] * templateSh[591];
		conv += panelSh[p_idx + 370] * templateSh[590];
		conv += panelSh[p_idx + 371] * templateSh[589];
		conv += panelSh[p_idx + 372] * templateSh[588];
		conv += panelSh[p_idx + 373] * templateSh[587];
		conv += panelSh[p_idx + 374] * templateSh[586];
		conv += panelSh[p_idx + 375] * templateSh[585];
		conv += panelSh[p_idx + 376] * templateSh[584];
		conv += panelSh[p_idx + 377] * templateSh[583];
		conv += panelSh[p_idx + 378] * templateSh[582];
		conv += panelSh[p_idx + 379] * templateSh[581];
		conv += panelSh[p_idx + 380] * templateSh[580];
		conv += panelSh[p_idx + 396] * templateSh[579];
		conv += panelSh[p_idx + 397] * templateSh[578];
		conv += panelSh[p_idx + 398] * templateSh[577];
		conv += panelSh[p_idx + 399] * templateSh[576];
		conv += panelSh[p_idx + 400] * templateSh[575];
		conv += panelSh[p_idx + 401] * templateSh[574];
		conv += panelSh[p_idx + 402] * templateSh[573];
		conv += panelSh[p_idx + 403] * templateSh[572];
		conv += panelSh[p_idx + 404] * templateSh[571];
		conv += panelSh[p_idx + 405] * templateSh[570];
		conv += panelSh[p_idx + 406] * templateSh[569];
		conv += panelSh[p_idx + 407] * templateSh[568];
		conv += panelSh[p_idx + 408] * templateSh[567];
		conv += panelSh[p_idx + 409] * templateSh[566];
		conv += panelSh[p_idx + 410] * templateSh[565];
		conv += panelSh[p_idx + 411] * templateSh[564];
		conv += panelSh[p_idx + 412] * templateSh[563];
		conv += panelSh[p_idx + 413] * templateSh[562];
		conv += panelSh[p_idx + 414] * templateSh[561];
		conv += panelSh[p_idx + 415] * templateSh[560];
		conv += panelSh[p_idx + 416] * templateSh[559];
		conv += panelSh[p_idx + 417] * templateSh[558];
		conv += panelSh[p_idx + 418] * templateSh[557];
		conv += panelSh[p_idx + 419] * templateSh[556];
		conv += panelSh[p_idx + 420] * templateSh[555];
		conv += panelSh[p_idx + 421] * templateSh[554];
		conv += panelSh[p_idx + 422] * templateSh[553];
		conv += panelSh[p_idx + 423] * templateSh[552];
		conv += panelSh[p_idx + 424] * templateSh[551];
		conv += panelSh[p_idx + 440] * templateSh[550];
		conv += panelSh[p_idx + 441] * templateSh[549];
		conv += panelSh[p_idx + 442] * templateSh[548];
		conv += panelSh[p_idx + 443] * templateSh[547];
		conv += panelSh[p_idx + 444] * templateSh[546];
		conv += panelSh[p_idx + 445] * templateSh[545];
		conv += panelSh[p_idx + 446] * templateSh[544];
		conv += panelSh[p_idx + 447] * templateSh[543];
		conv += panelSh[p_idx + 448] * templateSh[542];
		conv += panelSh[p_idx + 449] * templateSh[541];
		conv += panelSh[p_idx + 450] * templateSh[540];
		conv += panelSh[p_idx + 451] * templateSh[539];
		conv += panelSh[p_idx + 452] * templateSh[538];
		conv += panelSh[p_idx + 453] * templateSh[537];
		conv += panelSh[p_idx + 454] * templateSh[536];
		conv += panelSh[p_idx + 455] * templateSh[535];
		conv += panelSh[p_idx + 456] * templateSh[534];
		conv += panelSh[p_idx + 457] * templateSh[533];
		conv += panelSh[p_idx + 458] * templateSh[532];
		conv += panelSh[p_idx + 459] * templateSh[531];
		conv += panelSh[p_idx + 460] * templateSh[530];
		conv += panelSh[p_idx + 461] * templateSh[529];
		conv += panelSh[p_idx + 462] * templateSh[528];
		conv += panelSh[p_idx + 463] * templateSh[527];
		conv += panelSh[p_idx + 464] * templateSh[526];
		conv += panelSh[p_idx + 465] * templateSh[525];
		conv += panelSh[p_idx + 466] * templateSh[524];
		conv += panelSh[p_idx + 467] * templateSh[523];
		conv += panelSh[p_idx + 468] * templateSh[522];
		conv += panelSh[p_idx + 484] * templateSh[521];
		conv += panelSh[p_idx + 485] * templateSh[520];
		conv += panelSh[p_idx + 486] * templateSh[519];
		conv += panelSh[p_idx + 487] * templateSh[518];
		conv += panelSh[p_idx + 488] * templateSh[517];
		conv += panelSh[p_idx + 489] * templateSh[516];
		conv += panelSh[p_idx + 490] * templateSh[515];
		conv += panelSh[p_idx + 491] * templateSh[514];
		conv += panelSh[p_idx + 492] * templateSh[513];
		conv += panelSh[p_idx + 493] * templateSh[512];
		conv += panelSh[p_idx + 494] * templateSh[511];
		conv += panelSh[p_idx + 495] * templateSh[510];
		conv += panelSh[p_idx + 496] * templateSh[509];
		conv += panelSh[p_idx + 497] * templateSh[508];
		conv += panelSh[p_idx + 498] * templateSh[507];
		conv += panelSh[p_idx + 499] * templateSh[506];
		conv += panelSh[p_idx + 500] * templateSh[505];
		conv += panelSh[p_idx + 501] * templateSh[504];
		conv += panelSh[p_idx + 502] * templateSh[503];
		conv += panelSh[p_idx + 503] * templateSh[502];
		conv += panelSh[p_idx + 504] * templateSh[501];
		conv += panelSh[p_idx + 505] * templateSh[500];
		conv += panelSh[p_idx + 506] * templateSh[499];
		conv += panelSh[p_idx + 507] * templateSh[498];
		conv += panelSh[p_idx + 508] * templateSh[497];
		conv += panelSh[p_idx + 509] * templateSh[496];
		conv += panelSh[p_idx + 510] * templateSh[495];
		conv += panelSh[p_idx + 511] * templateSh[494];
		conv += panelSh[p_idx + 512] * templateSh[493];
		conv += panelSh[p_idx + 528] * templateSh[492];
		conv += panelSh[p_idx + 529] * templateSh[491];
		conv += panelSh[p_idx + 530] * templateSh[490];
		conv += panelSh[p_idx + 531] * templateSh[489];
		conv += panelSh[p_idx + 532] * templateSh[488];
		conv += panelSh[p_idx + 533] * templateSh[487];
		conv += panelSh[p_idx + 534] * templateSh[486];
		conv += panelSh[p_idx + 535] * templateSh[485];
		conv += panelSh[p_idx + 536] * templateSh[484];
		conv += panelSh[p_idx + 537] * templateSh[483];
		conv += panelSh[p_idx + 538] * templateSh[482];
		conv += panelSh[p_idx + 539] * templateSh[481];
		conv += panelSh[p_idx + 540] * templateSh[480];
		conv += panelSh[p_idx + 541] * templateSh[479];
		conv += panelSh[p_idx + 542] * templateSh[478];
		conv += panelSh[p_idx + 543] * templateSh[477];
		conv += panelSh[p_idx + 544] * templateSh[476];
		conv += panelSh[p_idx + 545] * templateSh[475];
		conv += panelSh[p_idx + 546] * templateSh[474];
		conv += panelSh[p_idx + 547] * templateSh[473];
		conv += panelSh[p_idx + 548] * templateSh[472];
		conv += panelSh[p_idx + 549] * templateSh[471];
		conv += panelSh[p_idx + 550] * templateSh[470];
		conv += panelSh[p_idx + 551] * templateSh[469];
		conv += panelSh[p_idx + 552] * templateSh[468];
		conv += panelSh[p_idx + 553] * templateSh[467];
		conv += panelSh[p_idx + 554] * templateSh[466];
		conv += panelSh[p_idx + 555] * templateSh[465];
		conv += panelSh[p_idx + 556] * templateSh[464];
		conv += panelSh[p_idx + 572] * templateSh[463];
		conv += panelSh[p_idx + 573] * templateSh[462];
		conv += panelSh[p_idx + 574] * templateSh[461];
		conv += panelSh[p_idx + 575] * templateSh[460];
		conv += panelSh[p_idx + 576] * templateSh[459];
		conv += panelSh[p_idx + 577] * templateSh[458];
		conv += panelSh[p_idx + 578] * templateSh[457];
		conv += panelSh[p_idx + 579] * templateSh[456];
		conv += panelSh[p_idx + 580] * templateSh[455];
		conv += panelSh[p_idx + 581] * templateSh[454];
		conv += panelSh[p_idx + 582] * templateSh[453];
		conv += panelSh[p_idx + 583] * templateSh[452];
		conv += panelSh[p_idx + 584] * templateSh[451];
		conv += panelSh[p_idx + 585] * templateSh[450];
		conv += panelSh[p_idx + 586] * templateSh[449];
		conv += panelSh[p_idx + 587] * templateSh[448];
		conv += panelSh[p_idx + 588] * templateSh[447];
		conv += panelSh[p_idx + 589] * templateSh[446];
		conv += panelSh[p_idx + 590] * templateSh[445];
		conv += panelSh[p_idx + 591] * templateSh[444];
		conv += panelSh[p_idx + 592] * templateSh[443];
		conv += panelSh[p_idx + 593] * templateSh[442];
		conv += panelSh[p_idx + 594] * templateSh[441];
		conv += panelSh[p_idx + 595] * templateSh[440];
		conv += panelSh[p_idx + 596] * templateSh[439];
		conv += panelSh[p_idx + 597] * templateSh[438];
		conv += panelSh[p_idx + 598] * templateSh[437];
		conv += panelSh[p_idx + 599] * templateSh[436];
		conv += panelSh[p_idx + 600] * templateSh[435];
		conv += panelSh[p_idx + 616] * templateSh[434];
		conv += panelSh[p_idx + 617] * templateSh[433];
		conv += panelSh[p_idx + 618] * templateSh[432];
		conv += panelSh[p_idx + 619] * templateSh[431];
		conv += panelSh[p_idx + 620] * templateSh[430];
		conv += panelSh[p_idx + 621] * templateSh[429];
		conv += panelSh[p_idx + 622] * templateSh[428];
		conv += panelSh[p_idx + 623] * templateSh[427];
		conv += panelSh[p_idx + 624] * templateSh[426];
		conv += panelSh[p_idx + 625] * templateSh[425];
		conv += panelSh[p_idx + 626] * templateSh[424];
		conv += panelSh[p_idx + 627] * templateSh[423];
		conv += panelSh[p_idx + 628] * templateSh[422];
		conv += panelSh[p_idx + 629] * templateSh[421];
		conv += panelSh[p_idx + 630] * templateSh[420];
		conv += panelSh[p_idx + 631] * templateSh[419];
		conv += panelSh[p_idx + 632] * templateSh[418];
		conv += panelSh[p_idx + 633] * templateSh[417];
		conv += panelSh[p_idx + 634] * templateSh[416];
		conv += panelSh[p_idx + 635] * templateSh[415];
		conv += panelSh[p_idx + 636] * templateSh[414];
		conv += panelSh[p_idx + 637] * templateSh[413];
		conv += panelSh[p_idx + 638] * templateSh[412];
		conv += panelSh[p_idx + 639] * templateSh[411];
		conv += panelSh[p_idx + 640] * templateSh[410];
		conv += panelSh[p_idx + 641] * templateSh[409];
		conv += panelSh[p_idx + 642] * templateSh[408];
		conv += panelSh[p_idx + 643] * templateSh[407];
		conv += panelSh[p_idx + 644] * templateSh[406];
		conv += panelSh[p_idx + 660] * templateSh[405];
		conv += panelSh[p_idx + 661] * templateSh[404];
		conv += panelSh[p_idx + 662] * templateSh[403];
		conv += panelSh[p_idx + 663] * templateSh[402];
		conv += panelSh[p_idx + 664] * templateSh[401];
		conv += panelSh[p_idx + 665] * templateSh[400];
		conv += panelSh[p_idx + 666] * templateSh[399];
		conv += panelSh[p_idx + 667] * templateSh[398];
		conv += panelSh[p_idx + 668] * templateSh[397];
		conv += panelSh[p_idx + 669] * templateSh[396];
		conv += panelSh[p_idx + 670] * templateSh[395];
		conv += panelSh[p_idx + 671] * templateSh[394];
		conv += panelSh[p_idx + 672] * templateSh[393];
		conv += panelSh[p_idx + 673] * templateSh[392];
		conv += panelSh[p_idx + 674] * templateSh[391];
		conv += panelSh[p_idx + 675] * templateSh[390];
		conv += panelSh[p_idx + 676] * templateSh[389];
		conv += panelSh[p_idx + 677] * templateSh[388];
		conv += panelSh[p_idx + 678] * templateSh[387];
		conv += panelSh[p_idx + 679] * templateSh[386];
		conv += panelSh[p_idx + 680] * templateSh[385];
		conv += panelSh[p_idx + 681] * templateSh[384];
		conv += panelSh[p_idx + 682] * templateSh[383];
		conv += panelSh[p_idx + 683] * templateSh[382];
		conv += panelSh[p_idx + 684] * templateSh[381];
		conv += panelSh[p_idx + 685] * templateSh[380];
		conv += panelSh[p_idx + 686] * templateSh[379];
		conv += panelSh[p_idx + 687] * templateSh[378];
		conv += panelSh[p_idx + 688] * templateSh[377];
		conv += panelSh[p_idx + 704] * templateSh[376];
		conv += panelSh[p_idx + 705] * templateSh[375];
		conv += panelSh[p_idx + 706] * templateSh[374];
		conv += panelSh[p_idx + 707] * templateSh[373];
		conv += panelSh[p_idx + 708] * templateSh[372];
		conv += panelSh[p_idx + 709] * templateSh[371];
		conv += panelSh[p_idx + 710] * templateSh[370];
		conv += panelSh[p_idx + 711] * templateSh[369];
		conv += panelSh[p_idx + 712] * templateSh[368];
		conv += panelSh[p_idx + 713] * templateSh[367];
		conv += panelSh[p_idx + 714] * templateSh[366];
		conv += panelSh[p_idx + 715] * templateSh[365];
		conv += panelSh[p_idx + 716] * templateSh[364];
		conv += panelSh[p_idx + 717] * templateSh[363];
		conv += panelSh[p_idx + 718] * templateSh[362];
		conv += panelSh[p_idx + 719] * templateSh[361];
		conv += panelSh[p_idx + 720] * templateSh[360];
		conv += panelSh[p_idx + 721] * templateSh[359];
		conv += panelSh[p_idx + 722] * templateSh[358];
		conv += panelSh[p_idx + 723] * templateSh[357];
		conv += panelSh[p_idx + 724] * templateSh[356];
		conv += panelSh[p_idx + 725] * templateSh[355];
		conv += panelSh[p_idx + 726] * templateSh[354];
		conv += panelSh[p_idx + 727] * templateSh[353];
		conv += panelSh[p_idx + 728] * templateSh[352];
		conv += panelSh[p_idx + 729] * templateSh[351];
		conv += panelSh[p_idx + 730] * templateSh[350];
		conv += panelSh[p_idx + 731] * templateSh[349];
		conv += panelSh[p_idx + 732] * templateSh[348];
		conv += panelSh[p_idx + 748] * templateSh[347];
		conv += panelSh[p_idx + 749] * templateSh[346];
		conv += panelSh[p_idx + 750] * templateSh[345];
		conv += panelSh[p_idx + 751] * templateSh[344];
		conv += panelSh[p_idx + 752] * templateSh[343];
		conv += panelSh[p_idx + 753] * templateSh[342];
		conv += panelSh[p_idx + 754] * templateSh[341];
		conv += panelSh[p_idx + 755] * templateSh[340];
		conv += panelSh[p_idx + 756] * templateSh[339];
		conv += panelSh[p_idx + 757] * templateSh[338];
		conv += panelSh[p_idx + 758] * templateSh[337];
		conv += panelSh[p_idx + 759] * templateSh[336];
		conv += panelSh[p_idx + 760] * templateSh[335];
		conv += panelSh[p_idx + 761] * templateSh[334];
		conv += panelSh[p_idx + 762] * templateSh[333];
		conv += panelSh[p_idx + 763] * templateSh[332];
		conv += panelSh[p_idx + 764] * templateSh[331];
		conv += panelSh[p_idx + 765] * templateSh[330];
		conv += panelSh[p_idx + 766] * templateSh[329];
		conv += panelSh[p_idx + 767] * templateSh[328];
		conv += panelSh[p_idx + 768] * templateSh[327];
		conv += panelSh[p_idx + 769] * templateSh[326];
		conv += panelSh[p_idx + 770] * templateSh[325];
		conv += panelSh[p_idx + 771] * templateSh[324];
		conv += panelSh[p_idx + 772] * templateSh[323];
		conv += panelSh[p_idx + 773] * templateSh[322];
		conv += panelSh[p_idx + 774] * templateSh[321];
		conv += panelSh[p_idx + 775] * templateSh[320];
		conv += panelSh[p_idx + 776] * templateSh[319];
		conv += panelSh[p_idx + 792] * templateSh[318];
		conv += panelSh[p_idx + 793] * templateSh[317];
		conv += panelSh[p_idx + 794] * templateSh[316];
		conv += panelSh[p_idx + 795] * templateSh[315];
		conv += panelSh[p_idx + 796] * templateSh[314];
		conv += panelSh[p_idx + 797] * templateSh[313];
		conv += panelSh[p_idx + 798] * templateSh[312];
		conv += panelSh[p_idx + 799] * templateSh[311];
		conv += panelSh[p_idx + 800] * templateSh[310];
		conv += panelSh[p_idx + 801] * templateSh[309];
		conv += panelSh[p_idx + 802] * templateSh[308];
		conv += panelSh[p_idx + 803] * templateSh[307];
		conv += panelSh[p_idx + 804] * templateSh[306];
		conv += panelSh[p_idx + 805] * templateSh[305];
		conv += panelSh[p_idx + 806] * templateSh[304];
		conv += panelSh[p_idx + 807] * templateSh[303];
		conv += panelSh[p_idx + 808] * templateSh[302];
		conv += panelSh[p_idx + 809] * templateSh[301];
		conv += panelSh[p_idx + 810] * templateSh[300];
		conv += panelSh[p_idx + 811] * templateSh[299];
		conv += panelSh[p_idx + 812] * templateSh[298];
		conv += panelSh[p_idx + 813] * templateSh[297];
		conv += panelSh[p_idx + 814] * templateSh[296];
		conv += panelSh[p_idx + 815] * templateSh[295];
		conv += panelSh[p_idx + 816] * templateSh[294];
		conv += panelSh[p_idx + 817] * templateSh[293];
		conv += panelSh[p_idx + 818] * templateSh[292];
		conv += panelSh[p_idx + 819] * templateSh[291];
		conv += panelSh[p_idx + 820] * templateSh[290];
		conv += panelSh[p_idx + 836] * templateSh[289];
		conv += panelSh[p_idx + 837] * templateSh[288];
		conv += panelSh[p_idx + 838] * templateSh[287];
		conv += panelSh[p_idx + 839] * templateSh[286];
		conv += panelSh[p_idx + 840] * templateSh[285];
		conv += panelSh[p_idx + 841] * templateSh[284];
		conv += panelSh[p_idx + 842] * templateSh[283];
		conv += panelSh[p_idx + 843] * templateSh[282];
		conv += panelSh[p_idx + 844] * templateSh[281];
		conv += panelSh[p_idx + 845] * templateSh[280];
		conv += panelSh[p_idx + 846] * templateSh[279];
		conv += panelSh[p_idx + 847] * templateSh[278];
		conv += panelSh[p_idx + 848] * templateSh[277];
		conv += panelSh[p_idx + 849] * templateSh[276];
		conv += panelSh[p_idx + 850] * templateSh[275];
		conv += panelSh[p_idx + 851] * templateSh[274];
		conv += panelSh[p_idx + 852] * templateSh[273];
		conv += panelSh[p_idx + 853] * templateSh[272];
		conv += panelSh[p_idx + 854] * templateSh[271];
		conv += panelSh[p_idx + 855] * templateSh[270];
		conv += panelSh[p_idx + 856] * templateSh[269];
		conv += panelSh[p_idx + 857] * templateSh[268];
		conv += panelSh[p_idx + 858] * templateSh[267];
		conv += panelSh[p_idx + 859] * templateSh[266];
		conv += panelSh[p_idx + 860] * templateSh[265];
		conv += panelSh[p_idx + 861] * templateSh[264];
		conv += panelSh[p_idx + 862] * templateSh[263];
		conv += panelSh[p_idx + 863] * templateSh[262];
		conv += panelSh[p_idx + 864] * templateSh[261];
		conv += panelSh[p_idx + 880] * templateSh[260];
		conv += panelSh[p_idx + 881] * templateSh[259];
		conv += panelSh[p_idx + 882] * templateSh[258];
		conv += panelSh[p_idx + 883] * templateSh[257];
		conv += panelSh[p_idx + 884] * templateSh[256];
		conv += panelSh[p_idx + 885] * templateSh[255];
		conv += panelSh[p_idx + 886] * templateSh[254];
		conv += panelSh[p_idx + 887] * templateSh[253];
		conv += panelSh[p_idx + 888] * templateSh[252];
		conv += panelSh[p_idx + 889] * templateSh[251];
		conv += panelSh[p_idx + 890] * templateSh[250];
		conv += panelSh[p_idx + 891] * templateSh[249];
		conv += panelSh[p_idx + 892] * templateSh[248];
		conv += panelSh[p_idx + 893] * templateSh[247];
		conv += panelSh[p_idx + 894] * templateSh[246];
		conv += panelSh[p_idx + 895] * templateSh[245];
		conv += panelSh[p_idx + 896] * templateSh[244];
		conv += panelSh[p_idx + 897] * templateSh[243];
		conv += panelSh[p_idx + 898] * templateSh[242];
		conv += panelSh[p_idx + 899] * templateSh[241];
		conv += panelSh[p_idx + 900] * templateSh[240];
		conv += panelSh[p_idx + 901] * templateSh[239];
		conv += panelSh[p_idx + 902] * templateSh[238];
		conv += panelSh[p_idx + 903] * templateSh[237];
		conv += panelSh[p_idx + 904] * templateSh[236];
		conv += panelSh[p_idx + 905] * templateSh[235];
		conv += panelSh[p_idx + 906] * templateSh[234];
		conv += panelSh[p_idx + 907] * templateSh[233];
		conv += panelSh[p_idx + 908] * templateSh[232];
		conv += panelSh[p_idx + 924] * templateSh[231];
		conv += panelSh[p_idx + 925] * templateSh[230];
		conv += panelSh[p_idx + 926] * templateSh[229];
		conv += panelSh[p_idx + 927] * templateSh[228];
		conv += panelSh[p_idx + 928] * templateSh[227];
		conv += panelSh[p_idx + 929] * templateSh[226];
		conv += panelSh[p_idx + 930] * templateSh[225];
		conv += panelSh[p_idx + 931] * templateSh[224];
		conv += panelSh[p_idx + 932] * templateSh[223];
		conv += panelSh[p_idx + 933] * templateSh[222];
		conv += panelSh[p_idx + 934] * templateSh[221];
		conv += panelSh[p_idx + 935] * templateSh[220];
		conv += panelSh[p_idx + 936] * templateSh[219];
		conv += panelSh[p_idx + 937] * templateSh[218];
		conv += panelSh[p_idx + 938] * templateSh[217];
		conv += panelSh[p_idx + 939] * templateSh[216];
		conv += panelSh[p_idx + 940] * templateSh[215];
		conv += panelSh[p_idx + 941] * templateSh[214];
		conv += panelSh[p_idx + 942] * templateSh[213];
		conv += panelSh[p_idx + 943] * templateSh[212];
		conv += panelSh[p_idx + 944] * templateSh[211];
		conv += panelSh[p_idx + 945] * templateSh[210];
		conv += panelSh[p_idx + 946] * templateSh[209];
		conv += panelSh[p_idx + 947] * templateSh[208];
		conv += panelSh[p_idx + 948] * templateSh[207];
		conv += panelSh[p_idx + 949] * templateSh[206];
		conv += panelSh[p_idx + 950] * templateSh[205];
		conv += panelSh[p_idx + 951] * templateSh[204];
		conv += panelSh[p_idx + 952] * templateSh[203];
		conv += panelSh[p_idx + 968] * templateSh[202];
		conv += panelSh[p_idx + 969] * templateSh[201];
		conv += panelSh[p_idx + 970] * templateSh[200];
		conv += panelSh[p_idx + 971] * templateSh[199];
		conv += panelSh[p_idx + 972] * templateSh[198];
		conv += panelSh[p_idx + 973] * templateSh[197];
		conv += panelSh[p_idx + 974] * templateSh[196];
		conv += panelSh[p_idx + 975] * templateSh[195];
		conv += panelSh[p_idx + 976] * templateSh[194];
		conv += panelSh[p_idx + 977] * templateSh[193];
		conv += panelSh[p_idx + 978] * templateSh[192];
		conv += panelSh[p_idx + 979] * templateSh[191];
		conv += panelSh[p_idx + 980] * templateSh[190];
		conv += panelSh[p_idx + 981] * templateSh[189];
		conv += panelSh[p_idx + 982] * templateSh[188];
		conv += panelSh[p_idx + 983] * templateSh[187];
		conv += panelSh[p_idx + 984] * templateSh[186];
		conv += panelSh[p_idx + 985] * templateSh[185];
		conv += panelSh[p_idx + 986] * templateSh[184];
		conv += panelSh[p_idx + 987] * templateSh[183];
		conv += panelSh[p_idx + 988] * templateSh[182];
		conv += panelSh[p_idx + 989] * templateSh[181];
		conv += panelSh[p_idx + 990] * templateSh[180];
		conv += panelSh[p_idx + 991] * templateSh[179];
		conv += panelSh[p_idx + 992] * templateSh[178];
		conv += panelSh[p_idx + 993] * templateSh[177];
		conv += panelSh[p_idx + 994] * templateSh[176];
		conv += panelSh[p_idx + 995] * templateSh[175];
		conv += panelSh[p_idx + 996] * templateSh[174];
		conv += panelSh[p_idx + 1012] * templateSh[173];
		conv += panelSh[p_idx + 1013] * templateSh[172];
		conv += panelSh[p_idx + 1014] * templateSh[171];
		conv += panelSh[p_idx + 1015] * templateSh[170];
		conv += panelSh[p_idx + 1016] * templateSh[169];
		conv += panelSh[p_idx + 1017] * templateSh[168];
		conv += panelSh[p_idx + 1018] * templateSh[167];
		conv += panelSh[p_idx + 1019] * templateSh[166];
		conv += panelSh[p_idx + 1020] * templateSh[165];
		conv += panelSh[p_idx + 1021] * templateSh[164];
		conv += panelSh[p_idx + 1022] * templateSh[163];
		conv += panelSh[p_idx + 1023] * templateSh[162];
		conv += panelSh[p_idx + 1024] * templateSh[161];
		conv += panelSh[p_idx + 1025] * templateSh[160];
		conv += panelSh[p_idx + 1026] * templateSh[159];
		conv += panelSh[p_idx + 1027] * templateSh[158];
		conv += panelSh[p_idx + 1028] * templateSh[157];
		conv += panelSh[p_idx + 1029] * templateSh[156];
		conv += panelSh[p_idx + 1030] * templateSh[155];
		conv += panelSh[p_idx + 1031] * templateSh[154];
		conv += panelSh[p_idx + 1032] * templateSh[153];
		conv += panelSh[p_idx + 1033] * templateSh[152];
		conv += panelSh[p_idx + 1034] * templateSh[151];
		conv += panelSh[p_idx + 1035] * templateSh[150];
		conv += panelSh[p_idx + 1036] * templateSh[149];
		conv += panelSh[p_idx + 1037] * templateSh[148];
		conv += panelSh[p_idx + 1038] * templateSh[147];
		conv += panelSh[p_idx + 1039] * templateSh[146];
		conv += panelSh[p_idx + 1040] * templateSh[145];
		conv += panelSh[p_idx + 1056] * templateSh[144];
		conv += panelSh[p_idx + 1057] * templateSh[143];
		conv += panelSh[p_idx + 1058] * templateSh[142];
		conv += panelSh[p_idx + 1059] * templateSh[141];
		conv += panelSh[p_idx + 1060] * templateSh[140];
		conv += panelSh[p_idx + 1061] * templateSh[139];
		conv += panelSh[p_idx + 1062] * templateSh[138];
		conv += panelSh[p_idx + 1063] * templateSh[137];
		conv += panelSh[p_idx + 1064] * templateSh[136];
		conv += panelSh[p_idx + 1065] * templateSh[135];
		conv += panelSh[p_idx + 1066] * templateSh[134];
		conv += panelSh[p_idx + 1067] * templateSh[133];
		conv += panelSh[p_idx + 1068] * templateSh[132];
		conv += panelSh[p_idx + 1069] * templateSh[131];
		conv += panelSh[p_idx + 1070] * templateSh[130];
		conv += panelSh[p_idx + 1071] * templateSh[129];
		conv += panelSh[p_idx + 1072] * templateSh[128];
		conv += panelSh[p_idx + 1073] * templateSh[127];
		conv += panelSh[p_idx + 1074] * templateSh[126];
		conv += panelSh[p_idx + 1075] * templateSh[125];
		conv += panelSh[p_idx + 1076] * templateSh[124];
		conv += panelSh[p_idx + 1077] * templateSh[123];
		conv += panelSh[p_idx + 1078] * templateSh[122];
		conv += panelSh[p_idx + 1079] * templateSh[121];
		conv += panelSh[p_idx + 1080] * templateSh[120];
		conv += panelSh[p_idx + 1081] * templateSh[119];
		conv += panelSh[p_idx + 1082] * templateSh[118];
		conv += panelSh[p_idx + 1083] * templateSh[117];
		conv += panelSh[p_idx + 1084] * templateSh[116];
		conv += panelSh[p_idx + 1100] * templateSh[115];
		conv += panelSh[p_idx + 1101] * templateSh[114];
		conv += panelSh[p_idx + 1102] * templateSh[113];
		conv += panelSh[p_idx + 1103] * templateSh[112];
		conv += panelSh[p_idx + 1104] * templateSh[111];
		conv += panelSh[p_idx + 1105] * templateSh[110];
		conv += panelSh[p_idx + 1106] * templateSh[109];
		conv += panelSh[p_idx + 1107] * templateSh[108];
		conv += panelSh[p_idx + 1108] * templateSh[107];
		conv += panelSh[p_idx + 1109] * templateSh[106];
		conv += panelSh[p_idx + 1110] * templateSh[105];
		conv += panelSh[p_idx + 1111] * templateSh[104];
		conv += panelSh[p_idx + 1112] * templateSh[103];
		conv += panelSh[p_idx + 1113] * templateSh[102];
		conv += panelSh[p_idx + 1114] * templateSh[101];
		conv += panelSh[p_idx + 1115] * templateSh[100];
		conv += panelSh[p_idx + 1116] * templateSh[99];
		conv += panelSh[p_idx + 1117] * templateSh[98];
		conv += panelSh[p_idx + 1118] * templateSh[97];
		conv += panelSh[p_idx + 1119] * templateSh[96];
		conv += panelSh[p_idx + 1120] * templateSh[95];
		conv += panelSh[p_idx + 1121] * templateSh[94];
		conv += panelSh[p_idx + 1122] * templateSh[93];
		conv += panelSh[p_idx + 1123] * templateSh[92];
		conv += panelSh[p_idx + 1124] * templateSh[91];
		conv += panelSh[p_idx + 1125] * templateSh[90];
		conv += panelSh[p_idx + 1126] * templateSh[89];
		conv += panelSh[p_idx + 1127] * templateSh[88];
		conv += panelSh[p_idx + 1128] * templateSh[87];
		conv += panelSh[p_idx + 1144] * templateSh[86];
		conv += panelSh[p_idx + 1145] * templateSh[85];
		conv += panelSh[p_idx + 1146] * templateSh[84];
		conv += panelSh[p_idx + 1147] * templateSh[83];
		conv += panelSh[p_idx + 1148] * templateSh[82];
		conv += panelSh[p_idx + 1149] * templateSh[81];
		conv += panelSh[p_idx + 1150] * templateSh[80];
		conv += panelSh[p_idx + 1151] * templateSh[79];
		conv += panelSh[p_idx + 1152] * templateSh[78];
		conv += panelSh[p_idx + 1153] * templateSh[77];
		conv += panelSh[p_idx + 1154] * templateSh[76];
		conv += panelSh[p_idx + 1155] * templateSh[75];
		conv += panelSh[p_idx + 1156] * templateSh[74];
		conv += panelSh[p_idx + 1157] * templateSh[73];
		conv += panelSh[p_idx + 1158] * templateSh[72];
		conv += panelSh[p_idx + 1159] * templateSh[71];
		conv += panelSh[p_idx + 1160] * templateSh[70];
		conv += panelSh[p_idx + 1161] * templateSh[69];
		conv += panelSh[p_idx + 1162] * templateSh[68];
		conv += panelSh[p_idx + 1163] * templateSh[67];
		conv += panelSh[p_idx + 1164] * templateSh[66];
		conv += panelSh[p_idx + 1165] * templateSh[65];
		conv += panelSh[p_idx + 1166] * templateSh[64];
		conv += panelSh[p_idx + 1167] * templateSh[63];
		conv += panelSh[p_idx + 1168] * templateSh[62];
		conv += panelSh[p_idx + 1169] * templateSh[61];
		conv += panelSh[p_idx + 1170] * templateSh[60];
		conv += panelSh[p_idx + 1171] * templateSh[59];
		conv += panelSh[p_idx + 1172] * templateSh[58];
		conv += panelSh[p_idx + 1188] * templateSh[57];
		conv += panelSh[p_idx + 1189] * templateSh[56];
		conv += panelSh[p_idx + 1190] * templateSh[55];
		conv += panelSh[p_idx + 1191] * templateSh[54];
		conv += panelSh[p_idx + 1192] * templateSh[53];
		conv += panelSh[p_idx + 1193] * templateSh[52];
		conv += panelSh[p_idx + 1194] * templateSh[51];
		conv += panelSh[p_idx + 1195] * templateSh[50];
		conv += panelSh[p_idx + 1196] * templateSh[49];
		conv += panelSh[p_idx + 1197] * templateSh[48];
		conv += panelSh[p_idx + 1198] * templateSh[47];
		conv += panelSh[p_idx + 1199] * templateSh[46];
		conv += panelSh[p_idx + 1200] * templateSh[45];
		conv += panelSh[p_idx + 1201] * templateSh[44];
		conv += panelSh[p_idx + 1202] * templateSh[43];
		conv += panelSh[p_idx + 1203] * templateSh[42];
		conv += panelSh[p_idx + 1204] * templateSh[41];
		conv += panelSh[p_idx + 1205] * templateSh[40];
		conv += panelSh[p_idx + 1206] * templateSh[39];
		conv += panelSh[p_idx + 1207] * templateSh[38];
		conv += panelSh[p_idx + 1208] * templateSh[37];
		conv += panelSh[p_idx + 1209] * templateSh[36];
		conv += panelSh[p_idx + 1210] * templateSh[35];
		conv += panelSh[p_idx + 1211] * templateSh[34];
		conv += panelSh[p_idx + 1212] * templateSh[33];
		conv += panelSh[p_idx + 1213] * templateSh[32];
		conv += panelSh[p_idx + 1214] * templateSh[31];
		conv += panelSh[p_idx + 1215] * templateSh[30];
		conv += panelSh[p_idx + 1216] * templateSh[29];
		conv += panelSh[p_idx + 1232] * templateSh[28];
		conv += panelSh[p_idx + 1233] * templateSh[27];
		conv += panelSh[p_idx + 1234] * templateSh[26];
		conv += panelSh[p_idx + 1235] * templateSh[25];
		conv += panelSh[p_idx + 1236] * templateSh[24];
		conv += panelSh[p_idx + 1237] * templateSh[23];
		conv += panelSh[p_idx + 1238] * templateSh[22];
		conv += panelSh[p_idx + 1239] * templateSh[21];
		conv += panelSh[p_idx + 1240] * templateSh[20];
		conv += panelSh[p_idx + 1241] * templateSh[19];
		conv += panelSh[p_idx + 1242] * templateSh[18];
		conv += panelSh[p_idx + 1243] * templateSh[17];
		conv += panelSh[p_idx + 1244] * templateSh[16];
		conv += panelSh[p_idx + 1245] * templateSh[15];
		conv += panelSh[p_idx + 1246] * templateSh[14];
		conv += panelSh[p_idx + 1247] * templateSh[13];
		conv += panelSh[p_idx + 1248] * templateSh[12];
		conv += panelSh[p_idx + 1249] * templateSh[11];
		conv += panelSh[p_idx + 1250] * templateSh[10];
		conv += panelSh[p_idx + 1251] * templateSh[9];
		conv += panelSh[p_idx + 1252] * templateSh[8];
		conv += panelSh[p_idx + 1253] * templateSh[7];
		conv += panelSh[p_idx + 1254] * templateSh[6];
		conv += panelSh[p_idx + 1255] * templateSh[5];
		conv += panelSh[p_idx + 1256] * templateSh[4];
		conv += panelSh[p_idx + 1257] * templateSh[3];
		conv += panelSh[p_idx + 1258] * templateSh[2];
		conv += panelSh[p_idx + 1259] * templateSh[1];
		conv += panelSh[p_idx + 1260] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_29x29<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_29x29<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_30x30 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[2025];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<45; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<45; i+=16) {
			panelSh[IMUL(j, 45) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[900];
	for (int j=threadIdx.y; j<30; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<30; i+=16) {
			const int jtwi = IMUL(j, 30) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 45);
		conv += panelSh[p_idx + 0] * templateSh[899];
		conv += panelSh[p_idx + 1] * templateSh[898];
		conv += panelSh[p_idx + 2] * templateSh[897];
		conv += panelSh[p_idx + 3] * templateSh[896];
		conv += panelSh[p_idx + 4] * templateSh[895];
		conv += panelSh[p_idx + 5] * templateSh[894];
		conv += panelSh[p_idx + 6] * templateSh[893];
		conv += panelSh[p_idx + 7] * templateSh[892];
		conv += panelSh[p_idx + 8] * templateSh[891];
		conv += panelSh[p_idx + 9] * templateSh[890];
		conv += panelSh[p_idx + 10] * templateSh[889];
		conv += panelSh[p_idx + 11] * templateSh[888];
		conv += panelSh[p_idx + 12] * templateSh[887];
		conv += panelSh[p_idx + 13] * templateSh[886];
		conv += panelSh[p_idx + 14] * templateSh[885];
		conv += panelSh[p_idx + 15] * templateSh[884];
		conv += panelSh[p_idx + 16] * templateSh[883];
		conv += panelSh[p_idx + 17] * templateSh[882];
		conv += panelSh[p_idx + 18] * templateSh[881];
		conv += panelSh[p_idx + 19] * templateSh[880];
		conv += panelSh[p_idx + 20] * templateSh[879];
		conv += panelSh[p_idx + 21] * templateSh[878];
		conv += panelSh[p_idx + 22] * templateSh[877];
		conv += panelSh[p_idx + 23] * templateSh[876];
		conv += panelSh[p_idx + 24] * templateSh[875];
		conv += panelSh[p_idx + 25] * templateSh[874];
		conv += panelSh[p_idx + 26] * templateSh[873];
		conv += panelSh[p_idx + 27] * templateSh[872];
		conv += panelSh[p_idx + 28] * templateSh[871];
		conv += panelSh[p_idx + 29] * templateSh[870];
		conv += panelSh[p_idx + 45] * templateSh[869];
		conv += panelSh[p_idx + 46] * templateSh[868];
		conv += panelSh[p_idx + 47] * templateSh[867];
		conv += panelSh[p_idx + 48] * templateSh[866];
		conv += panelSh[p_idx + 49] * templateSh[865];
		conv += panelSh[p_idx + 50] * templateSh[864];
		conv += panelSh[p_idx + 51] * templateSh[863];
		conv += panelSh[p_idx + 52] * templateSh[862];
		conv += panelSh[p_idx + 53] * templateSh[861];
		conv += panelSh[p_idx + 54] * templateSh[860];
		conv += panelSh[p_idx + 55] * templateSh[859];
		conv += panelSh[p_idx + 56] * templateSh[858];
		conv += panelSh[p_idx + 57] * templateSh[857];
		conv += panelSh[p_idx + 58] * templateSh[856];
		conv += panelSh[p_idx + 59] * templateSh[855];
		conv += panelSh[p_idx + 60] * templateSh[854];
		conv += panelSh[p_idx + 61] * templateSh[853];
		conv += panelSh[p_idx + 62] * templateSh[852];
		conv += panelSh[p_idx + 63] * templateSh[851];
		conv += panelSh[p_idx + 64] * templateSh[850];
		conv += panelSh[p_idx + 65] * templateSh[849];
		conv += panelSh[p_idx + 66] * templateSh[848];
		conv += panelSh[p_idx + 67] * templateSh[847];
		conv += panelSh[p_idx + 68] * templateSh[846];
		conv += panelSh[p_idx + 69] * templateSh[845];
		conv += panelSh[p_idx + 70] * templateSh[844];
		conv += panelSh[p_idx + 71] * templateSh[843];
		conv += panelSh[p_idx + 72] * templateSh[842];
		conv += panelSh[p_idx + 73] * templateSh[841];
		conv += panelSh[p_idx + 74] * templateSh[840];
		conv += panelSh[p_idx + 90] * templateSh[839];
		conv += panelSh[p_idx + 91] * templateSh[838];
		conv += panelSh[p_idx + 92] * templateSh[837];
		conv += panelSh[p_idx + 93] * templateSh[836];
		conv += panelSh[p_idx + 94] * templateSh[835];
		conv += panelSh[p_idx + 95] * templateSh[834];
		conv += panelSh[p_idx + 96] * templateSh[833];
		conv += panelSh[p_idx + 97] * templateSh[832];
		conv += panelSh[p_idx + 98] * templateSh[831];
		conv += panelSh[p_idx + 99] * templateSh[830];
		conv += panelSh[p_idx + 100] * templateSh[829];
		conv += panelSh[p_idx + 101] * templateSh[828];
		conv += panelSh[p_idx + 102] * templateSh[827];
		conv += panelSh[p_idx + 103] * templateSh[826];
		conv += panelSh[p_idx + 104] * templateSh[825];
		conv += panelSh[p_idx + 105] * templateSh[824];
		conv += panelSh[p_idx + 106] * templateSh[823];
		conv += panelSh[p_idx + 107] * templateSh[822];
		conv += panelSh[p_idx + 108] * templateSh[821];
		conv += panelSh[p_idx + 109] * templateSh[820];
		conv += panelSh[p_idx + 110] * templateSh[819];
		conv += panelSh[p_idx + 111] * templateSh[818];
		conv += panelSh[p_idx + 112] * templateSh[817];
		conv += panelSh[p_idx + 113] * templateSh[816];
		conv += panelSh[p_idx + 114] * templateSh[815];
		conv += panelSh[p_idx + 115] * templateSh[814];
		conv += panelSh[p_idx + 116] * templateSh[813];
		conv += panelSh[p_idx + 117] * templateSh[812];
		conv += panelSh[p_idx + 118] * templateSh[811];
		conv += panelSh[p_idx + 119] * templateSh[810];
		conv += panelSh[p_idx + 135] * templateSh[809];
		conv += panelSh[p_idx + 136] * templateSh[808];
		conv += panelSh[p_idx + 137] * templateSh[807];
		conv += panelSh[p_idx + 138] * templateSh[806];
		conv += panelSh[p_idx + 139] * templateSh[805];
		conv += panelSh[p_idx + 140] * templateSh[804];
		conv += panelSh[p_idx + 141] * templateSh[803];
		conv += panelSh[p_idx + 142] * templateSh[802];
		conv += panelSh[p_idx + 143] * templateSh[801];
		conv += panelSh[p_idx + 144] * templateSh[800];
		conv += panelSh[p_idx + 145] * templateSh[799];
		conv += panelSh[p_idx + 146] * templateSh[798];
		conv += panelSh[p_idx + 147] * templateSh[797];
		conv += panelSh[p_idx + 148] * templateSh[796];
		conv += panelSh[p_idx + 149] * templateSh[795];
		conv += panelSh[p_idx + 150] * templateSh[794];
		conv += panelSh[p_idx + 151] * templateSh[793];
		conv += panelSh[p_idx + 152] * templateSh[792];
		conv += panelSh[p_idx + 153] * templateSh[791];
		conv += panelSh[p_idx + 154] * templateSh[790];
		conv += panelSh[p_idx + 155] * templateSh[789];
		conv += panelSh[p_idx + 156] * templateSh[788];
		conv += panelSh[p_idx + 157] * templateSh[787];
		conv += panelSh[p_idx + 158] * templateSh[786];
		conv += panelSh[p_idx + 159] * templateSh[785];
		conv += panelSh[p_idx + 160] * templateSh[784];
		conv += panelSh[p_idx + 161] * templateSh[783];
		conv += panelSh[p_idx + 162] * templateSh[782];
		conv += panelSh[p_idx + 163] * templateSh[781];
		conv += panelSh[p_idx + 164] * templateSh[780];
		conv += panelSh[p_idx + 180] * templateSh[779];
		conv += panelSh[p_idx + 181] * templateSh[778];
		conv += panelSh[p_idx + 182] * templateSh[777];
		conv += panelSh[p_idx + 183] * templateSh[776];
		conv += panelSh[p_idx + 184] * templateSh[775];
		conv += panelSh[p_idx + 185] * templateSh[774];
		conv += panelSh[p_idx + 186] * templateSh[773];
		conv += panelSh[p_idx + 187] * templateSh[772];
		conv += panelSh[p_idx + 188] * templateSh[771];
		conv += panelSh[p_idx + 189] * templateSh[770];
		conv += panelSh[p_idx + 190] * templateSh[769];
		conv += panelSh[p_idx + 191] * templateSh[768];
		conv += panelSh[p_idx + 192] * templateSh[767];
		conv += panelSh[p_idx + 193] * templateSh[766];
		conv += panelSh[p_idx + 194] * templateSh[765];
		conv += panelSh[p_idx + 195] * templateSh[764];
		conv += panelSh[p_idx + 196] * templateSh[763];
		conv += panelSh[p_idx + 197] * templateSh[762];
		conv += panelSh[p_idx + 198] * templateSh[761];
		conv += panelSh[p_idx + 199] * templateSh[760];
		conv += panelSh[p_idx + 200] * templateSh[759];
		conv += panelSh[p_idx + 201] * templateSh[758];
		conv += panelSh[p_idx + 202] * templateSh[757];
		conv += panelSh[p_idx + 203] * templateSh[756];
		conv += panelSh[p_idx + 204] * templateSh[755];
		conv += panelSh[p_idx + 205] * templateSh[754];
		conv += panelSh[p_idx + 206] * templateSh[753];
		conv += panelSh[p_idx + 207] * templateSh[752];
		conv += panelSh[p_idx + 208] * templateSh[751];
		conv += panelSh[p_idx + 209] * templateSh[750];
		conv += panelSh[p_idx + 225] * templateSh[749];
		conv += panelSh[p_idx + 226] * templateSh[748];
		conv += panelSh[p_idx + 227] * templateSh[747];
		conv += panelSh[p_idx + 228] * templateSh[746];
		conv += panelSh[p_idx + 229] * templateSh[745];
		conv += panelSh[p_idx + 230] * templateSh[744];
		conv += panelSh[p_idx + 231] * templateSh[743];
		conv += panelSh[p_idx + 232] * templateSh[742];
		conv += panelSh[p_idx + 233] * templateSh[741];
		conv += panelSh[p_idx + 234] * templateSh[740];
		conv += panelSh[p_idx + 235] * templateSh[739];
		conv += panelSh[p_idx + 236] * templateSh[738];
		conv += panelSh[p_idx + 237] * templateSh[737];
		conv += panelSh[p_idx + 238] * templateSh[736];
		conv += panelSh[p_idx + 239] * templateSh[735];
		conv += panelSh[p_idx + 240] * templateSh[734];
		conv += panelSh[p_idx + 241] * templateSh[733];
		conv += panelSh[p_idx + 242] * templateSh[732];
		conv += panelSh[p_idx + 243] * templateSh[731];
		conv += panelSh[p_idx + 244] * templateSh[730];
		conv += panelSh[p_idx + 245] * templateSh[729];
		conv += panelSh[p_idx + 246] * templateSh[728];
		conv += panelSh[p_idx + 247] * templateSh[727];
		conv += panelSh[p_idx + 248] * templateSh[726];
		conv += panelSh[p_idx + 249] * templateSh[725];
		conv += panelSh[p_idx + 250] * templateSh[724];
		conv += panelSh[p_idx + 251] * templateSh[723];
		conv += panelSh[p_idx + 252] * templateSh[722];
		conv += panelSh[p_idx + 253] * templateSh[721];
		conv += panelSh[p_idx + 254] * templateSh[720];
		conv += panelSh[p_idx + 270] * templateSh[719];
		conv += panelSh[p_idx + 271] * templateSh[718];
		conv += panelSh[p_idx + 272] * templateSh[717];
		conv += panelSh[p_idx + 273] * templateSh[716];
		conv += panelSh[p_idx + 274] * templateSh[715];
		conv += panelSh[p_idx + 275] * templateSh[714];
		conv += panelSh[p_idx + 276] * templateSh[713];
		conv += panelSh[p_idx + 277] * templateSh[712];
		conv += panelSh[p_idx + 278] * templateSh[711];
		conv += panelSh[p_idx + 279] * templateSh[710];
		conv += panelSh[p_idx + 280] * templateSh[709];
		conv += panelSh[p_idx + 281] * templateSh[708];
		conv += panelSh[p_idx + 282] * templateSh[707];
		conv += panelSh[p_idx + 283] * templateSh[706];
		conv += panelSh[p_idx + 284] * templateSh[705];
		conv += panelSh[p_idx + 285] * templateSh[704];
		conv += panelSh[p_idx + 286] * templateSh[703];
		conv += panelSh[p_idx + 287] * templateSh[702];
		conv += panelSh[p_idx + 288] * templateSh[701];
		conv += panelSh[p_idx + 289] * templateSh[700];
		conv += panelSh[p_idx + 290] * templateSh[699];
		conv += panelSh[p_idx + 291] * templateSh[698];
		conv += panelSh[p_idx + 292] * templateSh[697];
		conv += panelSh[p_idx + 293] * templateSh[696];
		conv += panelSh[p_idx + 294] * templateSh[695];
		conv += panelSh[p_idx + 295] * templateSh[694];
		conv += panelSh[p_idx + 296] * templateSh[693];
		conv += panelSh[p_idx + 297] * templateSh[692];
		conv += panelSh[p_idx + 298] * templateSh[691];
		conv += panelSh[p_idx + 299] * templateSh[690];
		conv += panelSh[p_idx + 315] * templateSh[689];
		conv += panelSh[p_idx + 316] * templateSh[688];
		conv += panelSh[p_idx + 317] * templateSh[687];
		conv += panelSh[p_idx + 318] * templateSh[686];
		conv += panelSh[p_idx + 319] * templateSh[685];
		conv += panelSh[p_idx + 320] * templateSh[684];
		conv += panelSh[p_idx + 321] * templateSh[683];
		conv += panelSh[p_idx + 322] * templateSh[682];
		conv += panelSh[p_idx + 323] * templateSh[681];
		conv += panelSh[p_idx + 324] * templateSh[680];
		conv += panelSh[p_idx + 325] * templateSh[679];
		conv += panelSh[p_idx + 326] * templateSh[678];
		conv += panelSh[p_idx + 327] * templateSh[677];
		conv += panelSh[p_idx + 328] * templateSh[676];
		conv += panelSh[p_idx + 329] * templateSh[675];
		conv += panelSh[p_idx + 330] * templateSh[674];
		conv += panelSh[p_idx + 331] * templateSh[673];
		conv += panelSh[p_idx + 332] * templateSh[672];
		conv += panelSh[p_idx + 333] * templateSh[671];
		conv += panelSh[p_idx + 334] * templateSh[670];
		conv += panelSh[p_idx + 335] * templateSh[669];
		conv += panelSh[p_idx + 336] * templateSh[668];
		conv += panelSh[p_idx + 337] * templateSh[667];
		conv += panelSh[p_idx + 338] * templateSh[666];
		conv += panelSh[p_idx + 339] * templateSh[665];
		conv += panelSh[p_idx + 340] * templateSh[664];
		conv += panelSh[p_idx + 341] * templateSh[663];
		conv += panelSh[p_idx + 342] * templateSh[662];
		conv += panelSh[p_idx + 343] * templateSh[661];
		conv += panelSh[p_idx + 344] * templateSh[660];
		conv += panelSh[p_idx + 360] * templateSh[659];
		conv += panelSh[p_idx + 361] * templateSh[658];
		conv += panelSh[p_idx + 362] * templateSh[657];
		conv += panelSh[p_idx + 363] * templateSh[656];
		conv += panelSh[p_idx + 364] * templateSh[655];
		conv += panelSh[p_idx + 365] * templateSh[654];
		conv += panelSh[p_idx + 366] * templateSh[653];
		conv += panelSh[p_idx + 367] * templateSh[652];
		conv += panelSh[p_idx + 368] * templateSh[651];
		conv += panelSh[p_idx + 369] * templateSh[650];
		conv += panelSh[p_idx + 370] * templateSh[649];
		conv += panelSh[p_idx + 371] * templateSh[648];
		conv += panelSh[p_idx + 372] * templateSh[647];
		conv += panelSh[p_idx + 373] * templateSh[646];
		conv += panelSh[p_idx + 374] * templateSh[645];
		conv += panelSh[p_idx + 375] * templateSh[644];
		conv += panelSh[p_idx + 376] * templateSh[643];
		conv += panelSh[p_idx + 377] * templateSh[642];
		conv += panelSh[p_idx + 378] * templateSh[641];
		conv += panelSh[p_idx + 379] * templateSh[640];
		conv += panelSh[p_idx + 380] * templateSh[639];
		conv += panelSh[p_idx + 381] * templateSh[638];
		conv += panelSh[p_idx + 382] * templateSh[637];
		conv += panelSh[p_idx + 383] * templateSh[636];
		conv += panelSh[p_idx + 384] * templateSh[635];
		conv += panelSh[p_idx + 385] * templateSh[634];
		conv += panelSh[p_idx + 386] * templateSh[633];
		conv += panelSh[p_idx + 387] * templateSh[632];
		conv += panelSh[p_idx + 388] * templateSh[631];
		conv += panelSh[p_idx + 389] * templateSh[630];
		conv += panelSh[p_idx + 405] * templateSh[629];
		conv += panelSh[p_idx + 406] * templateSh[628];
		conv += panelSh[p_idx + 407] * templateSh[627];
		conv += panelSh[p_idx + 408] * templateSh[626];
		conv += panelSh[p_idx + 409] * templateSh[625];
		conv += panelSh[p_idx + 410] * templateSh[624];
		conv += panelSh[p_idx + 411] * templateSh[623];
		conv += panelSh[p_idx + 412] * templateSh[622];
		conv += panelSh[p_idx + 413] * templateSh[621];
		conv += panelSh[p_idx + 414] * templateSh[620];
		conv += panelSh[p_idx + 415] * templateSh[619];
		conv += panelSh[p_idx + 416] * templateSh[618];
		conv += panelSh[p_idx + 417] * templateSh[617];
		conv += panelSh[p_idx + 418] * templateSh[616];
		conv += panelSh[p_idx + 419] * templateSh[615];
		conv += panelSh[p_idx + 420] * templateSh[614];
		conv += panelSh[p_idx + 421] * templateSh[613];
		conv += panelSh[p_idx + 422] * templateSh[612];
		conv += panelSh[p_idx + 423] * templateSh[611];
		conv += panelSh[p_idx + 424] * templateSh[610];
		conv += panelSh[p_idx + 425] * templateSh[609];
		conv += panelSh[p_idx + 426] * templateSh[608];
		conv += panelSh[p_idx + 427] * templateSh[607];
		conv += panelSh[p_idx + 428] * templateSh[606];
		conv += panelSh[p_idx + 429] * templateSh[605];
		conv += panelSh[p_idx + 430] * templateSh[604];
		conv += panelSh[p_idx + 431] * templateSh[603];
		conv += panelSh[p_idx + 432] * templateSh[602];
		conv += panelSh[p_idx + 433] * templateSh[601];
		conv += panelSh[p_idx + 434] * templateSh[600];
		conv += panelSh[p_idx + 450] * templateSh[599];
		conv += panelSh[p_idx + 451] * templateSh[598];
		conv += panelSh[p_idx + 452] * templateSh[597];
		conv += panelSh[p_idx + 453] * templateSh[596];
		conv += panelSh[p_idx + 454] * templateSh[595];
		conv += panelSh[p_idx + 455] * templateSh[594];
		conv += panelSh[p_idx + 456] * templateSh[593];
		conv += panelSh[p_idx + 457] * templateSh[592];
		conv += panelSh[p_idx + 458] * templateSh[591];
		conv += panelSh[p_idx + 459] * templateSh[590];
		conv += panelSh[p_idx + 460] * templateSh[589];
		conv += panelSh[p_idx + 461] * templateSh[588];
		conv += panelSh[p_idx + 462] * templateSh[587];
		conv += panelSh[p_idx + 463] * templateSh[586];
		conv += panelSh[p_idx + 464] * templateSh[585];
		conv += panelSh[p_idx + 465] * templateSh[584];
		conv += panelSh[p_idx + 466] * templateSh[583];
		conv += panelSh[p_idx + 467] * templateSh[582];
		conv += panelSh[p_idx + 468] * templateSh[581];
		conv += panelSh[p_idx + 469] * templateSh[580];
		conv += panelSh[p_idx + 470] * templateSh[579];
		conv += panelSh[p_idx + 471] * templateSh[578];
		conv += panelSh[p_idx + 472] * templateSh[577];
		conv += panelSh[p_idx + 473] * templateSh[576];
		conv += panelSh[p_idx + 474] * templateSh[575];
		conv += panelSh[p_idx + 475] * templateSh[574];
		conv += panelSh[p_idx + 476] * templateSh[573];
		conv += panelSh[p_idx + 477] * templateSh[572];
		conv += panelSh[p_idx + 478] * templateSh[571];
		conv += panelSh[p_idx + 479] * templateSh[570];
		conv += panelSh[p_idx + 495] * templateSh[569];
		conv += panelSh[p_idx + 496] * templateSh[568];
		conv += panelSh[p_idx + 497] * templateSh[567];
		conv += panelSh[p_idx + 498] * templateSh[566];
		conv += panelSh[p_idx + 499] * templateSh[565];
		conv += panelSh[p_idx + 500] * templateSh[564];
		conv += panelSh[p_idx + 501] * templateSh[563];
		conv += panelSh[p_idx + 502] * templateSh[562];
		conv += panelSh[p_idx + 503] * templateSh[561];
		conv += panelSh[p_idx + 504] * templateSh[560];
		conv += panelSh[p_idx + 505] * templateSh[559];
		conv += panelSh[p_idx + 506] * templateSh[558];
		conv += panelSh[p_idx + 507] * templateSh[557];
		conv += panelSh[p_idx + 508] * templateSh[556];
		conv += panelSh[p_idx + 509] * templateSh[555];
		conv += panelSh[p_idx + 510] * templateSh[554];
		conv += panelSh[p_idx + 511] * templateSh[553];
		conv += panelSh[p_idx + 512] * templateSh[552];
		conv += panelSh[p_idx + 513] * templateSh[551];
		conv += panelSh[p_idx + 514] * templateSh[550];
		conv += panelSh[p_idx + 515] * templateSh[549];
		conv += panelSh[p_idx + 516] * templateSh[548];
		conv += panelSh[p_idx + 517] * templateSh[547];
		conv += panelSh[p_idx + 518] * templateSh[546];
		conv += panelSh[p_idx + 519] * templateSh[545];
		conv += panelSh[p_idx + 520] * templateSh[544];
		conv += panelSh[p_idx + 521] * templateSh[543];
		conv += panelSh[p_idx + 522] * templateSh[542];
		conv += panelSh[p_idx + 523] * templateSh[541];
		conv += panelSh[p_idx + 524] * templateSh[540];
		conv += panelSh[p_idx + 540] * templateSh[539];
		conv += panelSh[p_idx + 541] * templateSh[538];
		conv += panelSh[p_idx + 542] * templateSh[537];
		conv += panelSh[p_idx + 543] * templateSh[536];
		conv += panelSh[p_idx + 544] * templateSh[535];
		conv += panelSh[p_idx + 545] * templateSh[534];
		conv += panelSh[p_idx + 546] * templateSh[533];
		conv += panelSh[p_idx + 547] * templateSh[532];
		conv += panelSh[p_idx + 548] * templateSh[531];
		conv += panelSh[p_idx + 549] * templateSh[530];
		conv += panelSh[p_idx + 550] * templateSh[529];
		conv += panelSh[p_idx + 551] * templateSh[528];
		conv += panelSh[p_idx + 552] * templateSh[527];
		conv += panelSh[p_idx + 553] * templateSh[526];
		conv += panelSh[p_idx + 554] * templateSh[525];
		conv += panelSh[p_idx + 555] * templateSh[524];
		conv += panelSh[p_idx + 556] * templateSh[523];
		conv += panelSh[p_idx + 557] * templateSh[522];
		conv += panelSh[p_idx + 558] * templateSh[521];
		conv += panelSh[p_idx + 559] * templateSh[520];
		conv += panelSh[p_idx + 560] * templateSh[519];
		conv += panelSh[p_idx + 561] * templateSh[518];
		conv += panelSh[p_idx + 562] * templateSh[517];
		conv += panelSh[p_idx + 563] * templateSh[516];
		conv += panelSh[p_idx + 564] * templateSh[515];
		conv += panelSh[p_idx + 565] * templateSh[514];
		conv += panelSh[p_idx + 566] * templateSh[513];
		conv += panelSh[p_idx + 567] * templateSh[512];
		conv += panelSh[p_idx + 568] * templateSh[511];
		conv += panelSh[p_idx + 569] * templateSh[510];
		conv += panelSh[p_idx + 585] * templateSh[509];
		conv += panelSh[p_idx + 586] * templateSh[508];
		conv += panelSh[p_idx + 587] * templateSh[507];
		conv += panelSh[p_idx + 588] * templateSh[506];
		conv += panelSh[p_idx + 589] * templateSh[505];
		conv += panelSh[p_idx + 590] * templateSh[504];
		conv += panelSh[p_idx + 591] * templateSh[503];
		conv += panelSh[p_idx + 592] * templateSh[502];
		conv += panelSh[p_idx + 593] * templateSh[501];
		conv += panelSh[p_idx + 594] * templateSh[500];
		conv += panelSh[p_idx + 595] * templateSh[499];
		conv += panelSh[p_idx + 596] * templateSh[498];
		conv += panelSh[p_idx + 597] * templateSh[497];
		conv += panelSh[p_idx + 598] * templateSh[496];
		conv += panelSh[p_idx + 599] * templateSh[495];
		conv += panelSh[p_idx + 600] * templateSh[494];
		conv += panelSh[p_idx + 601] * templateSh[493];
		conv += panelSh[p_idx + 602] * templateSh[492];
		conv += panelSh[p_idx + 603] * templateSh[491];
		conv += panelSh[p_idx + 604] * templateSh[490];
		conv += panelSh[p_idx + 605] * templateSh[489];
		conv += panelSh[p_idx + 606] * templateSh[488];
		conv += panelSh[p_idx + 607] * templateSh[487];
		conv += panelSh[p_idx + 608] * templateSh[486];
		conv += panelSh[p_idx + 609] * templateSh[485];
		conv += panelSh[p_idx + 610] * templateSh[484];
		conv += panelSh[p_idx + 611] * templateSh[483];
		conv += panelSh[p_idx + 612] * templateSh[482];
		conv += panelSh[p_idx + 613] * templateSh[481];
		conv += panelSh[p_idx + 614] * templateSh[480];
		conv += panelSh[p_idx + 630] * templateSh[479];
		conv += panelSh[p_idx + 631] * templateSh[478];
		conv += panelSh[p_idx + 632] * templateSh[477];
		conv += panelSh[p_idx + 633] * templateSh[476];
		conv += panelSh[p_idx + 634] * templateSh[475];
		conv += panelSh[p_idx + 635] * templateSh[474];
		conv += panelSh[p_idx + 636] * templateSh[473];
		conv += panelSh[p_idx + 637] * templateSh[472];
		conv += panelSh[p_idx + 638] * templateSh[471];
		conv += panelSh[p_idx + 639] * templateSh[470];
		conv += panelSh[p_idx + 640] * templateSh[469];
		conv += panelSh[p_idx + 641] * templateSh[468];
		conv += panelSh[p_idx + 642] * templateSh[467];
		conv += panelSh[p_idx + 643] * templateSh[466];
		conv += panelSh[p_idx + 644] * templateSh[465];
		conv += panelSh[p_idx + 645] * templateSh[464];
		conv += panelSh[p_idx + 646] * templateSh[463];
		conv += panelSh[p_idx + 647] * templateSh[462];
		conv += panelSh[p_idx + 648] * templateSh[461];
		conv += panelSh[p_idx + 649] * templateSh[460];
		conv += panelSh[p_idx + 650] * templateSh[459];
		conv += panelSh[p_idx + 651] * templateSh[458];
		conv += panelSh[p_idx + 652] * templateSh[457];
		conv += panelSh[p_idx + 653] * templateSh[456];
		conv += panelSh[p_idx + 654] * templateSh[455];
		conv += panelSh[p_idx + 655] * templateSh[454];
		conv += panelSh[p_idx + 656] * templateSh[453];
		conv += panelSh[p_idx + 657] * templateSh[452];
		conv += panelSh[p_idx + 658] * templateSh[451];
		conv += panelSh[p_idx + 659] * templateSh[450];
		conv += panelSh[p_idx + 675] * templateSh[449];
		conv += panelSh[p_idx + 676] * templateSh[448];
		conv += panelSh[p_idx + 677] * templateSh[447];
		conv += panelSh[p_idx + 678] * templateSh[446];
		conv += panelSh[p_idx + 679] * templateSh[445];
		conv += panelSh[p_idx + 680] * templateSh[444];
		conv += panelSh[p_idx + 681] * templateSh[443];
		conv += panelSh[p_idx + 682] * templateSh[442];
		conv += panelSh[p_idx + 683] * templateSh[441];
		conv += panelSh[p_idx + 684] * templateSh[440];
		conv += panelSh[p_idx + 685] * templateSh[439];
		conv += panelSh[p_idx + 686] * templateSh[438];
		conv += panelSh[p_idx + 687] * templateSh[437];
		conv += panelSh[p_idx + 688] * templateSh[436];
		conv += panelSh[p_idx + 689] * templateSh[435];
		conv += panelSh[p_idx + 690] * templateSh[434];
		conv += panelSh[p_idx + 691] * templateSh[433];
		conv += panelSh[p_idx + 692] * templateSh[432];
		conv += panelSh[p_idx + 693] * templateSh[431];
		conv += panelSh[p_idx + 694] * templateSh[430];
		conv += panelSh[p_idx + 695] * templateSh[429];
		conv += panelSh[p_idx + 696] * templateSh[428];
		conv += panelSh[p_idx + 697] * templateSh[427];
		conv += panelSh[p_idx + 698] * templateSh[426];
		conv += panelSh[p_idx + 699] * templateSh[425];
		conv += panelSh[p_idx + 700] * templateSh[424];
		conv += panelSh[p_idx + 701] * templateSh[423];
		conv += panelSh[p_idx + 702] * templateSh[422];
		conv += panelSh[p_idx + 703] * templateSh[421];
		conv += panelSh[p_idx + 704] * templateSh[420];
		conv += panelSh[p_idx + 720] * templateSh[419];
		conv += panelSh[p_idx + 721] * templateSh[418];
		conv += panelSh[p_idx + 722] * templateSh[417];
		conv += panelSh[p_idx + 723] * templateSh[416];
		conv += panelSh[p_idx + 724] * templateSh[415];
		conv += panelSh[p_idx + 725] * templateSh[414];
		conv += panelSh[p_idx + 726] * templateSh[413];
		conv += panelSh[p_idx + 727] * templateSh[412];
		conv += panelSh[p_idx + 728] * templateSh[411];
		conv += panelSh[p_idx + 729] * templateSh[410];
		conv += panelSh[p_idx + 730] * templateSh[409];
		conv += panelSh[p_idx + 731] * templateSh[408];
		conv += panelSh[p_idx + 732] * templateSh[407];
		conv += panelSh[p_idx + 733] * templateSh[406];
		conv += panelSh[p_idx + 734] * templateSh[405];
		conv += panelSh[p_idx + 735] * templateSh[404];
		conv += panelSh[p_idx + 736] * templateSh[403];
		conv += panelSh[p_idx + 737] * templateSh[402];
		conv += panelSh[p_idx + 738] * templateSh[401];
		conv += panelSh[p_idx + 739] * templateSh[400];
		conv += panelSh[p_idx + 740] * templateSh[399];
		conv += panelSh[p_idx + 741] * templateSh[398];
		conv += panelSh[p_idx + 742] * templateSh[397];
		conv += panelSh[p_idx + 743] * templateSh[396];
		conv += panelSh[p_idx + 744] * templateSh[395];
		conv += panelSh[p_idx + 745] * templateSh[394];
		conv += panelSh[p_idx + 746] * templateSh[393];
		conv += panelSh[p_idx + 747] * templateSh[392];
		conv += panelSh[p_idx + 748] * templateSh[391];
		conv += panelSh[p_idx + 749] * templateSh[390];
		conv += panelSh[p_idx + 765] * templateSh[389];
		conv += panelSh[p_idx + 766] * templateSh[388];
		conv += panelSh[p_idx + 767] * templateSh[387];
		conv += panelSh[p_idx + 768] * templateSh[386];
		conv += panelSh[p_idx + 769] * templateSh[385];
		conv += panelSh[p_idx + 770] * templateSh[384];
		conv += panelSh[p_idx + 771] * templateSh[383];
		conv += panelSh[p_idx + 772] * templateSh[382];
		conv += panelSh[p_idx + 773] * templateSh[381];
		conv += panelSh[p_idx + 774] * templateSh[380];
		conv += panelSh[p_idx + 775] * templateSh[379];
		conv += panelSh[p_idx + 776] * templateSh[378];
		conv += panelSh[p_idx + 777] * templateSh[377];
		conv += panelSh[p_idx + 778] * templateSh[376];
		conv += panelSh[p_idx + 779] * templateSh[375];
		conv += panelSh[p_idx + 780] * templateSh[374];
		conv += panelSh[p_idx + 781] * templateSh[373];
		conv += panelSh[p_idx + 782] * templateSh[372];
		conv += panelSh[p_idx + 783] * templateSh[371];
		conv += panelSh[p_idx + 784] * templateSh[370];
		conv += panelSh[p_idx + 785] * templateSh[369];
		conv += panelSh[p_idx + 786] * templateSh[368];
		conv += panelSh[p_idx + 787] * templateSh[367];
		conv += panelSh[p_idx + 788] * templateSh[366];
		conv += panelSh[p_idx + 789] * templateSh[365];
		conv += panelSh[p_idx + 790] * templateSh[364];
		conv += panelSh[p_idx + 791] * templateSh[363];
		conv += panelSh[p_idx + 792] * templateSh[362];
		conv += panelSh[p_idx + 793] * templateSh[361];
		conv += panelSh[p_idx + 794] * templateSh[360];
		conv += panelSh[p_idx + 810] * templateSh[359];
		conv += panelSh[p_idx + 811] * templateSh[358];
		conv += panelSh[p_idx + 812] * templateSh[357];
		conv += panelSh[p_idx + 813] * templateSh[356];
		conv += panelSh[p_idx + 814] * templateSh[355];
		conv += panelSh[p_idx + 815] * templateSh[354];
		conv += panelSh[p_idx + 816] * templateSh[353];
		conv += panelSh[p_idx + 817] * templateSh[352];
		conv += panelSh[p_idx + 818] * templateSh[351];
		conv += panelSh[p_idx + 819] * templateSh[350];
		conv += panelSh[p_idx + 820] * templateSh[349];
		conv += panelSh[p_idx + 821] * templateSh[348];
		conv += panelSh[p_idx + 822] * templateSh[347];
		conv += panelSh[p_idx + 823] * templateSh[346];
		conv += panelSh[p_idx + 824] * templateSh[345];
		conv += panelSh[p_idx + 825] * templateSh[344];
		conv += panelSh[p_idx + 826] * templateSh[343];
		conv += panelSh[p_idx + 827] * templateSh[342];
		conv += panelSh[p_idx + 828] * templateSh[341];
		conv += panelSh[p_idx + 829] * templateSh[340];
		conv += panelSh[p_idx + 830] * templateSh[339];
		conv += panelSh[p_idx + 831] * templateSh[338];
		conv += panelSh[p_idx + 832] * templateSh[337];
		conv += panelSh[p_idx + 833] * templateSh[336];
		conv += panelSh[p_idx + 834] * templateSh[335];
		conv += panelSh[p_idx + 835] * templateSh[334];
		conv += panelSh[p_idx + 836] * templateSh[333];
		conv += panelSh[p_idx + 837] * templateSh[332];
		conv += panelSh[p_idx + 838] * templateSh[331];
		conv += panelSh[p_idx + 839] * templateSh[330];
		conv += panelSh[p_idx + 855] * templateSh[329];
		conv += panelSh[p_idx + 856] * templateSh[328];
		conv += panelSh[p_idx + 857] * templateSh[327];
		conv += panelSh[p_idx + 858] * templateSh[326];
		conv += panelSh[p_idx + 859] * templateSh[325];
		conv += panelSh[p_idx + 860] * templateSh[324];
		conv += panelSh[p_idx + 861] * templateSh[323];
		conv += panelSh[p_idx + 862] * templateSh[322];
		conv += panelSh[p_idx + 863] * templateSh[321];
		conv += panelSh[p_idx + 864] * templateSh[320];
		conv += panelSh[p_idx + 865] * templateSh[319];
		conv += panelSh[p_idx + 866] * templateSh[318];
		conv += panelSh[p_idx + 867] * templateSh[317];
		conv += panelSh[p_idx + 868] * templateSh[316];
		conv += panelSh[p_idx + 869] * templateSh[315];
		conv += panelSh[p_idx + 870] * templateSh[314];
		conv += panelSh[p_idx + 871] * templateSh[313];
		conv += panelSh[p_idx + 872] * templateSh[312];
		conv += panelSh[p_idx + 873] * templateSh[311];
		conv += panelSh[p_idx + 874] * templateSh[310];
		conv += panelSh[p_idx + 875] * templateSh[309];
		conv += panelSh[p_idx + 876] * templateSh[308];
		conv += panelSh[p_idx + 877] * templateSh[307];
		conv += panelSh[p_idx + 878] * templateSh[306];
		conv += panelSh[p_idx + 879] * templateSh[305];
		conv += panelSh[p_idx + 880] * templateSh[304];
		conv += panelSh[p_idx + 881] * templateSh[303];
		conv += panelSh[p_idx + 882] * templateSh[302];
		conv += panelSh[p_idx + 883] * templateSh[301];
		conv += panelSh[p_idx + 884] * templateSh[300];
		conv += panelSh[p_idx + 900] * templateSh[299];
		conv += panelSh[p_idx + 901] * templateSh[298];
		conv += panelSh[p_idx + 902] * templateSh[297];
		conv += panelSh[p_idx + 903] * templateSh[296];
		conv += panelSh[p_idx + 904] * templateSh[295];
		conv += panelSh[p_idx + 905] * templateSh[294];
		conv += panelSh[p_idx + 906] * templateSh[293];
		conv += panelSh[p_idx + 907] * templateSh[292];
		conv += panelSh[p_idx + 908] * templateSh[291];
		conv += panelSh[p_idx + 909] * templateSh[290];
		conv += panelSh[p_idx + 910] * templateSh[289];
		conv += panelSh[p_idx + 911] * templateSh[288];
		conv += panelSh[p_idx + 912] * templateSh[287];
		conv += panelSh[p_idx + 913] * templateSh[286];
		conv += panelSh[p_idx + 914] * templateSh[285];
		conv += panelSh[p_idx + 915] * templateSh[284];
		conv += panelSh[p_idx + 916] * templateSh[283];
		conv += panelSh[p_idx + 917] * templateSh[282];
		conv += panelSh[p_idx + 918] * templateSh[281];
		conv += panelSh[p_idx + 919] * templateSh[280];
		conv += panelSh[p_idx + 920] * templateSh[279];
		conv += panelSh[p_idx + 921] * templateSh[278];
		conv += panelSh[p_idx + 922] * templateSh[277];
		conv += panelSh[p_idx + 923] * templateSh[276];
		conv += panelSh[p_idx + 924] * templateSh[275];
		conv += panelSh[p_idx + 925] * templateSh[274];
		conv += panelSh[p_idx + 926] * templateSh[273];
		conv += panelSh[p_idx + 927] * templateSh[272];
		conv += panelSh[p_idx + 928] * templateSh[271];
		conv += panelSh[p_idx + 929] * templateSh[270];
		conv += panelSh[p_idx + 945] * templateSh[269];
		conv += panelSh[p_idx + 946] * templateSh[268];
		conv += panelSh[p_idx + 947] * templateSh[267];
		conv += panelSh[p_idx + 948] * templateSh[266];
		conv += panelSh[p_idx + 949] * templateSh[265];
		conv += panelSh[p_idx + 950] * templateSh[264];
		conv += panelSh[p_idx + 951] * templateSh[263];
		conv += panelSh[p_idx + 952] * templateSh[262];
		conv += panelSh[p_idx + 953] * templateSh[261];
		conv += panelSh[p_idx + 954] * templateSh[260];
		conv += panelSh[p_idx + 955] * templateSh[259];
		conv += panelSh[p_idx + 956] * templateSh[258];
		conv += panelSh[p_idx + 957] * templateSh[257];
		conv += panelSh[p_idx + 958] * templateSh[256];
		conv += panelSh[p_idx + 959] * templateSh[255];
		conv += panelSh[p_idx + 960] * templateSh[254];
		conv += panelSh[p_idx + 961] * templateSh[253];
		conv += panelSh[p_idx + 962] * templateSh[252];
		conv += panelSh[p_idx + 963] * templateSh[251];
		conv += panelSh[p_idx + 964] * templateSh[250];
		conv += panelSh[p_idx + 965] * templateSh[249];
		conv += panelSh[p_idx + 966] * templateSh[248];
		conv += panelSh[p_idx + 967] * templateSh[247];
		conv += panelSh[p_idx + 968] * templateSh[246];
		conv += panelSh[p_idx + 969] * templateSh[245];
		conv += panelSh[p_idx + 970] * templateSh[244];
		conv += panelSh[p_idx + 971] * templateSh[243];
		conv += panelSh[p_idx + 972] * templateSh[242];
		conv += panelSh[p_idx + 973] * templateSh[241];
		conv += panelSh[p_idx + 974] * templateSh[240];
		conv += panelSh[p_idx + 990] * templateSh[239];
		conv += panelSh[p_idx + 991] * templateSh[238];
		conv += panelSh[p_idx + 992] * templateSh[237];
		conv += panelSh[p_idx + 993] * templateSh[236];
		conv += panelSh[p_idx + 994] * templateSh[235];
		conv += panelSh[p_idx + 995] * templateSh[234];
		conv += panelSh[p_idx + 996] * templateSh[233];
		conv += panelSh[p_idx + 997] * templateSh[232];
		conv += panelSh[p_idx + 998] * templateSh[231];
		conv += panelSh[p_idx + 999] * templateSh[230];
		conv += panelSh[p_idx + 1000] * templateSh[229];
		conv += panelSh[p_idx + 1001] * templateSh[228];
		conv += panelSh[p_idx + 1002] * templateSh[227];
		conv += panelSh[p_idx + 1003] * templateSh[226];
		conv += panelSh[p_idx + 1004] * templateSh[225];
		conv += panelSh[p_idx + 1005] * templateSh[224];
		conv += panelSh[p_idx + 1006] * templateSh[223];
		conv += panelSh[p_idx + 1007] * templateSh[222];
		conv += panelSh[p_idx + 1008] * templateSh[221];
		conv += panelSh[p_idx + 1009] * templateSh[220];
		conv += panelSh[p_idx + 1010] * templateSh[219];
		conv += panelSh[p_idx + 1011] * templateSh[218];
		conv += panelSh[p_idx + 1012] * templateSh[217];
		conv += panelSh[p_idx + 1013] * templateSh[216];
		conv += panelSh[p_idx + 1014] * templateSh[215];
		conv += panelSh[p_idx + 1015] * templateSh[214];
		conv += panelSh[p_idx + 1016] * templateSh[213];
		conv += panelSh[p_idx + 1017] * templateSh[212];
		conv += panelSh[p_idx + 1018] * templateSh[211];
		conv += panelSh[p_idx + 1019] * templateSh[210];
		conv += panelSh[p_idx + 1035] * templateSh[209];
		conv += panelSh[p_idx + 1036] * templateSh[208];
		conv += panelSh[p_idx + 1037] * templateSh[207];
		conv += panelSh[p_idx + 1038] * templateSh[206];
		conv += panelSh[p_idx + 1039] * templateSh[205];
		conv += panelSh[p_idx + 1040] * templateSh[204];
		conv += panelSh[p_idx + 1041] * templateSh[203];
		conv += panelSh[p_idx + 1042] * templateSh[202];
		conv += panelSh[p_idx + 1043] * templateSh[201];
		conv += panelSh[p_idx + 1044] * templateSh[200];
		conv += panelSh[p_idx + 1045] * templateSh[199];
		conv += panelSh[p_idx + 1046] * templateSh[198];
		conv += panelSh[p_idx + 1047] * templateSh[197];
		conv += panelSh[p_idx + 1048] * templateSh[196];
		conv += panelSh[p_idx + 1049] * templateSh[195];
		conv += panelSh[p_idx + 1050] * templateSh[194];
		conv += panelSh[p_idx + 1051] * templateSh[193];
		conv += panelSh[p_idx + 1052] * templateSh[192];
		conv += panelSh[p_idx + 1053] * templateSh[191];
		conv += panelSh[p_idx + 1054] * templateSh[190];
		conv += panelSh[p_idx + 1055] * templateSh[189];
		conv += panelSh[p_idx + 1056] * templateSh[188];
		conv += panelSh[p_idx + 1057] * templateSh[187];
		conv += panelSh[p_idx + 1058] * templateSh[186];
		conv += panelSh[p_idx + 1059] * templateSh[185];
		conv += panelSh[p_idx + 1060] * templateSh[184];
		conv += panelSh[p_idx + 1061] * templateSh[183];
		conv += panelSh[p_idx + 1062] * templateSh[182];
		conv += panelSh[p_idx + 1063] * templateSh[181];
		conv += panelSh[p_idx + 1064] * templateSh[180];
		conv += panelSh[p_idx + 1080] * templateSh[179];
		conv += panelSh[p_idx + 1081] * templateSh[178];
		conv += panelSh[p_idx + 1082] * templateSh[177];
		conv += panelSh[p_idx + 1083] * templateSh[176];
		conv += panelSh[p_idx + 1084] * templateSh[175];
		conv += panelSh[p_idx + 1085] * templateSh[174];
		conv += panelSh[p_idx + 1086] * templateSh[173];
		conv += panelSh[p_idx + 1087] * templateSh[172];
		conv += panelSh[p_idx + 1088] * templateSh[171];
		conv += panelSh[p_idx + 1089] * templateSh[170];
		conv += panelSh[p_idx + 1090] * templateSh[169];
		conv += panelSh[p_idx + 1091] * templateSh[168];
		conv += panelSh[p_idx + 1092] * templateSh[167];
		conv += panelSh[p_idx + 1093] * templateSh[166];
		conv += panelSh[p_idx + 1094] * templateSh[165];
		conv += panelSh[p_idx + 1095] * templateSh[164];
		conv += panelSh[p_idx + 1096] * templateSh[163];
		conv += panelSh[p_idx + 1097] * templateSh[162];
		conv += panelSh[p_idx + 1098] * templateSh[161];
		conv += panelSh[p_idx + 1099] * templateSh[160];
		conv += panelSh[p_idx + 1100] * templateSh[159];
		conv += panelSh[p_idx + 1101] * templateSh[158];
		conv += panelSh[p_idx + 1102] * templateSh[157];
		conv += panelSh[p_idx + 1103] * templateSh[156];
		conv += panelSh[p_idx + 1104] * templateSh[155];
		conv += panelSh[p_idx + 1105] * templateSh[154];
		conv += panelSh[p_idx + 1106] * templateSh[153];
		conv += panelSh[p_idx + 1107] * templateSh[152];
		conv += panelSh[p_idx + 1108] * templateSh[151];
		conv += panelSh[p_idx + 1109] * templateSh[150];
		conv += panelSh[p_idx + 1125] * templateSh[149];
		conv += panelSh[p_idx + 1126] * templateSh[148];
		conv += panelSh[p_idx + 1127] * templateSh[147];
		conv += panelSh[p_idx + 1128] * templateSh[146];
		conv += panelSh[p_idx + 1129] * templateSh[145];
		conv += panelSh[p_idx + 1130] * templateSh[144];
		conv += panelSh[p_idx + 1131] * templateSh[143];
		conv += panelSh[p_idx + 1132] * templateSh[142];
		conv += panelSh[p_idx + 1133] * templateSh[141];
		conv += panelSh[p_idx + 1134] * templateSh[140];
		conv += panelSh[p_idx + 1135] * templateSh[139];
		conv += panelSh[p_idx + 1136] * templateSh[138];
		conv += panelSh[p_idx + 1137] * templateSh[137];
		conv += panelSh[p_idx + 1138] * templateSh[136];
		conv += panelSh[p_idx + 1139] * templateSh[135];
		conv += panelSh[p_idx + 1140] * templateSh[134];
		conv += panelSh[p_idx + 1141] * templateSh[133];
		conv += panelSh[p_idx + 1142] * templateSh[132];
		conv += panelSh[p_idx + 1143] * templateSh[131];
		conv += panelSh[p_idx + 1144] * templateSh[130];
		conv += panelSh[p_idx + 1145] * templateSh[129];
		conv += panelSh[p_idx + 1146] * templateSh[128];
		conv += panelSh[p_idx + 1147] * templateSh[127];
		conv += panelSh[p_idx + 1148] * templateSh[126];
		conv += panelSh[p_idx + 1149] * templateSh[125];
		conv += panelSh[p_idx + 1150] * templateSh[124];
		conv += panelSh[p_idx + 1151] * templateSh[123];
		conv += panelSh[p_idx + 1152] * templateSh[122];
		conv += panelSh[p_idx + 1153] * templateSh[121];
		conv += panelSh[p_idx + 1154] * templateSh[120];
		conv += panelSh[p_idx + 1170] * templateSh[119];
		conv += panelSh[p_idx + 1171] * templateSh[118];
		conv += panelSh[p_idx + 1172] * templateSh[117];
		conv += panelSh[p_idx + 1173] * templateSh[116];
		conv += panelSh[p_idx + 1174] * templateSh[115];
		conv += panelSh[p_idx + 1175] * templateSh[114];
		conv += panelSh[p_idx + 1176] * templateSh[113];
		conv += panelSh[p_idx + 1177] * templateSh[112];
		conv += panelSh[p_idx + 1178] * templateSh[111];
		conv += panelSh[p_idx + 1179] * templateSh[110];
		conv += panelSh[p_idx + 1180] * templateSh[109];
		conv += panelSh[p_idx + 1181] * templateSh[108];
		conv += panelSh[p_idx + 1182] * templateSh[107];
		conv += panelSh[p_idx + 1183] * templateSh[106];
		conv += panelSh[p_idx + 1184] * templateSh[105];
		conv += panelSh[p_idx + 1185] * templateSh[104];
		conv += panelSh[p_idx + 1186] * templateSh[103];
		conv += panelSh[p_idx + 1187] * templateSh[102];
		conv += panelSh[p_idx + 1188] * templateSh[101];
		conv += panelSh[p_idx + 1189] * templateSh[100];
		conv += panelSh[p_idx + 1190] * templateSh[99];
		conv += panelSh[p_idx + 1191] * templateSh[98];
		conv += panelSh[p_idx + 1192] * templateSh[97];
		conv += panelSh[p_idx + 1193] * templateSh[96];
		conv += panelSh[p_idx + 1194] * templateSh[95];
		conv += panelSh[p_idx + 1195] * templateSh[94];
		conv += panelSh[p_idx + 1196] * templateSh[93];
		conv += panelSh[p_idx + 1197] * templateSh[92];
		conv += panelSh[p_idx + 1198] * templateSh[91];
		conv += panelSh[p_idx + 1199] * templateSh[90];
		conv += panelSh[p_idx + 1215] * templateSh[89];
		conv += panelSh[p_idx + 1216] * templateSh[88];
		conv += panelSh[p_idx + 1217] * templateSh[87];
		conv += panelSh[p_idx + 1218] * templateSh[86];
		conv += panelSh[p_idx + 1219] * templateSh[85];
		conv += panelSh[p_idx + 1220] * templateSh[84];
		conv += panelSh[p_idx + 1221] * templateSh[83];
		conv += panelSh[p_idx + 1222] * templateSh[82];
		conv += panelSh[p_idx + 1223] * templateSh[81];
		conv += panelSh[p_idx + 1224] * templateSh[80];
		conv += panelSh[p_idx + 1225] * templateSh[79];
		conv += panelSh[p_idx + 1226] * templateSh[78];
		conv += panelSh[p_idx + 1227] * templateSh[77];
		conv += panelSh[p_idx + 1228] * templateSh[76];
		conv += panelSh[p_idx + 1229] * templateSh[75];
		conv += panelSh[p_idx + 1230] * templateSh[74];
		conv += panelSh[p_idx + 1231] * templateSh[73];
		conv += panelSh[p_idx + 1232] * templateSh[72];
		conv += panelSh[p_idx + 1233] * templateSh[71];
		conv += panelSh[p_idx + 1234] * templateSh[70];
		conv += panelSh[p_idx + 1235] * templateSh[69];
		conv += panelSh[p_idx + 1236] * templateSh[68];
		conv += panelSh[p_idx + 1237] * templateSh[67];
		conv += panelSh[p_idx + 1238] * templateSh[66];
		conv += panelSh[p_idx + 1239] * templateSh[65];
		conv += panelSh[p_idx + 1240] * templateSh[64];
		conv += panelSh[p_idx + 1241] * templateSh[63];
		conv += panelSh[p_idx + 1242] * templateSh[62];
		conv += panelSh[p_idx + 1243] * templateSh[61];
		conv += panelSh[p_idx + 1244] * templateSh[60];
		conv += panelSh[p_idx + 1260] * templateSh[59];
		conv += panelSh[p_idx + 1261] * templateSh[58];
		conv += panelSh[p_idx + 1262] * templateSh[57];
		conv += panelSh[p_idx + 1263] * templateSh[56];
		conv += panelSh[p_idx + 1264] * templateSh[55];
		conv += panelSh[p_idx + 1265] * templateSh[54];
		conv += panelSh[p_idx + 1266] * templateSh[53];
		conv += panelSh[p_idx + 1267] * templateSh[52];
		conv += panelSh[p_idx + 1268] * templateSh[51];
		conv += panelSh[p_idx + 1269] * templateSh[50];
		conv += panelSh[p_idx + 1270] * templateSh[49];
		conv += panelSh[p_idx + 1271] * templateSh[48];
		conv += panelSh[p_idx + 1272] * templateSh[47];
		conv += panelSh[p_idx + 1273] * templateSh[46];
		conv += panelSh[p_idx + 1274] * templateSh[45];
		conv += panelSh[p_idx + 1275] * templateSh[44];
		conv += panelSh[p_idx + 1276] * templateSh[43];
		conv += panelSh[p_idx + 1277] * templateSh[42];
		conv += panelSh[p_idx + 1278] * templateSh[41];
		conv += panelSh[p_idx + 1279] * templateSh[40];
		conv += panelSh[p_idx + 1280] * templateSh[39];
		conv += panelSh[p_idx + 1281] * templateSh[38];
		conv += panelSh[p_idx + 1282] * templateSh[37];
		conv += panelSh[p_idx + 1283] * templateSh[36];
		conv += panelSh[p_idx + 1284] * templateSh[35];
		conv += panelSh[p_idx + 1285] * templateSh[34];
		conv += panelSh[p_idx + 1286] * templateSh[33];
		conv += panelSh[p_idx + 1287] * templateSh[32];
		conv += panelSh[p_idx + 1288] * templateSh[31];
		conv += panelSh[p_idx + 1289] * templateSh[30];
		conv += panelSh[p_idx + 1305] * templateSh[29];
		conv += panelSh[p_idx + 1306] * templateSh[28];
		conv += panelSh[p_idx + 1307] * templateSh[27];
		conv += panelSh[p_idx + 1308] * templateSh[26];
		conv += panelSh[p_idx + 1309] * templateSh[25];
		conv += panelSh[p_idx + 1310] * templateSh[24];
		conv += panelSh[p_idx + 1311] * templateSh[23];
		conv += panelSh[p_idx + 1312] * templateSh[22];
		conv += panelSh[p_idx + 1313] * templateSh[21];
		conv += panelSh[p_idx + 1314] * templateSh[20];
		conv += panelSh[p_idx + 1315] * templateSh[19];
		conv += panelSh[p_idx + 1316] * templateSh[18];
		conv += panelSh[p_idx + 1317] * templateSh[17];
		conv += panelSh[p_idx + 1318] * templateSh[16];
		conv += panelSh[p_idx + 1319] * templateSh[15];
		conv += panelSh[p_idx + 1320] * templateSh[14];
		conv += panelSh[p_idx + 1321] * templateSh[13];
		conv += panelSh[p_idx + 1322] * templateSh[12];
		conv += panelSh[p_idx + 1323] * templateSh[11];
		conv += panelSh[p_idx + 1324] * templateSh[10];
		conv += panelSh[p_idx + 1325] * templateSh[9];
		conv += panelSh[p_idx + 1326] * templateSh[8];
		conv += panelSh[p_idx + 1327] * templateSh[7];
		conv += panelSh[p_idx + 1328] * templateSh[6];
		conv += panelSh[p_idx + 1329] * templateSh[5];
		conv += panelSh[p_idx + 1330] * templateSh[4];
		conv += panelSh[p_idx + 1331] * templateSh[3];
		conv += panelSh[p_idx + 1332] * templateSh[2];
		conv += panelSh[p_idx + 1333] * templateSh[1];
		conv += panelSh[p_idx + 1334] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_30x30<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_30x30<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_31x31 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[2116];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<46; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<46; i+=16) {
			panelSh[IMUL(j, 46) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[961];
	for (int j=threadIdx.y; j<31; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<31; i+=16) {
			const int jtwi = IMUL(j, 31) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 46);
		conv += panelSh[p_idx + 0] * templateSh[960];
		conv += panelSh[p_idx + 1] * templateSh[959];
		conv += panelSh[p_idx + 2] * templateSh[958];
		conv += panelSh[p_idx + 3] * templateSh[957];
		conv += panelSh[p_idx + 4] * templateSh[956];
		conv += panelSh[p_idx + 5] * templateSh[955];
		conv += panelSh[p_idx + 6] * templateSh[954];
		conv += panelSh[p_idx + 7] * templateSh[953];
		conv += panelSh[p_idx + 8] * templateSh[952];
		conv += panelSh[p_idx + 9] * templateSh[951];
		conv += panelSh[p_idx + 10] * templateSh[950];
		conv += panelSh[p_idx + 11] * templateSh[949];
		conv += panelSh[p_idx + 12] * templateSh[948];
		conv += panelSh[p_idx + 13] * templateSh[947];
		conv += panelSh[p_idx + 14] * templateSh[946];
		conv += panelSh[p_idx + 15] * templateSh[945];
		conv += panelSh[p_idx + 16] * templateSh[944];
		conv += panelSh[p_idx + 17] * templateSh[943];
		conv += panelSh[p_idx + 18] * templateSh[942];
		conv += panelSh[p_idx + 19] * templateSh[941];
		conv += panelSh[p_idx + 20] * templateSh[940];
		conv += panelSh[p_idx + 21] * templateSh[939];
		conv += panelSh[p_idx + 22] * templateSh[938];
		conv += panelSh[p_idx + 23] * templateSh[937];
		conv += panelSh[p_idx + 24] * templateSh[936];
		conv += panelSh[p_idx + 25] * templateSh[935];
		conv += panelSh[p_idx + 26] * templateSh[934];
		conv += panelSh[p_idx + 27] * templateSh[933];
		conv += panelSh[p_idx + 28] * templateSh[932];
		conv += panelSh[p_idx + 29] * templateSh[931];
		conv += panelSh[p_idx + 30] * templateSh[930];
		conv += panelSh[p_idx + 46] * templateSh[929];
		conv += panelSh[p_idx + 47] * templateSh[928];
		conv += panelSh[p_idx + 48] * templateSh[927];
		conv += panelSh[p_idx + 49] * templateSh[926];
		conv += panelSh[p_idx + 50] * templateSh[925];
		conv += panelSh[p_idx + 51] * templateSh[924];
		conv += panelSh[p_idx + 52] * templateSh[923];
		conv += panelSh[p_idx + 53] * templateSh[922];
		conv += panelSh[p_idx + 54] * templateSh[921];
		conv += panelSh[p_idx + 55] * templateSh[920];
		conv += panelSh[p_idx + 56] * templateSh[919];
		conv += panelSh[p_idx + 57] * templateSh[918];
		conv += panelSh[p_idx + 58] * templateSh[917];
		conv += panelSh[p_idx + 59] * templateSh[916];
		conv += panelSh[p_idx + 60] * templateSh[915];
		conv += panelSh[p_idx + 61] * templateSh[914];
		conv += panelSh[p_idx + 62] * templateSh[913];
		conv += panelSh[p_idx + 63] * templateSh[912];
		conv += panelSh[p_idx + 64] * templateSh[911];
		conv += panelSh[p_idx + 65] * templateSh[910];
		conv += panelSh[p_idx + 66] * templateSh[909];
		conv += panelSh[p_idx + 67] * templateSh[908];
		conv += panelSh[p_idx + 68] * templateSh[907];
		conv += panelSh[p_idx + 69] * templateSh[906];
		conv += panelSh[p_idx + 70] * templateSh[905];
		conv += panelSh[p_idx + 71] * templateSh[904];
		conv += panelSh[p_idx + 72] * templateSh[903];
		conv += panelSh[p_idx + 73] * templateSh[902];
		conv += panelSh[p_idx + 74] * templateSh[901];
		conv += panelSh[p_idx + 75] * templateSh[900];
		conv += panelSh[p_idx + 76] * templateSh[899];
		conv += panelSh[p_idx + 92] * templateSh[898];
		conv += panelSh[p_idx + 93] * templateSh[897];
		conv += panelSh[p_idx + 94] * templateSh[896];
		conv += panelSh[p_idx + 95] * templateSh[895];
		conv += panelSh[p_idx + 96] * templateSh[894];
		conv += panelSh[p_idx + 97] * templateSh[893];
		conv += panelSh[p_idx + 98] * templateSh[892];
		conv += panelSh[p_idx + 99] * templateSh[891];
		conv += panelSh[p_idx + 100] * templateSh[890];
		conv += panelSh[p_idx + 101] * templateSh[889];
		conv += panelSh[p_idx + 102] * templateSh[888];
		conv += panelSh[p_idx + 103] * templateSh[887];
		conv += panelSh[p_idx + 104] * templateSh[886];
		conv += panelSh[p_idx + 105] * templateSh[885];
		conv += panelSh[p_idx + 106] * templateSh[884];
		conv += panelSh[p_idx + 107] * templateSh[883];
		conv += panelSh[p_idx + 108] * templateSh[882];
		conv += panelSh[p_idx + 109] * templateSh[881];
		conv += panelSh[p_idx + 110] * templateSh[880];
		conv += panelSh[p_idx + 111] * templateSh[879];
		conv += panelSh[p_idx + 112] * templateSh[878];
		conv += panelSh[p_idx + 113] * templateSh[877];
		conv += panelSh[p_idx + 114] * templateSh[876];
		conv += panelSh[p_idx + 115] * templateSh[875];
		conv += panelSh[p_idx + 116] * templateSh[874];
		conv += panelSh[p_idx + 117] * templateSh[873];
		conv += panelSh[p_idx + 118] * templateSh[872];
		conv += panelSh[p_idx + 119] * templateSh[871];
		conv += panelSh[p_idx + 120] * templateSh[870];
		conv += panelSh[p_idx + 121] * templateSh[869];
		conv += panelSh[p_idx + 122] * templateSh[868];
		conv += panelSh[p_idx + 138] * templateSh[867];
		conv += panelSh[p_idx + 139] * templateSh[866];
		conv += panelSh[p_idx + 140] * templateSh[865];
		conv += panelSh[p_idx + 141] * templateSh[864];
		conv += panelSh[p_idx + 142] * templateSh[863];
		conv += panelSh[p_idx + 143] * templateSh[862];
		conv += panelSh[p_idx + 144] * templateSh[861];
		conv += panelSh[p_idx + 145] * templateSh[860];
		conv += panelSh[p_idx + 146] * templateSh[859];
		conv += panelSh[p_idx + 147] * templateSh[858];
		conv += panelSh[p_idx + 148] * templateSh[857];
		conv += panelSh[p_idx + 149] * templateSh[856];
		conv += panelSh[p_idx + 150] * templateSh[855];
		conv += panelSh[p_idx + 151] * templateSh[854];
		conv += panelSh[p_idx + 152] * templateSh[853];
		conv += panelSh[p_idx + 153] * templateSh[852];
		conv += panelSh[p_idx + 154] * templateSh[851];
		conv += panelSh[p_idx + 155] * templateSh[850];
		conv += panelSh[p_idx + 156] * templateSh[849];
		conv += panelSh[p_idx + 157] * templateSh[848];
		conv += panelSh[p_idx + 158] * templateSh[847];
		conv += panelSh[p_idx + 159] * templateSh[846];
		conv += panelSh[p_idx + 160] * templateSh[845];
		conv += panelSh[p_idx + 161] * templateSh[844];
		conv += panelSh[p_idx + 162] * templateSh[843];
		conv += panelSh[p_idx + 163] * templateSh[842];
		conv += panelSh[p_idx + 164] * templateSh[841];
		conv += panelSh[p_idx + 165] * templateSh[840];
		conv += panelSh[p_idx + 166] * templateSh[839];
		conv += panelSh[p_idx + 167] * templateSh[838];
		conv += panelSh[p_idx + 168] * templateSh[837];
		conv += panelSh[p_idx + 184] * templateSh[836];
		conv += panelSh[p_idx + 185] * templateSh[835];
		conv += panelSh[p_idx + 186] * templateSh[834];
		conv += panelSh[p_idx + 187] * templateSh[833];
		conv += panelSh[p_idx + 188] * templateSh[832];
		conv += panelSh[p_idx + 189] * templateSh[831];
		conv += panelSh[p_idx + 190] * templateSh[830];
		conv += panelSh[p_idx + 191] * templateSh[829];
		conv += panelSh[p_idx + 192] * templateSh[828];
		conv += panelSh[p_idx + 193] * templateSh[827];
		conv += panelSh[p_idx + 194] * templateSh[826];
		conv += panelSh[p_idx + 195] * templateSh[825];
		conv += panelSh[p_idx + 196] * templateSh[824];
		conv += panelSh[p_idx + 197] * templateSh[823];
		conv += panelSh[p_idx + 198] * templateSh[822];
		conv += panelSh[p_idx + 199] * templateSh[821];
		conv += panelSh[p_idx + 200] * templateSh[820];
		conv += panelSh[p_idx + 201] * templateSh[819];
		conv += panelSh[p_idx + 202] * templateSh[818];
		conv += panelSh[p_idx + 203] * templateSh[817];
		conv += panelSh[p_idx + 204] * templateSh[816];
		conv += panelSh[p_idx + 205] * templateSh[815];
		conv += panelSh[p_idx + 206] * templateSh[814];
		conv += panelSh[p_idx + 207] * templateSh[813];
		conv += panelSh[p_idx + 208] * templateSh[812];
		conv += panelSh[p_idx + 209] * templateSh[811];
		conv += panelSh[p_idx + 210] * templateSh[810];
		conv += panelSh[p_idx + 211] * templateSh[809];
		conv += panelSh[p_idx + 212] * templateSh[808];
		conv += panelSh[p_idx + 213] * templateSh[807];
		conv += panelSh[p_idx + 214] * templateSh[806];
		conv += panelSh[p_idx + 230] * templateSh[805];
		conv += panelSh[p_idx + 231] * templateSh[804];
		conv += panelSh[p_idx + 232] * templateSh[803];
		conv += panelSh[p_idx + 233] * templateSh[802];
		conv += panelSh[p_idx + 234] * templateSh[801];
		conv += panelSh[p_idx + 235] * templateSh[800];
		conv += panelSh[p_idx + 236] * templateSh[799];
		conv += panelSh[p_idx + 237] * templateSh[798];
		conv += panelSh[p_idx + 238] * templateSh[797];
		conv += panelSh[p_idx + 239] * templateSh[796];
		conv += panelSh[p_idx + 240] * templateSh[795];
		conv += panelSh[p_idx + 241] * templateSh[794];
		conv += panelSh[p_idx + 242] * templateSh[793];
		conv += panelSh[p_idx + 243] * templateSh[792];
		conv += panelSh[p_idx + 244] * templateSh[791];
		conv += panelSh[p_idx + 245] * templateSh[790];
		conv += panelSh[p_idx + 246] * templateSh[789];
		conv += panelSh[p_idx + 247] * templateSh[788];
		conv += panelSh[p_idx + 248] * templateSh[787];
		conv += panelSh[p_idx + 249] * templateSh[786];
		conv += panelSh[p_idx + 250] * templateSh[785];
		conv += panelSh[p_idx + 251] * templateSh[784];
		conv += panelSh[p_idx + 252] * templateSh[783];
		conv += panelSh[p_idx + 253] * templateSh[782];
		conv += panelSh[p_idx + 254] * templateSh[781];
		conv += panelSh[p_idx + 255] * templateSh[780];
		conv += panelSh[p_idx + 256] * templateSh[779];
		conv += panelSh[p_idx + 257] * templateSh[778];
		conv += panelSh[p_idx + 258] * templateSh[777];
		conv += panelSh[p_idx + 259] * templateSh[776];
		conv += panelSh[p_idx + 260] * templateSh[775];
		conv += panelSh[p_idx + 276] * templateSh[774];
		conv += panelSh[p_idx + 277] * templateSh[773];
		conv += panelSh[p_idx + 278] * templateSh[772];
		conv += panelSh[p_idx + 279] * templateSh[771];
		conv += panelSh[p_idx + 280] * templateSh[770];
		conv += panelSh[p_idx + 281] * templateSh[769];
		conv += panelSh[p_idx + 282] * templateSh[768];
		conv += panelSh[p_idx + 283] * templateSh[767];
		conv += panelSh[p_idx + 284] * templateSh[766];
		conv += panelSh[p_idx + 285] * templateSh[765];
		conv += panelSh[p_idx + 286] * templateSh[764];
		conv += panelSh[p_idx + 287] * templateSh[763];
		conv += panelSh[p_idx + 288] * templateSh[762];
		conv += panelSh[p_idx + 289] * templateSh[761];
		conv += panelSh[p_idx + 290] * templateSh[760];
		conv += panelSh[p_idx + 291] * templateSh[759];
		conv += panelSh[p_idx + 292] * templateSh[758];
		conv += panelSh[p_idx + 293] * templateSh[757];
		conv += panelSh[p_idx + 294] * templateSh[756];
		conv += panelSh[p_idx + 295] * templateSh[755];
		conv += panelSh[p_idx + 296] * templateSh[754];
		conv += panelSh[p_idx + 297] * templateSh[753];
		conv += panelSh[p_idx + 298] * templateSh[752];
		conv += panelSh[p_idx + 299] * templateSh[751];
		conv += panelSh[p_idx + 300] * templateSh[750];
		conv += panelSh[p_idx + 301] * templateSh[749];
		conv += panelSh[p_idx + 302] * templateSh[748];
		conv += panelSh[p_idx + 303] * templateSh[747];
		conv += panelSh[p_idx + 304] * templateSh[746];
		conv += panelSh[p_idx + 305] * templateSh[745];
		conv += panelSh[p_idx + 306] * templateSh[744];
		conv += panelSh[p_idx + 322] * templateSh[743];
		conv += panelSh[p_idx + 323] * templateSh[742];
		conv += panelSh[p_idx + 324] * templateSh[741];
		conv += panelSh[p_idx + 325] * templateSh[740];
		conv += panelSh[p_idx + 326] * templateSh[739];
		conv += panelSh[p_idx + 327] * templateSh[738];
		conv += panelSh[p_idx + 328] * templateSh[737];
		conv += panelSh[p_idx + 329] * templateSh[736];
		conv += panelSh[p_idx + 330] * templateSh[735];
		conv += panelSh[p_idx + 331] * templateSh[734];
		conv += panelSh[p_idx + 332] * templateSh[733];
		conv += panelSh[p_idx + 333] * templateSh[732];
		conv += panelSh[p_idx + 334] * templateSh[731];
		conv += panelSh[p_idx + 335] * templateSh[730];
		conv += panelSh[p_idx + 336] * templateSh[729];
		conv += panelSh[p_idx + 337] * templateSh[728];
		conv += panelSh[p_idx + 338] * templateSh[727];
		conv += panelSh[p_idx + 339] * templateSh[726];
		conv += panelSh[p_idx + 340] * templateSh[725];
		conv += panelSh[p_idx + 341] * templateSh[724];
		conv += panelSh[p_idx + 342] * templateSh[723];
		conv += panelSh[p_idx + 343] * templateSh[722];
		conv += panelSh[p_idx + 344] * templateSh[721];
		conv += panelSh[p_idx + 345] * templateSh[720];
		conv += panelSh[p_idx + 346] * templateSh[719];
		conv += panelSh[p_idx + 347] * templateSh[718];
		conv += panelSh[p_idx + 348] * templateSh[717];
		conv += panelSh[p_idx + 349] * templateSh[716];
		conv += panelSh[p_idx + 350] * templateSh[715];
		conv += panelSh[p_idx + 351] * templateSh[714];
		conv += panelSh[p_idx + 352] * templateSh[713];
		conv += panelSh[p_idx + 368] * templateSh[712];
		conv += panelSh[p_idx + 369] * templateSh[711];
		conv += panelSh[p_idx + 370] * templateSh[710];
		conv += panelSh[p_idx + 371] * templateSh[709];
		conv += panelSh[p_idx + 372] * templateSh[708];
		conv += panelSh[p_idx + 373] * templateSh[707];
		conv += panelSh[p_idx + 374] * templateSh[706];
		conv += panelSh[p_idx + 375] * templateSh[705];
		conv += panelSh[p_idx + 376] * templateSh[704];
		conv += panelSh[p_idx + 377] * templateSh[703];
		conv += panelSh[p_idx + 378] * templateSh[702];
		conv += panelSh[p_idx + 379] * templateSh[701];
		conv += panelSh[p_idx + 380] * templateSh[700];
		conv += panelSh[p_idx + 381] * templateSh[699];
		conv += panelSh[p_idx + 382] * templateSh[698];
		conv += panelSh[p_idx + 383] * templateSh[697];
		conv += panelSh[p_idx + 384] * templateSh[696];
		conv += panelSh[p_idx + 385] * templateSh[695];
		conv += panelSh[p_idx + 386] * templateSh[694];
		conv += panelSh[p_idx + 387] * templateSh[693];
		conv += panelSh[p_idx + 388] * templateSh[692];
		conv += panelSh[p_idx + 389] * templateSh[691];
		conv += panelSh[p_idx + 390] * templateSh[690];
		conv += panelSh[p_idx + 391] * templateSh[689];
		conv += panelSh[p_idx + 392] * templateSh[688];
		conv += panelSh[p_idx + 393] * templateSh[687];
		conv += panelSh[p_idx + 394] * templateSh[686];
		conv += panelSh[p_idx + 395] * templateSh[685];
		conv += panelSh[p_idx + 396] * templateSh[684];
		conv += panelSh[p_idx + 397] * templateSh[683];
		conv += panelSh[p_idx + 398] * templateSh[682];
		conv += panelSh[p_idx + 414] * templateSh[681];
		conv += panelSh[p_idx + 415] * templateSh[680];
		conv += panelSh[p_idx + 416] * templateSh[679];
		conv += panelSh[p_idx + 417] * templateSh[678];
		conv += panelSh[p_idx + 418] * templateSh[677];
		conv += panelSh[p_idx + 419] * templateSh[676];
		conv += panelSh[p_idx + 420] * templateSh[675];
		conv += panelSh[p_idx + 421] * templateSh[674];
		conv += panelSh[p_idx + 422] * templateSh[673];
		conv += panelSh[p_idx + 423] * templateSh[672];
		conv += panelSh[p_idx + 424] * templateSh[671];
		conv += panelSh[p_idx + 425] * templateSh[670];
		conv += panelSh[p_idx + 426] * templateSh[669];
		conv += panelSh[p_idx + 427] * templateSh[668];
		conv += panelSh[p_idx + 428] * templateSh[667];
		conv += panelSh[p_idx + 429] * templateSh[666];
		conv += panelSh[p_idx + 430] * templateSh[665];
		conv += panelSh[p_idx + 431] * templateSh[664];
		conv += panelSh[p_idx + 432] * templateSh[663];
		conv += panelSh[p_idx + 433] * templateSh[662];
		conv += panelSh[p_idx + 434] * templateSh[661];
		conv += panelSh[p_idx + 435] * templateSh[660];
		conv += panelSh[p_idx + 436] * templateSh[659];
		conv += panelSh[p_idx + 437] * templateSh[658];
		conv += panelSh[p_idx + 438] * templateSh[657];
		conv += panelSh[p_idx + 439] * templateSh[656];
		conv += panelSh[p_idx + 440] * templateSh[655];
		conv += panelSh[p_idx + 441] * templateSh[654];
		conv += panelSh[p_idx + 442] * templateSh[653];
		conv += panelSh[p_idx + 443] * templateSh[652];
		conv += panelSh[p_idx + 444] * templateSh[651];
		conv += panelSh[p_idx + 460] * templateSh[650];
		conv += panelSh[p_idx + 461] * templateSh[649];
		conv += panelSh[p_idx + 462] * templateSh[648];
		conv += panelSh[p_idx + 463] * templateSh[647];
		conv += panelSh[p_idx + 464] * templateSh[646];
		conv += panelSh[p_idx + 465] * templateSh[645];
		conv += panelSh[p_idx + 466] * templateSh[644];
		conv += panelSh[p_idx + 467] * templateSh[643];
		conv += panelSh[p_idx + 468] * templateSh[642];
		conv += panelSh[p_idx + 469] * templateSh[641];
		conv += panelSh[p_idx + 470] * templateSh[640];
		conv += panelSh[p_idx + 471] * templateSh[639];
		conv += panelSh[p_idx + 472] * templateSh[638];
		conv += panelSh[p_idx + 473] * templateSh[637];
		conv += panelSh[p_idx + 474] * templateSh[636];
		conv += panelSh[p_idx + 475] * templateSh[635];
		conv += panelSh[p_idx + 476] * templateSh[634];
		conv += panelSh[p_idx + 477] * templateSh[633];
		conv += panelSh[p_idx + 478] * templateSh[632];
		conv += panelSh[p_idx + 479] * templateSh[631];
		conv += panelSh[p_idx + 480] * templateSh[630];
		conv += panelSh[p_idx + 481] * templateSh[629];
		conv += panelSh[p_idx + 482] * templateSh[628];
		conv += panelSh[p_idx + 483] * templateSh[627];
		conv += panelSh[p_idx + 484] * templateSh[626];
		conv += panelSh[p_idx + 485] * templateSh[625];
		conv += panelSh[p_idx + 486] * templateSh[624];
		conv += panelSh[p_idx + 487] * templateSh[623];
		conv += panelSh[p_idx + 488] * templateSh[622];
		conv += panelSh[p_idx + 489] * templateSh[621];
		conv += panelSh[p_idx + 490] * templateSh[620];
		conv += panelSh[p_idx + 506] * templateSh[619];
		conv += panelSh[p_idx + 507] * templateSh[618];
		conv += panelSh[p_idx + 508] * templateSh[617];
		conv += panelSh[p_idx + 509] * templateSh[616];
		conv += panelSh[p_idx + 510] * templateSh[615];
		conv += panelSh[p_idx + 511] * templateSh[614];
		conv += panelSh[p_idx + 512] * templateSh[613];
		conv += panelSh[p_idx + 513] * templateSh[612];
		conv += panelSh[p_idx + 514] * templateSh[611];
		conv += panelSh[p_idx + 515] * templateSh[610];
		conv += panelSh[p_idx + 516] * templateSh[609];
		conv += panelSh[p_idx + 517] * templateSh[608];
		conv += panelSh[p_idx + 518] * templateSh[607];
		conv += panelSh[p_idx + 519] * templateSh[606];
		conv += panelSh[p_idx + 520] * templateSh[605];
		conv += panelSh[p_idx + 521] * templateSh[604];
		conv += panelSh[p_idx + 522] * templateSh[603];
		conv += panelSh[p_idx + 523] * templateSh[602];
		conv += panelSh[p_idx + 524] * templateSh[601];
		conv += panelSh[p_idx + 525] * templateSh[600];
		conv += panelSh[p_idx + 526] * templateSh[599];
		conv += panelSh[p_idx + 527] * templateSh[598];
		conv += panelSh[p_idx + 528] * templateSh[597];
		conv += panelSh[p_idx + 529] * templateSh[596];
		conv += panelSh[p_idx + 530] * templateSh[595];
		conv += panelSh[p_idx + 531] * templateSh[594];
		conv += panelSh[p_idx + 532] * templateSh[593];
		conv += panelSh[p_idx + 533] * templateSh[592];
		conv += panelSh[p_idx + 534] * templateSh[591];
		conv += panelSh[p_idx + 535] * templateSh[590];
		conv += panelSh[p_idx + 536] * templateSh[589];
		conv += panelSh[p_idx + 552] * templateSh[588];
		conv += panelSh[p_idx + 553] * templateSh[587];
		conv += panelSh[p_idx + 554] * templateSh[586];
		conv += panelSh[p_idx + 555] * templateSh[585];
		conv += panelSh[p_idx + 556] * templateSh[584];
		conv += panelSh[p_idx + 557] * templateSh[583];
		conv += panelSh[p_idx + 558] * templateSh[582];
		conv += panelSh[p_idx + 559] * templateSh[581];
		conv += panelSh[p_idx + 560] * templateSh[580];
		conv += panelSh[p_idx + 561] * templateSh[579];
		conv += panelSh[p_idx + 562] * templateSh[578];
		conv += panelSh[p_idx + 563] * templateSh[577];
		conv += panelSh[p_idx + 564] * templateSh[576];
		conv += panelSh[p_idx + 565] * templateSh[575];
		conv += panelSh[p_idx + 566] * templateSh[574];
		conv += panelSh[p_idx + 567] * templateSh[573];
		conv += panelSh[p_idx + 568] * templateSh[572];
		conv += panelSh[p_idx + 569] * templateSh[571];
		conv += panelSh[p_idx + 570] * templateSh[570];
		conv += panelSh[p_idx + 571] * templateSh[569];
		conv += panelSh[p_idx + 572] * templateSh[568];
		conv += panelSh[p_idx + 573] * templateSh[567];
		conv += panelSh[p_idx + 574] * templateSh[566];
		conv += panelSh[p_idx + 575] * templateSh[565];
		conv += panelSh[p_idx + 576] * templateSh[564];
		conv += panelSh[p_idx + 577] * templateSh[563];
		conv += panelSh[p_idx + 578] * templateSh[562];
		conv += panelSh[p_idx + 579] * templateSh[561];
		conv += panelSh[p_idx + 580] * templateSh[560];
		conv += panelSh[p_idx + 581] * templateSh[559];
		conv += panelSh[p_idx + 582] * templateSh[558];
		conv += panelSh[p_idx + 598] * templateSh[557];
		conv += panelSh[p_idx + 599] * templateSh[556];
		conv += panelSh[p_idx + 600] * templateSh[555];
		conv += panelSh[p_idx + 601] * templateSh[554];
		conv += panelSh[p_idx + 602] * templateSh[553];
		conv += panelSh[p_idx + 603] * templateSh[552];
		conv += panelSh[p_idx + 604] * templateSh[551];
		conv += panelSh[p_idx + 605] * templateSh[550];
		conv += panelSh[p_idx + 606] * templateSh[549];
		conv += panelSh[p_idx + 607] * templateSh[548];
		conv += panelSh[p_idx + 608] * templateSh[547];
		conv += panelSh[p_idx + 609] * templateSh[546];
		conv += panelSh[p_idx + 610] * templateSh[545];
		conv += panelSh[p_idx + 611] * templateSh[544];
		conv += panelSh[p_idx + 612] * templateSh[543];
		conv += panelSh[p_idx + 613] * templateSh[542];
		conv += panelSh[p_idx + 614] * templateSh[541];
		conv += panelSh[p_idx + 615] * templateSh[540];
		conv += panelSh[p_idx + 616] * templateSh[539];
		conv += panelSh[p_idx + 617] * templateSh[538];
		conv += panelSh[p_idx + 618] * templateSh[537];
		conv += panelSh[p_idx + 619] * templateSh[536];
		conv += panelSh[p_idx + 620] * templateSh[535];
		conv += panelSh[p_idx + 621] * templateSh[534];
		conv += panelSh[p_idx + 622] * templateSh[533];
		conv += panelSh[p_idx + 623] * templateSh[532];
		conv += panelSh[p_idx + 624] * templateSh[531];
		conv += panelSh[p_idx + 625] * templateSh[530];
		conv += panelSh[p_idx + 626] * templateSh[529];
		conv += panelSh[p_idx + 627] * templateSh[528];
		conv += panelSh[p_idx + 628] * templateSh[527];
		conv += panelSh[p_idx + 644] * templateSh[526];
		conv += panelSh[p_idx + 645] * templateSh[525];
		conv += panelSh[p_idx + 646] * templateSh[524];
		conv += panelSh[p_idx + 647] * templateSh[523];
		conv += panelSh[p_idx + 648] * templateSh[522];
		conv += panelSh[p_idx + 649] * templateSh[521];
		conv += panelSh[p_idx + 650] * templateSh[520];
		conv += panelSh[p_idx + 651] * templateSh[519];
		conv += panelSh[p_idx + 652] * templateSh[518];
		conv += panelSh[p_idx + 653] * templateSh[517];
		conv += panelSh[p_idx + 654] * templateSh[516];
		conv += panelSh[p_idx + 655] * templateSh[515];
		conv += panelSh[p_idx + 656] * templateSh[514];
		conv += panelSh[p_idx + 657] * templateSh[513];
		conv += panelSh[p_idx + 658] * templateSh[512];
		conv += panelSh[p_idx + 659] * templateSh[511];
		conv += panelSh[p_idx + 660] * templateSh[510];
		conv += panelSh[p_idx + 661] * templateSh[509];
		conv += panelSh[p_idx + 662] * templateSh[508];
		conv += panelSh[p_idx + 663] * templateSh[507];
		conv += panelSh[p_idx + 664] * templateSh[506];
		conv += panelSh[p_idx + 665] * templateSh[505];
		conv += panelSh[p_idx + 666] * templateSh[504];
		conv += panelSh[p_idx + 667] * templateSh[503];
		conv += panelSh[p_idx + 668] * templateSh[502];
		conv += panelSh[p_idx + 669] * templateSh[501];
		conv += panelSh[p_idx + 670] * templateSh[500];
		conv += panelSh[p_idx + 671] * templateSh[499];
		conv += panelSh[p_idx + 672] * templateSh[498];
		conv += panelSh[p_idx + 673] * templateSh[497];
		conv += panelSh[p_idx + 674] * templateSh[496];
		conv += panelSh[p_idx + 690] * templateSh[495];
		conv += panelSh[p_idx + 691] * templateSh[494];
		conv += panelSh[p_idx + 692] * templateSh[493];
		conv += panelSh[p_idx + 693] * templateSh[492];
		conv += panelSh[p_idx + 694] * templateSh[491];
		conv += panelSh[p_idx + 695] * templateSh[490];
		conv += panelSh[p_idx + 696] * templateSh[489];
		conv += panelSh[p_idx + 697] * templateSh[488];
		conv += panelSh[p_idx + 698] * templateSh[487];
		conv += panelSh[p_idx + 699] * templateSh[486];
		conv += panelSh[p_idx + 700] * templateSh[485];
		conv += panelSh[p_idx + 701] * templateSh[484];
		conv += panelSh[p_idx + 702] * templateSh[483];
		conv += panelSh[p_idx + 703] * templateSh[482];
		conv += panelSh[p_idx + 704] * templateSh[481];
		conv += panelSh[p_idx + 705] * templateSh[480];
		conv += panelSh[p_idx + 706] * templateSh[479];
		conv += panelSh[p_idx + 707] * templateSh[478];
		conv += panelSh[p_idx + 708] * templateSh[477];
		conv += panelSh[p_idx + 709] * templateSh[476];
		conv += panelSh[p_idx + 710] * templateSh[475];
		conv += panelSh[p_idx + 711] * templateSh[474];
		conv += panelSh[p_idx + 712] * templateSh[473];
		conv += panelSh[p_idx + 713] * templateSh[472];
		conv += panelSh[p_idx + 714] * templateSh[471];
		conv += panelSh[p_idx + 715] * templateSh[470];
		conv += panelSh[p_idx + 716] * templateSh[469];
		conv += panelSh[p_idx + 717] * templateSh[468];
		conv += panelSh[p_idx + 718] * templateSh[467];
		conv += panelSh[p_idx + 719] * templateSh[466];
		conv += panelSh[p_idx + 720] * templateSh[465];
		conv += panelSh[p_idx + 736] * templateSh[464];
		conv += panelSh[p_idx + 737] * templateSh[463];
		conv += panelSh[p_idx + 738] * templateSh[462];
		conv += panelSh[p_idx + 739] * templateSh[461];
		conv += panelSh[p_idx + 740] * templateSh[460];
		conv += panelSh[p_idx + 741] * templateSh[459];
		conv += panelSh[p_idx + 742] * templateSh[458];
		conv += panelSh[p_idx + 743] * templateSh[457];
		conv += panelSh[p_idx + 744] * templateSh[456];
		conv += panelSh[p_idx + 745] * templateSh[455];
		conv += panelSh[p_idx + 746] * templateSh[454];
		conv += panelSh[p_idx + 747] * templateSh[453];
		conv += panelSh[p_idx + 748] * templateSh[452];
		conv += panelSh[p_idx + 749] * templateSh[451];
		conv += panelSh[p_idx + 750] * templateSh[450];
		conv += panelSh[p_idx + 751] * templateSh[449];
		conv += panelSh[p_idx + 752] * templateSh[448];
		conv += panelSh[p_idx + 753] * templateSh[447];
		conv += panelSh[p_idx + 754] * templateSh[446];
		conv += panelSh[p_idx + 755] * templateSh[445];
		conv += panelSh[p_idx + 756] * templateSh[444];
		conv += panelSh[p_idx + 757] * templateSh[443];
		conv += panelSh[p_idx + 758] * templateSh[442];
		conv += panelSh[p_idx + 759] * templateSh[441];
		conv += panelSh[p_idx + 760] * templateSh[440];
		conv += panelSh[p_idx + 761] * templateSh[439];
		conv += panelSh[p_idx + 762] * templateSh[438];
		conv += panelSh[p_idx + 763] * templateSh[437];
		conv += panelSh[p_idx + 764] * templateSh[436];
		conv += panelSh[p_idx + 765] * templateSh[435];
		conv += panelSh[p_idx + 766] * templateSh[434];
		conv += panelSh[p_idx + 782] * templateSh[433];
		conv += panelSh[p_idx + 783] * templateSh[432];
		conv += panelSh[p_idx + 784] * templateSh[431];
		conv += panelSh[p_idx + 785] * templateSh[430];
		conv += panelSh[p_idx + 786] * templateSh[429];
		conv += panelSh[p_idx + 787] * templateSh[428];
		conv += panelSh[p_idx + 788] * templateSh[427];
		conv += panelSh[p_idx + 789] * templateSh[426];
		conv += panelSh[p_idx + 790] * templateSh[425];
		conv += panelSh[p_idx + 791] * templateSh[424];
		conv += panelSh[p_idx + 792] * templateSh[423];
		conv += panelSh[p_idx + 793] * templateSh[422];
		conv += panelSh[p_idx + 794] * templateSh[421];
		conv += panelSh[p_idx + 795] * templateSh[420];
		conv += panelSh[p_idx + 796] * templateSh[419];
		conv += panelSh[p_idx + 797] * templateSh[418];
		conv += panelSh[p_idx + 798] * templateSh[417];
		conv += panelSh[p_idx + 799] * templateSh[416];
		conv += panelSh[p_idx + 800] * templateSh[415];
		conv += panelSh[p_idx + 801] * templateSh[414];
		conv += panelSh[p_idx + 802] * templateSh[413];
		conv += panelSh[p_idx + 803] * templateSh[412];
		conv += panelSh[p_idx + 804] * templateSh[411];
		conv += panelSh[p_idx + 805] * templateSh[410];
		conv += panelSh[p_idx + 806] * templateSh[409];
		conv += panelSh[p_idx + 807] * templateSh[408];
		conv += panelSh[p_idx + 808] * templateSh[407];
		conv += panelSh[p_idx + 809] * templateSh[406];
		conv += panelSh[p_idx + 810] * templateSh[405];
		conv += panelSh[p_idx + 811] * templateSh[404];
		conv += panelSh[p_idx + 812] * templateSh[403];
		conv += panelSh[p_idx + 828] * templateSh[402];
		conv += panelSh[p_idx + 829] * templateSh[401];
		conv += panelSh[p_idx + 830] * templateSh[400];
		conv += panelSh[p_idx + 831] * templateSh[399];
		conv += panelSh[p_idx + 832] * templateSh[398];
		conv += panelSh[p_idx + 833] * templateSh[397];
		conv += panelSh[p_idx + 834] * templateSh[396];
		conv += panelSh[p_idx + 835] * templateSh[395];
		conv += panelSh[p_idx + 836] * templateSh[394];
		conv += panelSh[p_idx + 837] * templateSh[393];
		conv += panelSh[p_idx + 838] * templateSh[392];
		conv += panelSh[p_idx + 839] * templateSh[391];
		conv += panelSh[p_idx + 840] * templateSh[390];
		conv += panelSh[p_idx + 841] * templateSh[389];
		conv += panelSh[p_idx + 842] * templateSh[388];
		conv += panelSh[p_idx + 843] * templateSh[387];
		conv += panelSh[p_idx + 844] * templateSh[386];
		conv += panelSh[p_idx + 845] * templateSh[385];
		conv += panelSh[p_idx + 846] * templateSh[384];
		conv += panelSh[p_idx + 847] * templateSh[383];
		conv += panelSh[p_idx + 848] * templateSh[382];
		conv += panelSh[p_idx + 849] * templateSh[381];
		conv += panelSh[p_idx + 850] * templateSh[380];
		conv += panelSh[p_idx + 851] * templateSh[379];
		conv += panelSh[p_idx + 852] * templateSh[378];
		conv += panelSh[p_idx + 853] * templateSh[377];
		conv += panelSh[p_idx + 854] * templateSh[376];
		conv += panelSh[p_idx + 855] * templateSh[375];
		conv += panelSh[p_idx + 856] * templateSh[374];
		conv += panelSh[p_idx + 857] * templateSh[373];
		conv += panelSh[p_idx + 858] * templateSh[372];
		conv += panelSh[p_idx + 874] * templateSh[371];
		conv += panelSh[p_idx + 875] * templateSh[370];
		conv += panelSh[p_idx + 876] * templateSh[369];
		conv += panelSh[p_idx + 877] * templateSh[368];
		conv += panelSh[p_idx + 878] * templateSh[367];
		conv += panelSh[p_idx + 879] * templateSh[366];
		conv += panelSh[p_idx + 880] * templateSh[365];
		conv += panelSh[p_idx + 881] * templateSh[364];
		conv += panelSh[p_idx + 882] * templateSh[363];
		conv += panelSh[p_idx + 883] * templateSh[362];
		conv += panelSh[p_idx + 884] * templateSh[361];
		conv += panelSh[p_idx + 885] * templateSh[360];
		conv += panelSh[p_idx + 886] * templateSh[359];
		conv += panelSh[p_idx + 887] * templateSh[358];
		conv += panelSh[p_idx + 888] * templateSh[357];
		conv += panelSh[p_idx + 889] * templateSh[356];
		conv += panelSh[p_idx + 890] * templateSh[355];
		conv += panelSh[p_idx + 891] * templateSh[354];
		conv += panelSh[p_idx + 892] * templateSh[353];
		conv += panelSh[p_idx + 893] * templateSh[352];
		conv += panelSh[p_idx + 894] * templateSh[351];
		conv += panelSh[p_idx + 895] * templateSh[350];
		conv += panelSh[p_idx + 896] * templateSh[349];
		conv += panelSh[p_idx + 897] * templateSh[348];
		conv += panelSh[p_idx + 898] * templateSh[347];
		conv += panelSh[p_idx + 899] * templateSh[346];
		conv += panelSh[p_idx + 900] * templateSh[345];
		conv += panelSh[p_idx + 901] * templateSh[344];
		conv += panelSh[p_idx + 902] * templateSh[343];
		conv += panelSh[p_idx + 903] * templateSh[342];
		conv += panelSh[p_idx + 904] * templateSh[341];
		conv += panelSh[p_idx + 920] * templateSh[340];
		conv += panelSh[p_idx + 921] * templateSh[339];
		conv += panelSh[p_idx + 922] * templateSh[338];
		conv += panelSh[p_idx + 923] * templateSh[337];
		conv += panelSh[p_idx + 924] * templateSh[336];
		conv += panelSh[p_idx + 925] * templateSh[335];
		conv += panelSh[p_idx + 926] * templateSh[334];
		conv += panelSh[p_idx + 927] * templateSh[333];
		conv += panelSh[p_idx + 928] * templateSh[332];
		conv += panelSh[p_idx + 929] * templateSh[331];
		conv += panelSh[p_idx + 930] * templateSh[330];
		conv += panelSh[p_idx + 931] * templateSh[329];
		conv += panelSh[p_idx + 932] * templateSh[328];
		conv += panelSh[p_idx + 933] * templateSh[327];
		conv += panelSh[p_idx + 934] * templateSh[326];
		conv += panelSh[p_idx + 935] * templateSh[325];
		conv += panelSh[p_idx + 936] * templateSh[324];
		conv += panelSh[p_idx + 937] * templateSh[323];
		conv += panelSh[p_idx + 938] * templateSh[322];
		conv += panelSh[p_idx + 939] * templateSh[321];
		conv += panelSh[p_idx + 940] * templateSh[320];
		conv += panelSh[p_idx + 941] * templateSh[319];
		conv += panelSh[p_idx + 942] * templateSh[318];
		conv += panelSh[p_idx + 943] * templateSh[317];
		conv += panelSh[p_idx + 944] * templateSh[316];
		conv += panelSh[p_idx + 945] * templateSh[315];
		conv += panelSh[p_idx + 946] * templateSh[314];
		conv += panelSh[p_idx + 947] * templateSh[313];
		conv += panelSh[p_idx + 948] * templateSh[312];
		conv += panelSh[p_idx + 949] * templateSh[311];
		conv += panelSh[p_idx + 950] * templateSh[310];
		conv += panelSh[p_idx + 966] * templateSh[309];
		conv += panelSh[p_idx + 967] * templateSh[308];
		conv += panelSh[p_idx + 968] * templateSh[307];
		conv += panelSh[p_idx + 969] * templateSh[306];
		conv += panelSh[p_idx + 970] * templateSh[305];
		conv += panelSh[p_idx + 971] * templateSh[304];
		conv += panelSh[p_idx + 972] * templateSh[303];
		conv += panelSh[p_idx + 973] * templateSh[302];
		conv += panelSh[p_idx + 974] * templateSh[301];
		conv += panelSh[p_idx + 975] * templateSh[300];
		conv += panelSh[p_idx + 976] * templateSh[299];
		conv += panelSh[p_idx + 977] * templateSh[298];
		conv += panelSh[p_idx + 978] * templateSh[297];
		conv += panelSh[p_idx + 979] * templateSh[296];
		conv += panelSh[p_idx + 980] * templateSh[295];
		conv += panelSh[p_idx + 981] * templateSh[294];
		conv += panelSh[p_idx + 982] * templateSh[293];
		conv += panelSh[p_idx + 983] * templateSh[292];
		conv += panelSh[p_idx + 984] * templateSh[291];
		conv += panelSh[p_idx + 985] * templateSh[290];
		conv += panelSh[p_idx + 986] * templateSh[289];
		conv += panelSh[p_idx + 987] * templateSh[288];
		conv += panelSh[p_idx + 988] * templateSh[287];
		conv += panelSh[p_idx + 989] * templateSh[286];
		conv += panelSh[p_idx + 990] * templateSh[285];
		conv += panelSh[p_idx + 991] * templateSh[284];
		conv += panelSh[p_idx + 992] * templateSh[283];
		conv += panelSh[p_idx + 993] * templateSh[282];
		conv += panelSh[p_idx + 994] * templateSh[281];
		conv += panelSh[p_idx + 995] * templateSh[280];
		conv += panelSh[p_idx + 996] * templateSh[279];
		conv += panelSh[p_idx + 1012] * templateSh[278];
		conv += panelSh[p_idx + 1013] * templateSh[277];
		conv += panelSh[p_idx + 1014] * templateSh[276];
		conv += panelSh[p_idx + 1015] * templateSh[275];
		conv += panelSh[p_idx + 1016] * templateSh[274];
		conv += panelSh[p_idx + 1017] * templateSh[273];
		conv += panelSh[p_idx + 1018] * templateSh[272];
		conv += panelSh[p_idx + 1019] * templateSh[271];
		conv += panelSh[p_idx + 1020] * templateSh[270];
		conv += panelSh[p_idx + 1021] * templateSh[269];
		conv += panelSh[p_idx + 1022] * templateSh[268];
		conv += panelSh[p_idx + 1023] * templateSh[267];
		conv += panelSh[p_idx + 1024] * templateSh[266];
		conv += panelSh[p_idx + 1025] * templateSh[265];
		conv += panelSh[p_idx + 1026] * templateSh[264];
		conv += panelSh[p_idx + 1027] * templateSh[263];
		conv += panelSh[p_idx + 1028] * templateSh[262];
		conv += panelSh[p_idx + 1029] * templateSh[261];
		conv += panelSh[p_idx + 1030] * templateSh[260];
		conv += panelSh[p_idx + 1031] * templateSh[259];
		conv += panelSh[p_idx + 1032] * templateSh[258];
		conv += panelSh[p_idx + 1033] * templateSh[257];
		conv += panelSh[p_idx + 1034] * templateSh[256];
		conv += panelSh[p_idx + 1035] * templateSh[255];
		conv += panelSh[p_idx + 1036] * templateSh[254];
		conv += panelSh[p_idx + 1037] * templateSh[253];
		conv += panelSh[p_idx + 1038] * templateSh[252];
		conv += panelSh[p_idx + 1039] * templateSh[251];
		conv += panelSh[p_idx + 1040] * templateSh[250];
		conv += panelSh[p_idx + 1041] * templateSh[249];
		conv += panelSh[p_idx + 1042] * templateSh[248];
		conv += panelSh[p_idx + 1058] * templateSh[247];
		conv += panelSh[p_idx + 1059] * templateSh[246];
		conv += panelSh[p_idx + 1060] * templateSh[245];
		conv += panelSh[p_idx + 1061] * templateSh[244];
		conv += panelSh[p_idx + 1062] * templateSh[243];
		conv += panelSh[p_idx + 1063] * templateSh[242];
		conv += panelSh[p_idx + 1064] * templateSh[241];
		conv += panelSh[p_idx + 1065] * templateSh[240];
		conv += panelSh[p_idx + 1066] * templateSh[239];
		conv += panelSh[p_idx + 1067] * templateSh[238];
		conv += panelSh[p_idx + 1068] * templateSh[237];
		conv += panelSh[p_idx + 1069] * templateSh[236];
		conv += panelSh[p_idx + 1070] * templateSh[235];
		conv += panelSh[p_idx + 1071] * templateSh[234];
		conv += panelSh[p_idx + 1072] * templateSh[233];
		conv += panelSh[p_idx + 1073] * templateSh[232];
		conv += panelSh[p_idx + 1074] * templateSh[231];
		conv += panelSh[p_idx + 1075] * templateSh[230];
		conv += panelSh[p_idx + 1076] * templateSh[229];
		conv += panelSh[p_idx + 1077] * templateSh[228];
		conv += panelSh[p_idx + 1078] * templateSh[227];
		conv += panelSh[p_idx + 1079] * templateSh[226];
		conv += panelSh[p_idx + 1080] * templateSh[225];
		conv += panelSh[p_idx + 1081] * templateSh[224];
		conv += panelSh[p_idx + 1082] * templateSh[223];
		conv += panelSh[p_idx + 1083] * templateSh[222];
		conv += panelSh[p_idx + 1084] * templateSh[221];
		conv += panelSh[p_idx + 1085] * templateSh[220];
		conv += panelSh[p_idx + 1086] * templateSh[219];
		conv += panelSh[p_idx + 1087] * templateSh[218];
		conv += panelSh[p_idx + 1088] * templateSh[217];
		conv += panelSh[p_idx + 1104] * templateSh[216];
		conv += panelSh[p_idx + 1105] * templateSh[215];
		conv += panelSh[p_idx + 1106] * templateSh[214];
		conv += panelSh[p_idx + 1107] * templateSh[213];
		conv += panelSh[p_idx + 1108] * templateSh[212];
		conv += panelSh[p_idx + 1109] * templateSh[211];
		conv += panelSh[p_idx + 1110] * templateSh[210];
		conv += panelSh[p_idx + 1111] * templateSh[209];
		conv += panelSh[p_idx + 1112] * templateSh[208];
		conv += panelSh[p_idx + 1113] * templateSh[207];
		conv += panelSh[p_idx + 1114] * templateSh[206];
		conv += panelSh[p_idx + 1115] * templateSh[205];
		conv += panelSh[p_idx + 1116] * templateSh[204];
		conv += panelSh[p_idx + 1117] * templateSh[203];
		conv += panelSh[p_idx + 1118] * templateSh[202];
		conv += panelSh[p_idx + 1119] * templateSh[201];
		conv += panelSh[p_idx + 1120] * templateSh[200];
		conv += panelSh[p_idx + 1121] * templateSh[199];
		conv += panelSh[p_idx + 1122] * templateSh[198];
		conv += panelSh[p_idx + 1123] * templateSh[197];
		conv += panelSh[p_idx + 1124] * templateSh[196];
		conv += panelSh[p_idx + 1125] * templateSh[195];
		conv += panelSh[p_idx + 1126] * templateSh[194];
		conv += panelSh[p_idx + 1127] * templateSh[193];
		conv += panelSh[p_idx + 1128] * templateSh[192];
		conv += panelSh[p_idx + 1129] * templateSh[191];
		conv += panelSh[p_idx + 1130] * templateSh[190];
		conv += panelSh[p_idx + 1131] * templateSh[189];
		conv += panelSh[p_idx + 1132] * templateSh[188];
		conv += panelSh[p_idx + 1133] * templateSh[187];
		conv += panelSh[p_idx + 1134] * templateSh[186];
		conv += panelSh[p_idx + 1150] * templateSh[185];
		conv += panelSh[p_idx + 1151] * templateSh[184];
		conv += panelSh[p_idx + 1152] * templateSh[183];
		conv += panelSh[p_idx + 1153] * templateSh[182];
		conv += panelSh[p_idx + 1154] * templateSh[181];
		conv += panelSh[p_idx + 1155] * templateSh[180];
		conv += panelSh[p_idx + 1156] * templateSh[179];
		conv += panelSh[p_idx + 1157] * templateSh[178];
		conv += panelSh[p_idx + 1158] * templateSh[177];
		conv += panelSh[p_idx + 1159] * templateSh[176];
		conv += panelSh[p_idx + 1160] * templateSh[175];
		conv += panelSh[p_idx + 1161] * templateSh[174];
		conv += panelSh[p_idx + 1162] * templateSh[173];
		conv += panelSh[p_idx + 1163] * templateSh[172];
		conv += panelSh[p_idx + 1164] * templateSh[171];
		conv += panelSh[p_idx + 1165] * templateSh[170];
		conv += panelSh[p_idx + 1166] * templateSh[169];
		conv += panelSh[p_idx + 1167] * templateSh[168];
		conv += panelSh[p_idx + 1168] * templateSh[167];
		conv += panelSh[p_idx + 1169] * templateSh[166];
		conv += panelSh[p_idx + 1170] * templateSh[165];
		conv += panelSh[p_idx + 1171] * templateSh[164];
		conv += panelSh[p_idx + 1172] * templateSh[163];
		conv += panelSh[p_idx + 1173] * templateSh[162];
		conv += panelSh[p_idx + 1174] * templateSh[161];
		conv += panelSh[p_idx + 1175] * templateSh[160];
		conv += panelSh[p_idx + 1176] * templateSh[159];
		conv += panelSh[p_idx + 1177] * templateSh[158];
		conv += panelSh[p_idx + 1178] * templateSh[157];
		conv += panelSh[p_idx + 1179] * templateSh[156];
		conv += panelSh[p_idx + 1180] * templateSh[155];
		conv += panelSh[p_idx + 1196] * templateSh[154];
		conv += panelSh[p_idx + 1197] * templateSh[153];
		conv += panelSh[p_idx + 1198] * templateSh[152];
		conv += panelSh[p_idx + 1199] * templateSh[151];
		conv += panelSh[p_idx + 1200] * templateSh[150];
		conv += panelSh[p_idx + 1201] * templateSh[149];
		conv += panelSh[p_idx + 1202] * templateSh[148];
		conv += panelSh[p_idx + 1203] * templateSh[147];
		conv += panelSh[p_idx + 1204] * templateSh[146];
		conv += panelSh[p_idx + 1205] * templateSh[145];
		conv += panelSh[p_idx + 1206] * templateSh[144];
		conv += panelSh[p_idx + 1207] * templateSh[143];
		conv += panelSh[p_idx + 1208] * templateSh[142];
		conv += panelSh[p_idx + 1209] * templateSh[141];
		conv += panelSh[p_idx + 1210] * templateSh[140];
		conv += panelSh[p_idx + 1211] * templateSh[139];
		conv += panelSh[p_idx + 1212] * templateSh[138];
		conv += panelSh[p_idx + 1213] * templateSh[137];
		conv += panelSh[p_idx + 1214] * templateSh[136];
		conv += panelSh[p_idx + 1215] * templateSh[135];
		conv += panelSh[p_idx + 1216] * templateSh[134];
		conv += panelSh[p_idx + 1217] * templateSh[133];
		conv += panelSh[p_idx + 1218] * templateSh[132];
		conv += panelSh[p_idx + 1219] * templateSh[131];
		conv += panelSh[p_idx + 1220] * templateSh[130];
		conv += panelSh[p_idx + 1221] * templateSh[129];
		conv += panelSh[p_idx + 1222] * templateSh[128];
		conv += panelSh[p_idx + 1223] * templateSh[127];
		conv += panelSh[p_idx + 1224] * templateSh[126];
		conv += panelSh[p_idx + 1225] * templateSh[125];
		conv += panelSh[p_idx + 1226] * templateSh[124];
		conv += panelSh[p_idx + 1242] * templateSh[123];
		conv += panelSh[p_idx + 1243] * templateSh[122];
		conv += panelSh[p_idx + 1244] * templateSh[121];
		conv += panelSh[p_idx + 1245] * templateSh[120];
		conv += panelSh[p_idx + 1246] * templateSh[119];
		conv += panelSh[p_idx + 1247] * templateSh[118];
		conv += panelSh[p_idx + 1248] * templateSh[117];
		conv += panelSh[p_idx + 1249] * templateSh[116];
		conv += panelSh[p_idx + 1250] * templateSh[115];
		conv += panelSh[p_idx + 1251] * templateSh[114];
		conv += panelSh[p_idx + 1252] * templateSh[113];
		conv += panelSh[p_idx + 1253] * templateSh[112];
		conv += panelSh[p_idx + 1254] * templateSh[111];
		conv += panelSh[p_idx + 1255] * templateSh[110];
		conv += panelSh[p_idx + 1256] * templateSh[109];
		conv += panelSh[p_idx + 1257] * templateSh[108];
		conv += panelSh[p_idx + 1258] * templateSh[107];
		conv += panelSh[p_idx + 1259] * templateSh[106];
		conv += panelSh[p_idx + 1260] * templateSh[105];
		conv += panelSh[p_idx + 1261] * templateSh[104];
		conv += panelSh[p_idx + 1262] * templateSh[103];
		conv += panelSh[p_idx + 1263] * templateSh[102];
		conv += panelSh[p_idx + 1264] * templateSh[101];
		conv += panelSh[p_idx + 1265] * templateSh[100];
		conv += panelSh[p_idx + 1266] * templateSh[99];
		conv += panelSh[p_idx + 1267] * templateSh[98];
		conv += panelSh[p_idx + 1268] * templateSh[97];
		conv += panelSh[p_idx + 1269] * templateSh[96];
		conv += panelSh[p_idx + 1270] * templateSh[95];
		conv += panelSh[p_idx + 1271] * templateSh[94];
		conv += panelSh[p_idx + 1272] * templateSh[93];
		conv += panelSh[p_idx + 1288] * templateSh[92];
		conv += panelSh[p_idx + 1289] * templateSh[91];
		conv += panelSh[p_idx + 1290] * templateSh[90];
		conv += panelSh[p_idx + 1291] * templateSh[89];
		conv += panelSh[p_idx + 1292] * templateSh[88];
		conv += panelSh[p_idx + 1293] * templateSh[87];
		conv += panelSh[p_idx + 1294] * templateSh[86];
		conv += panelSh[p_idx + 1295] * templateSh[85];
		conv += panelSh[p_idx + 1296] * templateSh[84];
		conv += panelSh[p_idx + 1297] * templateSh[83];
		conv += panelSh[p_idx + 1298] * templateSh[82];
		conv += panelSh[p_idx + 1299] * templateSh[81];
		conv += panelSh[p_idx + 1300] * templateSh[80];
		conv += panelSh[p_idx + 1301] * templateSh[79];
		conv += panelSh[p_idx + 1302] * templateSh[78];
		conv += panelSh[p_idx + 1303] * templateSh[77];
		conv += panelSh[p_idx + 1304] * templateSh[76];
		conv += panelSh[p_idx + 1305] * templateSh[75];
		conv += panelSh[p_idx + 1306] * templateSh[74];
		conv += panelSh[p_idx + 1307] * templateSh[73];
		conv += panelSh[p_idx + 1308] * templateSh[72];
		conv += panelSh[p_idx + 1309] * templateSh[71];
		conv += panelSh[p_idx + 1310] * templateSh[70];
		conv += panelSh[p_idx + 1311] * templateSh[69];
		conv += panelSh[p_idx + 1312] * templateSh[68];
		conv += panelSh[p_idx + 1313] * templateSh[67];
		conv += panelSh[p_idx + 1314] * templateSh[66];
		conv += panelSh[p_idx + 1315] * templateSh[65];
		conv += panelSh[p_idx + 1316] * templateSh[64];
		conv += panelSh[p_idx + 1317] * templateSh[63];
		conv += panelSh[p_idx + 1318] * templateSh[62];
		conv += panelSh[p_idx + 1334] * templateSh[61];
		conv += panelSh[p_idx + 1335] * templateSh[60];
		conv += panelSh[p_idx + 1336] * templateSh[59];
		conv += panelSh[p_idx + 1337] * templateSh[58];
		conv += panelSh[p_idx + 1338] * templateSh[57];
		conv += panelSh[p_idx + 1339] * templateSh[56];
		conv += panelSh[p_idx + 1340] * templateSh[55];
		conv += panelSh[p_idx + 1341] * templateSh[54];
		conv += panelSh[p_idx + 1342] * templateSh[53];
		conv += panelSh[p_idx + 1343] * templateSh[52];
		conv += panelSh[p_idx + 1344] * templateSh[51];
		conv += panelSh[p_idx + 1345] * templateSh[50];
		conv += panelSh[p_idx + 1346] * templateSh[49];
		conv += panelSh[p_idx + 1347] * templateSh[48];
		conv += panelSh[p_idx + 1348] * templateSh[47];
		conv += panelSh[p_idx + 1349] * templateSh[46];
		conv += panelSh[p_idx + 1350] * templateSh[45];
		conv += panelSh[p_idx + 1351] * templateSh[44];
		conv += panelSh[p_idx + 1352] * templateSh[43];
		conv += panelSh[p_idx + 1353] * templateSh[42];
		conv += panelSh[p_idx + 1354] * templateSh[41];
		conv += panelSh[p_idx + 1355] * templateSh[40];
		conv += panelSh[p_idx + 1356] * templateSh[39];
		conv += panelSh[p_idx + 1357] * templateSh[38];
		conv += panelSh[p_idx + 1358] * templateSh[37];
		conv += panelSh[p_idx + 1359] * templateSh[36];
		conv += panelSh[p_idx + 1360] * templateSh[35];
		conv += panelSh[p_idx + 1361] * templateSh[34];
		conv += panelSh[p_idx + 1362] * templateSh[33];
		conv += panelSh[p_idx + 1363] * templateSh[32];
		conv += panelSh[p_idx + 1364] * templateSh[31];
		conv += panelSh[p_idx + 1380] * templateSh[30];
		conv += panelSh[p_idx + 1381] * templateSh[29];
		conv += panelSh[p_idx + 1382] * templateSh[28];
		conv += panelSh[p_idx + 1383] * templateSh[27];
		conv += panelSh[p_idx + 1384] * templateSh[26];
		conv += panelSh[p_idx + 1385] * templateSh[25];
		conv += panelSh[p_idx + 1386] * templateSh[24];
		conv += panelSh[p_idx + 1387] * templateSh[23];
		conv += panelSh[p_idx + 1388] * templateSh[22];
		conv += panelSh[p_idx + 1389] * templateSh[21];
		conv += panelSh[p_idx + 1390] * templateSh[20];
		conv += panelSh[p_idx + 1391] * templateSh[19];
		conv += panelSh[p_idx + 1392] * templateSh[18];
		conv += panelSh[p_idx + 1393] * templateSh[17];
		conv += panelSh[p_idx + 1394] * templateSh[16];
		conv += panelSh[p_idx + 1395] * templateSh[15];
		conv += panelSh[p_idx + 1396] * templateSh[14];
		conv += panelSh[p_idx + 1397] * templateSh[13];
		conv += panelSh[p_idx + 1398] * templateSh[12];
		conv += panelSh[p_idx + 1399] * templateSh[11];
		conv += panelSh[p_idx + 1400] * templateSh[10];
		conv += panelSh[p_idx + 1401] * templateSh[9];
		conv += panelSh[p_idx + 1402] * templateSh[8];
		conv += panelSh[p_idx + 1403] * templateSh[7];
		conv += panelSh[p_idx + 1404] * templateSh[6];
		conv += panelSh[p_idx + 1405] * templateSh[5];
		conv += panelSh[p_idx + 1406] * templateSh[4];
		conv += panelSh[p_idx + 1407] * templateSh[3];
		conv += panelSh[p_idx + 1408] * templateSh[2];
		conv += panelSh[p_idx + 1409] * templateSh[1];
		conv += panelSh[p_idx + 1410] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_31x31<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_31x31<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void convolution2d_kernel_32x32 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[2209];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<47; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<47; i+=16) {
			panelSh[IMUL(j, 47) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[1024];
	for (int j=threadIdx.y; j<32; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<32; i+=16) {
			const int jtwi = IMUL(j, 32) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision conv = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 47);
		conv += panelSh[p_idx + 0] * templateSh[1023];
		conv += panelSh[p_idx + 1] * templateSh[1022];
		conv += panelSh[p_idx + 2] * templateSh[1021];
		conv += panelSh[p_idx + 3] * templateSh[1020];
		conv += panelSh[p_idx + 4] * templateSh[1019];
		conv += panelSh[p_idx + 5] * templateSh[1018];
		conv += panelSh[p_idx + 6] * templateSh[1017];
		conv += panelSh[p_idx + 7] * templateSh[1016];
		conv += panelSh[p_idx + 8] * templateSh[1015];
		conv += panelSh[p_idx + 9] * templateSh[1014];
		conv += panelSh[p_idx + 10] * templateSh[1013];
		conv += panelSh[p_idx + 11] * templateSh[1012];
		conv += panelSh[p_idx + 12] * templateSh[1011];
		conv += panelSh[p_idx + 13] * templateSh[1010];
		conv += panelSh[p_idx + 14] * templateSh[1009];
		conv += panelSh[p_idx + 15] * templateSh[1008];
		conv += panelSh[p_idx + 16] * templateSh[1007];
		conv += panelSh[p_idx + 17] * templateSh[1006];
		conv += panelSh[p_idx + 18] * templateSh[1005];
		conv += panelSh[p_idx + 19] * templateSh[1004];
		conv += panelSh[p_idx + 20] * templateSh[1003];
		conv += panelSh[p_idx + 21] * templateSh[1002];
		conv += panelSh[p_idx + 22] * templateSh[1001];
		conv += panelSh[p_idx + 23] * templateSh[1000];
		conv += panelSh[p_idx + 24] * templateSh[999];
		conv += panelSh[p_idx + 25] * templateSh[998];
		conv += panelSh[p_idx + 26] * templateSh[997];
		conv += panelSh[p_idx + 27] * templateSh[996];
		conv += panelSh[p_idx + 28] * templateSh[995];
		conv += panelSh[p_idx + 29] * templateSh[994];
		conv += panelSh[p_idx + 30] * templateSh[993];
		conv += panelSh[p_idx + 31] * templateSh[992];
		conv += panelSh[p_idx + 47] * templateSh[991];
		conv += panelSh[p_idx + 48] * templateSh[990];
		conv += panelSh[p_idx + 49] * templateSh[989];
		conv += panelSh[p_idx + 50] * templateSh[988];
		conv += panelSh[p_idx + 51] * templateSh[987];
		conv += panelSh[p_idx + 52] * templateSh[986];
		conv += panelSh[p_idx + 53] * templateSh[985];
		conv += panelSh[p_idx + 54] * templateSh[984];
		conv += panelSh[p_idx + 55] * templateSh[983];
		conv += panelSh[p_idx + 56] * templateSh[982];
		conv += panelSh[p_idx + 57] * templateSh[981];
		conv += panelSh[p_idx + 58] * templateSh[980];
		conv += panelSh[p_idx + 59] * templateSh[979];
		conv += panelSh[p_idx + 60] * templateSh[978];
		conv += panelSh[p_idx + 61] * templateSh[977];
		conv += panelSh[p_idx + 62] * templateSh[976];
		conv += panelSh[p_idx + 63] * templateSh[975];
		conv += panelSh[p_idx + 64] * templateSh[974];
		conv += panelSh[p_idx + 65] * templateSh[973];
		conv += panelSh[p_idx + 66] * templateSh[972];
		conv += panelSh[p_idx + 67] * templateSh[971];
		conv += panelSh[p_idx + 68] * templateSh[970];
		conv += panelSh[p_idx + 69] * templateSh[969];
		conv += panelSh[p_idx + 70] * templateSh[968];
		conv += panelSh[p_idx + 71] * templateSh[967];
		conv += panelSh[p_idx + 72] * templateSh[966];
		conv += panelSh[p_idx + 73] * templateSh[965];
		conv += panelSh[p_idx + 74] * templateSh[964];
		conv += panelSh[p_idx + 75] * templateSh[963];
		conv += panelSh[p_idx + 76] * templateSh[962];
		conv += panelSh[p_idx + 77] * templateSh[961];
		conv += panelSh[p_idx + 78] * templateSh[960];
		conv += panelSh[p_idx + 94] * templateSh[959];
		conv += panelSh[p_idx + 95] * templateSh[958];
		conv += panelSh[p_idx + 96] * templateSh[957];
		conv += panelSh[p_idx + 97] * templateSh[956];
		conv += panelSh[p_idx + 98] * templateSh[955];
		conv += panelSh[p_idx + 99] * templateSh[954];
		conv += panelSh[p_idx + 100] * templateSh[953];
		conv += panelSh[p_idx + 101] * templateSh[952];
		conv += panelSh[p_idx + 102] * templateSh[951];
		conv += panelSh[p_idx + 103] * templateSh[950];
		conv += panelSh[p_idx + 104] * templateSh[949];
		conv += panelSh[p_idx + 105] * templateSh[948];
		conv += panelSh[p_idx + 106] * templateSh[947];
		conv += panelSh[p_idx + 107] * templateSh[946];
		conv += panelSh[p_idx + 108] * templateSh[945];
		conv += panelSh[p_idx + 109] * templateSh[944];
		conv += panelSh[p_idx + 110] * templateSh[943];
		conv += panelSh[p_idx + 111] * templateSh[942];
		conv += panelSh[p_idx + 112] * templateSh[941];
		conv += panelSh[p_idx + 113] * templateSh[940];
		conv += panelSh[p_idx + 114] * templateSh[939];
		conv += panelSh[p_idx + 115] * templateSh[938];
		conv += panelSh[p_idx + 116] * templateSh[937];
		conv += panelSh[p_idx + 117] * templateSh[936];
		conv += panelSh[p_idx + 118] * templateSh[935];
		conv += panelSh[p_idx + 119] * templateSh[934];
		conv += panelSh[p_idx + 120] * templateSh[933];
		conv += panelSh[p_idx + 121] * templateSh[932];
		conv += panelSh[p_idx + 122] * templateSh[931];
		conv += panelSh[p_idx + 123] * templateSh[930];
		conv += panelSh[p_idx + 124] * templateSh[929];
		conv += panelSh[p_idx + 125] * templateSh[928];
		conv += panelSh[p_idx + 141] * templateSh[927];
		conv += panelSh[p_idx + 142] * templateSh[926];
		conv += panelSh[p_idx + 143] * templateSh[925];
		conv += panelSh[p_idx + 144] * templateSh[924];
		conv += panelSh[p_idx + 145] * templateSh[923];
		conv += panelSh[p_idx + 146] * templateSh[922];
		conv += panelSh[p_idx + 147] * templateSh[921];
		conv += panelSh[p_idx + 148] * templateSh[920];
		conv += panelSh[p_idx + 149] * templateSh[919];
		conv += panelSh[p_idx + 150] * templateSh[918];
		conv += panelSh[p_idx + 151] * templateSh[917];
		conv += panelSh[p_idx + 152] * templateSh[916];
		conv += panelSh[p_idx + 153] * templateSh[915];
		conv += panelSh[p_idx + 154] * templateSh[914];
		conv += panelSh[p_idx + 155] * templateSh[913];
		conv += panelSh[p_idx + 156] * templateSh[912];
		conv += panelSh[p_idx + 157] * templateSh[911];
		conv += panelSh[p_idx + 158] * templateSh[910];
		conv += panelSh[p_idx + 159] * templateSh[909];
		conv += panelSh[p_idx + 160] * templateSh[908];
		conv += panelSh[p_idx + 161] * templateSh[907];
		conv += panelSh[p_idx + 162] * templateSh[906];
		conv += panelSh[p_idx + 163] * templateSh[905];
		conv += panelSh[p_idx + 164] * templateSh[904];
		conv += panelSh[p_idx + 165] * templateSh[903];
		conv += panelSh[p_idx + 166] * templateSh[902];
		conv += panelSh[p_idx + 167] * templateSh[901];
		conv += panelSh[p_idx + 168] * templateSh[900];
		conv += panelSh[p_idx + 169] * templateSh[899];
		conv += panelSh[p_idx + 170] * templateSh[898];
		conv += panelSh[p_idx + 171] * templateSh[897];
		conv += panelSh[p_idx + 172] * templateSh[896];
		conv += panelSh[p_idx + 188] * templateSh[895];
		conv += panelSh[p_idx + 189] * templateSh[894];
		conv += panelSh[p_idx + 190] * templateSh[893];
		conv += panelSh[p_idx + 191] * templateSh[892];
		conv += panelSh[p_idx + 192] * templateSh[891];
		conv += panelSh[p_idx + 193] * templateSh[890];
		conv += panelSh[p_idx + 194] * templateSh[889];
		conv += panelSh[p_idx + 195] * templateSh[888];
		conv += panelSh[p_idx + 196] * templateSh[887];
		conv += panelSh[p_idx + 197] * templateSh[886];
		conv += panelSh[p_idx + 198] * templateSh[885];
		conv += panelSh[p_idx + 199] * templateSh[884];
		conv += panelSh[p_idx + 200] * templateSh[883];
		conv += panelSh[p_idx + 201] * templateSh[882];
		conv += panelSh[p_idx + 202] * templateSh[881];
		conv += panelSh[p_idx + 203] * templateSh[880];
		conv += panelSh[p_idx + 204] * templateSh[879];
		conv += panelSh[p_idx + 205] * templateSh[878];
		conv += panelSh[p_idx + 206] * templateSh[877];
		conv += panelSh[p_idx + 207] * templateSh[876];
		conv += panelSh[p_idx + 208] * templateSh[875];
		conv += panelSh[p_idx + 209] * templateSh[874];
		conv += panelSh[p_idx + 210] * templateSh[873];
		conv += panelSh[p_idx + 211] * templateSh[872];
		conv += panelSh[p_idx + 212] * templateSh[871];
		conv += panelSh[p_idx + 213] * templateSh[870];
		conv += panelSh[p_idx + 214] * templateSh[869];
		conv += panelSh[p_idx + 215] * templateSh[868];
		conv += panelSh[p_idx + 216] * templateSh[867];
		conv += panelSh[p_idx + 217] * templateSh[866];
		conv += panelSh[p_idx + 218] * templateSh[865];
		conv += panelSh[p_idx + 219] * templateSh[864];
		conv += panelSh[p_idx + 235] * templateSh[863];
		conv += panelSh[p_idx + 236] * templateSh[862];
		conv += panelSh[p_idx + 237] * templateSh[861];
		conv += panelSh[p_idx + 238] * templateSh[860];
		conv += panelSh[p_idx + 239] * templateSh[859];
		conv += panelSh[p_idx + 240] * templateSh[858];
		conv += panelSh[p_idx + 241] * templateSh[857];
		conv += panelSh[p_idx + 242] * templateSh[856];
		conv += panelSh[p_idx + 243] * templateSh[855];
		conv += panelSh[p_idx + 244] * templateSh[854];
		conv += panelSh[p_idx + 245] * templateSh[853];
		conv += panelSh[p_idx + 246] * templateSh[852];
		conv += panelSh[p_idx + 247] * templateSh[851];
		conv += panelSh[p_idx + 248] * templateSh[850];
		conv += panelSh[p_idx + 249] * templateSh[849];
		conv += panelSh[p_idx + 250] * templateSh[848];
		conv += panelSh[p_idx + 251] * templateSh[847];
		conv += panelSh[p_idx + 252] * templateSh[846];
		conv += panelSh[p_idx + 253] * templateSh[845];
		conv += panelSh[p_idx + 254] * templateSh[844];
		conv += panelSh[p_idx + 255] * templateSh[843];
		conv += panelSh[p_idx + 256] * templateSh[842];
		conv += panelSh[p_idx + 257] * templateSh[841];
		conv += panelSh[p_idx + 258] * templateSh[840];
		conv += panelSh[p_idx + 259] * templateSh[839];
		conv += panelSh[p_idx + 260] * templateSh[838];
		conv += panelSh[p_idx + 261] * templateSh[837];
		conv += panelSh[p_idx + 262] * templateSh[836];
		conv += panelSh[p_idx + 263] * templateSh[835];
		conv += panelSh[p_idx + 264] * templateSh[834];
		conv += panelSh[p_idx + 265] * templateSh[833];
		conv += panelSh[p_idx + 266] * templateSh[832];
		conv += panelSh[p_idx + 282] * templateSh[831];
		conv += panelSh[p_idx + 283] * templateSh[830];
		conv += panelSh[p_idx + 284] * templateSh[829];
		conv += panelSh[p_idx + 285] * templateSh[828];
		conv += panelSh[p_idx + 286] * templateSh[827];
		conv += panelSh[p_idx + 287] * templateSh[826];
		conv += panelSh[p_idx + 288] * templateSh[825];
		conv += panelSh[p_idx + 289] * templateSh[824];
		conv += panelSh[p_idx + 290] * templateSh[823];
		conv += panelSh[p_idx + 291] * templateSh[822];
		conv += panelSh[p_idx + 292] * templateSh[821];
		conv += panelSh[p_idx + 293] * templateSh[820];
		conv += panelSh[p_idx + 294] * templateSh[819];
		conv += panelSh[p_idx + 295] * templateSh[818];
		conv += panelSh[p_idx + 296] * templateSh[817];
		conv += panelSh[p_idx + 297] * templateSh[816];
		conv += panelSh[p_idx + 298] * templateSh[815];
		conv += panelSh[p_idx + 299] * templateSh[814];
		conv += panelSh[p_idx + 300] * templateSh[813];
		conv += panelSh[p_idx + 301] * templateSh[812];
		conv += panelSh[p_idx + 302] * templateSh[811];
		conv += panelSh[p_idx + 303] * templateSh[810];
		conv += panelSh[p_idx + 304] * templateSh[809];
		conv += panelSh[p_idx + 305] * templateSh[808];
		conv += panelSh[p_idx + 306] * templateSh[807];
		conv += panelSh[p_idx + 307] * templateSh[806];
		conv += panelSh[p_idx + 308] * templateSh[805];
		conv += panelSh[p_idx + 309] * templateSh[804];
		conv += panelSh[p_idx + 310] * templateSh[803];
		conv += panelSh[p_idx + 311] * templateSh[802];
		conv += panelSh[p_idx + 312] * templateSh[801];
		conv += panelSh[p_idx + 313] * templateSh[800];
		conv += panelSh[p_idx + 329] * templateSh[799];
		conv += panelSh[p_idx + 330] * templateSh[798];
		conv += panelSh[p_idx + 331] * templateSh[797];
		conv += panelSh[p_idx + 332] * templateSh[796];
		conv += panelSh[p_idx + 333] * templateSh[795];
		conv += panelSh[p_idx + 334] * templateSh[794];
		conv += panelSh[p_idx + 335] * templateSh[793];
		conv += panelSh[p_idx + 336] * templateSh[792];
		conv += panelSh[p_idx + 337] * templateSh[791];
		conv += panelSh[p_idx + 338] * templateSh[790];
		conv += panelSh[p_idx + 339] * templateSh[789];
		conv += panelSh[p_idx + 340] * templateSh[788];
		conv += panelSh[p_idx + 341] * templateSh[787];
		conv += panelSh[p_idx + 342] * templateSh[786];
		conv += panelSh[p_idx + 343] * templateSh[785];
		conv += panelSh[p_idx + 344] * templateSh[784];
		conv += panelSh[p_idx + 345] * templateSh[783];
		conv += panelSh[p_idx + 346] * templateSh[782];
		conv += panelSh[p_idx + 347] * templateSh[781];
		conv += panelSh[p_idx + 348] * templateSh[780];
		conv += panelSh[p_idx + 349] * templateSh[779];
		conv += panelSh[p_idx + 350] * templateSh[778];
		conv += panelSh[p_idx + 351] * templateSh[777];
		conv += panelSh[p_idx + 352] * templateSh[776];
		conv += panelSh[p_idx + 353] * templateSh[775];
		conv += panelSh[p_idx + 354] * templateSh[774];
		conv += panelSh[p_idx + 355] * templateSh[773];
		conv += panelSh[p_idx + 356] * templateSh[772];
		conv += panelSh[p_idx + 357] * templateSh[771];
		conv += panelSh[p_idx + 358] * templateSh[770];
		conv += panelSh[p_idx + 359] * templateSh[769];
		conv += panelSh[p_idx + 360] * templateSh[768];
		conv += panelSh[p_idx + 376] * templateSh[767];
		conv += panelSh[p_idx + 377] * templateSh[766];
		conv += panelSh[p_idx + 378] * templateSh[765];
		conv += panelSh[p_idx + 379] * templateSh[764];
		conv += panelSh[p_idx + 380] * templateSh[763];
		conv += panelSh[p_idx + 381] * templateSh[762];
		conv += panelSh[p_idx + 382] * templateSh[761];
		conv += panelSh[p_idx + 383] * templateSh[760];
		conv += panelSh[p_idx + 384] * templateSh[759];
		conv += panelSh[p_idx + 385] * templateSh[758];
		conv += panelSh[p_idx + 386] * templateSh[757];
		conv += panelSh[p_idx + 387] * templateSh[756];
		conv += panelSh[p_idx + 388] * templateSh[755];
		conv += panelSh[p_idx + 389] * templateSh[754];
		conv += panelSh[p_idx + 390] * templateSh[753];
		conv += panelSh[p_idx + 391] * templateSh[752];
		conv += panelSh[p_idx + 392] * templateSh[751];
		conv += panelSh[p_idx + 393] * templateSh[750];
		conv += panelSh[p_idx + 394] * templateSh[749];
		conv += panelSh[p_idx + 395] * templateSh[748];
		conv += panelSh[p_idx + 396] * templateSh[747];
		conv += panelSh[p_idx + 397] * templateSh[746];
		conv += panelSh[p_idx + 398] * templateSh[745];
		conv += panelSh[p_idx + 399] * templateSh[744];
		conv += panelSh[p_idx + 400] * templateSh[743];
		conv += panelSh[p_idx + 401] * templateSh[742];
		conv += panelSh[p_idx + 402] * templateSh[741];
		conv += panelSh[p_idx + 403] * templateSh[740];
		conv += panelSh[p_idx + 404] * templateSh[739];
		conv += panelSh[p_idx + 405] * templateSh[738];
		conv += panelSh[p_idx + 406] * templateSh[737];
		conv += panelSh[p_idx + 407] * templateSh[736];
		conv += panelSh[p_idx + 423] * templateSh[735];
		conv += panelSh[p_idx + 424] * templateSh[734];
		conv += panelSh[p_idx + 425] * templateSh[733];
		conv += panelSh[p_idx + 426] * templateSh[732];
		conv += panelSh[p_idx + 427] * templateSh[731];
		conv += panelSh[p_idx + 428] * templateSh[730];
		conv += panelSh[p_idx + 429] * templateSh[729];
		conv += panelSh[p_idx + 430] * templateSh[728];
		conv += panelSh[p_idx + 431] * templateSh[727];
		conv += panelSh[p_idx + 432] * templateSh[726];
		conv += panelSh[p_idx + 433] * templateSh[725];
		conv += panelSh[p_idx + 434] * templateSh[724];
		conv += panelSh[p_idx + 435] * templateSh[723];
		conv += panelSh[p_idx + 436] * templateSh[722];
		conv += panelSh[p_idx + 437] * templateSh[721];
		conv += panelSh[p_idx + 438] * templateSh[720];
		conv += panelSh[p_idx + 439] * templateSh[719];
		conv += panelSh[p_idx + 440] * templateSh[718];
		conv += panelSh[p_idx + 441] * templateSh[717];
		conv += panelSh[p_idx + 442] * templateSh[716];
		conv += panelSh[p_idx + 443] * templateSh[715];
		conv += panelSh[p_idx + 444] * templateSh[714];
		conv += panelSh[p_idx + 445] * templateSh[713];
		conv += panelSh[p_idx + 446] * templateSh[712];
		conv += panelSh[p_idx + 447] * templateSh[711];
		conv += panelSh[p_idx + 448] * templateSh[710];
		conv += panelSh[p_idx + 449] * templateSh[709];
		conv += panelSh[p_idx + 450] * templateSh[708];
		conv += panelSh[p_idx + 451] * templateSh[707];
		conv += panelSh[p_idx + 452] * templateSh[706];
		conv += panelSh[p_idx + 453] * templateSh[705];
		conv += panelSh[p_idx + 454] * templateSh[704];
		conv += panelSh[p_idx + 470] * templateSh[703];
		conv += panelSh[p_idx + 471] * templateSh[702];
		conv += panelSh[p_idx + 472] * templateSh[701];
		conv += panelSh[p_idx + 473] * templateSh[700];
		conv += panelSh[p_idx + 474] * templateSh[699];
		conv += panelSh[p_idx + 475] * templateSh[698];
		conv += panelSh[p_idx + 476] * templateSh[697];
		conv += panelSh[p_idx + 477] * templateSh[696];
		conv += panelSh[p_idx + 478] * templateSh[695];
		conv += panelSh[p_idx + 479] * templateSh[694];
		conv += panelSh[p_idx + 480] * templateSh[693];
		conv += panelSh[p_idx + 481] * templateSh[692];
		conv += panelSh[p_idx + 482] * templateSh[691];
		conv += panelSh[p_idx + 483] * templateSh[690];
		conv += panelSh[p_idx + 484] * templateSh[689];
		conv += panelSh[p_idx + 485] * templateSh[688];
		conv += panelSh[p_idx + 486] * templateSh[687];
		conv += panelSh[p_idx + 487] * templateSh[686];
		conv += panelSh[p_idx + 488] * templateSh[685];
		conv += panelSh[p_idx + 489] * templateSh[684];
		conv += panelSh[p_idx + 490] * templateSh[683];
		conv += panelSh[p_idx + 491] * templateSh[682];
		conv += panelSh[p_idx + 492] * templateSh[681];
		conv += panelSh[p_idx + 493] * templateSh[680];
		conv += panelSh[p_idx + 494] * templateSh[679];
		conv += panelSh[p_idx + 495] * templateSh[678];
		conv += panelSh[p_idx + 496] * templateSh[677];
		conv += panelSh[p_idx + 497] * templateSh[676];
		conv += panelSh[p_idx + 498] * templateSh[675];
		conv += panelSh[p_idx + 499] * templateSh[674];
		conv += panelSh[p_idx + 500] * templateSh[673];
		conv += panelSh[p_idx + 501] * templateSh[672];
		conv += panelSh[p_idx + 517] * templateSh[671];
		conv += panelSh[p_idx + 518] * templateSh[670];
		conv += panelSh[p_idx + 519] * templateSh[669];
		conv += panelSh[p_idx + 520] * templateSh[668];
		conv += panelSh[p_idx + 521] * templateSh[667];
		conv += panelSh[p_idx + 522] * templateSh[666];
		conv += panelSh[p_idx + 523] * templateSh[665];
		conv += panelSh[p_idx + 524] * templateSh[664];
		conv += panelSh[p_idx + 525] * templateSh[663];
		conv += panelSh[p_idx + 526] * templateSh[662];
		conv += panelSh[p_idx + 527] * templateSh[661];
		conv += panelSh[p_idx + 528] * templateSh[660];
		conv += panelSh[p_idx + 529] * templateSh[659];
		conv += panelSh[p_idx + 530] * templateSh[658];
		conv += panelSh[p_idx + 531] * templateSh[657];
		conv += panelSh[p_idx + 532] * templateSh[656];
		conv += panelSh[p_idx + 533] * templateSh[655];
		conv += panelSh[p_idx + 534] * templateSh[654];
		conv += panelSh[p_idx + 535] * templateSh[653];
		conv += panelSh[p_idx + 536] * templateSh[652];
		conv += panelSh[p_idx + 537] * templateSh[651];
		conv += panelSh[p_idx + 538] * templateSh[650];
		conv += panelSh[p_idx + 539] * templateSh[649];
		conv += panelSh[p_idx + 540] * templateSh[648];
		conv += panelSh[p_idx + 541] * templateSh[647];
		conv += panelSh[p_idx + 542] * templateSh[646];
		conv += panelSh[p_idx + 543] * templateSh[645];
		conv += panelSh[p_idx + 544] * templateSh[644];
		conv += panelSh[p_idx + 545] * templateSh[643];
		conv += panelSh[p_idx + 546] * templateSh[642];
		conv += panelSh[p_idx + 547] * templateSh[641];
		conv += panelSh[p_idx + 548] * templateSh[640];
		conv += panelSh[p_idx + 564] * templateSh[639];
		conv += panelSh[p_idx + 565] * templateSh[638];
		conv += panelSh[p_idx + 566] * templateSh[637];
		conv += panelSh[p_idx + 567] * templateSh[636];
		conv += panelSh[p_idx + 568] * templateSh[635];
		conv += panelSh[p_idx + 569] * templateSh[634];
		conv += panelSh[p_idx + 570] * templateSh[633];
		conv += panelSh[p_idx + 571] * templateSh[632];
		conv += panelSh[p_idx + 572] * templateSh[631];
		conv += panelSh[p_idx + 573] * templateSh[630];
		conv += panelSh[p_idx + 574] * templateSh[629];
		conv += panelSh[p_idx + 575] * templateSh[628];
		conv += panelSh[p_idx + 576] * templateSh[627];
		conv += panelSh[p_idx + 577] * templateSh[626];
		conv += panelSh[p_idx + 578] * templateSh[625];
		conv += panelSh[p_idx + 579] * templateSh[624];
		conv += panelSh[p_idx + 580] * templateSh[623];
		conv += panelSh[p_idx + 581] * templateSh[622];
		conv += panelSh[p_idx + 582] * templateSh[621];
		conv += panelSh[p_idx + 583] * templateSh[620];
		conv += panelSh[p_idx + 584] * templateSh[619];
		conv += panelSh[p_idx + 585] * templateSh[618];
		conv += panelSh[p_idx + 586] * templateSh[617];
		conv += panelSh[p_idx + 587] * templateSh[616];
		conv += panelSh[p_idx + 588] * templateSh[615];
		conv += panelSh[p_idx + 589] * templateSh[614];
		conv += panelSh[p_idx + 590] * templateSh[613];
		conv += panelSh[p_idx + 591] * templateSh[612];
		conv += panelSh[p_idx + 592] * templateSh[611];
		conv += panelSh[p_idx + 593] * templateSh[610];
		conv += panelSh[p_idx + 594] * templateSh[609];
		conv += panelSh[p_idx + 595] * templateSh[608];
		conv += panelSh[p_idx + 611] * templateSh[607];
		conv += panelSh[p_idx + 612] * templateSh[606];
		conv += panelSh[p_idx + 613] * templateSh[605];
		conv += panelSh[p_idx + 614] * templateSh[604];
		conv += panelSh[p_idx + 615] * templateSh[603];
		conv += panelSh[p_idx + 616] * templateSh[602];
		conv += panelSh[p_idx + 617] * templateSh[601];
		conv += panelSh[p_idx + 618] * templateSh[600];
		conv += panelSh[p_idx + 619] * templateSh[599];
		conv += panelSh[p_idx + 620] * templateSh[598];
		conv += panelSh[p_idx + 621] * templateSh[597];
		conv += panelSh[p_idx + 622] * templateSh[596];
		conv += panelSh[p_idx + 623] * templateSh[595];
		conv += panelSh[p_idx + 624] * templateSh[594];
		conv += panelSh[p_idx + 625] * templateSh[593];
		conv += panelSh[p_idx + 626] * templateSh[592];
		conv += panelSh[p_idx + 627] * templateSh[591];
		conv += panelSh[p_idx + 628] * templateSh[590];
		conv += panelSh[p_idx + 629] * templateSh[589];
		conv += panelSh[p_idx + 630] * templateSh[588];
		conv += panelSh[p_idx + 631] * templateSh[587];
		conv += panelSh[p_idx + 632] * templateSh[586];
		conv += panelSh[p_idx + 633] * templateSh[585];
		conv += panelSh[p_idx + 634] * templateSh[584];
		conv += panelSh[p_idx + 635] * templateSh[583];
		conv += panelSh[p_idx + 636] * templateSh[582];
		conv += panelSh[p_idx + 637] * templateSh[581];
		conv += panelSh[p_idx + 638] * templateSh[580];
		conv += panelSh[p_idx + 639] * templateSh[579];
		conv += panelSh[p_idx + 640] * templateSh[578];
		conv += panelSh[p_idx + 641] * templateSh[577];
		conv += panelSh[p_idx + 642] * templateSh[576];
		conv += panelSh[p_idx + 658] * templateSh[575];
		conv += panelSh[p_idx + 659] * templateSh[574];
		conv += panelSh[p_idx + 660] * templateSh[573];
		conv += panelSh[p_idx + 661] * templateSh[572];
		conv += panelSh[p_idx + 662] * templateSh[571];
		conv += panelSh[p_idx + 663] * templateSh[570];
		conv += panelSh[p_idx + 664] * templateSh[569];
		conv += panelSh[p_idx + 665] * templateSh[568];
		conv += panelSh[p_idx + 666] * templateSh[567];
		conv += panelSh[p_idx + 667] * templateSh[566];
		conv += panelSh[p_idx + 668] * templateSh[565];
		conv += panelSh[p_idx + 669] * templateSh[564];
		conv += panelSh[p_idx + 670] * templateSh[563];
		conv += panelSh[p_idx + 671] * templateSh[562];
		conv += panelSh[p_idx + 672] * templateSh[561];
		conv += panelSh[p_idx + 673] * templateSh[560];
		conv += panelSh[p_idx + 674] * templateSh[559];
		conv += panelSh[p_idx + 675] * templateSh[558];
		conv += panelSh[p_idx + 676] * templateSh[557];
		conv += panelSh[p_idx + 677] * templateSh[556];
		conv += panelSh[p_idx + 678] * templateSh[555];
		conv += panelSh[p_idx + 679] * templateSh[554];
		conv += panelSh[p_idx + 680] * templateSh[553];
		conv += panelSh[p_idx + 681] * templateSh[552];
		conv += panelSh[p_idx + 682] * templateSh[551];
		conv += panelSh[p_idx + 683] * templateSh[550];
		conv += panelSh[p_idx + 684] * templateSh[549];
		conv += panelSh[p_idx + 685] * templateSh[548];
		conv += panelSh[p_idx + 686] * templateSh[547];
		conv += panelSh[p_idx + 687] * templateSh[546];
		conv += panelSh[p_idx + 688] * templateSh[545];
		conv += panelSh[p_idx + 689] * templateSh[544];
		conv += panelSh[p_idx + 705] * templateSh[543];
		conv += panelSh[p_idx + 706] * templateSh[542];
		conv += panelSh[p_idx + 707] * templateSh[541];
		conv += panelSh[p_idx + 708] * templateSh[540];
		conv += panelSh[p_idx + 709] * templateSh[539];
		conv += panelSh[p_idx + 710] * templateSh[538];
		conv += panelSh[p_idx + 711] * templateSh[537];
		conv += panelSh[p_idx + 712] * templateSh[536];
		conv += panelSh[p_idx + 713] * templateSh[535];
		conv += panelSh[p_idx + 714] * templateSh[534];
		conv += panelSh[p_idx + 715] * templateSh[533];
		conv += panelSh[p_idx + 716] * templateSh[532];
		conv += panelSh[p_idx + 717] * templateSh[531];
		conv += panelSh[p_idx + 718] * templateSh[530];
		conv += panelSh[p_idx + 719] * templateSh[529];
		conv += panelSh[p_idx + 720] * templateSh[528];
		conv += panelSh[p_idx + 721] * templateSh[527];
		conv += panelSh[p_idx + 722] * templateSh[526];
		conv += panelSh[p_idx + 723] * templateSh[525];
		conv += panelSh[p_idx + 724] * templateSh[524];
		conv += panelSh[p_idx + 725] * templateSh[523];
		conv += panelSh[p_idx + 726] * templateSh[522];
		conv += panelSh[p_idx + 727] * templateSh[521];
		conv += panelSh[p_idx + 728] * templateSh[520];
		conv += panelSh[p_idx + 729] * templateSh[519];
		conv += panelSh[p_idx + 730] * templateSh[518];
		conv += panelSh[p_idx + 731] * templateSh[517];
		conv += panelSh[p_idx + 732] * templateSh[516];
		conv += panelSh[p_idx + 733] * templateSh[515];
		conv += panelSh[p_idx + 734] * templateSh[514];
		conv += panelSh[p_idx + 735] * templateSh[513];
		conv += panelSh[p_idx + 736] * templateSh[512];
		conv += panelSh[p_idx + 752] * templateSh[511];
		conv += panelSh[p_idx + 753] * templateSh[510];
		conv += panelSh[p_idx + 754] * templateSh[509];
		conv += panelSh[p_idx + 755] * templateSh[508];
		conv += panelSh[p_idx + 756] * templateSh[507];
		conv += panelSh[p_idx + 757] * templateSh[506];
		conv += panelSh[p_idx + 758] * templateSh[505];
		conv += panelSh[p_idx + 759] * templateSh[504];
		conv += panelSh[p_idx + 760] * templateSh[503];
		conv += panelSh[p_idx + 761] * templateSh[502];
		conv += panelSh[p_idx + 762] * templateSh[501];
		conv += panelSh[p_idx + 763] * templateSh[500];
		conv += panelSh[p_idx + 764] * templateSh[499];
		conv += panelSh[p_idx + 765] * templateSh[498];
		conv += panelSh[p_idx + 766] * templateSh[497];
		conv += panelSh[p_idx + 767] * templateSh[496];
		conv += panelSh[p_idx + 768] * templateSh[495];
		conv += panelSh[p_idx + 769] * templateSh[494];
		conv += panelSh[p_idx + 770] * templateSh[493];
		conv += panelSh[p_idx + 771] * templateSh[492];
		conv += panelSh[p_idx + 772] * templateSh[491];
		conv += panelSh[p_idx + 773] * templateSh[490];
		conv += panelSh[p_idx + 774] * templateSh[489];
		conv += panelSh[p_idx + 775] * templateSh[488];
		conv += panelSh[p_idx + 776] * templateSh[487];
		conv += panelSh[p_idx + 777] * templateSh[486];
		conv += panelSh[p_idx + 778] * templateSh[485];
		conv += panelSh[p_idx + 779] * templateSh[484];
		conv += panelSh[p_idx + 780] * templateSh[483];
		conv += panelSh[p_idx + 781] * templateSh[482];
		conv += panelSh[p_idx + 782] * templateSh[481];
		conv += panelSh[p_idx + 783] * templateSh[480];
		conv += panelSh[p_idx + 799] * templateSh[479];
		conv += panelSh[p_idx + 800] * templateSh[478];
		conv += panelSh[p_idx + 801] * templateSh[477];
		conv += panelSh[p_idx + 802] * templateSh[476];
		conv += panelSh[p_idx + 803] * templateSh[475];
		conv += panelSh[p_idx + 804] * templateSh[474];
		conv += panelSh[p_idx + 805] * templateSh[473];
		conv += panelSh[p_idx + 806] * templateSh[472];
		conv += panelSh[p_idx + 807] * templateSh[471];
		conv += panelSh[p_idx + 808] * templateSh[470];
		conv += panelSh[p_idx + 809] * templateSh[469];
		conv += panelSh[p_idx + 810] * templateSh[468];
		conv += panelSh[p_idx + 811] * templateSh[467];
		conv += panelSh[p_idx + 812] * templateSh[466];
		conv += panelSh[p_idx + 813] * templateSh[465];
		conv += panelSh[p_idx + 814] * templateSh[464];
		conv += panelSh[p_idx + 815] * templateSh[463];
		conv += panelSh[p_idx + 816] * templateSh[462];
		conv += panelSh[p_idx + 817] * templateSh[461];
		conv += panelSh[p_idx + 818] * templateSh[460];
		conv += panelSh[p_idx + 819] * templateSh[459];
		conv += panelSh[p_idx + 820] * templateSh[458];
		conv += panelSh[p_idx + 821] * templateSh[457];
		conv += panelSh[p_idx + 822] * templateSh[456];
		conv += panelSh[p_idx + 823] * templateSh[455];
		conv += panelSh[p_idx + 824] * templateSh[454];
		conv += panelSh[p_idx + 825] * templateSh[453];
		conv += panelSh[p_idx + 826] * templateSh[452];
		conv += panelSh[p_idx + 827] * templateSh[451];
		conv += panelSh[p_idx + 828] * templateSh[450];
		conv += panelSh[p_idx + 829] * templateSh[449];
		conv += panelSh[p_idx + 830] * templateSh[448];
		conv += panelSh[p_idx + 846] * templateSh[447];
		conv += panelSh[p_idx + 847] * templateSh[446];
		conv += panelSh[p_idx + 848] * templateSh[445];
		conv += panelSh[p_idx + 849] * templateSh[444];
		conv += panelSh[p_idx + 850] * templateSh[443];
		conv += panelSh[p_idx + 851] * templateSh[442];
		conv += panelSh[p_idx + 852] * templateSh[441];
		conv += panelSh[p_idx + 853] * templateSh[440];
		conv += panelSh[p_idx + 854] * templateSh[439];
		conv += panelSh[p_idx + 855] * templateSh[438];
		conv += panelSh[p_idx + 856] * templateSh[437];
		conv += panelSh[p_idx + 857] * templateSh[436];
		conv += panelSh[p_idx + 858] * templateSh[435];
		conv += panelSh[p_idx + 859] * templateSh[434];
		conv += panelSh[p_idx + 860] * templateSh[433];
		conv += panelSh[p_idx + 861] * templateSh[432];
		conv += panelSh[p_idx + 862] * templateSh[431];
		conv += panelSh[p_idx + 863] * templateSh[430];
		conv += panelSh[p_idx + 864] * templateSh[429];
		conv += panelSh[p_idx + 865] * templateSh[428];
		conv += panelSh[p_idx + 866] * templateSh[427];
		conv += panelSh[p_idx + 867] * templateSh[426];
		conv += panelSh[p_idx + 868] * templateSh[425];
		conv += panelSh[p_idx + 869] * templateSh[424];
		conv += panelSh[p_idx + 870] * templateSh[423];
		conv += panelSh[p_idx + 871] * templateSh[422];
		conv += panelSh[p_idx + 872] * templateSh[421];
		conv += panelSh[p_idx + 873] * templateSh[420];
		conv += panelSh[p_idx + 874] * templateSh[419];
		conv += panelSh[p_idx + 875] * templateSh[418];
		conv += panelSh[p_idx + 876] * templateSh[417];
		conv += panelSh[p_idx + 877] * templateSh[416];
		conv += panelSh[p_idx + 893] * templateSh[415];
		conv += panelSh[p_idx + 894] * templateSh[414];
		conv += panelSh[p_idx + 895] * templateSh[413];
		conv += panelSh[p_idx + 896] * templateSh[412];
		conv += panelSh[p_idx + 897] * templateSh[411];
		conv += panelSh[p_idx + 898] * templateSh[410];
		conv += panelSh[p_idx + 899] * templateSh[409];
		conv += panelSh[p_idx + 900] * templateSh[408];
		conv += panelSh[p_idx + 901] * templateSh[407];
		conv += panelSh[p_idx + 902] * templateSh[406];
		conv += panelSh[p_idx + 903] * templateSh[405];
		conv += panelSh[p_idx + 904] * templateSh[404];
		conv += panelSh[p_idx + 905] * templateSh[403];
		conv += panelSh[p_idx + 906] * templateSh[402];
		conv += panelSh[p_idx + 907] * templateSh[401];
		conv += panelSh[p_idx + 908] * templateSh[400];
		conv += panelSh[p_idx + 909] * templateSh[399];
		conv += panelSh[p_idx + 910] * templateSh[398];
		conv += panelSh[p_idx + 911] * templateSh[397];
		conv += panelSh[p_idx + 912] * templateSh[396];
		conv += panelSh[p_idx + 913] * templateSh[395];
		conv += panelSh[p_idx + 914] * templateSh[394];
		conv += panelSh[p_idx + 915] * templateSh[393];
		conv += panelSh[p_idx + 916] * templateSh[392];
		conv += panelSh[p_idx + 917] * templateSh[391];
		conv += panelSh[p_idx + 918] * templateSh[390];
		conv += panelSh[p_idx + 919] * templateSh[389];
		conv += panelSh[p_idx + 920] * templateSh[388];
		conv += panelSh[p_idx + 921] * templateSh[387];
		conv += panelSh[p_idx + 922] * templateSh[386];
		conv += panelSh[p_idx + 923] * templateSh[385];
		conv += panelSh[p_idx + 924] * templateSh[384];
		conv += panelSh[p_idx + 940] * templateSh[383];
		conv += panelSh[p_idx + 941] * templateSh[382];
		conv += panelSh[p_idx + 942] * templateSh[381];
		conv += panelSh[p_idx + 943] * templateSh[380];
		conv += panelSh[p_idx + 944] * templateSh[379];
		conv += panelSh[p_idx + 945] * templateSh[378];
		conv += panelSh[p_idx + 946] * templateSh[377];
		conv += panelSh[p_idx + 947] * templateSh[376];
		conv += panelSh[p_idx + 948] * templateSh[375];
		conv += panelSh[p_idx + 949] * templateSh[374];
		conv += panelSh[p_idx + 950] * templateSh[373];
		conv += panelSh[p_idx + 951] * templateSh[372];
		conv += panelSh[p_idx + 952] * templateSh[371];
		conv += panelSh[p_idx + 953] * templateSh[370];
		conv += panelSh[p_idx + 954] * templateSh[369];
		conv += panelSh[p_idx + 955] * templateSh[368];
		conv += panelSh[p_idx + 956] * templateSh[367];
		conv += panelSh[p_idx + 957] * templateSh[366];
		conv += panelSh[p_idx + 958] * templateSh[365];
		conv += panelSh[p_idx + 959] * templateSh[364];
		conv += panelSh[p_idx + 960] * templateSh[363];
		conv += panelSh[p_idx + 961] * templateSh[362];
		conv += panelSh[p_idx + 962] * templateSh[361];
		conv += panelSh[p_idx + 963] * templateSh[360];
		conv += panelSh[p_idx + 964] * templateSh[359];
		conv += panelSh[p_idx + 965] * templateSh[358];
		conv += panelSh[p_idx + 966] * templateSh[357];
		conv += panelSh[p_idx + 967] * templateSh[356];
		conv += panelSh[p_idx + 968] * templateSh[355];
		conv += panelSh[p_idx + 969] * templateSh[354];
		conv += panelSh[p_idx + 970] * templateSh[353];
		conv += panelSh[p_idx + 971] * templateSh[352];
		conv += panelSh[p_idx + 987] * templateSh[351];
		conv += panelSh[p_idx + 988] * templateSh[350];
		conv += panelSh[p_idx + 989] * templateSh[349];
		conv += panelSh[p_idx + 990] * templateSh[348];
		conv += panelSh[p_idx + 991] * templateSh[347];
		conv += panelSh[p_idx + 992] * templateSh[346];
		conv += panelSh[p_idx + 993] * templateSh[345];
		conv += panelSh[p_idx + 994] * templateSh[344];
		conv += panelSh[p_idx + 995] * templateSh[343];
		conv += panelSh[p_idx + 996] * templateSh[342];
		conv += panelSh[p_idx + 997] * templateSh[341];
		conv += panelSh[p_idx + 998] * templateSh[340];
		conv += panelSh[p_idx + 999] * templateSh[339];
		conv += panelSh[p_idx + 1000] * templateSh[338];
		conv += panelSh[p_idx + 1001] * templateSh[337];
		conv += panelSh[p_idx + 1002] * templateSh[336];
		conv += panelSh[p_idx + 1003] * templateSh[335];
		conv += panelSh[p_idx + 1004] * templateSh[334];
		conv += panelSh[p_idx + 1005] * templateSh[333];
		conv += panelSh[p_idx + 1006] * templateSh[332];
		conv += panelSh[p_idx + 1007] * templateSh[331];
		conv += panelSh[p_idx + 1008] * templateSh[330];
		conv += panelSh[p_idx + 1009] * templateSh[329];
		conv += panelSh[p_idx + 1010] * templateSh[328];
		conv += panelSh[p_idx + 1011] * templateSh[327];
		conv += panelSh[p_idx + 1012] * templateSh[326];
		conv += panelSh[p_idx + 1013] * templateSh[325];
		conv += panelSh[p_idx + 1014] * templateSh[324];
		conv += panelSh[p_idx + 1015] * templateSh[323];
		conv += panelSh[p_idx + 1016] * templateSh[322];
		conv += panelSh[p_idx + 1017] * templateSh[321];
		conv += panelSh[p_idx + 1018] * templateSh[320];
		conv += panelSh[p_idx + 1034] * templateSh[319];
		conv += panelSh[p_idx + 1035] * templateSh[318];
		conv += panelSh[p_idx + 1036] * templateSh[317];
		conv += panelSh[p_idx + 1037] * templateSh[316];
		conv += panelSh[p_idx + 1038] * templateSh[315];
		conv += panelSh[p_idx + 1039] * templateSh[314];
		conv += panelSh[p_idx + 1040] * templateSh[313];
		conv += panelSh[p_idx + 1041] * templateSh[312];
		conv += panelSh[p_idx + 1042] * templateSh[311];
		conv += panelSh[p_idx + 1043] * templateSh[310];
		conv += panelSh[p_idx + 1044] * templateSh[309];
		conv += panelSh[p_idx + 1045] * templateSh[308];
		conv += panelSh[p_idx + 1046] * templateSh[307];
		conv += panelSh[p_idx + 1047] * templateSh[306];
		conv += panelSh[p_idx + 1048] * templateSh[305];
		conv += panelSh[p_idx + 1049] * templateSh[304];
		conv += panelSh[p_idx + 1050] * templateSh[303];
		conv += panelSh[p_idx + 1051] * templateSh[302];
		conv += panelSh[p_idx + 1052] * templateSh[301];
		conv += panelSh[p_idx + 1053] * templateSh[300];
		conv += panelSh[p_idx + 1054] * templateSh[299];
		conv += panelSh[p_idx + 1055] * templateSh[298];
		conv += panelSh[p_idx + 1056] * templateSh[297];
		conv += panelSh[p_idx + 1057] * templateSh[296];
		conv += panelSh[p_idx + 1058] * templateSh[295];
		conv += panelSh[p_idx + 1059] * templateSh[294];
		conv += panelSh[p_idx + 1060] * templateSh[293];
		conv += panelSh[p_idx + 1061] * templateSh[292];
		conv += panelSh[p_idx + 1062] * templateSh[291];
		conv += panelSh[p_idx + 1063] * templateSh[290];
		conv += panelSh[p_idx + 1064] * templateSh[289];
		conv += panelSh[p_idx + 1065] * templateSh[288];
		conv += panelSh[p_idx + 1081] * templateSh[287];
		conv += panelSh[p_idx + 1082] * templateSh[286];
		conv += panelSh[p_idx + 1083] * templateSh[285];
		conv += panelSh[p_idx + 1084] * templateSh[284];
		conv += panelSh[p_idx + 1085] * templateSh[283];
		conv += panelSh[p_idx + 1086] * templateSh[282];
		conv += panelSh[p_idx + 1087] * templateSh[281];
		conv += panelSh[p_idx + 1088] * templateSh[280];
		conv += panelSh[p_idx + 1089] * templateSh[279];
		conv += panelSh[p_idx + 1090] * templateSh[278];
		conv += panelSh[p_idx + 1091] * templateSh[277];
		conv += panelSh[p_idx + 1092] * templateSh[276];
		conv += panelSh[p_idx + 1093] * templateSh[275];
		conv += panelSh[p_idx + 1094] * templateSh[274];
		conv += panelSh[p_idx + 1095] * templateSh[273];
		conv += panelSh[p_idx + 1096] * templateSh[272];
		conv += panelSh[p_idx + 1097] * templateSh[271];
		conv += panelSh[p_idx + 1098] * templateSh[270];
		conv += panelSh[p_idx + 1099] * templateSh[269];
		conv += panelSh[p_idx + 1100] * templateSh[268];
		conv += panelSh[p_idx + 1101] * templateSh[267];
		conv += panelSh[p_idx + 1102] * templateSh[266];
		conv += panelSh[p_idx + 1103] * templateSh[265];
		conv += panelSh[p_idx + 1104] * templateSh[264];
		conv += panelSh[p_idx + 1105] * templateSh[263];
		conv += panelSh[p_idx + 1106] * templateSh[262];
		conv += panelSh[p_idx + 1107] * templateSh[261];
		conv += panelSh[p_idx + 1108] * templateSh[260];
		conv += panelSh[p_idx + 1109] * templateSh[259];
		conv += panelSh[p_idx + 1110] * templateSh[258];
		conv += panelSh[p_idx + 1111] * templateSh[257];
		conv += panelSh[p_idx + 1112] * templateSh[256];
		conv += panelSh[p_idx + 1128] * templateSh[255];
		conv += panelSh[p_idx + 1129] * templateSh[254];
		conv += panelSh[p_idx + 1130] * templateSh[253];
		conv += panelSh[p_idx + 1131] * templateSh[252];
		conv += panelSh[p_idx + 1132] * templateSh[251];
		conv += panelSh[p_idx + 1133] * templateSh[250];
		conv += panelSh[p_idx + 1134] * templateSh[249];
		conv += panelSh[p_idx + 1135] * templateSh[248];
		conv += panelSh[p_idx + 1136] * templateSh[247];
		conv += panelSh[p_idx + 1137] * templateSh[246];
		conv += panelSh[p_idx + 1138] * templateSh[245];
		conv += panelSh[p_idx + 1139] * templateSh[244];
		conv += panelSh[p_idx + 1140] * templateSh[243];
		conv += panelSh[p_idx + 1141] * templateSh[242];
		conv += panelSh[p_idx + 1142] * templateSh[241];
		conv += panelSh[p_idx + 1143] * templateSh[240];
		conv += panelSh[p_idx + 1144] * templateSh[239];
		conv += panelSh[p_idx + 1145] * templateSh[238];
		conv += panelSh[p_idx + 1146] * templateSh[237];
		conv += panelSh[p_idx + 1147] * templateSh[236];
		conv += panelSh[p_idx + 1148] * templateSh[235];
		conv += panelSh[p_idx + 1149] * templateSh[234];
		conv += panelSh[p_idx + 1150] * templateSh[233];
		conv += panelSh[p_idx + 1151] * templateSh[232];
		conv += panelSh[p_idx + 1152] * templateSh[231];
		conv += panelSh[p_idx + 1153] * templateSh[230];
		conv += panelSh[p_idx + 1154] * templateSh[229];
		conv += panelSh[p_idx + 1155] * templateSh[228];
		conv += panelSh[p_idx + 1156] * templateSh[227];
		conv += panelSh[p_idx + 1157] * templateSh[226];
		conv += panelSh[p_idx + 1158] * templateSh[225];
		conv += panelSh[p_idx + 1159] * templateSh[224];
		conv += panelSh[p_idx + 1175] * templateSh[223];
		conv += panelSh[p_idx + 1176] * templateSh[222];
		conv += panelSh[p_idx + 1177] * templateSh[221];
		conv += panelSh[p_idx + 1178] * templateSh[220];
		conv += panelSh[p_idx + 1179] * templateSh[219];
		conv += panelSh[p_idx + 1180] * templateSh[218];
		conv += panelSh[p_idx + 1181] * templateSh[217];
		conv += panelSh[p_idx + 1182] * templateSh[216];
		conv += panelSh[p_idx + 1183] * templateSh[215];
		conv += panelSh[p_idx + 1184] * templateSh[214];
		conv += panelSh[p_idx + 1185] * templateSh[213];
		conv += panelSh[p_idx + 1186] * templateSh[212];
		conv += panelSh[p_idx + 1187] * templateSh[211];
		conv += panelSh[p_idx + 1188] * templateSh[210];
		conv += panelSh[p_idx + 1189] * templateSh[209];
		conv += panelSh[p_idx + 1190] * templateSh[208];
		conv += panelSh[p_idx + 1191] * templateSh[207];
		conv += panelSh[p_idx + 1192] * templateSh[206];
		conv += panelSh[p_idx + 1193] * templateSh[205];
		conv += panelSh[p_idx + 1194] * templateSh[204];
		conv += panelSh[p_idx + 1195] * templateSh[203];
		conv += panelSh[p_idx + 1196] * templateSh[202];
		conv += panelSh[p_idx + 1197] * templateSh[201];
		conv += panelSh[p_idx + 1198] * templateSh[200];
		conv += panelSh[p_idx + 1199] * templateSh[199];
		conv += panelSh[p_idx + 1200] * templateSh[198];
		conv += panelSh[p_idx + 1201] * templateSh[197];
		conv += panelSh[p_idx + 1202] * templateSh[196];
		conv += panelSh[p_idx + 1203] * templateSh[195];
		conv += panelSh[p_idx + 1204] * templateSh[194];
		conv += panelSh[p_idx + 1205] * templateSh[193];
		conv += panelSh[p_idx + 1206] * templateSh[192];
		conv += panelSh[p_idx + 1222] * templateSh[191];
		conv += panelSh[p_idx + 1223] * templateSh[190];
		conv += panelSh[p_idx + 1224] * templateSh[189];
		conv += panelSh[p_idx + 1225] * templateSh[188];
		conv += panelSh[p_idx + 1226] * templateSh[187];
		conv += panelSh[p_idx + 1227] * templateSh[186];
		conv += panelSh[p_idx + 1228] * templateSh[185];
		conv += panelSh[p_idx + 1229] * templateSh[184];
		conv += panelSh[p_idx + 1230] * templateSh[183];
		conv += panelSh[p_idx + 1231] * templateSh[182];
		conv += panelSh[p_idx + 1232] * templateSh[181];
		conv += panelSh[p_idx + 1233] * templateSh[180];
		conv += panelSh[p_idx + 1234] * templateSh[179];
		conv += panelSh[p_idx + 1235] * templateSh[178];
		conv += panelSh[p_idx + 1236] * templateSh[177];
		conv += panelSh[p_idx + 1237] * templateSh[176];
		conv += panelSh[p_idx + 1238] * templateSh[175];
		conv += panelSh[p_idx + 1239] * templateSh[174];
		conv += panelSh[p_idx + 1240] * templateSh[173];
		conv += panelSh[p_idx + 1241] * templateSh[172];
		conv += panelSh[p_idx + 1242] * templateSh[171];
		conv += panelSh[p_idx + 1243] * templateSh[170];
		conv += panelSh[p_idx + 1244] * templateSh[169];
		conv += panelSh[p_idx + 1245] * templateSh[168];
		conv += panelSh[p_idx + 1246] * templateSh[167];
		conv += panelSh[p_idx + 1247] * templateSh[166];
		conv += panelSh[p_idx + 1248] * templateSh[165];
		conv += panelSh[p_idx + 1249] * templateSh[164];
		conv += panelSh[p_idx + 1250] * templateSh[163];
		conv += panelSh[p_idx + 1251] * templateSh[162];
		conv += panelSh[p_idx + 1252] * templateSh[161];
		conv += panelSh[p_idx + 1253] * templateSh[160];
		conv += panelSh[p_idx + 1269] * templateSh[159];
		conv += panelSh[p_idx + 1270] * templateSh[158];
		conv += panelSh[p_idx + 1271] * templateSh[157];
		conv += panelSh[p_idx + 1272] * templateSh[156];
		conv += panelSh[p_idx + 1273] * templateSh[155];
		conv += panelSh[p_idx + 1274] * templateSh[154];
		conv += panelSh[p_idx + 1275] * templateSh[153];
		conv += panelSh[p_idx + 1276] * templateSh[152];
		conv += panelSh[p_idx + 1277] * templateSh[151];
		conv += panelSh[p_idx + 1278] * templateSh[150];
		conv += panelSh[p_idx + 1279] * templateSh[149];
		conv += panelSh[p_idx + 1280] * templateSh[148];
		conv += panelSh[p_idx + 1281] * templateSh[147];
		conv += panelSh[p_idx + 1282] * templateSh[146];
		conv += panelSh[p_idx + 1283] * templateSh[145];
		conv += panelSh[p_idx + 1284] * templateSh[144];
		conv += panelSh[p_idx + 1285] * templateSh[143];
		conv += panelSh[p_idx + 1286] * templateSh[142];
		conv += panelSh[p_idx + 1287] * templateSh[141];
		conv += panelSh[p_idx + 1288] * templateSh[140];
		conv += panelSh[p_idx + 1289] * templateSh[139];
		conv += panelSh[p_idx + 1290] * templateSh[138];
		conv += panelSh[p_idx + 1291] * templateSh[137];
		conv += panelSh[p_idx + 1292] * templateSh[136];
		conv += panelSh[p_idx + 1293] * templateSh[135];
		conv += panelSh[p_idx + 1294] * templateSh[134];
		conv += panelSh[p_idx + 1295] * templateSh[133];
		conv += panelSh[p_idx + 1296] * templateSh[132];
		conv += panelSh[p_idx + 1297] * templateSh[131];
		conv += panelSh[p_idx + 1298] * templateSh[130];
		conv += panelSh[p_idx + 1299] * templateSh[129];
		conv += panelSh[p_idx + 1300] * templateSh[128];
		conv += panelSh[p_idx + 1316] * templateSh[127];
		conv += panelSh[p_idx + 1317] * templateSh[126];
		conv += panelSh[p_idx + 1318] * templateSh[125];
		conv += panelSh[p_idx + 1319] * templateSh[124];
		conv += panelSh[p_idx + 1320] * templateSh[123];
		conv += panelSh[p_idx + 1321] * templateSh[122];
		conv += panelSh[p_idx + 1322] * templateSh[121];
		conv += panelSh[p_idx + 1323] * templateSh[120];
		conv += panelSh[p_idx + 1324] * templateSh[119];
		conv += panelSh[p_idx + 1325] * templateSh[118];
		conv += panelSh[p_idx + 1326] * templateSh[117];
		conv += panelSh[p_idx + 1327] * templateSh[116];
		conv += panelSh[p_idx + 1328] * templateSh[115];
		conv += panelSh[p_idx + 1329] * templateSh[114];
		conv += panelSh[p_idx + 1330] * templateSh[113];
		conv += panelSh[p_idx + 1331] * templateSh[112];
		conv += panelSh[p_idx + 1332] * templateSh[111];
		conv += panelSh[p_idx + 1333] * templateSh[110];
		conv += panelSh[p_idx + 1334] * templateSh[109];
		conv += panelSh[p_idx + 1335] * templateSh[108];
		conv += panelSh[p_idx + 1336] * templateSh[107];
		conv += panelSh[p_idx + 1337] * templateSh[106];
		conv += panelSh[p_idx + 1338] * templateSh[105];
		conv += panelSh[p_idx + 1339] * templateSh[104];
		conv += panelSh[p_idx + 1340] * templateSh[103];
		conv += panelSh[p_idx + 1341] * templateSh[102];
		conv += panelSh[p_idx + 1342] * templateSh[101];
		conv += panelSh[p_idx + 1343] * templateSh[100];
		conv += panelSh[p_idx + 1344] * templateSh[99];
		conv += panelSh[p_idx + 1345] * templateSh[98];
		conv += panelSh[p_idx + 1346] * templateSh[97];
		conv += panelSh[p_idx + 1347] * templateSh[96];
		conv += panelSh[p_idx + 1363] * templateSh[95];
		conv += panelSh[p_idx + 1364] * templateSh[94];
		conv += panelSh[p_idx + 1365] * templateSh[93];
		conv += panelSh[p_idx + 1366] * templateSh[92];
		conv += panelSh[p_idx + 1367] * templateSh[91];
		conv += panelSh[p_idx + 1368] * templateSh[90];
		conv += panelSh[p_idx + 1369] * templateSh[89];
		conv += panelSh[p_idx + 1370] * templateSh[88];
		conv += panelSh[p_idx + 1371] * templateSh[87];
		conv += panelSh[p_idx + 1372] * templateSh[86];
		conv += panelSh[p_idx + 1373] * templateSh[85];
		conv += panelSh[p_idx + 1374] * templateSh[84];
		conv += panelSh[p_idx + 1375] * templateSh[83];
		conv += panelSh[p_idx + 1376] * templateSh[82];
		conv += panelSh[p_idx + 1377] * templateSh[81];
		conv += panelSh[p_idx + 1378] * templateSh[80];
		conv += panelSh[p_idx + 1379] * templateSh[79];
		conv += panelSh[p_idx + 1380] * templateSh[78];
		conv += panelSh[p_idx + 1381] * templateSh[77];
		conv += panelSh[p_idx + 1382] * templateSh[76];
		conv += panelSh[p_idx + 1383] * templateSh[75];
		conv += panelSh[p_idx + 1384] * templateSh[74];
		conv += panelSh[p_idx + 1385] * templateSh[73];
		conv += panelSh[p_idx + 1386] * templateSh[72];
		conv += panelSh[p_idx + 1387] * templateSh[71];
		conv += panelSh[p_idx + 1388] * templateSh[70];
		conv += panelSh[p_idx + 1389] * templateSh[69];
		conv += panelSh[p_idx + 1390] * templateSh[68];
		conv += panelSh[p_idx + 1391] * templateSh[67];
		conv += panelSh[p_idx + 1392] * templateSh[66];
		conv += panelSh[p_idx + 1393] * templateSh[65];
		conv += panelSh[p_idx + 1394] * templateSh[64];
		conv += panelSh[p_idx + 1410] * templateSh[63];
		conv += panelSh[p_idx + 1411] * templateSh[62];
		conv += panelSh[p_idx + 1412] * templateSh[61];
		conv += panelSh[p_idx + 1413] * templateSh[60];
		conv += panelSh[p_idx + 1414] * templateSh[59];
		conv += panelSh[p_idx + 1415] * templateSh[58];
		conv += panelSh[p_idx + 1416] * templateSh[57];
		conv += panelSh[p_idx + 1417] * templateSh[56];
		conv += panelSh[p_idx + 1418] * templateSh[55];
		conv += panelSh[p_idx + 1419] * templateSh[54];
		conv += panelSh[p_idx + 1420] * templateSh[53];
		conv += panelSh[p_idx + 1421] * templateSh[52];
		conv += panelSh[p_idx + 1422] * templateSh[51];
		conv += panelSh[p_idx + 1423] * templateSh[50];
		conv += panelSh[p_idx + 1424] * templateSh[49];
		conv += panelSh[p_idx + 1425] * templateSh[48];
		conv += panelSh[p_idx + 1426] * templateSh[47];
		conv += panelSh[p_idx + 1427] * templateSh[46];
		conv += panelSh[p_idx + 1428] * templateSh[45];
		conv += panelSh[p_idx + 1429] * templateSh[44];
		conv += panelSh[p_idx + 1430] * templateSh[43];
		conv += panelSh[p_idx + 1431] * templateSh[42];
		conv += panelSh[p_idx + 1432] * templateSh[41];
		conv += panelSh[p_idx + 1433] * templateSh[40];
		conv += panelSh[p_idx + 1434] * templateSh[39];
		conv += panelSh[p_idx + 1435] * templateSh[38];
		conv += panelSh[p_idx + 1436] * templateSh[37];
		conv += panelSh[p_idx + 1437] * templateSh[36];
		conv += panelSh[p_idx + 1438] * templateSh[35];
		conv += panelSh[p_idx + 1439] * templateSh[34];
		conv += panelSh[p_idx + 1440] * templateSh[33];
		conv += panelSh[p_idx + 1441] * templateSh[32];
		conv += panelSh[p_idx + 1457] * templateSh[31];
		conv += panelSh[p_idx + 1458] * templateSh[30];
		conv += panelSh[p_idx + 1459] * templateSh[29];
		conv += panelSh[p_idx + 1460] * templateSh[28];
		conv += panelSh[p_idx + 1461] * templateSh[27];
		conv += panelSh[p_idx + 1462] * templateSh[26];
		conv += panelSh[p_idx + 1463] * templateSh[25];
		conv += panelSh[p_idx + 1464] * templateSh[24];
		conv += panelSh[p_idx + 1465] * templateSh[23];
		conv += panelSh[p_idx + 1466] * templateSh[22];
		conv += panelSh[p_idx + 1467] * templateSh[21];
		conv += panelSh[p_idx + 1468] * templateSh[20];
		conv += panelSh[p_idx + 1469] * templateSh[19];
		conv += panelSh[p_idx + 1470] * templateSh[18];
		conv += panelSh[p_idx + 1471] * templateSh[17];
		conv += panelSh[p_idx + 1472] * templateSh[16];
		conv += panelSh[p_idx + 1473] * templateSh[15];
		conv += panelSh[p_idx + 1474] * templateSh[14];
		conv += panelSh[p_idx + 1475] * templateSh[13];
		conv += panelSh[p_idx + 1476] * templateSh[12];
		conv += panelSh[p_idx + 1477] * templateSh[11];
		conv += panelSh[p_idx + 1478] * templateSh[10];
		conv += panelSh[p_idx + 1479] * templateSh[9];
		conv += panelSh[p_idx + 1480] * templateSh[8];
		conv += panelSh[p_idx + 1481] * templateSh[7];
		conv += panelSh[p_idx + 1482] * templateSh[6];
		conv += panelSh[p_idx + 1483] * templateSh[5];
		conv += panelSh[p_idx + 1484] * templateSh[4];
		conv += panelSh[p_idx + 1485] * templateSh[3];
		conv += panelSh[p_idx + 1486] * templateSh[2];
		conv += panelSh[p_idx + 1487] * templateSh[1];
		conv += panelSh[p_idx + 1488] * templateSh[0];
	outputDev[(u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW)] = conv;
}
#ifndef NO_SINGLE_PREC 
template __global__ void convolution2d_kernel_32x32<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void convolution2d_kernel_32x32<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

