// This file is generated automatically. 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_2x2 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[289];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<17; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<17; i+=16) {
			panelSh[IMUL(j, 17) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[4];
	if (threadIdx.x < 2 && threadIdx.y < 2) {
		const int jtwi = IMUL(threadIdx.y, 2) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 17);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/4;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_2x2<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_2x2<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_3x3 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[324];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<18; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<18; i+=16) {
			panelSh[IMUL(j, 18) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[9];
	if (threadIdx.x < 3 && threadIdx.y < 3) {
		const int jtwi = IMUL(threadIdx.y, 3) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 18);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/9;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_3x3<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_3x3<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_4x4 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[361];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<19; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<19; i+=16) {
			panelSh[IMUL(j, 19) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[16];
	if (threadIdx.x < 4 && threadIdx.y < 4) {
		const int jtwi = IMUL(threadIdx.y, 4) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 19);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/16;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_4x4<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_4x4<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_5x5 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[400];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<20; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<20; i+=16) {
			panelSh[IMUL(j, 20) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[25];
	if (threadIdx.x < 5 && threadIdx.y < 5) {
		const int jtwi = IMUL(threadIdx.y, 5) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 20);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/25;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_5x5<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_5x5<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_6x6 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[441];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<21; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<21; i+=16) {
			panelSh[IMUL(j, 21) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[36];
	if (threadIdx.x < 6 && threadIdx.y < 6) {
		const int jtwi = IMUL(threadIdx.y, 6) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 21);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/36;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_6x6<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_6x6<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_7x7 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[484];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<22; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<22; i+=16) {
			panelSh[IMUL(j, 22) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[49];
	if (threadIdx.x < 7 && threadIdx.y < 7) {
		const int jtwi = IMUL(threadIdx.y, 7) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 22);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/49;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_7x7<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_7x7<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_8x8 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[529];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<23; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<23; i+=16) {
			panelSh[IMUL(j, 23) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[64];
	if (threadIdx.x < 8 && threadIdx.y < 8) {
		const int jtwi = IMUL(threadIdx.y, 8) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 23);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/64;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_8x8<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_8x8<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_9x9 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[576];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<24; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<24; i+=16) {
			panelSh[IMUL(j, 24) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[81];
	if (threadIdx.x < 9 && threadIdx.y < 9) {
		const int jtwi = IMUL(threadIdx.y, 9) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 24);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/81;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_9x9<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_9x9<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_10x10 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[625];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<25; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<25; i+=16) {
			panelSh[IMUL(j, 25) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[100];
	if (threadIdx.x < 10 && threadIdx.y < 10) {
		const int jtwi = IMUL(threadIdx.y, 10) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 25);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/100;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_10x10<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_10x10<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_11x11 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[676];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<26; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<26; i+=16) {
			panelSh[IMUL(j, 26) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[121];
	if (threadIdx.x < 11 && threadIdx.y < 11) {
		const int jtwi = IMUL(threadIdx.y, 11) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 26);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/121;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_11x11<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_11x11<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_12x12 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[729];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<27; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<27; i+=16) {
			panelSh[IMUL(j, 27) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[144];
	if (threadIdx.x < 12 && threadIdx.y < 12) {
		const int jtwi = IMUL(threadIdx.y, 12) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 27);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/144;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_12x12<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_12x12<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_13x13 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[784];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<28; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<28; i+=16) {
			panelSh[IMUL(j, 28) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[169];
	if (threadIdx.x < 13 && threadIdx.y < 13) {
		const int jtwi = IMUL(threadIdx.y, 13) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 28);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/169;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_13x13<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_13x13<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_14x14 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[841];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<29; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<29; i+=16) {
			panelSh[IMUL(j, 29) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[196];
	if (threadIdx.x < 14 && threadIdx.y < 14) {
		const int jtwi = IMUL(threadIdx.y, 14) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 29);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/196;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_14x14<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_14x14<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_15x15 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[900];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<30; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<30; i+=16) {
			panelSh[IMUL(j, 30) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[225];
	if (threadIdx.x < 15 && threadIdx.y < 15) {
		const int jtwi = IMUL(threadIdx.y, 15) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 30);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/225;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_15x15<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_15x15<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_16x16 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[961];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<31; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<31; i+=16) {
			panelSh[IMUL(j, 31) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[256];
	if (threadIdx.x < 16 && threadIdx.y < 16) {
		const int jtwi = IMUL(threadIdx.y, 16) + threadIdx.x;
		templateSh[jtwi] = templateDev[jtwi]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 31);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/256;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_16x16<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_16x16<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_17x17 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1024];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<32; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<32; i+=16) {
			panelSh[IMUL(j, 32) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[289];
	for (int j=threadIdx.y; j<17; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<17; i+=16) {
			const int jtwi = IMUL(j, 17) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 32);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/289;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_17x17<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_17x17<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_18x18 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1089];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<33; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<33; i+=16) {
			panelSh[IMUL(j, 33) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[324];
	for (int j=threadIdx.y; j<18; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<18; i+=16) {
			const int jtwi = IMUL(j, 18) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 33);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/324;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_18x18<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_18x18<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_19x19 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1156];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<34; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<34; i+=16) {
			panelSh[IMUL(j, 34) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[361];
	for (int j=threadIdx.y; j<19; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<19; i+=16) {
			const int jtwi = IMUL(j, 19) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 34);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/361;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_19x19<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_19x19<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_20x20 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1225];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<35; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<35; i+=16) {
			panelSh[IMUL(j, 35) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[400];
	for (int j=threadIdx.y; j<20; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<20; i+=16) {
			const int jtwi = IMUL(j, 20) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 35);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/400;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_20x20<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_20x20<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_21x21 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1296];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<36; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<36; i+=16) {
			panelSh[IMUL(j, 36) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[441];
	for (int j=threadIdx.y; j<21; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<21; i+=16) {
			const int jtwi = IMUL(j, 21) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 36);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/441;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_21x21<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_21x21<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_22x22 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1369];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<37; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<37; i+=16) {
			panelSh[IMUL(j, 37) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[484];
	for (int j=threadIdx.y; j<22; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<22; i+=16) {
			const int jtwi = IMUL(j, 22) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 37);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 747];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 791];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 795];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 796];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 797];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/484;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_22x22<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_22x22<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_23x23 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1444];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<38; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<38; i+=16) {
			panelSh[IMUL(j, 38) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[529];
	for (int j=threadIdx.y; j<23; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<23; i+=16) {
			const int jtwi = IMUL(j, 23) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 38);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 773];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 805];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 806];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 807];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 808];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 809];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 851];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 852];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 853];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/529;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_23x23<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_23x23<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_24x24 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1521];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<39; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<39; i+=16) {
			panelSh[IMUL(j, 39) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[576];
	for (int j=threadIdx.y; j<24; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<24; i+=16) {
			const int jtwi = IMUL(j, 24) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 39);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 747];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 791];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 795];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 796];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 797];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 825];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 826];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 827];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 831];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 832];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 833];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 834];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 835];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 865];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 866];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 867];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 868];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 869];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 870];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 877];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 878];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 879];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 909];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 910];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 911];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 912];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 913];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 914];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 916];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 917];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 918];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 919];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/576;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_24x24<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_24x24<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_25x25 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1600];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<40; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<40; i+=16) {
			panelSh[IMUL(j, 40) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[625];
	for (int j=threadIdx.y; j<25; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<25; i+=16) {
			const int jtwi = IMUL(j, 25) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 40);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 773];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 805];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 806];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 807];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 808];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 809];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 851];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 852];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 853];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 887];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 888];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 889];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 890];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 891];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 892];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 893];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 894];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 895];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 896];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 923];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 928];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 929];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 930];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 931];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 932];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 933];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 934];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 935];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 936];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 937];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 938];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 939];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 940];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 941];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 942];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 943];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 944];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 960];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 961];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 962];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 963];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 964];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 965];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 972];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 973];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 974];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 975];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 976];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 977];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 978];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 979];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 980];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 981];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 982];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 983];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 984];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/625;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_25x25<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_25x25<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_26x26 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1681];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<41; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<41; i+=16) {
			panelSh[IMUL(j, 41) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[676];
	for (int j=threadIdx.y; j<26; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<26; i+=16) {
			const int jtwi = IMUL(j, 26) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 41);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 83];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 747];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 791];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 795];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 796];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 797];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 825];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 826];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 827];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 831];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 832];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 833];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 834];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 835];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 865];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 866];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 867];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 868];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 869];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 870];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 877];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 878];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 879];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 909];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 910];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 911];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 912];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 913];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 914];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 916];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 917];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 918];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 919];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 923];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 943];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 944];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 951];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 952];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 953];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 954];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 955];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 956];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 957];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 958];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 959];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 960];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 961];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 962];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 963];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 964];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 965];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 984];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 985];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 986];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 987];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 988];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 989];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 997];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 998];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 999];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1000];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1001];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1002];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1003];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1004];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1005];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1006];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1007];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1025];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1026];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1027];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1028];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1029];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1030];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1031];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1032];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1033];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1034];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1035];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1041];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1042];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1043];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1044];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1045];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1046];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1047];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1048];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1049];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1050];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/676;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_26x26<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_26x26<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_27x27 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1764];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<42; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<42; i+=16) {
			panelSh[IMUL(j, 42) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[729];
	for (int j=threadIdx.y; j<27; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<27; i+=16) {
			const int jtwi = IMUL(j, 27) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 42);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 126];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 127];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 128];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 773];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 805];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 806];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 807];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 808];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 809];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 851];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 852];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 853];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 865];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 866];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 887];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 888];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 889];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 890];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 891];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 892];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 893];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 894];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 895];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 896];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 928];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 929];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 930];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 931];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 932];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 933];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 934];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 935];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 936];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 937];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 938];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 939];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 940];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 941];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 942];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 943];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 944];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 972];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 973];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 974];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 975];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 976];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 977];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 978];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 979];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 980];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 981];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 982];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 983];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 984];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 985];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 986];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 987];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 988];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 989];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1010];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1011];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1015];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1016];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1017];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1018];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1019];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1020];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1021];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1022];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1023];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1024];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1025];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1026];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1027];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1028];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1029];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1030];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1031];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1032];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1033];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1034];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1050];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1051];
		corr   += im * templateSh[676];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1052];
		corr   += im * templateSh[677];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1053];
		corr   += im * templateSh[678];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1054];
		corr   += im * templateSh[679];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1055];
		corr   += im * templateSh[680];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1056];
		corr   += im * templateSh[681];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1057];
		corr   += im * templateSh[682];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1058];
		corr   += im * templateSh[683];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1059];
		corr   += im * templateSh[684];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1060];
		corr   += im * templateSh[685];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1061];
		corr   += im * templateSh[686];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1062];
		corr   += im * templateSh[687];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1063];
		corr   += im * templateSh[688];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1064];
		corr   += im * templateSh[689];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1065];
		corr   += im * templateSh[690];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1066];
		corr   += im * templateSh[691];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1067];
		corr   += im * templateSh[692];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1068];
		corr   += im * templateSh[693];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1069];
		corr   += im * templateSh[694];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1070];
		corr   += im * templateSh[695];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1071];
		corr   += im * templateSh[696];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1072];
		corr   += im * templateSh[697];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1073];
		corr   += im * templateSh[698];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1074];
		corr   += im * templateSh[699];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1075];
		corr   += im * templateSh[700];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1076];
		corr   += im * templateSh[701];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1092];
		corr   += im * templateSh[702];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1093];
		corr   += im * templateSh[703];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1094];
		corr   += im * templateSh[704];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1095];
		corr   += im * templateSh[705];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1096];
		corr   += im * templateSh[706];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1097];
		corr   += im * templateSh[707];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1098];
		corr   += im * templateSh[708];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1099];
		corr   += im * templateSh[709];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1100];
		corr   += im * templateSh[710];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1101];
		corr   += im * templateSh[711];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1102];
		corr   += im * templateSh[712];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1103];
		corr   += im * templateSh[713];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1104];
		corr   += im * templateSh[714];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1105];
		corr   += im * templateSh[715];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1106];
		corr   += im * templateSh[716];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1107];
		corr   += im * templateSh[717];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1108];
		corr   += im * templateSh[718];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1109];
		corr   += im * templateSh[719];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1110];
		corr   += im * templateSh[720];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1111];
		corr   += im * templateSh[721];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1112];
		corr   += im * templateSh[722];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1113];
		corr   += im * templateSh[723];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1114];
		corr   += im * templateSh[724];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1115];
		corr   += im * templateSh[725];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1116];
		corr   += im * templateSh[726];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1117];
		corr   += im * templateSh[727];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1118];
		corr   += im * templateSh[728];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/729;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_27x27<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_27x27<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_28x28 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1849];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<43; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<43; i+=16) {
			panelSh[IMUL(j, 43) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[784];
	for (int j=threadIdx.y; j<28; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<28; i+=16) {
			const int jtwi = IMUL(j, 28) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 43);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 129];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 130];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 131];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 175];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 747];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 791];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 795];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 796];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 797];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 825];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 826];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 827];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 831];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 832];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 833];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 834];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 835];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 865];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 866];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 867];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 868];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 869];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 870];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 877];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 878];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 879];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 887];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 909];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 910];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 911];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 912];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 913];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 914];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 916];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 917];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 918];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 919];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 923];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 928];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 929];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 930];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 951];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 952];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 953];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 954];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 955];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 956];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 957];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 958];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 959];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 960];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 961];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 962];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 963];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 964];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 965];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 972];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 973];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 989];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 997];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 998];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 999];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1000];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1001];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1002];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1003];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1004];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1005];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1006];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1007];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1010];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1011];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1015];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1016];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1032];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1033];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1034];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1035];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[676];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[677];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[678];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[679];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[680];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1041];
		corr   += im * templateSh[681];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1042];
		corr   += im * templateSh[682];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1043];
		corr   += im * templateSh[683];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1044];
		corr   += im * templateSh[684];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1045];
		corr   += im * templateSh[685];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1046];
		corr   += im * templateSh[686];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1047];
		corr   += im * templateSh[687];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1048];
		corr   += im * templateSh[688];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1049];
		corr   += im * templateSh[689];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1050];
		corr   += im * templateSh[690];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1051];
		corr   += im * templateSh[691];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1052];
		corr   += im * templateSh[692];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1053];
		corr   += im * templateSh[693];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1054];
		corr   += im * templateSh[694];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1055];
		corr   += im * templateSh[695];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1056];
		corr   += im * templateSh[696];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1057];
		corr   += im * templateSh[697];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1058];
		corr   += im * templateSh[698];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1059];
		corr   += im * templateSh[699];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1075];
		corr   += im * templateSh[700];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1076];
		corr   += im * templateSh[701];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1077];
		corr   += im * templateSh[702];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1078];
		corr   += im * templateSh[703];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1079];
		corr   += im * templateSh[704];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1080];
		corr   += im * templateSh[705];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1081];
		corr   += im * templateSh[706];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1082];
		corr   += im * templateSh[707];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1083];
		corr   += im * templateSh[708];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1084];
		corr   += im * templateSh[709];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1085];
		corr   += im * templateSh[710];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1086];
		corr   += im * templateSh[711];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1087];
		corr   += im * templateSh[712];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1088];
		corr   += im * templateSh[713];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1089];
		corr   += im * templateSh[714];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1090];
		corr   += im * templateSh[715];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1091];
		corr   += im * templateSh[716];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1092];
		corr   += im * templateSh[717];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1093];
		corr   += im * templateSh[718];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1094];
		corr   += im * templateSh[719];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1095];
		corr   += im * templateSh[720];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1096];
		corr   += im * templateSh[721];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1097];
		corr   += im * templateSh[722];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1098];
		corr   += im * templateSh[723];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1099];
		corr   += im * templateSh[724];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1100];
		corr   += im * templateSh[725];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1101];
		corr   += im * templateSh[726];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1102];
		corr   += im * templateSh[727];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1118];
		corr   += im * templateSh[728];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1119];
		corr   += im * templateSh[729];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1120];
		corr   += im * templateSh[730];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1121];
		corr   += im * templateSh[731];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1122];
		corr   += im * templateSh[732];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1123];
		corr   += im * templateSh[733];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1124];
		corr   += im * templateSh[734];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1125];
		corr   += im * templateSh[735];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1126];
		corr   += im * templateSh[736];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1127];
		corr   += im * templateSh[737];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1128];
		corr   += im * templateSh[738];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1129];
		corr   += im * templateSh[739];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1130];
		corr   += im * templateSh[740];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1131];
		corr   += im * templateSh[741];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1132];
		corr   += im * templateSh[742];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1133];
		corr   += im * templateSh[743];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1134];
		corr   += im * templateSh[744];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1135];
		corr   += im * templateSh[745];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1136];
		corr   += im * templateSh[746];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1137];
		corr   += im * templateSh[747];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1138];
		corr   += im * templateSh[748];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1139];
		corr   += im * templateSh[749];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1140];
		corr   += im * templateSh[750];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1141];
		corr   += im * templateSh[751];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1142];
		corr   += im * templateSh[752];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1143];
		corr   += im * templateSh[753];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1144];
		corr   += im * templateSh[754];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1145];
		corr   += im * templateSh[755];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1161];
		corr   += im * templateSh[756];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1162];
		corr   += im * templateSh[757];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1163];
		corr   += im * templateSh[758];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1164];
		corr   += im * templateSh[759];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1165];
		corr   += im * templateSh[760];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1166];
		corr   += im * templateSh[761];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1167];
		corr   += im * templateSh[762];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1168];
		corr   += im * templateSh[763];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1169];
		corr   += im * templateSh[764];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1170];
		corr   += im * templateSh[765];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1171];
		corr   += im * templateSh[766];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1172];
		corr   += im * templateSh[767];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1173];
		corr   += im * templateSh[768];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1174];
		corr   += im * templateSh[769];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1175];
		corr   += im * templateSh[770];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1176];
		corr   += im * templateSh[771];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1177];
		corr   += im * templateSh[772];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1178];
		corr   += im * templateSh[773];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1179];
		corr   += im * templateSh[774];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1180];
		corr   += im * templateSh[775];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1181];
		corr   += im * templateSh[776];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1182];
		corr   += im * templateSh[777];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1183];
		corr   += im * templateSh[778];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1184];
		corr   += im * templateSh[779];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1185];
		corr   += im * templateSh[780];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1186];
		corr   += im * templateSh[781];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1187];
		corr   += im * templateSh[782];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1188];
		corr   += im * templateSh[783];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/784;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_28x28<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_28x28<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_29x29 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[1936];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<44; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<44; i+=16) {
			panelSh[IMUL(j, 44) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[841];
	for (int j=threadIdx.y; j<29; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<29; i+=16) {
			const int jtwi = IMUL(j, 29) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 44);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 176];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 177];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 178];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 179];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 773];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 795];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 796];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 797];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 805];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 806];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 807];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 808];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 809];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 851];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 852];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 853];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 887];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 888];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 889];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 890];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 891];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 892];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 893];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 894];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 895];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 896];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 928];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 929];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 930];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 931];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 932];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 933];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 934];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 935];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 936];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 937];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 938];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 939];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 940];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 941];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 942];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 943];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 944];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 951];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 952];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 972];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 973];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 974];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 975];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 976];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 977];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 978];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 979];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 980];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 981];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 982];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 983];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 984];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 985];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 986];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 987];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 988];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 989];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1015];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1016];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1017];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1018];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1019];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1020];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1021];
		corr   += im * templateSh[676];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1022];
		corr   += im * templateSh[677];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1023];
		corr   += im * templateSh[678];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1024];
		corr   += im * templateSh[679];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1025];
		corr   += im * templateSh[680];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1026];
		corr   += im * templateSh[681];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1027];
		corr   += im * templateSh[682];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1028];
		corr   += im * templateSh[683];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1029];
		corr   += im * templateSh[684];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1030];
		corr   += im * templateSh[685];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1031];
		corr   += im * templateSh[686];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1032];
		corr   += im * templateSh[687];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1033];
		corr   += im * templateSh[688];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1034];
		corr   += im * templateSh[689];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1035];
		corr   += im * templateSh[690];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[691];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[692];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[693];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[694];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[695];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1056];
		corr   += im * templateSh[696];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1057];
		corr   += im * templateSh[697];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1058];
		corr   += im * templateSh[698];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1059];
		corr   += im * templateSh[699];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1060];
		corr   += im * templateSh[700];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1061];
		corr   += im * templateSh[701];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1062];
		corr   += im * templateSh[702];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1063];
		corr   += im * templateSh[703];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1064];
		corr   += im * templateSh[704];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1065];
		corr   += im * templateSh[705];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1066];
		corr   += im * templateSh[706];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1067];
		corr   += im * templateSh[707];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1068];
		corr   += im * templateSh[708];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1069];
		corr   += im * templateSh[709];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1070];
		corr   += im * templateSh[710];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1071];
		corr   += im * templateSh[711];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1072];
		corr   += im * templateSh[712];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1073];
		corr   += im * templateSh[713];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1074];
		corr   += im * templateSh[714];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1075];
		corr   += im * templateSh[715];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1076];
		corr   += im * templateSh[716];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1077];
		corr   += im * templateSh[717];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1078];
		corr   += im * templateSh[718];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1079];
		corr   += im * templateSh[719];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1080];
		corr   += im * templateSh[720];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1081];
		corr   += im * templateSh[721];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1082];
		corr   += im * templateSh[722];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1083];
		corr   += im * templateSh[723];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1084];
		corr   += im * templateSh[724];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1100];
		corr   += im * templateSh[725];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1101];
		corr   += im * templateSh[726];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1102];
		corr   += im * templateSh[727];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1103];
		corr   += im * templateSh[728];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1104];
		corr   += im * templateSh[729];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1105];
		corr   += im * templateSh[730];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1106];
		corr   += im * templateSh[731];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1107];
		corr   += im * templateSh[732];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1108];
		corr   += im * templateSh[733];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1109];
		corr   += im * templateSh[734];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1110];
		corr   += im * templateSh[735];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1111];
		corr   += im * templateSh[736];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1112];
		corr   += im * templateSh[737];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1113];
		corr   += im * templateSh[738];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1114];
		corr   += im * templateSh[739];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1115];
		corr   += im * templateSh[740];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1116];
		corr   += im * templateSh[741];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1117];
		corr   += im * templateSh[742];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1118];
		corr   += im * templateSh[743];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1119];
		corr   += im * templateSh[744];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1120];
		corr   += im * templateSh[745];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1121];
		corr   += im * templateSh[746];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1122];
		corr   += im * templateSh[747];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1123];
		corr   += im * templateSh[748];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1124];
		corr   += im * templateSh[749];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1125];
		corr   += im * templateSh[750];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1126];
		corr   += im * templateSh[751];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1127];
		corr   += im * templateSh[752];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1128];
		corr   += im * templateSh[753];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1144];
		corr   += im * templateSh[754];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1145];
		corr   += im * templateSh[755];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1146];
		corr   += im * templateSh[756];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1147];
		corr   += im * templateSh[757];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1148];
		corr   += im * templateSh[758];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1149];
		corr   += im * templateSh[759];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1150];
		corr   += im * templateSh[760];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1151];
		corr   += im * templateSh[761];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1152];
		corr   += im * templateSh[762];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1153];
		corr   += im * templateSh[763];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1154];
		corr   += im * templateSh[764];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1155];
		corr   += im * templateSh[765];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1156];
		corr   += im * templateSh[766];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1157];
		corr   += im * templateSh[767];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1158];
		corr   += im * templateSh[768];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1159];
		corr   += im * templateSh[769];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1160];
		corr   += im * templateSh[770];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1161];
		corr   += im * templateSh[771];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1162];
		corr   += im * templateSh[772];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1163];
		corr   += im * templateSh[773];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1164];
		corr   += im * templateSh[774];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1165];
		corr   += im * templateSh[775];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1166];
		corr   += im * templateSh[776];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1167];
		corr   += im * templateSh[777];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1168];
		corr   += im * templateSh[778];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1169];
		corr   += im * templateSh[779];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1170];
		corr   += im * templateSh[780];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1171];
		corr   += im * templateSh[781];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1172];
		corr   += im * templateSh[782];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1188];
		corr   += im * templateSh[783];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1189];
		corr   += im * templateSh[784];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1190];
		corr   += im * templateSh[785];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1191];
		corr   += im * templateSh[786];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1192];
		corr   += im * templateSh[787];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1193];
		corr   += im * templateSh[788];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1194];
		corr   += im * templateSh[789];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1195];
		corr   += im * templateSh[790];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1196];
		corr   += im * templateSh[791];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1197];
		corr   += im * templateSh[792];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1198];
		corr   += im * templateSh[793];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1199];
		corr   += im * templateSh[794];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1200];
		corr   += im * templateSh[795];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1201];
		corr   += im * templateSh[796];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1202];
		corr   += im * templateSh[797];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1203];
		corr   += im * templateSh[798];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1204];
		corr   += im * templateSh[799];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1205];
		corr   += im * templateSh[800];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1206];
		corr   += im * templateSh[801];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1207];
		corr   += im * templateSh[802];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1208];
		corr   += im * templateSh[803];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1209];
		corr   += im * templateSh[804];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1210];
		corr   += im * templateSh[805];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1211];
		corr   += im * templateSh[806];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1212];
		corr   += im * templateSh[807];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1213];
		corr   += im * templateSh[808];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1214];
		corr   += im * templateSh[809];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1215];
		corr   += im * templateSh[810];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1216];
		corr   += im * templateSh[811];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1232];
		corr   += im * templateSh[812];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1233];
		corr   += im * templateSh[813];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1234];
		corr   += im * templateSh[814];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1235];
		corr   += im * templateSh[815];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1236];
		corr   += im * templateSh[816];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1237];
		corr   += im * templateSh[817];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1238];
		corr   += im * templateSh[818];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1239];
		corr   += im * templateSh[819];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1240];
		corr   += im * templateSh[820];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1241];
		corr   += im * templateSh[821];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1242];
		corr   += im * templateSh[822];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1243];
		corr   += im * templateSh[823];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1244];
		corr   += im * templateSh[824];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1245];
		corr   += im * templateSh[825];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1246];
		corr   += im * templateSh[826];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1247];
		corr   += im * templateSh[827];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1248];
		corr   += im * templateSh[828];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1249];
		corr   += im * templateSh[829];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1250];
		corr   += im * templateSh[830];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1251];
		corr   += im * templateSh[831];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1252];
		corr   += im * templateSh[832];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1253];
		corr   += im * templateSh[833];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1254];
		corr   += im * templateSh[834];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1255];
		corr   += im * templateSh[835];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1256];
		corr   += im * templateSh[836];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1257];
		corr   += im * templateSh[837];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1258];
		corr   += im * templateSh[838];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1259];
		corr   += im * templateSh[839];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1260];
		corr   += im * templateSh[840];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/841;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_29x29<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_29x29<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_30x30 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[2025];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<45; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<45; i+=16) {
			panelSh[IMUL(j, 45) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[900];
	for (int j=threadIdx.y; j<30; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<30; i+=16) {
			const int jtwi = IMUL(j, 30) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 45);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 136];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 137];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 361];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 362];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 413];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 503];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 504];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 505];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 596];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 597];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 643];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 747];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 773];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 791];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 825];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 826];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 827];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 831];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 832];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 833];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 834];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 835];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 865];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 866];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 867];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 868];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 869];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 870];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 877];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 878];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 879];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 909];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 910];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 911];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 912];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 913];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 914];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 916];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 917];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 918];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 919];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 923];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 928];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 929];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 951];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 952];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 953];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 954];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 955];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 956];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 957];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 958];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 959];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 960];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 961];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 962];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 963];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 964];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 965];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 972];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 973];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 974];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 997];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 998];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 999];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1000];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1001];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1002];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1003];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1004];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1005];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1006];
		corr   += im * templateSh[676];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1007];
		corr   += im * templateSh[677];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[678];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[679];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1010];
		corr   += im * templateSh[680];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1011];
		corr   += im * templateSh[681];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[682];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[683];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[684];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1015];
		corr   += im * templateSh[685];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1016];
		corr   += im * templateSh[686];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1017];
		corr   += im * templateSh[687];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1018];
		corr   += im * templateSh[688];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1019];
		corr   += im * templateSh[689];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1035];
		corr   += im * templateSh[690];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[691];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[692];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[693];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[694];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[695];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1041];
		corr   += im * templateSh[696];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1042];
		corr   += im * templateSh[697];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1043];
		corr   += im * templateSh[698];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1044];
		corr   += im * templateSh[699];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1045];
		corr   += im * templateSh[700];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1046];
		corr   += im * templateSh[701];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1047];
		corr   += im * templateSh[702];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1048];
		corr   += im * templateSh[703];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1049];
		corr   += im * templateSh[704];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1050];
		corr   += im * templateSh[705];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1051];
		corr   += im * templateSh[706];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1052];
		corr   += im * templateSh[707];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1053];
		corr   += im * templateSh[708];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1054];
		corr   += im * templateSh[709];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1055];
		corr   += im * templateSh[710];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1056];
		corr   += im * templateSh[711];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1057];
		corr   += im * templateSh[712];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1058];
		corr   += im * templateSh[713];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1059];
		corr   += im * templateSh[714];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1060];
		corr   += im * templateSh[715];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1061];
		corr   += im * templateSh[716];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1062];
		corr   += im * templateSh[717];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1063];
		corr   += im * templateSh[718];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1064];
		corr   += im * templateSh[719];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1080];
		corr   += im * templateSh[720];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1081];
		corr   += im * templateSh[721];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1082];
		corr   += im * templateSh[722];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1083];
		corr   += im * templateSh[723];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1084];
		corr   += im * templateSh[724];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1085];
		corr   += im * templateSh[725];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1086];
		corr   += im * templateSh[726];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1087];
		corr   += im * templateSh[727];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1088];
		corr   += im * templateSh[728];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1089];
		corr   += im * templateSh[729];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1090];
		corr   += im * templateSh[730];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1091];
		corr   += im * templateSh[731];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1092];
		corr   += im * templateSh[732];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1093];
		corr   += im * templateSh[733];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1094];
		corr   += im * templateSh[734];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1095];
		corr   += im * templateSh[735];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1096];
		corr   += im * templateSh[736];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1097];
		corr   += im * templateSh[737];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1098];
		corr   += im * templateSh[738];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1099];
		corr   += im * templateSh[739];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1100];
		corr   += im * templateSh[740];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1101];
		corr   += im * templateSh[741];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1102];
		corr   += im * templateSh[742];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1103];
		corr   += im * templateSh[743];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1104];
		corr   += im * templateSh[744];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1105];
		corr   += im * templateSh[745];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1106];
		corr   += im * templateSh[746];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1107];
		corr   += im * templateSh[747];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1108];
		corr   += im * templateSh[748];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1109];
		corr   += im * templateSh[749];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1125];
		corr   += im * templateSh[750];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1126];
		corr   += im * templateSh[751];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1127];
		corr   += im * templateSh[752];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1128];
		corr   += im * templateSh[753];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1129];
		corr   += im * templateSh[754];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1130];
		corr   += im * templateSh[755];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1131];
		corr   += im * templateSh[756];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1132];
		corr   += im * templateSh[757];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1133];
		corr   += im * templateSh[758];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1134];
		corr   += im * templateSh[759];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1135];
		corr   += im * templateSh[760];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1136];
		corr   += im * templateSh[761];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1137];
		corr   += im * templateSh[762];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1138];
		corr   += im * templateSh[763];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1139];
		corr   += im * templateSh[764];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1140];
		corr   += im * templateSh[765];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1141];
		corr   += im * templateSh[766];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1142];
		corr   += im * templateSh[767];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1143];
		corr   += im * templateSh[768];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1144];
		corr   += im * templateSh[769];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1145];
		corr   += im * templateSh[770];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1146];
		corr   += im * templateSh[771];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1147];
		corr   += im * templateSh[772];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1148];
		corr   += im * templateSh[773];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1149];
		corr   += im * templateSh[774];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1150];
		corr   += im * templateSh[775];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1151];
		corr   += im * templateSh[776];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1152];
		corr   += im * templateSh[777];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1153];
		corr   += im * templateSh[778];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1154];
		corr   += im * templateSh[779];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1170];
		corr   += im * templateSh[780];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1171];
		corr   += im * templateSh[781];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1172];
		corr   += im * templateSh[782];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1173];
		corr   += im * templateSh[783];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1174];
		corr   += im * templateSh[784];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1175];
		corr   += im * templateSh[785];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1176];
		corr   += im * templateSh[786];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1177];
		corr   += im * templateSh[787];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1178];
		corr   += im * templateSh[788];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1179];
		corr   += im * templateSh[789];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1180];
		corr   += im * templateSh[790];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1181];
		corr   += im * templateSh[791];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1182];
		corr   += im * templateSh[792];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1183];
		corr   += im * templateSh[793];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1184];
		corr   += im * templateSh[794];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1185];
		corr   += im * templateSh[795];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1186];
		corr   += im * templateSh[796];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1187];
		corr   += im * templateSh[797];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1188];
		corr   += im * templateSh[798];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1189];
		corr   += im * templateSh[799];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1190];
		corr   += im * templateSh[800];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1191];
		corr   += im * templateSh[801];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1192];
		corr   += im * templateSh[802];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1193];
		corr   += im * templateSh[803];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1194];
		corr   += im * templateSh[804];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1195];
		corr   += im * templateSh[805];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1196];
		corr   += im * templateSh[806];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1197];
		corr   += im * templateSh[807];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1198];
		corr   += im * templateSh[808];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1199];
		corr   += im * templateSh[809];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1215];
		corr   += im * templateSh[810];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1216];
		corr   += im * templateSh[811];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1217];
		corr   += im * templateSh[812];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1218];
		corr   += im * templateSh[813];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1219];
		corr   += im * templateSh[814];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1220];
		corr   += im * templateSh[815];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1221];
		corr   += im * templateSh[816];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1222];
		corr   += im * templateSh[817];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1223];
		corr   += im * templateSh[818];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1224];
		corr   += im * templateSh[819];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1225];
		corr   += im * templateSh[820];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1226];
		corr   += im * templateSh[821];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1227];
		corr   += im * templateSh[822];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1228];
		corr   += im * templateSh[823];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1229];
		corr   += im * templateSh[824];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1230];
		corr   += im * templateSh[825];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1231];
		corr   += im * templateSh[826];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1232];
		corr   += im * templateSh[827];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1233];
		corr   += im * templateSh[828];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1234];
		corr   += im * templateSh[829];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1235];
		corr   += im * templateSh[830];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1236];
		corr   += im * templateSh[831];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1237];
		corr   += im * templateSh[832];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1238];
		corr   += im * templateSh[833];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1239];
		corr   += im * templateSh[834];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1240];
		corr   += im * templateSh[835];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1241];
		corr   += im * templateSh[836];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1242];
		corr   += im * templateSh[837];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1243];
		corr   += im * templateSh[838];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1244];
		corr   += im * templateSh[839];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1260];
		corr   += im * templateSh[840];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1261];
		corr   += im * templateSh[841];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1262];
		corr   += im * templateSh[842];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1263];
		corr   += im * templateSh[843];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1264];
		corr   += im * templateSh[844];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1265];
		corr   += im * templateSh[845];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1266];
		corr   += im * templateSh[846];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1267];
		corr   += im * templateSh[847];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1268];
		corr   += im * templateSh[848];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1269];
		corr   += im * templateSh[849];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1270];
		corr   += im * templateSh[850];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1271];
		corr   += im * templateSh[851];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1272];
		corr   += im * templateSh[852];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1273];
		corr   += im * templateSh[853];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1274];
		corr   += im * templateSh[854];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1275];
		corr   += im * templateSh[855];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1276];
		corr   += im * templateSh[856];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1277];
		corr   += im * templateSh[857];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1278];
		corr   += im * templateSh[858];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1279];
		corr   += im * templateSh[859];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1280];
		corr   += im * templateSh[860];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1281];
		corr   += im * templateSh[861];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1282];
		corr   += im * templateSh[862];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1283];
		corr   += im * templateSh[863];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1284];
		corr   += im * templateSh[864];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1285];
		corr   += im * templateSh[865];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1286];
		corr   += im * templateSh[866];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1287];
		corr   += im * templateSh[867];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1288];
		corr   += im * templateSh[868];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1289];
		corr   += im * templateSh[869];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1305];
		corr   += im * templateSh[870];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1306];
		corr   += im * templateSh[871];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1307];
		corr   += im * templateSh[872];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1308];
		corr   += im * templateSh[873];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1309];
		corr   += im * templateSh[874];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1310];
		corr   += im * templateSh[875];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1311];
		corr   += im * templateSh[876];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1312];
		corr   += im * templateSh[877];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1313];
		corr   += im * templateSh[878];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1314];
		corr   += im * templateSh[879];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1315];
		corr   += im * templateSh[880];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1316];
		corr   += im * templateSh[881];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1317];
		corr   += im * templateSh[882];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1318];
		corr   += im * templateSh[883];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1319];
		corr   += im * templateSh[884];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1320];
		corr   += im * templateSh[885];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1321];
		corr   += im * templateSh[886];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1322];
		corr   += im * templateSh[887];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1323];
		corr   += im * templateSh[888];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1324];
		corr   += im * templateSh[889];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1325];
		corr   += im * templateSh[890];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1326];
		corr   += im * templateSh[891];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1327];
		corr   += im * templateSh[892];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1328];
		corr   += im * templateSh[893];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1329];
		corr   += im * templateSh[894];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1330];
		corr   += im * templateSh[895];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1331];
		corr   += im * templateSh[896];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1332];
		corr   += im * templateSh[897];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1333];
		corr   += im * templateSh[898];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1334];
		corr   += im * templateSh[899];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/900;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_30x30<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_30x30<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_31x31 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[2116];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<46; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<46; i+=16) {
			panelSh[IMUL(j, 46) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[961];
	for (int j=threadIdx.y; j<31; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<31; i+=16) {
			const int jtwi = IMUL(j, 31) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 46);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 138];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 139];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 140];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 233];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 279];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 323];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 370];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 371];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 372];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 373];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 414];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 415];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 416];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 417];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 418];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 419];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 461];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 506];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 552];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 553];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 554];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 598];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 599];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 609];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 610];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 651];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 652];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 653];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 654];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 655];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 656];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 657];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 698];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 699];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 700];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 701];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 747];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 748];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 749];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 791];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 792];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 793];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 794];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 795];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 796];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 797];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 805];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 806];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 807];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 808];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 809];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 831];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 832];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 833];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 834];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 835];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 836];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 837];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 838];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 839];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 851];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 852];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 853];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 877];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 878];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 879];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 880];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 881];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 882];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 883];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 887];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 888];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 889];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 890];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 891];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 892];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 893];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 894];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 895];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 896];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 923];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 925];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 926];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 927];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 928];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 929];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 930];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 931];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 932];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 933];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 934];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 935];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 936];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 937];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 938];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 939];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 940];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 941];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 942];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 943];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 944];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 972];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 973];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 974];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 975];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 976];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 977];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 978];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 979];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 980];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 981];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 982];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 983];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 984];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 985];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 986];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 987];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 988];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 989];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[676];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[677];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[678];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[679];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[680];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[681];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[682];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[683];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[684];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1015];
		corr   += im * templateSh[685];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1016];
		corr   += im * templateSh[686];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1017];
		corr   += im * templateSh[687];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1018];
		corr   += im * templateSh[688];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1019];
		corr   += im * templateSh[689];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1020];
		corr   += im * templateSh[690];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1021];
		corr   += im * templateSh[691];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1022];
		corr   += im * templateSh[692];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1023];
		corr   += im * templateSh[693];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1024];
		corr   += im * templateSh[694];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1025];
		corr   += im * templateSh[695];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1026];
		corr   += im * templateSh[696];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1027];
		corr   += im * templateSh[697];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1028];
		corr   += im * templateSh[698];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1029];
		corr   += im * templateSh[699];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1030];
		corr   += im * templateSh[700];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1031];
		corr   += im * templateSh[701];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1032];
		corr   += im * templateSh[702];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1033];
		corr   += im * templateSh[703];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1034];
		corr   += im * templateSh[704];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1035];
		corr   += im * templateSh[705];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[706];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[707];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[708];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[709];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[710];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1041];
		corr   += im * templateSh[711];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1042];
		corr   += im * templateSh[712];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1058];
		corr   += im * templateSh[713];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1059];
		corr   += im * templateSh[714];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1060];
		corr   += im * templateSh[715];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1061];
		corr   += im * templateSh[716];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1062];
		corr   += im * templateSh[717];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1063];
		corr   += im * templateSh[718];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1064];
		corr   += im * templateSh[719];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1065];
		corr   += im * templateSh[720];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1066];
		corr   += im * templateSh[721];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1067];
		corr   += im * templateSh[722];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1068];
		corr   += im * templateSh[723];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1069];
		corr   += im * templateSh[724];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1070];
		corr   += im * templateSh[725];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1071];
		corr   += im * templateSh[726];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1072];
		corr   += im * templateSh[727];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1073];
		corr   += im * templateSh[728];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1074];
		corr   += im * templateSh[729];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1075];
		corr   += im * templateSh[730];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1076];
		corr   += im * templateSh[731];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1077];
		corr   += im * templateSh[732];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1078];
		corr   += im * templateSh[733];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1079];
		corr   += im * templateSh[734];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1080];
		corr   += im * templateSh[735];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1081];
		corr   += im * templateSh[736];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1082];
		corr   += im * templateSh[737];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1083];
		corr   += im * templateSh[738];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1084];
		corr   += im * templateSh[739];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1085];
		corr   += im * templateSh[740];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1086];
		corr   += im * templateSh[741];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1087];
		corr   += im * templateSh[742];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1088];
		corr   += im * templateSh[743];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1104];
		corr   += im * templateSh[744];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1105];
		corr   += im * templateSh[745];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1106];
		corr   += im * templateSh[746];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1107];
		corr   += im * templateSh[747];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1108];
		corr   += im * templateSh[748];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1109];
		corr   += im * templateSh[749];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1110];
		corr   += im * templateSh[750];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1111];
		corr   += im * templateSh[751];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1112];
		corr   += im * templateSh[752];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1113];
		corr   += im * templateSh[753];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1114];
		corr   += im * templateSh[754];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1115];
		corr   += im * templateSh[755];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1116];
		corr   += im * templateSh[756];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1117];
		corr   += im * templateSh[757];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1118];
		corr   += im * templateSh[758];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1119];
		corr   += im * templateSh[759];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1120];
		corr   += im * templateSh[760];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1121];
		corr   += im * templateSh[761];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1122];
		corr   += im * templateSh[762];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1123];
		corr   += im * templateSh[763];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1124];
		corr   += im * templateSh[764];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1125];
		corr   += im * templateSh[765];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1126];
		corr   += im * templateSh[766];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1127];
		corr   += im * templateSh[767];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1128];
		corr   += im * templateSh[768];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1129];
		corr   += im * templateSh[769];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1130];
		corr   += im * templateSh[770];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1131];
		corr   += im * templateSh[771];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1132];
		corr   += im * templateSh[772];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1133];
		corr   += im * templateSh[773];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1134];
		corr   += im * templateSh[774];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1150];
		corr   += im * templateSh[775];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1151];
		corr   += im * templateSh[776];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1152];
		corr   += im * templateSh[777];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1153];
		corr   += im * templateSh[778];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1154];
		corr   += im * templateSh[779];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1155];
		corr   += im * templateSh[780];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1156];
		corr   += im * templateSh[781];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1157];
		corr   += im * templateSh[782];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1158];
		corr   += im * templateSh[783];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1159];
		corr   += im * templateSh[784];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1160];
		corr   += im * templateSh[785];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1161];
		corr   += im * templateSh[786];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1162];
		corr   += im * templateSh[787];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1163];
		corr   += im * templateSh[788];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1164];
		corr   += im * templateSh[789];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1165];
		corr   += im * templateSh[790];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1166];
		corr   += im * templateSh[791];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1167];
		corr   += im * templateSh[792];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1168];
		corr   += im * templateSh[793];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1169];
		corr   += im * templateSh[794];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1170];
		corr   += im * templateSh[795];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1171];
		corr   += im * templateSh[796];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1172];
		corr   += im * templateSh[797];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1173];
		corr   += im * templateSh[798];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1174];
		corr   += im * templateSh[799];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1175];
		corr   += im * templateSh[800];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1176];
		corr   += im * templateSh[801];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1177];
		corr   += im * templateSh[802];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1178];
		corr   += im * templateSh[803];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1179];
		corr   += im * templateSh[804];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1180];
		corr   += im * templateSh[805];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1196];
		corr   += im * templateSh[806];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1197];
		corr   += im * templateSh[807];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1198];
		corr   += im * templateSh[808];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1199];
		corr   += im * templateSh[809];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1200];
		corr   += im * templateSh[810];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1201];
		corr   += im * templateSh[811];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1202];
		corr   += im * templateSh[812];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1203];
		corr   += im * templateSh[813];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1204];
		corr   += im * templateSh[814];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1205];
		corr   += im * templateSh[815];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1206];
		corr   += im * templateSh[816];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1207];
		corr   += im * templateSh[817];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1208];
		corr   += im * templateSh[818];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1209];
		corr   += im * templateSh[819];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1210];
		corr   += im * templateSh[820];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1211];
		corr   += im * templateSh[821];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1212];
		corr   += im * templateSh[822];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1213];
		corr   += im * templateSh[823];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1214];
		corr   += im * templateSh[824];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1215];
		corr   += im * templateSh[825];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1216];
		corr   += im * templateSh[826];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1217];
		corr   += im * templateSh[827];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1218];
		corr   += im * templateSh[828];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1219];
		corr   += im * templateSh[829];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1220];
		corr   += im * templateSh[830];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1221];
		corr   += im * templateSh[831];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1222];
		corr   += im * templateSh[832];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1223];
		corr   += im * templateSh[833];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1224];
		corr   += im * templateSh[834];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1225];
		corr   += im * templateSh[835];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1226];
		corr   += im * templateSh[836];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1242];
		corr   += im * templateSh[837];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1243];
		corr   += im * templateSh[838];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1244];
		corr   += im * templateSh[839];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1245];
		corr   += im * templateSh[840];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1246];
		corr   += im * templateSh[841];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1247];
		corr   += im * templateSh[842];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1248];
		corr   += im * templateSh[843];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1249];
		corr   += im * templateSh[844];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1250];
		corr   += im * templateSh[845];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1251];
		corr   += im * templateSh[846];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1252];
		corr   += im * templateSh[847];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1253];
		corr   += im * templateSh[848];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1254];
		corr   += im * templateSh[849];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1255];
		corr   += im * templateSh[850];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1256];
		corr   += im * templateSh[851];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1257];
		corr   += im * templateSh[852];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1258];
		corr   += im * templateSh[853];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1259];
		corr   += im * templateSh[854];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1260];
		corr   += im * templateSh[855];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1261];
		corr   += im * templateSh[856];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1262];
		corr   += im * templateSh[857];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1263];
		corr   += im * templateSh[858];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1264];
		corr   += im * templateSh[859];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1265];
		corr   += im * templateSh[860];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1266];
		corr   += im * templateSh[861];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1267];
		corr   += im * templateSh[862];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1268];
		corr   += im * templateSh[863];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1269];
		corr   += im * templateSh[864];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1270];
		corr   += im * templateSh[865];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1271];
		corr   += im * templateSh[866];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1272];
		corr   += im * templateSh[867];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1288];
		corr   += im * templateSh[868];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1289];
		corr   += im * templateSh[869];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1290];
		corr   += im * templateSh[870];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1291];
		corr   += im * templateSh[871];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1292];
		corr   += im * templateSh[872];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1293];
		corr   += im * templateSh[873];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1294];
		corr   += im * templateSh[874];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1295];
		corr   += im * templateSh[875];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1296];
		corr   += im * templateSh[876];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1297];
		corr   += im * templateSh[877];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1298];
		corr   += im * templateSh[878];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1299];
		corr   += im * templateSh[879];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1300];
		corr   += im * templateSh[880];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1301];
		corr   += im * templateSh[881];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1302];
		corr   += im * templateSh[882];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1303];
		corr   += im * templateSh[883];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1304];
		corr   += im * templateSh[884];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1305];
		corr   += im * templateSh[885];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1306];
		corr   += im * templateSh[886];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1307];
		corr   += im * templateSh[887];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1308];
		corr   += im * templateSh[888];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1309];
		corr   += im * templateSh[889];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1310];
		corr   += im * templateSh[890];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1311];
		corr   += im * templateSh[891];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1312];
		corr   += im * templateSh[892];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1313];
		corr   += im * templateSh[893];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1314];
		corr   += im * templateSh[894];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1315];
		corr   += im * templateSh[895];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1316];
		corr   += im * templateSh[896];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1317];
		corr   += im * templateSh[897];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1318];
		corr   += im * templateSh[898];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1334];
		corr   += im * templateSh[899];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1335];
		corr   += im * templateSh[900];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1336];
		corr   += im * templateSh[901];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1337];
		corr   += im * templateSh[902];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1338];
		corr   += im * templateSh[903];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1339];
		corr   += im * templateSh[904];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1340];
		corr   += im * templateSh[905];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1341];
		corr   += im * templateSh[906];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1342];
		corr   += im * templateSh[907];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1343];
		corr   += im * templateSh[908];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1344];
		corr   += im * templateSh[909];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1345];
		corr   += im * templateSh[910];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1346];
		corr   += im * templateSh[911];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1347];
		corr   += im * templateSh[912];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1348];
		corr   += im * templateSh[913];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1349];
		corr   += im * templateSh[914];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1350];
		corr   += im * templateSh[915];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1351];
		corr   += im * templateSh[916];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1352];
		corr   += im * templateSh[917];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1353];
		corr   += im * templateSh[918];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1354];
		corr   += im * templateSh[919];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1355];
		corr   += im * templateSh[920];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1356];
		corr   += im * templateSh[921];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1357];
		corr   += im * templateSh[922];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1358];
		corr   += im * templateSh[923];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1359];
		corr   += im * templateSh[924];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1360];
		corr   += im * templateSh[925];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1361];
		corr   += im * templateSh[926];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1362];
		corr   += im * templateSh[927];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1363];
		corr   += im * templateSh[928];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1364];
		corr   += im * templateSh[929];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1380];
		corr   += im * templateSh[930];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1381];
		corr   += im * templateSh[931];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1382];
		corr   += im * templateSh[932];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1383];
		corr   += im * templateSh[933];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1384];
		corr   += im * templateSh[934];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1385];
		corr   += im * templateSh[935];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1386];
		corr   += im * templateSh[936];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1387];
		corr   += im * templateSh[937];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1388];
		corr   += im * templateSh[938];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1389];
		corr   += im * templateSh[939];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1390];
		corr   += im * templateSh[940];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1391];
		corr   += im * templateSh[941];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1392];
		corr   += im * templateSh[942];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1393];
		corr   += im * templateSh[943];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1394];
		corr   += im * templateSh[944];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1395];
		corr   += im * templateSh[945];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1396];
		corr   += im * templateSh[946];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1397];
		corr   += im * templateSh[947];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1398];
		corr   += im * templateSh[948];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1399];
		corr   += im * templateSh[949];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1400];
		corr   += im * templateSh[950];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1401];
		corr   += im * templateSh[951];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1402];
		corr   += im * templateSh[952];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1403];
		corr   += im * templateSh[953];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1404];
		corr   += im * templateSh[954];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1405];
		corr   += im * templateSh[955];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1406];
		corr   += im * templateSh[956];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1407];
		corr   += im * templateSh[957];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1408];
		corr   += im * templateSh[958];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1409];
		corr   += im * templateSh[959];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1410];
		corr   += im * templateSh[960];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/961;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_31x31<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_31x31<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

template <class flccPrecision>
__global__ void lcorrelation2d_kernel_32x32 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int BW )
{
	const int u0 = IMUL(blockIdx.x, blockDim.x);
	const int v0 = IMUL(blockIdx.y, blockDim.y);
	__shared__ flccPrecision panelSh[2209];
	const int i_idx = u0 + IMUL(v0, BW);
	for (int j=threadIdx.y; j<47; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<47; i+=16) {
			panelSh[IMUL(j, 47) + i] = imageDev[i_idx + IMUL(j, BW) + i]; } }
	__shared__ flccPrecision templateSh[1024];
	for (int j=threadIdx.y; j<32; j+=16) {
		#pragma unroll
		for (int i=threadIdx.x; i<32; i+=16) {
			const int jtwi = IMUL(j, 32) + i;
			templateSh[jtwi] = templateDev[jtwi]; } }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y, 47);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 8];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 98];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 99];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 103];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 104];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 113];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 114];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 115];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 116];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 117];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 118];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 119];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 125];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 141];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 142];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 149];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 150];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 151];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 152];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 153];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 161];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 162];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 163];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 164];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 165];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 166];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 167];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 188];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 189];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 190];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 191];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 203];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 204];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 205];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 206];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 207];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 217];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 218];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 219];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 248];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 249];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 250];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 251];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 263];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 293];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 294];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 295];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 296];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 297];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 298];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 299];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 308];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 309];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 310];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 311];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 329];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 344];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 345];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 346];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 347];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 348];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 349];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 350];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 357];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 358];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 359];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 360];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 383];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 384];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 389];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 400];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 401];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 402];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 427];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 428];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 429];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 430];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 431];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 441];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 442];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 443];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 473];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 474];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 475];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 488];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 489];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 490];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 491];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 492];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 493];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 494];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 518];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 519];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 539];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 565];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 566];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 567];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 568];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 569];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 570];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 571];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 581];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 582];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 583];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 584];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 585];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 586];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 587];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 595];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 611];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 623];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 629];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 637];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 638];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 639];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 640];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 641];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 642];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 665];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 666];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 667];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 668];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 669];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 670];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 671];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 683];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 684];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 685];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 686];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 687];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 688];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 713];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 714];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 734];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[512];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[513];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[514];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[515];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[516];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[517];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 758];
		corr   += im * templateSh[518];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 759];
		corr   += im * templateSh[519];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 760];
		corr   += im * templateSh[520];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 761];
		corr   += im * templateSh[521];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 762];
		corr   += im * templateSh[522];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 763];
		corr   += im * templateSh[523];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 764];
		corr   += im * templateSh[524];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[525];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[526];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[527];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[528];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[529];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[530];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[531];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[532];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 773];
		corr   += im * templateSh[533];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 774];
		corr   += im * templateSh[534];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 775];
		corr   += im * templateSh[535];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 776];
		corr   += im * templateSh[536];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 777];
		corr   += im * templateSh[537];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 778];
		corr   += im * templateSh[538];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 779];
		corr   += im * templateSh[539];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[540];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[541];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[542];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[543];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[544];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[545];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[546];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[547];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[548];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[549];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 805];
		corr   += im * templateSh[550];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 806];
		corr   += im * templateSh[551];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 807];
		corr   += im * templateSh[552];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 808];
		corr   += im * templateSh[553];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 809];
		corr   += im * templateSh[554];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 810];
		corr   += im * templateSh[555];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 811];
		corr   += im * templateSh[556];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[557];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[558];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[559];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[560];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[561];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[562];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[563];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 819];
		corr   += im * templateSh[564];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 820];
		corr   += im * templateSh[565];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 821];
		corr   += im * templateSh[566];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 822];
		corr   += im * templateSh[567];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 823];
		corr   += im * templateSh[568];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 824];
		corr   += im * templateSh[569];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 825];
		corr   += im * templateSh[570];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 826];
		corr   += im * templateSh[571];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 827];
		corr   += im * templateSh[572];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[573];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[574];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[575];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[576];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[577];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[578];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[579];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[580];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 851];
		corr   += im * templateSh[581];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 852];
		corr   += im * templateSh[582];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 853];
		corr   += im * templateSh[583];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[584];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[585];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[586];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[587];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[588];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[589];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[590];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[591];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[592];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[593];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 864];
		corr   += im * templateSh[594];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 865];
		corr   += im * templateSh[595];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 866];
		corr   += im * templateSh[596];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 867];
		corr   += im * templateSh[597];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 868];
		corr   += im * templateSh[598];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 869];
		corr   += im * templateSh[599];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 870];
		corr   += im * templateSh[600];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[601];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[602];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[603];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[604];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[605];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[606];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 877];
		corr   += im * templateSh[607];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 893];
		corr   += im * templateSh[608];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 894];
		corr   += im * templateSh[609];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 895];
		corr   += im * templateSh[610];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 896];
		corr   += im * templateSh[611];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[612];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[613];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[614];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[615];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[616];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[617];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[618];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[619];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[620];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[621];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[622];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 908];
		corr   += im * templateSh[623];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 909];
		corr   += im * templateSh[624];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 910];
		corr   += im * templateSh[625];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 911];
		corr   += im * templateSh[626];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 912];
		corr   += im * templateSh[627];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 913];
		corr   += im * templateSh[628];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 914];
		corr   += im * templateSh[629];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[630];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 916];
		corr   += im * templateSh[631];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 917];
		corr   += im * templateSh[632];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 918];
		corr   += im * templateSh[633];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 919];
		corr   += im * templateSh[634];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[635];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[636];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[637];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 923];
		corr   += im * templateSh[638];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 924];
		corr   += im * templateSh[639];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 940];
		corr   += im * templateSh[640];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 941];
		corr   += im * templateSh[641];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 942];
		corr   += im * templateSh[642];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 943];
		corr   += im * templateSh[643];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 944];
		corr   += im * templateSh[644];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[645];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[646];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[647];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[648];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[649];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[650];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 951];
		corr   += im * templateSh[651];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 952];
		corr   += im * templateSh[652];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 953];
		corr   += im * templateSh[653];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 954];
		corr   += im * templateSh[654];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 955];
		corr   += im * templateSh[655];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 956];
		corr   += im * templateSh[656];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 957];
		corr   += im * templateSh[657];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 958];
		corr   += im * templateSh[658];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 959];
		corr   += im * templateSh[659];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 960];
		corr   += im * templateSh[660];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 961];
		corr   += im * templateSh[661];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 962];
		corr   += im * templateSh[662];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 963];
		corr   += im * templateSh[663];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 964];
		corr   += im * templateSh[664];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 965];
		corr   += im * templateSh[665];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[666];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[667];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 968];
		corr   += im * templateSh[668];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 969];
		corr   += im * templateSh[669];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 970];
		corr   += im * templateSh[670];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 971];
		corr   += im * templateSh[671];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 987];
		corr   += im * templateSh[672];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 988];
		corr   += im * templateSh[673];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 989];
		corr   += im * templateSh[674];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[675];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[676];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[677];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[678];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[679];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[680];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[681];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 997];
		corr   += im * templateSh[682];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 998];
		corr   += im * templateSh[683];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 999];
		corr   += im * templateSh[684];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1000];
		corr   += im * templateSh[685];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1001];
		corr   += im * templateSh[686];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1002];
		corr   += im * templateSh[687];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1003];
		corr   += im * templateSh[688];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1004];
		corr   += im * templateSh[689];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1005];
		corr   += im * templateSh[690];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1006];
		corr   += im * templateSh[691];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1007];
		corr   += im * templateSh[692];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[693];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[694];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1010];
		corr   += im * templateSh[695];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1011];
		corr   += im * templateSh[696];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[697];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[698];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[699];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1015];
		corr   += im * templateSh[700];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1016];
		corr   += im * templateSh[701];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1017];
		corr   += im * templateSh[702];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1018];
		corr   += im * templateSh[703];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1034];
		corr   += im * templateSh[704];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1035];
		corr   += im * templateSh[705];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[706];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[707];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[708];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[709];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[710];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1041];
		corr   += im * templateSh[711];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1042];
		corr   += im * templateSh[712];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1043];
		corr   += im * templateSh[713];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1044];
		corr   += im * templateSh[714];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1045];
		corr   += im * templateSh[715];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1046];
		corr   += im * templateSh[716];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1047];
		corr   += im * templateSh[717];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1048];
		corr   += im * templateSh[718];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1049];
		corr   += im * templateSh[719];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1050];
		corr   += im * templateSh[720];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1051];
		corr   += im * templateSh[721];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1052];
		corr   += im * templateSh[722];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1053];
		corr   += im * templateSh[723];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1054];
		corr   += im * templateSh[724];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1055];
		corr   += im * templateSh[725];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1056];
		corr   += im * templateSh[726];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1057];
		corr   += im * templateSh[727];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1058];
		corr   += im * templateSh[728];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1059];
		corr   += im * templateSh[729];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1060];
		corr   += im * templateSh[730];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1061];
		corr   += im * templateSh[731];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1062];
		corr   += im * templateSh[732];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1063];
		corr   += im * templateSh[733];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1064];
		corr   += im * templateSh[734];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1065];
		corr   += im * templateSh[735];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1081];
		corr   += im * templateSh[736];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1082];
		corr   += im * templateSh[737];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1083];
		corr   += im * templateSh[738];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1084];
		corr   += im * templateSh[739];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1085];
		corr   += im * templateSh[740];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1086];
		corr   += im * templateSh[741];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1087];
		corr   += im * templateSh[742];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1088];
		corr   += im * templateSh[743];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1089];
		corr   += im * templateSh[744];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1090];
		corr   += im * templateSh[745];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1091];
		corr   += im * templateSh[746];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1092];
		corr   += im * templateSh[747];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1093];
		corr   += im * templateSh[748];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1094];
		corr   += im * templateSh[749];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1095];
		corr   += im * templateSh[750];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1096];
		corr   += im * templateSh[751];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1097];
		corr   += im * templateSh[752];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1098];
		corr   += im * templateSh[753];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1099];
		corr   += im * templateSh[754];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1100];
		corr   += im * templateSh[755];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1101];
		corr   += im * templateSh[756];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1102];
		corr   += im * templateSh[757];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1103];
		corr   += im * templateSh[758];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1104];
		corr   += im * templateSh[759];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1105];
		corr   += im * templateSh[760];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1106];
		corr   += im * templateSh[761];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1107];
		corr   += im * templateSh[762];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1108];
		corr   += im * templateSh[763];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1109];
		corr   += im * templateSh[764];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1110];
		corr   += im * templateSh[765];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1111];
		corr   += im * templateSh[766];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1112];
		corr   += im * templateSh[767];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1128];
		corr   += im * templateSh[768];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1129];
		corr   += im * templateSh[769];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1130];
		corr   += im * templateSh[770];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1131];
		corr   += im * templateSh[771];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1132];
		corr   += im * templateSh[772];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1133];
		corr   += im * templateSh[773];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1134];
		corr   += im * templateSh[774];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1135];
		corr   += im * templateSh[775];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1136];
		corr   += im * templateSh[776];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1137];
		corr   += im * templateSh[777];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1138];
		corr   += im * templateSh[778];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1139];
		corr   += im * templateSh[779];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1140];
		corr   += im * templateSh[780];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1141];
		corr   += im * templateSh[781];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1142];
		corr   += im * templateSh[782];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1143];
		corr   += im * templateSh[783];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1144];
		corr   += im * templateSh[784];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1145];
		corr   += im * templateSh[785];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1146];
		corr   += im * templateSh[786];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1147];
		corr   += im * templateSh[787];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1148];
		corr   += im * templateSh[788];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1149];
		corr   += im * templateSh[789];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1150];
		corr   += im * templateSh[790];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1151];
		corr   += im * templateSh[791];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1152];
		corr   += im * templateSh[792];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1153];
		corr   += im * templateSh[793];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1154];
		corr   += im * templateSh[794];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1155];
		corr   += im * templateSh[795];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1156];
		corr   += im * templateSh[796];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1157];
		corr   += im * templateSh[797];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1158];
		corr   += im * templateSh[798];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1159];
		corr   += im * templateSh[799];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1175];
		corr   += im * templateSh[800];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1176];
		corr   += im * templateSh[801];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1177];
		corr   += im * templateSh[802];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1178];
		corr   += im * templateSh[803];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1179];
		corr   += im * templateSh[804];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1180];
		corr   += im * templateSh[805];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1181];
		corr   += im * templateSh[806];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1182];
		corr   += im * templateSh[807];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1183];
		corr   += im * templateSh[808];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1184];
		corr   += im * templateSh[809];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1185];
		corr   += im * templateSh[810];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1186];
		corr   += im * templateSh[811];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1187];
		corr   += im * templateSh[812];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1188];
		corr   += im * templateSh[813];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1189];
		corr   += im * templateSh[814];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1190];
		corr   += im * templateSh[815];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1191];
		corr   += im * templateSh[816];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1192];
		corr   += im * templateSh[817];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1193];
		corr   += im * templateSh[818];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1194];
		corr   += im * templateSh[819];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1195];
		corr   += im * templateSh[820];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1196];
		corr   += im * templateSh[821];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1197];
		corr   += im * templateSh[822];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1198];
		corr   += im * templateSh[823];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1199];
		corr   += im * templateSh[824];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1200];
		corr   += im * templateSh[825];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1201];
		corr   += im * templateSh[826];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1202];
		corr   += im * templateSh[827];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1203];
		corr   += im * templateSh[828];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1204];
		corr   += im * templateSh[829];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1205];
		corr   += im * templateSh[830];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1206];
		corr   += im * templateSh[831];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1222];
		corr   += im * templateSh[832];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1223];
		corr   += im * templateSh[833];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1224];
		corr   += im * templateSh[834];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1225];
		corr   += im * templateSh[835];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1226];
		corr   += im * templateSh[836];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1227];
		corr   += im * templateSh[837];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1228];
		corr   += im * templateSh[838];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1229];
		corr   += im * templateSh[839];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1230];
		corr   += im * templateSh[840];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1231];
		corr   += im * templateSh[841];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1232];
		corr   += im * templateSh[842];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1233];
		corr   += im * templateSh[843];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1234];
		corr   += im * templateSh[844];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1235];
		corr   += im * templateSh[845];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1236];
		corr   += im * templateSh[846];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1237];
		corr   += im * templateSh[847];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1238];
		corr   += im * templateSh[848];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1239];
		corr   += im * templateSh[849];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1240];
		corr   += im * templateSh[850];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1241];
		corr   += im * templateSh[851];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1242];
		corr   += im * templateSh[852];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1243];
		corr   += im * templateSh[853];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1244];
		corr   += im * templateSh[854];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1245];
		corr   += im * templateSh[855];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1246];
		corr   += im * templateSh[856];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1247];
		corr   += im * templateSh[857];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1248];
		corr   += im * templateSh[858];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1249];
		corr   += im * templateSh[859];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1250];
		corr   += im * templateSh[860];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1251];
		corr   += im * templateSh[861];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1252];
		corr   += im * templateSh[862];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1253];
		corr   += im * templateSh[863];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1269];
		corr   += im * templateSh[864];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1270];
		corr   += im * templateSh[865];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1271];
		corr   += im * templateSh[866];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1272];
		corr   += im * templateSh[867];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1273];
		corr   += im * templateSh[868];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1274];
		corr   += im * templateSh[869];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1275];
		corr   += im * templateSh[870];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1276];
		corr   += im * templateSh[871];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1277];
		corr   += im * templateSh[872];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1278];
		corr   += im * templateSh[873];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1279];
		corr   += im * templateSh[874];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1280];
		corr   += im * templateSh[875];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1281];
		corr   += im * templateSh[876];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1282];
		corr   += im * templateSh[877];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1283];
		corr   += im * templateSh[878];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1284];
		corr   += im * templateSh[879];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1285];
		corr   += im * templateSh[880];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1286];
		corr   += im * templateSh[881];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1287];
		corr   += im * templateSh[882];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1288];
		corr   += im * templateSh[883];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1289];
		corr   += im * templateSh[884];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1290];
		corr   += im * templateSh[885];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1291];
		corr   += im * templateSh[886];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1292];
		corr   += im * templateSh[887];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1293];
		corr   += im * templateSh[888];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1294];
		corr   += im * templateSh[889];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1295];
		corr   += im * templateSh[890];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1296];
		corr   += im * templateSh[891];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1297];
		corr   += im * templateSh[892];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1298];
		corr   += im * templateSh[893];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1299];
		corr   += im * templateSh[894];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1300];
		corr   += im * templateSh[895];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1316];
		corr   += im * templateSh[896];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1317];
		corr   += im * templateSh[897];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1318];
		corr   += im * templateSh[898];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1319];
		corr   += im * templateSh[899];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1320];
		corr   += im * templateSh[900];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1321];
		corr   += im * templateSh[901];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1322];
		corr   += im * templateSh[902];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1323];
		corr   += im * templateSh[903];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1324];
		corr   += im * templateSh[904];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1325];
		corr   += im * templateSh[905];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1326];
		corr   += im * templateSh[906];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1327];
		corr   += im * templateSh[907];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1328];
		corr   += im * templateSh[908];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1329];
		corr   += im * templateSh[909];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1330];
		corr   += im * templateSh[910];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1331];
		corr   += im * templateSh[911];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1332];
		corr   += im * templateSh[912];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1333];
		corr   += im * templateSh[913];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1334];
		corr   += im * templateSh[914];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1335];
		corr   += im * templateSh[915];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1336];
		corr   += im * templateSh[916];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1337];
		corr   += im * templateSh[917];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1338];
		corr   += im * templateSh[918];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1339];
		corr   += im * templateSh[919];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1340];
		corr   += im * templateSh[920];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1341];
		corr   += im * templateSh[921];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1342];
		corr   += im * templateSh[922];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1343];
		corr   += im * templateSh[923];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1344];
		corr   += im * templateSh[924];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1345];
		corr   += im * templateSh[925];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1346];
		corr   += im * templateSh[926];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1347];
		corr   += im * templateSh[927];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1363];
		corr   += im * templateSh[928];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1364];
		corr   += im * templateSh[929];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1365];
		corr   += im * templateSh[930];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1366];
		corr   += im * templateSh[931];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1367];
		corr   += im * templateSh[932];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1368];
		corr   += im * templateSh[933];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1369];
		corr   += im * templateSh[934];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1370];
		corr   += im * templateSh[935];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1371];
		corr   += im * templateSh[936];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1372];
		corr   += im * templateSh[937];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1373];
		corr   += im * templateSh[938];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1374];
		corr   += im * templateSh[939];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1375];
		corr   += im * templateSh[940];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1376];
		corr   += im * templateSh[941];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1377];
		corr   += im * templateSh[942];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1378];
		corr   += im * templateSh[943];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1379];
		corr   += im * templateSh[944];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1380];
		corr   += im * templateSh[945];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1381];
		corr   += im * templateSh[946];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1382];
		corr   += im * templateSh[947];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1383];
		corr   += im * templateSh[948];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1384];
		corr   += im * templateSh[949];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1385];
		corr   += im * templateSh[950];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1386];
		corr   += im * templateSh[951];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1387];
		corr   += im * templateSh[952];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1388];
		corr   += im * templateSh[953];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1389];
		corr   += im * templateSh[954];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1390];
		corr   += im * templateSh[955];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1391];
		corr   += im * templateSh[956];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1392];
		corr   += im * templateSh[957];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1393];
		corr   += im * templateSh[958];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1394];
		corr   += im * templateSh[959];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1410];
		corr   += im * templateSh[960];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1411];
		corr   += im * templateSh[961];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1412];
		corr   += im * templateSh[962];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1413];
		corr   += im * templateSh[963];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1414];
		corr   += im * templateSh[964];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1415];
		corr   += im * templateSh[965];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1416];
		corr   += im * templateSh[966];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1417];
		corr   += im * templateSh[967];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1418];
		corr   += im * templateSh[968];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1419];
		corr   += im * templateSh[969];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1420];
		corr   += im * templateSh[970];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1421];
		corr   += im * templateSh[971];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1422];
		corr   += im * templateSh[972];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1423];
		corr   += im * templateSh[973];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1424];
		corr   += im * templateSh[974];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1425];
		corr   += im * templateSh[975];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1426];
		corr   += im * templateSh[976];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1427];
		corr   += im * templateSh[977];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1428];
		corr   += im * templateSh[978];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1429];
		corr   += im * templateSh[979];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1430];
		corr   += im * templateSh[980];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1431];
		corr   += im * templateSh[981];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1432];
		corr   += im * templateSh[982];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1433];
		corr   += im * templateSh[983];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1434];
		corr   += im * templateSh[984];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1435];
		corr   += im * templateSh[985];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1436];
		corr   += im * templateSh[986];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1437];
		corr   += im * templateSh[987];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1438];
		corr   += im * templateSh[988];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1439];
		corr   += im * templateSh[989];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1440];
		corr   += im * templateSh[990];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1441];
		corr   += im * templateSh[991];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1457];
		corr   += im * templateSh[992];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1458];
		corr   += im * templateSh[993];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1459];
		corr   += im * templateSh[994];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1460];
		corr   += im * templateSh[995];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1461];
		corr   += im * templateSh[996];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1462];
		corr   += im * templateSh[997];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1463];
		corr   += im * templateSh[998];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1464];
		corr   += im * templateSh[999];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1465];
		corr   += im * templateSh[1000];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1466];
		corr   += im * templateSh[1001];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1467];
		corr   += im * templateSh[1002];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1468];
		corr   += im * templateSh[1003];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1469];
		corr   += im * templateSh[1004];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1470];
		corr   += im * templateSh[1005];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1471];
		corr   += im * templateSh[1006];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1472];
		corr   += im * templateSh[1007];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1473];
		corr   += im * templateSh[1008];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1474];
		corr   += im * templateSh[1009];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1475];
		corr   += im * templateSh[1010];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1476];
		corr   += im * templateSh[1011];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1477];
		corr   += im * templateSh[1012];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1478];
		corr   += im * templateSh[1013];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1479];
		corr   += im * templateSh[1014];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1480];
		corr   += im * templateSh[1015];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1481];
		corr   += im * templateSh[1016];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1482];
		corr   += im * templateSh[1017];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1483];
		corr   += im * templateSh[1018];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1484];
		corr   += im * templateSh[1019];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1485];
		corr   += im * templateSh[1020];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1486];
		corr   += im * templateSh[1021];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1487];
		corr   += im * templateSh[1022];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1488];
		corr   += im * templateSh[1023];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/1024;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y), SW);
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation2d_kernel_32x32<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int BW );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation2d_kernel_32x32<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int BW );
#endif 

