// This file is generated automatically. 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_2x2x2 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[729];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<9; k+=8) {
		for (int j=threadIdx.y; j<9; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<9; i+=8) {
				panelSh[i + IMUL(j, 9) + IMUL(k, 81)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[8];
	if (threadIdx.x < 2 && threadIdx.y < 2 && threadIdx.z < 2) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,2) + IMUL(threadIdx.z,4);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,9) + IMUL(threadIdx.z,81);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 9];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/8;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_2x2x2<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_2x2x2<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_3x3x3 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[1000];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<10; k+=8) {
		for (int j=threadIdx.y; j<10; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<10; i+=8) {
				panelSh[i + IMUL(j, 10) + IMUL(k, 100)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[27];
	if (threadIdx.x < 3 && threadIdx.y < 3 && threadIdx.z < 3) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,3) + IMUL(threadIdx.z,9);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,10) + IMUL(threadIdx.z,100);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 10];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 100];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 101];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 102];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 120];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 220];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/27;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_3x3x3<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_3x3x3<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_4x4x4 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[1331];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<11; k+=8) {
		for (int j=threadIdx.y; j<11; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<11; i+=8) {
				panelSh[i + IMUL(j, 11) + IMUL(k, 121)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[64];
	if (threadIdx.x < 4 && threadIdx.y < 4 && threadIdx.z < 4) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,4) + IMUL(threadIdx.z,16);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,11) + IMUL(threadIdx.z,121);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 11];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 23];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 121];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 122];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 123];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 124];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 132];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 133];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 134];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 135];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 143];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 154];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 155];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 264];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 265];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 278];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 363];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 374];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 375];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 376];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 385];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 386];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 387];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 388];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 399];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/64;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_4x4x4<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_4x4x4<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_5x5x5 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[1728];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<12; k+=8) {
		for (int j=threadIdx.y; j<12; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<12; i+=8) {
				panelSh[i + IMUL(j, 12) + IMUL(k, 144)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[125];
	if (threadIdx.x < 5 && threadIdx.y < 5 && threadIdx.z < 5) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,5) + IMUL(threadIdx.z,25);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,12) + IMUL(threadIdx.z,144);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 12];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 24];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 25];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 38];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 144];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 145];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 146];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 147];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 148];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 156];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 157];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 158];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 159];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 160];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 168];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 180];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 181];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 192];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 193];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 194];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 312];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 313];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 314];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 324];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 325];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 326];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 327];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 328];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 432];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 433];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 444];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 445];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 446];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 447];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 458];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 459];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 460];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 578];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 579];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 580];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 600];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 601];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 612];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 613];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 614];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 615];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 624];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 625];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 626];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 627];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 628];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/125;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_5x5x5<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_5x5x5<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_6x6x6 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[2197];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<13; k+=8) {
		for (int j=threadIdx.y; j<13; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<13; i+=8) {
				panelSh[i + IMUL(j, 13) + IMUL(k, 169)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[216];
	if (threadIdx.x < 6 && threadIdx.y < 6 && threadIdx.z < 6) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,6) + IMUL(threadIdx.z,36);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,13) + IMUL(threadIdx.z,169);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 13];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 26];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 27];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 39];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 40];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 41];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 53];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 54];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 55];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 68];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 69];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 169];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 170];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 171];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 172];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 173];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 174];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 182];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 183];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 184];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 185];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 186];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 187];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 195];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 208];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 209];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 221];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 222];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 223];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 234];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 235];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 236];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 237];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 338];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 339];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 340];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 341];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 342];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 343];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 351];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 352];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 353];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 354];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 355];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 356];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 364];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 365];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 366];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 367];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 368];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 369];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 377];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 378];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 379];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 380];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 381];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 382];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 390];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 391];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 403];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 404];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 405];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 507];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 508];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 509];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 520];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 521];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 522];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 523];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 524];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 533];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 534];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 535];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 536];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 537];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 538];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 548];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 549];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 550];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 551];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 563];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 564];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 572];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 573];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 574];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 575];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 576];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 577];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 689];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 702];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 703];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 704];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 715];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 716];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 717];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 718];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 719];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 728];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 729];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 730];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 731];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 732];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 733];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 743];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 744];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 745];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 746];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 847];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 848];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 849];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 850];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 861];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 862];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 863];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 875];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 876];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 884];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 885];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 886];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 887];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 888];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 889];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 897];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 898];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 899];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 910];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 911];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 912];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 913];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 914];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/216;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_6x6x6<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_6x6x6<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_7x7x7 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[2744];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<14; k+=8) {
		for (int j=threadIdx.y; j<14; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<14; i+=8) {
				panelSh[i + IMUL(j, 14) + IMUL(k, 196)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[343];
	if (threadIdx.x < 7 && threadIdx.y < 7 && threadIdx.z < 7) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,7) + IMUL(threadIdx.z,49);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,14) + IMUL(threadIdx.z,196);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 14];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 28];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 29];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 42];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 43];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 44];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 56];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 57];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 58];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 59];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 70];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 71];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 72];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 73];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 74];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 84];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 85];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 86];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 87];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 88];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 89];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 196];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 197];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 198];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 199];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 200];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 201];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 202];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 210];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 211];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 212];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 213];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 214];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 215];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 216];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 224];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 238];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 239];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 252];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 253];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 254];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 266];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 267];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 268];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 269];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 280];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 281];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 282];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 283];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 284];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 392];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 393];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 394];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 395];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 396];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 397];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 398];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 406];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 407];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 408];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 409];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 410];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 411];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 412];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 420];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 421];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 422];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 423];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 424];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 425];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 426];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 434];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 435];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 436];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 437];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 438];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 439];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 440];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 448];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 449];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 462];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 463];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 464];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 476];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 477];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 478];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 479];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 588];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 589];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 590];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 591];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 592];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 593];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 594];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 602];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 603];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 604];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 605];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 606];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 607];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 608];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 616];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 617];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 618];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 619];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 620];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 621];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 622];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 630];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 631];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 632];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 633];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 634];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 635];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 636];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 644];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 645];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 646];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 647];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 648];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 649];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 650];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 658];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 659];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 660];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 661];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 662];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 663];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 664];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 672];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 673];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 674];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 788];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 789];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 790];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 798];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 799];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 800];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 801];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 802];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 803];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 804];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 812];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 813];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 814];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 815];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 816];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 817];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 818];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 826];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 827];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 828];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 829];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 830];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 831];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 832];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 840];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 841];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 842];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 843];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 844];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 845];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 846];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 854];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 855];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 856];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 857];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 858];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 859];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 860];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 868];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 869];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 870];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 871];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 872];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 873];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 874];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 980];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 981];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 982];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 983];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 984];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 985];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 986];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 997];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 998];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 999];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1000];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1010];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1011];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1013];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1014];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1022];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1023];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1024];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1025];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1026];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1027];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1028];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1036];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1037];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1038];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1039];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1040];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1041];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1042];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1050];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1051];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1052];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1053];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1054];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1055];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1056];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1064];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1065];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1066];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1067];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1068];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1069];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1070];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1176];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1177];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1178];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1179];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1180];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1181];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1182];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1190];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1191];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1192];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1193];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1194];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1195];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1196];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1204];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1205];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1206];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1207];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1208];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1209];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1210];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1218];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1219];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1220];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1221];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1222];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1223];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1224];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1232];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1233];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1234];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1235];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1236];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1237];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1238];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1246];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1247];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1248];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1249];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1250];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1251];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1252];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1260];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1261];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1262];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1263];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1264];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1265];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1266];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/343;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_7x7x7<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_7x7x7<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

template <class flccPrecision>
__global__ void lcorrelation3d_kernel_8x8x8 (
	flccPrecision *imageDev, flccPrecision *templateDev, flccPrecision *outputDev, int SW, int SD, int BW, int BD )
{
	const int block_num_x = SD/blockDim.x;
	const int u0 = IMUL(blockDim.x, blockIdx.x%block_num_x);
	const int v0 = IMUL(blockDim.y, blockIdx.x/block_num_x);
	const int w0 = IMUL(blockDim.z, blockIdx.y);
	__shared__ flccPrecision panelSh[3375];
	const int i_idx = u0 + IMUL(v0,BD) + IMUL(w0,IMUL(BD,BW));
	for (int k=threadIdx.z; k<15; k+=8) {
		for (int j=threadIdx.y; j<15; j+=8) {
			#pragma unroll
			for (int i=threadIdx.x; i<15; i+=8) {
				panelSh[i + IMUL(j, 15) + IMUL(k, 225)] = imageDev[i_idx + i + IMUL(j,BD) + IMUL(k,IMUL(BD,BW))]; } } }
	__shared__ flccPrecision templateSh[512];
	if (threadIdx.x < 8 && threadIdx.y < 8 && threadIdx.z < 8) {
		const int ijk = threadIdx.x + IMUL(threadIdx.y,8) + IMUL(threadIdx.z,64);
		templateSh[ijk] = templateDev[ijk]; }
	__syncthreads();
	register flccPrecision corr   = 0.0;
	register flccPrecision sum    = 0.0;
	register flccPrecision sum_sq = 0.0;
	const int p_idx = threadIdx.x + IMUL(threadIdx.y,15) + IMUL(threadIdx.z,225);
	register flccPrecision im;
		im = panelSh[p_idx + 0];
		corr   += im * templateSh[0];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1];
		corr   += im * templateSh[1];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 2];
		corr   += im * templateSh[2];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 3];
		corr   += im * templateSh[3];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 4];
		corr   += im * templateSh[4];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 5];
		corr   += im * templateSh[5];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 6];
		corr   += im * templateSh[6];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 7];
		corr   += im * templateSh[7];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 15];
		corr   += im * templateSh[8];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 16];
		corr   += im * templateSh[9];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 17];
		corr   += im * templateSh[10];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 18];
		corr   += im * templateSh[11];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 19];
		corr   += im * templateSh[12];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 20];
		corr   += im * templateSh[13];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 21];
		corr   += im * templateSh[14];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 22];
		corr   += im * templateSh[15];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 30];
		corr   += im * templateSh[16];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 31];
		corr   += im * templateSh[17];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 32];
		corr   += im * templateSh[18];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 33];
		corr   += im * templateSh[19];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 34];
		corr   += im * templateSh[20];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 35];
		corr   += im * templateSh[21];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 36];
		corr   += im * templateSh[22];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 37];
		corr   += im * templateSh[23];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 45];
		corr   += im * templateSh[24];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 46];
		corr   += im * templateSh[25];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 47];
		corr   += im * templateSh[26];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 48];
		corr   += im * templateSh[27];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 49];
		corr   += im * templateSh[28];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 50];
		corr   += im * templateSh[29];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 51];
		corr   += im * templateSh[30];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 52];
		corr   += im * templateSh[31];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 60];
		corr   += im * templateSh[32];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 61];
		corr   += im * templateSh[33];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 62];
		corr   += im * templateSh[34];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 63];
		corr   += im * templateSh[35];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 64];
		corr   += im * templateSh[36];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 65];
		corr   += im * templateSh[37];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 66];
		corr   += im * templateSh[38];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 67];
		corr   += im * templateSh[39];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 75];
		corr   += im * templateSh[40];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 76];
		corr   += im * templateSh[41];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 77];
		corr   += im * templateSh[42];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 78];
		corr   += im * templateSh[43];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 79];
		corr   += im * templateSh[44];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 80];
		corr   += im * templateSh[45];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 81];
		corr   += im * templateSh[46];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 82];
		corr   += im * templateSh[47];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 90];
		corr   += im * templateSh[48];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 91];
		corr   += im * templateSh[49];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 92];
		corr   += im * templateSh[50];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 93];
		corr   += im * templateSh[51];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 94];
		corr   += im * templateSh[52];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 95];
		corr   += im * templateSh[53];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 96];
		corr   += im * templateSh[54];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 97];
		corr   += im * templateSh[55];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 105];
		corr   += im * templateSh[56];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 106];
		corr   += im * templateSh[57];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 107];
		corr   += im * templateSh[58];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 108];
		corr   += im * templateSh[59];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 109];
		corr   += im * templateSh[60];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 110];
		corr   += im * templateSh[61];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 111];
		corr   += im * templateSh[62];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 112];
		corr   += im * templateSh[63];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 225];
		corr   += im * templateSh[64];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 226];
		corr   += im * templateSh[65];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 227];
		corr   += im * templateSh[66];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 228];
		corr   += im * templateSh[67];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 229];
		corr   += im * templateSh[68];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 230];
		corr   += im * templateSh[69];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 231];
		corr   += im * templateSh[70];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 232];
		corr   += im * templateSh[71];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 240];
		corr   += im * templateSh[72];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 241];
		corr   += im * templateSh[73];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 242];
		corr   += im * templateSh[74];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 243];
		corr   += im * templateSh[75];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 244];
		corr   += im * templateSh[76];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 245];
		corr   += im * templateSh[77];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 246];
		corr   += im * templateSh[78];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 247];
		corr   += im * templateSh[79];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 255];
		corr   += im * templateSh[80];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 256];
		corr   += im * templateSh[81];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 257];
		corr   += im * templateSh[82];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 258];
		corr   += im * templateSh[83];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 259];
		corr   += im * templateSh[84];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 260];
		corr   += im * templateSh[85];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 261];
		corr   += im * templateSh[86];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 262];
		corr   += im * templateSh[87];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 270];
		corr   += im * templateSh[88];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 271];
		corr   += im * templateSh[89];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 272];
		corr   += im * templateSh[90];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 273];
		corr   += im * templateSh[91];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 274];
		corr   += im * templateSh[92];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 275];
		corr   += im * templateSh[93];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 276];
		corr   += im * templateSh[94];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 277];
		corr   += im * templateSh[95];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 285];
		corr   += im * templateSh[96];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 286];
		corr   += im * templateSh[97];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 287];
		corr   += im * templateSh[98];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 288];
		corr   += im * templateSh[99];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 289];
		corr   += im * templateSh[100];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 290];
		corr   += im * templateSh[101];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 291];
		corr   += im * templateSh[102];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 292];
		corr   += im * templateSh[103];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 300];
		corr   += im * templateSh[104];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 301];
		corr   += im * templateSh[105];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 302];
		corr   += im * templateSh[106];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 303];
		corr   += im * templateSh[107];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 304];
		corr   += im * templateSh[108];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 305];
		corr   += im * templateSh[109];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 306];
		corr   += im * templateSh[110];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 307];
		corr   += im * templateSh[111];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 315];
		corr   += im * templateSh[112];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 316];
		corr   += im * templateSh[113];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 317];
		corr   += im * templateSh[114];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 318];
		corr   += im * templateSh[115];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 319];
		corr   += im * templateSh[116];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 320];
		corr   += im * templateSh[117];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 321];
		corr   += im * templateSh[118];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 322];
		corr   += im * templateSh[119];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 330];
		corr   += im * templateSh[120];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 331];
		corr   += im * templateSh[121];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 332];
		corr   += im * templateSh[122];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 333];
		corr   += im * templateSh[123];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 334];
		corr   += im * templateSh[124];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 335];
		corr   += im * templateSh[125];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 336];
		corr   += im * templateSh[126];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 337];
		corr   += im * templateSh[127];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 450];
		corr   += im * templateSh[128];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 451];
		corr   += im * templateSh[129];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 452];
		corr   += im * templateSh[130];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 453];
		corr   += im * templateSh[131];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 454];
		corr   += im * templateSh[132];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 455];
		corr   += im * templateSh[133];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 456];
		corr   += im * templateSh[134];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 457];
		corr   += im * templateSh[135];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 465];
		corr   += im * templateSh[136];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 466];
		corr   += im * templateSh[137];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 467];
		corr   += im * templateSh[138];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 468];
		corr   += im * templateSh[139];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 469];
		corr   += im * templateSh[140];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 470];
		corr   += im * templateSh[141];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 471];
		corr   += im * templateSh[142];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 472];
		corr   += im * templateSh[143];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 480];
		corr   += im * templateSh[144];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 481];
		corr   += im * templateSh[145];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 482];
		corr   += im * templateSh[146];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 483];
		corr   += im * templateSh[147];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 484];
		corr   += im * templateSh[148];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 485];
		corr   += im * templateSh[149];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 486];
		corr   += im * templateSh[150];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 487];
		corr   += im * templateSh[151];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 495];
		corr   += im * templateSh[152];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 496];
		corr   += im * templateSh[153];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 497];
		corr   += im * templateSh[154];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 498];
		corr   += im * templateSh[155];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 499];
		corr   += im * templateSh[156];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 500];
		corr   += im * templateSh[157];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 501];
		corr   += im * templateSh[158];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 502];
		corr   += im * templateSh[159];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 510];
		corr   += im * templateSh[160];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 511];
		corr   += im * templateSh[161];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 512];
		corr   += im * templateSh[162];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 513];
		corr   += im * templateSh[163];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 514];
		corr   += im * templateSh[164];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 515];
		corr   += im * templateSh[165];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 516];
		corr   += im * templateSh[166];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 517];
		corr   += im * templateSh[167];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 525];
		corr   += im * templateSh[168];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 526];
		corr   += im * templateSh[169];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 527];
		corr   += im * templateSh[170];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 528];
		corr   += im * templateSh[171];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 529];
		corr   += im * templateSh[172];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 530];
		corr   += im * templateSh[173];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 531];
		corr   += im * templateSh[174];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 532];
		corr   += im * templateSh[175];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 540];
		corr   += im * templateSh[176];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 541];
		corr   += im * templateSh[177];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 542];
		corr   += im * templateSh[178];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 543];
		corr   += im * templateSh[179];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 544];
		corr   += im * templateSh[180];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 545];
		corr   += im * templateSh[181];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 546];
		corr   += im * templateSh[182];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 547];
		corr   += im * templateSh[183];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 555];
		corr   += im * templateSh[184];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 556];
		corr   += im * templateSh[185];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 557];
		corr   += im * templateSh[186];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 558];
		corr   += im * templateSh[187];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 559];
		corr   += im * templateSh[188];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 560];
		corr   += im * templateSh[189];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 561];
		corr   += im * templateSh[190];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 562];
		corr   += im * templateSh[191];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 675];
		corr   += im * templateSh[192];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 676];
		corr   += im * templateSh[193];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 677];
		corr   += im * templateSh[194];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 678];
		corr   += im * templateSh[195];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 679];
		corr   += im * templateSh[196];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 680];
		corr   += im * templateSh[197];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 681];
		corr   += im * templateSh[198];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 682];
		corr   += im * templateSh[199];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 690];
		corr   += im * templateSh[200];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 691];
		corr   += im * templateSh[201];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 692];
		corr   += im * templateSh[202];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 693];
		corr   += im * templateSh[203];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 694];
		corr   += im * templateSh[204];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 695];
		corr   += im * templateSh[205];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 696];
		corr   += im * templateSh[206];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 697];
		corr   += im * templateSh[207];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 705];
		corr   += im * templateSh[208];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 706];
		corr   += im * templateSh[209];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 707];
		corr   += im * templateSh[210];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 708];
		corr   += im * templateSh[211];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 709];
		corr   += im * templateSh[212];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 710];
		corr   += im * templateSh[213];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 711];
		corr   += im * templateSh[214];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 712];
		corr   += im * templateSh[215];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 720];
		corr   += im * templateSh[216];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 721];
		corr   += im * templateSh[217];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 722];
		corr   += im * templateSh[218];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 723];
		corr   += im * templateSh[219];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 724];
		corr   += im * templateSh[220];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 725];
		corr   += im * templateSh[221];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 726];
		corr   += im * templateSh[222];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 727];
		corr   += im * templateSh[223];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 735];
		corr   += im * templateSh[224];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 736];
		corr   += im * templateSh[225];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 737];
		corr   += im * templateSh[226];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 738];
		corr   += im * templateSh[227];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 739];
		corr   += im * templateSh[228];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 740];
		corr   += im * templateSh[229];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 741];
		corr   += im * templateSh[230];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 742];
		corr   += im * templateSh[231];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 750];
		corr   += im * templateSh[232];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 751];
		corr   += im * templateSh[233];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 752];
		corr   += im * templateSh[234];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 753];
		corr   += im * templateSh[235];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 754];
		corr   += im * templateSh[236];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 755];
		corr   += im * templateSh[237];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 756];
		corr   += im * templateSh[238];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 757];
		corr   += im * templateSh[239];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 765];
		corr   += im * templateSh[240];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 766];
		corr   += im * templateSh[241];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 767];
		corr   += im * templateSh[242];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 768];
		corr   += im * templateSh[243];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 769];
		corr   += im * templateSh[244];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 770];
		corr   += im * templateSh[245];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 771];
		corr   += im * templateSh[246];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 772];
		corr   += im * templateSh[247];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 780];
		corr   += im * templateSh[248];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 781];
		corr   += im * templateSh[249];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 782];
		corr   += im * templateSh[250];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 783];
		corr   += im * templateSh[251];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 784];
		corr   += im * templateSh[252];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 785];
		corr   += im * templateSh[253];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 786];
		corr   += im * templateSh[254];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 787];
		corr   += im * templateSh[255];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 900];
		corr   += im * templateSh[256];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 901];
		corr   += im * templateSh[257];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 902];
		corr   += im * templateSh[258];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 903];
		corr   += im * templateSh[259];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 904];
		corr   += im * templateSh[260];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 905];
		corr   += im * templateSh[261];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 906];
		corr   += im * templateSh[262];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 907];
		corr   += im * templateSh[263];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 915];
		corr   += im * templateSh[264];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 916];
		corr   += im * templateSh[265];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 917];
		corr   += im * templateSh[266];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 918];
		corr   += im * templateSh[267];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 919];
		corr   += im * templateSh[268];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 920];
		corr   += im * templateSh[269];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 921];
		corr   += im * templateSh[270];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 922];
		corr   += im * templateSh[271];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 930];
		corr   += im * templateSh[272];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 931];
		corr   += im * templateSh[273];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 932];
		corr   += im * templateSh[274];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 933];
		corr   += im * templateSh[275];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 934];
		corr   += im * templateSh[276];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 935];
		corr   += im * templateSh[277];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 936];
		corr   += im * templateSh[278];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 937];
		corr   += im * templateSh[279];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 945];
		corr   += im * templateSh[280];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 946];
		corr   += im * templateSh[281];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 947];
		corr   += im * templateSh[282];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 948];
		corr   += im * templateSh[283];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 949];
		corr   += im * templateSh[284];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 950];
		corr   += im * templateSh[285];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 951];
		corr   += im * templateSh[286];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 952];
		corr   += im * templateSh[287];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 960];
		corr   += im * templateSh[288];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 961];
		corr   += im * templateSh[289];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 962];
		corr   += im * templateSh[290];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 963];
		corr   += im * templateSh[291];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 964];
		corr   += im * templateSh[292];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 965];
		corr   += im * templateSh[293];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 966];
		corr   += im * templateSh[294];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 967];
		corr   += im * templateSh[295];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 975];
		corr   += im * templateSh[296];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 976];
		corr   += im * templateSh[297];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 977];
		corr   += im * templateSh[298];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 978];
		corr   += im * templateSh[299];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 979];
		corr   += im * templateSh[300];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 980];
		corr   += im * templateSh[301];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 981];
		corr   += im * templateSh[302];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 982];
		corr   += im * templateSh[303];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 990];
		corr   += im * templateSh[304];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 991];
		corr   += im * templateSh[305];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 992];
		corr   += im * templateSh[306];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 993];
		corr   += im * templateSh[307];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 994];
		corr   += im * templateSh[308];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 995];
		corr   += im * templateSh[309];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 996];
		corr   += im * templateSh[310];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 997];
		corr   += im * templateSh[311];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1005];
		corr   += im * templateSh[312];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1006];
		corr   += im * templateSh[313];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1007];
		corr   += im * templateSh[314];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1008];
		corr   += im * templateSh[315];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1009];
		corr   += im * templateSh[316];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1010];
		corr   += im * templateSh[317];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1011];
		corr   += im * templateSh[318];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1012];
		corr   += im * templateSh[319];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1125];
		corr   += im * templateSh[320];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1126];
		corr   += im * templateSh[321];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1127];
		corr   += im * templateSh[322];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1128];
		corr   += im * templateSh[323];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1129];
		corr   += im * templateSh[324];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1130];
		corr   += im * templateSh[325];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1131];
		corr   += im * templateSh[326];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1132];
		corr   += im * templateSh[327];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1140];
		corr   += im * templateSh[328];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1141];
		corr   += im * templateSh[329];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1142];
		corr   += im * templateSh[330];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1143];
		corr   += im * templateSh[331];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1144];
		corr   += im * templateSh[332];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1145];
		corr   += im * templateSh[333];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1146];
		corr   += im * templateSh[334];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1147];
		corr   += im * templateSh[335];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1155];
		corr   += im * templateSh[336];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1156];
		corr   += im * templateSh[337];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1157];
		corr   += im * templateSh[338];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1158];
		corr   += im * templateSh[339];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1159];
		corr   += im * templateSh[340];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1160];
		corr   += im * templateSh[341];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1161];
		corr   += im * templateSh[342];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1162];
		corr   += im * templateSh[343];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1170];
		corr   += im * templateSh[344];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1171];
		corr   += im * templateSh[345];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1172];
		corr   += im * templateSh[346];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1173];
		corr   += im * templateSh[347];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1174];
		corr   += im * templateSh[348];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1175];
		corr   += im * templateSh[349];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1176];
		corr   += im * templateSh[350];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1177];
		corr   += im * templateSh[351];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1185];
		corr   += im * templateSh[352];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1186];
		corr   += im * templateSh[353];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1187];
		corr   += im * templateSh[354];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1188];
		corr   += im * templateSh[355];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1189];
		corr   += im * templateSh[356];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1190];
		corr   += im * templateSh[357];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1191];
		corr   += im * templateSh[358];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1192];
		corr   += im * templateSh[359];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1200];
		corr   += im * templateSh[360];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1201];
		corr   += im * templateSh[361];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1202];
		corr   += im * templateSh[362];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1203];
		corr   += im * templateSh[363];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1204];
		corr   += im * templateSh[364];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1205];
		corr   += im * templateSh[365];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1206];
		corr   += im * templateSh[366];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1207];
		corr   += im * templateSh[367];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1215];
		corr   += im * templateSh[368];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1216];
		corr   += im * templateSh[369];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1217];
		corr   += im * templateSh[370];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1218];
		corr   += im * templateSh[371];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1219];
		corr   += im * templateSh[372];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1220];
		corr   += im * templateSh[373];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1221];
		corr   += im * templateSh[374];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1222];
		corr   += im * templateSh[375];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1230];
		corr   += im * templateSh[376];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1231];
		corr   += im * templateSh[377];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1232];
		corr   += im * templateSh[378];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1233];
		corr   += im * templateSh[379];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1234];
		corr   += im * templateSh[380];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1235];
		corr   += im * templateSh[381];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1236];
		corr   += im * templateSh[382];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1237];
		corr   += im * templateSh[383];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1350];
		corr   += im * templateSh[384];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1351];
		corr   += im * templateSh[385];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1352];
		corr   += im * templateSh[386];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1353];
		corr   += im * templateSh[387];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1354];
		corr   += im * templateSh[388];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1355];
		corr   += im * templateSh[389];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1356];
		corr   += im * templateSh[390];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1357];
		corr   += im * templateSh[391];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1365];
		corr   += im * templateSh[392];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1366];
		corr   += im * templateSh[393];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1367];
		corr   += im * templateSh[394];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1368];
		corr   += im * templateSh[395];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1369];
		corr   += im * templateSh[396];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1370];
		corr   += im * templateSh[397];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1371];
		corr   += im * templateSh[398];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1372];
		corr   += im * templateSh[399];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1380];
		corr   += im * templateSh[400];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1381];
		corr   += im * templateSh[401];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1382];
		corr   += im * templateSh[402];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1383];
		corr   += im * templateSh[403];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1384];
		corr   += im * templateSh[404];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1385];
		corr   += im * templateSh[405];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1386];
		corr   += im * templateSh[406];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1387];
		corr   += im * templateSh[407];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1395];
		corr   += im * templateSh[408];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1396];
		corr   += im * templateSh[409];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1397];
		corr   += im * templateSh[410];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1398];
		corr   += im * templateSh[411];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1399];
		corr   += im * templateSh[412];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1400];
		corr   += im * templateSh[413];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1401];
		corr   += im * templateSh[414];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1402];
		corr   += im * templateSh[415];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1410];
		corr   += im * templateSh[416];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1411];
		corr   += im * templateSh[417];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1412];
		corr   += im * templateSh[418];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1413];
		corr   += im * templateSh[419];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1414];
		corr   += im * templateSh[420];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1415];
		corr   += im * templateSh[421];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1416];
		corr   += im * templateSh[422];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1417];
		corr   += im * templateSh[423];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1425];
		corr   += im * templateSh[424];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1426];
		corr   += im * templateSh[425];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1427];
		corr   += im * templateSh[426];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1428];
		corr   += im * templateSh[427];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1429];
		corr   += im * templateSh[428];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1430];
		corr   += im * templateSh[429];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1431];
		corr   += im * templateSh[430];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1432];
		corr   += im * templateSh[431];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1440];
		corr   += im * templateSh[432];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1441];
		corr   += im * templateSh[433];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1442];
		corr   += im * templateSh[434];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1443];
		corr   += im * templateSh[435];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1444];
		corr   += im * templateSh[436];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1445];
		corr   += im * templateSh[437];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1446];
		corr   += im * templateSh[438];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1447];
		corr   += im * templateSh[439];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1455];
		corr   += im * templateSh[440];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1456];
		corr   += im * templateSh[441];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1457];
		corr   += im * templateSh[442];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1458];
		corr   += im * templateSh[443];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1459];
		corr   += im * templateSh[444];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1460];
		corr   += im * templateSh[445];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1461];
		corr   += im * templateSh[446];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1462];
		corr   += im * templateSh[447];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1575];
		corr   += im * templateSh[448];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1576];
		corr   += im * templateSh[449];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1577];
		corr   += im * templateSh[450];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1578];
		corr   += im * templateSh[451];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1579];
		corr   += im * templateSh[452];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1580];
		corr   += im * templateSh[453];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1581];
		corr   += im * templateSh[454];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1582];
		corr   += im * templateSh[455];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1590];
		corr   += im * templateSh[456];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1591];
		corr   += im * templateSh[457];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1592];
		corr   += im * templateSh[458];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1593];
		corr   += im * templateSh[459];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1594];
		corr   += im * templateSh[460];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1595];
		corr   += im * templateSh[461];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1596];
		corr   += im * templateSh[462];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1597];
		corr   += im * templateSh[463];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1605];
		corr   += im * templateSh[464];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1606];
		corr   += im * templateSh[465];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1607];
		corr   += im * templateSh[466];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1608];
		corr   += im * templateSh[467];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1609];
		corr   += im * templateSh[468];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1610];
		corr   += im * templateSh[469];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1611];
		corr   += im * templateSh[470];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1612];
		corr   += im * templateSh[471];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1620];
		corr   += im * templateSh[472];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1621];
		corr   += im * templateSh[473];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1622];
		corr   += im * templateSh[474];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1623];
		corr   += im * templateSh[475];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1624];
		corr   += im * templateSh[476];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1625];
		corr   += im * templateSh[477];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1626];
		corr   += im * templateSh[478];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1627];
		corr   += im * templateSh[479];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1635];
		corr   += im * templateSh[480];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1636];
		corr   += im * templateSh[481];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1637];
		corr   += im * templateSh[482];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1638];
		corr   += im * templateSh[483];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1639];
		corr   += im * templateSh[484];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1640];
		corr   += im * templateSh[485];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1641];
		corr   += im * templateSh[486];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1642];
		corr   += im * templateSh[487];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1650];
		corr   += im * templateSh[488];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1651];
		corr   += im * templateSh[489];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1652];
		corr   += im * templateSh[490];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1653];
		corr   += im * templateSh[491];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1654];
		corr   += im * templateSh[492];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1655];
		corr   += im * templateSh[493];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1656];
		corr   += im * templateSh[494];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1657];
		corr   += im * templateSh[495];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1665];
		corr   += im * templateSh[496];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1666];
		corr   += im * templateSh[497];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1667];
		corr   += im * templateSh[498];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1668];
		corr   += im * templateSh[499];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1669];
		corr   += im * templateSh[500];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1670];
		corr   += im * templateSh[501];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1671];
		corr   += im * templateSh[502];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1672];
		corr   += im * templateSh[503];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1680];
		corr   += im * templateSh[504];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1681];
		corr   += im * templateSh[505];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1682];
		corr   += im * templateSh[506];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1683];
		corr   += im * templateSh[507];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1684];
		corr   += im * templateSh[508];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1685];
		corr   += im * templateSh[509];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1686];
		corr   += im * templateSh[510];
		sum    += im;
		sum_sq += im * im;
		im = panelSh[p_idx + 1687];
		corr   += im * templateSh[511];
		sum    += im;
		sum_sq += im * im;
	const flccPrecision var = sum_sq - sum*sum/512;
	const int out_idx = (u0+threadIdx.x) + IMUL((v0+threadIdx.y),SD) + IMUL((w0+threadIdx.z),IMUL(SD,SW));
	if (var == 0)	outputDev[out_idx] = 0.0;
	else			outputDev[out_idx] = corr / sqrtf(var);
}
#ifndef NO_SINGLE_PREC 
template __global__ void lcorrelation3d_kernel_8x8x8<float> ( float *imageDev, float *templateDev, float *outputDev, int SW, int SD, int BW, int BD );
#endif 
#ifndef NO_DOUBLE_PREC 
template __global__ void lcorrelation3d_kernel_8x8x8<double> ( double *imageDev, double *templateDev, double *outputDev, int SW, int SD, int BW, int BD );
#endif 

